// Generated by CoffeeScript 1.9.1
(function() {
  var bcv_parser, bcv_passage, bcv_utils, root,
    hasProp = {}.hasOwnProperty;

  root = this;

  bcv_parser = (function() {
    bcv_parser.prototype.s = "";

    bcv_parser.prototype.entities = [];

    bcv_parser.prototype.passage = null;

    bcv_parser.prototype.regexps = {};

    bcv_parser.prototype.options = {
      consecutive_combination_strategy: "combine",
      osis_compaction_strategy: "b",
      book_sequence_strategy: "ignore",
      invalid_sequence_strategy: "ignore",
      sequence_combination_strategy: "combine",
      invalid_passage_strategy: "ignore",
      non_latin_digits_strategy: "ignore",
      passage_existence_strategy: "bcv",
      zero_chapter_strategy: "error",
      zero_verse_strategy: "error",
      book_alone_strategy: "ignore",
      book_range_strategy: "ignore",
      captive_end_digits_strategy: "delete",
      end_range_digits_strategy: "verse",
      include_apocrypha: false,
      ps151_strategy: "c",
      versification_system: "default",
      case_sensitive: "none"
    };

    function bcv_parser() {
      var key, ref, val;
      this.options = {};
      ref = bcv_parser.prototype.options;
      for (key in ref) {
        if (!hasProp.call(ref, key)) continue;
        val = ref[key];
        this.options[key] = val;
      }
      this.versification_system(this.options.versification_system);
    }

    bcv_parser.prototype.parse = function(s) {
      var ref;
      this.reset();
      this.s = s;
      s = this.replace_control_characters(s);
      ref = this.match_books(s), s = ref[0], this.passage.books = ref[1];
      this.entities = this.match_passages(s)[0];
      return this;
    };

    bcv_parser.prototype.parse_with_context = function(s, context) {
      var entities, ref, ref1, ref2;
      this.reset();
      ref = this.match_books(this.replace_control_characters(context)), context = ref[0], this.passage.books = ref[1];
      ref1 = this.match_passages(context), entities = ref1[0], context = ref1[1];
      this.reset();
      this.s = s;
      s = this.replace_control_characters(s);
      ref2 = this.match_books(s), s = ref2[0], this.passage.books = ref2[1];
      this.passage.books.push({
        value: "",
        parsed: [],
        start_index: 0,
        type: "context",
        context: context
      });
      s = "\x1f" + (this.passage.books.length - 1) + "/9\x1f" + s;
      this.entities = this.match_passages(s)[0];
      return this;
    };

    bcv_parser.prototype.reset = function() {
      this.s = "";
      this.entities = [];
      if (this.passage) {
        this.passage.books = [];
        return this.passage.indices = {};
      } else {
        this.passage = new bcv_passage;
        this.passage.options = this.options;
        return this.passage.translations = this.translations;
      }
    };

    bcv_parser.prototype.set_options = function(options) {
      var key, val;
      for (key in options) {
        if (!hasProp.call(options, key)) continue;
        val = options[key];
        if (key === "include_apocrypha" || key === "versification_system" || key === "case_sensitive") {
          this[key](val);
        } else {
          this.options[key] = val;
        }
      }
      return this;
    };

    bcv_parser.prototype.include_apocrypha = function(arg) {
      var base, base1, ref, translation, verse_count;
      if (!((arg != null) && (arg === true || arg === false))) {
        return this;
      }
      this.options.include_apocrypha = arg;
      this.regexps.books = this.regexps.get_books(arg, this.options.case_sensitive);
      ref = this.translations;
      for (translation in ref) {
        if (!hasProp.call(ref, translation)) continue;
        if (translation === "aliases" || translation === "alternates") {
          continue;
        }
        if ((base = this.translations[translation]).chapters == null) {
          base.chapters = {};
        }
        if ((base1 = this.translations[translation].chapters)["Ps"] == null) {
          base1["Ps"] = bcv_utils.shallow_clone_array(this.translations["default"].chapters["Ps"]);
        }
        if (arg === true) {
          if (this.translations[translation].chapters["Ps151"] != null) {
            verse_count = this.translations[translation].chapters["Ps151"][0];
          } else {
            verse_count = this.translations["default"].chapters["Ps151"][0];
          }
          this.translations[translation].chapters["Ps"][150] = verse_count;
        } else {
          if (this.translations[translation].chapters["Ps"].length === 151) {
            this.translations[translation].chapters["Ps"].pop();
          }
        }
      }
      return this;
    };

    bcv_parser.prototype.versification_system = function(system) {
      var base, base1, base2, book, chapter_list, ref, ref1;
      if (!((system != null) && (this.translations[system] != null))) {
        return this;
      }
      if (this.translations.alternates["default"] != null) {
        if (system === "default") {
          if (this.translations.alternates["default"].order != null) {
            this.translations["default"].order = bcv_utils.shallow_clone(this.translations.alternates["default"].order);
          }
          ref = this.translations.alternates["default"].chapters;
          for (book in ref) {
            if (!hasProp.call(ref, book)) continue;
            chapter_list = ref[book];
            this.translations["default"].chapters[book] = bcv_utils.shallow_clone_array(chapter_list);
          }
        } else {
          this.versification_system("default");
        }
      }
      if ((base = this.translations.alternates)["default"] == null) {
        base["default"] = {
          order: null,
          chapters: {}
        };
      }
      if (system !== "default" && (this.translations[system].order != null)) {
        if ((base1 = this.translations.alternates["default"]).order == null) {
          base1.order = bcv_utils.shallow_clone(this.translations["default"].order);
        }
        this.translations["default"].order = bcv_utils.shallow_clone(this.translations[system].order);
      }
      if (system !== "default" && (this.translations[system].chapters != null)) {
        ref1 = this.translations[system].chapters;
        for (book in ref1) {
          if (!hasProp.call(ref1, book)) continue;
          chapter_list = ref1[book];
          if ((base2 = this.translations.alternates["default"].chapters)[book] == null) {
            base2[book] = bcv_utils.shallow_clone_array(this.translations["default"].chapters[book]);
          }
          this.translations["default"].chapters[book] = bcv_utils.shallow_clone_array(chapter_list);
        }
      }
      this.options.versification_system = system;
      this.include_apocrypha(this.options.include_apocrypha);
      return this;
    };

    bcv_parser.prototype.case_sensitive = function(arg) {
      if (!((arg != null) && (arg === "none" || arg === "books"))) {
        return this;
      }
      if (arg === this.options.case_sensitive) {
        return this;
      }
      this.options.case_sensitive = arg;
      this.regexps.books = this.regexps.get_books(this.options.include_apocrypha, arg);
      return this;
    };

    bcv_parser.prototype.translation_info = function(new_translation) {
      var book, chapter_list, id, old_translation, out, ref, ref1, ref2;
      if (new_translation == null) {
        new_translation = "default";
      }
      if ((new_translation != null) && (((ref = this.translations.aliases[new_translation]) != null ? ref.alias : void 0) != null)) {
        new_translation = this.translations.aliases[new_translation].alias;
      }
      if (!((new_translation != null) && (this.translations[new_translation] != null))) {
        new_translation = "default";
      }
      old_translation = this.options.versification_system;
      if (new_translation !== old_translation) {
        this.versification_system(new_translation);
      }
      out = {
        order: bcv_utils.shallow_clone(this.translations["default"].order),
        books: [],
        chapters: {}
      };
      ref1 = this.translations["default"].chapters;
      for (book in ref1) {
        if (!hasProp.call(ref1, book)) continue;
        chapter_list = ref1[book];
        out.chapters[book] = bcv_utils.shallow_clone_array(chapter_list);
      }
      ref2 = out.order;
      for (book in ref2) {
        if (!hasProp.call(ref2, book)) continue;
        id = ref2[book];
        out.books[id - 1] = book;
      }
      if (new_translation !== old_translation) {
        this.versification_system(old_translation);
      }
      return out;
    };

    bcv_parser.prototype.replace_control_characters = function(s) {
      s = s.replace(this.regexps.control, " ");
      if (this.options.non_latin_digits_strategy === "replace") {
        s = s.replace(/[٠۰߀०০੦૦୦0౦೦൦๐໐༠၀႐០᠐᥆᧐᪀᪐᭐᮰᱀᱐꘠꣐꤀꧐꩐꯰０]/g, "0");
        s = s.replace(/[١۱߁१১੧૧୧௧౧೧൧๑໑༡၁႑១᠑᥇᧑᪁᪑᭑᮱᱁᱑꘡꣑꤁꧑꩑꯱１]/g, "1");
        s = s.replace(/[٢۲߂२২੨૨୨௨౨೨൨๒໒༢၂႒២᠒᥈᧒᪂᪒᭒᮲᱂᱒꘢꣒꤂꧒꩒꯲２]/g, "2");
        s = s.replace(/[٣۳߃३৩੩૩୩௩౩೩൩๓໓༣၃႓៣᠓᥉᧓᪃᪓᭓᮳᱃᱓꘣꣓꤃꧓꩓꯳３]/g, "3");
        s = s.replace(/[٤۴߄४৪੪૪୪௪౪೪൪๔໔༤၄႔៤᠔᥊᧔᪄᪔᭔᮴᱄᱔꘤꣔꤄꧔꩔꯴４]/g, "4");
        s = s.replace(/[٥۵߅५৫੫૫୫௫౫೫൫๕໕༥၅႕៥᠕᥋᧕᪅᪕᭕᮵᱅᱕꘥꣕꤅꧕꩕꯵５]/g, "5");
        s = s.replace(/[٦۶߆६৬੬૬୬௬౬೬൬๖໖༦၆႖៦᠖᥌᧖᪆᪖᭖᮶᱆᱖꘦꣖꤆꧖꩖꯶６]/g, "6");
        s = s.replace(/[٧۷߇७৭੭૭୭௭౭೭൭๗໗༧၇႗៧᠗᥍᧗᪇᪗᭗᮷᱇᱗꘧꣗꤇꧗꩗꯷７]/g, "7");
        s = s.replace(/[٨۸߈८৮੮૮୮௮౮೮൮๘໘༨၈႘៨᠘᥎᧘᪈᪘᭘᮸᱈᱘꘨꣘꤈꧘꩘꯸８]/g, "8");
        s = s.replace(/[٩۹߉९৯੯૯୯௯౯೯൯๙໙༩၉႙៩᠙᥏᧙᪉᪙᭙᮹᱉᱙꘩꣙꤉꧙꩙꯹９]/g, "9");
      }
      return s;
    };

    bcv_parser.prototype.match_books = function(s) {
      var book, books, k, len, ref;
      books = [];
      ref = this.regexps.books;
      for (k = 0, len = ref.length; k < len; k++) {
        book = ref[k];
        s = s.replace(book.regexp, function(full, prev, bk) {
          var extra;
          books.push({
            value: bk,
            parsed: book.osis,
            type: "book"
          });
          extra = book.extra != null ? "/" + book.extra : "";
          return prev + "\x1f" + (books.length - 1) + extra + "\x1f";
        });
      }
      s = s.replace(this.regexps.translations, function(match) {
        books.push({
          value: match,
          parsed: match.toLowerCase(),
          type: "translation"
        });
        return "\x1e" + (books.length - 1) + "\x1e";
      });
      return [s, this.get_book_indices(books, s)];
    };

    bcv_parser.prototype.get_book_indices = function(books, s) {
      var add_index, match, re;
      add_index = 0;
      re = /([\x1f\x1e])(\d+)(?:\/\d+)?\1/g;
      while (match = re.exec(s)) {
        books[match[2]].start_index = match.index + add_index;
        add_index += books[match[2]].value.length - match[0].length;
      }
      return books;
    };

    bcv_parser.prototype.match_passages = function(s) {
      var accum, book_id, entities, full, match, next_char, original_part_length, part, passage, post_context, re, ref, regexp_index_adjust, start_index_adjust;
      entities = [];
      post_context = {};
      while (match = this.regexps.escaped_passage.exec(s)) {
        full = match[0], part = match[1], book_id = match[2];
        original_part_length = part.length;
        match.index += full.length - original_part_length;
        if (/\s[2-9]\d\d\s*$|\s\d{4,}\s*$/.test(part)) {
          re = /\s+\d+\s*$/;
          part = part.replace(re, "");
        }
        if (!/[\d\x1f\x1e)]$/.test(part)) {
          part = this.replace_match_end(part);
        }
        if (this.options.captive_end_digits_strategy === "delete") {
          next_char = match.index + part.length;
          if (s.length > next_char && /^\w/.test(s.substr(next_char, 1))) {
            part = part.replace(/[\s*]+\d+$/, "");
          }
          part = part.replace(/(\x1e[)\]]?)[\s*]*\d+$/, "$1");
        }
        part = part.replace(/[A-Z]+/g, function(capitals) {
          return capitals.toLowerCase();
        });
        start_index_adjust = part.substr(0, 1) === "\x1f" ? 0 : part.split("\x1f")[0].length;
        passage = {
          value: grammar.parse(part),
          type: "base",
          start_index: this.passage.books[book_id].start_index - start_index_adjust,
          match: part
        };
        if (this.options.book_alone_strategy === "full" && this.options.book_range_strategy === "include" && passage.value[0].type === "b" && (passage.value.length === 1 || (passage.value.length > 1 && passage.value[1].type === "translation_sequence")) && start_index_adjust === 0 && (this.passage.books[book_id].parsed.length === 1 || (this.passage.books[book_id].parsed.length > 1 && this.passage.books[book_id].parsed[1].type === "translation")) && /^[234]/.test(this.passage.books[book_id].parsed[0])) {
          this.create_book_range(s, passage, book_id);
        }
        ref = this.passage.handle_obj(passage), accum = ref[0], post_context = ref[1];
        entities = entities.concat(accum);
        regexp_index_adjust = this.adjust_regexp_end(accum, original_part_length, part.length);
        if (regexp_index_adjust > 0) {
          this.regexps.escaped_passage.lastIndex -= regexp_index_adjust;
        }
      }
      return [entities, post_context];
    };

    bcv_parser.prototype.adjust_regexp_end = function(accum, old_length, new_length) {
      var regexp_index_adjust;
      regexp_index_adjust = 0;
      if (accum.length > 0) {
        regexp_index_adjust = old_length - accum[accum.length - 1].indices[1] - 1;
      } else if (old_length !== new_length) {
        regexp_index_adjust = old_length - new_length;
      }
      return regexp_index_adjust;
    };

    bcv_parser.prototype.replace_match_end = function(part) {
      var match, remove;
      remove = part.length;
      while (match = this.regexps.match_end_split.exec(part)) {
        remove = match.index + match[0].length;
      }
      if (remove < part.length) {
        part = part.substr(0, remove);
      }
      return part;
    };

    bcv_parser.prototype.create_book_range = function(s, passage, book_id) {
      var cases, i, k, limit, prev, range_regexp, ref;
      cases = [bcv_parser.prototype.regexps.first, bcv_parser.prototype.regexps.second, bcv_parser.prototype.regexps.third];
      limit = parseInt(this.passage.books[book_id].parsed[0].substr(0, 1), 10);
      for (i = k = 1, ref = limit; 1 <= ref ? k < ref : k > ref; i = 1 <= ref ? ++k : --k) {
        range_regexp = i === limit - 1 ? bcv_parser.prototype.regexps.range_and : bcv_parser.prototype.regexps.range_only;
        prev = s.match(RegExp("(?:^|\\W)(" + cases[i - 1] + "\\s*" + range_regexp + "\\s*)\\x1f" + book_id + "\\x1f", "i"));
        if (prev != null) {
          return this.add_book_range_object(passage, prev, i);
        }
      }
      return false;
    };

    bcv_parser.prototype.add_book_range_object = function(passage, prev, start_book_number) {
      var i, k, length, ref, ref1, results;
      length = prev[1].length;
      passage.value[0] = {
        type: "b_range_pre",
        value: [
          {
            type: "b_pre",
            value: start_book_number.toString(),
            indices: [prev.index, prev.index + length]
          }, passage.value[0]
        ],
        indices: [0, passage.value[0].indices[1] + length]
      };
      passage.value[0].value[1].indices[0] += length;
      passage.value[0].value[1].indices[1] += length;
      passage.start_index -= length;
      passage.match = prev[1] + passage.match;
      if (passage.value.length === 1) {
        return;
      }
      results = [];
      for (i = k = 1, ref = passage.value.length; 1 <= ref ? k < ref : k > ref; i = 1 <= ref ? ++k : --k) {
        if (passage.value[i].value == null) {
          continue;
        }
        if (((ref1 = passage.value[i].value[0]) != null ? ref1.indices : void 0) != null) {
          passage.value[i].value[0].indices[0] += length;
          passage.value[i].value[0].indices[1] += length;
        }
        passage.value[i].indices[0] += length;
        results.push(passage.value[i].indices[1] += length);
      }
      return results;
    };

    bcv_parser.prototype.osis = function() {
      var k, len, osis, out, ref;
      out = [];
      ref = this.parsed_entities();
      for (k = 0, len = ref.length; k < len; k++) {
        osis = ref[k];
        if (osis.osis.length > 0) {
          out.push(osis.osis);
        }
      }
      return out.join(",");
    };

    bcv_parser.prototype.osis_and_translations = function() {
      var k, len, osis, out, ref;
      out = [];
      ref = this.parsed_entities();
      for (k = 0, len = ref.length; k < len; k++) {
        osis = ref[k];
        if (osis.osis.length > 0) {
          out.push([osis.osis, osis.translations.join(",")]);
        }
      }
      return out;
    };

    bcv_parser.prototype.osis_and_indices = function() {
      var k, len, osis, out, ref;
      out = [];
      ref = this.parsed_entities();
      for (k = 0, len = ref.length; k < len; k++) {
        osis = ref[k];
        if (osis.osis.length > 0) {
          out.push({
            osis: osis.osis,
            translations: osis.translations,
            indices: osis.indices
          });
        }
      }
      return out;
    };

    bcv_parser.prototype.parsed_entities = function() {
      var entity, entity_id, i, k, l, last_i, len, len1, length, m, n, osis, osises, out, passage, ref, ref1, ref2, ref3, strings, translation, translation_alias, translation_osis, translations;
      out = [];
      for (entity_id = k = 0, ref = this.entities.length; 0 <= ref ? k < ref : k > ref; entity_id = 0 <= ref ? ++k : --k) {
        entity = this.entities[entity_id];
        if (entity.type && entity.type === "translation_sequence" && out.length > 0 && entity_id === out[out.length - 1].entity_id + 1) {
          out[out.length - 1].indices[1] = entity.absolute_indices[1];
        }
        if (entity.passages == null) {
          continue;
        }
        if ((entity.type === "b" && this.options.book_alone_strategy === "ignore") || (entity.type === "b_range" && this.options.book_range_strategy === "ignore") || entity.type === "context") {
          continue;
        }
        translations = [];
        translation_alias = null;
        if (entity.passages[0].translations != null) {
          ref1 = entity.passages[0].translations;
          for (l = 0, len = ref1.length; l < len; l++) {
            translation = ref1[l];
            translation_osis = ((ref2 = translation.osis) != null ? ref2.length : void 0) > 0 ? translation.osis : "";
            if (translation_alias == null) {
              translation_alias = translation.alias;
            }
            translations.push(translation_osis);
          }
        } else {
          translations = [""];
          translation_alias = "default";
        }
        osises = [];
        length = entity.passages.length;
        for (i = m = 0, ref3 = length; 0 <= ref3 ? m < ref3 : m > ref3; i = 0 <= ref3 ? ++m : --m) {
          passage = entity.passages[i];
          if (passage.type == null) {
            passage.type = entity.type;
          }
          if (passage.valid.valid === false) {
            if (this.options.invalid_sequence_strategy === "ignore" && entity.type === "sequence") {
              this.snap_sequence("ignore", entity, osises, i, length);
            }
            if (this.options.invalid_passage_strategy === "ignore") {
              continue;
            }
          }
          if ((passage.type === "b" || passage.type === "b_range") && this.options.book_sequence_strategy === "ignore" && entity.type === "sequence") {
            this.snap_sequence("book", entity, osises, i, length);
            continue;
          }
          if ((passage.type === "b_range_start" || passage.type === "range_end_b") && this.options.book_range_strategy === "ignore") {
            this.snap_range(entity, i);
          }
          if (passage.absolute_indices == null) {
            passage.absolute_indices = entity.absolute_indices;
          }
          osises.push({
            osis: passage.valid.valid ? this.to_osis(passage.start, passage.end, translation_alias) : "",
            type: passage.type,
            indices: passage.absolute_indices,
            translations: translations,
            start: passage.start,
            end: passage.end,
            enclosed_indices: passage.enclosed_absolute_indices,
            entity_id: entity_id,
            entities: [passage]
          });
        }
        if (osises.length === 0) {
          continue;
        }
        if (osises.length > 1 && this.options.consecutive_combination_strategy === "combine") {
          osises = this.combine_consecutive_passages(osises, translation_alias);
        }
        if (this.options.sequence_combination_strategy === "separate") {
          out = out.concat(osises);
        } else {
          strings = [];
          last_i = osises.length - 1;
          if ((osises[last_i].enclosed_indices != null) && osises[last_i].enclosed_indices[1] >= 0) {
            entity.absolute_indices[1] = osises[last_i].enclosed_indices[1];
          }
          for (n = 0, len1 = osises.length; n < len1; n++) {
            osis = osises[n];
            if (osis.osis.length > 0) {
              strings.push(osis.osis);
            }
          }
          out.push({
            osis: strings.join(","),
            indices: entity.absolute_indices,
            translations: translations,
            entity_id: entity_id,
            entities: osises
          });
        }
      }
      return out;
    };

    bcv_parser.prototype.to_osis = function(start, end, translation) {
      var osis, out;
      if ((end.c == null) && (end.v == null) && start.b === end.b && (start.c == null) && (start.v == null) && this.options.book_alone_strategy === "first_chapter") {
        end.c = 1;
      }
      osis = {
        start: "",
        end: ""
      };
      if (start.c == null) {
        start.c = 1;
      }
      if (start.v == null) {
        start.v = 1;
      }
      if (end.c == null) {
        if (this.options.passage_existence_strategy.indexOf("c") >= 0 || ((this.passage.translations[translation].chapters[end.b] != null) && this.passage.translations[translation].chapters[end.b].length === 1)) {
          end.c = this.passage.translations[translation].chapters[end.b].length;
        } else {
          end.c = 999;
        }
      }
      if (end.v == null) {
        if ((this.passage.translations[translation].chapters[end.b][end.c - 1] != null) && this.options.passage_existence_strategy.indexOf("v") >= 0) {
          end.v = this.passage.translations[translation].chapters[end.b][end.c - 1];
        } else {
          end.v = 999;
        }
      }
      if (this.options.include_apocrypha && this.options.ps151_strategy === "b" && ((start.c === 151 && start.b === "Ps") || (end.c === 151 && end.b === "Ps"))) {
        this.fix_ps151(start, end, translation);
      }
      if (this.options.osis_compaction_strategy === "b" && start.c === 1 && start.v === 1 && end.c === this.passage.translations[translation].chapters[end.b].length && end.v === this.passage.translations[translation].chapters[end.b][end.c - 1]) {
        osis.start = start.b;
        osis.end = end.b;
      } else if (this.options.osis_compaction_strategy.length <= 2 && start.v === 1 && (end.v === 999 || end.v === this.passage.translations[translation].chapters[end.b][end.c - 1])) {
        osis.start = start.b + "." + start.c.toString();
        osis.end = end.b + "." + end.c.toString();
      } else {
        osis.start = start.b + "." + start.c.toString() + "." + start.v.toString();
        osis.end = end.b + "." + end.c.toString() + "." + end.v.toString();
      }
      if (osis.start === osis.end) {
        out = osis.start;
      } else {
        out = osis.start + "-" + osis.end;
      }
      if (start.extra != null) {
        out = start.extra + "," + out;
      }
      if (end.extra != null) {
        out += "," + end.extra;
      }
      return out;
    };

    bcv_parser.prototype.fix_ps151 = function(start, end, translation) {
      var ref;
      if (translation !== "default" && (((ref = this.translations[translation]) != null ? ref.chapters["Ps151"] : void 0) == null)) {
        this.passage.promote_book_to_translation("Ps151", translation);
      }
      if (start.c === 151 && start.b === "Ps") {
        if (end.c === 151 && end.b === "Ps") {
          start.b = "Ps151";
          start.c = 1;
          end.b = "Ps151";
          return end.c = 1;
        } else {
          start.extra = this.to_osis({
            b: "Ps151",
            c: 1,
            v: start.v
          }, {
            b: "Ps151",
            c: 1,
            v: this.passage.translations[translation].chapters["Ps151"][0]
          }, translation);
          start.b = "Prov";
          start.c = 1;
          return start.v = 1;
        }
      } else {
        end.extra = this.to_osis({
          b: "Ps151",
          c: 1,
          v: 1
        }, {
          b: "Ps151",
          c: 1,
          v: end.v
        }, translation);
        end.c = 150;
        return end.v = this.passage.translations[translation].chapters["Ps"][149];
      }
    };

    bcv_parser.prototype.combine_consecutive_passages = function(osises, translation) {
      var enclosed_sequence_start, has_enclosed, i, is_enclosed_last, k, last_i, osis, out, prev, prev_i, ref;
      out = [];
      prev = {};
      last_i = osises.length - 1;
      enclosed_sequence_start = -1;
      has_enclosed = false;
      for (i = k = 0, ref = last_i; 0 <= ref ? k <= ref : k >= ref; i = 0 <= ref ? ++k : --k) {
        osis = osises[i];
        if (osis.osis.length > 0) {
          prev_i = out.length - 1;
          is_enclosed_last = false;
          if (osis.enclosed_indices[0] !== enclosed_sequence_start) {
            enclosed_sequence_start = osis.enclosed_indices[0];
          }
          if (enclosed_sequence_start >= 0 && (i === last_i || osises[i + 1].enclosed_indices[0] !== osis.enclosed_indices[0])) {
            is_enclosed_last = true;
            has_enclosed = true;
          }
          if (this.is_verse_consecutive(prev, osis.start, translation)) {
            out[prev_i].end = osis.end;
            out[prev_i].is_enclosed_last = is_enclosed_last;
            out[prev_i].indices[1] = osis.indices[1];
            out[prev_i].enclosed_indices[1] = osis.enclosed_indices[1];
            out[prev_i].osis = this.to_osis(out[prev_i].start, osis.end, translation);
          } else {
            out.push(osis);
          }
          prev = {
            b: osis.end.b,
            c: osis.end.c,
            v: osis.end.v
          };
        } else {
          out.push(osis);
          prev = {};
        }
      }
      if (has_enclosed) {
        this.snap_enclosed_indices(out);
      }
      return out;
    };

    bcv_parser.prototype.snap_enclosed_indices = function(osises) {
      var k, len, osis;
      for (k = 0, len = osises.length; k < len; k++) {
        osis = osises[k];
        if (osis.is_enclosed_last != null) {
          if (osis.enclosed_indices[0] < 0 && osis.is_enclosed_last) {
            osis.indices[1] = osis.enclosed_indices[1];
          }
          delete osis.is_enclosed_last;
        }
      }
      return osises;
    };

    bcv_parser.prototype.is_verse_consecutive = function(prev, check, translation) {
      var translation_order;
      if (prev.b == null) {
        return false;
      }
      translation_order = this.passage.translations[translation].order != null ? this.passage.translations[translation].order : this.passage.translations["default"].order;
      if (prev.b === check.b) {
        if (prev.c === check.c) {
          if (prev.v === check.v - 1) {
            return true;
          }
        } else if (check.v === 1 && prev.c === check.c - 1) {
          if (prev.v === this.passage.translations[translation].chapters[prev.b][prev.c - 1]) {
            return true;
          }
        }
      } else if (check.c === 1 && check.v === 1 && translation_order[prev.b] === translation_order[check.b] - 1) {
        if (prev.c === this.passage.translations[translation].chapters[prev.b].length && prev.v === this.passage.translations[translation].chapters[prev.b][prev.c - 1]) {
          return true;
        }
      }
      return false;
    };

    bcv_parser.prototype.snap_range = function(entity, passage_i) {
      var entity_i, key, pluck, ref, source_entity, target_entity, temp, type;
      if (entity.type === "b_range_start" || (entity.type === "sequence" && entity.passages[passage_i].type === "b_range_start")) {
        entity_i = 1;
        source_entity = "end";
        type = "b_range_start";
      } else {
        entity_i = 0;
        source_entity = "start";
        type = "range_end_b";
      }
      target_entity = source_entity === "end" ? "start" : "end";
      ref = entity.passages[passage_i][target_entity];
      for (key in ref) {
        if (!hasProp.call(ref, key)) continue;
        entity.passages[passage_i][target_entity][key] = entity.passages[passage_i][source_entity][key];
      }
      if (entity.type === "sequence") {
        if (passage_i >= entity.value.length) {
          passage_i = entity.value.length - 1;
        }
        pluck = this.passage.pluck(type, entity.value[passage_i]);
        if (pluck != null) {
          temp = this.snap_range(pluck, 0);
          if (passage_i === 0) {
            entity.absolute_indices[0] = temp.absolute_indices[0];
          } else {
            entity.absolute_indices[1] = temp.absolute_indices[1];
          }
        }
      } else {
        entity.original_type = entity.type;
        entity.type = entity.value[entity_i].type;
        entity.absolute_indices = [entity.value[entity_i].absolute_indices[0], entity.value[entity_i].absolute_indices[1]];
      }
      return entity;
    };

    bcv_parser.prototype.snap_sequence = function(type, entity, osises, i, length) {
      var passage;
      passage = entity.passages[i];
      if (passage.absolute_indices[0] === entity.absolute_indices[0] && i < length - 1 && this.get_snap_sequence_i(entity.passages, i, length) !== i) {
        entity.absolute_indices[0] = entity.passages[i + 1].absolute_indices[0];
        this.remove_absolute_indices(entity.passages, i + 1);
      } else if (passage.absolute_indices[1] === entity.absolute_indices[1] && i > 0) {
        entity.absolute_indices[1] = osises.length > 0 ? osises[osises.length - 1].indices[1] : entity.passages[i - 1].absolute_indices[1];
      } else if (type === "book" && i < length - 1 && !this.starts_with_book(entity.passages[i + 1])) {
        entity.passages[i + 1].absolute_indices[0] = passage.absolute_indices[0];
      }
      return entity;
    };

    bcv_parser.prototype.get_snap_sequence_i = function(passages, i, length) {
      var j, k, ref, ref1;
      for (j = k = ref = i + 1, ref1 = length; ref <= ref1 ? k < ref1 : k > ref1; j = ref <= ref1 ? ++k : --k) {
        if (this.starts_with_book(passages[j])) {
          return j;
        }
        if (passages[j].valid.valid) {
          return i;
        }
      }
      return i;
    };

    bcv_parser.prototype.starts_with_book = function(passage) {
      if (passage.type.substr(0, 1) === "b") {
        return true;
      }
      if ((passage.type === "range" || passage.type === "ff") && passage.start.type.substr(0, 1) === "b") {
        return true;
      }
      return false;
    };

    bcv_parser.prototype.remove_absolute_indices = function(passages, i) {
      var end, k, len, passage, ref, ref1, start;
      if (passages[i].enclosed_absolute_indices[0] < 0) {
        return false;
      }
      ref = passages[i].enclosed_absolute_indices, start = ref[0], end = ref[1];
      ref1 = passages.slice(i);
      for (k = 0, len = ref1.length; k < len; k++) {
        passage = ref1[k];
        if (passage.enclosed_absolute_indices[0] === start && passage.enclosed_absolute_indices[1] === end) {
          passage.enclosed_absolute_indices = [-1, -1];
        } else {
          break;
        }
      }
      return true;
    };

    return bcv_parser;

  })();

  root.bcv_parser = bcv_parser;

  bcv_passage = (function() {
    function bcv_passage() {}

    bcv_passage.prototype.books = [];

    bcv_passage.prototype.indices = {};

    bcv_passage.prototype.options = {};

    bcv_passage.prototype.translations = {};

    bcv_passage.prototype.handle_array = function(passages, accum, context) {
      var k, len, passage, ref;
      if (accum == null) {
        accum = [];
      }
      if (context == null) {
        context = {};
      }
      for (k = 0, len = passages.length; k < len; k++) {
        passage = passages[k];
        if (passage == null) {
          continue;
        }
        if (passage.type === "stop") {
          break;
        }
        ref = this.handle_obj(passage, accum, context), accum = ref[0], context = ref[1];
      }
      return [accum, context];
    };

    bcv_passage.prototype.handle_obj = function(passage, accum, context) {
      if ((passage.type != null) && (this[passage.type] != null)) {
        return this[passage.type](passage, accum, context);
      } else {
        return [accum, context];
      }
    };

    bcv_passage.prototype.b = function(passage, accum, context) {
      var alternates, b, k, len, obj, ref, valid;
      passage.start_context = bcv_utils.shallow_clone(context);
      passage.passages = [];
      alternates = [];
      ref = this.books[passage.value].parsed;
      for (k = 0, len = ref.length; k < len; k++) {
        b = ref[k];
        valid = this.validate_ref(passage.start_context.translations, {
          b: b
        });
        obj = {
          start: {
            b: b
          },
          end: {
            b: b
          },
          valid: valid
        };
        if (passage.passages.length === 0 && valid.valid) {
          passage.passages.push(obj);
        } else {
          alternates.push(obj);
        }
      }
      if (passage.passages.length === 0) {
        passage.passages.push(alternates.shift());
      }
      if (alternates.length > 0) {
        passage.passages[0].alternates = alternates;
      }
      if (passage.start_context.translations != null) {
        passage.passages[0].translations = passage.start_context.translations;
      }
      if (passage.absolute_indices == null) {
        passage.absolute_indices = this.get_absolute_indices(passage.indices);
      }
      accum.push(passage);
      context = {
        b: passage.passages[0].start.b
      };
      if (passage.start_context.translations != null) {
        context.translations = passage.start_context.translations;
      }
      return [accum, context];
    };

    bcv_passage.prototype.b_range = function(passage, accum, context) {
      return this.range(passage, accum, context);
    };

    bcv_passage.prototype.b_range_pre = function(passage, accum, context) {
      var alternates, book, end, ref, ref1, start_obj;
      passage.start_context = bcv_utils.shallow_clone(context);
      passage.passages = [];
      alternates = [];
      book = this.pluck("b", passage.value);
      ref = this.b(book, [], context), (ref1 = ref[0], end = ref1[0]), context = ref[1];
      if (passage.absolute_indices == null) {
        passage.absolute_indices = this.get_absolute_indices(passage.indices);
      }
      start_obj = {
        b: passage.value[0].value + end.passages[0].start.b.substr(1),
        type: "b"
      };
      passage.passages = [
        {
          start: start_obj,
          end: end.passages[0].end,
          valid: end.passages[0].valid
        }
      ];
      if (passage.start_context.translations != null) {
        passage.passages[0].translations = passage.start_context.translations;
      }
      accum.push(passage);
      return [accum, context];
    };

    bcv_passage.prototype.b_range_start = function(passage, accum, context) {
      return this.range(passage, accum, context);
    };

    bcv_passage.prototype.base = function(passage, accum, context) {
      this.indices = this.calculate_indices(passage.match, passage.start_index);
      return this.handle_array(passage.value, accum, context);
    };

    bcv_passage.prototype.bc = function(passage, accum, context) {
      var alternates, b, c, context_key, k, len, obj, ref, ref1, valid;
      passage.start_context = bcv_utils.shallow_clone(context);
      passage.passages = [];
      this.reset_context(context, ["b", "c", "v"]);
      c = this.pluck("c", passage.value).value;
      alternates = [];
      ref = this.books[this.pluck("b", passage.value).value].parsed;
      for (k = 0, len = ref.length; k < len; k++) {
        b = ref[k];
        context_key = "c";
        valid = this.validate_ref(passage.start_context.translations, {
          b: b,
          c: c
        });
        obj = {
          start: {
            b: b
          },
          end: {
            b: b
          },
          valid: valid
        };
        if (valid.messages.start_chapter_not_exist_in_single_chapter_book) {
          obj.valid = this.validate_ref(passage.start_context.translations, {
            b: b,
            v: c
          });
          obj.valid.messages.start_chapter_not_exist_in_single_chapter_book = 1;
          obj.start.c = 1;
          obj.end.c = 1;
          context_key = "v";
        }
        obj.start[context_key] = c;
        ref1 = this.fix_start_zeroes(obj.valid, obj.start.c, obj.start.v), obj.start.c = ref1[0], obj.start.v = ref1[1];
        if (obj.start.v == null) {
          delete obj.start.v;
        }
        obj.end[context_key] = obj.start[context_key];
        if (passage.passages.length === 0 && obj.valid.valid) {
          passage.passages.push(obj);
        } else {
          alternates.push(obj);
        }
      }
      if (passage.passages.length === 0) {
        passage.passages.push(alternates.shift());
      }
      if (alternates.length > 0) {
        passage.passages[0].alternates = alternates;
      }
      if (passage.start_context.translations != null) {
        passage.passages[0].translations = passage.start_context.translations;
      }
      if (passage.absolute_indices == null) {
        passage.absolute_indices = this.get_absolute_indices(passage.indices);
      }
      this.set_context_from_object(context, ["b", "c", "v"], passage.passages[0].start);
      accum.push(passage);
      return [accum, context];
    };

    bcv_passage.prototype.bc_title = function(passage, accum, context) {
      var bc, i, k, ref, ref1, ref2, title;
      passage.start_context = bcv_utils.shallow_clone(context);
      ref = this.bc(this.pluck("bc", passage.value), [], context), (ref1 = ref[0], bc = ref1[0]), context = ref[1];
      if (bc.passages[0].start.b.substr(0, 2) !== "Ps" && (bc.passages[0].alternates != null)) {
        for (i = k = 0, ref2 = bc.passages[0].alternates.length; 0 <= ref2 ? k < ref2 : k > ref2; i = 0 <= ref2 ? ++k : --k) {
          if (bc.passages[0].alternates[i].start.b.substr(0, 2) !== "Ps") {
            continue;
          }
          bc.passages[0] = bc.passages[0].alternates[i];
          break;
        }
      }
      if (bc.passages[0].start.b.substr(0, 2) !== "Ps") {
        accum.push(bc);
        return [accum, context];
      }
      this.books[this.pluck("b", bc.value).value].parsed = ["Ps"];
      title = this.pluck("title", passage.value);
      if (title == null) {
        title = this.pluck("v", passage.value);
      }
      passage.value[1] = {
        type: "v",
        value: [
          {
            type: "integer",
            value: 1,
            indices: title.indices
          }
        ],
        indices: title.indices
      };
      passage.type = "bcv";
      return this.bcv(passage, accum, passage.start_context);
    };

    bcv_passage.prototype.bcv = function(passage, accum, context) {
      var alternates, b, bc, c, k, len, obj, ref, ref1, v, valid;
      passage.start_context = bcv_utils.shallow_clone(context);
      passage.passages = [];
      this.reset_context(context, ["b", "c", "v"]);
      bc = this.pluck("bc", passage.value);
      c = this.pluck("c", bc.value).value;
      v = this.pluck("v", passage.value).value;
      alternates = [];
      ref = this.books[this.pluck("b", bc.value).value].parsed;
      for (k = 0, len = ref.length; k < len; k++) {
        b = ref[k];
        valid = this.validate_ref(passage.start_context.translations, {
          b: b,
          c: c,
          v: v
        });
        ref1 = this.fix_start_zeroes(valid, c, v), c = ref1[0], v = ref1[1];
        obj = {
          start: {
            b: b,
            c: c,
            v: v
          },
          end: {
            b: b,
            c: c,
            v: v
          },
          valid: valid
        };
        if (passage.passages.length === 0 && valid.valid) {
          passage.passages.push(obj);
        } else {
          alternates.push(obj);
        }
      }
      if (passage.passages.length === 0) {
        passage.passages.push(alternates.shift());
      }
      if (alternates.length > 0) {
        passage.passages[0].alternates = alternates;
      }
      if (passage.start_context.translations != null) {
        passage.passages[0].translations = passage.start_context.translations;
      }
      if (passage.absolute_indices == null) {
        passage.absolute_indices = this.get_absolute_indices(passage.indices);
      }
      this.set_context_from_object(context, ["b", "c", "v"], passage.passages[0].start);
      accum.push(passage);
      return [accum, context];
    };

    bcv_passage.prototype.bv = function(passage, accum, context) {
      var b, bcv, ref, ref1, ref2, v;
      passage.start_context = bcv_utils.shallow_clone(context);
      ref = passage.value, b = ref[0], v = ref[1];
      bcv = {
        indices: passage.indices,
        value: [
          {
            type: "bc",
            value: [
              b, {
                type: "c",
                value: [
                  {
                    type: "integer",
                    value: 1
                  }
                ]
              }
            ]
          }, v
        ]
      };
      ref1 = this.bcv(bcv, [], context), (ref2 = ref1[0], bcv = ref2[0]), context = ref1[1];
      passage.passages = bcv.passages;
      if (passage.absolute_indices == null) {
        passage.absolute_indices = this.get_absolute_indices(passage.indices);
      }
      accum.push(passage);
      return [accum, context];
    };

    bcv_passage.prototype.c = function(passage, accum, context) {
      var c, valid;
      passage.start_context = bcv_utils.shallow_clone(context);
      c = passage.type === "integer" ? passage.value : this.pluck("integer", passage.value).value;
      valid = this.validate_ref(passage.start_context.translations, {
        b: context.b,
        c: c
      });
      if (!valid.valid && valid.messages.start_chapter_not_exist_in_single_chapter_book) {
        return this.v(passage, accum, context);
      }
      c = this.fix_start_zeroes(valid, c)[0];
      passage.passages = [
        {
          start: {
            b: context.b,
            c: c
          },
          end: {
            b: context.b,
            c: c
          },
          valid: valid
        }
      ];
      if (passage.start_context.translations != null) {
        passage.passages[0].translations = passage.start_context.translations;
      }
      accum.push(passage);
      context.c = c;
      this.reset_context(context, ["v"]);
      if (passage.absolute_indices == null) {
        passage.absolute_indices = this.get_absolute_indices(passage.indices);
      }
      return [accum, context];
    };

    bcv_passage.prototype.c_psalm = function(passage, accum, context) {
      var c;
      passage.type = "bc";
      c = parseInt(this.books[passage.value].value.match(/^\d+/)[0], 10);
      passage.value = [
        {
          type: "b",
          value: passage.value,
          indices: passage.indices
        }, {
          type: "c",
          value: [
            {
              type: "integer",
              value: c,
              indices: passage.indices
            }
          ],
          indices: passage.indices
        }
      ];
      return this.bc(passage, accum, context);
    };

    bcv_passage.prototype.c_title = function(passage, accum, context) {
      var title;
      passage.start_context = bcv_utils.shallow_clone(context);
      if (context.b !== "Ps") {
        return this.c(passage.value[0], accum, context);
      }
      title = this.pluck("title", passage.value);
      passage.value[1] = {
        type: "v",
        value: [
          {
            type: "integer",
            value: 1,
            indices: title.indices
          }
        ],
        indices: title.indices
      };
      passage.type = "cv";
      return this.cv(passage, accum, passage.start_context);
    };

    bcv_passage.prototype.cv = function(passage, accum, context) {
      var c, ref, v, valid;
      passage.start_context = bcv_utils.shallow_clone(context);
      c = this.pluck("c", passage.value).value;
      v = this.pluck("v", passage.value).value;
      valid = this.validate_ref(passage.start_context.translations, {
        b: context.b,
        c: c,
        v: v
      });
      ref = this.fix_start_zeroes(valid, c, v), c = ref[0], v = ref[1];
      passage.passages = [
        {
          start: {
            b: context.b,
            c: c,
            v: v
          },
          end: {
            b: context.b,
            c: c,
            v: v
          },
          valid: valid
        }
      ];
      if (passage.start_context.translations != null) {
        passage.passages[0].translations = passage.start_context.translations;
      }
      accum.push(passage);
      context.c = c;
      context.v = v;
      if (passage.absolute_indices == null) {
        passage.absolute_indices = this.get_absolute_indices(passage.indices);
      }
      return [accum, context];
    };

    bcv_passage.prototype.cb_range = function(passage, accum, context) {
      var b, end_c, ref, start_c;
      passage.type = "range";
      ref = passage.value, b = ref[0], start_c = ref[1], end_c = ref[2];
      passage.value = [
        {
          type: "bc",
          value: [b, start_c],
          indices: passage.indices
        }, end_c
      ];
      end_c.indices[1] = passage.indices[1];
      return this.range(passage, accum, context);
    };

    bcv_passage.prototype.context = function(passage, accum, context) {
      var key, ref;
      passage.start_context = bcv_utils.shallow_clone(context);
      passage.passages = [];
      ref = this.books[passage.value].context;
      for (key in ref) {
        if (!hasProp.call(ref, key)) continue;
        context[key] = this.books[passage.value].context[key];
      }
      accum.push(passage);
      return [accum, context];
    };

    bcv_passage.prototype.cv_psalm = function(passage, accum, context) {
      var bc, c_psalm, ref, v;
      passage.start_context = bcv_utils.shallow_clone(context);
      passage.type = "bcv";
      ref = passage.value, c_psalm = ref[0], v = ref[1];
      bc = this.c_psalm(c_psalm, [], passage.start_context)[0][0];
      passage.value = [bc, v];
      return this.bcv(passage, accum, context);
    };

    bcv_passage.prototype.ff = function(passage, accum, context) {
      var ref, ref1;
      passage.start_context = bcv_utils.shallow_clone(context);
      passage.value.push({
        type: "integer",
        indices: passage.indices,
        value: 999
      });
      ref = this.range(passage, [], passage.start_context), (ref1 = ref[0], passage = ref1[0]), context = ref[1];
      passage.value[0].indices = passage.value[1].indices;
      passage.value[0].absolute_indices = passage.value[1].absolute_indices;
      passage.value.pop();
      if (passage.passages[0].valid.messages.end_verse_not_exist != null) {
        delete passage.passages[0].valid.messages.end_verse_not_exist;
      }
      if (passage.passages[0].valid.messages.end_chapter_not_exist != null) {
        delete passage.passages[0].valid.messages.end_chapter_not_exist;
      }
      if (passage.passages[0].end.original_c != null) {
        delete passage.passages[0].end.original_c;
      }
      accum.push(passage);
      return [accum, context];
    };

    bcv_passage.prototype.integer_title = function(passage, accum, context) {
      var v_indices;
      passage.start_context = bcv_utils.shallow_clone(context);
      if (context.b !== "Ps") {
        return this.integer(passage.value[0], accum, context);
      }
      passage.value[0] = {
        type: "c",
        value: [passage.value[0]],
        indices: [passage.value[0].indices[0], passage.value[0].indices[1]]
      };
      v_indices = [passage.indices[1] - 5, passage.indices[1]];
      passage.value[1] = {
        type: "v",
        value: [
          {
            type: "integer",
            value: 1,
            indices: v_indices
          }
        ],
        indices: v_indices
      };
      passage.type = "cv";
      return this.cv(passage, accum, passage.start_context);
    };

    bcv_passage.prototype.integer = function(passage, accum, context) {
      if (context.v != null) {
        return this.v(passage, accum, context);
      }
      return this.c(passage, accum, context);
    };

    bcv_passage.prototype.sequence = function(passage, accum, context) {
      var k, l, len, len1, obj, psg, ref, ref1, ref2, ref3, sub_psg;
      passage.start_context = bcv_utils.shallow_clone(context);
      passage.passages = [];
      ref = passage.value;
      for (k = 0, len = ref.length; k < len; k++) {
        obj = ref[k];
        ref1 = this.handle_array(obj, [], context), (ref2 = ref1[0], psg = ref2[0]), context = ref1[1];
        ref3 = psg.passages;
        for (l = 0, len1 = ref3.length; l < len1; l++) {
          sub_psg = ref3[l];
          if (sub_psg.type == null) {
            sub_psg.type = psg.type;
          }
          if (sub_psg.absolute_indices == null) {
            sub_psg.absolute_indices = psg.absolute_indices;
          }
          if (psg.start_context.translations != null) {
            sub_psg.translations = psg.start_context.translations;
          }
          sub_psg.enclosed_absolute_indices = psg.type === "sequence_post_enclosed" ? psg.absolute_indices : [-1, -1];
          passage.passages.push(sub_psg);
        }
      }
      if (passage.absolute_indices == null) {
        if (passage.passages.length > 0 && passage.type === "sequence") {
          passage.absolute_indices = [passage.passages[0].absolute_indices[0], passage.passages[passage.passages.length - 1].absolute_indices[1]];
        } else {
          passage.absolute_indices = this.get_absolute_indices(passage.indices);
        }
      }
      accum.push(passage);
      return [accum, context];
    };

    bcv_passage.prototype.sequence_post_enclosed = function(passage, accum, context) {
      return this.sequence(passage, accum, context);
    };

    bcv_passage.prototype.v = function(passage, accum, context) {
      var c, no_c, ref, v, valid;
      v = passage.type === "integer" ? passage.value : this.pluck("integer", passage.value).value;
      passage.start_context = bcv_utils.shallow_clone(context);
      c = context.c != null ? context.c : 1;
      valid = this.validate_ref(passage.start_context.translations, {
        b: context.b,
        c: c,
        v: v
      });
      ref = this.fix_start_zeroes(valid, 0, v), no_c = ref[0], v = ref[1];
      passage.passages = [
        {
          start: {
            b: context.b,
            c: c,
            v: v
          },
          end: {
            b: context.b,
            c: c,
            v: v
          },
          valid: valid
        }
      ];
      if (passage.start_context.translations != null) {
        passage.passages[0].translations = passage.start_context.translations;
      }
      if (passage.absolute_indices == null) {
        passage.absolute_indices = this.get_absolute_indices(passage.indices);
      }
      accum.push(passage);
      context.v = v;
      return [accum, context];
    };

    bcv_passage.prototype.range = function(passage, accum, context) {
      var end, end_obj, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, ref8, ref9, return_now, return_value, start, start_obj, valid;
      passage.start_context = bcv_utils.shallow_clone(context);
      ref = passage.value, start = ref[0], end = ref[1];
      ref1 = this.handle_obj(start, [], context), (ref2 = ref1[0], start = ref2[0]), context = ref1[1];
      if (end.type === "v" && ((start.type === "bc" && !((ref3 = start.passages) != null ? (ref4 = ref3[0]) != null ? (ref5 = ref4.valid) != null ? (ref6 = ref5.messages) != null ? ref6.start_chapter_not_exist_in_single_chapter_book : void 0 : void 0 : void 0 : void 0)) || start.type === "c") && this.options.end_range_digits_strategy === "verse") {
        passage.value[0] = start;
        return this.range_change_integer_end(passage, accum);
      }
      ref7 = this.handle_obj(end, [], context), (ref8 = ref7[0], end = ref8[0]), context = ref7[1];
      passage.value = [start, end];
      passage.indices = [start.indices[0], end.indices[1]];
      delete passage.absolute_indices;
      start_obj = {
        b: start.passages[0].start.b,
        c: start.passages[0].start.c,
        v: start.passages[0].start.v,
        type: start.type
      };
      end_obj = {
        b: end.passages[0].end.b,
        c: end.passages[0].end.c,
        v: end.passages[0].end.v,
        type: end.type
      };
      if (end.passages[0].valid.messages.start_chapter_is_zero) {
        end_obj.c = 0;
      }
      if (end.passages[0].valid.messages.start_verse_is_zero) {
        end_obj.v = 0;
      }
      valid = this.validate_ref(passage.start_context.translations, start_obj, end_obj);
      if (valid.valid) {
        ref9 = this.range_handle_valid(valid, passage, start, start_obj, end, end_obj, accum), return_now = ref9[0], return_value = ref9[1];
        if (return_now) {
          return return_value;
        }
      } else {
        return this.range_handle_invalid(valid, passage, start, start_obj, end, end_obj, accum);
      }
      if (passage.absolute_indices == null) {
        passage.absolute_indices = this.get_absolute_indices(passage.indices);
      }
      passage.passages = [
        {
          start: start_obj,
          end: end_obj,
          valid: valid
        }
      ];
      if (passage.start_context.translations != null) {
        passage.passages[0].translations = passage.start_context.translations;
      }
      if (start_obj.type === "b") {
        if (end_obj.type === "b") {
          passage.type = "b_range";
        } else {
          passage.type = "b_range_start";
        }
      } else if (end_obj.type === "b") {
        passage.type = "range_end_b";
      }
      accum.push(passage);
      return [accum, context];
    };

    bcv_passage.prototype.range_change_end = function(passage, accum, new_end) {
      var end, new_obj, ref, start;
      ref = passage.value, start = ref[0], end = ref[1];
      if (end.type === "integer") {
        end.original_value = end.value;
        end.value = new_end;
      } else if (end.type === "v") {
        new_obj = this.pluck("integer", end.value);
        new_obj.original_value = new_obj.value;
        new_obj.value = new_end;
      } else if (end.type === "cv") {
        new_obj = this.pluck("c", end.value);
        new_obj.original_value = new_obj.value;
        new_obj.value = new_end;
      }
      return this.handle_obj(passage, accum, passage.start_context);
    };

    bcv_passage.prototype.range_change_integer_end = function(passage, accum) {
      var end, ref, start;
      ref = passage.value, start = ref[0], end = ref[1];
      if (passage.original_type == null) {
        passage.original_type = passage.type;
      }
      if (passage.original_value == null) {
        passage.original_value = [start, end];
      }
      passage.type = start.type === "integer" ? "cv" : start.type + "v";
      if (start.type === "integer") {
        passage.value[0] = {
          type: "c",
          value: [start],
          indices: start.indices
        };
      }
      if (end.type === "integer") {
        passage.value[1] = {
          type: "v",
          value: [end],
          indices: end.indices
        };
      }
      return this.handle_obj(passage, accum, passage.start_context);
    };

    bcv_passage.prototype.range_check_new_end = function(translations, start_obj, end_obj, valid) {
      var new_end, new_valid, obj_to_validate, type;
      new_end = 0;
      type = null;
      if (valid.messages.end_chapter_before_start) {
        type = "c";
      } else if (valid.messages.end_verse_before_start) {
        type = "v";
      }
      if (type != null) {
        new_end = this.range_get_new_end_value(start_obj, end_obj, valid, type);
      }
      if (new_end > 0) {
        obj_to_validate = {
          b: end_obj.b,
          c: end_obj.c,
          v: end_obj.v
        };
        obj_to_validate[type] = new_end;
        new_valid = this.validate_ref(translations, obj_to_validate);
        if (!new_valid.valid) {
          new_end = 0;
        }
      }
      return new_end;
    };

    bcv_passage.prototype.range_end_b = function(passage, accum, context) {
      return this.range(passage, accum, context);
    };

    bcv_passage.prototype.range_get_new_end_value = function(start_obj, end_obj, valid, key) {
      var new_end;
      new_end = 0;
      if ((key === "c" && valid.messages.end_chapter_is_zero) || (key === "v" && valid.messages.end_verse_is_zero)) {
        return new_end;
      }
      if (start_obj[key] >= 10 && end_obj[key] < 10 && start_obj[key] - 10 * Math.floor(start_obj[key] / 10) < end_obj[key]) {
        new_end = end_obj[key] + 10 * Math.floor(start_obj[key] / 10);
      } else if (start_obj[key] >= 100 && end_obj[key] < 100 && start_obj[key] - 100 < end_obj[key]) {
        new_end = end_obj[key] + 100;
      }
      return new_end;
    };

    bcv_passage.prototype.range_handle_invalid = function(valid, passage, start, start_obj, end, end_obj, accum) {
      var new_end, ref, temp_valid, temp_value;
      if (valid.valid === false && (valid.messages.end_chapter_before_start || valid.messages.end_verse_before_start) && (end.type === "integer" || end.type === "v") || (valid.valid === false && valid.messages.end_chapter_before_start && end.type === "cv")) {
        new_end = this.range_check_new_end(passage.start_context.translations, start_obj, end_obj, valid);
        if (new_end > 0) {
          return this.range_change_end(passage, accum, new_end);
        }
      }
      if (this.options.end_range_digits_strategy === "verse" && (start_obj.v == null) && (end.type === "integer" || end.type === "v")) {
        temp_value = end.type === "v" ? this.pluck("integer", end.value) : end.value;
        temp_valid = this.validate_ref(passage.start_context.translations, {
          b: start_obj.b,
          c: start_obj.c,
          v: temp_value
        });
        if (temp_valid.valid) {
          return this.range_change_integer_end(passage, accum);
        }
      }
      if (passage.original_type == null) {
        passage.original_type = passage.type;
      }
      passage.type = "sequence";
      ref = [[start, end], [[start], [end]]], passage.original_value = ref[0], passage.value = ref[1];
      return this.sequence(passage, accum, passage.start_context);
    };

    bcv_passage.prototype.range_handle_valid = function(valid, passage, start, start_obj, end, end_obj, accum) {
      var temp_valid, temp_value;
      if (valid.messages.end_chapter_not_exist && this.options.end_range_digits_strategy === "verse" && (start_obj.v == null) && (end.type === "integer" || end.type === "v") && this.options.passage_existence_strategy.indexOf("v") >= 0) {
        temp_value = end.type === "v" ? this.pluck("integer", end.value) : end.value;
        temp_valid = this.validate_ref(passage.start_context.translations, {
          b: start_obj.b,
          c: start_obj.c,
          v: temp_value
        });
        if (temp_valid.valid) {
          return [true, this.range_change_integer_end(passage, accum)];
        }
      }
      this.range_validate(valid, start_obj, end_obj, passage);
      return [false, null];
    };

    bcv_passage.prototype.range_validate = function(valid, start_obj, end_obj, passage) {
      var ref;
      if (valid.messages.end_chapter_not_exist || valid.messages.end_chapter_not_exist_in_single_chapter_book) {
        end_obj.original_c = end_obj.c;
        end_obj.c = valid.messages.end_chapter_not_exist ? valid.messages.end_chapter_not_exist : valid.messages.end_chapter_not_exist_in_single_chapter_book;
        if (end_obj.v != null) {
          end_obj.v = this.validate_ref(passage.start_context.translations, {
            b: end_obj.b,
            c: end_obj.c,
            v: 999
          }).messages.end_verse_not_exist;
          delete valid.messages.end_verse_is_zero;
        }
      } else if (valid.messages.end_verse_not_exist) {
        end_obj.original_v = end_obj.v;
        end_obj.v = valid.messages.end_verse_not_exist;
      }
      if (valid.messages.end_verse_is_zero && this.options.zero_verse_strategy !== "allow") {
        end_obj.v = valid.messages.end_verse_is_zero;
      }
      if (valid.messages.end_chapter_is_zero) {
        end_obj.c = valid.messages.end_chapter_is_zero;
      }
      ref = this.fix_start_zeroes(valid, start_obj.c, start_obj.v), start_obj.c = ref[0], start_obj.v = ref[1];
      return true;
    };

    bcv_passage.prototype.translation_sequence = function(passage, accum, context) {
      var k, l, len, len1, ref, translation, translations, val;
      passage.start_context = bcv_utils.shallow_clone(context);
      translations = [];
      translations.push({
        translation: this.books[passage.value[0].value].parsed
      });
      ref = passage.value[1];
      for (k = 0, len = ref.length; k < len; k++) {
        val = ref[k];
        val = this.books[this.pluck("translation", val).value].parsed;
        if (val != null) {
          translations.push({
            translation: val
          });
        }
      }
      for (l = 0, len1 = translations.length; l < len1; l++) {
        translation = translations[l];
        if (this.translations.aliases[translation.translation] != null) {
          translation.alias = this.translations.aliases[translation.translation].alias;
          translation.osis = this.translations.aliases[translation.translation].osis || "";
        } else {
          translation.alias = "default";
          translation.osis = translation.translation.toUpperCase();
        }
      }
      if (accum.length > 0) {
        context = this.translation_sequence_apply(accum, translations);
      }
      if (passage.absolute_indices == null) {
        passage.absolute_indices = this.get_absolute_indices(passage.indices);
      }
      accum.push(passage);
      this.reset_context(context, ["translations"]);
      return [accum, context];
    };

    bcv_passage.prototype.translation_sequence_apply = function(accum, translations) {
      var context, i, k, new_accum, ref, ref1, use_i;
      use_i = 0;
      for (i = k = ref = accum.length - 1; ref <= 0 ? k <= 0 : k >= 0; i = ref <= 0 ? ++k : --k) {
        if (accum[i].original_type != null) {
          accum[i].type = accum[i].original_type;
        }
        if (accum[i].original_value != null) {
          accum[i].value = accum[i].original_value;
        }
        if (accum[i].type !== "translation_sequence") {
          continue;
        }
        use_i = i + 1;
        break;
      }
      if (use_i < accum.length) {
        accum[use_i].start_context.translations = translations;
        ref1 = this.handle_array(accum.slice(use_i), [], accum[use_i].start_context), new_accum = ref1[0], context = ref1[1];
      } else {
        context = bcv_utils.shallow_clone(accum[accum.length - 1].start_context);
      }
      return context;
    };

    bcv_passage.prototype.pluck = function(type, passages) {
      var k, len, passage;
      for (k = 0, len = passages.length; k < len; k++) {
        passage = passages[k];
        if (!((passage != null) && (passage.type != null) && passage.type === type)) {
          continue;
        }
        if (type === "c" || type === "v") {
          return this.pluck("integer", passage.value);
        }
        return passage;
      }
      return null;
    };

    bcv_passage.prototype.set_context_from_object = function(context, keys, obj) {
      var k, len, results, type;
      results = [];
      for (k = 0, len = keys.length; k < len; k++) {
        type = keys[k];
        if (obj[type] == null) {
          continue;
        }
        results.push(context[type] = obj[type]);
      }
      return results;
    };

    bcv_passage.prototype.reset_context = function(context, keys) {
      var k, len, results, type;
      results = [];
      for (k = 0, len = keys.length; k < len; k++) {
        type = keys[k];
        results.push(delete context[type]);
      }
      return results;
    };

    bcv_passage.prototype.fix_start_zeroes = function(valid, c, v) {
      if (valid.messages.start_chapter_is_zero && this.options.zero_chapter_strategy === "upgrade") {
        c = valid.messages.start_chapter_is_zero;
      }
      if (valid.messages.start_verse_is_zero && this.options.zero_verse_strategy === "upgrade") {
        v = valid.messages.start_verse_is_zero;
      }
      return [c, v];
    };

    bcv_passage.prototype.calculate_indices = function(match, adjust) {
      var character, end_index, indices, k, l, len, len1, len2, m, match_index, part, part_length, parts, ref, switch_type, temp;
      switch_type = "book";
      indices = [];
      match_index = 0;
      adjust = parseInt(adjust, 10);
      parts = [match];
      ref = ["\x1e", "\x1f"];
      for (k = 0, len = ref.length; k < len; k++) {
        character = ref[k];
        temp = [];
        for (l = 0, len1 = parts.length; l < len1; l++) {
          part = parts[l];
          temp = temp.concat(part.split(character));
        }
        parts = temp;
      }
      for (m = 0, len2 = parts.length; m < len2; m++) {
        part = parts[m];
        switch_type = switch_type === "book" ? "rest" : "book";
        part_length = part.length;
        if (part_length === 0) {
          continue;
        }
        if (switch_type === "book") {
          part = part.replace(/\/\d+$/, "");
          end_index = match_index + part_length;
          if (indices.length > 0 && indices[indices.length - 1].index === adjust) {
            indices[indices.length - 1].end = end_index;
          } else {
            indices.push({
              start: match_index,
              end: end_index,
              index: adjust
            });
          }
          match_index += part_length + 2;
          adjust = this.books[part].start_index + this.books[part].value.length - match_index;
          indices.push({
            start: end_index + 1,
            end: end_index + 1,
            index: adjust
          });
        } else {
          end_index = match_index + part_length - 1;
          if (indices.length > 0 && indices[indices.length - 1].index === adjust) {
            indices[indices.length - 1].end = end_index;
          } else {
            indices.push({
              start: match_index,
              end: end_index,
              index: adjust
            });
          }
          match_index += part_length;
        }
      }
      return indices;
    };

    bcv_passage.prototype.get_absolute_indices = function(arg1) {
      var end, end_out, index, k, len, ref, start, start_out;
      start = arg1[0], end = arg1[1];
      start_out = null;
      end_out = null;
      ref = this.indices;
      for (k = 0, len = ref.length; k < len; k++) {
        index = ref[k];
        if (start_out === null && (index.start <= start && start <= index.end)) {
          start_out = start + index.index;
        }
        if ((index.start <= end && end <= index.end)) {
          end_out = end + index.index + 1;
          break;
        }
      }
      return [start_out, end_out];
    };

    bcv_passage.prototype.validate_ref = function(translations, start, end) {
      var k, len, messages, temp_valid, translation, valid;
      if (!((translations != null) && translations.length > 0)) {
        translations = [
          {
            translation: "default",
            osis: "",
            alias: "default"
          }
        ];
      }
      valid = false;
      messages = {};
      for (k = 0, len = translations.length; k < len; k++) {
        translation = translations[k];
        if (translation.alias == null) {
          translation.alias = "default";
        }
        if (translation.alias == null) {
          if (messages.translation_invalid == null) {
            messages.translation_invalid = [];
          }
          messages.translation_invalid.push(translation);
          continue;
        }
        if (this.translations.aliases[translation.alias] == null) {
          translation.alias = "default";
          if (messages.translation_unknown == null) {
            messages.translation_unknown = [];
          }
          messages.translation_unknown.push(translation);
        }
        temp_valid = this.validate_start_ref(translation.alias, start, messages)[0];
        if (end) {
          temp_valid = this.validate_end_ref(translation.alias, start, end, temp_valid, messages)[0];
        }
        if (temp_valid === true) {
          valid = true;
        }
      }
      return {
        valid: valid,
        messages: messages
      };
    };

    bcv_passage.prototype.validate_start_ref = function(translation, start, messages) {
      var ref, ref1, translation_order, valid;
      valid = true;
      if (translation !== "default" && (((ref = this.translations[translation]) != null ? ref.chapters[start.b] : void 0) == null)) {
        this.promote_book_to_translation(start.b, translation);
      }
      translation_order = ((ref1 = this.translations[translation]) != null ? ref1.order : void 0) != null ? translation : "default";
      if (start.v != null) {
        start.v = parseInt(start.v, 10);
      }
      if (this.translations[translation_order].order[start.b] != null) {
        if (start.c == null) {
          start.c = 1;
        }
        start.c = parseInt(start.c, 10);
        if (isNaN(start.c)) {
          valid = false;
          messages.start_chapter_not_numeric = true;
          return [valid, messages];
        }
        if (start.c === 0) {
          messages.start_chapter_is_zero = 1;
          if (this.options.zero_chapter_strategy === "error") {
            valid = false;
          } else {
            start.c = 1;
          }
        }
        if ((start.v != null) && start.v === 0) {
          messages.start_verse_is_zero = 1;
          if (this.options.zero_verse_strategy === "error") {
            valid = false;
          } else if (this.options.zero_verse_strategy === "upgrade") {
            start.v = 1;
          }
        }
        if (start.c > 0 && (this.translations[translation].chapters[start.b][start.c - 1] != null)) {
          if (start.v != null) {
            if (isNaN(start.v)) {
              valid = false;
              messages.start_verse_not_numeric = true;
            } else if (start.v > this.translations[translation].chapters[start.b][start.c - 1]) {
              if (this.options.passage_existence_strategy.indexOf("v") >= 0) {
                valid = false;
                messages.start_verse_not_exist = this.translations[translation].chapters[start.b][start.c - 1];
              }
            }
          }
        } else {
          if (start.c !== 1 && this.translations[translation].chapters[start.b].length === 1) {
            valid = false;
            messages.start_chapter_not_exist_in_single_chapter_book = 1;
          } else if (start.c > 0 && this.options.passage_existence_strategy.indexOf("c") >= 0) {
            valid = false;
            messages.start_chapter_not_exist = this.translations[translation].chapters[start.b].length;
          }
        }
      } else {
        if (this.options.passage_existence_strategy.indexOf("b") >= 0) {
          valid = false;
        }
        messages.start_book_not_exist = true;
      }
      return [valid, messages];
    };

    bcv_passage.prototype.validate_end_ref = function(translation, start, end, valid, messages) {
      var ref, translation_order;
      translation_order = ((ref = this.translations[translation]) != null ? ref.order : void 0) != null ? translation : "default";
      if (end.c != null) {
        end.c = parseInt(end.c, 10);
        if (isNaN(end.c)) {
          valid = false;
          messages.end_chapter_not_numeric = true;
        } else if (end.c === 0) {
          messages.end_chapter_is_zero = 1;
          if (this.options.zero_chapter_strategy === "error") {
            valid = false;
          } else {
            end.c = 1;
          }
        }
      }
      if (end.v != null) {
        end.v = parseInt(end.v, 10);
        if (isNaN(end.v)) {
          valid = false;
          messages.end_verse_not_numeric = true;
        } else if (end.v === 0) {
          messages.end_verse_is_zero = 1;
          if (this.options.zero_verse_strategy === "error") {
            valid = false;
          } else if (this.options.zero_verse_strategy === "upgrade") {
            end.v = 1;
          }
        }
      }
      if (this.translations[translation_order].order[end.b] != null) {
        if ((end.c == null) && this.translations[translation].chapters[end.b].length === 1) {
          end.c = 1;
        }
        if ((this.translations[translation_order].order[start.b] != null) && this.translations[translation_order].order[start.b] > this.translations[translation_order].order[end.b]) {
          if (this.options.passage_existence_strategy.indexOf("b") >= 0) {
            valid = false;
          }
          messages.end_book_before_start = true;
        }
        if (start.b === end.b && (end.c != null) && !isNaN(end.c)) {
          if (start.c == null) {
            start.c = 1;
          }
          if (!isNaN(parseInt(start.c, 10)) && start.c > end.c) {
            valid = false;
            messages.end_chapter_before_start = true;
          } else if (start.c === end.c && (end.v != null) && !isNaN(end.v)) {
            if (start.v == null) {
              start.v = 1;
            }
            if (!isNaN(parseInt(start.v, 10)) && start.v > end.v) {
              valid = false;
              messages.end_verse_before_start = true;
            }
          }
        }
        if ((end.c != null) && !isNaN(end.c)) {
          if (this.translations[translation].chapters[end.b][end.c - 1] == null) {
            if (this.translations[translation].chapters[end.b].length === 1) {
              messages.end_chapter_not_exist_in_single_chapter_book = 1;
            } else if (end.c > 0 && this.options.passage_existence_strategy.indexOf("c") >= 0) {
              messages.end_chapter_not_exist = this.translations[translation].chapters[end.b].length;
            }
          }
        }
        if ((end.v != null) && !isNaN(end.v)) {
          if (end.c == null) {
            end.c = this.translations[translation].chapters[end.b].length;
          }
          if (end.v > this.translations[translation].chapters[end.b][end.c - 1] && this.options.passage_existence_strategy.indexOf("v") >= 0) {
            messages.end_verse_not_exist = this.translations[translation].chapters[end.b][end.c - 1];
          }
        }
      } else {
        valid = false;
        messages.end_book_not_exist = true;
      }
      return [valid, messages];
    };

    bcv_passage.prototype.promote_book_to_translation = function(book, translation) {
      var base, base1;
      if ((base = this.translations)[translation] == null) {
        base[translation] = {};
      }
      if ((base1 = this.translations[translation]).chapters == null) {
        base1.chapters = {};
      }
      if (this.translations[translation].chapters[book] == null) {
        return this.translations[translation].chapters[book] = bcv_utils.shallow_clone_array(this.translations["default"].chapters[book]);
      }
    };

    return bcv_passage;

  })();

  bcv_utils = {
    shallow_clone: function(obj) {
      var key, out, val;
      if (obj == null) {
        return obj;
      }
      out = {};
      for (key in obj) {
        if (!hasProp.call(obj, key)) continue;
        val = obj[key];
        out[key] = val;
      }
      return out;
    },
    shallow_clone_array: function(arr) {
      var i, k, out, ref;
      if (arr == null) {
        return arr;
      }
      out = [];
      for (i = k = 0, ref = arr.length; 0 <= ref ? k <= ref : k >= ref; i = 0 <= ref ? ++k : --k) {
        if (typeof arr[i] !== "undefined") {
          out[i] = arr[i];
        }
      }
      return out;
    }
  };

  bcv_parser.prototype.regexps.translations = /(?:(?:A(?:MP|SV)|KJV|TNIV|MSG|HCSB|RSV|N(?:A(?:B(?:RE)?|SB?)|I(?:RV|V)|KJV|LT|RSV)|E[RS]V|CE[BV]))\b/gi;

  bcv_parser.prototype.translations = {
    aliases: {
      ceb: {
        osis: "CEB",
        alias: "ceb"
      },
      kjv: {
        osis: "KJV",
        alias: "kjv"
      },
      nab: {
        osis: "NAB",
        alias: "nab"
      },
      nabre: {
        osis: "NABRE",
        alias: "nab"
      },
      nas: {
        osis: "NASB",
        alias: "default"
      },
      nirv: {
        osis: "NIRV",
        alias: "kjv"
      },
      niv: {
        osis: "NIV",
        alias: "kjv"
      },
      nkjv: {
        osis: "NKJV",
        alias: "nkjv"
      },
      nlt: {
        osis: "NLT",
        alias: "nlt"
      },
      nrsv: {
        osis: "NRSV",
        alias: "nrsv"
      },
      tniv: {
        osis: "TNIV",
        alias: "kjv"
      },
      "default": {
        osis: "",
        alias: "default"
      }
    },
    alternates: {},
    "default": {
      order: {
        "Gen": 1,
        "Exod": 2,
        "Lev": 3,
        "Num": 4,
        "Deut": 5,
        "Josh": 6,
        "Judg": 7,
        "Ruth": 8,
        "1Sam": 9,
        "2Sam": 10,
        "1Kgs": 11,
        "2Kgs": 12,
        "1Chr": 13,
        "2Chr": 14,
        "Ezra": 15,
        "Neh": 16,
        "Esth": 17,
        "Job": 18,
        "Ps": 19,
        "Prov": 20,
        "Eccl": 21,
        "Song": 22,
        "Isa": 23,
        "Jer": 24,
        "Lam": 25,
        "Ezek": 26,
        "Dan": 27,
        "Hos": 28,
        "Joel": 29,
        "Amos": 30,
        "Obad": 31,
        "Jonah": 32,
        "Mic": 33,
        "Nah": 34,
        "Hab": 35,
        "Zeph": 36,
        "Hag": 37,
        "Zech": 38,
        "Mal": 39,
        "Matt": 40,
        "Mark": 41,
        "Luke": 42,
        "John": 43,
        "Acts": 44,
        "Rom": 45,
        "1Cor": 46,
        "2Cor": 47,
        "Gal": 48,
        "Eph": 49,
        "Phil": 50,
        "Col": 51,
        "1Thess": 52,
        "2Thess": 53,
        "1Tim": 54,
        "2Tim": 55,
        "Titus": 56,
        "Phlm": 57,
        "Heb": 58,
        "Jas": 59,
        "1Pet": 60,
        "2Pet": 61,
        "1John": 62,
        "2John": 63,
        "3John": 64,
        "Jude": 65,
        "Rev": 66,
        "Tob": 67,
        "Jdt": 68,
        "GkEsth": 69,
        "Wis": 70,
        "Sir": 71,
        "Bar": 72,
        "PrAzar": 73,
        "Sus": 74,
        "Bel": 75,
        "SgThree": 76,
        "EpJer": 77,
        "1Macc": 78,
        "2Macc": 79,
        "3Macc": 80,
        "4Macc": 81,
        "1Esd": 82,
        "2Esd": 83,
        "PrMan": 84
      },
      chapters: {
        "Gen": [31, 25, 24, 26, 32, 22, 24, 22, 29, 32, 32, 20, 18, 24, 21, 16, 27, 33, 38, 18, 34, 24, 20, 67, 34, 35, 46, 22, 35, 43, 55, 32, 20, 31, 29, 43, 36, 30, 23, 23, 57, 38, 34, 34, 28, 34, 31, 22, 33, 26],
        "Exod": [22, 25, 22, 31, 23, 30, 25, 32, 35, 29, 10, 51, 22, 31, 27, 36, 16, 27, 25, 26, 36, 31, 33, 18, 40, 37, 21, 43, 46, 38, 18, 35, 23, 35, 35, 38, 29, 31, 43, 38],
        "Lev": [17, 16, 17, 35, 19, 30, 38, 36, 24, 20, 47, 8, 59, 57, 33, 34, 16, 30, 37, 27, 24, 33, 44, 23, 55, 46, 34],
        "Num": [54, 34, 51, 49, 31, 27, 89, 26, 23, 36, 35, 16, 33, 45, 41, 50, 13, 32, 22, 29, 35, 41, 30, 25, 18, 65, 23, 31, 40, 16, 54, 42, 56, 29, 34, 13],
        "Deut": [46, 37, 29, 49, 33, 25, 26, 20, 29, 22, 32, 32, 18, 29, 23, 22, 20, 22, 21, 20, 23, 30, 25, 22, 19, 19, 26, 68, 29, 20, 30, 52, 29, 12],
        "Josh": [18, 24, 17, 24, 15, 27, 26, 35, 27, 43, 23, 24, 33, 15, 63, 10, 18, 28, 51, 9, 45, 34, 16, 33],
        "Judg": [36, 23, 31, 24, 31, 40, 25, 35, 57, 18, 40, 15, 25, 20, 20, 31, 13, 31, 30, 48, 25],
        "Ruth": [22, 23, 18, 22],
        "1Sam": [28, 36, 21, 22, 12, 21, 17, 22, 27, 27, 15, 25, 23, 52, 35, 23, 58, 30, 24, 42, 15, 23, 29, 22, 44, 25, 12, 25, 11, 31, 13],
        "2Sam": [27, 32, 39, 12, 25, 23, 29, 18, 13, 19, 27, 31, 39, 33, 37, 23, 29, 33, 43, 26, 22, 51, 39, 25],
        "1Kgs": [53, 46, 28, 34, 18, 38, 51, 66, 28, 29, 43, 33, 34, 31, 34, 34, 24, 46, 21, 43, 29, 53],
        "2Kgs": [18, 25, 27, 44, 27, 33, 20, 29, 37, 36, 21, 21, 25, 29, 38, 20, 41, 37, 37, 21, 26, 20, 37, 20, 30],
        "1Chr": [54, 55, 24, 43, 26, 81, 40, 40, 44, 14, 47, 40, 14, 17, 29, 43, 27, 17, 19, 8, 30, 19, 32, 31, 31, 32, 34, 21, 30],
        "2Chr": [17, 18, 17, 22, 14, 42, 22, 18, 31, 19, 23, 16, 22, 15, 19, 14, 19, 34, 11, 37, 20, 12, 21, 27, 28, 23, 9, 27, 36, 27, 21, 33, 25, 33, 27, 23],
        "Ezra": [11, 70, 13, 24, 17, 22, 28, 36, 15, 44],
        "Neh": [11, 20, 32, 23, 19, 19, 73, 18, 38, 39, 36, 47, 31],
        "Esth": [22, 23, 15, 17, 14, 14, 10, 17, 32, 3],
        "Job": [22, 13, 26, 21, 27, 30, 21, 22, 35, 22, 20, 25, 28, 22, 35, 22, 16, 21, 29, 29, 34, 30, 17, 25, 6, 14, 23, 28, 25, 31, 40, 22, 33, 37, 16, 33, 24, 41, 30, 24, 34, 17],
        "Ps": [6, 12, 8, 8, 12, 10, 17, 9, 20, 18, 7, 8, 6, 7, 5, 11, 15, 50, 14, 9, 13, 31, 6, 10, 22, 12, 14, 9, 11, 12, 24, 11, 22, 22, 28, 12, 40, 22, 13, 17, 13, 11, 5, 26, 17, 11, 9, 14, 20, 23, 19, 9, 6, 7, 23, 13, 11, 11, 17, 12, 8, 12, 11, 10, 13, 20, 7, 35, 36, 5, 24, 20, 28, 23, 10, 12, 20, 72, 13, 19, 16, 8, 18, 12, 13, 17, 7, 18, 52, 17, 16, 15, 5, 23, 11, 13, 12, 9, 9, 5, 8, 28, 22, 35, 45, 48, 43, 13, 31, 7, 10, 10, 9, 8, 18, 19, 2, 29, 176, 7, 8, 9, 4, 8, 5, 6, 5, 6, 8, 8, 3, 18, 3, 3, 21, 26, 9, 8, 24, 13, 10, 7, 12, 15, 21, 10, 20, 14, 9, 6],
        "Prov": [33, 22, 35, 27, 23, 35, 27, 36, 18, 32, 31, 28, 25, 35, 33, 33, 28, 24, 29, 30, 31, 29, 35, 34, 28, 28, 27, 28, 27, 33, 31],
        "Eccl": [18, 26, 22, 16, 20, 12, 29, 17, 18, 20, 10, 14],
        "Song": [17, 17, 11, 16, 16, 13, 13, 14],
        "Isa": [31, 22, 26, 6, 30, 13, 25, 22, 21, 34, 16, 6, 22, 32, 9, 14, 14, 7, 25, 6, 17, 25, 18, 23, 12, 21, 13, 29, 24, 33, 9, 20, 24, 17, 10, 22, 38, 22, 8, 31, 29, 25, 28, 28, 25, 13, 15, 22, 26, 11, 23, 15, 12, 17, 13, 12, 21, 14, 21, 22, 11, 12, 19, 12, 25, 24],
        "Jer": [19, 37, 25, 31, 31, 30, 34, 22, 26, 25, 23, 17, 27, 22, 21, 21, 27, 23, 15, 18, 14, 30, 40, 10, 38, 24, 22, 17, 32, 24, 40, 44, 26, 22, 19, 32, 21, 28, 18, 16, 18, 22, 13, 30, 5, 28, 7, 47, 39, 46, 64, 34],
        "Lam": [22, 22, 66, 22, 22],
        "Ezek": [28, 10, 27, 17, 17, 14, 27, 18, 11, 22, 25, 28, 23, 23, 8, 63, 24, 32, 14, 49, 32, 31, 49, 27, 17, 21, 36, 26, 21, 26, 18, 32, 33, 31, 15, 38, 28, 23, 29, 49, 26, 20, 27, 31, 25, 24, 23, 35],
        "Dan": [21, 49, 30, 37, 31, 28, 28, 27, 27, 21, 45, 13],
        "Hos": [11, 23, 5, 19, 15, 11, 16, 14, 17, 15, 12, 14, 16, 9],
        "Joel": [20, 32, 21],
        "Amos": [15, 16, 15, 13, 27, 14, 17, 14, 15],
        "Obad": [21],
        "Jonah": [17, 10, 10, 11],
        "Mic": [16, 13, 12, 13, 15, 16, 20],
        "Nah": [15, 13, 19],
        "Hab": [17, 20, 19],
        "Zeph": [18, 15, 20],
        "Hag": [15, 23],
        "Zech": [21, 13, 10, 14, 11, 15, 14, 23, 17, 12, 17, 14, 9, 21],
        "Mal": [14, 17, 18, 6],
        "Matt": [25, 23, 17, 25, 48, 34, 29, 34, 38, 42, 30, 50, 58, 36, 39, 28, 27, 35, 30, 34, 46, 46, 39, 51, 46, 75, 66, 20],
        "Mark": [45, 28, 35, 41, 43, 56, 37, 38, 50, 52, 33, 44, 37, 72, 47, 20],
        "Luke": [80, 52, 38, 44, 39, 49, 50, 56, 62, 42, 54, 59, 35, 35, 32, 31, 37, 43, 48, 47, 38, 71, 56, 53],
        "John": [51, 25, 36, 54, 47, 71, 53, 59, 41, 42, 57, 50, 38, 31, 27, 33, 26, 40, 42, 31, 25],
        "Acts": [26, 47, 26, 37, 42, 15, 60, 40, 43, 48, 30, 25, 52, 28, 41, 40, 34, 28, 41, 38, 40, 30, 35, 27, 27, 32, 44, 31],
        "Rom": [32, 29, 31, 25, 21, 23, 25, 39, 33, 21, 36, 21, 14, 23, 33, 27],
        "1Cor": [31, 16, 23, 21, 13, 20, 40, 13, 27, 33, 34, 31, 13, 40, 58, 24],
        "2Cor": [24, 17, 18, 18, 21, 18, 16, 24, 15, 18, 33, 21, 14],
        "Gal": [24, 21, 29, 31, 26, 18],
        "Eph": [23, 22, 21, 32, 33, 24],
        "Phil": [30, 30, 21, 23],
        "Col": [29, 23, 25, 18],
        "1Thess": [10, 20, 13, 18, 28],
        "2Thess": [12, 17, 18],
        "1Tim": [20, 15, 16, 16, 25, 21],
        "2Tim": [18, 26, 17, 22],
        "Titus": [16, 15, 15],
        "Phlm": [25],
        "Heb": [14, 18, 19, 16, 14, 20, 28, 13, 28, 39, 40, 29, 25],
        "Jas": [27, 26, 18, 17, 20],
        "1Pet": [25, 25, 22, 19, 14],
        "2Pet": [21, 22, 18],
        "1John": [10, 29, 24, 21, 21],
        "2John": [13],
        "3John": [15],
        "Jude": [25],
        "Rev": [20, 29, 22, 11, 14, 17, 17, 13, 21, 11, 19, 17, 18, 20, 8, 21, 18, 24, 21, 15, 27, 21],
        "Tob": [22, 14, 17, 21, 22, 18, 16, 21, 6, 13, 18, 22, 17, 15],
        "Jdt": [16, 28, 10, 15, 24, 21, 32, 36, 14, 23, 23, 20, 20, 19, 14, 25],
        "GkEsth": [22, 23, 15, 17, 14, 14, 10, 17, 32, 13, 12, 6, 18, 19, 16, 24],
        "Wis": [16, 24, 19, 20, 23, 25, 30, 21, 18, 21, 26, 27, 19, 31, 19, 29, 21, 25, 22],
        "Sir": [30, 18, 31, 31, 15, 37, 36, 19, 18, 31, 34, 18, 26, 27, 20, 30, 32, 33, 30, 31, 28, 27, 27, 34, 26, 29, 30, 26, 28, 25, 31, 24, 33, 31, 26, 31, 31, 34, 35, 30, 22, 25, 33, 23, 26, 20, 25, 25, 16, 29, 30],
        "Bar": [22, 35, 37, 37, 9],
        "PrAzar": [68],
        "Sus": [64],
        "Bel": [42],
        "SgThree": [39],
        "EpJer": [73],
        "1Macc": [64, 70, 60, 61, 68, 63, 50, 32, 73, 89, 74, 53, 53, 49, 41, 24],
        "2Macc": [36, 32, 40, 50, 27, 31, 42, 36, 29, 38, 38, 45, 26, 46, 39],
        "3Macc": [29, 33, 30, 21, 51, 41, 23],
        "4Macc": [35, 24, 21, 26, 38, 35, 23, 29, 32, 21, 27, 19, 27, 20, 32, 25, 24, 24],
        "1Esd": [58, 30, 24, 63, 73, 34, 15, 96, 55],
        "2Esd": [40, 48, 36, 52, 56, 59, 70, 63, 47, 59, 46, 51, 58, 48, 63, 78],
        "PrMan": [15],
        "Ps151": [7]
      }
    },
    vulgate: {
      chapters: {
        "Ps": [6, 13, 9, 10, 13, 11, 18, 10, 39, 8, 9, 6, 7, 5, 10, 15, 51, 15, 10, 14, 32, 6, 10, 22, 12, 14, 9, 11, 13, 25, 11, 22, 23, 28, 13, 40, 23, 14, 18, 14, 12, 5, 26, 18, 12, 10, 15, 21, 23, 21, 11, 7, 9, 24, 13, 12, 12, 18, 14, 9, 13, 12, 11, 14, 20, 8, 36, 37, 6, 24, 20, 28, 23, 11, 13, 21, 72, 13, 20, 17, 8, 19, 13, 14, 17, 7, 19, 53, 17, 16, 16, 5, 23, 11, 13, 12, 9, 9, 5, 8, 29, 22, 35, 45, 48, 43, 14, 31, 7, 10, 10, 9, 26, 9, 19, 2, 29, 176, 7, 8, 9, 4, 8, 5, 6, 5, 6, 8, 8, 3, 18, 3, 3, 21, 26, 9, 8, 24, 14, 10, 8, 12, 15, 21, 10, 11, 20, 14, 9, 7]
      }
    },
    ceb: {
      chapters: {
        "2Cor": [24, 17, 18, 18, 21, 18, 16, 24, 15, 18, 33, 21, 13],
        "Rev": [20, 29, 22, 11, 14, 17, 17, 13, 21, 11, 19, 18, 18, 20, 8, 21, 18, 24, 21, 15, 27, 21],
        "Tob": [22, 14, 17, 21, 22, 18, 16, 21, 6, 13, 18, 22, 18, 15],
        "PrAzar": [67],
        "EpJer": [72],
        "1Esd": [55, 26, 24, 63, 71, 33, 15, 92, 55]
      }
    },
    kjv: {
      chapters: {
        "3John": [14]
      }
    },
    nab: {
      order: {
        "Gen": 1,
        "Exod": 2,
        "Lev": 3,
        "Num": 4,
        "Deut": 5,
        "Josh": 6,
        "Judg": 7,
        "Ruth": 8,
        "1Sam": 9,
        "2Sam": 10,
        "1Kgs": 11,
        "2Kgs": 12,
        "1Chr": 13,
        "2Chr": 14,
        "PrMan": 15,
        "Ezra": 16,
        "Neh": 17,
        "1Esd": 18,
        "2Esd": 19,
        "Tob": 20,
        "Jdt": 21,
        "Esth": 22,
        "GkEsth": 23,
        "1Macc": 24,
        "2Macc": 25,
        "3Macc": 26,
        "4Macc": 27,
        "Job": 28,
        "Ps": 29,
        "Prov": 30,
        "Eccl": 31,
        "Song": 32,
        "Wis": 33,
        "Sir": 34,
        "Isa": 35,
        "Jer": 36,
        "Lam": 37,
        "Bar": 38,
        "EpJer": 39,
        "Ezek": 40,
        "Dan": 41,
        "PrAzar": 42,
        "Sus": 43,
        "Bel": 44,
        "SgThree": 45,
        "Hos": 46,
        "Joel": 47,
        "Amos": 48,
        "Obad": 49,
        "Jonah": 50,
        "Mic": 51,
        "Nah": 52,
        "Hab": 53,
        "Zeph": 54,
        "Hag": 55,
        "Zech": 56,
        "Mal": 57,
        "Matt": 58,
        "Mark": 59,
        "Luke": 60,
        "John": 61,
        "Acts": 62,
        "Rom": 63,
        "1Cor": 64,
        "2Cor": 65,
        "Gal": 66,
        "Eph": 67,
        "Phil": 68,
        "Col": 69,
        "1Thess": 70,
        "2Thess": 71,
        "1Tim": 72,
        "2Tim": 73,
        "Titus": 74,
        "Phlm": 75,
        "Heb": 76,
        "Jas": 77,
        "1Pet": 78,
        "2Pet": 79,
        "1John": 80,
        "2John": 81,
        "3John": 82,
        "Jude": 83,
        "Rev": 84
      },
      chapters: {
        "Gen": [31, 25, 24, 26, 32, 22, 24, 22, 29, 32, 32, 20, 18, 24, 21, 16, 27, 33, 38, 18, 34, 24, 20, 67, 34, 35, 46, 22, 35, 43, 54, 33, 20, 31, 29, 43, 36, 30, 23, 23, 57, 38, 34, 34, 28, 34, 31, 22, 33, 26],
        "Exod": [22, 25, 22, 31, 23, 30, 29, 28, 35, 29, 10, 51, 22, 31, 27, 36, 16, 27, 25, 26, 37, 30, 33, 18, 40, 37, 21, 43, 46, 38, 18, 35, 23, 35, 35, 38, 29, 31, 43, 38],
        "Lev": [17, 16, 17, 35, 26, 23, 38, 36, 24, 20, 47, 8, 59, 57, 33, 34, 16, 30, 37, 27, 24, 33, 44, 23, 55, 46, 34],
        "Num": [54, 34, 51, 49, 31, 27, 89, 26, 23, 36, 35, 16, 33, 45, 41, 35, 28, 32, 22, 29, 35, 41, 30, 25, 19, 65, 23, 31, 39, 17, 54, 42, 56, 29, 34, 13],
        "Deut": [46, 37, 29, 49, 33, 25, 26, 20, 29, 22, 32, 31, 19, 29, 23, 22, 20, 22, 21, 20, 23, 29, 26, 22, 19, 19, 26, 69, 28, 20, 30, 52, 29, 12],
        "1Sam": [28, 36, 21, 22, 12, 21, 17, 22, 27, 27, 15, 25, 23, 52, 35, 23, 58, 30, 24, 42, 16, 23, 28, 23, 44, 25, 12, 25, 11, 31, 13],
        "2Sam": [27, 32, 39, 12, 25, 23, 29, 18, 13, 19, 27, 31, 39, 33, 37, 23, 29, 32, 44, 26, 22, 51, 39, 25],
        "1Kgs": [53, 46, 28, 20, 32, 38, 51, 66, 28, 29, 43, 33, 34, 31, 34, 34, 24, 46, 21, 43, 29, 54],
        "2Kgs": [18, 25, 27, 44, 27, 33, 20, 29, 37, 36, 20, 22, 25, 29, 38, 20, 41, 37, 37, 21, 26, 20, 37, 20, 30],
        "1Chr": [54, 55, 24, 43, 41, 66, 40, 40, 44, 14, 47, 41, 14, 17, 29, 43, 27, 17, 19, 8, 30, 19, 32, 31, 31, 32, 34, 21, 30],
        "2Chr": [18, 17, 17, 22, 14, 42, 22, 18, 31, 19, 23, 16, 23, 14, 19, 14, 19, 34, 11, 37, 20, 12, 21, 27, 28, 23, 9, 27, 36, 27, 21, 33, 25, 33, 27, 23],
        "Neh": [11, 20, 38, 17, 19, 19, 72, 18, 37, 40, 36, 47, 31],
        "Job": [22, 13, 26, 21, 27, 30, 21, 22, 35, 22, 20, 25, 28, 22, 35, 22, 16, 21, 29, 29, 34, 30, 17, 25, 6, 14, 23, 28, 25, 31, 40, 22, 33, 37, 16, 33, 24, 41, 30, 32, 26, 17],
        "Ps": [6, 11, 9, 9, 13, 11, 18, 10, 21, 18, 7, 9, 6, 7, 5, 11, 15, 51, 15, 10, 14, 32, 6, 10, 22, 12, 14, 9, 11, 13, 25, 11, 22, 23, 28, 13, 40, 23, 14, 18, 14, 12, 5, 27, 18, 12, 10, 15, 21, 23, 21, 11, 7, 9, 24, 14, 12, 12, 18, 14, 9, 13, 12, 11, 14, 20, 8, 36, 37, 6, 24, 20, 28, 23, 11, 13, 21, 72, 13, 20, 17, 8, 19, 13, 14, 17, 7, 19, 53, 17, 16, 16, 5, 23, 11, 13, 12, 9, 9, 5, 8, 29, 22, 35, 45, 48, 43, 14, 31, 7, 10, 10, 9, 8, 18, 19, 2, 29, 176, 7, 8, 9, 4, 8, 5, 6, 5, 6, 8, 8, 3, 18, 3, 3, 21, 26, 9, 8, 24, 14, 10, 8, 12, 15, 21, 10, 20, 14, 9, 6],
        "Eccl": [18, 26, 22, 17, 19, 12, 29, 17, 18, 20, 10, 14],
        "Song": [17, 17, 11, 16, 16, 12, 14, 14],
        "Isa": [31, 22, 26, 6, 30, 13, 25, 23, 20, 34, 16, 6, 22, 32, 9, 14, 14, 7, 25, 6, 17, 25, 18, 23, 12, 21, 13, 29, 24, 33, 9, 20, 24, 17, 10, 22, 38, 22, 8, 31, 29, 25, 28, 28, 25, 13, 15, 22, 26, 11, 23, 15, 12, 17, 13, 12, 21, 14, 21, 22, 11, 12, 19, 11, 25, 24],
        "Jer": [19, 37, 25, 31, 31, 30, 34, 23, 25, 25, 23, 17, 27, 22, 21, 21, 27, 23, 15, 18, 14, 30, 40, 10, 38, 24, 22, 17, 32, 24, 40, 44, 26, 22, 19, 32, 21, 28, 18, 16, 18, 22, 13, 30, 5, 28, 7, 47, 39, 46, 64, 34],
        "Ezek": [28, 10, 27, 17, 17, 14, 27, 18, 11, 22, 25, 28, 23, 23, 8, 63, 24, 32, 14, 44, 37, 31, 49, 27, 17, 21, 36, 26, 21, 26, 18, 32, 33, 31, 15, 38, 28, 23, 29, 49, 26, 20, 27, 31, 25, 24, 23, 35],
        "Dan": [21, 49, 100, 34, 30, 29, 28, 27, 27, 21, 45, 13, 64, 42],
        "Hos": [9, 25, 5, 19, 15, 11, 16, 14, 17, 15, 11, 15, 15, 10],
        "Joel": [20, 27, 5, 21],
        "Jonah": [16, 11, 10, 11],
        "Mic": [16, 13, 12, 14, 14, 16, 20],
        "Nah": [14, 14, 19],
        "Zech": [17, 17, 10, 14, 11, 15, 14, 23, 17, 12, 17, 14, 9, 21],
        "Mal": [14, 17, 24],
        "Acts": [26, 47, 26, 37, 42, 15, 60, 40, 43, 49, 30, 25, 52, 28, 41, 40, 34, 28, 40, 38, 40, 30, 35, 27, 27, 32, 44, 31],
        "2Cor": [24, 17, 18, 18, 21, 18, 16, 24, 15, 18, 33, 21, 13],
        "Rev": [20, 29, 22, 11, 14, 17, 17, 13, 21, 11, 19, 18, 18, 20, 8, 21, 18, 24, 21, 15, 27, 21],
        "Tob": [22, 14, 17, 21, 22, 18, 17, 21, 6, 13, 18, 22, 18, 15],
        "Sir": [30, 18, 31, 31, 15, 37, 36, 19, 18, 31, 34, 18, 26, 27, 20, 30, 32, 33, 30, 31, 28, 27, 27, 33, 26, 29, 30, 26, 28, 25, 31, 24, 33, 31, 26, 31, 31, 34, 35, 30, 22, 25, 33, 23, 26, 20, 25, 25, 16, 29, 30],
        "Bar": [22, 35, 38, 37, 9, 72],
        "2Macc": [36, 32, 40, 50, 27, 31, 42, 36, 29, 38, 38, 46, 26, 46, 39]
      }
    },
    nlt: {
      chapters: {
        "Rev": [20, 29, 22, 11, 14, 17, 17, 13, 21, 11, 19, 18, 18, 20, 8, 21, 18, 24, 21, 15, 27, 21]
      }
    },
    nrsv: {
      chapters: {
        "2Cor": [24, 17, 18, 18, 21, 18, 16, 24, 15, 18, 33, 21, 13],
        "Rev": [20, 29, 22, 11, 14, 17, 17, 13, 21, 11, 19, 18, 18, 20, 8, 21, 18, 24, 21, 15, 27, 21]
      }
    }
  };

  bcv_parser.prototype.regexps.space = "[\\s\\xa0]";

  bcv_parser.prototype.regexps.escaped_passage = RegExp("(?:^|[^\\x1f\\x1e\\dA-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])((?:(?:ch(?:apters?|a?pts?\\.?|a?p?s?\\.?)?\\s*\\d+\\s*(?:[\\u2013\\u2014\\-]|through|thru|to)\\s*\\d+\\s*(?:from|of|in)(?:\\s+the\\s+book\\s+of)?\\s*)|(?:ch(?:apters?|a?pts?\\.?|a?p?s?\\.?)?\\s*\\d+\\s*(?:from|of|in)(?:\\s+the\\s+book\\s+of)?\\s*)|(?:\\d+(?:th|nd|st)\\s*ch(?:apter|a?pt\\.?|a?p?\\.?)?\\s*(?:from|of|in)(?:\\s+the\\s+book\\s+of)?\\s*))?\\x1f(\\d+)(?:/\\d+)?\\x1f(?:/\\d+\\x1f|[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014]|title(?![a-z])|see" + bcv_parser.prototype.regexps.space + "+also|ff(?![a-z0-9])|f(?![a-z0-9])|chapters|chapter|through|compare|chapts|verses|chpts|chapt|chaps|verse|chap|thru|also|chp|chs|cha|and|see|ver|vss|ch|to|cf|vs|vv|v|[a-e](?!\\w)|$)+)", "gi");

  bcv_parser.prototype.regexps.match_end_split = /\d\W*title|\d\W*(?:ff(?![a-z0-9])|f(?![a-z0-9]))(?:[\s\xa0*]*\.)?|\d[\s\xa0*]*[a-e](?!\w)|\x1e(?:[\s\xa0*]*[)\]\uff09])?|[\d\x1f]/gi;

  bcv_parser.prototype.regexps.control = /[\x1e\x1f]/g;

  bcv_parser.prototype.regexps.pre_book = "[^A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ]";

  bcv_parser.prototype.regexps.first = "(?:1st|1|I|First)\\.?" + bcv_parser.prototype.regexps.space + "*";

  bcv_parser.prototype.regexps.second = "(?:2nd|2|II|Second)\\.?" + bcv_parser.prototype.regexps.space + "*";

  bcv_parser.prototype.regexps.third = "(?:3rd|3|III|Third)\\.?" + bcv_parser.prototype.regexps.space + "*";

  bcv_parser.prototype.regexps.range_and = "(?:[&\u2013\u2014-]|(?:and|compare|cf|see" + bcv_parser.prototype.regexps.space + "+also|also|see)|(?:through|thru|to))";

  bcv_parser.prototype.regexps.range_only = "(?:[\u2013\u2014-]|(?:through|thru|to))";

  bcv_parser.prototype.regexps.get_books = function(include_apocrypha, case_sensitive) {
    var book, books, k, len, out;
    books = [
      {
        osis: ["Ps"],
        apocrypha: true,
        extra: "2",
        regexp: /(\b)(Ps151)(?=\.1)/g
      }, {
        osis: ["Gen"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])((?:ਉਤਪਤ|Ter(?:emt[eé]s)?|Sáng[\s\xa0]*thế[\s\xa0]*ký|[ĀA]tiy(?:[aā]kamam)|M(?:[oó]zes[\s\xa0]*I|wa(?:nzo)?)|《(?:创(?:世记》|》)|創(?:世[紀記]》|》))|K(?:itabu[\s\xa0]*cha[\s\xa0]*Kwanza[\s\xa0]*cha[\s\xa0]*Musa|n(?:jiga[\s\xa0]*Postanka|iha[\s\xa0]*(?:stvorenia|p[oô]vodu))|s(?:i[eę]g(?:[ai][\s\xa0]*Rodzaju)|\.[\s\xa0]*Rodzaju|[\s\xa0]*Rodzaju)|\.[\s\xa0]*(?:stvorenia|p[oô]vodu)|[\s\xa0]*(?:stvorenia|p[oô]vodu))|창(?:세기?)?|تك|उत्प(?:ाति|त(?:्ति(?:को[\s\xa0]*पुस्तक)?|ि))|pīdāyiš|தொ(?:டக்க[\s\xa0]*நூல்|நூ)|Книга[\s\xa0]*Бытия|F(?:(?:[oö]rsta[\s\xa0]*Mosebok(?:en)?)|yrsta[\s\xa0]*(?:b[oó]k[\s\xa0]*M(?:[oó]se)|M[oó]seb(?:[oó]k))|ørste[\s\xa0]*Mos(?:ebo[gk])?|acerea)|سفر[\s\xa0]*التكوين|Henesis|Γ(?:έν(?:εσ(?:ις|η))?|ε(?:ν(?:εσ(?:ις|η))?)?)|בר(?:אשית|יאה)|ଆଦି(?:ପୁସ୍ତକ)?|ﺗﻜﻮﻳﻦ|ஆதி(?:யாகமம்)?|R(?:odz|dz)|ปฐ(?:มกาล|ก)|1(?:-?(?:ше(?:\.[\s\xa0]*книга[\s\xa0]*Мо[ий]сеева|[\s\xa0]*книга[\s\xa0]*Мо[ий]сеева)|[ае](?:\.[\s\xa0]*книга[\s\xa0]*Мо(?:[ий]сеева|[\s\xa0]*книга[\s\xa0]*Мо[ий]сеева)))|e(?:\.[\s\xa0]*Mozes|[\s\xa0]*Mozes)|\.[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|книга[\s\xa0]*Мо[ийј]сеева|Ks(?:i[eę]g(?:[ai][\s\xa0]*Mo(?:j(?:[zż]eszowa|y[zż]eszowe)))|\.[\s\xa0]*Mo(?:j[zż]eszowa|y[zż]eszowe)|[\s\xa0]*Mo(?:j[zż]eszowa|y[zż]eszowe))|Buch[\s\xa0]*Mose|Мо(?:исеева|јс(?:ијева)?)|M(?:ó(?:zes|s(?:eb[oó]k)?)|o(?:oseksen[\s\xa0]*kirja|zes|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)|s(?:e(?:b(?:o(?:g|k(?:en)?)|ók))?)?)?))|Mós|[\s\xa0]*(?:книга[\s\xa0]*Мо[ийј]сеева|Ks(?:i[eę]g(?:[ai][\s\xa0]*Mo(?:j(?:[zż]eszowa|y[zż]eszowe)))|\.[\s\xa0]*Mo(?:j[zż]eszowa|y[zż]eszowe)|[\s\xa0]*Mo(?:j[zż]eszowa|y[zż]eszowe))|k(?:niha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|\.[\s\xa0]*Moj[zž]i(?:[sš]ova)|[\s\xa0]*Moj[zž]i(?:[sš]ova))|Buch[\s\xa0]*Mose|M(?:ó(?:s(?:eb[oó]k)?|z(?:es)?)|o(?:os(?:eksen[\s\xa0]*kirja)?|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)?|s(?:e(?:b(?:o(?:g|k(?:en)?)|ók))?)?|z(?:es)?)?|z)|М(?:о(?:исеева|јс(?:ијева)?))?))|پ(?:َیدایش|يدائش|یدا[ئی]ش)|P(?:urwaning[\s\xa0]*Dumadi|rv(?:n[ií][\s\xa0]*(?:kniha[\s\xa0]*Moj(?:[zž](?:[ií](?:[sš]ova))|Moj[zž](?:[ií](?:[sš]ova))))|[aá][\s\xa0]*(?:kniha[\s\xa0]*Moj(?:[zž]i(?:[sš]ova)|Moj[zž]i(?:[sš]ova)))|[yý][\s\xa0]*(?:list[\s\xa0]*Moj(?:[zž]i(?:[sš]ova)|Moj[zž]i(?:[sš]ova))))|ierwsz[aey][\s\xa0]*(?:Ks(?:i(?:[eę]g(?:[ai][\s\xa0]*Mo(?:j(?:[zż]eszowa|y[zż]eszowe)))|\.[\s\xa0]*Mo(?:j[zż]eszowa|y[zż]eszowe)|[\s\xa0]*Mo(?:j[zż]eszowa|y[zż]eszowe))|Moj(?:[zż](?:eszowa)?)))|ost(?:anak)?)|Liber[\s\xa0]*Genesis|E(?:nsimm[aä]inen[\s\xa0]*Mooseksen[\s\xa0]*kirja|erste[\s\xa0]*Mozes|ls[oő][\s\xa0]*M(?:[oó]zes)|rste[\s\xa0]*(?:Buch[\s\xa0]*Mose|Mose))|I(?:\.[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|книга[\s\xa0]*Мо[ийј]сеева|Ks(?:i[eę]g(?:[ai][\s\xa0]*Mo(?:j(?:[zż]eszowa|y[zż]eszowe)))|\.[\s\xa0]*Mo(?:j[zż]eszowa|y[zż]eszowe)|[\s\xa0]*Mo(?:j[zż]eszowa|y[zż]eszowe))|Мо(?:исеева|јс(?:ијева)?)|M(?:o(?:oseksen[\s\xa0]*kirja|zes|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)|s(?:eb[oó]k)?)|ó(?:zes|s(?:eb[oó]k)?)))|[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|книга[\s\xa0]*Мо[ийј]сеева|Ks(?:i[eę]g(?:[ai][\s\xa0]*Mo(?:j(?:[zż]eszowa|y[zż]eszowe)))|\.[\s\xa0]*Mo(?:j[zż]eszowa|y[zż]eszowe)|[\s\xa0]*Mo(?:j[zż]eszowa|y[zż]eszowe))|Мо(?:исеева|јс(?:ијева)?)|M(?:o(?:oseksen[\s\xa0]*kirja|zes|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)?|s(?:eb[oó]k)?)|ó(?:zes|s(?:eb[oó]k)?))))|B(?:eresjiet|ilowgii|uttja)|П(?:ерш[ае][\s\xa0]*книга[\s\xa0]*Мо(?:[ий]сеева)|ърва[\s\xa0]*(?:книга[\s\xa0]*Моисеева|Моисеева)|рв(?:о[\s\xa0]*книга[\s\xa0]*Мојсеева|а[\s\xa0]*(?:книга[\s\xa0]*Мојсеева|Мојс(?:ијева)?))|ост(?:ање)?)|liv[\s\xa0]*Konmansman[\s\xa0]*an|На(?:станување|ч(?:ало)?)|Jen(?:[eè]z)?|G(?:ên(?:esis)?|e(?:n(?:i(?:[ei]s(?:[eiu]s)|s[eiu]s)|n(?:i(?:[ei]s(?:[eiu]s)|s[eiu]s)|e(?:es[eiu]s|s[eiu]s|is(?:[eiu]s)?)|sis)|e(?:es[eiu]s|is(?:[eiu]s)?|s(?:us|[ai]|es?)|z(?:is|a))|sis|èse)?)?|n|é(?:n(?:esis)?)?)|Zan(?:afilla)?|Б(?:(?:[иы]т(?:ие)?)|у(?:г|т(?:тя)?))|utpat(?:ti(?:ko[\s\xa0]*pustak)?)?|Utpaati)|(?:I(?:\.[\s\xa0]*Ksi[eę]g(?:[ai][\s\xa0]*Moy(?:[zż]eszowe))|[\s\xa0]*Ksi[eę]g(?:[ai][\s\xa0]*Moy(?:[zż]eszowe)))|1(?:\.[\s\xa0]*Ksi[eę]g(?:[ai][\s\xa0]*Moy(?:[zż]eszowe))|[\s\xa0]*Ksi[eę]g(?:[ai][\s\xa0]*Moy(?:[zż]eszowe))|-?[ае][\s\xa0]*книга[\s\xa0]*Мо(?:[ий]сеева))|P(?:rv(?:n[ií][\s\xa0]*Moj(?:[zž](?:[ií](?:[sš]ova)))|[ayáý][\s\xa0]*Moj(?:[zž]i(?:[sš]ova)))|ierwsz[aey][\s\xa0]*(?:Ks(?:i(?:[eę]g(?:[ai][\s\xa0]*Moy(?:[zż]eszowe))|\.[\s\xa0]*Mo(?:j[zż]eszowa|y[zż]eszowe)|[\s\xa0]*Mo(?:j[zż]eszowa|y[zż]eszowe))|Moj(?:[zż](?:eszowa)?)))))|Pierwsz[aey][\s\xa0]*(?:Ks(?:\.[\s\xa0]*Mo(?:j(?:[zż]eszowa|y[zż]eszowe)|[\s\xa0]*Mo(?:j[zż]eszowa|y[zż]eszowe))|Moj(?:[zż](?:eszowa)?)))|Pierwsz[aey][\s\xa0]*(?:Ks(?:\.[\s\xa0]*Moy(?:[zż]eszowe|[\s\xa0]*Mo(?:j[zż]eszowa|y[zż]eszowe))|Moj(?:[zż](?:eszowa)?)))|Pierwsz[aey][\s\xa0]*(?:Ks[\s\xa0]*Mo(?:j(?:[zż]eszowa|y[zż]eszowe)|Moj(?:[zż](?:eszowa)?)))|Pierwsz[aey][\s\xa0]*(?:Ks[\s\xa0]*Moy(?:[zż]eszowe|Moj(?:[zż](?:eszowa)?)))|Pierwsz(?:[aey][\s\xa0]*Moj(?:[zż](?:eszowa)?))|(?:Ensimm[äa]inen[\s\xa0]*Mooseksen|utpattiko|创(?:世记》?|》)?|Genesis|उत्पत्तिको|(?:[1I](?:\.[\s\xa0]*Mooseksen|[\s\xa0]*Mooseksen))|《(?:创(?:世记)?|創(?:世[紀記])?)|創(?:世[記紀]》?|》)?|Konmansman|Sáng(?:[\s\xa0]*Thế)?|التكوين))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["Exod"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])((?:Книга[\s\xa0]*Исход|Nirgaman|An(?:nen[\s\xa0]*Mosebok|d(?:en[\s\xa0]*Mos(?:ebog)?|r(?:a[\s\xa0]*Mosebok(?:en)?|e[\s\xa0]*Mos(?:ebok)?)))|Xuất[\s\xa0]*(?:Ê-?díp-?tô[\s\xa0]*ký|Ai(?:[\s\xa0]*Cập[\s\xa0]*Ký|-?cập)|Hành)|خ(?:ُرُوج|ر(?:وج)?)|出エ[シジ](?:[フプ]ト記)|T(?:oinen[\s\xa0]*Mooseksen[\s\xa0]*kirja|weede[\s\xa0]*Mozes)|I(?:e[sşș]irea|I(?:\.[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|книга[\s\xa0]*Мо[ийј]сеева|Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Мо(?:исеева|јс(?:ијева)?)|M(?:o(?:oseksen[\s\xa0]*kirja|zes|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)|s(?:eb[oó]k)?)|ó(?:zes|s(?:eb[oó]k)?)))|[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|книга[\s\xa0]*Мо[ийј]сеева|Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Мо(?:исеева|јс(?:ијева)?)|M(?:o(?:oseksen[\s\xa0]*kirja|zes|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)?|s(?:eb[oó]k)?)|ó(?:zes|s(?:eb[oó]k)?))))|zl(?:azak)?)|ଯାତ୍ରା(?:[\s\xa0]*ପୁସ୍ତକ|ପୁସ୍ତକ)|(?:[ÉÊ]x(?:d|o(?:do?)?)?)|Bax(?:niintii)?|Sjemot|ḫurūj|nirgam|2(?:-?(?:ге(?:\.[\s\xa0]*книга[\s\xa0]*Мо[ий]сеева|[\s\xa0]*книга[\s\xa0]*Мо[ий]сеева)|[ае](?:\.[\s\xa0]*книга[\s\xa0]*Мо(?:[ий]сеева|[\s\xa0]*книга[\s\xa0]*Мо[ий]сеева)))|e(?:\.[\s\xa0]*Mozes|[\s\xa0]*Mozes)|\.[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|книга[\s\xa0]*Мо[ийј]сеева|Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Buch[\s\xa0]*Mose|Мо(?:исеева|јс(?:ијева)?)|M(?:ó(?:zes|s(?:eb[oó]k)?)|o(?:oseksen[\s\xa0]*kirja|zes|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)|s(?:e(?:b(?:o(?:g|k(?:en)?)|ók))?)?)?))|Mós|[\s\xa0]*(?:книга[\s\xa0]*Мо[ийј]сеева|Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|k(?:niha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|\.[\s\xa0]*Moj[zž]i(?:[sš]ova)|[\s\xa0]*Moj[zž]i(?:[sš]ova))|Buch[\s\xa0]*Mose|M(?:ó(?:s(?:eb[oó]k)?|z(?:es)?)|o(?:os(?:eksen[\s\xa0]*kirja)?|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)?|s(?:e(?:b(?:o(?:g|k(?:en)?)|ók))?)?|z(?:es)?)?|z)|М(?:о(?:исеева|јс(?:ијева)?))?))|kūč|탈출기?|प्रस्थान(?:को[\s\xa0]*पुस्तक)?|سفر[\s\xa0]*الخروج|Pangentasan|E(?:sodo|cs(?:odus)?|gz(?:od(?:us)?|òd)?|ks(?:od[io])?|x(?:d|o(?:d(?:is|ul|[eos])?)?)?)|[OÖ]nnur[\s\xa0]*(?:b(?:[oó]k[\s\xa0]*M(?:[oó]se)|M[oó]seb(?:[oó]k)))|liv[\s\xa0]*delivrans[\s\xa0]*lan|निर्गमन?|D(?:ru(?:h(?:[aá][\s\xa0]*(?:kniha[\s\xa0]*Moj(?:[zž](?:[ií](?:[sš]ova))|Moj[zž](?:[ií](?:[sš]ova))))|[yý][\s\xa0]*(?:kniha[\s\xa0]*Moj(?:[zž](?:[ií](?:[sš]ova))|list[\s\xa0]*Moj[zž]i(?:[sš]ova)|Moj[zž](?:[ií](?:[sš]ova)))))|g[ai][\s\xa0]*(?:Ks(?:i(?:[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Moj(?:[zż](?:eszowa)?))))|al(?:ja)?)|வி(?:டுதலைப்[\s\xa0]*பயணம்|ப)|Liber[\s\xa0]*Exodus|יציא(?:ת[\s\xa0]*מצרים|ה)|Ἔξ|K(?:njiga[\s\xa0]*Izlaska|s(?:i[eę]g(?:[ai][\s\xa0]*Wyj(?:[sś]cia))|\.[\s\xa0]*Wyj[sś]cia|[\s\xa0]*Wyj[sś]cia)|i(?:tabu[\s\xa0]*cha[\s\xa0]*Pili[\s\xa0]*cha[\s\xa0]*Musa|v(?:onul[aá]s)?)|ut(?:oka)?)|Друг(?:е[\s\xa0]*книга[\s\xa0]*Мо[ий]сеева|а[\s\xa0]*(?:книга[\s\xa0]*Мо[ий]сеева|Мојс(?:ијева)?))|Егзодус|Zweite[\s\xa0]*(?:Buch[\s\xa0]*Mose|Mose)|யாத்(?:திராகமம்)?|《出(?:埃及(?:[記记]》|》)|谷紀》|》)|M(?:[aá]sodik[\s\xa0]*M(?:[oó]zes)|[oó]zes[\s\xa0]*II)|И(?:з(?:л(?:азак|ез)?|х(?:од)?)|сх)|Εξ(?:οδος)?|출(?:애굽기)?|Έξοδος|W(?:yj|j)|Y[aā]ttir(?:[aā]kamam)|שמות|อพยพ?|Vy[hȟ]id|В(?:тор(?:о[\s\xa0]*книга[\s\xa0]*Мојсеева|а[\s\xa0]*(?:книга[\s\xa0]*Мо[иј]сеева|Моисеева))|их(?:ід)?)|ਕੂਚ|prastʰ[aā]nko[\s\xa0]*pustak)|(?:2-?[ае][\s\xa0]*книга[\s\xa0]*Мо(?:[ий]сеева)|[OÖ]nnur[\s\xa0]*M(?:[oó]seb(?:[oó]k))|Dru(?:h(?:[aá][\s\xa0]*Moj(?:[zž](?:[ií](?:[sš]ova)))|[yý][\s\xa0]*(?:list[\s\xa0]*Moj(?:[zž]i(?:[sš]ova)|Moj[zž](?:[ií](?:[sš]ova)))))|g[ai][\s\xa0]*(?:Ks(?:\.[\s\xa0]*Moj(?:[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Moj(?:[zż](?:eszowa)?)))))|Dru(?:h[yý][\s\xa0]*Moj(?:[zž](?:[ií](?:[sš]ova)))|g[ai][\s\xa0]*(?:Ks[\s\xa0]*Moj(?:[zż]eszowa|Moj(?:[zż](?:eszowa)?))))|Drug(?:[ai][\s\xa0]*Moj(?:[zż](?:eszowa)?))|(?:الخروج|ଯାତ୍ରା|《出(?:谷紀|埃及[記记]?)?|Exodus|2(?:\.[\s\xa0]*Mooseksen|[\s\xa0]*Mooseksen)|Xuất|II(?:\.[\s\xa0]*Mooseksen|[\s\xa0]*Mooseksen)|Исход|Delivrans|प्रस्थानको|Toinen[\s\xa0]*Mooseksen|出(?:谷紀》?|埃及(?:[记記]》?|》)?|》)?|prastʰ[aā]nko))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["Bel"],
        apocrypha: true,
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:התנין[\\s\\xa0]*בבבל|Si[\\s\\xa0]*Bel[\\s\\xa0]*at[\\s\\xa0]*ang[\\s\\xa0]*Dragon|[ヘベ]ルと[竜龍]|Виле[\\s\\xa0]*и[\\s\\xa0]*драконе|Danieli[\\s\\xa0]*na[\\s\\xa0]*Makuhani[\\s\\xa0]*wa[\\s\\xa0]*Beli|பேல்[\\s\\xa0]*தெய்வமும்[\\s\\xa0]*அரக்கப்பாம்பும்[\\s\\xa0]*என்பவையாகும்|《Bel》|벨과[\\s\\xa0]*[뱀용]|Бел(?:[\\s\\xa0]*(?:и[\\s\\xa0]*Дракон|і[\\s\\xa0]*дракон)|е)|Opowiadaniem[\\s\\xa0]*o[\\s\\xa0]*Belu[\\s\\xa0]*i[\\s\\xa0]*w[eę](?:[zż]u)|بل[\\s\\xa0]*والتنين|Istoria[\\s\\xa0]*(?:omor[aâ]rii[\\s\\xa0]*balaurului[\\s\\xa0]*(?:[sş]i[\\s\\xa0]*a[\\s\\xa0]*sf(?:[aă]r(?:[aâ]m(?:[aă]rii[\\s\\xa0]*lui[\\s\\xa0]*Bel))))|Balaurului)|Histoia[\\s\\xa0]*Beli[\\s\\xa0]*et[\\s\\xa0]*draconis|Β(?:ηλ[\\s\\xa0]*και[\\s\\xa0]*Δρ[άα]κων|ὴλ)|בל[\\s\\xa0]*והדרקון|B(?:a[aá]l[\\s\\xa0]*(?:[eé]s[\\s\\xa0]*a[\\s\\xa0]*s(?:[aá]rk(?:[aá]ny)))|el(?:a[\\s\\xa0]*i[\\s\\xa0]*w[eę](?:[zż]a)|[\\s\\xa0]*(?:ja[\\s\\xa0]*lohik[aä](?:[aä]rme)|a(?:['’]r[\\s\\xa0]*Ddraig|nd[\\s\\xa0]*(?:the[\\s\\xa0]*(?:Dragon|S(?:erpent|nake))|Dragon|S(?:erpent|nake))|[\\s\\xa0]*drak)|y[\\s\\xa0]*el[\\s\\xa0]*(?:Serpiente|Drag[oó]n)|és[\\s\\xa0]*a[\\s\\xa0]*s[aá]rk(?:[aá]ny)|e(?:s[\\s\\xa0]*a[\\s\\xa0]*s[aá]rk(?:[aá]ny)|n[\\s\\xa0]*de[\\s\\xa0]*draak|t[\\s\\xa0]*(?:le[\\s\\xa0]*(?:Serpent|Dragon)|draconis)|[\\s\\xa0]*(?:il[\\s\\xa0]*Drago|o[\\s\\xa0]*Drag[aã]o))|[sș]i[\\s\\xa0]*dragonul|o(?:ch[\\s\\xa0]*Ormguden|g[\\s\\xa0]*dr(?:ekinn|a(?:gen[\\s\\xa0]*i[\\s\\xa0]*Babylon|ken)))|&[\\s\\xa0]*(?:the[\\s\\xa0]*(?:Dragon|S(?:erpent|nake))|Dragon|S(?:erpent|nake))|und[\\s\\xa0]*Vom[\\s\\xa0]*Drachen))|él[\\s\\xa0]*(?:[eé]s[\\s\\xa0]*a[\\s\\xa0]*s(?:[aá]rk(?:[aá]ny))|a[\\s\\xa0]*drak)))|(?:《Bel|பேல்(?:[\\s\\xa0]*தெய்வமும்[\\s\\xa0]*அரக்கப்பாம்பும்)?|Βηλ|Бел|B(?:él|el(?:[\\s\\xa0]*(?:at[\\s\\xa0]*ang[\\s\\xa0]*Dragon|e(?:t[\\s\\xa0]*le[\\s\\xa0]*(?:serpent|dragon)|[\\s\\xa0]*o[\\s\\xa0]*drag[aã]o)|og[\\s\\xa0]*Dragen)|》)?)))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Phlm"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(filēmōn[\\s\\xa0]*ke[\\s\\xa0]*nām[\\s\\xa0]*kā[\\s\\xa0]*ḫaṭ|(?:F(?:íl(?:emonsbr[eé]fið|m)|lmn?|i(?:l(?:èmone|émon|em(?:o(?:n(?:sbr[eé]fið|brevet|hoz|it)|m))?|im(?:on)?|m))?|mn?)|Ф(?:илим|лм)|الرسالة[\\s\\xa0]*إلى[\\s\\xa0]*فليمون|pʰilemon(?:[\\s\\xa0]*nū̃[\\s\\xa0]*pattrī|[aā]l(?:[aā][\\s\\xa0]*patra)|l[aā](?:[iī][\\s\\xa0]*patra))|पौलाचे[\\s\\xa0]*फिलेमोनाला[\\s\\xa0]*पत्र|אגרת[\\s\\xa0]*פולוס[\\s\\xa0]*אל-?פילימון|《(?:腓利(?:門書》|门书》)|費肋孟書》|肥利孟》|[門门]》)|Φλμ|फ(?:िलेमोन(?:लाई[\\s\\xa0]*प(?:ावलको[\\s\\xa0]*पत्र|त्र)|ा)?|ले)|Προς[\\s\\xa0]*Φιλ[ήη]μονα|Epistula(?:m[\\s\\xa0]*ad[\\s\\xa0]*Philemonem|[\\s\\xa0]*ad[\\s\\xa0]*Philemonem)|П(?:исмо[\\s\\xa0]*од[\\s\\xa0]*апостол[\\s\\xa0]*Павле[\\s\\xa0]*до[\\s\\xa0]*Филемон|ослан(?:ня[\\s\\xa0]*(?:св(?:\\.[\\s\\xa0]*апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Филимона|[\\s\\xa0]*апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Филимона)|апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Филимона|до[\\s\\xa0]*Фили(?:пі[ий]ців|мона))|и(?:е[\\s\\xa0]*(?:на[\\s\\xa0]*св(?:\\.[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Филимона|[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Филимона)|[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Филимона|[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Филимона))|к(?:ъм[\\s\\xa0]*Филимон|[\\s\\xa0]*Филимону))|ца[\\s\\xa0]*Филимону)))|האיגרת[\\s\\xa0]*אל[\\s\\xa0]*פילימון|பில(?:மோன(?:ுக்கு[\\s\\xa0]*எழுதிய[\\s\\xa0]*திருமுகம்|்)|ே(?:மோன(?:ுக்கு[\\s\\xa0]*எழுதிய[\\s\\xa0]*(?:நிருபம்|கடிதம்)|்))?)?|ଫିଲୀମୋନଙ୍କ[\\s\\xa0]*ପ୍ରତି[\\s\\xa0]*ପତ୍ର|K(?:irje[\\s\\xa0]*Filemonille|a(?:ng[\\s\\xa0]*Filem[oó]n|y[\\s\\xa0]*Filemon))|フィレモン(?:への手紙|書)?|B(?:arua[\\s\\xa0]*kwa[\\s\\xa0]*Filemoni|r(?:éf[\\s\\xa0]*P[aá]ls[\\s\\xa0]*til[\\s\\xa0]*F(?:[ií]lemons)|e(?:f[\\s\\xa0]*P[aá]ls[\\s\\xa0]*til[\\s\\xa0]*F(?:[ií]lemons)|vet[\\s\\xa0]*til(?:l[\\s\\xa0]*Filemon|[\\s\\xa0]*Filemon))))|(?:[ヒピ]レモン(?:ヘの手紙|への(?:手紙|書)|書))|필레(?:몬(?:에게[\\s\\xa0]*보낸[\\s\\xa0]*서간|서))?|P(?:oslannja[\\s\\xa0]*apostola[\\s\\xa0]*Pavla[\\s\\xa0]*do[\\s\\xa0]*Fylymona|il[eē]m(?:[oō](?:[nṉ]ukku[\\s\\xa0]*E(?:[lḻ]utiya[\\s\\xa0]*Nirupam)))|a(?:vlova[\\s\\xa0]*poslanica[\\s\\xa0]*Filemonu|ulus['’][\\s\\xa0]*Brev[\\s\\xa0]*til[\\s\\xa0]*Filemon)|h(?:i(?:-?lê-?môn|l(?:[éê]mon|e(?:m(?:on(?:hoz)?)?)?))|l(?:[ei]mon|mn?)|mn?))|ਫ(?:਼ਿਲੇਮੋਨ[\\s\\xa0]*ਨੂੰ[\\s\\xa0]*ਪੱਤ੍ਰੀ|ਿਲੇਮੋਨ[\\s\\xa0]*ਨੂੰ[\\s\\xa0]*ਪੱਤ੍ਰੀ)|L(?:ettera[\\s\\xa0]*a[\\s\\xa0]*Filemone|ist[\\s\\xa0]*(?:(?:[sś]w(?:\\.[\\s\\xa0]*Pawła[\\s\\xa0]*do[\\s\\xa0]*Filemona|[\\s\\xa0]*Pawła[\\s\\xa0]*do[\\s\\xa0]*Filemona))|do[\\s\\xa0]*Filemona|Filem[oó]novi))|ฟ(?:ีเลโมน|ม)|Waraka[\\s\\xa0]*kwa[\\s\\xa0]*Filemoni|빌레몬서|ف(?:ِلیمون[\\s\\xa0]*کے[\\s\\xa0]*نام[\\s\\xa0]*کا[\\s\\xa0]*خط|لیمون[\\s\\xa0]*کے[\\s\\xa0]*نام[\\s\\xa0]*(?:پولس[\\s\\xa0]*رسُول[\\s\\xa0]*کا[\\s\\xa0]*خط|کا[\\s\\xa0]*خط)|يل)?|رسالة[\\s\\xa0]*بولس[\\s\\xa0]*الرسول[\\s\\xa0]*إلى[\\s\\xa0]*فليمون)|(?:फिलेमोन(?:ाला(?:[\\s\\xa0]*पत्र)?|लाई)|[门門]》?|Фил(?:емон|имон[уа]?)|肥利孟》?|pʰilemon(?:[āa]l[aā]|l[aā][iī])?|Filem(?:on(?:ovi|i(?:lle)?|[uea])?|ón)|腓利(?:門書》?|门书》?)|אל[\\s\\xa0]*פילימון|P(?:aulus’[\\s\\xa0]*brev[\\s\\xa0]*til[\\s\\xa0]*Filemon|oslanica[\\s\\xa0]*Filemonu|il[ēe]m(?:[ōo](?:[ṉn]ukku))|hi(?:lemonem|-?lê))|《(?:費肋孟書|腓利(?:门书|門書)|肥利孟|[門门])|ف(?:ِلیمون|ل[يی]مون)|ਫ਼ਿਲੇਮੋਨ[\\s\\xa0]*ਨੂੰ|Φιλ[ήη]μονα|ad[\\s\\xa0]*Philemonem|К[\\s\\xa0]*Филимону|ଫିଲୀମୋନଙ୍କ|費肋孟書》?|До[\\s\\xa0]*Филимона))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Lev"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(Λευ[ιϊ]τ(?:ικ(?:[οό]ν?)?)|Λευ(?:[ιϊ]τ)|(?:سفر[\s\xa0]*اللاويين|3(?:-?(?:тє(?:\.[\s\xa0]*книга[\s\xa0]*Мо[ий]сеева|[\s\xa0]*книга[\s\xa0]*Мо[ий]сеева)|[ае](?:\.[\s\xa0]*книга[\s\xa0]*Мо(?:[ий]сеева|[\s\xa0]*книга[\s\xa0]*Мо[ий]сеева)))|e(?:\.[\s\xa0]*Mo(?:sebok(?:en)?|zes)|[\s\xa0]*Mo(?:sebok(?:en)?|zes))|\.[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|книга[\s\xa0]*Мо[ий]сеева|Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Buch[\s\xa0]*Mose|Мо(?:исеева|јс(?:ијева)?)|M(?:ó(?:zes|s(?:eb[oó]k)?)|o(?:oseksen[\s\xa0]*kirja|zes|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)|s(?:e(?:b(?:o(?:g|k(?:en)?)|ók))?)?)?))|Mós|[\s\xa0]*(?:книга[\s\xa0]*Мо[ий]сеева|Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|k(?:niha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|\.[\s\xa0]*Moj[zž]i(?:[sš]ova)|[\s\xa0]*Moj[zž]i(?:[sš]ova))|Buch[\s\xa0]*Mose|M(?:ó(?:s(?:eb[oó]k)?|z(?:es)?)|o(?:os(?:eksen[\s\xa0]*kirja)?|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)?|s(?:e(?:b(?:o(?:g|k(?:en)?)|ók))?)?|z(?:es)?)?|z)|М(?:о(?:исеева|јс(?:ијева)?))?))|D(?:erde[\s\xa0]*Mozes|ritte[\s\xa0]*(?:Buch[\s\xa0]*Mose|Mose))|M(?:ambo[\s\xa0]*ya[\s\xa0]*Walawi|[oó]zes[\s\xa0]*III)|أح|ויקרא|l(?:iv[\s\xa0]*Prensip[\s\xa0]*lavi[\s\xa0]*nan[\s\xa0]*Bondye|e(?:v(?:ihar[uū]ko[\s\xa0]*pustak|ī(?:har[uū]ko[\s\xa0]*pustak|āṃ[\s\xa0]*dī[\s\xa0]*potʰī))|w[iī]y))|레(?:위기?)?|ספר[\s\xa0]*הלוויים|K(?:itabu[\s\xa0]*cha[\s\xa0]*Tatu[\s\xa0]*cha[\s\xa0]*Musa|olmas[\s\xa0]*Mooseksen[\s\xa0]*kirja|s(?:i[eę]g(?:[ai][\s\xa0]*Kapła(?:[nń]ska))|\.[\s\xa0]*Kapła[nń]ska|[\s\xa0]*Kapła[nń]ska)|a(?:imaman|p[lł])|p[lł])|iḥbār|《(?:肋未紀》|利(?:未[記记]》|末记》|》))|L(?:ēviyar[aā]kamam|i(?:ber[\s\xa0]*Leviticus|v[ei]t(?:(?:[ei]cus|cus)))|ê-?vi[\s\xa0]*ký|a(?:a(?:ivyavyavastha|w(?:iyiintii)?)|w)|e(?:b(?:iti(?:co|k(?:us|o)))?|f(?:iticus)?|v(?:et(?:[ei]cus|cus)|íticos?|yt|i(?:yar[aā]kamam|t(?:ski[\s\xa0]*zakonik|ecus|cus|[aá]k|i(?:que|c(?:u(?:si|l)|os?)?|k(?:[eë]t|us?)?)))?)?)?|v|é(?:v(?:itique)?)?)|Тре(?:т(?:а[\s\xa0]*книга[\s\xa0]*Мо[иј]сеева|[яє][\s\xa0]*книга[\s\xa0]*Мо(?:[ий]сеева)|о[\s\xa0]*Моисеева)|ћ(?:ом[\s\xa0]*Мојс(?:ијева)?|а[\s\xa0]*Мојс(?:ијева)?))|Vajikra|Книга[\s\xa0]*Левит|لا|Лев(?:итска[\s\xa0]*книга)?|Λευ?|Harmadik[\s\xa0]*M[oó]zes|ल(?:ैव्य(?:्व्य्वस्था|व(?:्यवस्था?|स्था))?|ेव(?:ि|ी(?:हरूको[\s\xa0]*पुस्तक|य)?))|Þriðja[\s\xa0]*(?:b[oó]k[\s\xa0]*M(?:[oó]se)|M[oó]seb(?:[oó]k))|ลนต|Wa(?:jikra|l)|ଲେବୀୟ[\s\xa0]*ପୁସ୍ତକ|ﺍﻟﻼﻭﻳﻲ|T(?:řet[ií][\s\xa0]*(?:kniha[\s\xa0]*Moj(?:[zž](?:[ií](?:[sš]ova))|Moj[zž](?:[ií](?:[sš]ova))))|r(?:zeci(?:a[\s\xa0]*(?:Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Moj(?:[zż](?:eszowa)?))|[\s\xa0]*(?:Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Moj(?:[zż](?:eszowa)?)))|e(?:t(?:i(?:a[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž]i(?:[sš]ova)|Moj[zž]i(?:[sš]ova))|[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|Moj[zž](?:[ií](?:[sš]ova))))|í[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|Moj[zž](?:[ií](?:[sš]ova))))|dje[\s\xa0]*Mos(?:ebo(?:g|k(?:en)?))?)))|ا(?:لأحبار|حبار)|เลวีนิติ|லேவி(?:யர(?:ாகமம்|்))?|III(?:\.[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|книга[\s\xa0]*Мо[ий]сеева|Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Мо(?:исеева|јс(?:ијева)?)|M(?:o(?:oseksen[\s\xa0]*kirja|zes|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)|s(?:eb[oó]k)?)|ó(?:zes|s(?:eb[oó]k)?)))|[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|книга[\s\xa0]*Мо[ий]сеева|Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Мо(?:исеева|јс(?:ијева)?)|M(?:o(?:oseksen[\s\xa0]*kirja|zes|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)?|s(?:eb[oó]k)?)|ó(?:zes|s(?:eb[oó]k)?))))|レ[ヒビ]記?|ਲੇਵੀਆਂ[\s\xa0]*ਦੀ[\s\xa0]*ਪੋਥੀ)|(?:3-?[ае][\s\xa0]*книга[\s\xa0]*Мо(?:[ий]сеева)|Třet[ií][\s\xa0]*Moj(?:[zž](?:[ií](?:[sš]ova))))|(?:ଲେବୀୟ|lev(?:ihar[ūu]ko|ī(?:har[ūu]ko|āṃ))|लेवीहरूको|L(?:eviticus|ê(?:-?vi)?)|Walawi|Kolmas[\s\xa0]*Mooseksen|3(?:\.[\s\xa0]*Mooseksen|[\s\xa0]*Mooseksen)|اللاويين|肋未紀》?|利(?:未[记記]》?|末记》?|》)|《(?:肋未紀|利(?:未[记記]|末记)?)|III(?:\.[\s\xa0]*Mooseksen|[\s\xa0]*Mooseksen)|Левит(?:ска)?|ਲੇਵੀਆਂ))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["2Thess"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(2\.[\s\xa0]*Tessalonikerbrevet|2(?:[\s\xa0]*Tessalonikerbrevet|\.[\s\xa0]*tessalonikerbrev)|(?:2(?:º(?:\.[\s\xa0]*Tesaloni[cs]enses?|[\s\xa0]*Tesaloni[cs]enses?)|[ея](?:\.[\s\xa0]*(?:к[\s\xa0]*Фессалоники(?:[ий]цам|Фессалоники[ий]цам)|[\s\xa0]*(?:к[\s\xa0]*Фессалоники[ий]цам|Фессалоники[ий]цам)))|ème(?:\.[\s\xa0]*Thes(?:saloniciens|aloniciens)|[\s\xa0]*Thes(?:saloniciens|aloniciens))|-?(?:я(?:\.[\s\xa0]*(?:к[\s\xa0]*Фессалоники[ий]цам|Фессалоники[ий]цам)|[\s\xa0]*(?:к[\s\xa0]*Фессалоники[ий]цам|Фессалоники[ий]цам))|تھِسّلُنیکیوں|ге(?:\.[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))|фессалонікі[ий]ців|до[\s\xa0]*солунян|Солун(?:ьці|ян))|[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))|фессалонікі[ий]ців|до[\s\xa0]*солунян|Солун(?:ьці|ян)))|а(?:\.[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))|фессалонікі[ий]ців|до[\s\xa0]*солунян|Солун(?:ьці|ян))|[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))|фессалонікі[ий]ців|до[\s\xa0]*солунян|Солун(?:ьці|ян)))|е(?:\.[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))|к[\s\xa0]*Фессалоники[ий]цам|Фессалоники[ий]цам|фессалонікі[ий]ців|до[\s\xa0]*солунян|Солун(?:ьці|ян))|[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))|к[\s\xa0]*Фессалоники[ий]цам|Фессалоники[ий]цам|фессалонікі[ий]ців|до[\s\xa0]*солунян|Солун(?:ьці|ян))))|d(?:\.[\s\xa0]*Thes(?:saloniciens|aloniciens)|e(?:\.[\s\xa0]*Thes(?:saloniciens|aloniciens)|[\s\xa0]*Thes(?:saloniciens|aloniciens))|[\s\xa0]*Thes(?:saloniciens|aloniciens))|o(?:\.[\s\xa0]*Tes(?:salonicenses|aloni[cs]enses?)|[\s\xa0]*Tes(?:salonicenses|aloni[cs]enses?))|nd(?:\.[\s\xa0]*Th(?:es(?:al(?:lonians|oni(?:[ci]ans|ons|ans?|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:i[ae]ns|ans)|ions|ens|(?:[ao](?:ans|ns?))|ns)))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s)?)?|s(?:ss?)?)?|[\s\xa0]*Th(?:es(?:al(?:lonians|oni(?:[ci]ans|ons|ans?|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:i[ae]ns|ans)|ions|ens|(?:[ao](?:ans|ns?))|ns)))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s)?)?|s(?:ss?)?)?)|[\s\xa0]*(?:ธส|थ(?:ेस्सलनीकाकरांस|िस(?:लुनिकी|्स(?:ल(?:ुनीकियों|ोनिकी(?:हरूलाई)?))?))|เธ[ซส]ะโลนิกา|தெச(?:லோ(?:னிக்க(?:ேயர்|ர்))?)?|фессалонікі[ий]ців|Сол(?:у(?:њанима|н(?:јани|ьці|ци(?:те)?|ян)))?|Þess|Kirje[\s\xa0]*tessalonikalaisille|t(?:essalonikerbrev|ʰ(?:issalonik[iī]har(?:[uū]l(?:[aā][iī]))|essalan[iī]k(?:[aā]kar(?:[aā](?:[mṃ]s)))|assalunīkīāṃ))|Wathesalonike|Mga[\s\xa0]*T(?:aga(?:[\s\xa0]*Tesaloni[ck]a|-?(?:[\s\xa0]*Tesaloni[ck]a|Tesal[oó]ni(?:[ck]a)))|esaloni[cs]ense)|S(?:elanikasve|ol(?:u(?:n(?:janima[\s\xa0]*Poslanica|[cč]anom|sk[yý]m)|ňsk[yý]m)|ún(?:[cč]anom|skym))?)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Солун|ослан(?:ица[\s\xa0]*Солуњанима|ня[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))))|до[\s\xa0]*солунян|ਥੱਸਲੁਨੀਕੀਆਂ[\s\xa0]*ਨੂੰ|к[\s\xa0]*Фессалоники[ий]цам|k(?:\.[\s\xa0]*(?:Tesaloni(?:čanom|c(?:anom|k[yý]m))|Sol[uú]n(?:(?:[cč]anom|skym)))|[\s\xa0]*(?:Tesaloni(?:čanom|c(?:anom|k[yý]m))|Sol[uú]n(?:(?:[cč]anom|skym))))|Фес(?:салоники[ий]цам)?|ଥେସଲନୀକୀୟଙ|list[\s\xa0]*(?:Tesalonick[yý]m|Solu[nň]sk(?:[yý]m))|T(?:aga-?Tesal[oó]ni(?:[ck]a)|ê-?sa-?lô-?ni-?ca|èsalonika|e(?:cal[oō](?:[nṉ]ikkiyarukku)|s(?:al(?:óni[ck]a|oni(?:senses?|čanom|ika|c(?:en(?:s(?:[oó]w|es?)|i)|k[yý]m|zan|a(?:nom)?)|k(?:yen|a)?))|s(?:aloni(?:ce(?:n(?:s(?:k[yý]m|es)|zen)|si)|k(?:alais(?:kirje|ille)|er(?:ne)?))|z(?:alonika(?:iakhoz)?)?)?)?)?|h(?:aissaluneekiyon|ê(?:-?sa-?lô-?ni-?ca|xalônica)|e(?:s(?:al(?:lonians|oni(?:kasve|c(?:iens|ans)|ians|ons|a(?:id|ns?)|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:kerbrev(?:et)?|c(?:en(?:ses|zen)|i[ae]ns|ans|her)|ions|ens|a(?:ans|id|ns?)|ns|o(?:ans|ns?))))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s|z(?:alonika(?:iakhoz)?)?)?)?)?|s(?:ss?)?)?|s)|ت(?:ھ(?:ِسلُنیکیوں|س(?:ّلنیکیوں|لنیکوں))|س)|(?:[ie](?:\.[\s\xa0]*(?:Thesalonikasve|Selanikasve)|[\s\xa0]*(?:Thesalonikasve|Selanikasve)))|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan))|do[\s\xa0]*Tesaloniczan))|a(?:\.[\s\xa0]*Tessalonicenses|[\s\xa0]*Tessalonicenses)|Thess|۔تھسلنیکیوں|°(?:\.[\s\xa0]*Tessalonicesi|[\s\xa0]*Tessalonicesi)|\.(?:[oº](?:\.[\s\xa0]*Tesaloni(?:[cs]enses?|[\s\xa0]*Tesaloni[cs]enses?))|-?تھِسّلُنیکیوں|۔تھسلنیکیوں|[\s\xa0]*(?:เธ[ซส]ะโลนิกา|фессалонікі[ий]ців|Сол(?:у(?:њанима|н(?:јани|ьці|ци(?:те)?|ян)))?|Þess|Kirje[\s\xa0]*tessalonikalaisille|Wathesalonike|Mga[\s\xa0]*T(?:aga(?:[\s\xa0]*Tesaloni[ck]a|-?(?:[\s\xa0]*Tesaloni[ck]a|Tesal[oó]ni(?:[ck]a)))|esaloni[cs]ense)|S(?:elanikasve|ol(?:u(?:n(?:janima[\s\xa0]*Poslanica|[cč]anom|sk[yý]m)|ňsk[yý]m)|ún(?:[cč]anom|skym))?)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Солун|ослан(?:ица[\s\xa0]*Солуњанима|ня[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))))|tʰissalonik[iī]har(?:[uū]l(?:[aā][iī]))|до[\s\xa0]*солунян|T(?:aga-?Tesal[oó]ni(?:[ck]a)|ê-?sa-?lô-?ni-?ca|èsalonika|e(?:s(?:al(?:óni[ck]a|oni(?:senses?|čanom|ika|c(?:en(?:s(?:[oó]w|es?)|i)|k[yý]m|zan|a(?:nom)?)|k(?:yen|a)?))|s(?:aloni(?:ce(?:n(?:s(?:k[yý]m|es)|zen)|si)|k(?:alais(?:kirje|ille)|er(?:ne)?))|z(?:alonika(?:iakhoz)?)?)?)?)?|h(?:aissaluneekiyon|ê(?:-?sa-?lô-?ni-?ca|xalônica)|e(?:s(?:al(?:lonians|oni(?:kasve|c(?:iens|ans)|ians|ons|a(?:id|ns?)|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:kerbrev(?:et)?|c(?:en(?:ses|zen)|i[ae]ns|ans|her)|ions|ens|a(?:ans|id|ns?)|ns|o(?:ans|ns?))))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s|z(?:alonika(?:iakhoz)?)?)?)?)?|s(?:ss?)?)?)|Фессалоники[ий]цам|к[\s\xa0]*Фессалоники[ий]цам|थिस(?:लुनिकी|्स(?:ल(?:ुनीकियों|ोनिकी(?:हरूलाई)?))?)|ଥେସଲନୀକୀୟଙ|list[\s\xa0]*(?:Tesalonick[yý]m|Solu[nň]sk(?:[yý]m))|تھ(?:ِسلُنیکیوں|س(?:ّلنیکیوں|لنیکوں))|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan))|do[\s\xa0]*Tesaloniczan)))|테살|e(?:me(?:\.[\s\xa0]*Thes(?:saloniciens|aloniciens)|[\s\xa0]*Thes(?:saloniciens|aloniciens))|\.[\s\xa0]*T(?:hes(?:aloniciens|s(?:alonic(?:enzen|iens))?)|es(?:s(?:alonicenzen)?)?)|[\s\xa0]*T(?:hes(?:aloniciens|s(?:alonic(?:enzen|iens))?)|es(?:s(?:alonicenzen)?)?)))|थिस्सलोनिकीहरूलाई[\s\xa0]*(?:पावलको[\s\xa0]*दोस्रो[\s\xa0]*पत्र|दोस्त्रो[\s\xa0]*पत्र)|T(?:oinen[\s\xa0]*(?:Kirje[\s\xa0]*tessalonikalaisille|Tessalonikalais(?:kirje|ille))|e(?:cal[oō](?:[nṉ]ikkiyarukku[\s\xa0]*E(?:[lḻ]utiya[\s\xa0]*Ira(?:[nṇ](?:[tṭ](?:[aā]vatu[\s\xa0]*Nirupam)))))|soloniika[\s\xa0]*Labaad)|weede[\s\xa0]*T(?:hess(?:alonicenzen)?|es(?:s(?:alonicenzen)?)?))|தெசலோனிக்க(?:ியருக்கு[\s\xa0]*எழுதிய[\s\xa0]*இரண்டாவது[\s\xa0]*நிருபம்|ருக்கு[\s\xa0]*எழுதிய[\s\xa0]*இரண்டா(?:வது[\s\xa0]*திருமுகம்|ம்[\s\xa0]*திருமுகம்)|ேயருக்கு[\s\xa0]*எழுதிய[\s\xa0]*இரண்டாம்[\s\xa0]*கடிதம்)|I(?:kalawang[\s\xa0]*(?:Mga[\s\xa0]*T(?:aga(?:-?[\s\xa0]*Tesaloni[ck]a|[\s\xa0]*Tesaloni[ck]a)|esaloni[cs]ense)|Tesaloni(?:sense|c(?:ense|a)|ka))|I(?:\.[\s\xa0]*(?:Mga[\s\xa0]*T(?:aga(?:-?[\s\xa0]*Tesaloni[ck]a|[\s\xa0]*Tesaloni[ck]a)|esaloni[cs]ense)|фессалонікі[ий]ців|Сол(?:у(?:њанима|н(?:јани|ьці|ци(?:те)?|ян)))?|Þess|Kirje[\s\xa0]*tessalonikalaisille|Sol(?:u(?:n(?:janima[\s\xa0]*Poslanica|[cč]anom|sk[yý]m)|ňsk[yý]m)|ún(?:[cč]anom|skym))?|Wathesalonike|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Солун|ослан(?:ица[\s\xa0]*Солуњанима|ня[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))))|до[\s\xa0]*солунян|list[\s\xa0]*(?:Tesalonick[yý]m|Solu[nň]sk(?:[yý]m))|T(?:ê-?sa-?lô-?ni-?ca|èsalonika|e(?:s(?:aloni(?:senses?|čanom|ika|c(?:en(?:s(?:[oó]w|es?)|i)|k[yý]m|zan|a(?:nom)?)|k(?:yen|a)?)|s(?:aloni(?:kalais(?:kirje|ille)|ce(?:n(?:s(?:k[yý]m|es)|zen)|si))|z(?:alonika(?:iakhoz)?)?)?)?)?|h(?:ê(?:-?sa-?lô-?ni-?ca|xalônica)|e(?:s(?:al(?:lonians|oni(?:c(?:iens|ans)|ians|ons|a(?:id|ns?)|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:en(?:ses|zen)|i[ae]ns|ans)|ions|ens|a(?:ans|id|ns?)|ns|o(?:ans|ns?))))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s|z(?:alonika(?:iakhoz)?)?)?)?)?|s(?:ss?)?)?)|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan))|do[\s\xa0]*Tesaloniczan))|[\s\xa0]*(?:Mga[\s\xa0]*T(?:aga(?:-?[\s\xa0]*Tesaloni[ck]a|[\s\xa0]*Tesaloni[ck]a)|esaloni[cs]ense)|фессалонікі[ий]ців|Сол(?:у(?:њанима|н(?:јани|ьці|ци(?:те)?|ян)))?|Þess|Kirje[\s\xa0]*tessalonikalaisille|Sol(?:u(?:n(?:janima[\s\xa0]*Poslanica|[cč]anom|sk[yý]m)|ňsk[yý]m)|ún(?:[cč]anom|skym))?|Wathesalonike|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Солун|ослан(?:ица[\s\xa0]*Солуњанима|ня[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))))|до[\s\xa0]*солунян|list[\s\xa0]*(?:Tesalonick[yý]m|Solu[nň]sk(?:[yý]m))|T(?:ê-?sa-?lô-?ni-?ca|èsalonika|e(?:s(?:aloni(?:senses?|čanom|ika|c(?:en(?:s(?:[oó]w|es?)|i)|k[yý]m|zan|a(?:nom)?)|k(?:yen|a)?)|s(?:aloni(?:kalais(?:kirje|ille)|ce(?:n(?:s(?:k[yý]m|es)|zen)|si))|z(?:alonika(?:iakhoz)?)?)?)?)?|h(?:ê(?:-?sa-?lô-?ni-?ca|xalônica)|e(?:s(?:al(?:lonians|oni(?:c(?:iens|ans)|ians|ons|a(?:id|ns?)|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:en(?:ses|zen)|i[ae]ns|ans)|ions|ens|a(?:ans|id|ns?)|ns|o(?:ans|ns?))))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s|z(?:alonika(?:iakhoz)?)?)?)?)?|s(?:ss?)?)?)|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan))|do[\s\xa0]*Tesaloniczan))))|테살로니카(?:[\s\xa0]*신자들에게[\s\xa0]*보낸[\s\xa0]*둘째[\s\xa0]*서간|2서)|पौलाचे[\s\xa0]*थेस्सलनीकाकरांस[\s\xa0]*दुसरे[\s\xa0]*पत्र|Zweite[\s\xa0]*Thessalonicher|دوم(?:-?تھِسّلُنیکیوں|۔تھسلنیکیوں|[\s\xa0]*تھ(?:ِسلُنیکیوں|س(?:ّلنیکیوں|لنیکوں)))|رسالة[\s\xa0]*(?:بولس[\s\xa0]*الرسول[\s\xa0]*الثانية[\s\xa0]*إلى[\s\xa0]*أهل[\s\xa0]*تسالونيكي|تسالونيكي[\s\xa0]*الثانية)|《(?:得撒洛尼後書》|莎倫後》|帖(?:撒(?:罗尼迦后书》|羅尼迦後書》)|[后後]》))|데살로니가[2후]서|テサロニケ(?:の信徒への手紙二|人への(?:第二の手紙|後の書|手紙二)|[\s\xa0]*2|後書)|האיגרת[\s\xa0]*השנייה[\s\xa0]*אל[\s\xa0]*התסלוניקים|אגרת[\s\xa0]*פולוס[\s\xa0]*השנייה[\s\xa0]*אל-?התסלונ|M(?:[aá]sodik[\s\xa0]*T(?:hessz(?:alonika(?:iakhoz)?)?|essz(?:alonika(?:iakhoz)?)?))|S(?:[ií]ðara[\s\xa0]*(?:br(?:[eé]f[\s\xa0]*P(?:[aá]ls[\s\xa0]*til[\s\xa0]*Þess(?:alon(?:[ií]kumanna)?))|Þessalon[ií]kubr(?:[eé]f)))|e(?:gund(?:a[\s\xa0]*Tessalonicenses|o[\s\xa0]*Tes(?:salonicenses|aloni[cs]enses?))|cond(?:a[\s\xa0]*(?:lettera[\s\xa0]*ai[\s\xa0]*Tessalonicesi|Tessalonicesi)|o[\s\xa0]*Tessalonicesi|[\s\xa0]*Th(?:es(?:al(?:lonians|oni(?:[ci]ans|ons|ans?|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:i[ae]ns|ans)|ions|ens|(?:[ao](?:ans|ns?))|ns)))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s)?)?|s(?:ss?)?)?)))|And(?:e(?:t[\s\xa0]*Thessalonikerbrev|n[\s\xa0]*T(?:essalonikerne|hess(?:alonikerbrev)?))|r(?:a[\s\xa0]*T(?:hessalonikerbrevet|essalonikerbrevet)|e[\s\xa0]*(?:tessalonikerbrev|Tess(?:aloniker(?:ne)?)?)))|الرسالة[\s\xa0]*الثانية[\s\xa0]*إلى[\s\xa0]*أهل[\s\xa0]*تسالونيكي|Epistula[\s\xa0]*(?:II[\s\xa0]*ad[\s\xa0]*Thessalonicenses|ad[\s\xa0]*Thessalonicenses[\s\xa0]*II)|۲(?:-?تھِسّلُنیکیوں|۔تھسلنیکیوں|[\s\xa0]*تھ(?:ِسلُنیکیوں|س(?:ّلنیکیوں|لنیکوں)))|Barua[\s\xa0]*ya[\s\xa0]*Pili[\s\xa0]*kwa[\s\xa0]*Wathesalonike|ଥେସଲନୀକୀୟଙ୍କ[\s\xa0]*ପ୍ରତି[\s\xa0]*ଦ୍ୱିତୀୟ[\s\xa0]*ପତ୍ର|Втор(?:о[\s\xa0]*(?:п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Солун|ослание[\s\xa0]*(?:на[\s\xa0]*св(?:\.[\s\xa0]*ап(?:\.[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Солуняни|[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Солуняни)|[\s\xa0]*ап(?:\.[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Солуняни|[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Солуняни))|към[\s\xa0]*солунците))|Солун(?:ците|јани))|а[\s\xa0]*(?:писмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Солун|Сол(?:ун(?:јани|ци(?:те)?))?))|تھ(?:ِسّلُنیکیوں[\s\xa0]*کے[\s\xa0]*نام[\s\xa0]*کا[\s\xa0]*دوسرا[\s\xa0]*خط|سلنیک(?:وں[\s\xa0]*کے[\s\xa0]*نام[\s\xa0]*پو[\s\xa0]*لس[\s\xa0]*رسول[\s\xa0]*کادوسرا[\s\xa0]*خط|یوں[\s\xa0]*کے[\s\xa0]*نام[\s\xa0]*کا[\s\xa0]*دوسرا[\s\xa0]*خط))|Друг(?:а[\s\xa0]*(?:послан(?:ица[\s\xa0]*Солуњанима|ня[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян))))|фессалонікі[ий]ців|до[\s\xa0]*солунян|Солу(?:њанима|н(?:ьці|ян)))|е[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))|фессалонікі[ий]ців|до[\s\xa0]*солунян|Солун(?:ьці|ян)))|Προς[\s\xa0]*Θεσσαλονικε[ίι]ς[\s\xa0]*Β['ʹʹ΄’]|ଦ୍ୱିତୀୟ[\s\xa0]*ଥେସଲନୀକୀୟଙ|tʰ(?:issal(?:unīkiyōṅ[\s\xa0]*ke[\s\xa0]*nām[\s\xa0]*kā[\s\xa0]*dūsrā[\s\xa0]*ḫaṭ|onik[iī]har(?:[uū]l(?:[aā](?:[iī][\s\xa0]*dostro[\s\xa0]*patra))))|assalunīkīāṃ[\s\xa0]*nū̃[\s\xa0]*dūjī[\s\xa0]*pattrī|essalan[iī]k(?:[aā]kar(?:[aā](?:[mṃ]s[\s\xa0]*dusre[\s\xa0]*patra))))|P(?:a(?:ulus(?:'[\s\xa0]*Andet[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Thessalonikerne|’[\s\xa0]*(?:Andet[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Thessalonikerne|andre[\s\xa0]*brev[\s\xa0]*til[\s\xa0]*tessalonikerne))|vlova[\s\xa0]*druga[\s\xa0]*poslanica[\s\xa0]*Solunjanima)|ili[\s\xa0]*(?:Wathesalonike|Th(?:es?)?))|ਥੱਸਲੁਨੀਕੀਆਂ[\s\xa0]*ਨੂੰ[\s\xa0]*ਦੂਜੀ[\s\xa0]*ਪੱਤ੍ਰੀ|Β['ʹʹ΄’][\s\xa0]*Θε(?:σ(?:σαλονικε(?:[ίι]ς)?)?)|D(?:e(?:uxi(?:[eè]me(?:s[\s\xa0]*Thes(?:saloniciens|aloniciens)|[\s\xa0]*Thes(?:saloniciens|aloniciens)))|zy(?:[eè]m[\s\xa0]*Tesalonik(?:yen)?))|ru(?:g(?:a[\s\xa0]*(?:Solunjanima[\s\xa0]*Poslanica|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan))|do[\s\xa0]*Tesaloniczan)|Tesalonic(?:ens[oó]w|zan))|i[\s\xa0]*(?:List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan))|do[\s\xa0]*Tesaloniczan)|Tesalonic(?:ens[oó]w|zan)))|h(?:e[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*solunjan|(?:[aá][\s\xa0]*(?:kniha[\s\xa0]*(?:Tesaloni(?:čanom|c(?:anom|k[yý]m))|Sol[uú]n(?:(?:[cč]anom|skym)))|list[\s\xa0]*(?:Tesalonick[yý]m|Solu[nň]sk(?:[yý]m))|Sol(?:u(?:n(?:[cč]anom|sk[yý]m)|ňsk[yý]m)|ún(?:[cč]anom|skym))?|Te(?:s(?:salonicensk[yý]m|aloni(?:čanom|c(?:anom|k[yý]m))))?))|(?:[yý][\s\xa0]*(?:list[\s\xa0]*(?:Tesaloni(?:čanom|c(?:anom|k[yý]m))|Sol(?:u(?:n(?:[cč]anom|sk[yý]m)|ňsk[yý]m)|ún(?:[cč]anom|skym)))|Sol(?:u(?:n(?:[cč]anom|sk[yý]m)|ňsk[yý]m)|ún(?:[cč]anom|skym))?|Te(?:s(?:salonicensk[yý]m|aloni(?:čanom|c(?:anom|k[yý]m))))?)))))|Wa(?:raka[\s\xa0]*wa[\s\xa0]*Pili[\s\xa0]*kwa[\s\xa0]*Wathesalonik[ei]|thesalonike[\s\xa0]*II)|ﺍﻟﺜﺎﻧﻴﺔ[\s\xa0]*ﺗﺴﺎﻟﻮﻧﻴﻜﻲ)|(?:S[ií]ðara[\s\xa0]*(?:br(?:[eé]f[\s\xa0]*P(?:[aá]ls[\s\xa0]*til[\s\xa0]*Þess)|Þessalon[ií]kubr(?:[eé]f)))|2(?:[ея](?:\.[\s\xa0]*Фессалоники(?:[ий]цам|[\s\xa0]*(?:к[\s\xa0]*Фессалоники[ий]цам|Фессалоники[ий]цам)))|\.[oº][\s\xa0]*Tesaloni(?:[cs]enses?))|Β['ʹʹ΄’][\s\xa0]*Θε)|(?:S[ií]ðara[\s\xa0]*Þessalon(?:[ií]kubr(?:[eé]f))|2[ея][\s\xa0]*(?:к[\s\xa0]*Фессалоники(?:[ий]цам|Фессалоники[ий]цам)))|2[ея][\s\xa0]*Фессалоники(?:[ий]цам)|(?:《(?:得撒洛尼後書|莎倫後|帖(?:撒(?:罗尼迦后书|羅尼迦後書)|[後后]))|Druga[\s\xa0]*(?:poslanica[\s\xa0]*Solunjanima|Solunjanima)|2(?:\.[\s\xa0]*(?:Solunjanima|Tê)|[\s\xa0]*(?:Solunjanima|Tê))|得撒洛尼後書》?|帖(?:撒(?:羅尼迦後書》?|罗尼迦后书》?)|[后後]》?)|II(?:\.[\s\xa0]*(?:Solunjanima|Tê)|[\s\xa0]*(?:Solunjanima|Tê))|莎倫後》?|थेस्सलनीकाकरांस[\s\xa0]*दुसरे[\s\xa0]*पत्र|השנייה[\s\xa0]*אל[\s\xa0]*התסלוניקים|Thessalonicenses[\s\xa0]*II|ad[\s\xa0]*Thessalonicenses[\s\xa0]*II))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["1Thess"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(1\.[\s\xa0]*Tessalonikerbrevet|1(?:[\s\xa0]*Tessalonikerbrevet|\.[\s\xa0]*tessalonikerbrev)|(?:데살로니가[1전]서|۱(?:-?تھِسّلُنیکیوں|[\s\xa0]*تھ(?:ِسلُنیکیوں|سّلنیکیوں)|۔تھسلنیکیوں)|I(?:\.[\s\xa0]*(?:Mga[\s\xa0]*T(?:aga(?:-?[\s\xa0]*Tesaloni[ck]a|[\s\xa0]*Tesaloni[ck]a)|esaloni[cs]ense)|фессалонікі[ий]ців|Сол(?:у(?:њанима|н(?:јани|ьці|ци(?:те)?|ян)))?|Þess|Kirje[\s\xa0]*tessalonikalaisille|Sol(?:u(?:n(?:janima[\s\xa0]*Poslanica|[cč]anom|sk[yý]m)|ňsk[yý]m)|ún(?:[cč]anom|skym))?|Wathesalonike|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Солун|ослан(?:ица[\s\xa0]*Солуњанима|ня[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))))|до[\s\xa0]*солунян|list[\s\xa0]*(?:Tesalonick[yý]m|Solu[nň]sk(?:[yý]m))|T(?:ê-?sa-?lô-?ni-?ca|èsalonika|e(?:s(?:aloni(?:senses?|čanom|ika|c(?:en(?:s(?:[oó]w|es?)|i)|k[yý]m|zan|a(?:nom)?)|k(?:yen|a)?)|s(?:aloni(?:kalais(?:kirje|ille)|ce(?:n(?:s(?:k[yý]m|es)|zen)|si))|z(?:alonika(?:iakhoz)?)?)?)?)?|h(?:ê(?:-?sa-?lô-?ni-?ca|xalônica)|e(?:s(?:al(?:lonians|oni(?:c(?:iens|ans)|ians|ons|a(?:id|ns?)|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:en(?:ses|zen)|i[ae]ns|ans)|ions|ens|a(?:ans|id|ns?)|ns|o(?:ans|ns?))))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s|z(?:alonika(?:iakhoz)?)?)?)?)?|s(?:ss?)?)?)|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan))|do[\s\xa0]*Tesaloniczan))|[\s\xa0]*(?:Mga[\s\xa0]*T(?:aga(?:-?[\s\xa0]*Tesaloni[ck]a|[\s\xa0]*Tesaloni[ck]a)|esaloni[cs]ense)|фессалонікі[ий]ців|Сол(?:у(?:њанима|н(?:јани|ьці|ци(?:те)?|ян)))?|Þess|Kirje[\s\xa0]*tessalonikalaisille|Sol(?:u(?:n(?:janima[\s\xa0]*Poslanica|[cč]anom|sk[yý]m)|ňsk[yý]m)|ún(?:[cč]anom|skym))?|Wathesalonike|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Солун|ослан(?:ица[\s\xa0]*Солуњанима|ня[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))))|до[\s\xa0]*солунян|list[\s\xa0]*(?:Tesalonick[yý]m|Solu[nň]sk(?:[yý]m))|T(?:ê-?sa-?lô-?ni-?ca|èsalonika|e(?:s(?:aloni(?:senses?|čanom|ika|c(?:en(?:s(?:[oó]w|es?)|i)|k[yý]m|zan|a(?:nom)?)|k(?:yen|a)?)|s(?:aloni(?:kalais(?:kirje|ille)|ce(?:n(?:s(?:k[yý]m|es)|zen)|si))|z(?:alonika(?:iakhoz)?)?)?)?)?|h(?:ê(?:-?sa-?lô-?ni-?ca|xalônica)|e(?:s(?:al(?:lonians|oni(?:c(?:iens|ans)|ians|ons|a(?:id|ns?)|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:en(?:ses|zen)|i[ae]ns|ans)|ions|ens|a(?:ans|id|ns?)|ns|o(?:ans|ns?))))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s|z(?:alonika(?:iakhoz)?)?)?)?)?|s(?:ss?)?)?)|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan))|do[\s\xa0]*Tesaloniczan)))|P(?:er[sš]e[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*solunjan|a(?:ulus(?:'[\s\xa0]*(?:Første[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Thessalonikerne|1(?:\.[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Thessalonikerne|[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Thessalonikerne))|’[\s\xa0]*(?:Første[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Thessalonikerne|første[\s\xa0]*brev[\s\xa0]*til[\s\xa0]*tessalonikerne|1(?:\.[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Thessalonikerne|[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Thessalonikerne)))|vlova[\s\xa0]*prva[\s\xa0]*poslanica[\s\xa0]*Solunjanima)|ierwsz(?:[aey][\s\xa0]*(?:List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan))|do[\s\xa0]*Tesaloniczan)|Tesalonic(?:ens[oó]w|zan)))|r(?:im(?:e(?:ir[ao][\s\xa0]*Tessalonicenses|r(?:o[\s\xa0]*Tesaloni[cs]enses?|[\s\xa0]*Tesaloni[cs]enses?))|a[\s\xa0]*(?:lettera[\s\xa0]*ai[\s\xa0]*Tessalonicesi|Tessalonicesi)|o[\s\xa0]*Tessalonicesi)|em(?:i(?:ère(?:s[\s\xa0]*Thes(?:saloniciens|aloniciens)|[\s\xa0]*Thes(?:saloniciens|aloniciens))|er(?:e(?:s[\s\xa0]*Thes(?:saloniciens|aloniciens)|[\s\xa0]*Thes(?:saloniciens|aloniciens))|s[\s\xa0]*Thes(?:saloniciens|aloniciens)|[\s\xa0]*Thes(?:saloniciens|aloniciens)))|ye[\s\xa0]*Tesalonik(?:yen)?)|v(?:a[\s\xa0]*(?:kniha[\s\xa0]*(?:Tesaloni(?:čanom|c(?:anom|k[yý]m))|Sol[uú]n(?:(?:[cč]anom|skym)))|Tesaloni(?:čanom|c(?:anom|k[yý]m))|Sol(?:un(?:janima[\s\xa0]*Poslanica|[cč]anom|skym)|ún(?:[cč]anom|skym)))|(?:[yý][\s\xa0]*(?:list[\s\xa0]*(?:Tesaloni(?:čanom|c(?:anom|k[yý]m))|Sol[uú]n(?:(?:[cč]anom|skym)))|Tesaloni(?:čanom|c(?:anom|k[yý]m))|Sol[uú]n(?:(?:[cč]anom|skym))))|á[\s\xa0]*(?:kniha[\s\xa0]*(?:Tesaloni(?:čanom|c(?:anom|k[yý]m))|Sol[uú]n(?:(?:[cč]anom|skym)))|Tesaloni(?:čanom|c(?:anom|k[yý]m))|Sol[uú]n(?:(?:[cč]anom|skym)))|n[ií][\s\xa0]*(?:list[\s\xa0]*(?:Tesalonick(?:[yý]m|Solu[nň]sk(?:[yý]m))|Sol(?:u[nň]sk(?:[yý]m))?|Te(?:s(?:salonicensk[yý]m|alonick[yý]m))?)))))|E(?:nsimm(?:[aä]inen[\s\xa0]*(?:Kirje[\s\xa0]*tessalonikalaisille|Tessalonikalais(?:kirje|ille)))|pistula[\s\xa0]*(?:I[\s\xa0]*ad[\s\xa0]*Thessalonicenses|ad[\s\xa0]*Thessalonicenses[\s\xa0]*I)|rste[\s\xa0]*Thessalonicher|erste[\s\xa0]*T(?:hess(?:alonicenzen)?|es(?:s(?:alonicenzen)?)?)|ls(?:[oő][\s\xa0]*T(?:hessz(?:alonika(?:iakhoz)?)?|essz(?:alonika(?:iakhoz)?)?)))|Προς[\s\xa0]*Θεσσαλονικε[ίι]ς[\s\xa0]*Α['ʹʹ΄’]|ﺍﻻﻭﻝ[\s\xa0]*ﺗﺴﺎﻟﻮﻧﻴﻜﻲ|1(?:[\s\xa0]*(?:ธส|थ(?:ेस्सलनीकाकरांस|िस(?:लुनिकी|्स(?:ल(?:ुनीकियों|ोनिकी(?:हरूलाई)?))?))|เธ[ซส]ะโลนิกา|தெச(?:லோ(?:னிக்க(?:ேயர்|ர்))?)?|фессалонікі[ий]ців|Сол(?:у(?:њанима|н(?:јани|ьці|ци(?:те)?|ян)))?|Þess|ت(?:ھ(?:ِسلُنیکیوں|سّلنیکیوں)|س)|Kirje[\s\xa0]*tessalonikalaisille|t(?:essalonikerbrev|ʰ(?:issalonik[iī]har(?:[uū]l(?:[aā][iī]))|essalan[iī]k(?:[aā]kar(?:[aā](?:[mṃ]s)))|assalunīkīāṃ))|Wathesalonike|Mga[\s\xa0]*T(?:aga(?:[\s\xa0]*Tesaloni[ck]a|-?(?:[\s\xa0]*Tesaloni[ck]a|Tesal[oó]ni(?:[ck]a)))|esaloni[cs]ense)|S(?:elanikasve|ol(?:u(?:n(?:janima[\s\xa0]*Poslanica|[cč]anom|sk[yý]m)|ňsk[yý]m)|ún(?:[cč]anom|skym))?)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Солун|ослан(?:ица[\s\xa0]*Солуњанима|ня[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))))|до[\s\xa0]*солунян|ਥੱਸਲੁਨੀਕੀਆਂ[\s\xa0]*ਨੂੰ|к[\s\xa0]*Фессалоники[ий]цам|k(?:\.[\s\xa0]*(?:Tesaloni(?:čanom|c(?:anom|k[yý]m))|Sol[uú]n(?:(?:[cč]anom|skym)))|[\s\xa0]*(?:Tesaloni(?:čanom|c(?:anom|k[yý]m))|Sol[uú]n(?:(?:[cč]anom|skym))))|Фес(?:салоники[ий]цам)?|ଥେସଲନୀକୀୟଙ|list[\s\xa0]*(?:Tesalonick[yý]m|Solu[nň]sk(?:[yý]m))|T(?:aga-?Tesal[oó]ni(?:[ck]a)|ê-?sa-?lô-?ni-?ca|èsalonika|e(?:cal[oō](?:[nṉ]ikkiyarukku)|s(?:al(?:óni[ck]a|oni(?:senses?|čanom|ika|c(?:en(?:s(?:[oó]w|es?)|i)|k[yý]m|zan|a(?:nom)?)|k(?:yen|a)?))|s(?:aloni(?:ce(?:n(?:s(?:k[yý]m|es)|zen)|si)|k(?:alais(?:kirje|ille)|er(?:ne)?))|z(?:alonika(?:iakhoz)?)?)?)?)?|h(?:aissaluneekiyon|ê(?:-?sa-?lô-?ni-?ca|xalônica)|e(?:s(?:al(?:lonians|oni(?:kasve|c(?:iens|ans)|ians|ons|a(?:id|ns?)|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:kerbrev(?:et)?|c(?:en(?:ses|zen)|i[ae]ns|ans|her)|ions|ens|a(?:ans|id|ns?)|ns|o(?:ans|ns?))))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s|z(?:alonika(?:iakhoz)?)?)?)?)?|s(?:ss?)?)?|s)|(?:[ie](?:\.[\s\xa0]*(?:Thesalonikasve|Selanikasve)|[\s\xa0]*(?:Thesalonikasve|Selanikasve)))|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan))|do[\s\xa0]*Tesaloniczan))|º(?:\.[\s\xa0]*Tesaloni[cs]enses?|[\s\xa0]*Tesaloni[cs]enses?)|[ея](?:\.[\s\xa0]*(?:к[\s\xa0]*Фессалоники(?:[ий]цам|Фессалоники[ий]цам)|[\s\xa0]*(?:к[\s\xa0]*Фессалоники[ий]цам|Фессалоники[ий]цам)))|\.(?:[oº](?:\.[\s\xa0]*Tesaloni(?:[cs]enses?|[\s\xa0]*Tesaloni[cs]enses?))|-?تھِسّلُنیکیوں|۔تھسلنیکیوں|[\s\xa0]*(?:เธ[ซส]ะโลนิกา|фессалонікі[ий]ців|Сол(?:у(?:њанима|н(?:јани|ьці|ци(?:те)?|ян)))?|Þess|تھ(?:ِسلُنیکیوں|سّلنیکیوں)|Kirje[\s\xa0]*tessalonikalaisille|Wathesalonike|Mga[\s\xa0]*T(?:aga(?:[\s\xa0]*Tesaloni[ck]a|-?(?:[\s\xa0]*Tesaloni[ck]a|Tesal[oó]ni(?:[ck]a)))|esaloni[cs]ense)|S(?:elanikasve|ol(?:u(?:n(?:janima[\s\xa0]*Poslanica|[cč]anom|sk[yý]m)|ňsk[yý]m)|ún(?:[cč]anom|skym))?)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Солун|ослан(?:ица[\s\xa0]*Солуњанима|ня[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))))|tʰissalonik[iī]har(?:[uū]l(?:[aā][iī]))|до[\s\xa0]*солунян|T(?:aga-?Tesal[oó]ni(?:[ck]a)|ê-?sa-?lô-?ni-?ca|èsalonika|e(?:s(?:al(?:óni[ck]a|oni(?:senses?|čanom|ika|c(?:en(?:s(?:[oó]w|es?)|i)|k[yý]m|zan|a(?:nom)?)|k(?:yen|a)?))|s(?:aloni(?:ce(?:n(?:s(?:k[yý]m|es)|zen)|si)|k(?:alais(?:kirje|ille)|er(?:ne)?))|z(?:alonika(?:iakhoz)?)?)?)?)?|h(?:aissaluneekiyon|ê(?:-?sa-?lô-?ni-?ca|xalônica)|e(?:s(?:al(?:lonians|oni(?:kasve|c(?:iens|ans)|ians|ons|a(?:id|ns?)|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:kerbrev(?:et)?|c(?:en(?:ses|zen)|i[ae]ns|ans|her)|ions|ens|a(?:ans|id|ns?)|ns|o(?:ans|ns?))))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s|z(?:alonika(?:iakhoz)?)?)?)?)?|s(?:ss?)?)?)|Фессалоники[ий]цам|к[\s\xa0]*Фессалоники[ий]цам|थिस(?:लुनिकी|्स(?:ल(?:ुनीकियों|ोनिकी(?:हरूलाई)?))?)|ଥେସଲନୀକୀୟଙ|list[\s\xa0]*(?:Tesalonick[yý]m|Solu[nň]sk(?:[yý]m))|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tesaloniczan))|do[\s\xa0]*Tesaloniczan)))|e(?:r(?:\.[\s\xa0]*Thes(?:saloniciens|aloniciens)|e(?:\.[\s\xa0]*Thes(?:saloniciens|aloniciens)|[\s\xa0]*Thes(?:saloniciens|aloniciens))|[\s\xa0]*Thes(?:saloniciens|aloniciens))|\.[\s\xa0]*T(?:hess(?:alonicenzen)?|es(?:s(?:alonicenzen)?)?)|[\s\xa0]*T(?:hess(?:alonicenzen)?|es(?:s(?:alonicenzen)?)?))|o(?:\.[\s\xa0]*Tes(?:salonicenses|aloni[cs]enses?)|[\s\xa0]*Tes(?:salonicenses|aloni[cs]enses?))|-?(?:я(?:\.[\s\xa0]*(?:к[\s\xa0]*Фессалоники[ий]цам|Фессалоники[ий]цам)|[\s\xa0]*(?:к[\s\xa0]*Фессалоники[ий]цам|Фессалоники[ий]цам))|تھِسّلُنیکیوں|ше(?:\.[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))|фессалонікі[ий]ців|до[\s\xa0]*солунян|Солун(?:ьці|ян))|[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))|фессалонікі[ий]ців|до[\s\xa0]*солунян|Солун(?:ьці|ян)))|а(?:\.[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))|фессалонікі[ий]ців|до[\s\xa0]*солунян|Солун(?:ьці|ян))|[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))|фессалонікі[ий]ців|до[\s\xa0]*солунян|Солун(?:ьці|ян)))|е(?:\.[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))|к[\s\xa0]*Фессалоники[ий]цам|Фессалоники[ий]цам|фессалонікі[ий]ців|до[\s\xa0]*солунян|Солун(?:ьці|ян))|[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))|к[\s\xa0]*Фессалоники[ий]цам|Фессалоники[ий]цам|фессалонікі[ий]ців|до[\s\xa0]*солунян|Солун(?:ьці|ян))))|a(?:\.[\s\xa0]*Tessalonicenses|[\s\xa0]*Tessalonicenses)|Thess|۔تھسلنیکیوں|°(?:\.[\s\xa0]*Tessalonicesi|[\s\xa0]*Tessalonicesi)|테살|ère(?:\.[\s\xa0]*Thes(?:saloniciens|aloniciens)|[\s\xa0]*Thes(?:saloniciens|aloniciens))|re(?:\.[\s\xa0]*Thes(?:saloniciens|aloniciens)|[\s\xa0]*Thes(?:saloniciens|aloniciens))|st(?:\.[\s\xa0]*Th(?:es(?:al(?:lonians|oni(?:[ci]ans|ons|ans?|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:i[ae]ns|ans)|ions|ens|(?:[ao](?:ans|ns?))|ns)))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s)?)?|s(?:ss?)?)?|[\s\xa0]*Th(?:es(?:al(?:lonians|oni(?:[ci]ans|ons|ans?|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:i[ae]ns|ans)|ions|ens|(?:[ao](?:ans|ns?))|ns)))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s)?)?|s(?:ss?)?)?))|《(?:得撒洛尼前書》|莎倫前》|帖(?:撒(?:罗尼迦前书》|羅尼迦前書》)|前》))|tʰ(?:assalunīkīāṃ[\s\xa0]*nū̃[\s\xa0]*pahilī[\s\xa0]*pattrī|issal(?:unīkiyōṅ[\s\xa0]*ke[\s\xa0]*nām[\s\xa0]*kā[\s\xa0]*pahlā[\s\xa0]*ḫaṭ|onik[iī]har(?:[uū]l(?:[aā](?:[iī][\s\xa0]*pahilo[\s\xa0]*patra))))|essalan[iī]k(?:[aā]kar(?:[aā](?:[mṃ]s[\s\xa0]*pahile[\s\xa0]*patra))))|테살로니카(?:[\s\xa0]*신자들에게[\s\xa0]*보낸[\s\xa0]*첫째[\s\xa0]*서간|1서)|Barua[\s\xa0]*ya[\s\xa0]*Kwanza[\s\xa0]*kwa[\s\xa0]*Wathesalonike|ଥେସଲନୀକୀୟଙ୍କ[\s\xa0]*ପ୍ରତି[\s\xa0]*ପ୍ରଥମ[\s\xa0]*ପତ୍ର|Wa(?:raka[\s\xa0]*wa[\s\xa0]*Kwanza[\s\xa0]*kwa[\s\xa0]*Wathesalonik[ei]|thesalonike[\s\xa0]*I)|Una(?:ng[\s\xa0]*(?:Mga[\s\xa0]*T(?:aga(?:-?[\s\xa0]*Tesaloni[ck]a|[\s\xa0]*Tesaloni[ck]a)|esaloni[cs]ense)|Tesaloni(?:sense|c(?:ense|a)|ka))|[\s\xa0]*(?:Mga[\s\xa0]*T(?:aga(?:-?[\s\xa0]*Tesaloni[ck]a|[\s\xa0]*Tesaloni[ck]a)|esaloni[cs]ense)|Tesaloni(?:sense|c(?:ense|a)|ka)))|Te(?:cal[oō](?:[nṉ]ikkiyarukku[\s\xa0]*E(?:[lḻ]utiya[\s\xa0]*Mutal(?:[aā]vatu[\s\xa0]*Nirupam)))|soloniika[\s\xa0]*Kowaad)|تھ(?:ِسّلُنیکیوں[\s\xa0]*کے[\s\xa0]*نام[\s\xa0]*کا[\s\xa0]*پہلا[\s\xa0]*خط|س(?:ّلنیکیوں[\s\xa0]*کے[\s\xa0]*نام[\s\xa0]*پولس[\s\xa0]*رسول[\s\xa0]*کا[\s\xa0]*پہلا[\s\xa0]*خط|لنیکیوں[\s\xa0]*کے[\s\xa0]*نام[\s\xa0]*کا[\s\xa0]*پہلا[\s\xa0]*خط))|ਥ(?:ਸੱਲੁਨੀਕੀਆਂ[\s\xa0]*ਨੂੰ[\s\xa0]*ਪਹਿਲੀ[\s\xa0]*ਪੱਤ੍ਰੀ|ੱਸਲੁਨੀਕੀਆਂ[\s\xa0]*ਨੂੰ[\s\xa0]*ਪਹਿਲੀ[\s\xa0]*ਪੱਤ੍ਰੀ)|थिस्सलोनिकीहरूलाई[\s\xa0]*प(?:ावलको[\s\xa0]*पहिलो[\s\xa0]*पत्र|हिलो[\s\xa0]*पत्र)|தெசலோனிக்க(?:ியருக்கு[\s\xa0]*எழுதிய[\s\xa0]*முதலாவது[\s\xa0]*நிருபம்|ேயருக்கு[\s\xa0]*எழுதிய[\s\xa0]*முதலாம்[\s\xa0]*கடிதம்|ருக்கு[\s\xa0]*எழுதிய[\s\xa0]*முதல்[\s\xa0]*திருமுகம்)|पौलाचे[\s\xa0]*थेस्सलनीकाकरांस[\s\xa0]*पहिले[\s\xa0]*पत्र|F(?:(?:[oö]rsta[\s\xa0]*T(?:hessalonikerbrevet|essalonikerbrevet))|yrra[\s\xa0]*(?:br[eé]f[\s\xa0]*P(?:[aá]ls[\s\xa0]*til[\s\xa0]*Þessa(?:lon(?:[ií]kumanna)?))|Þessalon[ií]kubr(?:[eé]f))|ørste[\s\xa0]*(?:tessalonikerbrev|T(?:hess(?:alonikerbrev)?|ess(?:aloniker(?:ne)?)?))|irst[\s\xa0]*Th(?:es(?:al(?:lonians|oni(?:[ci]ans|ons|ans?|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:i[ae]ns|ans)|ions|ens|(?:[ao](?:ans|ns?))|ns)))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s)?)?|s(?:ss?)?)?)|אגרת[\s\xa0]*פולוס[\s\xa0]*הראשונה[\s\xa0]*אל-?התסלו|П(?:рв(?:а[\s\xa0]*(?:п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Солун|осланица[\s\xa0]*Солуњанима)|Солу(?:њанима|н(?:ците|јани)))|о[\s\xa0]*(?:писмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Солун|Солун(?:ците|јани)))|ерш(?:[ае][\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*солунян|до[\s\xa0]*(?:фессалонікі[ий]ців|с(?:алонікі[ий]ців|олунян)))|фессалонікі[ий]ців|до[\s\xa0]*солунян|Солун(?:ьці|ян)))|ърв(?:о[\s\xa0]*послание[\s\xa0]*(?:на[\s\xa0]*св(?:\.[\s\xa0]*ап(?:\.[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Солуняни|[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Солуняни)|[\s\xa0]*ап(?:\.[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Солуняни|[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Солуняни))|към[\s\xa0]*солунците)|а[\s\xa0]*Сол(?:унци(?:те)?)?))|האיגרת[\s\xa0]*הראשונה[\s\xa0]*אל[\s\xa0]*התסלוניקים|رسالة[\s\xa0]*(?:بولس[\s\xa0]*الرسول[\s\xa0]*الأولى[\s\xa0]*إلى[\s\xa0]*أهل[\s\xa0]*تسالونيكي|تسالونيكي[\s\xa0]*الأولى)|ا(?:لرسالة[\s\xa0]*الأولى[\s\xa0]*إلى[\s\xa0]*أهل[\s\xa0]*تسالونيكي|وّل(?:-?تھِسّلُنیکیوں|[\s\xa0]*تھ(?:ِسلُنیکیوں|سّلنیکیوں)|۔تھسلنیکیوں))|Kwanza[\s\xa0]*(?:Wathesalonike|Th(?:es?)?)|Α['ʹʹ΄’][\s\xa0]*Θε(?:σ(?:σαλονικε(?:[ίι]ς)?)?)|ପ୍ରଥମ[\s\xa0]*ଥେସଲନୀକୀୟଙ|テサロニケ(?:の信徒への手紙一|人への(?:第一の手紙|前の書|手紙一)|[\s\xa0]*1|前書))|(?:Fyrra[\s\xa0]*br[eé]f[\s\xa0]*P(?:[aá]ls[\s\xa0]*til[\s\xa0]*Þessa)|1(?:[ея](?:\.[\s\xa0]*Фессалоники(?:[ий]цам|[\s\xa0]*(?:к[\s\xa0]*Фессалоники[ий]цам|Фессалоники[ий]цам)))|\.[oº][\s\xa0]*Tesaloni(?:[cs]enses?))|Prvn[ií][\s\xa0]*(?:Sol(?:u(?:[nň]sk(?:[yý]m))?|Te(?:s(?:salonicensk[yý]m|alonick[yý]m))?))|Α['ʹʹ΄’][\s\xa0]*Θε)|(?:1[ея][\s\xa0]*(?:к[\s\xa0]*Фессалоники(?:[ий]цам|Фессалоники[ий]цам))|Prvn(?:[ií][\s\xa0]*(?:Sol|Te(?:s(?:salonicensk[yý]m|alonick[yý]m))?)))|1[ея][\s\xa0]*Фессалоники(?:[ий]цам)|(?:《(?:得撒洛尼前書|莎倫前|帖(?:撒(?:羅尼迦前書|罗尼迦前书)|前))|帖(?:撒(?:罗尼迦前书》?|羅尼迦前書》?)|前》?)|(?:[1I](?:\.[\s\xa0]*(?:Solunjanima|Tê)|[\s\xa0]*(?:Solunjanima|Tê)))|थेस्सलनीकाकरांस[\s\xa0]*पहिले[\s\xa0]*पत्र|得撒洛尼前書》?|הראשונה[\s\xa0]*אל[\s\xa0]*התסלוניקים|ad[\s\xa0]*Thessalonicenses[\s\xa0]*I|Thes(?:s(?:oloni(?:ns|ans?)|elon(?:ains|ians?)|al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:ions|c(?:enses[\s\xa0]*I|i[ae]ns|ans)|ns|(?:[ao](?:ans|ns?))))))|elon(?:ains|ians?)|olonians?|al(?:lonians|oni(?:[ic]ans|ons|ns|ans?)))|莎倫前》?|Prva[\s\xa0]*(?:poslanica[\s\xa0]*Solunjanima|Solunjanima)))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["2Kgs"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(2[\s\xa0]*kniha[\s\xa0]*kr(?:[aá]lovsk[aá])|(?:δυτικ[οό]ς[\s\xa0]*Βασιλ(?:[έε]ων[\s\xa0]*Β['ʹʹ΄’])|दुसरे[\s\xa0]*राजे|الممالك[\s\xa0]*الرابع|Regum[\s\xa0]*II|M(?:[aá]sodik[\s\xa0]*Kir(?:[aá]lyok)?)|Wafalme[\s\xa0]*II|இராஜாக்களின்[\s\xa0]*இரண்டாம்[\s\xa0]*புத்தகம்|राजा(?:ओ[\s\xa0]*का[\s\xa0]*विर्तान्त[\s\xa0]*[2२]रा[\s\xa0]*भाग|हरूको[\s\xa0]*दोस्रो[\s\xa0]*पुस्तक)|D(?:e(?:uxi(?:[eè]me(?:s[\s\xa0]*Rois|[\s\xa0]*Rois))|zy(?:[eè]m[\s\xa0]*(?:liv[\s\xa0]*Wa[\s\xa0]*yo|Wa)))|ru(?:g(?:a[\s\xa0]*(?:knjiga[\s\xa0]*o[\s\xa0]*Kraljevima|K(?:r(?:aljevima|[oó]lewska)|s(?:i(?:[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))))|\.[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))|[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w)))))|i[\s\xa0]*K(?:r[oó]lewska|s(?:i(?:[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))))|\.[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))|[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w)))))|h(?:[aá][\s\xa0]*(?:kniha[\s\xa0]*(?:kr(?:[aá]lovsk[aá]|Kr[aá](?:[lľ]ov))|Kr(?:[aá](?:ľov|l(?:ov(?:sk[aá])?)?))?))|[yý][\s\xa0]*(?:kniha[\s\xa0]*kr(?:[aá]lovsk[aá]|list[\s\xa0]*Kr[aá](?:[lľ]ov)|Kr(?:[aá](?:ľov|l(?:ov(?:sk[aá])?)?))?)))))|Zweite[\s\xa0]*K(?:o(?:enige|nige)|önige)|I(?:ka(?:apat[\s\xa0]*Mga[\s\xa0]*Hari|lawang[\s\xa0]*(?:Mga[\s\xa0]*Hari|Hari))|V(?:\.[\s\xa0]*(?:Книга[\s\xa0]*на[\s\xa0]*царете|краљев(?:ства|има)|Mga[\s\xa0]*Hari|K(?:s(?:i[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]lewska))|\.[\s\xa0]*Kr[oó]lewska|[\s\xa0]*Kr[oó]lewska)|ingdoms|r[aá](?:[lľ]ov))|Re(?:inos|g(?:norum|i))|Цар(?:ства|ів|е))|[\s\xa0]*(?:Книга[\s\xa0]*на[\s\xa0]*царете|краљев(?:ства|има)|Mga[\s\xa0]*Hari|K(?:s(?:i[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]lewska))|\.[\s\xa0]*Kr[oó]lewska|[\s\xa0]*Kr[oó]lewska)|ingdoms|r[aá](?:[lľ]ov))|Re(?:inos|g(?:norum|i))|Цар(?:ства|ів|е)))|I(?:\.[\s\xa0]*(?:Mga[\s\xa0]*Hari|царів|Para[\s\xa0]*Raja|kniha[\s\xa0]*kr[aá]lovsk[aá]|Vua|Wa(?:falme)?|C(?:ác[\s\xa0]*Vua|ariv)|Hari|о[\s\xa0]*царевима|Fal|R(?:ois|e(?:yes|is|g(?:um|i)?)?)|K(?:uninkaiden[\s\xa0]*kirja|s(?:i(?:[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))))|\.[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))|[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w)))|gs?|i(?:gs?|n(?:gs?|s)?|r(?:[aá]lyok)?|s)?|n(?:gs?|s)?|o(?:n(?:ingen)?)?|r(?:[oó]lewska|a(?:ľov|l(?:jevima|ov(?:sk[aá])?)?)|á(?:ľov|l(?:ov(?:sk[aá])?)?))?)|B(?:ren(?:hinoedd|inoedd)|oq(?:orradii)?)|Царев[аи]|к(?:нига[\s\xa0]*(?:за[\s\xa0]*царевите|царів)|раљева)|[IÎ]mp(?:[aă]ra(?:[tţ]i)?))|[\s\xa0]*(?:Mga[\s\xa0]*Hari|царів|R(?:ois|e(?:yes|is|gi?)?)|Para[\s\xa0]*Raja|kniha[\s\xa0]*kr[aá]lovsk[aá]|Vua|Wa(?:falme)?|C(?:ác[\s\xa0]*Vua|ariv)|Hari|a[\s\xa0]*[IÎ]mp(?:[aă]ra(?:[tţ]ilor))|о[\s\xa0]*царевима|Fal|K(?:uninkaiden[\s\xa0]*kirja|s(?:i(?:[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))))|\.[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))|[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w)))|gs?|i(?:gs?|n(?:gs?|s)?|r(?:[aá]lyok)?|s)?|n(?:gs?|s)?|o(?:n(?:ingen)?)?|r(?:[oó]lewska|a(?:ľov|l(?:jevima|ov(?:sk[aá])?)?)|á(?:ľov|l(?:ov(?:sk[aá])?)?))?)?|B(?:ren(?:hinoedd|inoedd)|oq(?:orradii)?)|Царев[аи]|к(?:нига[\s\xa0]*(?:за[\s\xa0]*царевите|царів)|раљева)|[IÎ]mp(?:[aă]ra(?:[tţ]i)?))))|rājiāṃ[\s\xa0]*dī[\s\xa0]*dūjī[\s\xa0]*potʰī|2(?:o(?:\.[\s\xa0]*Re(?:yes|is)|[\s\xa0]*Re(?:yes|is))|ème(?:\.[\s\xa0]*Rois|[\s\xa0]*Rois)|d(?:\.[\s\xa0]*Rois|e(?:\.[\s\xa0]*Rois|[\s\xa0]*Rois)|[\s\xa0]*Rois)|e(?:me(?:\.[\s\xa0]*Rois|[\s\xa0]*Rois)|\.[\s\xa0]*(?:Rois|Ko(?:n(?:ingen)?)?)|[\s\xa0]*(?:Rois|Ko(?:n(?:ingen)?)?))|°(?:\.[\s\xa0]*Re|[\s\xa0]*Re)|º(?:\.[\s\xa0]*Reyes|[\s\xa0]*Reyes)|Kgs|a(?:\.[\s\xa0]*Reis|[\s\xa0]*Reis)|-?(?:ге(?:\.[\s\xa0]*(?:книга[\s\xa0]*царів|Cariv|царів)|[\s\xa0]*(?:книга[\s\xa0]*царів|Cariv|царів))|а(?:\.[\s\xa0]*(?:книга[\s\xa0]*царів|Cariv|царів)|[\s\xa0]*(?:книга[\s\xa0]*царів|Cariv|царів))|е(?:\.[\s\xa0]*(?:книга[\s\xa0]*царів|Cariv|Царе[ий]|царів)|[\s\xa0]*(?:книга[\s\xa0]*царів|Cariv|Царе[ий]|царів))|я(?:\.[\s\xa0]*Царе[ий]|[\s\xa0]*Царе[ий])|سلاطِین)|\.(?:-?سلاطِین|(?:[oº](?:\.[\s\xa0]*Reyes|[\s\xa0]*Reyes))|۔سلاطین|[\s\xa0]*(?:царів|Царе(?:в[аи]|[ий])|Para[\s\xa0]*Raja|kniha[\s\xa0]*kr[aá]lovsk[aá]|M(?:bret[eë]rve|ga[\s\xa0]*Hari)|Vua|พ(?:งศ์กษัตริย์|กษ)|Wa(?:falme)?|C(?:ác[\s\xa0]*Vua|ariv)|Hari|о[\s\xa0]*царевима|Fal|K(?:un(?:inkaiden[\s\xa0]*kirja|gaboken)|s(?:i(?:[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))))|\.[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))|[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w)))|ön(?:ige)?|gs?|i(?:gs?|n(?:gs?|s)?|r(?:[aá]lyok)?|s)?|n(?:gs?|s)?|o(?:enige|n(?:ungaboken|i(?:ngen|ge)|g(?:ebo[gk])?)?)?|r(?:[oó]lewska|a(?:ľov|l(?:jevima|ov(?:sk[aá])?)?)|á(?:ľov|l(?:ov(?:sk[aá])?)?))?)|B(?:ren(?:hinoedd|inoedd)|oq(?:orradii)?)|ରାଜାବଳୀର?|к(?:нига[\s\xa0]*(?:за[\s\xa0]*царевите|царів)|раљева)|[IÎ]mp(?:[aă]ra(?:[tţ]i)?)|R(?:aja|ois|e(?:yes|is|g(?:um|i)?))|سلاطین|r[aā]ǳ(?:[aā]har(?:[uū]ko))|राजा(?:हरूको|ओं)?))|nd(?:\.[\s\xa0]*K(?:gs?|i(?:gs?|n(?:gs?|s)?|s)?|n(?:gs?|s)?|s)?|[\s\xa0]*K(?:gs?|i(?:gs?|n(?:gs?|s)?|s)?|n(?:gs?|s)?|s)?)|(?:[ея](?:\.[\s\xa0]*Царе[ий]|[\s\xa0]*Царе[ий]))|[\s\xa0]*(?:царів|Царе(?:в[аи]|[ий])|الملوك|Para[\s\xa0]*Raja|[ie](?:\.[\s\xa0]*Mbret(?:[eë]rve|[\s\xa0]*Mbret[eë]rve))|M(?:ga[\s\xa0]*Hari|b(?:ret[eë]rve)?)|I(?:r[aā]j(?:[aā]kka[lḷ])|mp[aă]ra(?:[tţ]i)?)|مل|Vua|ਰਾਜਿਆਂ|Ha(?:ri)?|พ(?:งศ์กษัตริย์|กษ)|Wa(?:falme)?|C(?:ác[\s\xa0]*Vua|ariv)|r(?:aǳ(?:[aā]har(?:[uū]ko)|e)|ā(?:jiāṃ|ǳ(?:[aā]har(?:[uū]ko)|e)))|о[\s\xa0]*царевима|Fal|R(?:aja|ois|e(?:is|es?|g(?:um|i)?|s|y(?:es?|s)?)|s|y(?:es?|s)?)?|K(?:s(?:i(?:[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))))|\.[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))|[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w)))|un(?:inkaiden[\s\xa0]*kirja|g(?:aboken)?)?|ön(?:ige)?|gs?|i(?:gs?|n(?:gs?|s)?|r(?:[aá]lyok)?|s)?|n(?:gs?|s)?|o(?:enige|n(?:ungaboken|i(?:ngen|ge)|g(?:ebo[gk])?)?)?|r(?:a(?:ľov|l(?:jevima|ov(?:sk[aá])?)?)|(?:[oó]l(?:ewska)?)|á(?:ľov|l(?:ov(?:sk[aá])?)?)|[lľ])?)|k(?:\.[\s\xa0]*Kr[aá](?:[lľ]ov)|[\s\xa0]*Kr[aá](?:[lľ]ov))|राज(?:ा(?:हरूको|ओं)?|े)|B(?:ren(?:hinoedd|inoedd)?|oq(?:orradii)?)|ରାଜାବଳୀର?|к(?:нига[\s\xa0]*(?:за[\s\xa0]*царевите|царів)|раљева)|Împ[aă]ra(?:[tţ]i)?|இரா(?:ஜா(?:க்கள்)?)?|salāṭīn|سلاطین|அர(?:சர்கள்)?)|열왕|۔سلاطین)|دوم(?:-?سلاطِین|[\s\xa0۔]*سلاطین)|Четв(?:рта[\s\xa0]*краљев(?:ства|има)|ерта[\s\xa0]*Царів|ърта[\s\xa0]*(?:Книга[\s\xa0]*на[\s\xa0]*царете|книга[\s\xa0]*Царства|Цар(?:ства|е)))|Štvrt[aá][\s\xa0]*(?:kniha[\s\xa0]*Kr(?:[aá](?:[lľ]ov)|Kr[aá](?:[lľ]ov)))|왕하|ରାଜାବଳୀର[\s\xa0]*ଦ୍ୱିତୀୟ[\s\xa0]*ପୁସ୍ତକ|列(?:王(?:紀略下|[\s\xa0]*2|記(?:第四巻|下))|下)|Друг(?:а[\s\xa0]*(?:о[\s\xa0]*царевима|к(?:нига[\s\xa0]*царів|раљева)|Царева|Cariv|царів)|е[\s\xa0]*(?:книга[\s\xa0]*царів|Cariv|царів))|מלכים[\s\xa0]*ב['’]|C(?:zwarta[\s\xa0]*Ks(?:i[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]lewska))|\.[\s\xa0]*Kr[oó]lewska|[\s\xa0]*Kr[oó]lewska)|artea[\s\xa0]*(?:a[\s\xa0]*patra[\s\xa0]*a[\s\xa0]*Regilor|IV[\s\xa0]*a[\s\xa0]*Regilor))|4(?:th(?:\.[\s\xa0]*Kingdoms|[\s\xa0]*Kingdoms)|-?(?:[ея](?:\.[\s\xa0]*(?:Книга[\s\xa0]*Царств|Царств)|[\s\xa0]*(?:Книга[\s\xa0]*Царств|Царств)))|(?:[ao](?:\.[\s\xa0]*Reinos|[\s\xa0]*Reinos))|(?:[ея](?:\.[\s\xa0]*(?:Книга[\s\xa0]*Царств|Царств)|[\s\xa0]*(?:Книга[\s\xa0]*Царств|Царств)))|\.[\s\xa0]*(?:Книга[\s\xa0]*(?:на[\s\xa0]*царете|Царств)|краљев(?:ства|има)|M(?:bret[eë]rve|ga[\s\xa0]*Hari)|K(?:ongerigernes[\s\xa0]*Bog|s(?:i[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]lewska))|\.[\s\xa0]*Kr[oó]lewska|[\s\xa0]*Kr[oó]lewska)|ingdoms|r[aá](?:[lľ]ov))|Re(?:inos|g(?:norum|i))|Цар(?:ства?|ів|е))|[\s\xa0]*(?:Re(?:inos|g(?:norum|i))|K(?:ongerigernes[\s\xa0]*Bog|s(?:i[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]lewska))|\.[\s\xa0]*Kr[oó]lewska|[\s\xa0]*Kr[oó]lewska)|ingdoms|r[aá](?:[lľ]ov))|[ie](?:\.[\s\xa0]*Mbret(?:[eë]rve|[\s\xa0]*Mbret[eë]rve))|அரசுகள்|M(?:bret[eë]rve|ga[\s\xa0]*Hari)|k(?:\.[\s\xa0]*Kr[aá](?:[lľ]ov)|[\s\xa0]*Kr[aá](?:[lľ]ov))|краљев(?:ства|има)|Книга[\s\xa0]*(?:на[\s\xa0]*царете|Царств)|Ц(?:ар(?:ства?|ів|е)?)?))|Liber[\s\xa0]*II[\s\xa0]*Regum|سفر[\s\xa0]*الملوك[\s\xa0]*الثاني|T(?:oinen[\s\xa0]*Kuninkaiden[\s\xa0]*kirja|weede[\s\xa0]*Ko(?:n(?:ingen)?)?)|Quart[ao][\s\xa0]*Reinos|열왕기(?:[\s\xa0]*하권?|하)|Втор(?:[ао][\s\xa0]*(?:книга[\s\xa0]*за[\s\xa0]*царевите|Цареви))|۲(?:-?سلاطِین|[\s\xa0۔]*سلاطین)|S(?:[ií]ðari[\s\xa0]*(?:b(?:[oó]k[\s\xa0]*konunganna|Konungab[oó]k))|tvrt[aá][\s\xa0]*(?:kniha[\s\xa0]*Kr(?:[aá](?:[lľ]ov)|Kr[aá](?:[lľ]ov)))|e(?:gund(?:a[\s\xa0]*Reis|o[\s\xa0]*Re(?:yes|is))|cond(?:[ao][\s\xa0]*Re|[\s\xa0]*K(?:gs?|i(?:gs?|n(?:gs?|s)?|s)?|n(?:gs?|s)?|s)?)))|Boqorradii[\s\xa0]*Labaad|F(?:jerde[\s\xa0]*Kongerigernes[\s\xa0]*Bog|ourth[\s\xa0]*Kingdoms)|And(?:en[\s\xa0]*Kong(?:ebog)?|r(?:a[\s\xa0]*K(?:onungaboken|ungaboken)|e[\s\xa0]*Kong(?:ebok)?))|Β(?:ασιλει[ωώ]ν[\s\xa0]*Δ['ʹʹ΄’]|['ʹʹ΄’][\s\xa0]*Βα(?:σ(?:ιλ(?:[έε]ων)?)?))|Ki(?:tabu[\s\xa0]*cha[\s\xa0]*Pili[\s\xa0]*cha[\s\xa0]*Wafalme|r[aá]lyok[\s\xa0]*II)|ﺍﻟﻤﻠﻮﻙ[\s\xa0]*ﺍﻟﺜﺎﻧﻲ|ਰਾਜਿਆਂ[\s\xa0]*ਦੀ[\s\xa0]*ਦੂਜੀ[\s\xa0]*ਪੋਥੀ|Pili[\s\xa0]*(?:Wafalme|Fal)|《(?:列王[紀纪记]下》|王下》)|ଦ୍ୱିତୀୟ[\s\xa0]*ରାଜାବଳୀର?)|(?:4[\s\xa0]*[ei][\s\xa0]*Mbret(?:[eë]rve)|S(?:[ií]ðari[\s\xa0]*Konungab(?:[oó]k)|tvrt[aá][\s\xa0]*Kr(?:[aá](?:[lľ]ov)))|Štvrt[aá][\s\xa0]*Kr(?:[aá](?:[lľ]ov))|Druh(?:(?:[aá][\s\xa0]*Kr(?:[aá](?:ľov|l(?:ov(?:sk[aá])?)?))?)|[yý][\s\xa0]*(?:list[\s\xa0]*Kr(?:[aá](?:[lľ]ov)|Kr(?:[aá](?:ľov|l(?:ov(?:sk[aá])?)?))?)))|II(?:\.[\s\xa0]*[IÎ]mp|[\s\xa0]*[IÎ]mp)|2(?:\.[\s\xa0]*[IÎ]mp|[\s\xa0]*(?:[ei][\s\xa0]*Mbret(?:[eë]rve)|[IÎ]mp))|Β['ʹʹ΄’][\s\xa0]*Βα)|Druh(?:[yý][\s\xa0]*Kr(?:[aá](?:ľov|l(?:ov(?:sk[aá])?)?))?)|(?:Четвърта[\s\xa0]*книга[\s\xa0]*на[\s\xa0]*царете|2(?:\.[\s\xa0]*Kuninkaiden|[\s\xa0]*Kuninkaiden)|《(?:列王[紀记纪]下|王下)|Síðari[\s\xa0]*konungabók|列王[记纪紀]下》?|מלכים[\s\xa0]*ב|王下》?|Toinen[\s\xa0]*Kuninkaiden|II(?:\.[\s\xa0]*Kuninkaiden|[\s\xa0]*(?:Kuninkaiden|Regum))))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["1Kgs"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(1(?:[\s\xa0]*kniha[\s\xa0]*kr[aá]lovsk[aá]|re(?:\.[\s\xa0]*Rois|[\s\xa0]*Rois))|(?:Wafalme[\s\xa0]*I|《(?:列王[紀纪记]上》|王上》)|ପ୍ରଥମ[\s\xa0]*ରାଜାବଳୀର?|E(?:nsimm[aä]inen[\s\xa0]*Kuninkaiden[\s\xa0]*kirja|rste[\s\xa0]*K(?:o(?:enige|nige)|önige)|erste[\s\xa0]*Ko(?:n(?:ingen)?)?|ls(?:[oő][\s\xa0]*Kir(?:[aá]lyok)?))|열왕기(?:[\s\xa0]*상권?|상)|سفر[\s\xa0]*الملوك[\s\xa0]*الأول|왕상|1(?:o(?:\.[\s\xa0]*Re(?:yes|is)|[\s\xa0]*Re(?:yes|is))|e(?:r(?:\.[\s\xa0]*Rois|e(?:\.[\s\xa0]*Rois|[\s\xa0]*Rois)|[\s\xa0]*Rois)|\.[\s\xa0]*Ko(?:n(?:ingen)?)?|[\s\xa0]*Ko(?:n(?:ingen)?)?)|°(?:\.[\s\xa0]*Re|[\s\xa0]*Re)|st(?:\.[\s\xa0]*K(?:gs?|i(?:gs?|n(?:gs?|s)?)?|n(?:gs?|s)?|s)?|[\s\xa0]*K(?:gs?|i(?:gs?|n(?:gs?|s)?)?|n(?:gs?|s)?|s)?)|º(?:\.[\s\xa0]*Reyes|[\s\xa0]*Reyes)|Kgs|a(?:\.[\s\xa0]*Reis|[\s\xa0]*Reis)|ère(?:\.[\s\xa0]*Rois|[\s\xa0]*Rois)|\.(?:-?سلاطِین|(?:[oº](?:\.[\s\xa0]*Reyes|[\s\xa0]*Reyes))|۔سلاطین|[\s\xa0]*(?:царів|Царе(?:в[аи]|[ий])|Para[\s\xa0]*Raja|kniha[\s\xa0]*kr[aá]lovsk[aá]|M(?:bret[eë]rve|ga[\s\xa0]*Hari)|Vua|พ(?:งศ์กษัตริย์|กษ)|Wa(?:falme)?|C(?:ác[\s\xa0]*Vua|ariv)|Hari|о[\s\xa0]*царевима|Fal|K(?:un(?:inkaiden[\s\xa0]*kirja|gaboken)|s(?:i(?:[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))))|\.[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))|[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w)))|ön(?:ige)?|gs?|i(?:gs?|n(?:gs?|s)?|r(?:[aá]lyok)?)?|n(?:gs?|s)?|o(?:enige|n(?:ungaboken|i(?:ngen|ge)|g(?:ebo[gk])?)?)?|r(?:[oó]lewska|a(?:ľov|l(?:jevima|ov(?:sk[aá])?)?)|á(?:ľov|l(?:ov(?:sk[aá])?)?))?)|B(?:ren(?:hinoedd|inoedd)|oq(?:orradii)?)|ରାଜାବଳୀର?|к(?:нига[\s\xa0]*(?:за[\s\xa0]*царевите|царів)|раљева)|[IÎ]mp(?:[aă]ra(?:[tţ]i)?)|R(?:aja|ois|e(?:yes|is|g(?:um|i)?))|سلاطین|r[aā]ǳ(?:[aā]har(?:[uū]ko))|राजा(?:हरूको|ओं)?))|-?(?:ше(?:\.[\s\xa0]*(?:книга[\s\xa0]*царів|Cariv|царів)|[\s\xa0]*(?:книга[\s\xa0]*царів|Cariv|царів))|а(?:\.[\s\xa0]*(?:книга[\s\xa0]*царів|Cariv|царів)|[\s\xa0]*(?:книга[\s\xa0]*царів|Cariv|царів))|е(?:\.[\s\xa0]*(?:книга[\s\xa0]*царів|Cariv|Царе[ий]|царів)|[\s\xa0]*(?:книга[\s\xa0]*царів|Cariv|Царе[ий]|царів))|я(?:\.[\s\xa0]*Царе[ий]|[\s\xa0]*Царе[ий])|سلاطِین)|(?:[ея](?:\.[\s\xa0]*Царе[ий]|[\s\xa0]*Царе[ий]))|[\s\xa0]*(?:царів|Царе(?:в[аи]|[ий])|الملوك|Para[\s\xa0]*Raja|[ie](?:\.[\s\xa0]*Mbret(?:[eë]rve|[\s\xa0]*Mbret[eë]rve))|M(?:ga[\s\xa0]*Hari|b(?:ret[eë]rve)?)|I(?:r[aā]j(?:[aā]kka[lḷ])|mp[aă]ra(?:[tţ]i)?)|مل|Vua|ਰਾਜਿਆਂ|Ha(?:ri)?|พ(?:งศ์กษัตริย์|กษ)|Wa(?:falme)?|C(?:ác[\s\xa0]*Vua|ariv)|r(?:aǳ(?:[aā]har(?:[uū]ko)|e)|ā(?:jiāṃ|ǳ(?:[aā]har(?:[uū]ko)|e)))|о[\s\xa0]*царевима|Fal|R(?:aja|ois|e(?:is|es?|g(?:um|i)?|s|y(?:es?|s)?)|s|y(?:es?|s)?)?|k(?:\.[\s\xa0]*Kr[aá](?:[lľ]ov)|[\s\xa0]*Kr[aá](?:[lľ]ov))|K(?:s(?:i(?:[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))))|\.[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))|[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w)))|un(?:inkaiden[\s\xa0]*kirja|g(?:aboken)?)?|ön(?:ige)?|gs?|i(?:gs?|n(?:gs?|s)?|r(?:[aá]lyok)?)?|n(?:gs?|s)?|o(?:enige|n(?:ungaboken|i(?:ngen|ge)|g(?:ebo[gk])?)?)?|r(?:a(?:ľov|l(?:jevima|ov(?:sk[aá])?)?)|(?:[oó]l(?:ewska)?)|á(?:ľov|l(?:ov(?:sk[aá])?)?)|[lľ])?)|राज(?:ा(?:हरूको|ओं)?|े)|B(?:ren(?:hinoedd|inoedd)?|oq(?:orradii)?)|ରାଜାବଳୀର?|к(?:нига[\s\xa0]*(?:за[\s\xa0]*царевите|царів)|раљева)|Împ[aă]ra(?:[tţ]i)?|இரா(?:ஜா(?:க்கள்)?)?|salāṭīn|سلاطین|அர(?:சர்கள்)?)|열왕|۔سلاطین)|F(?:(?:[oö]rsta[\s\xa0]*K(?:onungaboken|ungaboken))|yrri[\s\xa0]*(?:b[oó]k[\s\xa0]*konunganna|Konungab[oó]k)|ørste[\s\xa0]*Kong(?:ebo[gk])?|irst[\s\xa0]*K(?:gs?|i(?:gs?|n(?:gs?|s)?)?|n(?:gs?|s)?|s)?)|Boqorradii[\s\xa0]*Kowaad|I(?:katlong[\s\xa0]*Mga[\s\xa0]*Hari|II(?:\.[\s\xa0]*(?:Книга[\s\xa0]*на[\s\xa0]*царете|краљев(?:ства|има)|Mga[\s\xa0]*Hari|K(?:s(?:i[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]lewska))|\.[\s\xa0]*Kr[oó]lewska|[\s\xa0]*Kr[oó]lewska)|ingdoms|r[aá](?:[lľ]ov))|Re(?:inos|g(?:norum|i))|Цар(?:ства|ів|е))|[\s\xa0]*(?:Книга[\s\xa0]*на[\s\xa0]*царете|краљев(?:ства|има)|Mga[\s\xa0]*Hari|K(?:s(?:i[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]lewska))|\.[\s\xa0]*Kr[oó]lewska|[\s\xa0]*Kr[oó]lewska)|ingdoms|r[aá](?:[lľ]ov))|Re(?:inos|g(?:norum|i))|Цар(?:ства|ів|е)))|\.[\s\xa0]*(?:Mga[\s\xa0]*Hari|царів|Para[\s\xa0]*Raja|kniha[\s\xa0]*kr[aá]lovsk[aá]|Vua|Wa(?:falme)?|C(?:ác[\s\xa0]*Vua|ariv)|Hari|о[\s\xa0]*царевима|Fal|R(?:ois|e(?:yes|is|g(?:um|i)?)?)|K(?:uninkaiden[\s\xa0]*kirja|s(?:i(?:[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))))|\.[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))|[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w)))|gs?|i(?:gs?|n(?:gs?|s)?|r(?:[aá]lyok)?)?|n(?:gs?|s)?|o(?:n(?:ingen)?)?|r(?:[oó]lewska|a(?:ľov|l(?:jevima|ov(?:sk[aá])?)?)|á(?:ľov|l(?:ov(?:sk[aá])?)?))?)|B(?:ren(?:hinoedd|inoedd)|oq(?:orradii)?)|Царев[аи]|к(?:нига[\s\xa0]*(?:за[\s\xa0]*царевите|царів)|раљева)|[IÎ]mp(?:[aă]ra(?:[tţ]i)?))|[\s\xa0]*(?:Mga[\s\xa0]*Hari|царів|R(?:ois|e(?:yes|is|gi?)?)|Para[\s\xa0]*Raja|kniha[\s\xa0]*kr[aá]lovsk[aá]|Vua|Wa(?:falme)?|C(?:ác[\s\xa0]*Vua|ariv)|Hari|a[\s\xa0]*[IÎ]mp(?:[aă]ra(?:[tţ]ilor))|о[\s\xa0]*царевима|Fal|K(?:uninkaiden[\s\xa0]*kirja|s(?:i(?:[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))))|\.[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))|[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w)))|gs?|i(?:gs?|n(?:gs?|s)?|r(?:[aá]lyok)?)?|n(?:gs?|s)?|o(?:n(?:ingen)?)?|r(?:[oó]lewska|a(?:ľov|l(?:jevima|ov(?:sk[aá])?)?)|á(?:ľov|l(?:ov(?:sk[aá])?)?))?)?|B(?:ren(?:hinoedd|inoedd)|oq(?:orradii)?)|Царев[аи]|к(?:нига[\s\xa0]*(?:за[\s\xa0]*царевите|царів)|раљева)|[IÎ]mp(?:[aă]ra(?:[tţ]i)?)))|ରାଜାବଳୀର[\s\xa0]*ପ୍ରଥମ[\s\xa0]*ପୁସ୍ତକ|3(?:rd(?:\.[\s\xa0]*Kingdoms|[\s\xa0]*Kingdoms)|-?(?:тє(?:\.[\s\xa0]*Царів|[\s\xa0]*Царів)|я(?:\.[\s\xa0]*(?:Книга[\s\xa0]*Царств|Царств)|[\s\xa0]*(?:Книга[\s\xa0]*Царств|Царств))|а(?:\.[\s\xa0]*Царів|[\s\xa0]*Царів)|е(?:\.[\s\xa0]*(?:Книга[\s\xa0]*Царств|Цар(?:ств|ів))|[\s\xa0]*(?:Книга[\s\xa0]*Царств|Цар(?:ств|ів))))|(?:[ao](?:\.[\s\xa0]*Reinos|[\s\xa0]*Reinos))|(?:[ея](?:\.[\s\xa0]*(?:Книга[\s\xa0]*Царств|Царств)|[\s\xa0]*(?:Книга[\s\xa0]*Царств|Царств)))|\.[\s\xa0]*(?:Книга[\s\xa0]*(?:на[\s\xa0]*царете|Царств)|краљев(?:ства|има)|M(?:bret[eë]rve|ga[\s\xa0]*Hari)|K(?:ongerigernes[\s\xa0]*Bog|s(?:i[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]lewska))|\.[\s\xa0]*Kr[oó]lewska|[\s\xa0]*Kr[oó]lewska)|ingdoms|r[aá](?:[lľ]ov))|Re(?:inos|g(?:norum|i))|Цар(?:ства?|ів|е))|[\s\xa0]*(?:Re(?:inos|g(?:norum|i))|K(?:ongerigernes[\s\xa0]*Bog|s(?:i[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]lewska))|\.[\s\xa0]*Kr[oó]lewska|[\s\xa0]*Kr[oó]lewska)|ingdoms|r[aá](?:[lľ]ov))|[ie](?:\.[\s\xa0]*Mbret(?:[eë]rve|[\s\xa0]*Mbret[eë]rve))|அரசுகள்|M(?:bret[eë]rve|ga[\s\xa0]*Hari)|k(?:\.[\s\xa0]*Kr[aá](?:[lľ]ov)|[\s\xa0]*Kr[aá](?:[lľ]ov))|краљев(?:ства|има)|Книга[\s\xa0]*(?:на[\s\xa0]*царете|Царств)|Ц(?:ар(?:ства?|ів|е)?)?))|δυτικ[οό]ς[\s\xa0]*Βασιλ(?:[έε]ων[\s\xa0]*Α['ʹʹ΄’])|Cartea[\s\xa0]*(?:a[\s\xa0]*treia[\s\xa0]*a[\s\xa0]*Regilor|III[\s\xa0]*a[\s\xa0]*Regilor)|राजा(?:ओ[\s\xa0]*का[\s\xa0]*विर्तान्त[\s\xa0]*[1१]ला[\s\xa0]*भाग्|हरूक[\s\xa0]*पहिल[\s\xa0]*पुस्तक)|Liber[\s\xa0]*I[\s\xa0]*Regum|இராஜாக்களின்[\s\xa0]*முதலாம்[\s\xa0]*புத்தகம்|מלכים[\s\xa0]*א['’]|Βασιλει[ωώ]ν[\s\xa0]*Γ['ʹʹ΄’]|П(?:ерш(?:[ае][\s\xa0]*(?:книга[\s\xa0]*царів|Cariv|царів))|рв(?:а[\s\xa0]*(?:о[\s\xa0]*царевима|к(?:нига[\s\xa0]*за[\s\xa0]*царевите|раљева)|Царев[аи])|о[\s\xa0]*(?:книга[\s\xa0]*за[\s\xa0]*царевите|Цареви)))|पहिले[\s\xa0]*राजे|K(?:i(?:tabu[\s\xa0]*cha[\s\xa0]*Kwanza[\s\xa0]*cha[\s\xa0]*Wafalme|r[aá]lyok[\s\xa0]*I)|wanza[\s\xa0]*(?:Wafalme|Fal))|۱(?:-?سلاطِین|[\s\xa0۔]*سلاطین)|ﺍﻟﻤﻠﻮﻙ[\s\xa0]*ﺍﻷﻭ|T(?:erceir[ao][\s\xa0]*Reinos|hird[\s\xa0]*Kingdoms|r(?:zeci(?:a[\s\xa0]*Ks(?:i[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]lewska))|\.[\s\xa0]*Kr[oó]lewska|[\s\xa0]*Kr[oó]lewska)|[\s\xa0]*Ks(?:i[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]lewska))|\.[\s\xa0]*Kr[oó]lewska|[\s\xa0]*Kr[oó]lewska))|e(?:dje[\s\xa0]*Kongerigernes[\s\xa0]*Bog|t(?:i(?:a[\s\xa0]*(?:kniha[\s\xa0]*Kr[aá](?:[lľ]ov)|Kr[aá](?:[lľ]ov))|[\s\xa0]*Kr[aá](?:[lľ]ov))|í[\s\xa0]*Kr[aá](?:[lľ]ov)))))|Una(?:ng[\s\xa0]*(?:Mga[\s\xa0]*Hari|Hari)|[\s\xa0]*(?:Mga[\s\xa0]*Hari|Hari))|ਰਾਜਿਆਂ[\s\xa0]*ਦੀ[\s\xa0]*ਪਹਿਲੀ[\s\xa0]*ਪੋਥੀ|Тре(?:ћ(?:ом[\s\xa0]*краљев(?:ства|има)|а[\s\xa0]*краљев(?:ства|има))|т(?:а[\s\xa0]*книга[\s\xa0]*(?:на[\s\xa0]*царете|Царства)|[яє][\s\xa0]*Царів|о[\s\xa0]*(?:Книга[\s\xa0]*на[\s\xa0]*царете|Цар(?:ства|е))))|ا(?:لممالك[\s\xa0]*الثالث|وّل(?:-?سلاطِین|[\s\xa0۔]*سلاطین))|P(?:ierwsz[aey][\s\xa0]*K(?:r(?:[oó]lewska|s(?:i(?:[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))))|\.[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))|[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w)))))|r(?:em(?:i(?:ère(?:s[\s\xa0]*Rois|[\s\xa0]*Rois)|er(?:e(?:s[\s\xa0]*Rois|[\s\xa0]*Rois)|s[\s\xa0]*Rois|[\s\xa0]*Rois))|ye[\s\xa0]*(?:liv[\s\xa0]*Wa[\s\xa0]*yo|Wa))|im(?:e(?:ir[ao][\s\xa0]*Reis|r(?:o[\s\xa0]*Reyes|[\s\xa0]*Reyes))|[ao][\s\xa0]*Re)|v(?:a[\s\xa0]*(?:kn(?:jiga[\s\xa0]*o[\s\xa0]*Kraljevima|iha[\s\xa0]*Kr[aá](?:[lľ]ov))|Kr(?:a(?:l(?:jevima|ov)|ľov)|á[lľ]ov))|[yý][\s\xa0]*(?:list[\s\xa0]*Kr(?:[aá](?:[lľ]ov)|Kr[aá](?:[lľ]ov)))|á[\s\xa0]*(?:kniha[\s\xa0]*Kr[aá](?:[lľ]ov)|Kr[aá](?:[lľ]ov))|n[ií][\s\xa0]*(?:kniha[\s\xa0]*kr(?:[aá]lovsk[aá]|Kr(?:[aá]l(?:ovsk[aá])?)?)))))|Α['ʹʹ΄’][\s\xa0]*Βα(?:σ(?:ιλ(?:[έε]ων)?)?)|列(?:王(?:紀略上|[\s\xa0]*1|記(?:第三巻|上))|上)|Regum[\s\xa0]*I|r(?:aǳ[aā]har(?:[uū]ko[\s\xa0]*pustak)|ā(?:jiāṃ[\s\xa0]*dī[\s\xa0]*pahilī[\s\xa0]*potʰī|ǳ[aā]har(?:[uū]ko[\s\xa0]*pustak))))|(?:3[\s\xa0]*[ei][\s\xa0]*Mbret(?:[eë]rve)|P(?:ierwsz(?:[aey][\s\xa0]*Ks(?:i(?:[eę]g(?:[ai][\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))))|\.[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))|[\s\xa0]*Kr(?:[oó]l(?:ewska|[oó]w))))|rv(?:[yý][\s\xa0]*Kr(?:[aá](?:[lľ]ov))|n(?:[ií][\s\xa0]*Kr(?:[aá]l(?:ovsk[aá])?)?)))|1(?:\.[\s\xa0]*[IÎ]mp|[\s\xa0]*(?:[ei][\s\xa0]*Mbret(?:[eë]rve)|[IÎ]mp))|I(?:\.[\s\xa0]*[IÎ]mp|[\s\xa0]*[IÎ]mp)|Α['ʹʹ΄’][\s\xa0]*Βα)|(?:1(?:\.[\s\xa0]*Kuninkaiden|[\s\xa0]*Kuninkaiden)|Fyrri[\s\xa0]*konungabók|מלכים[\s\xa0]*א|王上》?|I(?:\.[\s\xa0]*Kuninkaiden|[\s\xa0]*(?:Kuninkaiden|Regum))|K(?:ngs|gs|in(?:gs)?)|《(?:列王[记紀纪]上|王上)|Ensimm[aä]inen[\s\xa0]*Kuninkaiden|الملوك[\s\xa0]*الأول|列王[纪记紀]上》?))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["EpJer"],
        apocrypha: true,
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:L(?:a[\\s\\xa0]*Carta[\\s\\xa0]*de[\\s\\xa0]*Jerem[ií]as|lythyr[\\s\\xa0]*Jeremeia|et(?:tera[\\s\\xa0]*di[\\s\\xa0]*Geremia|-?ger)|i(?:st[\\s\\xa0]*Jerem(?:iasza|j[aá](?:[sš](?:[uů]v)))|h[\\s\\xa0]*Jer))|Jer(?:emi(?:jino[\\s\\xa0]*pismo|á(?:s(?:[\\s\\xa0]*levele|ov[\\s\\xa0]*list)|šov[\\s\\xa0]*list)|a(?:šov[\\s\\xa0]*list|n[\\s\\xa0]*kirje|s(?:ov[\\s\\xa0]*list|['’][\\s\\xa0]*Brev|[\\s\\xa0]*(?:levele|brev))))|[\\s\\xa0]*br|br)|Ang[\\s\\xa0]*Liham[\\s\\xa0]*ni[\\s\\xa0]*Jeremias|《EpJer》|Επιστολ(?:ή[\\s\\xa0]*Ιερεμ[ίι]ου|η[\\s\\xa0]*(?:Ιερεμ[ίι]ου|᾿Ιερ)|ὴ[\\s\\xa0]*᾿Ιερ)|எரேமியாவின்[\\s\\xa0]*(?:கடிதம்|மடல்)|예레미야의[\\s\\xa0]*편지|Pismo[\\s\\xa0]*Jeremije[\\s\\xa0]*proroka|エレミヤ(?:の(?:手紙|書翰)|・手)|П(?:ослан(?:и(?:ца[\\s\\xa0]*Јеремијина|е[\\s\\xa0]*(?:на[\\s\\xa0]*Иеремия|Иеремии))|ня[\\s\\xa0]*Єремі[ії])|исма[\\s\\xa0]*Јеремије)|Ep(?:i(?:st(?:ola[\\s\\xa0]*lui[\\s\\xa0]*Ieremia|le[\\s\\xa0]*of[\\s\\xa0]*Jeremy)|tre[\\s\\xa0]*de[\\s\\xa0]*J[eé]r(?:[eé]mie))|ître[\\s\\xa0]*de[\\s\\xa0]*J[eé]r(?:[eé]mie)|\\.[\\s\\xa0]*J(?:[eé]r(?:[eé]mie)?)|[\\s\\xa0]*J(?:[eé]r(?:[eé]mie)?))|رسالة[\\s\\xa0]*إرميا|அவை[\\s\\xa0]*இளைஞர்[\\s\\xa0]*மூவரின்[\\s\\xa0]*பாடல்|Or(?:atio[\\s\\xa0]*Ieremiae|\\.[\\s\\xa0]*Ier|[\\s\\xa0]*Ier)|イエレミヤの達書|Cart(?:\\.[\\s\\xa0]*Jer|a[\\s\\xa0]*Jer(?:em[ií]as)?|[\\s\\xa0]*Jer)|איגרת[\\s\\xa0]*ירמיהו|Лист[\\s\\xa0]*Єремі[ії]|Ép(?:[iî]tre[\\s\\xa0]*de[\\s\\xa0]*J(?:[eé]r(?:[eé]mie))|\\.[\\s\\xa0]*J(?:[eé]r(?:[eé]mie)?)|[\\s\\xa0]*J(?:[eé]r(?:[eé]mie)?))|The[\\s\\xa0]*(?:Let(?:ter[\\s\\xa0]*of[\\s\\xa0]*Jeremiah|\\.[\\s\\xa0]*of[\\s\\xa0]*Jeremiah|[\\s\\xa0]*of[\\s\\xa0]*Jeremiah)|Ep(?:istle[\\s\\xa0]*of[\\s\\xa0]*Jeremiah|\\.[\\s\\xa0]*of[\\s\\xa0]*Jeremiah|[\\s\\xa0]*of[\\s\\xa0]*Jeremiah))|B(?:arua[\\s\\xa0]*ya[\\s\\xa0]*Yeremia|r(?:ief[\\s\\xa0]*(?:des[\\s\\xa0]*Jeremia|van[\\s\\xa0]*Jeremia)|[eé]f[\\s\\xa0]*Jerem(?:[ií]a)|[\\s\\xa0]*Jer)|Jer))|(?:Carta[\\s\\xa0]*de[\\s\\xa0]*Jerem[ií]as|L(?:iham[\\s\\xa0]*ni[\\s\\xa0]*Jeremias|et(?:ter[\\s\\xa0]*of[\\s\\xa0]*Jeremiah|\\.[\\s\\xa0]*of[\\s\\xa0]*Jeremiah|[\\s\\xa0]*of[\\s\\xa0]*Jeremiah))|《EpJer|Ep(?:istle[\\s\\xa0]*of[\\s\\xa0]*Jeremiah|\\.[\\s\\xa0]*of[\\s\\xa0]*Jeremiah|[\\s\\xa0]*of[\\s\\xa0]*Jeremiah|Jer》?)))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Lam"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Pla[cč][\\s\\xa0]*Jeremi(?:(?:[aá](?:[sš](?:[ouů]v))|[iï]))|(?:เพลงคร่ำครวญ|П(?:лач(?:от[\\s\\xa0]*на[\\s\\xa0]*Еремија|ът[\\s\\xa0]*на[\\s\\xa0]*(?:[ИЙ]еремия|Еремия)|[\\s\\xa0]*(?:на[\\s\\xa0]*Еремиин|Јеремијин|Ереми(?:ев|ин)|Иеремии|Єремі[ії]))|\\.[\\s\\xa0]*[ИЙ]ер|[\\s\\xa0]*[ИЙ]ер)|哀歌|nūḥâ|wil[aā]pg(?:[iī]t)|M(?:ga[\\s\\xa0]*(?:Lamentasyon|Pa(?:gbangotan|naghoy))|ao(?:mbolezo[\\s\\xa0]*ya[\\s\\xa0]*Yeremia)?)|ଯିରିମିୟଙ୍କ[\\s\\xa0]*ବିଳାପ|Baroor(?:ashadii[\\s\\xa0]*Yeremyaah)?|קינות|(?:[ZŽ]alosp(?:evy)?)|איכה|Θρ[ήη]νοι[\\s\\xa0]*Ιερεμ(?:[ίι]ου)?|مرا|Jeremi(?:jine[\\s\\xa0]*tu[zž]aljke|(?:[aá](?:šov[\\s\\xa0]*Pla[cč]|s(?:ov[\\s\\xa0]*Pla[cč]|[\\s\\xa0]*sir(?:almai)?))))|エレミヤの哀歌|سفر[\\s\\xa0]*مراثي[\\s\\xa0]*إرميا|P(?:ulampal|anag|l(?:á[cč][\\s\\xa0]*Jerem(?:[ij](?:[aá](?:[sš](?:[uů]v))))|a(?:[cč][\\s\\xa0]*Jeremj(?:[aá](?:[sš](?:[uů]v)))|ng(?:eri(?:le[\\s\\xa0]*(?:profetului[\\s\\xa0]*Ieremia|lui[\\s\\xa0]*Ieremia))?)?)|âng(?:eri(?:le[\\s\\xa0]*(?:profetului[\\s\\xa0]*Ieremia|lui[\\s\\xa0]*Ieremia))?)?)?)|ਵਿਰਲਾਪ|எரேமியாவின்[\\s\\xa0]*புலம்பல்|L(?:am(?:antasyon|enta(?:ç[oôõ]es[\\s\\xa0]*de[\\s\\xa0]*Jeremias|zioni|c(?:[oôõ]es[\\s\\xa0]*de[\\s\\xa0]*Jeremias|je[\\s\\xa0]*Jeremiasza|i(?:ones?|je))|tion(?:s[\\s\\xa0]*de[\\s\\xa0]*J[eé]r(?:[eé]mie)|es)?)|inta(?:ciones?|tions?))?|m)|Omb|N(?:[aá]r(?:eky)?)|Siral(?:m(?:ak)?)?|예레미(?:아애가|야(?:[\\s\\xa0]*애가|애가))|yarmiy[aā]ko[\\s\\xa0]*vil(?:[aā]p)|K(?:idung[\\s\\xa0]*Pa(?:ngadhuh|sambat)|s(?:i[eę]g(?:[ai][\\s\\xa0]*Lamentacji)|\\.[\\s\\xa0]*Lamentacji|[\\s\\xa0]*Lamentacji)|niha[\\s\\xa0]*n(?:[aá](?:r(?:ekov|k[uů])|řk[uů]))|\\.[\\s\\xa0]*n[aá]rekov|[\\s\\xa0]*n[aá]rekov|l(?:a(?:agl(?:iederen)?|g(?:ovisorna|e(?:lieder[\\s\\xa0]*Jeremias|s(?:angene)?))?)|gl)?)|《(?:耶利米哀歌》|連同哀歌》|哀》)|บทเพลงคร่ำครวญ|virlāp|A(?:klat[\\s\\xa0]*ng[\\s\\xa0]*Pa(?:nanaghoy|gtaghoy)|i[\\s\\xa0]*Ca)|애|C(?:hante[\\s\\xa0]*pou[\\s\\xa0]*plenn[\\s\\xa0]*S[oò][\\s\\xa0]*lavil[\\s\\xa0]*Jerizal(?:[eè]m)|a[\\s\\xa0]*thương)|พคค|H(?:armlj[oó]ðin|lj)|Книга[\\s\\xa0]*Плач[\\s\\xa0]*Иеремиев|புல(?:ம்)?|T(?:u[zž]|r(?:eny[\\s\\xa0]*Jeremiasza)?)|المراثي|ن(?:َوحہ|وحہ)|विलापग[ीे]त|Galar(?:nad[\\s\\xa0]*Jeremiah)?|यर्मियाको[\\s\\xa0]*विलाप|V(?:ilapageet|a(?:lit(?:usvirret)?|j(?:timet)?)))|Θρ|(?:哀》?|مراثي[\\s\\xa0]*إرميا|애가|Galarnad|Плач(?:[\\s\\xa0]*Иеремиев)?|புலம்பல்|Θρ[ηή]νοι|《(?:耶利米哀歌|連同哀歌|哀)|T(?:u[zž]aljke|reny)|P(?:a(?:gbangotan|naghoy)|l(?:enn|[aá][čc]))|विलाप|Maombolezo|Klagelieder|耶利米哀歌》?|連同哀歌》?|Baroorashadii|Lamenta(?:tions|ç[oõ]es|c(?:[õo]es|je))))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Num"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])((?:Бр(?:о(?:јеви|еви))?|Vier(?:de[\s\xa0]*Mozes|te[\s\xa0]*(?:Buch[\s\xa0]*Mose|Mose))|ਗਿਣਤੀ|ଗଣନା[\s\xa0]*ପୁସ୍ତକ|N(?:elj[aä]s[\s\xa0]*Mooseksen[\s\xa0]*kirja|[bm]|o(?:nb|m(?:b(?:res)?)?)?|u(?:m(?:erii|rat|b(?:er[is]?)?)?)?|ú(?:m(?:eros)?)?)|g(?:a(?:n(?:t[iī]ko[\s\xa0]*pustak|an[aā])|ṇan[aā])|i[nṇ]tī)|Книга[\s\xa0]*Чисел|عد|ספירה|4(?:\.[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|книга[\s\xa0]*Мо[ий]сеева|Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Buch[\s\xa0]*Mose|Мо(?:исеева|јс(?:ијева)?)|M(?:ó(?:zes|s(?:eb[oó]k)?)|o(?:oseksen[\s\xa0]*kirja|zes|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)|s(?:e(?:b(?:o(?:g|k(?:en)?)|ók))?)?)?))|Mós|[\s\xa0]*(?:книга[\s\xa0]*Мо[ий]сеева|Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|k(?:niha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|\.[\s\xa0]*Moj[zž]i(?:[sš]ova)|[\s\xa0]*Moj[zž]i(?:[sš]ova))|Buch[\s\xa0]*Mose|M(?:ó(?:s(?:eb[oó]k)?|z(?:es)?)|o(?:os(?:eksen[\s\xa0]*kirja)?|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)?|s(?:e(?:b(?:o(?:g|k(?:en)?)|ók))?)?|z(?:es)?)?|z)|М(?:о(?:исеева|јс(?:ијева)?))?))|liv[\s\xa0]*Resansman[\s\xa0]*an|سفر[\s\xa0]*العدد|Αρ(?:ιθ(?:μο[ίι])?)?|Ἀρ|민(?:수기?)?|K(?:itabu[\s\xa0]*cha[\s\xa0]*Nne[\s\xa0]*cha[\s\xa0]*Musa|njiga[\s\xa0]*Brojeva|s(?:i[eę]g(?:[ai][\s\xa0]*Liczb)|\.[\s\xa0]*Liczb|[\s\xa0]*Liczb))|Štvrt[aá][\s\xa0]*(?:kniha[\s\xa0]*Moj(?:[zž]i(?:[sš]ova)|Moj[zž]i(?:[sš]ova)))|L(?:iber[\s\xa0]*Numeri|b)|民数記|Dân[\s\xa0]*số[\s\xa0]*ký|Hesabu|Fj(?:(?:[aä]rde[\s\xa0]*Mosebok(?:en)?)|[oó]rða[\s\xa0]*(?:b(?:[oó]k[\s\xa0]*M(?:[oó]se)|M[oó]seb(?:[oó]k)))|erde[\s\xa0]*Mos(?:ebo[gk])?)|Res|Wilangan|எண்(?:ண(?:ாகமம்|ிக்கை))?|Č(?:tvrt[aá][\s\xa0]*(?:kniha[\s\xa0]*Moj(?:[zž](?:[ií](?:[sš]ova))|Moj[zž](?:[ií](?:[sš]ova))))|ysla)|ग(?:न्ती(?:को[\s\xa0]*पुस्तक)?|िनती|णना)|מניין|E[nṇ](?:[nṇ](?:[aā]kamam))|ก(?:ันดารวิถี|ดว)|B(?:[ae]midbar|rojevi|il)|IV(?:\.[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|книга[\s\xa0]*Мо[ий]сеева|Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Мо(?:исеева|јс(?:ијева)?)|M(?:o(?:oseksen[\s\xa0]*kirja|zes|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)|s(?:eb[oó]k)?)|ó(?:zes|s(?:eb[oó]k)?)))|[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|книга[\s\xa0]*Мо[ий]сеева|Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Мо(?:исеева|јс(?:ијева)?)|M(?:o(?:oseksen[\s\xa0]*kirja|zes|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)?|s(?:eb[oó]k)?)|ó(?:zes|s(?:eb[oó]k)?))))|S(?:tvrt[aá][\s\xa0]*(?:kniha[\s\xa0]*Moj(?:[zž]i(?:[sš]ova)|Moj[zž]i(?:[sš]ova)))|z(?:[aá]m(?:ok)?))|Ч(?:етв(?:ерта[\s\xa0]*книга[\s\xa0]*Мо[ий]сеева|ърта[\s\xa0]*(?:книга[\s\xa0]*Моисеева|Моисеева)|рта[\s\xa0]*(?:книга[\s\xa0]*Мојсеева|Мојс(?:ијева)?))|ис(?:ла)?)|M(?:ga[\s\xa0]*(?:Bilang|Numeros?)|[oó]zes[\s\xa0]*IV)|במדבר|گ(?:ِنتی|نتی)|Tir(?:intii)?|《(?:戶籍紀》|民(?:数记》|數記》|》))|C(?:tvrt[aá][\s\xa0]*(?:kniha[\s\xa0]*Moj(?:[zž](?:[ií](?:[sš]ova))|Moj[zž](?:[ií](?:[sš]ova))))|zwarta[\s\xa0]*(?:Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Moj(?:[zż](?:eszowa)?))|ysla)|Ginatee)|(?:[CČ]tvrt(?:[aá][\s\xa0]*Moj(?:[zž](?:[ií](?:[sš]ova))))|[SŠ]tvrt(?:[aá][\s\xa0]*Moj(?:[zž]i(?:[sš]ova)))|Fj[oó]rða[\s\xa0]*M(?:[oó]seb(?:[oó]k)))|(?:ଗଣନା|Resansman|gant[īi]ko|4(?:\.[\s\xa0]*Mooseksen|[\s\xa0]*Mooseksen)|गन्तीको|IV(?:\.[\s\xa0]*Mooseksen|[\s\xa0]*Mooseksen)|民(?:数记》?|數記》?|》)?|N(?:elj[äa]s[\s\xa0]*Mooseksen|umer(?:os?|i))|《(?:戶籍紀|民(?:数记|數記)?)|Liczb|戶籍紀》?|العدد|Dân(?:[\s\xa0]*Số)?))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["Sus"],
        apocrypha: true,
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:《Sus》|Σ(?:ωσ[άα]ννα|ουσ(?:[άα]ννα)?)|كتاب[\\s\\xa0]*سوزانا|Hist(?:ória[\\s\\xa0]*de[\\s\\xa0]*Susana|oria[\\s\\xa0]*(?:de[\\s\\xa0]*Susana|Susannae))|С(?:казанию[\\s\\xa0]*о[\\s\\xa0]*Сусанне[\\s\\xa0]*и[\\s\\xa0]*Данииле|ус(?:анна[\\s\\xa0]*и[\\s\\xa0]*старцы)?)|수산나|ス(?:[サザ]ンナ(?:物語)?)|שושנה|Z(?:suz(?:s(?:anna[\\s\\xa0]*[eé]s[\\s\\xa0]*a[\\s\\xa0]*v(?:[eé]nek))?)?|uz(?:an(?:na|[ae]))?)|சூசன்னா|Fortellingen[\\s\\xa0]*om[\\s\\xa0]*Susanna|Opowiadaniem[\\s\\xa0]*o[\\s\\xa0]*Zuzannie|Istoria[\\s\\xa0]*Susanei|S(?:toria[\\s\\xa0]*di[\\s\\xa0]*Susanna|i[\\s\\xa0]*Susana|hoshana|[wú]sanna|u(?:sann(?:e[\\s\\xa0]*(?:et[\\s\\xa0]*les[\\s\\xa0]*(?:deux[\\s\\xa0]*vieillards|vieillards)|au[\\s\\xa0]*bain)|a(?:[\\s\\xa0]*(?:und[\\s\\xa0]*die[\\s\\xa0]*Alten|ja[\\s\\xa0]*vanhimmat|i(?:[\\s\\xa0]*badet|m[\\s\\xa0]*Bade))|h))|z(?:an(?:ne[\\s\\xa0]*(?:et[\\s\\xa0]*les[\\s\\xa0]*(?:deux[\\s\\xa0]*vieillards|vieillards)|au[\\s\\xa0]*bain)|a))?)?))|(?:Zsuzsanna|Сусанна|سوزانا|《Sus|Su(?:zanne|s(?:an(?:n(?:ae?|e)|ei|a)|》)?)))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Sir"],
        apocrypha: true,
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:Бен[\\s\\xa0]*Сираха|Huấn[\\s\\xa0]*Ca|Ang[\\s\\xa0]*Karunungan[\\s\\xa0]*ni[\\s\\xa0]*Jesus(?:,[\\s\\xa0]*Anak[\\s\\xa0]*ni[\\s\\xa0]*Sirac|[\\s\\xa0]*Anak[\\s\\xa0]*ni[\\s\\xa0]*Sirac)|K(?:arunungan[\\s\\xa0]*ng[\\s\\xa0]*Anak[\\s\\xa0]*ni[\\s\\xa0]*Sirac|itab[\\s\\xa0]*Yesus[\\s\\xa0]*bin[\\s\\xa0]*Sirakh|n(?:iha[\\s\\xa0]*(?:Ekleziastikus|S(?:írachovcova|irachov(?:ho[\\s\\xa0]*syna|c(?:ova|a))))|jiga[\\s\\xa0]*Sirahova)|\\.[\\s\\xa0]*(?:Ekleziastikus|Sirachov(?:ho[\\s\\xa0]*syna|c(?:ova|a)))|[\\s\\xa0]*(?:Ekleziastikus|Sirachov(?:ho[\\s\\xa0]*syna|c(?:ova|a))))|ספר[\\s\\xa0]*בן[\\s\\xa0]*סירא|Cartea[\\s\\xa0]*[iî]n(?:[tţ]elepciunii[\\s\\xa0]*lui[\\s\\xa0]*Isus,[\\s\\xa0]*fiul[\\s\\xa0]*lui[\\s\\xa0]*Sirah)|Сир(?:ина)?|(?:[ヘベ]ン・シラの(?:智慧|知恵))|Книга[\\s\\xa0]*(?:Премъдрост[\\s\\xa0]*на[\\s\\xa0]*Иисуса,[\\s\\xa0]*син[\\s\\xa0]*Сирахов|на[\\s\\xa0]*Сирах|Сираха)|M[aą]dro(?:[sś](?:[cć][\\s\\xa0]*Syracha))|Wijsheid[\\s\\xa0]*van[\\s\\xa0]*(?:J(?:ozua[\\s\\xa0]*Ben[\\s\\xa0]*Sirach|ezus[\\s\\xa0]*Sirach)|Ben[\\s\\xa0]*Sirach)|Екле(?:зијастикус|сіаст)|يشوع[\\s\\xa0]*بن[\\s\\xa0]*سيراخ|Прем(?:ъдрост[\\s\\xa0]*на[\\s\\xa0]*Иисус,[\\s\\xa0]*син[\\s\\xa0]*Сирахов|удр(?:ість[\\s\\xa0]*Ісуса,[\\s\\xa0]*сина[\\s\\xa0]*Сирахова|ост(?:и[\\s\\xa0]*И(?:исуса,[\\s\\xa0]*сына[\\s\\xa0]*Сирахова|суса[\\s\\xa0]*сина[\\s\\xa0]*Сирахова)|ь[\\s\\xa0]*Сираха)))|சீ(?:ராக்(?:கின்[\\s\\xa0]*ஞானம்|[\\s\\xa0]*ஆகமம்)|ஞா)|Oratio[\\s\\xa0]*Iesu[\\s\\xa0]*filii[\\s\\xa0]*Sirach|L(?:a[\\s\\xa0]*Sagesse[\\s\\xa0]*de[\\s\\xa0]*Ben[\\s\\xa0]*Sira|iber[\\s\\xa0]*Ecclesiasticus)|The[\\s\\xa0]*Wisdom[\\s\\xa0]*of[\\s\\xa0]*Jesus(?:,[\\s\\xa0]*Son[\\s\\xa0]*of[\\s\\xa0]*Sirach|[\\s\\xa0]*(?:Son[\\s\\xa0]*of[\\s\\xa0]*Sirach|ben[\\s\\xa0]*Sirach))|משלי[\\s\\xa0]*בן[\\s\\xa0\\-?]*סירא|E(?:c(?:le(?:si[aá]stico|ziastic)|c(?:l(?:ésiastique|esiasti(?:que|c(?:ul|o))|us(?:iasticus)?)|s))|k(?:kle(?:s(?:[iy]astik(?:us|o))|ziastik)|l(?:e(?:s(?:[iy]astik(?:us|o))|zjastyka?)|i)))|S(?:apienza[\\s\\xa0]*di[\\s\\xa0]*Sirac(?:ide|h)|yr(?:ak)?|ír(?:a(?:chovec|ksb[oó]k))?|i(?:r(?:a(?:c(?:hovec|id(?:es|as?))|k(?:[\\s\\xa0]*(?:b[oö]lcsess(?:[eé]ge)|fia)|s(?:[\\s\\xa0]*(?:Bog|bok)|b[oó]k)|i(?:n[\\s\\xa0]*kirja|d[ae]s?)))|àcide|á(?:k(?:[\\s\\xa0]*(?:b[oö]lcsess(?:[eé]ge)|fia)|id[ae]s?|h)|c(?:id[ae]s?|h)?))?)?)|シラ(?:フの子イイススの知恵書|書（集会の書）)?|ИсС|벤시(?:리크의[\\s\\xa0]*지혜|라(?:의[\\s\\xa0]*지혜|크(?:의[\\s\\xa0]*지혜|[\\s\\xa0]*지혜)|[\\s\\xa0]*지혜))|س(?:فر[\\s\\xa0]*ابن[\\s\\xa0]*سيراخ|ي)|Y(?:oshua[\\s\\xa0]*bin[\\s\\xa0]*Sira|bS)|บุตรสิรา|집회서?|《德訓篇》|Σοφ[ίι]α[\\s\\xa0]*Σ(?:ειρ(?:[άα]χ|ιραχ))|Je(?:esus[\\s\\xa0]*Siirakin[\\s\\xa0]*kirja|su(?:[\\s\\xa0]*Siraks[\\s\\xa0]*sønns[\\s\\xa0]*visdom|s[\\s\\xa0]*S(?:yraks[\\s\\xa0]*vishet|i(?:irakin[\\s\\xa0]*kirja|rach)))))|Σοφ(?:[ίι]α[\\s\\xa0]*Σιραχ)|(?:Ecclesiasticus|Wisdom[\\s\\xa0]*of[\\s\\xa0]*Jesus(?:,[\\s\\xa0]*Son[\\s\\xa0]*of[\\s\\xa0]*Sirach|[\\s\\xa0]*(?:Son[\\s\\xa0]*of[\\s\\xa0]*Sirach|ben[\\s\\xa0]*Sirach))|集会の書|Σειρ[αά]χ|《德訓篇|S(?:agesse[\\s\\xa0]*de[\\s\\xa0]*Ben[\\s\\xa0]*Sira|yracha|i(?:irakin(?:[\\s\\xa0]*kirja)?|r(?:ák|a(?:k(?:in|h)?|c(?:ide|h(?:ovcova)?)?)?)))|シラ書|Jezus[\\s\\xa0]*Sirach|德訓篇》?|Ben[\\s\\xa0]*Sira|سيراخ|Сирах(?:ова?|а)))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["PrMan"],
        apocrypha: true,
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Manasses[\\s\\xa0]*bønn|(?:תפילת[\\s\\xa0]*מנשה|《PrMan》|Da(?:langin[\\s\\xa0]*ni[\\s\\xa0]*Manases|sal[\\s\\xa0]*ni[\\s\\xa0]*Manases)|Rug(?:[aă]ciunea[\\s\\xa0]*(?:regelui[\\s\\xa0]*Manase|lui[\\s\\xa0]*Manase))|Молитва[\\s\\xa0]*Манас(?:ијина|сии)|므나쎄의[\\s\\xa0]*기도|マナセの(?:いのり|祈[り禱])|G(?:weddi[\\s\\xa0]*Manasse|eb(?:et[\\s\\xa0]*(?:des[\\s\\xa0]*Manasse|Manasses?)|[\\s\\xa0]*Man))|The[\\s\\xa0]*Pr(?:ayer(?:s[\\s\\xa0]*(?:of[\\s\\xa0]*Manasseh|Manasseh)|[\\s\\xa0]*(?:of[\\s\\xa0]*Manasseh|Manasseh))|[\\s\\xa0]*(?:of[\\s\\xa0]*Manasseh|Manasseh))|Or(?:a(?:zione[\\s\\xa0]*di[\\s\\xa0]*Manasse[\\s\\xa0]*Re[\\s\\xa0]*di[\\s\\xa0]*Giuda|tio[\\s\\xa0]*(?:regis[\\s\\xa0]*Manassae|Manassae))|\\.[\\s\\xa0]*Man|[\\s\\xa0]*Man)|B(?:æn[\\s\\xa0]*Manasse|Mn)|La[\\s\\xa0]*(?:Oraci[oó]n[\\s\\xa0]*de[\\s\\xa0]*Manas(?:[eé]s)|Pri[eè]re[\\s\\xa0]*de[\\s\\xa0]*Manass[eé])|Pr(?:e(?:ghiera[\\s\\xa0]*di[\\s\\xa0]*Manasse|ce[\\s\\xa0]*de[\\s\\xa0]*Manass[eé]s)|\\.[\\s\\xa0]*Man(?:ass[eé])?|[\\s\\xa0]*Man(?:ass[eé])?)|صلاة[\\s\\xa0]*منسى|M(?:odlit(?:wa[\\s\\xa0]*Manassesa|bu[\\s\\xa0]*Manasse)|an(?:as(?:esova[\\s\\xa0]*modlitba|s(?:é[\\s\\xa0]*im[aá]ds(?:[aá]ga)|ze[\\s\\xa0]*im[aá]ja|e(?:n[\\s\\xa0]*rukouksen|s(?:’[\\s\\xa0]*b[oö]n|[\\s\\xa0]*(?:Bøn|b[oö]n))|[\\s\\xa0]*(?:im[aá]ds(?:[aá]ga)|b[oö]n))))|[\\s\\xa0]*ru))|Πρ(?:οσευχ[ήη][\\s\\xa0]*Μανασσ[ήη]|[\\s\\xa0]*Μαν)|Ang[\\s\\xa0]*Panalangin[\\s\\xa0]*ni[\\s\\xa0]*Manases)|(?:Ora(?:zione[\\s\\xa0]*di[\\s\\xa0]*Manasse|ci[oó]n[\\s\\xa0]*de[\\s\\xa0]*Manas(?:[ée]s))|《PrMan|P(?:analangin[\\s\\xa0]*ni[\\s\\xa0]*Manases|r(?:i[eè]re[\\s\\xa0]*de[\\s\\xa0]*Manass[ée]|ayer(?:s[\\s\\xa0]*(?:of[\\s\\xa0]*Manasseh|Manasseh)|[\\s\\xa0]*(?:of[\\s\\xa0]*Manasseh|Manasseh))|[\\s\\xa0]*(?:of[\\s\\xa0]*Manasseh|Manasseh)|Man》?))|Man(?:as(?:se|e))?))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Acts"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:Fapt(?:e(?:le[\\s\\xa0]*Apostolilor|[\\s\\xa0]*Apostolilor))?|Дап)|(?:사도(?:행전)?|B(?:uhat[\\s\\xa0]*sa[\\s\\xa0]*mga[\\s\\xa0]*Apostoles|in)|Πρ(?:[άα]ξ(?:εις[\\s\\xa0]*των[\\s\\xa0]*Αποστ(?:[οό]λων)?)|ξ)|H(?:and(?:elingen[\\s\\xa0]*(?:van[\\s\\xa0]*de[\\s\\xa0]*apostelen|der[\\s\\xa0]*apostelen))?|ech?|nd|ch?)|《(?:使徒行[传傳]》|宗徒(?:大事錄》|行實》)|徒》)|ก(?:ิจการ​ของ​อัครทูต|จ)|Ebanghelyo[\\s\\xa0]*ng[\\s\\xa0]*Espiritu[\\s\\xa0]*Santo|ਰਸੂਲਾਂ[\\s\\xa0]*ਦੇ[\\s\\xa0]*ਕਰਤੱਬ|C(?:ông[\\s\\xa0]*vụ[\\s\\xa0]*(?:các[\\s\\xa0]*Sứ[\\s\\xa0]*đồ|Tông[\\s\\xa0]*đồ)|selekedetek)|தி(?:ருத்தூதர்[\\s\\xa0]*பணிகள்|ப)|ا(?:َعمال|ع)|मसीह-?दूत|یوحنا[\\s\\xa0]*کے[\\s\\xa0]*اعمال|رس(?:ُولوں[\\s\\xa0]*کے[\\s\\xa0]*اعمال|ولوں[\\s\\xa0]*کے[\\s\\xa0]*اعمال)|ପ୍ରେରିତ(?:ମାନଙ୍କ[\\s\\xa0]*କାର୍ଯ୍ୟର[\\s\\xa0]*ବିବରଣ)?|P(?:raeriton[\\s\\xa0]*Ke[\\s\\xa0]*Kam|ostulasagan)|pre(?:[sš]it(?:[aā](?:[mṃ]c(?:[iī](?:[mṃ][\\s\\xa0]*kr̥tye[mṃ]))))|rithar[uū]k(?:[aā][\\s\\xa0]*k(?:[aā]m)))|ﺍﻋﻤﺎﻝ[\\s\\xa0]*ﺍﻟﺮﺳﻞ|F(?:[\\s\\xa0]*Ap|\\.(?:[\\s\\xa0]*Ap|A)|a(?:l(?:imaha[\\s\\xa0]*Rasuullada)?|p)|A)|rasūl(?:āṃ[\\s\\xa0]*de[\\s\\xa0]*kartabb|ōṅ[\\s\\xa0]*ke[\\s\\xa0]*aʿmāl)|سفر[\\s\\xa0]*أعمال[\\s\\xa0]*الرسل|A(?:ng[\\s\\xa0]*Mga[\\s\\xa0]*Binuhatan|k(?:syon[\\s\\xa0]*ap[oò]t[\\s\\xa0]*yo|d[eè]zapot)|z[\\s\\xa0]*(?:apostolok[\\s\\xa0]*cselekedetei|ApCsel)|p(?:ost(?:l(?:enes(?:[\\s\\xa0]*(?:gjerninger|Gerninger)|-?gjerninge)|ag[aä]rningarna)|elg(?:jerningene|eschichte)|olien[\\s\\xa0]*teot)|p[oō]stalar[\\s\\xa0]*Pa(?:[nṇ]i)|[\\s\\xa0]*(?:Csel|t)|\\.(?:[\\s\\xa0]*(?:Csel|t)|[Gt])|[Gt])|c(?:t(?:es[\\s\\xa0]*des[\\s\\xa0]*Ap[oô]tres|us[\\s\\xa0]*Apostolorum|sss?|a(?:u['’]r[\\s\\xa0]*Apostolion)?)?)?|t(?:ti[\\s\\xa0]*degli[\\s\\xa0]*Apostoli|os[\\s\\xa0]*dos[\\s\\xa0]*Ap[oó]stolos)?)|Vep(?:rat[\\s\\xa0]*e[\\s\\xa0]*Apostujve)?|Д(?:\\.[\\s\\xa0]*А|е(?:ла[\\s\\xa0]*(?:на[\\s\\xa0]*(?:светите[\\s\\xa0]*апостоли|апостолите)|Ап(?:остолска)?)|ян(?:ия(?:та[\\s\\xa0]*на[\\s\\xa0]*апостолите|[\\s\\xa0]*на[\\s\\xa0]*(?:светите[\\s\\xa0]*Апостоли|апостолите)))?)|і(?:(?:[ії][\\s\\xa0]*(?:святих[\\s\\xa0]*апостолів|Апостолів))|ян(?:ня[\\s\\xa0]*Святих[\\s\\xa0]*Апостолів)?)|[\\s\\xa0]*А)|Sk(?:utky[\\s\\xa0]*apo(?:[sš]tol(?:sk[eé]|ov|[uů])))?|G(?:awa[\\s\\xa0]*ng[\\s\\xa0]*Apostoles|w)|D(?:ijannja[\\s\\xa0]*svjaty[hȟ][\\s\\xa0]*apostoliv|z(?:iej(?:ach[\\s\\xa0]*Apostolskich|e[\\s\\xa0]*Apost(?:olskie)?)|[\\s\\xa0]*Ap)|j(?:ela[\\s\\xa0]*apostolska)?)|T(?:he[\\s\\xa0]*Acts[\\s\\xa0]*of[\\s\\xa0]*the[\\s\\xa0]*Apostles|ravay[\\s\\xa0]*ap[oò]t[\\s\\xa0]*yo)|L(?:os[\\s\\xa0]*Hechos[\\s\\xa0]*de[\\s\\xa0]*los[\\s\\xa0]*Ap[oó]stoles|elakone[\\s\\xa0]*Para[\\s\\xa0]*Rasul)|M(?:a(?:buting[\\s\\xa0]*Balita[\\s\\xa0]*(?:ayon[\\s\\xa0]*sa[\\s\\xa0]*Espiritu[\\s\\xa0]*Santo|ng[\\s\\xa0]*Espiritu[\\s\\xa0]*Santo)|tendo[\\s\\xa0]*ya[\\s\\xa0]*Mitume)|ga[\\s\\xa0]*Gawa(?:[\\s\\xa0]*ng[\\s\\xa0]*mga[\\s\\xa0]*A(?:postol(?:es)?|lagad)|in)|do)|प्र(?:े(?:षितांची(?:[\\s\\xa0]*कृत्यें|ं[\\s\\xa0]*कृत्यें?)|रित(?:हरूका[\\s\\xa0]*काम|ों[\\s\\xa0]*के[\\s\\xa0]*काम(?:ों)?)?)|[\\s\\xa0]*क|\\.(?:[\\s\\xa0]*क|क)|क)|מעשי[\\s\\xa0]*השליחים|அப்(?:போ(?:ஸ்தலர(?:ுடைய[\\s\\xa0]*நடபடிகள்|்[\\s\\xa0]*பணி))?)?|使徒(?:言行録|行[伝録]|書)?)|Πρ(?:[άα]ξ)|(?:徒》?|Dz(?:ieje)?|A(?:ct(?:[ue]s|au|s(?:[\\s\\xa0]*of[\\s\\xa0]*the[\\s\\xa0]*Apostles)?)|t(?:ti|os)|p(?:ostolok(?:[\\s\\xa0]*cselekedetei)?|Csel|g))|اعمال|M(?:ga[\\s\\xa0]*Gawa|atendo)|رسولوں|Los[\\s\\xa0]*Hechos|أعمال[\\s\\xa0]*الرسل|G(?:erninger|awa(?:[\\s\\xa0]*ng[\\s\\xa0]*mga[\\s\\xa0]*Apostol)?)|T(?:ravay|eot)|Πρ[αά]ξεις|Д(?:е(?:яния|ла)|і(?:яння|[їі]))|宗徒(?:大事錄》?|行實》?)|S(?:kutky|ứ[\\s\\xa0]*đồ)|அப்போஸ்தலர்|《(?:使徒行[傳传]|宗徒(?:大事錄|行實)|徒)|Veprat(?:[\\s\\xa0]*e[\\s\\xa0]*apostujve)?|H(?:andelingen|echos(?:[\\s\\xa0]*de[\\s\\xa0]*los[\\s\\xa0]*Ap[óo]stoles)?)|Fapte(?:le)?|Para[\\s\\xa0]*Rasul|Binuhatan|使徒行[传傳]》?|กิจการ|Công(?:[\\s\\xa0]*Vụ)?))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Rev"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Opinberunarb(?:[oó]kin)|(?:Muuj(?:intii)?|О(?:б(?:['’]явлення[\\s\\xa0]*(?:св(?:\\.[\\s\\xa0]*(?:Івана[\\s\\xa0]*Богослова|[ИЙ]оана[\\s\\xa0]*Богослова)|[\\s\\xa0]*(?:Івана[\\s\\xa0]*Богослова|[ИЙ]оана[\\s\\xa0]*Богослова))|Івана[\\s\\xa0]*Богослова))|дкр(?:овення[\\s\\xa0]*Івана[\\s\\xa0]*Богослова|иттє)|тк(?:р(?:ивење[\\s\\xa0]*Јованово|ове(?:ние(?:то[\\s\\xa0]*на[\\s\\xa0]*[ИЙ]оан|[\\s\\xa0]*на[\\s\\xa0]*(?:св(?:\\.[\\s\\xa0]*Иоана[\\s\\xa0]*Богослова|[\\s\\xa0]*Иоана[\\s\\xa0]*Богослова)|[ИЙ]оан))|ње[\\s\\xa0]*Јованово))?)?)|Gipadayag|Dat(?:gudd(?:iad)?)?|᾿Απ|தி(?:ருவெளிப்பாடு|வெ)|Апок(?:[aá]ліпсис|а(?:́ліпсис|л[iíиі]псис))|ی(?:و[\\s\\xa0]*حنا[\\s\\xa0]*عارف[\\s\\xa0]*کا[\\s\\xa0]*مکاشفہ|ُو(?:[\\s\\xa0]*حنّا[\\s\\xa0]*عارِف[\\s\\xa0]*کا[\\s\\xa0]*مُکاشفہ|حنا[\\s\\xa0]*عارف[\\s\\xa0]*کا[\\s\\xa0]*مکاشفہ))|Å(?:b(?:enbaring(?:sbogen|en))?|p(?:enbaring(?:sboken|en))?)|ਯੂਹੰਨਾ[\\s\\xa0]*ਦੇ[\\s\\xa0]*ਪਰਕਾਸ਼[\\s\\xa0]*ਦੀ[\\s\\xa0]*ਪੋਥੀ|ଯୋହନଙ୍କ[\\s\\xa0]*ପ୍ରତି[\\s\\xa0]*ପ୍ରକାଶିତ[\\s\\xa0]*ବାକ୍ୟ|Απ(?:οκ(?:άλυψ(?:ις[\\s\\xa0]*Ιω[άα]ννου|η)|αλ(?:ύψεις|υψ(?:ις[\\s\\xa0]*Ιω[άα]ννου|εις|η)))?)?|y(?:oh[aā]n(?:[aā]l(?:[aā][\\s\\xa0]*ǳʰ(?:[aā]lele[\\s\\xa0]*praka(?:[tṭ](?:[iī]kara[nṇ])))))|uhann[aā]l(?:[aā](?:[iī][\\s\\xa0]*bʰaeko[\\s\\xa0]*prak(?:[aā][sš])))|ū(?:ḥannā[\\s\\xa0]*ʿārif[\\s\\xa0]*kā[\\s\\xa0]*mukāšafâ|h(?:ãnā[\\s\\xa0]*de[\\s\\xa0]*prakāš[\\s\\xa0]*dī[\\s\\xa0]*potʰī|ann[aā]l(?:[aā](?:[iī][\\s\\xa0]*bʰaeko[\\s\\xa0]*prak(?:[aā][sš]))))))|חזון[\\s\\xa0]*יוחנן|ヨハネの[默黙]示録|J(?:[aá]nos[\\s\\xa0]*jelen(?:[eé]sei)|oh(?:anne(?:ksen[\\s\\xa0]*ilmestys|s(?:['’][\\s\\xa0]*(?:(?:[AÅ]benbaring|[aå]penbaring))|apokalypsen|[\\s\\xa0]*(?:Uppenbarelse|apokalyps)))|s(?:\\.[\\s\\xa0]*[AÅ]benbaring|[\\s\\xa0]*[AÅ]benbaring))|el(?:en[eé]sek)?)|رؤ(?:يا[\\s\\xa0]*يوحنا)?|யோவானுக்கு[\\s\\xa0]*வெளிப்படுத்தின[\\s\\xa0]*விசேஷம்|黙示録|ה(?:התגלות|תגלות)|Відкриття[\\s\\xa0]*Івана|K(?:niha[\\s\\xa0]*Zjeven[ií]|s(?:i(?:[eę]g(?:[ai][\\s\\xa0]*(?:Apokalipsy|Objawienia)))|\\.[\\s\\xa0]*(?:Apokalipsy|Objawienia)|[\\s\\xa0]*(?:Apokalipsy|Objawienia))|itab[\\s\\xa0]*Wahyu|hải[\\s\\xa0]*(?:Huyền[\\s\\xa0]*của[\\s\\xa0]*John|thị))|《(?:若望默示錄》|[啓默]示錄》|启(?:示录》|》)|啟(?:示錄》|》))|الرؤيــا|묵시|R(?:e(?:belasyon|v(?:[ao]lations?|lations?|el(?:a(?:syon|tions?))?)?)|iv(?:elazione)?|v)|U(?:pp(?:enbarelseboken)?|f(?:u(?:nu(?:a[\\s\\xa0]*wa[\\s\\xa0]*Yohana|o[\\s\\xa0]*wa[\\s\\xa0]*Yohan[ae]))?)?)|El[\\s\\xa0]*Apocalipsis|P(?:rakashaitavakya|a(?:medaran|h(?:ayag[\\s\\xa0]*kay[\\s\\xa0]*Juan)?))|O(?:ff(?:enbarung|b)|b(?:['’]javlennja[\\s\\xa0]*Ivana[\\s\\xa0]*Bohoslova|j(?:awienie[\\s\\xa0]*(?:(?:[sś]w(?:\\.[\\s\\xa0]*Jana|[\\s\\xa0]*Jana))|Jana))?)|tk(?:rivenje[\\s\\xa0]*Ivanovo)?|p(?:inberun(?:arb[oó]k[\\s\\xa0]*J(?:[oó]hannesar)|[\\s\\xa0]*J[oó]hannesar)|enb(?:aring(?:[\\s\\xa0]*van[\\s\\xa0]*Johannes|en))?|b)?)|வெளி(?:ப்படுத்தின[\\s\\xa0]*விசேடங்கள்)?|य(?:ोहानाला[\\s\\xa0]*झालेले[\\s\\xa0]*प्रकटीकरण|ूहन्नालाई[\\s\\xa0]*भएको[\\s\\xa0]*प्रकाश)|요한(?:[\\s\\xa0]*[계묵]시록|[계묵]시록)|ﻳﻮﺣﻨﺎ[\\s\\xa0]*ﺭﺅﻳﺎ|ว(?:ิวรณ์|ว)|Ve[lḷ]ippa(?:[tṭ]utti(?:[nṉ]a[\\s\\xa0]*Vic(?:[eē](?:[tṭ]a(?:[nṅ]ka[lḷ])))))|Ilm(?:estyskirja)?|प्र(?:काशित(?:-?वाक्‍य|[\\s\\xa0]*वाक्य|वाक्य)|\\.[\\s\\xa0]*व|[\\s\\xa0]*व)|Z(?:b(?:u(?:lesa)?)?|j(?:even(?:i[\\s\\xa0]*(?:svat[eé]ho[\\s\\xa0]*Jana|Janovo)|í[\\s\\xa0]*Janovo)|av(?:enie[\\s\\xa0]*(?:Apo[sš]tola[\\s\\xa0]*J(?:[aá]na)|sv[aä]t(?:[eé]ho[\\s\\xa0]*J(?:[aá]na))|J[aá]na))?|v)?)|A(?:abenbaringen|benbaring(?:sbogen|en)|p(?:enbaring(?:sboken|en)|[ck]|o(?:kal(?:yps(?:en|a)|ips(?:is[\\s\\xa0]*ni[\\s\\xa0]*Juan|a[\\s\\xa0]*(?:[SŚ]wi(?:[eę]tego[\\s\\xa0]*Jana)|(?:[sś]w(?:\\.[\\s\\xa0]*Jana|[\\s\\xa0]*Jana)))|zis)?)|c(?:al(?:i(?:sse[\\s\\xa0]*di[\\s\\xa0]*Giovanni|ps(?:a[\\s\\xa0]*lui[\\s\\xa0]*Ioan|is[\\s\\xa0]*ni[\\s\\xa0]*Juan|e[\\s\\xa0]*de[\\s\\xa0]*(?:S[aã]o[\\s\\xa0]*Jo(?:[aã]o)|Jo[aã]o)))|yps(?:is[\\s\\xa0]*Ioannis[\\s\\xa0]*Apostoli|e[\\s\\xa0]*de[\\s\\xa0]*Jean)?))?)?)?))|(?:O(?:tkrivenje|penbaring|bjawienie)|ਪਰਕਾਸ਼[\\s\\xa0]*ਦੀ[\\s\\xa0]*ਪੋਥੀ|启(?:示录》?|》)?|Wahyu|《(?:若望默示錄|[默啓]示錄|启(?:示录)?|啟(?:示錄)?)|Ufunuo|Zj(?:avenie|even[íi])|[默啓]示錄》?|Pahayag|啟(?:示錄》?|》)?|praka[ṭt](?:[iī]kara[nṇ])|Ap(?:enbaring|o(?:kalips(?:is|a)|cal(?:i(?:sse|ps(?:is|[ea]))|yps(?:is(?:[\\s\\xa0]*Ioannis)?|e))))|م(?:ُکاشفہ|کاشفہ)|若望默示錄》?|Ve[ḷl]ippa(?:[ṭt]utti(?:[nṉ]a))|Ilmestys|Khải(?:[\\s\\xa0]*Huyền)?|प्रक(?:टीकरण|ाश)|yūhãnā[\\s\\xa0]*de[\\s\\xa0]*prakāš|О(?:ткр(?:овение|ивење)|б(?:[’']явлення)?)))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["PrAzar"],
        apocrypha: true,
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:صلاة[\\s\\xa0]*عزريا|G(?:weddi[\\s\\xa0]*Asarias|eb(?:e(?:d[\\s\\xa0]*van[\\s\\xa0]*Azarja|t[\\s\\xa0]*des[\\s\\xa0]*Asarja)|[\\s\\xa0]*As))|A(?:ng[\\s\\xa0]*Panalangin[\\s\\xa0]*ni[\\s\\xa0]*Azarias|z(?:ári[aá]s[\\s\\xa0]*im(?:[aá](?:ds(?:[aá]ga|ja)))|ar(?:i[aá]s[\\s\\xa0]*im(?:[aá](?:ds(?:[aá]ga|ja)))|j(?:á[sš]ova[\\s\\xa0]*modlitba|a(?:šova[\\s\\xa0]*modlitba|s(?:ova[\\s\\xa0]*modlitba|[\\s\\xa0]*Bøn)))))|sar(?:ias(?:’[\\s\\xa0]*b[oö]n|[\\s\\xa0]*b[oö]n)|ja(?:n[\\s\\xa0]*rukous|s(?:’[\\s\\xa0]*b[oö]n|[\\s\\xa0]*b(?:ønn|[oö]n)))|[\\s\\xa0]*ru))|Sal(?:mo[\\s\\xa0]*de[\\s\\xa0]*Azarias|[\\s\\xa0]*Azar)|C[aá]ntico[\\s\\xa0]*de[\\s\\xa0]*Azar(?:[ií]as)|La[\\s\\xa0]*Pri[eè]re[\\s\\xa0]*d(?:['’]Azaria[hs])|அசரியா|תפילת[\\s\\xa0]*עזריה[\\s\\xa0]*בתוך[\\s\\xa0]*הכבשן|Rug[aă]ciunea[\\s\\xa0]*lui[\\s\\xa0]*Azaria|《PrAzar》|The[\\s\\xa0]*Pr(?:ayer(?:s[\\s\\xa0]*of[\\s\\xa0]*Azariah?|[\\s\\xa0]*of[\\s\\xa0]*Azariah?)|[\\s\\xa0]*of[\\s\\xa0]*Azariah?)|Молитва[\\s\\xa0]*Азар(?:ия|і[ії])|P(?:ie[sś](?:[nń][\\s\\xa0]*Azariasza)|r(?:eghiera[\\s\\xa0]*di[\\s\\xa0]*Azaria|\\.[\\s\\xa0]*Azar|[\\s\\xa0]*Azar|Azr))|Or(?:a(?:ci[oó]n[\\s\\xa0]*de[\\s\\xa0]*Azar(?:[ií]as)|tio[\\s\\xa0]*Azariae)|\\.[\\s\\xa0]*Azar|[\\s\\xa0]*Az(?:ar)?)|Πρ(?:οσευχ[ήη][\\s\\xa0]*Αζαρ(?:[ίι]ου)|[\\s\\xa0]*Αζαρ)|Bæn[\\s\\xa0]*Asarja|ア[サザ]ルヤの祈り|Modlitw[aą][\\s\\xa0]*Azariasza)|Az[aá]ri(?:[aá]s[\\s\\xa0]*im(?:[aá]ja))|(?:תפילת[\\s\\xa0]*עזריה|《PrAzar|Azar(?:jas[\\s\\xa0]*bøn|ías|ia[sh]?)|P(?:analangin[\\s\\xa0]*ni[\\s\\xa0]*Azarias|r(?:ayer(?:s[\\s\\xa0]*of[\\s\\xa0]*Azariah?|[\\s\\xa0]*of[\\s\\xa0]*Azariah?)|i[èe]re[\\s\\xa0]*d(?:['’]Azaria[sh])|[\\s\\xa0]*of[\\s\\xa0]*Azariah?|Azar》?))))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["SgThree"],
        apocrypha: true,
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])((?:Kolmen[\s\xa0]*(?:nuoren[\s\xa0]*miehen[\s\xa0]*ollessa[\s\xa0]*tulisessa[\s\xa0]*p[aä]tsiss[aä]|miehen[\s\xa0]*kiitosvirsi[\s\xa0]*tulessa)|《SgThree》|Gezang[\s\xa0]*der[\s\xa0]*drie[\s\xa0]*mannen[\s\xa0]*in[\s\xa0]*het[\s\xa0]*vuur|H(?:[aá]rom[\s\xa0]*fiatalember[\s\xa0]*(?:[eé]neke)|ymnus[\s\xa0]*trium[\s\xa0]*puerorum)|De(?:r[\s\xa0]*Gesang[\s\xa0]*der[\s\xa0]*Drei[\s\xa0]*M[aä]nner[\s\xa0]*im[\s\xa0]*feurigen[\s\xa0]*Ofen|[\s\xa0]*(?:Tre[\s\xa0]*Mænds[\s\xa0]*Lovsang|tre[\s\xa0]*m(?:[aä]nnens[\s\xa0]*lovs(?:[aå]ng)|enn(?:enes[\s\xa0]*sang[\s\xa0]*føyer|s[\s\xa0]*sang))))|இளைஞர்[\s\xa0]*மூவரின்[\s\xa0]*பாடல்|[ΥΎ]μνος[\s\xa0]*των[\s\xa0]*Τρι(?:[ωώ]ν[\s\xa0]*Πα(?:[ίι]δων))|أنشودة[\s\xa0]*الأطفال[\s\xa0]*الثلاثة|T(?:r(?:aja[\s\xa0]*ml[aá]denci[\s\xa0]*v[\s\xa0]*rozp(?:[aá]lenej[\s\xa0]*peci)|i[\s\xa0]*mu[zž]i[\s\xa0]*v[\s\xa0]*rozp(?:[aá]len(?:[eé][\s\xa0]*peci)))|ři[\s\xa0]*mu[zž]i[\s\xa0]*v[\s\xa0]*rozp(?:[aá]len(?:[eé][\s\xa0]*peci))|he[\s\xa0]*Song[\s\xa0]*of[\s\xa0]*(?:Three[\s\xa0]*(?:Holy[\s\xa0]*Children|You(?:ng[\s\xa0]*Men|ths)|Jews)|the[\s\xa0]*(?:Three[\s\xa0]*(?:Holy[\s\xa0]*Children|You(?:ng[\s\xa0]*Men|ths)|Jews)|3[\s\xa0]*(?:Holy[\s\xa0]*Children|You(?:ng[\s\xa0]*Men|ths)|Jews))|3[\s\xa0]*(?:Holy[\s\xa0]*Children|You(?:ng[\s\xa0]*Men|ths)|Jews)))|三(?:人の若者の賛歌|童兒の歌)|S(?:ong[\s\xa0]*Three|ng[\s\xa0]*Three|\.[\s\xa0]*(?:of[\s\xa0]*(?:Th(?:ree(?:\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y))|\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y))|3(?:\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y)))|Th(?:ree(?:\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y))|\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y))|3(?:\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y)))|g[\s\xa0]*Thr(?:ee)?|[\s\xa0]*(?:of[\s\xa0]*(?:Th(?:ree(?:\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y))|\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y))|3(?:\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y)))|Th(?:ree(?:\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y))|\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y))|3(?:\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y))))|P(?:íse[nň][\s\xa0]*ml(?:[aá]denc(?:[uů][\s\xa0]*v[\s\xa0]*ho(?:[rř](?:[ií]c(?:[ií][\s\xa0]*peci)))))|i(?:se[nň][\s\xa0]*ml(?:[aá]denc(?:[uů][\s\xa0]*v[\s\xa0]*ho(?:[rř](?:[ií]c(?:[ií][\s\xa0]*peci)))))|e(?:s(?:e[nň][\s\xa0]*ml(?:[aá]dencov[\s\xa0]*v[\s\xa0]*ohnivej[\s\xa0]*peci)|n(?:i[aą][\s\xa0]*trzech[\s\xa0]*młodzie(?:[nń]c(?:[oó]w))|[\s\xa0]*trzech[\s\xa0]*młodzie[nń]c(?:[oó]w))|ń[\s\xa0]*trzech[\s\xa0]*młodzie[nń]c(?:[oó]w))|ś(?:n(?:i[aą][\s\xa0]*trzech[\s\xa0]*młodzie(?:[nń]c(?:[oó]w))|[\s\xa0]*trzech[\s\xa0]*młodzie[nń]c(?:[oó]w))|ń[\s\xa0]*trzech[\s\xa0]*młodzie[nń]c(?:[oó]w)))))|3[\s\xa0]*tineri|Aw(?:it[\s\xa0]*ng[\s\xa0]*(?:Tatlong[\s\xa0]*(?:Kabataan(?:g[\s\xa0]*Banal)?|B(?:anal[\s\xa0]*na[\s\xa0]*Kabataan|inata))|3[\s\xa0]*Kabataan)|[\s\xa0]*ng[\s\xa0]*3[\s\xa0]*Kab)|Благодарственная[\s\xa0]*песнь[\s\xa0]*отроков|C(?:an(?:t(?:area[\s\xa0]*celor[\s\xa0]*trei[\s\xa0]*(?:tineri|evrei)|i(?:que[\s\xa0]*des[\s\xa0]*(?:Trois[\s\xa0]*Enfants|3[\s\xa0]*Enfants)|co[\s\xa0]*d(?:ei[\s\xa0]*tre[\s\xa0]*(?:giovani[\s\xa0]*nella[\s\xa0]*fornace|fanciulli)|os[\s\xa0]*(?:Tr[eê]s[\s\xa0]*Jovens|3[\s\xa0]*Jovens))))|[\s\xa0]*y[\s\xa0]*Tri[\s\xa0]*L(?:lanc|anc))|ân(?:t(?:area[\s\xa0]*celor[\s\xa0]*trei[\s\xa0]*(?:tineri|evrei)|ico[\s\xa0]*dos[\s\xa0]*(?:Tr[eê]s[\s\xa0]*Jovens|3[\s\xa0]*Jovens))|[\s\xa0]*y[\s\xa0]*Tri[\s\xa0]*L(?:lanc|anc))|t[\s\xa0]*3[\s\xa0]*(?:J[oó]|E)|3J)|Молитва[\s\xa0]*святых[\s\xa0]*трех[\s\xa0]*отроков|Wimbo[\s\xa0]*wa[\s\xa0]*Vijana[\s\xa0]*Watatu|П(?:існя[\s\xa0]*трьох[\s\xa0]*отроків|еснь[\s\xa0]*тр[её]х[\s\xa0]*отроков)|שירת[\s\xa0]*שלושת[\s\xa0]*הנערים[\s\xa0]*בכבשן|El[\s\xa0]*(?:Canto[\s\xa0]*de[\s\xa0]*los[\s\xa0]*(?:Tres[\s\xa0]*J(?:[oó]venes[\s\xa0]*(?:Hebreos|Jud[ií]os))|3[\s\xa0]*J(?:[oó]venes[\s\xa0]*(?:Hebreos|Jud[ií]os)))|Himno[\s\xa0]*de[\s\xa0]*los[\s\xa0]*(?:Tres[\s\xa0]*J(?:[oó]venes[\s\xa0]*(?:Hebreos|Jud[ií]os))|3[\s\xa0]*J(?:[oó]venes[\s\xa0]*(?:Hebreos|Jud[ií]os))))|L(?:o(?:bgesang[\s\xa0]*der[\s\xa0]*(?:drei[\s\xa0]*jungen[\s\xa0]*M[aä]nner[\s\xa0]*im[\s\xa0]*Feuerofen|3[\s\xa0]*jungen[\s\xa0]*M[aä]nner)|fs[oö]ngur[\s\xa0]*ungmennanna[\s\xa0]*þriggja)|ied[\s\xa0]*van[\s\xa0]*de[\s\xa0]*drie[\s\xa0]*jongemannen|3J))|(?:3[\s\xa0]*J[óo]venes|Lobgesang[\s\xa0]*der[\s\xa0]*drei[\s\xa0]*jungen[\s\xa0]*M[äa]nner|Himno[\s\xa0]*de[\s\xa0]*los[\s\xa0]*(?:Tres[\s\xa0]*J[óo]venes(?:[\s\xa0]*Jud(?:[ií]os)?)|3[\s\xa0]*J(?:[óo]venes(?:[\s\xa0]*(?:Hebreos|Jud[íi]os))?))|De(?:[\s\xa0]*tre[\s\xa0]*mænds[\s\xa0]*lovsang|r[\s\xa0]*Gesang[\s\xa0]*der[\s\xa0]*Drei)|Kolmen[\s\xa0]*(?:nuoren[\s\xa0]*miehen|miehen(?:[\s\xa0]*kiitosvirsi)?)|S(?:ong[\s\xa0]*of[\s\xa0]*(?:the[\s\xa0]*(?:Three[\s\xa0]*(?:Holy[\s\xa0]*Children|You(?:ng[\s\xa0]*Men|ths)|Jews)|3[\s\xa0]*(?:Holy[\s\xa0]*Children|You(?:ng[\s\xa0]*Men|ths)|Jews))|Three[\s\xa0]*(?:Holy[\s\xa0]*Children|You(?:ng[\s\xa0]*Men|ths)|Jews)|3[\s\xa0]*(?:Holy[\s\xa0]*Children|You(?:ng[\s\xa0]*Men|ths)|Jews))|gThree》?)|《SgThree|Canto[\s\xa0]*de[\s\xa0]*los[\s\xa0]*(?:Tres[\s\xa0]*J(?:[oó]venes(?:[\s\xa0]*(?:Hebreos|Jud[íi]os))?)|3[\s\xa0]*J(?:[oó]venes(?:[\s\xa0]*(?:Hebreos|Jud[íi]os))?))|Gesang[\s\xa0]*der[\s\xa0]*Drei|T(?:atlong[\s\xa0]*Kabataan|re(?:s[\s\xa0]*J[oó]venes|i[\s\xa0]*tineri)))|Himno[\s\xa0]*de[\s\xa0]*los[\s\xa0]*Tres[\s\xa0]*J(?:[óo]venes))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["2Pet"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(2[\s\xa0]*p(?:etr[aā]ce[mṃ]|atr(?:usko|as))|(?:p(?:a(?:ṭras[\s\xa0]*kā[\s\xa0]*dūsrā[\s\xa0]*ʿām[\s\xa0]*ḫaṭ|tr(?:as[\s\xa0]*dī[\s\xa0]*dūjī[\s\xa0]*pattrī|usko[\s\xa0]*dostro[\s\xa0]*patra))|etr[aā]ce(?:[mṃ][\s\xa0]*dusre[\s\xa0]*patra))|Epistula[\s\xa0]*(?:II[\s\xa0]*Petri|Petri[\s\xa0]*II)|प(?:त्रुसको[\s\xa0]*दोस्(?:त्रो[\s\xa0]*पत्र|रो[\s\xa0]*पत्र)|ेत्राचें[\s\xa0]*दुसरे[\s\xa0]*पत्र|ौलाचें[\s\xa0]*दुसरे[\s\xa0]*पत्र)|Zweite[\s\xa0]*Petrus|베드로(?:의[\s\xa0]*둘째[\s\xa0]*서간|[2후]서)|二[ヘペ]トロ|ਪਤਰਸ[\s\xa0]*ਦੀ[\s\xa0]*ਦੂਜੀ[\s\xa0]*ਪੱਤ੍ਰੀ|(?:[ヘペ](?:テロの(?:第二の手紙|後の書)|トロ(?:の(?:第二の手紙|手紙二)|[\s\xa0]*2)))|2(?:nd(?:\.[\s\xa0]*P(?:e(?:r|t(?:er?|r)?)?|tr?)?|[\s\xa0]*P(?:e(?:r|t(?:er?|r)?)?|tr?)?)|\.(?:(?:[oº](?:\.[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro)|[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro)))|[\-?۔]پطرس|[\s\xa0]*(?:п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Петар|ослан(?:и(?:ца[\s\xa0]*Петрова|е[\s\xa0]*(?:на[\s\xa0]*апостол[\s\xa0]*Петар|Петра))|ня[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра)))|But(?:ros)?|San[\s\xa0]*Pedro|پطر(?:[\s\xa0]*س|س)|पत(?:्रुस(?:को)?|रस?)|list[\s\xa0]*Petr[uů]v|เปโตร|patrusko|ପିତରଙ|Пет(?:ира|[аъ]р|р(?:ов[ао]|а)?)?|соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra))|Piotra)|P(?:ataras|jetrit|h(?:i(?:a-?rơ|-?(?:e-?rơ|rơ))|ê(?:-?rơ|rô))|i(?:otra?|e(?:rre|t(?:arin[\s\xa0]*kirje|ro))?|è)|y[eè]|ét(?:rus|er)?|e(?:dro?|r|t(?:e(?:r(?:s(?:brev)?)?)?|r(?:ův|i|o(?:v(?:a[\s\xa0]*Poslanica)?)?|u(?:s(?:brevet)?|v)?)?)?)?|tr?)?))|[\s\xa0]*(?:п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Петар|ослан(?:и(?:ца[\s\xa0]*Петрова|е[\s\xa0]*(?:на[\s\xa0]*апостол[\s\xa0]*Петар|Петра))|ня[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра)))|But(?:ros)?|San[\s\xa0]*Pedro|پطر(?:[\s\xa0]*س|س)|list[\s\xa0]*Petr[uů]v|प(?:ेत्र(?:ाचें)?|त(?:्रुस(?:को)?|रस?))|เปโตร|(?:[ie](?:\.[\s\xa0]*Pjetrit|[\s\xa0]*Pjetrit))|P(?:h(?:i(?:a-?rơ|-?(?:e-?rơ|rơ))|ê(?:-?rơ|rô))|e(?:d(?:ro?)?|r|t(?:uru|e(?:r(?:s(?:brev)?)?)?|r(?:ův|i|o(?:v(?:a[\s\xa0]*Poslanica)?)?|u(?:s(?:brevet)?|v)?)?)?)?|ét(?:rus|er)?|y[eè]|j(?:e(?:trit)?)?|ataras|i(?:otra?|e(?:rre|t(?:arin[\s\xa0]*kirje|ro)?)?|è)?|d|tr?|ēturu)?|k(?:\.[\s\xa0]*Petrov|[\s\xa0]*Petrov)|ਪਤਰਸ|பேது(?:ரு)?|ปต|ପିତରଙ|بط|Пет(?:ира|[аъ]р|р(?:ов[ао]|а)?)?|соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra))|Piotra)|இராயப்பர்)|e(?:me(?:\.[\s\xa0]*Pierre|[\s\xa0]*Pierre)|\.[\s\xa0]*P(?:ierre|et(?:r(?:us)?)?)|[\s\xa0]*P(?:ierre|et(?:r(?:us)?)?))|°(?:\.[\s\xa0]*Pietro|[\s\xa0]*Pietro)|-?(?:ге(?:\.[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|послання[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра)|Петр(?:ово|а))|[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|послання[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра)|Петр(?:ово|а)))|а(?:\.[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|послання[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра)|Петр(?:ово|а))|[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|послання[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра)|Петр(?:ово|а)))|е(?:\.[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|послан(?:ие[\s\xa0]*Петра|ня[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра))|Пет(?:ира|р(?:ово|а)))|[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|послан(?:ие[\s\xa0]*Петра|ня[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра))|Пет(?:ира|р(?:ово|а))))|я(?:\.[\s\xa0]*(?:послание[\s\xa0]*Петра|Пет(?:ира|ра))|[\s\xa0]*(?:послание[\s\xa0]*Петра|Пет(?:ира|ра)))|پطرس)|Pet|ème(?:\.[\s\xa0]*Pierre|[\s\xa0]*Pierre)|베드|a(?:\.[\s\xa0]*Pedro|[\s\xa0]*Pedro)|۔پطرس|d(?:\.[\s\xa0]*Pierre|e(?:\.[\s\xa0]*Pierre|[\s\xa0]*Pierre)|[\s\xa0]*Pierre)|بط|(?:[ея](?:\.[\s\xa0]*(?:послание[\s\xa0]*Петра|Пет(?:ира|ра))|[\s\xa0]*(?:послание[\s\xa0]*Петра|Пет(?:ира|ра))))|(?:[oº](?:\.[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro)|[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro))))|《(?:伯多祿後書》|撇特爾後》|彼(?:得(?:后书》|後書》)|[后後]》))|B(?:arua[\s\xa0]*ya[\s\xa0]*Pili[\s\xa0]*ya[\s\xa0]*Petro|utros[\s\xa0]*Labaad)|I(?:kalawang[\s\xa0]*Pedro|I(?:\.[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Петар|ослан(?:и(?:е[\s\xa0]*на[\s\xa0]*апостол[\s\xa0]*Петар|ца[\s\xa0]*Петрова)|ня[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра)))|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra))|Piotra)|list[\s\xa0]*Petr[uů]v|San[\s\xa0]*Pedro|But(?:ros)?|Пет(?:[аъ]р|р(?:ов[ао]|а)?)?|P(?:h(?:i(?:a-?rơ|-?(?:e-?rơ|rơ))|ê(?:-?rơ|rô))|i(?:otra?|e(?:rre|t(?:arin[\s\xa0]*kirje|ro))?|è)|y[eè]|ét(?:rus|er)?|e(?:dro?|r|t(?:er?|r(?:ův|i|o(?:v(?:a[\s\xa0]*Poslanica)?)?|u[sv]?)?)?)?|tr?)?)|[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Петар|ослан(?:и(?:е[\s\xa0]*на[\s\xa0]*апостол[\s\xa0]*Петар|ца[\s\xa0]*Петрова)|ня[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра)))|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra))|Piotra)|list[\s\xa0]*Petr[uů]v|San[\s\xa0]*Pedro|But(?:ros)?|Пет(?:[аъ]р|р(?:ов[ао]|а)?)?|P(?:h(?:i(?:a-?rơ|-?(?:e-?rơ|rơ))|ê(?:-?rơ|rô))|i(?:otra?|e(?:rre|t(?:arin[\s\xa0]*kirje|ro))?|è)|y[eè]|ét(?:rus|er)?|e(?:dro?|r|t(?:er?|r(?:ův|o(?:v(?:a[\s\xa0]*Poslanica)?)?|u[sv]?)?)?)?|tr?)?)))|Втор(?:о[\s\xa0]*(?:съборно[\s\xa0]*послание[\s\xa0]*на[\s\xa0]*св(?:\.[\s\xa0]*ап(?:\.[\s\xa0]*Петра|[\s\xa0]*Петра)|[\s\xa0]*ап(?:\.[\s\xa0]*Петра|[\s\xa0]*Петра))|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Петар|ослание[\s\xa0]*на[\s\xa0]*(?:апостол[\s\xa0]*Петар|Петър))|Пет(?:рово|ар))|а[\s\xa0]*(?:п(?:ослание[\s\xa0]*на[\s\xa0]*апостол[\s\xa0]*Петар|исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Петар)|Пет(?:[аъ]р|р(?:ово)?)?))|Waraka[\s\xa0]*wa[\s\xa0]*Pili[\s\xa0]*wa[\s\xa0]*Petro|ଦ୍ୱିତୀୟ[\s\xa0]*ପିତରଙ|ପିତରଙ୍କ[\s\xa0]*ଦ୍ୱିତୀୟ[\s\xa0]*ପତ୍ର|א(?:גרתו[\s\xa0]*השנייה[\s\xa0]*של[\s\xa0]*פטרוס[\s\xa0]*השליח|יגרת[\s\xa0]*פטרוס[\s\xa0]*השנייה)|دوم(?:[\s\xa0]*پطر(?:[\s\xa0]*س|س)|[\-?۔]پطرس)|P(?:ēturu[\s\xa0]*E[lḻ]utiya[\s\xa0]*Ira(?:[nṇ](?:[tṭ](?:[aā]vatu[\s\xa0]*Nirupam)))|et(?:uru[\s\xa0]*E[lḻ]utiya[\s\xa0]*Ira(?:[nṇ](?:[tṭ](?:[aā]vatu[\s\xa0]*Nirupam)))|ers[\s\xa0]*(?:Andet[\s\xa0]*Brev|andre[\s\xa0]*brev)|r(?:us[\s\xa0]*andra[\s\xa0]*brev|o[\s\xa0]*II))|ili[\s\xa0]*Pet(?:ro)?)|S(?:[ií]ðara[\s\xa0]*(?:almenna[\s\xa0]*br(?:[eé]f[\s\xa0]*P(?:[eé]turs)|P[eé]tursbr(?:[eé]f)))|e(?:gund(?:a[\s\xa0]*Pedro|o[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro))|cond(?:a[\s\xa0]*(?:lettera[\s\xa0]*di[\s\xa0]*Pietro|Pietro)|o[\s\xa0]*Pietro|[\s\xa0]*P(?:e(?:r|t(?:er?|r)?)?|tr?)?)))|T(?:oinen[\s\xa0]*Pietarin[\s\xa0]*kirje|weede[\s\xa0]*Pet(?:r(?:us)?)?)|And(?:e(?:t[\s\xa0]*Petersbrev|n[\s\xa0]*Pet(?:er(?:sbrev)?)?)|r(?:a[\s\xa0]*Petrusbrevet|e[\s\xa0]*Pet(?:er(?:s(?:brev)?)?)?))|پطرس[\s\xa0]*کا[\s\xa0]*دوسرا[\s\xa0]*عام[\s\xa0]*خط|M(?:[aá]sodik[\s\xa0]*P(?:[eé]t(?:er)?))|Друг(?:а[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|послан(?:ица[\s\xa0]*Петрова|ня[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра))|Петр(?:ов[ао]|а))|е[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|послання[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра)|Петр(?:ово|а)))|رسالة[\s\xa0]*(?:القديس[\s\xa0]*بطرس[\s\xa0]*الثانية|بطرس[\s\xa0]*(?:الثانية|2))|Β(?:['ʹʹ΄’][\s\xa0]*Π(?:[έε](?:τ(?:ρ(?:ου)?)?)?))|۲(?:[\s\xa0]*پطر(?:[\s\xa0]*س|س)|[\-?۔]پطرس)|Π[έε]τρου[\s\xa0]*Β['ʹʹ΄’]|D(?:e(?:uxi(?:[eè]me(?:s[\s\xa0]*Pierre|[\s\xa0]*Pierre))|zy[eè]m[\s\xa0]*P(?:[iy][eè]))|ru(?:g(?:a[\s\xa0]*(?:List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra))|Piotra)|P(?:etrova[\s\xa0]*Poslanica|iotra?))|i[\s\xa0]*(?:List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra))|Piotra)|Piotra?))|h(?:e[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Petra|(?:[aá][\s\xa0]*(?:kniha[\s\xa0]*Petrov|list[\s\xa0]*Petr[uů]v|P(?:etr(?:ova?|[uů]v)?|t)?))|[yý][\s\xa0]*(?:list[\s\xa0]*Petr(?:[ouů]v|P(?:etr(?:ov(?:[\s\xa0]*list|a)|[uů]v)?|t)?)))))|பேதுரு[\s\xa0]*(?:எழுதிய[\s\xa0]*இரண்டா(?:வது[\s\xa0]*நிருபம்|ம்[\s\xa0]*(?:திருமுகம்|கடிதம்))|இரண்டாம்[\s\xa0]*திருமுகம்))|(?:S[ií]ðara[\s\xa0]*P(?:[eé]tursbr(?:[eé]f))|Druh(?:[yý][\s\xa0]*P(?:etr(?:ov(?:[\s\xa0]*list|a)|[uů]v)?|t)?))|(?:II(?:\.[\s\xa0]*P(?:ietarin|etrova|hia)|[\s\xa0]*P(?:ietarin|etr(?:ova|i)|hia))|بطرس[\s\xa0]*الثانية|彼(?:得(?:后书》?|後書》?)|[后後]》?)|Petri[\s\xa0]*II|《(?:伯多祿後書|撇特爾後|彼(?:得(?:後書|后书)|[後后]))|Toinen[\s\xa0]*Pietarin|伯多祿後書》?|Dru(?:ga[\s\xa0]*Petrova(?:[\s\xa0]*poslanica)?|h[yý][\s\xa0]*Petrov)|撇特爾後》?|2(?:\.[\s\xa0]*P(?:ietarin|etrova|hia)|[\s\xa0]*P(?:ietarin|etrova|hia))))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["1Pet"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(1[\s\xa0]*p(?:etr[aā]ce[mṃ]|atr(?:usko|as))|(?:Una(?:ng[\s\xa0]*Pedro|[\s\xa0]*Pedro)|א(?:גרתו[\s\xa0]*הראשונה[\s\xa0]*של[\s\xa0]*פטרוס[\s\xa0]*השלי|יגרת[\s\xa0]*פטרוס[\s\xa0]*הראשונה)|ପ(?:ିତରଙ୍କ[\s\xa0]*ପ୍ରଥମ[\s\xa0]*ପତ୍ର|୍ରଥମ[\s\xa0]*ପିତରଙ)|Kwanza[\s\xa0]*Pet(?:ro)?|ਪਤਰਸ[\s\xa0]*ਦੀ[\s\xa0]*ਪਹਿਲੀ[\s\xa0]*ਪੱਤ੍ਰੀ|p(?:a(?:ṭras[\s\xa0]*kā[\s\xa0]*pahlā[\s\xa0]*ʿām[\s\xa0]*ḫaṭ|tr(?:as[\s\xa0]*dī[\s\xa0]*pahilī[\s\xa0]*pattrī|usko[\s\xa0]*pahilo[\s\xa0]*patra))|etr[aā]ce(?:[mṃ][\s\xa0]*pahile[\s\xa0]*patra))|一[ヘペ]トロ|Waraka[\s\xa0]*wa[\s\xa0]*Kwanza[\s\xa0]*wa[\s\xa0]*Petro|《(?:伯多祿前書》|撇特爾前》|彼(?:得前[书書]》|前》))|П(?:ерш(?:[ае][\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|послання[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра)|Петр(?:ово|а)))|рв(?:а[\s\xa0]*(?:п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Петар|ослани(?:е[\s\xa0]*на[\s\xa0]*апостол[\s\xa0]*Петар|ца[\s\xa0]*Петрова))|Пет(?:ров[ао]|ар))|о[\s\xa0]*(?:п(?:ослание[\s\xa0]*на[\s\xa0]*апостол[\s\xa0]*Петар|исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Петар)|Пет(?:рово|ар)))|ърв(?:о[\s\xa0]*(?:съборно[\s\xa0]*послание[\s\xa0]*на[\s\xa0]*св(?:\.[\s\xa0]*ап(?:\.[\s\xa0]*Петра|[\s\xa0]*Петра)|[\s\xa0]*ап(?:\.[\s\xa0]*Петра|[\s\xa0]*Петра))|послание[\s\xa0]*на[\s\xa0]*Петър)|а[\s\xa0]*Пет(?:ър|р(?:ово)?)?))|رسالة[\s\xa0]*(?:القديس[\s\xa0]*بطرس[\s\xa0]*الأولى|بطرس[\s\xa0]*(?:الأولى|1))|I(?:\.[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Петар|ослан(?:и(?:е[\s\xa0]*на[\s\xa0]*апостол[\s\xa0]*Петар|ца[\s\xa0]*Петрова)|ня[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра)))|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra))|Piotra)|list[\s\xa0]*Petr[uů]v|San[\s\xa0]*Pedro|But(?:ros)?|Пет(?:[аъ]р|р(?:ов[ао]|а)?)?|P(?:h(?:i(?:a-?rơ|-?(?:e-?rơ|rơ))|ê(?:-?rơ|rô))|i(?:otra?|e(?:rre|t(?:arin[\s\xa0]*kirje|ro))?|è)|y[eè]|ét(?:rus|er)?|e(?:dro?|r|t(?:er?|r(?:ův|i|o(?:v(?:a[\s\xa0]*Poslanica)?)?|u[sv]?)?)?)?|tr?)?)|[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Петар|ослан(?:и(?:е[\s\xa0]*на[\s\xa0]*апостол[\s\xa0]*Петар|ца[\s\xa0]*Петрова)|ня[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра)))|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra))|Piotra)|list[\s\xa0]*Petr[uů]v|San[\s\xa0]*Pedro|But(?:ros)?|Пет(?:[аъ]р|р(?:ов[ао]|а)?)?|P(?:h(?:i(?:a-?rơ|-?(?:e-?rơ|rơ))|ê(?:-?rơ|rô))|i(?:otra?|e(?:rre|t(?:arin[\s\xa0]*kirje|ro))?|è)|y[eè]|ét(?:rus|er)?|e(?:dro?|r|t(?:er?|r(?:ův|o(?:v(?:a[\s\xa0]*Poslanica)?)?|u[sv]?)?)?)?|tr?)?))|பேதுரு[\s\xa0]*(?:எழுதிய[\s\xa0]*முதல(?:்[\s\xa0]*திருமுகம்|ா(?:வது[\s\xa0]*நிருபம்|ம்[\s\xa0]*கடிதம்))|முதல்[\s\xa0]*திருமுகம்)|اوّل(?:[\s\xa0]*پطر(?:[\s\xa0]*س|س)|[\-?۔]پطرس)|1(?:e(?:r(?:\.[\s\xa0]*Pierre|e(?:\.[\s\xa0]*Pierre|[\s\xa0]*Pierre)|[\s\xa0]*Pierre)|\.[\s\xa0]*Pet(?:r(?:us)?)?|[\s\xa0]*Pet(?:r(?:us)?)?)|ère(?:\.[\s\xa0]*Pierre|[\s\xa0]*Pierre)|re(?:\.[\s\xa0]*Pierre|[\s\xa0]*Pierre)|\.(?:(?:[oº](?:\.[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro)|[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro)))|[\-?۔]پطرس|[\s\xa0]*(?:п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Петар|ослан(?:и(?:ца[\s\xa0]*Петрова|е[\s\xa0]*(?:на[\s\xa0]*апостол[\s\xa0]*Петар|Петра))|ня[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра)))|But(?:ros)?|San[\s\xa0]*Pedro|پطر(?:[\s\xa0]*س|س)|पत(?:्रुस(?:को)?|रस?)|list[\s\xa0]*Petr[uů]v|เปโตร|patrusko|ପିତରଙ|Пет(?:ира|[аъ]р|р(?:ов[ао]|а)?)?|соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra))|Piotra)|P(?:ataras|jetrit|h(?:i(?:a-?rơ|-?(?:e-?rơ|rơ))|ê(?:-?rơ|rô))|i(?:otra?|e(?:rre|t(?:arin[\s\xa0]*kirje|ro))?|è)|y[eè]|ét(?:rus|er)?|e(?:dro?|r|t(?:e(?:r(?:s(?:brev)?)?)?|r(?:ův|i|o(?:v(?:a[\s\xa0]*Poslanica)?)?|u(?:s(?:brevet)?|v)?)?)?)?|tr?)?))|[\s\xa0]*(?:п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Петар|ослан(?:и(?:ца[\s\xa0]*Петрова|е[\s\xa0]*(?:на[\s\xa0]*апостол[\s\xa0]*Петар|Петра))|ня[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра)))|But(?:ros)?|San[\s\xa0]*Pedro|پطر(?:[\s\xa0]*س|س)|list[\s\xa0]*Petr[uů]v|प(?:ेत्र(?:ाचें)?|त(?:्रुस(?:को)?|रस?))|เปโตร|(?:[ie](?:\.[\s\xa0]*Pjetrit|[\s\xa0]*Pjetrit))|P(?:h(?:i(?:a-?rơ|-?(?:e-?rơ|rơ))|ê(?:-?rơ|rô))|e(?:d(?:ro?)?|r|t(?:uru|e(?:r(?:s(?:brev)?)?)?|r(?:ův|i|o(?:v(?:a[\s\xa0]*Poslanica)?)?|u(?:s(?:brevet)?|v)?)?)?)?|ét(?:rus|er)?|y[eè]|j(?:e(?:trit)?)?|ataras|i(?:otra?|e(?:rre|t(?:arin[\s\xa0]*kirje|ro)?)?|è)?|d|tr?|ēturu)?|k(?:\.[\s\xa0]*Petrov|[\s\xa0]*Petrov)|ਪਤਰਸ|பேது(?:ரு)?|ปต|ପିତରଙ|بط|Пет(?:ира|[аъ]р|р(?:ов[ао]|а)?)?|соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra))|Piotra)|இராயப்பர்)|°(?:\.[\s\xa0]*Pietro|[\s\xa0]*Pietro)|Pet|-?(?:ше(?:\.[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|послання[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра)|Петр(?:ово|а))|[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|послання[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра)|Петр(?:ово|а)))|а(?:\.[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|послання[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра)|Петр(?:ово|а))|[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|послання[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра)|Петр(?:ово|а)))|е(?:\.[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|послан(?:ие[\s\xa0]*Петра|ня[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра))|Пет(?:ира|р(?:ово|а)))|[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Петра|[\s\xa0]*апостола[\s\xa0]*Петра)|апостола[\s\xa0]*Петра|Петра)|послан(?:ие[\s\xa0]*Петра|ня[\s\xa0]*(?:апостола[\s\xa0]*Петра|Петра))|Пет(?:ира|р(?:ово|а))))|я(?:\.[\s\xa0]*(?:послание[\s\xa0]*Петра|Пет(?:ира|ра))|[\s\xa0]*(?:послание[\s\xa0]*Петра|Пет(?:ира|ра)))|پطرس)|베드|st(?:\.[\s\xa0]*P(?:e(?:r|t(?:er?|r)?)?|tr?)?|[\s\xa0]*P(?:e(?:r|t(?:er?|r)?)?|tr?)?)|a(?:\.[\s\xa0]*Pedro|[\s\xa0]*Pedro)|۔پطرس|بط|(?:[ея](?:\.[\s\xa0]*(?:послание[\s\xa0]*Петра|Пет(?:ира|ра))|[\s\xa0]*(?:послание[\s\xa0]*Петра|Пет(?:ира|ра))))|(?:[oº](?:\.[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro)|[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro))))|(?:[ヘペ](?:テロの(?:第一の手紙|前の書)|トロ(?:の(?:第一の手紙|手紙一)|[\s\xa0]*1)))|پطر(?:[\s\xa0]*س[\s\xa0]*کاپہلا[\s\xa0]*عا[\s\xa0]*م[\s\xa0]*خط|س[\s\xa0]*کا[\s\xa0]*پہلا[\s\xa0]*عام[\s\xa0]*خط)|F(?:[oö]rsta[\s\xa0]*Petrusbrevet|yrra[\s\xa0]*(?:almenna[\s\xa0]*br[eé]f[\s\xa0]*P(?:[eé]turs)|P[eé]tursbr(?:[eé]f))|ørste[\s\xa0]*Pet(?:er(?:s(?:brev)?)?)?|irst[\s\xa0]*P(?:e(?:r|t(?:er?|r)?)?|tr?)?)|B(?:arua[\s\xa0]*ya[\s\xa0]*Kwanza[\s\xa0]*ya[\s\xa0]*Petro|utros[\s\xa0]*Kowaad)|E(?:nsimm[aä]inen[\s\xa0]*Pietarin[\s\xa0]*kirje|pistula[\s\xa0]*(?:I[\s\xa0]*Petri|Petri[\s\xa0]*I)|rste[\s\xa0]*Petrus|erste[\s\xa0]*Pet(?:r(?:us)?)?|ls(?:[oő][\s\xa0]*P(?:[eé]t(?:er)?)))|Π[έε]τρου[\s\xa0]*Α['ʹʹ΄’]|Α(?:['ʹʹ΄’][\s\xa0]*Π(?:[έε](?:τ(?:ρ(?:ου)?)?)?))|P(?:ēturu[\s\xa0]*E[lḻ]utiya[\s\xa0]*Mutal(?:[aā]vatu[\s\xa0]*Nirupam)|ierwsz(?:[aey][\s\xa0]*(?:List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra))|Piotra)|Piotra?))|e(?:r[sš]e[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Petra|t(?:uru[\s\xa0]*E[lḻ]utiya[\s\xa0]*Mutal(?:[aā]vatu[\s\xa0]*Nirupam)|ers[\s\xa0]*(?:Første[\s\xa0]*Brev|1(?:\.[\s\xa0]*Brev|[\s\xa0]*Brev))|r(?:us[\s\xa0]*f[oö]rsta[\s\xa0]*brev|o[\s\xa0]*I)))|r(?:im(?:a[\s\xa0]*(?:lettera[\s\xa0]*di[\s\xa0]*Pietro|Pietro)|e(?:ir[ao][\s\xa0]*Pedro|r(?:o[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro)|[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro)))|o[\s\xa0]*Pietro)|em(?:i(?:ère(?:s[\s\xa0]*Pierre|[\s\xa0]*Pierre)|er(?:e(?:s[\s\xa0]*Pierre|[\s\xa0]*Pierre)|s[\s\xa0]*Pierre|[\s\xa0]*Pierre))|ye[\s\xa0]*P[iy][eè])|v(?:(?:[yý][\s\xa0]*(?:Petrov[\s\xa0]*list|list[\s\xa0]*Petrov))|a[\s\xa0]*(?:kniha[\s\xa0]*Petrov|Petrov(?:a[\s\xa0]*Poslanica)?)|á[\s\xa0]*(?:kniha[\s\xa0]*Petrov|Petrov)|n[ií][\s\xa0]*(?:list[\s\xa0]*Petr(?:[uů]v|P(?:etr(?:ova|[uů]v)?|t)?)))))|۱(?:[\s\xa0]*پطر(?:[\s\xa0]*س|س)|[\-?۔]پطرس)|베드로(?:의[\s\xa0]*첫째[\s\xa0]*서간|[1전]서)|प(?:त्रुसको[\s\xa0]*पहिलो[\s\xa0]*पत्र|ेत्राचे(?:ं[\s\xa0]*पहिले[\s\xa0]*पत्र|[\s\xa0]*पहिले[\s\xa0]*पत्र)))|Prvn(?:[ií][\s\xa0]*P(?:etr(?:ova|[uů]v)?|t)?)|(?:彼(?:得前[书書]》?|前》?)|伯多祿前書》?|Ensimm[aä]inen[\s\xa0]*Pietarin|1(?:\.[\s\xa0]*P(?:ietarin|etrova|hia)|[\s\xa0]*P(?:ietarin|etrova|hia))|P(?:rv(?:a[\s\xa0]*Petrova(?:[\s\xa0]*poslanica)?|[yý][\s\xa0]*Petrov)|et(?:ri[\s\xa0]*I|er(?:s[\s\xa0]*første[\s\xa0]*brev)?))|بطرس[\s\xa0]*الأولى|撇特爾前》?|《(?:伯多祿前書|撇特爾前|彼(?:得前[书書]|前))|I(?:\.[\s\xa0]*P(?:ietarin|etrova|hia)|[\s\xa0]*P(?:ietarin|etr(?:ova|i)|hia))))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["Rom"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(r(?:ōmiyōṅ[\\s\\xa0]*ke[\\s\\xa0]*nām[\\s\\xa0]*kā[\\s\\xa0]*ḫaṭ|om(?:ihar[uū]l(?:[aā](?:[iī][\\s\\xa0]*patra))|ī(?:har[uū]l(?:[aā](?:[iī][\\s\\xa0]*patra))|āṃ[\\s\\xa0]*nū̃[\\s\\xa0]*pattrī)|kar[aā](?:[mṃ]s[\\s\\xa0]*patra)))|(?:Προς[\\s\\xa0]*Ρωμα[ίι]ους|P(?:oslannja[\\s\\xa0]*apostola[\\s\\xa0]*Pavla[\\s\\xa0]*do[\\s\\xa0]*rymljan|a(?:vlova[\\s\\xa0]*poslanica[\\s\\xa0]*Rimljanima|ulus['’][\\s\\xa0]*Brev[\\s\\xa0]*til[\\s\\xa0]*Romerne))|ਰੋਮੀਆਂ[\\s\\xa0]*ਨੂੰ[\\s\\xa0]*ਪੱਤ੍ਰੀ|รม|Waraka[\\s\\xa0]*kwa[\\s\\xa0]*War(?:oma|umi)|Ur[oō]marukku[\\s\\xa0]*E(?:[lḻ]utiya[\\s\\xa0]*Nirupam)|L(?:ettera[\\s\\xa0]*ai[\\s\\xa0]*Romani|ist[\\s\\xa0]*(?:(?:[sś]w(?:\\.[\\s\\xa0]*Pawła[\\s\\xa0]*do[\\s\\xa0]*Rzymian|[\\s\\xa0]*Pawła[\\s\\xa0]*do[\\s\\xa0]*Rzymian))|do[\\s\\xa0]*Rzymian|R(?:iman[ouů]m|íman[uů]m)|Ř[ií]man(?:[uů]m))|a(?:yang[\\s\\xa0]*Paulus[\\s\\xa0]*Roma|-?mã))|Epistula[\\s\\xa0]*ad[\\s\\xa0]*Romanos|ロ(?:マ人への書|ーマ(?:の信徒への手紙|人への手紙|書)?)|א(?:גרת[\\s\\xa0]*פולוס[\\s\\xa0]*השליח[\\s\\xa0]*אל-?הרומיים|ל[\\s\\xa0]*הרומים)|रोम(?:कंरास|ियों?|ी(?:हरूलाई[\\s\\xa0]*प(?:ावलको[\\s\\xa0]*पत्र|त्र))?)|Mga[\\s\\xa0]*Taga(?:[\\s\\xa0]*Roma|-?(?:[\\s\\xa0]*Roma|Roma))|῾Ρω|Sulat[\\s\\xa0]*sa[\\s\\xa0]*mga[\\s\\xa0]*Romano|ରୋମୀୟଙ୍କ[\\s\\xa0]*ପ୍ରତି[\\s\\xa0]*ପତ୍ର|《(?:罗(?:马书》|》)|羅(?:爾瑪書》|馬書》|》))|पौलाचे[\\s\\xa0]*रोमकरांस[\\s\\xa0]*पत्र|R(?:o(?:amns|emer|om(?:a(?:laiskirje)?)?|m(?:verjabr[eé]fið|iyon|a(?:rbrevet|k[eë]ve|i(?:akhoz|ns)|sn|n(?:ds|s)?)|e(?:inen(?:brief)?|n|r(?:brevet)?)|s)?|s)?|[òu]m|m(?:ns?|s)?|(?:[ií]m(?:skym)?)|óm(?:verjabr[eé]fið|a(?:iakhoz)?)?|öm(?:er)?|ô(?:-?ma|ma)|z(?:ym)?|huf(?:einiaid)?|pmans)?|ﺭﻭﻣﻴﺔ|로마(?:[\\s\\xa0]*신자들에게[\\s\\xa0]*보낸[\\s\\xa0]*서간|서)|Рим(?:јани(?:те)?|л)|Ρωμ|โรม|ரோம(?:ாபுரியாருக்கு[\\s\\xa0]*எழுதிய[\\s\\xa0]*கடிதம்|ர்)|உரோ(?:ம(?:ருக்கு[\\s\\xa0]*எழுதிய[\\s\\xa0]*நிருபம்|ையர(?:ுக்கு[\\s\\xa0]*எழுதிய[\\s\\xa0]*திருமுகம்|்)))?|الرسالة[\\s\\xa0]*إلى[\\s\\xa0]*أهل[\\s\\xa0]*رومية|B(?:r[eé]f[\\s\\xa0]*P(?:[aá]ls[\\s\\xa0]*til[\\s\\xa0]*R(?:[oó]mverja))|arua[\\s\\xa0]*kwa[\\s\\xa0]*Waroma)|Kirje[\\s\\xa0]*roomalaisille|האיגרת[\\s\\xa0]*אל[\\s\\xa0]*הרומאים|Ř(?:[ií]m)?|ر(?:سالة[\\s\\xa0]*(?:بولس[\\s\\xa0]*الرسول[\\s\\xa0]*إلى[\\s\\xa0]*أهل[\\s\\xa0]*رومية|روما)|ُومِیوں|و(?:م(?:یوں[\\s\\xa0]*کے[\\s\\xa0]*نام[\\s\\xa0]*(?:پولس[\\s\\xa0]*رسول[\\s\\xa0]*کا[\\s\\xa0]*خط|کا[\\s\\xa0]*خط))?)?)|П(?:исмо[\\s\\xa0]*од[\\s\\xa0]*апостол[\\s\\xa0]*Павле[\\s\\xa0]*до[\\s\\xa0]*христијаните[\\s\\xa0]*во[\\s\\xa0]*Рим|ослан(?:и(?:е[\\s\\xa0]*(?:на[\\s\\xa0]*св(?:\\.[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Римляни|[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Римляни)|[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Римляни|[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Римляни))|к(?:ъм[\\s\\xa0]*римляните|[\\s\\xa0]*Римлянам))|ца[\\s\\xa0]*Римљанима)|ня[\\s\\xa0]*(?:св(?:\\.[\\s\\xa0]*апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*римлян|[\\s\\xa0]*апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*римлян)|апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*римлян|до[\\s\\xa0]*римлян))))|Paulus’[\\s\\xa0]*brev[\\s\\xa0]*til[\\s\\xa0]*romerne|Poslanica[\\s\\xa0]*Rimljanima|(?:रोमकरांस[\\s\\xa0]*पत्र|Roomalaisille)|(?:Ur[oō]marukku|Taga-?[\\s\\xa0]*Roma|rom[iī]har(?:[ūu]l(?:[aā][iī]))|Rimljanima|אל[\\s\\xa0]*הרומאים|ਰੋਮੀਆਂ[\\s\\xa0]*ਨੂੰ|ad[\\s\\xa0]*Romanos|К[\\s\\xa0]*Римлянам|रोमीहरूलाई)|(?:римляните|До[\\s\\xa0]*римлян|Taga[\\s\\xa0]*Roma|romkar[āa](?:[mṃ]s)|Рим(?:љанима|лянам)|ରୋମୀୟଙ୍କ|रोमकरांस|Ρωμα[ίι]ους)|(?:Ř[íi]man(?:[ůu]m)|رومیوں|ਰੋਮੀਆਂ|Римляни?|R(?:iman[ůou]m|zymian|íman[ůu]m|om(?:erne|an(?:os?|i)))|War(?:oma|umi)|romīāṃ)|(?:罗马书》|《(?:罗马书|羅(?:爾瑪書|馬書))|Roma|羅(?:馬書》|爾瑪書》?))|(?:Рим|로마|羅(?:馬書|》)|罗(?:马书|》)|《[羅罗])|[羅罗])(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Song"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Pies(?:[nń][\\s\\xa0]*Salomona)|(?:K(?:idung[\\s\\xa0]*Agung|orkea[\\s\\xa0]*veisu|ant(?:i(?:d[\\s\\xa0]*de[\\s\\xa0]*Kantik|k(?:u(?:[\\s\\xa0]*i[\\s\\xa0]*Kantik[eë]ve|lo)|o)))?)|غزل(?:ُ[\\s\\xa0]*الغزلات|[\\s\\xa0]*الغزلات)|П(?:\\.[\\s\\xa0]*П|існ(?:я[\\s\\xa0]*(?:над[\\s\\xa0]*піснями[\\s\\xa0]*Соломона|Пісне[ий]))?|[\\s\\xa0]*П|ес(?:ма[\\s\\xa0]*(?:над[\\s\\xa0]*песмама|Соломонова)|н(?:а(?:та[\\s\\xa0]*на(?:д[\\s\\xa0]*песните|[\\s\\xa0]*Соломон)|[\\s\\xa0]*над[\\s\\xa0]*песните)|ь[\\s\\xa0]*(?:песне[ий][\\s\\xa0]*Соломона|Суле[ий]мана)|и[\\s\\xa0]*Песне[ий])?)?|нп)|ପରମଗୀତ|Diễm[\\s\\xa0]*ca|A(?:ng[\\s\\xa0]*Awit[\\s\\xa0]*n(?:g[\\s\\xa0]*mga[\\s\\xa0]*Awit|i[\\s\\xa0]*S[ao]lom(?:[oó]n))|w(?:it[\\s\\xa0]*sa[\\s\\xa0]*mga[\\s\\xa0]*Awit|[\\s\\xa0]*ni[\\s\\xa0]*S))|Црковни[\\s\\xa0]*химни|ਸਲੇਮਾਨ[\\s\\xa0]*ਦਾ[\\s\\xa0]*ਗੀਤ|ﻧﺸﻴﺪ[\\s\\xa0]*ﺍﻷﻧﺸﺎ|아가?|Gab(?:aygii[\\s\\xa0]*Sulaymaan)?|L(?:aul(?:ujen[\\s\\xa0]*laulu|\\.[\\s\\xa0]*l|[\\s\\xa0]*l)|j(?:[oó]ðalj(?:[oó]ðin)|l))|Ἆσ|Wim(?:bo[\\s\\xa0]*(?:Ulio[\\s\\xa0]*Bora|Bora))?|E(?:l[\\s\\xa0]*Cantar[\\s\\xa0]*de[\\s\\xa0]*los[\\s\\xa0]*Cantares|nekek[\\s\\xa0]*[eé]neke)|T(?:he[\\s\\xa0]*Song(?:s[\\s\\xa0]*of[\\s\\xa0]*S(?:alom[ao]ns?|o(?:lom[ao]ns?|ngs?))|[\\s\\xa0]*of[\\s\\xa0]*S(?:alom[ao]ns?|o(?:lom[ao]ns?|ngs?)))|ình[\\s\\xa0]*ca)|نش(?:يد[\\s\\xa0]*الأناشيد)?|U[nṉ](?:[nṉ]atapp(?:[aā](?:[tṭ](?:[tṭ]u))))|உன்ன(?:த[\\s\\xa0]*(?:சங்கீதம்|பாட்டு))?|श्रेष्ठ|Én(?:ekek[\\s\\xa0]*[eé]neke)?|《(?:雅歌》|歌》)|พซม|שיר(?:[\\s\\xa0]*השירים|י[\\s\\xa0]*שלמה)|V(?:e[lľ]p(?:iese(?:[nň][\\s\\xa0]*(?:[SŠ]alam(?:[uú]nova)))?)|[lľ]p)|سفر[\\s\\xa0]*نشيد[\\s\\xa0]*الأنشاد|S(?:al(?:omo(?:ns[\\s\\xa0]*Højsang|s[\\s\\xa0]*(?:Høisang|høysang))|amon[\\s\\xa0]*[eé]neke)|[\\s\\xa0]*of[\\s\\xa0]*S|ngs?|S|gs?|o[Sln]?)|ġazalu[\\s\\xa0]*l-?ġazalāt|P(?:NP|i(?:[\\s\\xa0]*bèl[\\s\\xa0]*Chante[\\s\\xa0]*a|e(?:ś[nń][\\s\\xa0]*(?:nad[\\s\\xa0]*Pie(?:[sś]niami|Salomona))|s(?:[nń][\\s\\xa0]*nad[\\s\\xa0]*Pie(?:[sś]niami)|e[nň][\\s\\xa0]*(?:(?:[SŠ]alam(?:[uú]nova)|piesn[ií])))?)|s(?:nja[\\s\\xa0]*nad[\\s\\xa0]*pisnjamy|e[nň][\\s\\xa0]*(?:(?:[SŠ]alamounova|p[ií]sn[ií])))?)|ís(?:e[nň][\\s\\xa0]*(?:(?:[SŠ]alamounova|p[ií]sn[ií])))?|j(?:esma[\\s\\xa0]*nad[\\s\\xa0]*pjesmama)?|Š)|Книга[\\s\\xa0]*П(?:есен[\\s\\xa0]*на[\\s\\xa0]*Песните,[\\s\\xa0]*от[\\s\\xa0]*Соломона|існі[\\s\\xa0]*Пісень[\\s\\xa0]*Соломона)|諸歌の歌|เพลง(?:ซาโลมอน|โซโลมอน)|गीतरत्न|g[iī]tratna|இ(?:னிமைமிகு[\\s\\xa0]*பாடல்|பா)|Ασ(?:μα[\\s\\xa0]*Ασμ[άα]των)?|Nhã[\\s\\xa0]*ca|Reshthageet|Άσμα[\\s\\xa0]*Ασμ[άα]των|சாலொமோனின்[\\s\\xa0]*உன்னதப்பாட்டு|s(?:ulem[aā]nko[\\s\\xa0]*(?:[sš]re(?:[sṣ](?:[tṭ]ʰag(?:[iī]t))))|alemān[\\s\\xa0]*dā[\\s\\xa0]*gīt)|Musthikaning[\\s\\xa0]*Kidung|H(?:öga(?:[\\s\\xa0]*V(?:isan)?|v)|o(?:he(?:lied[\\s\\xa0]*Salomonis|s(?:lied[\\s\\xa0]*Salomos|[\\s\\xa0]*Lied))|ga(?:[\\s\\xa0]*(?:visan|V)|v)|ogl(?:ied)?|js)|ø(?:[jy]s(?:angen)?)|ld?)|C(?:hante[\\s\\xa0]*Salomon|ânt(?:ico(?:s[\\s\\xa0]*dos[\\s\\xa0]*C[aâ]nticos|[\\s\\xa0]*(?:Superlativo|d(?:os[\\s\\xa0]*C[aâ]nticos|e[\\s\\xa0]*Salom[aã]o)))|ar(?:ea[\\s\\xa0]*(?:lui[\\s\\xa0]*Solomon|C[aâ]nt(?:[aă]rilor))|i)|ări)?|an(?:iad(?:[\\s\\xa0]*Solomon|au)|t(?:i(?:que[\\s\\xa0]*des[\\s\\xa0]*Cantiques|c(?:um[\\s\\xa0]*Canticorum|o(?:s[\\s\\xa0]*dos[\\s\\xa0]*C[aâ]nticos|[\\s\\xa0]*(?:Superlativo|d(?:os[\\s\\xa0]*C[aâ]nticos|i[\\s\\xa0]*Salomone|e(?:i[\\s\\xa0]*Cantici|[\\s\\xa0]*Salom[aã]o))))))|\\.[\\s\\xa0]*Cantic|[\\s\\xa0]*Cantic|ar(?:e(?:[\\s\\xa0]*de[\\s\\xa0]*los[\\s\\xa0]*Cantares|a[\\s\\xa0]*(?:lui[\\s\\xa0]*Solomon|C[aâ]nt(?:[aă]rilor))|s[\\s\\xa0]*de[\\s\\xa0]*Salom[aã]o)|i)|ări))?|nt|t)|स(?:ुलेमानको[\\s\\xa0]*श्रेष्ठगीत|्रेस्ट[\\s\\xa0]*गीत))|(?:Pieś[nń][\\s\\xa0]*Salomona|Ve[lľ]p)|(?:H(?:öga(?:[\\s\\xa0]*visan)?|o(?:he(?:slied|lied)|ga(?:[\\s\\xa0]*v)?))|Song(?:s[\\s\\xa0]*of[\\s\\xa0]*S(?:alom[ao]ns?|o(?:lom[oa]ns?|ngs?))|[\\s\\xa0]*of[\\s\\xa0]*S(?:alom[ao]ns?|o(?:lom[oa]ns?|ngs?)))?|歌》|Ve[lľ]piese[ňn]|உன்னதப்பாட்டு|P(?:i(?:ese[ňn]|se[nň])|íse[nň]|np)|雅歌》?|C(?:ânticos|hante|ant(?:ar(?:[\\s\\xa0]*de[\\s\\xa0]*los[\\s\\xa0]*Cantares|e(?:a[\\s\\xa0]*cantarilor|s))|i(?:que(?:[\\s\\xa0]*des[\\s\\xa0]*cantiques|s)?|c(?:um[\\s\\xa0]*canticorum|o(?:[\\s\\xa0]*dei[\\s\\xa0]*cantici|s)?)))?)|श्रेष्ठगीत|Tình|П(?:існ(?:я[\\s\\xa0]*над[\\s\\xa0]*піснями|і[\\s\\xa0]*Пісень)|ес(?:ен[\\s\\xa0]*на[\\s\\xa0]*песните|нь))|பாடல்|《(?:雅歌|歌)|Gabaygii|Awit[\\s\\xa0]*n(?:g[\\s\\xa0]*mga[\\s\\xa0]*Awit|i[\\s\\xa0]*S[ao]lom(?:[oó]n))))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Prov"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Pr[ií]sloví[\\s\\xa0]*(?:[SŠ]alomounova)|Pr[ií]slovi(?:[\\s\\xa0]*(?:[SŠ]alomounova|a))|Pr(?:[ií]slovia)|(?:ا(?:َمثال|م(?:ثال)?)|Π(?:αροιμ(?:[ίι](?:αι|ες))|ρμ)|ਕਹਾਉ(?:ਂਤਾ|ਤਾਂ)|n[iī]tis(?:[uū]tre)|S(?:a(?:lomos[\\s\\xa0]*Ordspr(?:[aå]k|og)|nanl(?:asku(?:jen[\\s\\xa0]*kirja|t))?)|nl|pr(?:ichw[oö]rter|euken|u(?:eche|che)|üche)?)|Книга[\\s\\xa0]*(?:притче[ий][\\s\\xa0]*Соломоновых|При(?:повісте[ий][\\s\\xa0]*Соломонових|казок[\\s\\xa0]*Соломонових|тчи[\\s\\xa0]*Соломонови))|格(?:言の書)?|П(?:ословици|р(?:и(?:че[\\s\\xa0]*Солом[оу]нове|пові(?:док|сті)|казки|т(?:ч(?:і[\\s\\xa0]*Соломона)?)?))?)|سفر[\\s\\xa0]*الأمثال|פתגמים|Мудр(?:ые[\\s\\xa0]*изречения)?|ﺃﻣﺜﺎﻝ|משלים?|Diar(?:hebion|ebion)?|P(?:ildele[\\s\\xa0]*lui[\\s\\xa0]*Solomon|o(?:slovice|rverb(?:ios|s)|verb(?:ios|s))|[eé]ld(?:abesz(?:[eé]dek)?)|r(?:ypovisti|everb(?:ios?|s)?|[ií]s|o(?:b(?:verb(?:ios|s)|erb(?:ios|s))|v(?:érbios|e(?:b(?:ios|s)|rb(?:e(?:le[\\s\\xa0]*lui[\\s\\xa0]*Solomon|s)?|i(?:a|os?)?|s)?))?)?|v(?:erb(?:ios?|s)?|b(?:os?|s)?)?|z(?:y(?:p(?:owie[sś]ci[\\s\\xa0]*Salomonowych)?)?)?)?|[vw]|ř[ií]s(?:lov(?:[ií][\\s\\xa0]*(?:[SŠ]alomounova))?)?)|Châm[\\s\\xa0]*ngôn|Izr|hitopade[sš]ko[\\s\\xa0]*pustak|பழமொழி[\\s\\xa0]*ஆகமம்|잠언?|مثل|Wulang[\\s\\xa0]*Bebasan|N(?:eetivachan|[iī]timo(?:[lḻ]ika[lḷ]))|Fjal[eë]t[\\s\\xa0]*e[\\s\\xa0]*urta|ส(?:ุภาษิต|ภษ)|أمثال|ams̱āl|K(?:niha[\\s\\xa0]*pr[ií]slov[ií]|\\.[\\s\\xa0]*pr[ií]slov[ií]|s(?:i[eę]g(?:[ai][\\s\\xa0]*Przy(?:powie(?:[sś]ci[\\s\\xa0]*Salomona|sł[oó]w)))|\\.[\\s\\xa0]*Przy(?:powie[sś]ci[\\s\\xa0]*Salomona|sł[oó]w)|[\\s\\xa0]*Przy(?:powie[sś]ci[\\s\\xa0]*Salomona|sł[oó]w))|[\\s\\xa0]*pr[ií]slov[ií]|aw)|kahāutāṃ|《箴(?:言》|》)|Li(?:ber[\\s\\xa0]*Proverbiorum|v[\\s\\xa0]*Pwov[eè]b[\\s\\xa0]*yo)|Изрек[еи]|நீ(?:தி(?:மொழிகள்)?|மொ)|नीति(?:सूत्रें?|[\\s\\xa0]*वचन|[बव]चन)|M(?:ga[\\s\\xa0]*(?:Panultihon|Kawikaan)|udre[\\s\\xa0]*izreke|aah(?:maahyadii)?|eth(?:ali)?|it(?:h(?:ali)?)?)|O(?:r(?:ðskviðirnir|overbs|ds(?:p(?:r(?:(?:[aå]k(?:sboken|ene))|ogene(?:s[\\s\\xa0]*Bog)?))?)?)|kv)|हितोपदेश(?:को[\\s\\xa0]*पुस्तक)?|ହିତୋପଦେଶ)|(?:Ksi[eę]g(?:[ai][\\s\\xa0]*Przysł(?:[oó]w))|P(?:[eé]ld|ř))|(?:Kawikaan|《箴言?|हितोपदेशको|hitopade[šs]ko|Sananlaskujen|При(?:повісте(?:[ий](?:[\\s\\xa0]*соломонових)?)|казок|тч(?:и(?:[\\s\\xa0]*Соломонови)?|і))|नीति|箴(?:言》?|》)?|الأمثال|Châm|P(?:anultihon|r(?:overbele|[íi]slov[íi])|ř[íi]slov[íi]|wov[eè]b)))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Wis"],
        apocrypha: true,
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Σοφ[ίι]α[\\s\\xa0]*Σολ(?:ομ(?:[ωώ]ντος)?)|Σοφ(?:[ίι]α[\\s\\xa0]*Σολ)|(?:《智慧篇》|B[oö]lcs(?:ess(?:[eé]g)?)|Vi(?:is(?:auden[\\s\\xa0]*kirja)?|s(?:d(?:ommen(?:s[\\s\\xa0]*(?:Bog|bok))?)?|h(?:eten(?:s[\\s\\xa0]*bok)?)?))|Прем(?:уд(?:орсти[\\s\\xa0]*Соломонове|р(?:ости[\\s\\xa0]*Соломона|ість[\\s\\xa0]*Соломона))|[\\s\\xa0]*Сол)|Liber[\\s\\xa0]*Sapientiae|سفر[\\s\\xa0]*الحكمة|지혜서?|சா(?:லமோனின்[\\s\\xa0]*ஞானம்|ஞா)|Книга[\\s\\xa0]*(?:Прем(?:ъдрост[\\s\\xa0]*Соломонова|удрості[\\s\\xa0]*Соломона)|на[\\s\\xa0]*мъдростта|Мудрост(?:[\\s\\xa0]*Соломонова|и))|Cartea[\\s\\xa0]*(?:[iî]n(?:[tţ]elepciunii[\\s\\xa0]*lui[\\s\\xa0]*Solomon)|[IÎ]nțelepciunii)|K(?:n(?:iha[\\s\\xa0]*(?:Moudrosti|moudrostí)|jiga[\\s\\xa0]*Mudrosti)|s(?:i[eę]g(?:[ai][\\s\\xa0]*M(?:[aą]dro(?:[sś]ci)))|\\.[\\s\\xa0]*M[aą]dro(?:[sś]ci)|[\\s\\xa0]*M[aą]dro(?:[sś]ci))|hôn[\\s\\xa0]*Ngoan|a(?:wicaksanan[\\s\\xa0]*Salomo|r))|Ang[\\s\\xa0]*Karunungan[\\s\\xa0]*ni[\\s\\xa0]*S[ao]lom(?:[oó]n)|D(?:e[\\s\\xa0]*wijsheid[\\s\\xa0]*van[\\s\\xa0]*Salomo|oethineb[\\s\\xa0]*Solomon)|ソロモンの(?:知恵書|智慧)|Weish(?:eit[\\s\\xa0]*Salomos)?|Муд(?:рости[\\s\\xa0]*Соломонове)?|M(?:oudrost[\\s\\xa0]*[SŠ]alomounova|[aą]dr(?:o(?:[sś](?:[cć][\\s\\xa0]*Salomona))?)|dr|ud(?:r(?:os[tť])?)?|úd(?:ros(?:ti?|ť))?)|He(?:t[\\s\\xa0]*boek[\\s\\xa0]*der[\\s\\xa0]*wijsheid|k(?:ima[\\s\\xa0]*ya[\\s\\xa0]*Solomoni)?)|[IÎ]n(?:[tț]elepciunea[\\s\\xa0]*lui[\\s\\xa0]*Solomon)|知(?:恵(?:の書)?)?|ஞானாகமம்|The[\\s\\xa0]*Wis(?:om[\\s\\xa0]*of[\\s\\xa0]*Solomon|d(?:om[\\s\\xa0]*of[\\s\\xa0]*Solomon|[\\s\\xa0]*of[\\s\\xa0]*Solomon)|[\\s\\xa0]*of[\\s\\xa0]*Solomon)|S(?:peki[\\s\\xa0]*Sal[oó]mons|Sal|a(?:gesse[\\s\\xa0]*de[\\s\\xa0]*Salomon|l(?:amon[\\s\\xa0]*b[oö]lcsess(?:[eé]ge)|omo(?:n[\\s\\xa0]*viisaus|s[\\s\\xa0]*(?:Visdom|vishet)))|b(?:edoria[\\s\\xa0]*de[\\s\\xa0]*Salom[aã]o|idur[ií]a)?|p(?:ien(?:za[\\s\\xa0]*di[\\s\\xa0]*Salomone|t(?:ia[\\s\\xa0]*Salomonis)?))?)|b)|ปรีชาญาณ|חכמת[\\s\\xa0]*שלמה|حك(?:مة[\\s\\xa0]*سليمان)?|Σοφ[ίι]α[\\s\\xa0]*Σαλωμ(?:[ωώ]ντος)?)|(?:B[oö]lcs|M[aą]dr|Σοφ)|(?:W(?:eisheit|i(?:jsheid(?:[\\s\\xa0]*van[\\s\\xa0]*Salomo)?|s(?:om[\\s\\xa0]*of[\\s\\xa0]*Solomon|[\\s\\xa0]*of[\\s\\xa0]*Solomon|d(?:[\\s\\xa0]*of[\\s\\xa0]*Solomon|om(?:[\\s\\xa0]*of[\\s\\xa0]*Solomon)?)?)?))|Мудрости|K(?:niha[\\s\\xa0]*moudrosti|a(?:wicaksanan|runungan(?:[\\s\\xa0]*ni[\\s\\xa0]*S[oa]lom(?:[óo]n))?))|Σοφ[ιί]α|智慧篇》?|M(?:oudrost|udrosti)|Cartea[\\s\\xa0]*[IÎ]ntelepciunii|Hekima|S(?:a(?:bedoria|pien(?:tia|za)|gesse|lom[óo]n)|olom[oó]n)|《智慧篇|الحكمة|Прем(?:ъдрост(?:[\\s\\xa0]*Соломонова)?)?))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Joel"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:யோவே(?:ல்)?|سفر[\\s\\xa0]*يوئيل|요엘서?|ی(?:ُوایل|وایل)|Книга[\\s\\xa0]*(?:на[\\s\\xa0]*пророк[\\s\\xa0]*Иоиля?|пророка[\\s\\xa0]*(?:Ио(?:иля|іла)|Йоіла)|[ИЙ]оіла)|[ਜਯ]ੋਏਲ|योएल(?:को[\\s\\xa0]*पुस्तक)?|يوء|《(?:岳厄爾》|約珥書》|约[珥饵]书》|珥》)|Йо(?:ил|[ії][лн])|Pro(?:roctwo[\\s\\xa0]*Ioelowe|phetia[\\s\\xa0]*Ioel)|Ks(?:i[eę]g(?:[ai][\\s\\xa0]*Joela)|\\.[\\s\\xa0]*Joela|[\\s\\xa0]*Joela)|יואל|โยเอล|yōʾīl|Ἰλ|Јо(?:ел|и[лљ])|J(?:ó[eé]l|o(?:[iéï]l|e(?:l(?:s[\\s\\xa0]*(?:Bog|bok)|i(?:n[\\s\\xa0]*kirja)?)?)?|ël?)|l)|Ioil|Gi(?:ô-?ên|oe(?:le)?)|ยอล|Ио(?:иль|[ії][лн])|Ι(?:ω[ήη]λ|λ)|Y(?:ōv[eē]l|o(?:ael|v[eē]l|le|o(?:['’]eel|l)|e(?:li?)?))|ヨエル書?|욜|ଯୋୟେଲ[\\s\\xa0]*ଭବିଷ୍ୟ‌ଦ୍‌ବକ୍ତାଙ୍କ[\\s\\xa0]*ପୁସ୍ତକ|Liv[\\s\\xa0]*Jow[eè]l[\\s\\xa0]*la|よえるしょ)|(?:[Iy]oel|珥》?|约[饵珥]书》?|يوئيل|Ио(?:іла|иля?)|約珥書》?|Jo(?:el(?:in|a)|w[eè]l)|岳厄爾》?|Йоіла|ଯୋୟେଲ|《(?:约[饵珥]书|岳厄爾|約珥書|珥)))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Jonah"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:Ionas?|ਯੂਨਾਹ|Книга[\\s\\xa0]*(?:на[\\s\\xa0]*пророк[\\s\\xa0]*Иона|пророка[\\s\\xa0]*(?:Ион[иы]|Йони))|யோனா|요나서?|יונה|Йона?|Gi(?:ô-?na|o(?:na)?)|《(?:约拿书》|約(?:拿書》|納》)|拿》)|J(?:n[hs]|o(?:ona(?:n[\\s\\xa0]*kirja)?|n(?:a(?:s(?:['’][\\s\\xa0]*Bog|[\\s\\xa0]*bok)|[\\s\\xa0]*bok|[hš])|á[hsš]?)?)|ón(?:[aá]s)?)|Јона|yūn(?:as|āh)|ଯୂନସ[\\s\\xa0]*ଭବିଷ୍ୟ‌ଦ୍‌ବକ୍ତାଙ୍କ[\\s\\xa0]*ପୁସ୍ତକ|Y(?:unus|ō[nṉ][aā]|o(?:on(?:is)?|ṉ[aā]|n[aā]?))|ยนา|ヨナ(?:しょ|書)?|โยนาห์|Ион|يون|Юнус|Ἰν|Ι(?:ων[άα]ς|ν)|Ks(?:i[eę]g(?:[ai][\\s\\xa0]*Jonasza)|\\.[\\s\\xa0]*Jonasza|[\\s\\xa0]*Jonasza)|ی(?:ُوناہ|ونس)|Pro(?:roctwo[\\s\\xa0]*Ionaszowe|phetia[\\s\\xa0]*Ionae)|욘|سفر[\\s\\xa0]*يونان|Liv[\\s\\xa0]*Jonas[\\s\\xa0]*la|योना(?:को[\\s\\xa0]*पुस्तक)?)|(?:ଯୂନସ|拿》?|《(?:约拿书|約(?:拿書|納)|拿)|Йони|約(?:拿書》?|納》?)|Ион[ыиа]|yon[āa]|约拿书》?|Jo(?:onan|na(?:s(?:za)?)?)|يونان))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Nah"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:น(?:าฮูม|ฮม)|《(?:那(?:鴻[书書]》|鸿书》)|納鴻》|[鴻鸿]》)|ਨਹੂਮ|नहूम(?:को[\\s\\xa0]*पुस्तक)?|Книга[\\s\\xa0]*(?:на[\\s\\xa0]*пророк[\\s\\xa0]*Наума?|пророка[\\s\\xa0]*Наума)|Pro(?:roctwo[\\s\\xa0]*Nahumowe|phetia[\\s\\xa0]*Nahum)|ナホム(?:しょ|書)?|ନାହୂମ[\\s\\xa0]*ଭବିଷ୍ୟ‌ଦ୍‌ବକ୍ତାଙ୍କ[\\s\\xa0]*ପୁସ୍ତକ|n(?:ahūm|āḥūm)|나(?:훔서?)?|Liv[\\s\\xa0]*Nawoum[\\s\\xa0]*lan|N(?:āk[uū]m|a(?:-?h[uâ]m|k[uū]m|ch|um|h(?:oom|u(?:m(?:s[\\s\\xa0]*(?:Bog|bok)|i(?:n[\\s\\xa0]*kirja)?|u))?|úm?)?|w(?:oun)?|x(?:uum)?)|áh(?:um)?|h)|ن(?:ا(?:[\\s\\xa0]*حُوم|حُوم)|حوم?)|נחום|நாகூ(?:ம்)?|Ks(?:i[eę]g(?:[ai][\\s\\xa0]*Nahuma)|\\.[\\s\\xa0]*Nahuma|[\\s\\xa0]*Nahuma)|سفر[\\s\\xa0]*ناحوم|Να(?:ο[υύ]μ)?)|(?:[鴻鸿]》?|那(?:鸿书》?|鴻[書书]》?)|ନାହୂମ|《(?:那(?:鸿书|鴻[書书])|納鴻|[鸿鴻])|نا(?:حوم)?|Na(?:woum|hum(?:in|a)?)?|nahum|納鴻》?|Наума?))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["1John"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])((?:א(?:גרתו[\s\xa0]*הראשונה[\s\xa0]*של[\s\xa0]*יוחנן[\s\xa0]*השלי|יגרת[\s\xa0]*יוחנן[\s\xa0]*הראשונה)|Ιω[άα]ννου[\s\xa0]*Α['ʹʹ΄’]|رسالة[\s\xa0]*(?:القديس[\s\xa0]*يوحنا[\s\xa0]*الأولى|يوحنا[\s\xa0]*(?:الأولى|1))|I(?:\.[\s\xa0]*(?:Gi(?:o(?:vanni|an)|ăng)?|Јован(?:ов[ао])?|San[\s\xa0]*J[au](?:[au]n)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Јован|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|и(?:е[\s\xa0]*на[\s\xa0]*апостол[\s\xa0]*Јован|ца[\s\xa0]*Јованова)))|соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|Послання[\s\xa0]*Івана|I(?:vanova[\s\xa0]*Poslanica|oan(?:nis)?|n)|Yo(?:kanan|ox(?:anaa)?|h(?:an(?:a|es?))?)|І(?:оанна|вана)|(?:[ИЙ]оан(?:ово)?)|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana))|Jana)|J(?:a(?:[au]n|n(?:o(?:s|va?)|[uů]v|a)?)|h(?:[ho]n|n)?|phn|o(?:phn|[aã]o|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s)|[mn])?)?|ean|áno[sv]|n|u[au]n|óh)?|list[\s\xa0]*Jan[uů]v)|[\s\xa0]*(?:Gi(?:o(?:vanni|an)|ăng)?|Јован(?:ов[ао])?|San[\s\xa0]*J[au](?:[au]n)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Јован|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|и(?:е[\s\xa0]*на[\s\xa0]*апостол[\s\xa0]*Јован|ца[\s\xa0]*Јованова)))|соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|Послання[\s\xa0]*Івана|Yo(?:kanan|ox(?:anaa)?|h(?:an(?:a|es?))?)|І(?:оанна|вана)|(?:[ИЙ]оан(?:ово)?)|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana))|Jana)|I(?:vanova[\s\xa0]*Poslanica|oan|n)|J(?:a(?:[au]n|n(?:o(?:s|va?)|[uů]v|a)?)|h(?:[ho]n|n)?|phn|o(?:phn|[aã]o|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s)|[mn])?)?|ean|áno[sv]|n|u[au]n|óh)?|list[\s\xa0]*Jan[uů]v))|முதலாவது[\s\xa0]*யோவான்|ਯੂਹੰਨਾ[\s\xa0]*ਦੀ[\s\xa0]*ਪਹਿਲੀ[\s\xa0]*ਪੱਤ੍ਰੀ|y(?:oh[aā]n(?:[aā]ce(?:[mṃ][\s\xa0]*pahile[\s\xa0]*patra))|uhann[aā]ko[\s\xa0]*pahilo[\s\xa0]*patra|ū(?:ḥannā[\s\xa0]*kā[\s\xa0]*pahlā[\s\xa0]*ʿām[\s\xa0]*ḫaṭ|h(?:ãnā[\s\xa0]*dī[\s\xa0]*pahilī[\s\xa0]*pattrī|ann[aā]ko[\s\xa0]*pahilo[\s\xa0]*patra)))|ଯୋହନଙ୍କ[\s\xa0]*ପ୍ରଥମ[\s\xa0]*ପତ୍ର|П(?:ерш(?:[ае][\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послання[\s\xa0]*апостола[\s\xa0]*Івана|Послання[\s\xa0]*Івана|[ИЙ]оаново|І(?:оанна|вана)))|рв(?:а[\s\xa0]*(?:п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Јован|ослани(?:е[\s\xa0]*на[\s\xa0]*апостол[\s\xa0]*Јован|ца[\s\xa0]*Јованова))|Јован(?:ов[ао])?)|о[\s\xa0]*(?:п(?:ослание[\s\xa0]*на[\s\xa0]*апостол[\s\xa0]*Јован|исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Јован)|Јован(?:ово)?))|ърв(?:о[\s\xa0]*(?:съборно[\s\xa0]*послание[\s\xa0]*на[\s\xa0]*св(?:\.[\s\xa0]*ап(?:\.[\s\xa0]*Иоана[\s\xa0]*Богослова|[\s\xa0]*Иоана[\s\xa0]*Богослова)|[\s\xa0]*ап(?:\.[\s\xa0]*Иоана[\s\xa0]*Богослова|[\s\xa0]*Иоана[\s\xa0]*Богослова))|послание[\s\xa0]*на[\s\xa0]*[ИЙ]оан)|а[\s\xa0]*(?:[ИЙ]оан(?:ово)?)))|《(?:伊望第一》|若望一書》|約(?:翰[一壹]書》|壹》)|约(?:翰[一壹]书》|壹》))|اوّل(?:-?یُوحنّا|[\s\xa0]*ی(?:ُوحنّا|وحنّا)|۔یوحنا)|ヨハネ(?:の(?:第一の(?:手紙|書)|手紙一)|[\s\xa0]*1)|य(?:ूहन्नाको[\s\xa0]*पहिलो[\s\xa0]*पत्र|ोहानाचें[\s\xa0]*पहिले[\s\xa0]*पत्र)|Kwanza[\s\xa0]*Yoh(?:an[ae])?|Α(?:['ʹʹ΄’][\s\xa0]*(?:᾿Ιω|Ιω(?:[άα]ννη)?))|யோவ(?:ன்[\s\xa0]*எழுதிய[\s\xa0]*முதலாவது[\s\xa0]*நிருபம்|ான்[\s\xa0]*(?:எழுதிய[\s\xa0]*முதல(?:்[\s\xa0]*திருமுகம்|ாம்[\s\xa0]*கடிதம்)|முதல்[\s\xa0]*திருமுகம்))|Barua[\s\xa0]*ya[\s\xa0]*Kwanza[\s\xa0]*ya[\s\xa0]*Yohane|Una(?:ng[\s\xa0]*Juan|[\s\xa0]*Juan)|요한(?:의[\s\xa0]*첫째[\s\xa0]*서간|[1일]서)|1(?:-?(?:ше(?:\.[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послання[\s\xa0]*апостола[\s\xa0]*Івана|Послання[\s\xa0]*Івана|[ИЙ]оаново|І(?:оанна|вана))|[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послання[\s\xa0]*апостола[\s\xa0]*Івана|Послання[\s\xa0]*Івана|[ИЙ]оаново|І(?:оанна|вана)))|я(?:\.[\s\xa0]*(?:послание[\s\xa0]*Иоанна|Ио(?:анна|хана))|[\s\xa0]*(?:послание[\s\xa0]*Иоанна|Ио(?:анна|хана)))|а(?:\.[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послання[\s\xa0]*апостола[\s\xa0]*Івана|Послання[\s\xa0]*Івана|[ИЙ]оаново|І(?:оанна|вана))|[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послання[\s\xa0]*апостола[\s\xa0]*Івана|Послання[\s\xa0]*Івана|[ИЙ]оаново|І(?:оанна|вана)))|е(?:\.[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|ие[\s\xa0]*Иоанна)|Послання[\s\xa0]*Івана|Йоаново|Ио(?:ан(?:ово|на)|хана)|І(?:оанна|вана))|[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|ие[\s\xa0]*Иоанна)|Послання[\s\xa0]*Івана|Йоаново|Ио(?:ан(?:ово|на)|хана)|І(?:оанна|вана)))|یُوحنّا)|st(?:\.[\s\xa0]*J(?:phn|h(?:[ho]n|n)?|n|o(?:phn|nh|on|h[mn]?)?)|[\s\xa0]*J(?:phn|h(?:[ho]n|n)?|n|o(?:phn|nh|on|h[mn]?)?))|°(?:\.[\s\xa0]*Giovanni|[\s\xa0]*Giovanni)|[\s\xa0]*(?:ย(?:อห์น|น)|y(?:oh[aā]n(?:[aā]ce[mṃ])|uhann[aā]ko|ūh(?:ann[aā]ko|ãnā))|அருளப்பர்|San[\s\xa0]*J[au](?:[au]n)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Јован|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|и(?:ца[\s\xa0]*Јованова|е[\s\xa0]*(?:на[\s\xa0]*апостол[\s\xa0]*Јован|Иоанна))))|G(?:i(?:o(?:vanni|an)|ăng)?|j(?:onit)?|v)|I(?:oan(?:nis)?|n|v(?:anova[\s\xa0]*Poslanica)?)|соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|Послання[\s\xa0]*Івана|யோ(?:வா(?:ன்)?)?|ی(?:ُوحنّا|وحنّا)|(?:[ei](?:\.[\s\xa0]*Gjonit|[\s\xa0]*Gjonit))|И(?:о(?:хана|ан(?:ово|на)?)|н)|ଯୋହନଙ|І(?:оанна|в(?:ана)?)|J(?:a(?:[au]n|n(?:o(?:s|va?)|[uů]v|a)?)|o(?:phn|[aã]o|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s(?:brev(?:et)?)?)|[mn])?)?|h(?:[ho]n|n)?|phn|ean|áno[sv]|n|u[au]n|óh)?|k(?:\.[\s\xa0]*J[aá]nov|[\s\xa0]*J[aá]nov)|ਯੂਹੰਨਾ|Йоан(?:ово)?|Y(?:ōva[nṉ]|o(?:kanan|va[nṉ]|o(?:hanna|x(?:anaa)?)|h(?:an(?:a|es?))?))|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana))|Jana)|Ј(?:ован(?:ов[ао])?|н)|य(?:ुहत्रा|ूहन्ना(?:को)?|ोहान(?:ाच)?)|يو|list[\s\xa0]*Jan[uů]v)|(?:[яе](?:\.[\s\xa0]*(?:послание[\s\xa0]*Иоанна|Ио(?:анна|хана))|[\s\xa0]*(?:послание[\s\xa0]*Иоанна|Ио(?:анна|хана))))|ère(?:\.[\s\xa0]*Jean|[\s\xa0]*Jean)|re(?:\.[\s\xa0]*Jean|[\s\xa0]*Jean)|a(?:\.[\s\xa0]*Jo[aã]o|[\s\xa0]*Jo[aã]o)|요한|e(?:r(?:\.[\s\xa0]*Jean|e(?:\.[\s\xa0]*Jean|[\s\xa0]*Jean)|[\s\xa0]*Jean)|\.[\s\xa0]*Joh(?:annes)?|[\s\xa0]*Joh(?:annes)?)|John|۔یوحنا|º(?:\.[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n)))|o(?:\.[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J(?:[au](?:[au]n)|o[aã]o))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J(?:[au](?:[au]n)|o[aã]o)))|\.(?:-?یُوحنّا|[oº](?:\.[\s\xa0]*(?:San[\s\xa0]*J(?:[au](?:[au]n)|J[au](?:[au]n))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n))))|۔یوحنا|[\s\xa0]*(?:Јован(?:ов[ао])?|San[\s\xa0]*J[au](?:[au]n)|G(?:jonit|i(?:o(?:vanni|an)|ăng)?)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Јован|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|и(?:ца[\s\xa0]*Јованова|е[\s\xa0]*(?:на[\s\xa0]*апостол[\s\xa0]*Јован|Иоанна))))|ยอห์น|Yo(?:kanan|o(?:hanna|x(?:anaa)?)|h(?:an(?:a|es?))?)|соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|Послання[\s\xa0]*Івана|I(?:vanova[\s\xa0]*Poslanica|oan(?:nis)?|n)|य(?:ुहत्रा|ूहन्ना(?:को)?)|யோவான்|ی(?:ُوحنّا|وحنّا)|ଯୋହନଙ|J(?:a(?:[au]n|n(?:o(?:s|va?)|[uů]v|a)?)|o(?:phn|[aã]o|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s(?:brev(?:et)?)?)|[mn])?)?|h(?:[ho]n|n)?|phn|ean|áno[sv]|n|u[au]n|óh)?|І(?:оанна|вана)|Ио(?:хана|ан(?:ово|на)?)|Йоан(?:ово)?|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana))|Jana)|list[\s\xa0]*Jan[uů]v|y[uū]hann(?:[aā]ko))))|ପ୍ରଥମ[\s\xa0]*ଯୋହନଙ|۱(?:-?یُوحنّا|[\s\xa0]*ی(?:ُوحنّا|وحنّا)|۔یوحنا)|ی(?:ُوحنّا[\s\xa0]*کا[\s\xa0]*پہلا[\s\xa0]*عام[\s\xa0]*خط|وحن(?:ّا[\s\xa0]*کا[\s\xa0]*پہلا[\s\xa0]*عام[\s\xa0]*خط|ا[\s\xa0]*کا[\s\xa0]*پہلا[\s\xa0]*عام[\s\xa0]*خط))|F(?:[oö]rsta[\s\xa0]*Johannesbrevet|yrsta[\s\xa0]*(?:br[eé]f[\s\xa0]*J(?:[oó]hannesar[\s\xa0]*hið[\s\xa0]*almenna)|J[oó]hannesarbr(?:[eé]f))|ørste[\s\xa0]*Joh(?:annes(?:brev)?)?|irst[\s\xa0]*J(?:phn|h(?:[ho]n|n)?|n|o(?:phn|nh|on|h[mn]?)?))|一ヨハネ|Mutal[aā]vatu[\s\xa0]*யோவான்|ﻳﻮﺣﻨﺎ[\s\xa0]*ﺍﻻﻭﻝ|Y(?:ōva[nṉ][\s\xa0]*E(?:[lḻ]utiya[\s\xa0]*Mutal(?:[aā]vatu[\s\xa0]*Nirupam))|o(?:va[nṉ][\s\xa0]*E(?:[lḻ]utiya[\s\xa0]*Mutal(?:[aā]vatu[\s\xa0]*Nirupam))|oxanaa[\s\xa0]*Kowaad|hane[\s\xa0]*I))|E(?:nsimm[aä]inen[\s\xa0]*Johanneksen[\s\xa0]*kirje|pistula[\s\xa0]*I(?:[\s\xa0]*Ioannis|oannis[\s\xa0]*I)|rste[\s\xa0]*Johannes|erste[\s\xa0]*Joh(?:annes)?|ls[oő][\s\xa0]*J(?:(?:[aá]nos|n)))|P(?:er[sš]e[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Ivana|ierwsz(?:[aey][\s\xa0]*(?:List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana))|Jana)|Jana))|r(?:im(?:a[\s\xa0]*(?:lettera[\s\xa0]*di[\s\xa0]*Giovanni|Giovanni)|o[\s\xa0]*Giovanni|e(?:ir[ao][\s\xa0]*Jo(?:[aã]o)|r(?:o[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n)))))|em(?:i(?:ère(?:s[\s\xa0]*Jean|[\s\xa0]*Jean)|er(?:e(?:s[\s\xa0]*Jean|[\s\xa0]*Jean)|s[\s\xa0]*Jean|[\s\xa0]*Jean))|ye[\s\xa0]*Jan)|v(?:[yý][\s\xa0]*(?:J(?:[aá]nov[\s\xa0]*list|list[\s\xa0]*J[aá]nov))|a[\s\xa0]*(?:Ivanova[\s\xa0]*Poslanica|kniha[\s\xa0]*J[aá]nov|J[aá]nov)|á[\s\xa0]*(?:kniha[\s\xa0]*J[aá]nov|J[aá]nov)|n[ií][\s\xa0]*(?:list[\s\xa0]*Jan(?:[uů]v|J(?:an(?:ova|[uů]v)?)?)))))|J(?:ohannes(?:[\s\xa0]*f[oö]rsta[\s\xa0]*brev|(?:['’][\s\xa0]*(?:Første[\s\xa0]*Brev|1(?:\.[\s\xa0]*Brev|[\s\xa0]*Brev))))|[aá]nos[\s\xa0]*I)|Waraka[\s\xa0]*wa[\s\xa0]*Kwanza[\s\xa0]*wa[\s\xa0]*Yohane)|(?:1\.[oº](?:\.[\s\xa0]*J(?:[au](?:[au]n)|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n))))|Prv(?:[yý][\s\xa0]*list[\s\xa0]*J(?:[aá]nov)|n(?:[ií][\s\xa0]*J(?:an(?:ova|[uů]v)?)?)))|1\.[oº][\s\xa0]*(?:San[\s\xa0]*J(?:[au](?:[au]n)|J[au](?:[au]n)))|1\.[oº][\s\xa0]*J(?:[au](?:[au]n))|(?:I(?:\.[\s\xa0]*(?:Johanneksen|Ivanova)|[\s\xa0]*(?:Johanneksen|I(?:vanova|oannis))|oannis[\s\xa0]*I)|Fyrsta[\s\xa0]*br[eé]f[\s\xa0]*J(?:[óo]hannesar)|1(?:\.[\s\xa0]*(?:Johanneksen|Ivanova)|[\s\xa0]*(?:Johanneksen|Ivanova))|约(?:翰[壹一]书》?|壹》?)|伊望第一》?|約(?:翰[壹一]書》?|壹》?)|Prv(?:a[\s\xa0]*Ivanova(?:[\s\xa0]*poslanica)?|[ýy][\s\xa0]*J(?:[áa]nov))|يوحنا[\s\xa0]*الأولى|《(?:若望一書|伊望第一|约(?:翰[壹一]书|壹)|約(?:翰[一壹]書|壹))|Ensimm[aä]inen[\s\xa0]*Johanneksen|Johannes’[\s\xa0]*første[\s\xa0]*brev|若望一書》?))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["2John"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])((?:رسالة[\s\xa0]*(?:القديس[\s\xa0]*يوحنا[\s\xa0]*الثانية|يوحنا[\s\xa0]*(?:الثانية|2))|Zweite[\s\xa0]*Johannes|Втор(?:о[\s\xa0]*(?:съборно[\s\xa0]*послание[\s\xa0]*на[\s\xa0]*св(?:\.[\s\xa0]*ап(?:\.[\s\xa0]*Иоана[\s\xa0]*Богослова|[\s\xa0]*Иоана[\s\xa0]*Богослова)|[\s\xa0]*ап(?:\.[\s\xa0]*Иоана[\s\xa0]*Богослова|[\s\xa0]*Иоана[\s\xa0]*Богослова))|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Јован|ослание[\s\xa0]*на[\s\xa0]*(?:апостол[\s\xa0]*Јован|[ИЙ]оан))|Јован(?:ово)?)|а[\s\xa0]*(?:п(?:ослание[\s\xa0]*на[\s\xa0]*апостол[\s\xa0]*Јован|исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Јован)|Јован(?:ово)?|(?:[ИЙ]оан(?:ово)?)))|y(?:uhann[aā]ko[\s\xa0]*dostro[\s\xa0]*patra|oh[aā]n(?:[aā]ce(?:[mṃ][\s\xa0]*dusre[\s\xa0]*patra))|ū(?:ḥannā[\s\xa0]*kā[\s\xa0]*dūsrā[\s\xa0]*ʿām[\s\xa0]*ḫaṭ|h(?:ann[aā]ko[\s\xa0]*dostro[\s\xa0]*patra|ãnā[\s\xa0]*dī[\s\xa0]*dūjī[\s\xa0]*pattrī)))|Waraka[\s\xa0]*wa[\s\xa0]*Pili[\s\xa0]*wa[\s\xa0]*Yohane|Epistula[\s\xa0]*I(?:I[\s\xa0]*Ioannis|oannis[\s\xa0]*II)|ਯੂਹੰਨਾ[\s\xa0]*ਦੀ[\s\xa0]*ਦੂਜੀ[\s\xa0]*ਪੱਤ੍ਰੀ|Β(?:['ʹʹ΄’][\s\xa0]*(?:᾿Ιω|Ιω(?:[άα]ννη)?))|دوم(?:-?یُوحنّا|[\s\xa0]*ی(?:ُوحنّا|وحنّا)|۔یوحنا)|ଯୋହନଙ୍କ[\s\xa0]*ଦ୍ୱିତୀୟ[\s\xa0]*ପତ୍ର|Ιω[άα]ννου[\s\xa0]*Β['ʹʹ΄’]|Друг(?:а[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|ица[\s\xa0]*Јованова)|Послання[\s\xa0]*Івана|Јованова|[ИЙ]оаново|І(?:оанна|вана))|е[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послання[\s\xa0]*апостола[\s\xa0]*Івана|Послання[\s\xa0]*Івана|[ИЙ]оаново|І(?:оанна|вана)))|ଦ୍ୱିତୀୟ[\s\xa0]*ଯୋହନଙ|T(?:oinen[\s\xa0]*Joh(?:anneksen[\s\xa0]*kirje)?|weede[\s\xa0]*Joh(?:annes)?)|य(?:ूहन्नाको[\s\xa0]*दोस्(?:त्रो[\s\xa0]*पत्र|रो[\s\xa0]*पत्र)|ोहानाचें[\s\xa0]*दुसरे[\s\xa0]*पत्र)|Se(?:gund(?:a[\s\xa0]*Jo[aã]o|o[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J(?:[au](?:[au]n)|o[aã]o)))|cond(?:a[\s\xa0]*(?:lettera[\s\xa0]*di[\s\xa0]*Giovanni|Giovanni)|o[\s\xa0]*Giovanni|[\s\xa0]*J(?:phn|h(?:[ho]n|n)?|n|o(?:phn|nh|on|h[mn]?)?)))|ی(?:ُوحنّا[\s\xa0]*کا[\s\xa0]*دوسرا[\s\xa0]*عام[\s\xa0]*خط|وحن(?:ا[\s\xa0]*کا[\s\xa0]*دوسرا[\s\xa0]*عام[\s\xa0]*خط|ّا[\s\xa0]*کا[\s\xa0]*دوسرا[\s\xa0]*خط))|M[aá]sodik[\s\xa0]*J(?:(?:[aá]nos|n))|Barua[\s\xa0]*ya[\s\xa0]*Pili[\s\xa0]*ya[\s\xa0]*Yohane|I(?:kalawang[\s\xa0]*Juan|I(?:\.[\s\xa0]*(?:Gi(?:o(?:vanni|an)|ăng)?|Јован(?:ов[ао])?|San[\s\xa0]*J[au](?:[au]n)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Јован|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|и(?:е[\s\xa0]*на[\s\xa0]*апостол[\s\xa0]*Јован|ца[\s\xa0]*Јованова)))|соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|Послання[\s\xa0]*Івана|I(?:vanova[\s\xa0]*Poslanica|oan(?:nis)?|n)|Yo(?:kanan|ox(?:anaa)?|h(?:an(?:a|es?))?)|І(?:оанна|вана)|(?:[ИЙ]оан(?:ово)?)|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana))|Jana)|J(?:a(?:[au]n|n(?:o(?:s|va?)|[uů]v|a)?)|h(?:[ho]n|n)?|phn|o(?:phn|[aã]o|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s)|[mn])?)?|ean|áno[sv]|n|u[au]n|óh)?|list[\s\xa0]*Jan[uů]v)|[\s\xa0]*(?:Gi(?:o(?:vanni|an)|ăng)?|Јован(?:ов[ао])?|San[\s\xa0]*J[au](?:[au]n)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Јован|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|и(?:е[\s\xa0]*на[\s\xa0]*апостол[\s\xa0]*Јован|ца[\s\xa0]*Јованова)))|соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|Послання[\s\xa0]*Івана|Yo(?:kanan|ox(?:anaa)?|h(?:an(?:a|es?))?)|І(?:оанна|вана)|(?:[ИЙ]оан(?:ово)?)|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana))|Jana)|I(?:vanova[\s\xa0]*Poslanica|oan|n)|J(?:a(?:[au]n|n(?:o(?:s|va?)|[uů]v|a)?)|h(?:[ho]n|n)?|phn|o(?:phn|[aã]o|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s)|[mn])?)?|ean|áno[sv]|n|u[au]n|óh)?|list[\s\xa0]*Jan[uů]v)))|۲(?:-?یُوحنّا|[\s\xa0]*ی(?:ُوحنّا|وحنّا)|۔یوحنا)|二ヨハネ|An(?:nað[\s\xa0]*(?:br[eé]f[\s\xa0]*J(?:[oó]hannesar)|J[oó]hannesarbr(?:[eé]f))|d(?:e(?:t[\s\xa0]*Johannesbrev|n[\s\xa0]*Joh(?:annes(?:brev)?)?)|r(?:a[\s\xa0]*Johannesbrevet|e[\s\xa0]*Joh(?:annes)?)))|யோவ(?:ன்[\s\xa0]*எழுதிய[\s\xa0]*இரண்டாவது[\s\xa0]*நிருபம்|ான்[\s\xa0]*(?:எழுதிய[\s\xa0]*இரண்டாம்[\s\xa0]*(?:திருமுகம்|கடிதம்)|இரண்டாம்[\s\xa0]*திருமுகம்))|Y(?:ōva[nṉ][\s\xa0]*E(?:[lḻ]utiya[\s\xa0]*Ira(?:[nṇ](?:[tṭ](?:[aā]vatu[\s\xa0]*Nirupam))))|o(?:va[nṉ][\s\xa0]*E(?:[lḻ]utiya[\s\xa0]*Ira(?:[nṇ](?:[tṭ](?:[aā]vatu[\s\xa0]*Nirupam))))|oxanaa[\s\xa0]*Labaad|hane[\s\xa0]*II))|Послання[\s\xa0]*до[\s\xa0]*Тита|2(?:e(?:me(?:\.[\s\xa0]*Jean|[\s\xa0]*Jean)|\.[\s\xa0]*J(?:ean|oh(?:annes)?)|[\s\xa0]*J(?:ean|oh(?:annes)?))|°(?:\.[\s\xa0]*Giovanni|[\s\xa0]*Giovanni)|[\s\xa0]*(?:ย(?:อห์น|น)|y(?:oh[aā]n(?:[aā]ce[mṃ])|uhann[aā]ko|ūh(?:ann[aā]ko|ãnā))|அருளப்பர்|San[\s\xa0]*J[au](?:[au]n)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Јован|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|и(?:ца[\s\xa0]*Јованова|е[\s\xa0]*(?:на[\s\xa0]*апостол[\s\xa0]*Јован|Иоанна))))|G(?:i(?:o(?:vanni|an)|ăng)?|j(?:onit)?|v)|I(?:oan(?:nis)?|n|v(?:anova[\s\xa0]*Poslanica)?)|соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|Послання[\s\xa0]*Івана|யோ(?:வா(?:ன்)?)?|ی(?:ُوحنّا|وحنّا)|(?:[ei](?:\.[\s\xa0]*Gjonit|[\s\xa0]*Gjonit))|И(?:о(?:хана|ан(?:ово|на)?)|н)|ଯୋହନଙ|І(?:оанна|в(?:ана)?)|J(?:a(?:[au]n|n(?:o(?:s|va?)|[uů]v|a)?)|o(?:phn|[aã]o|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s(?:brev(?:et)?)?)|[mn])?)?|h(?:[ho]n|n)?|phn|ean|áno[sv]|n|u[au]n|óh)?|k(?:\.[\s\xa0]*J[aá]nov|[\s\xa0]*J[aá]nov)|ਯੂਹੰਨਾ|Йоан(?:ово)?|Y(?:ōva[nṉ]|o(?:kanan|va[nṉ]|o(?:hanna|x(?:anaa)?)|h(?:an(?:a|es?))?))|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana))|Jana)|Ј(?:ован(?:ов[ао])?|н)|य(?:ुहत्रा|ूहन्ना(?:को)?|ोहान(?:ाच)?)|يو|list[\s\xa0]*Jan[uů]v)|(?:[яе](?:\.[\s\xa0]*(?:послание[\s\xa0]*Иоанна|Ио(?:анна|хана))|[\s\xa0]*(?:послание[\s\xa0]*Иоанна|Ио(?:анна|хана))))|a(?:\.[\s\xa0]*Jo[aã]o|[\s\xa0]*Jo[aã]o)|요한|John|d(?:\.[\s\xa0]*Jean|e(?:\.[\s\xa0]*Jean|[\s\xa0]*Jean)|[\s\xa0]*Jean)|nd(?:\.[\s\xa0]*J(?:phn|h(?:[ho]n|n)?|n|o(?:phn|nh|on|h[mn]?)?)|[\s\xa0]*J(?:phn|h(?:[ho]n|n)?|n|o(?:phn|nh|on|h[mn]?)?))|۔یوحنا|º(?:\.[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n)))|o(?:\.[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J(?:[au](?:[au]n)|o[aã]o))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J(?:[au](?:[au]n)|o[aã]o)))|ème(?:\.[\s\xa0]*Jean|[\s\xa0]*Jean)|\.(?:-?یُوحنّا|[oº](?:\.[\s\xa0]*(?:San[\s\xa0]*J(?:[au](?:[au]n)|J[au](?:[au]n))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n))))|۔یوحنا|[\s\xa0]*(?:Јован(?:ов[ао])?|San[\s\xa0]*J[au](?:[au]n)|G(?:jonit|i(?:o(?:vanni|an)|ăng)?)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Јован|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|и(?:ца[\s\xa0]*Јованова|е[\s\xa0]*(?:на[\s\xa0]*апостол[\s\xa0]*Јован|Иоанна))))|ยอห์น|Yo(?:kanan|o(?:hanna|x(?:anaa)?)|h(?:an(?:a|es?))?)|соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|Послання[\s\xa0]*Івана|I(?:vanova[\s\xa0]*Poslanica|oan(?:nis)?|n)|य(?:ुहत्रा|ूहन्ना(?:को)?)|ی(?:ُوحنّا|وحنّا)|ଯୋହନଙ|J(?:a(?:[au]n|n(?:o(?:s|va?)|[uů]v|a)?)|o(?:phn|[aã]o|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s(?:brev(?:et)?)?)|[mn])?)?|h(?:[ho]n|n)?|phn|ean|áno[sv]|n|u[au]n|óh)?|І(?:оанна|вана)|Ио(?:хана|ан(?:ово|на)?)|Йоан(?:ово)?|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana))|Jana)|list[\s\xa0]*Jan[uů]v|y[uū]hann(?:[aā]ko)))|-?(?:ге(?:\.[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послання[\s\xa0]*апостола[\s\xa0]*Івана|Послання[\s\xa0]*Івана|[ИЙ]оаново|І(?:оанна|вана))|[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послання[\s\xa0]*апостола[\s\xa0]*Івана|Послання[\s\xa0]*Івана|[ИЙ]оаново|І(?:оанна|вана)))|я(?:\.[\s\xa0]*(?:послание[\s\xa0]*Иоанна|Ио(?:анна|хана))|[\s\xa0]*(?:послание[\s\xa0]*Иоанна|Ио(?:анна|хана)))|а(?:\.[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послання[\s\xa0]*апостола[\s\xa0]*Івана|Послання[\s\xa0]*Івана|[ИЙ]оаново|І(?:оанна|вана))|[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послання[\s\xa0]*апостола[\s\xa0]*Івана|Послання[\s\xa0]*Івана|[ИЙ]оаново|І(?:оанна|вана)))|е(?:\.[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|ие[\s\xa0]*Иоанна)|Послання[\s\xa0]*Івана|Йоаново|Ио(?:ан(?:ово|на)|хана)|І(?:оанна|вана))|[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|ие[\s\xa0]*Иоанна)|Послання[\s\xa0]*Івана|Йоаново|Ио(?:ан(?:ово|на)|хана)|І(?:оанна|вана)))|یُوحنّا))|D(?:e(?:uxi(?:[eè]me(?:s[\s\xa0]*Jean|[\s\xa0]*Jean))|zy[eè]m[\s\xa0]*Jan)|ru(?:g(?:a[\s\xa0]*(?:Ivanova[\s\xa0]*Poslanica|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana))|Jana)|Jana)|i[\s\xa0]*(?:List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana))|Jana)|Jana))|h(?:e[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Ivana|[aá][\s\xa0]*(?:kniha[\s\xa0]*J(?:[aá]nov|list[\s\xa0]*Jan[uů]v|J(?:ánov|an(?:ova?|[uů]v)?)?))|[yý][\s\xa0]*(?:list[\s\xa0]*J(?:an(?:[ouů]v|ánov)|J(?:ánov[\s\xa0]*list|an(?:ov(?:[\s\xa0]*list|a)|[uů]v)?)?)))))|J(?:ohannes(?:'[\s\xa0]*Andet[\s\xa0]*Brev|’[\s\xa0]*(?:Andet[\s\xa0]*Brev|andre[\s\xa0]*brev)|[\s\xa0]*andra[\s\xa0]*brev)|[aá]nos[\s\xa0]*II)|Pili[\s\xa0]*Yoh(?:an[ae])?|《(?:伊望第二》|若望二書》|約(?:翰[二貳]書》|貳》)|约(?:翰[二贰]书》|贰》))|א(?:גרתו[\s\xa0]*השנייה[\s\xa0]*של[\s\xa0]*יוחנן[\s\xa0]*השליח|יגרת[\s\xa0]*יוחנן[\s\xa0]*השנייה)|요한(?:의[\s\xa0]*둘째[\s\xa0]*서간|[2이]서)|ヨハネ(?:の(?:第二の(?:手紙|書)|手紙二)|[\s\xa0]*2))|(?:2\.[oº](?:\.[\s\xa0]*J(?:[au](?:[au]n)|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n))))|Druh(?:[aá][\s\xa0]*(?:list[\s\xa0]*Jan(?:[uů]v|J(?:ánov|an(?:ova?|[uů]v)?)?))|(?:[yý][\s\xa0]*(?:list[\s\xa0]*Jánov|J(?:ánov[\s\xa0]*list|an(?:ov(?:[\s\xa0]*list|a)|[uů]v)?)?))))|(?:2\.[oº][\s\xa0]*(?:San[\s\xa0]*J(?:[au](?:[au]n)|J[au](?:[au]n)))|Druh(?:[aá][\s\xa0]*J(?:ánov|an(?:ova?|[uů]v)?)?))|2\.[oº][\s\xa0]*J(?:[au](?:[au]n))|(?:يوحنا[\s\xa0]*الثانية|《(?:伊望第二|若望二書|約(?:翰[貳二]書|貳)|约(?:翰[二贰]书|贰))|2(?:\.[\s\xa0]*(?:Johanneksen|Ivanova)|[\s\xa0]*(?:Johanneksen|Ivanova))|I(?:oannis[\s\xa0]*II|I(?:\.[\s\xa0]*(?:Johanneksen|Ivanova)|[\s\xa0]*(?:Johanneksen|I(?:vanova|oannis))))|Dru(?:ga[\s\xa0]*Ivanova(?:[\s\xa0]*poslanica)?|h[ýy][\s\xa0]*J(?:[áa]nov))|伊望第二》?|Toinen[\s\xa0]*Johanneksen|若望二書》?|约(?:翰[贰二]书》?|贰》?)|約(?:翰[貳二]書》?|貳》?)))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["3John"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])((?:א(?:גרתו[\s\xa0]*השלישית[\s\xa0]*של[\s\xa0]*יוחנן[\s\xa0]*השלי|יגרת[\s\xa0]*יוחנן[\s\xa0]*השלישית)|T(?:er(?:z(?:a[\s\xa0]*(?:lettera[\s\xa0]*di[\s\xa0]*Giovanni|Giovanni)|o[\s\xa0]*Giovanni)|ce(?:ir[ao][\s\xa0]*Jo(?:[aã]o)|r(?:o[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n)))))|atu[\s\xa0]*Yoh(?:an[ae])?|hird[\s\xa0]*J(?:phn|h(?:[ho]n|n)?|n|o(?:phn|nh|on|h[mn]?)?)|r(?:oisi(?:[eè]me(?:s[\s\xa0]*Jean|[\s\xa0]*Jean))|zeci(?:a[\s\xa0]*(?:List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana))|Jana)|Jana)|[\s\xa0]*(?:List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana))|Jana)|Jana))|e(?:[cæć]a[\s\xa0]*Ivanova[\s\xa0]*Poslanica|dje[\s\xa0]*Joh(?:annes(?:brev(?:et)?)?)?|t(?:je[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Ivana|i(?:a[\s\xa0]*(?:kniha[\s\xa0]*J[aá]nov|J[aá]nov)|[\s\xa0]*(?:list[\s\xa0]*Jan[uů]v|J(?:ánov[\s\xa0]*list|an(?:ov(?:[\s\xa0]*list|a)|[uů]v)?)?))|í[\s\xa0]*(?:list[\s\xa0]*Jan[uů]v|J(?:ánov[\s\xa0]*list|an(?:ov(?:[\s\xa0]*list|a)|[uů]v)?)?))))|řet[ií][\s\xa0]*(?:list[\s\xa0]*Jan(?:[uů]v|J(?:an(?:ova|[uů]v)?)?)))|Y(?:ōva[nṉ][\s\xa0]*E(?:[lḻ]utiya[\s\xa0]*M(?:[uū](?:[nṉ](?:[rṛ](?:[aā]vatu[\s\xa0]*Nirupam)))))|o(?:va[nṉ][\s\xa0]*E(?:[lḻ]utiya[\s\xa0]*M(?:[uū](?:[nṉ](?:[rṛ](?:[aā]vatu[\s\xa0]*Nirupam)))))|oxanaa[\s\xa0]*Saddexaad|hane[\s\xa0]*III))|ਯੂਹੰਨਾ[\s\xa0]*ਦੀ[\s\xa0]*ਤੀਜੀ[\s\xa0]*ਪੱਤ੍ਰੀ|Waraka[\s\xa0]*wa[\s\xa0]*Tatu[\s\xa0]*wa[\s\xa0]*Yohane|Ιω[άα]ννου[\s\xa0]*Γ['ʹʹ΄’]|I(?:katlong[\s\xa0]*Juan|II(?:\.[\s\xa0]*(?:Gi(?:o(?:vanni|an)|ăng)?|Јован(?:ов[ао])?|San[\s\xa0]*J[au](?:[au]n)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Јован|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|и(?:е[\s\xa0]*на[\s\xa0]*апостол[\s\xa0]*Јован|ца[\s\xa0]*Јованова)))|соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|Послання[\s\xa0]*Івана|I(?:vanova[\s\xa0]*Poslanica|oan(?:nis)?|n)|Yo(?:kanan|ox(?:anaa)?|h(?:an(?:a|es?))?)|І(?:оанна|вана)|(?:[ИЙ]оан(?:ово)?)|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana))|Jana)|J(?:a(?:[au]n|n(?:o(?:s|va?)|[uů]v|a)?)|h(?:[ho]n|n)?|phn|o(?:phn|[aã]o|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s)|[mn])?)?|ean|áno[sv]|n|u[au]n|óh)?|list[\s\xa0]*Jan[uů]v)|[\s\xa0]*(?:Gi(?:o(?:vanni|an)|ăng)?|Јован(?:ов[ао])?|San[\s\xa0]*J[au](?:[au]n)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Јован|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|и(?:е[\s\xa0]*на[\s\xa0]*апостол[\s\xa0]*Јован|ца[\s\xa0]*Јованова)))|соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|Послання[\s\xa0]*Івана|Yo(?:kanan|ox(?:anaa)?|h(?:an(?:a|es?))?)|І(?:оанна|вана)|(?:[ИЙ]оан(?:ово)?)|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana))|Jana)|I(?:vanova[\s\xa0]*Poslanica|oan|n)|J(?:a(?:[au]n|n(?:o(?:s|va?)|[uů]v|a)?)|h(?:[ho]n|n)?|phn|o(?:phn|[aã]o|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s)|[mn])?)?|ean|áno[sv]|n|u[au]n|óh)?|list[\s\xa0]*Jan[uů]v)))|य(?:ूहन्नाको[\s\xa0]*तेस्(?:त्रो[\s\xa0]*पत्र|रो[\s\xa0]*पत्र)|ोहानाचें[\s\xa0]*तिसरे[\s\xa0]*पत्र)|Γ(?:['ʹʹ΄’][\s\xa0]*(?:᾿Ιω|Ιω(?:[άα]ννη)?))|J(?:ohannes(?:[\s\xa0]*tredje[\s\xa0]*brev|(?:['’][\s\xa0]*(?:Tredje[\s\xa0]*Brev|3(?:\.[\s\xa0]*Brev|[\s\xa0]*Brev))))|[aá]nos[\s\xa0]*III)|3(?:°(?:\.[\s\xa0]*Giovanni|[\s\xa0]*Giovanni)|[\s\xa0]*(?:ย(?:อห์น|น)|y(?:oh[aā]n(?:[aā]ce[mṃ])|uhann[aā]ko|ūh(?:ann[aā]ko|ãnā))|அருளப்பர்|San[\s\xa0]*J[au](?:[au]n)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Јован|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|и(?:ца[\s\xa0]*Јованова|е[\s\xa0]*(?:на[\s\xa0]*апостол[\s\xa0]*Јован|Иоанна))))|G(?:i(?:o(?:vanni|an)|ăng)?|j(?:onit)?|v)|I(?:oan(?:nis)?|n|v(?:anova[\s\xa0]*Poslanica)?)|соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|Послання[\s\xa0]*Івана|யோ(?:வா(?:ன்)?)?|ی(?:ُوحنّا|وحنّا)|(?:[ei](?:\.[\s\xa0]*Gjonit|[\s\xa0]*Gjonit))|И(?:о(?:хана|ан(?:ово|на)?)|н)|ଯୋହନଙ|І(?:оанна|в(?:ана)?)|J(?:a(?:[au]n|n(?:o(?:s|va?)|[uů]v|a)?)|o(?:phn|[aã]o|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s(?:brev(?:et)?)?)|[mn])?)?|h(?:[ho]n|n)?|phn|ean|áno[sv]|n|u[au]n|óh)?|k(?:\.[\s\xa0]*J[aá]nov|[\s\xa0]*J[aá]nov)|ਯੂਹੰਨਾ|Йоан(?:ово)?|Y(?:ōva[nṉ]|o(?:kanan|va[nṉ]|o(?:hanna|x(?:anaa)?)|h(?:an(?:a|es?))?))|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana))|Jana)|Ј(?:ован(?:ов[ао])?|н)|य(?:ुहत्रा|ूहन्ना(?:को)?|ोहान(?:ाच)?)|يو|list[\s\xa0]*Jan[uů]v)|(?:[яе](?:\.[\s\xa0]*(?:послание[\s\xa0]*Иоанна|Ио(?:анна|хана))|[\s\xa0]*(?:послание[\s\xa0]*Иоанна|Ио(?:анна|хана))))|-?(?:тє(?:\.[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послання[\s\xa0]*апостола[\s\xa0]*Івана|Послання[\s\xa0]*Івана|[ИЙ]оаново|І(?:оанна|вана))|[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послання[\s\xa0]*апостола[\s\xa0]*Івана|Послання[\s\xa0]*Івана|[ИЙ]оаново|І(?:оанна|вана)))|я(?:\.[\s\xa0]*(?:послание[\s\xa0]*Иоанна|Ио(?:анна|хана))|[\s\xa0]*(?:послание[\s\xa0]*Иоанна|Ио(?:анна|хана)))|а(?:\.[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послання[\s\xa0]*апостола[\s\xa0]*Івана|Послання[\s\xa0]*Івана|[ИЙ]оаново|І(?:оанна|вана))|[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послання[\s\xa0]*апостола[\s\xa0]*Івана|Послання[\s\xa0]*Івана|[ИЙ]оаново|І(?:оанна|вана)))|е(?:\.[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|ие[\s\xa0]*Иоанна)|Послання[\s\xa0]*Івана|Йоаново|Ио(?:ан(?:ово|на)|хана)|І(?:оанна|вана))|[\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|ие[\s\xa0]*Иоанна)|Послання[\s\xa0]*Івана|Йоаново|Ио(?:ан(?:ово|на)|хана)|І(?:оанна|вана)))|یُوحنّا)|a(?:\.[\s\xa0]*Jo[aã]o|[\s\xa0]*Jo[aã]o)|요한|John|rd(?:\.[\s\xa0]*J(?:phn|h(?:[ho]n|n)?|n|o(?:phn|nh|on|h[mn]?)?)|[\s\xa0]*J(?:phn|h(?:[ho]n|n)?|n|o(?:phn|nh|on|h[mn]?)?))|۔یوحنا|º(?:\.[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n)))|o(?:\.[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J(?:[au](?:[au]n)|o[aã]o))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J(?:[au](?:[au]n)|o[aã]o)))|ème(?:\.[\s\xa0]*Jean|[\s\xa0]*Jean)|e(?:me(?:\.[\s\xa0]*Jean|[\s\xa0]*Jean)|\.[\s\xa0]*J(?:ean|oh(?:annes(?:brevet)?)?)|[\s\xa0]*J(?:ean|oh(?:annes(?:brevet)?)?))|\.(?:-?یُوحنّا|[oº](?:\.[\s\xa0]*(?:San[\s\xa0]*J(?:[au](?:[au]n)|J[au](?:[au]n))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n))))|۔یوحنا|[\s\xa0]*(?:Јован(?:ов[ао])?|San[\s\xa0]*J[au](?:[au]n)|G(?:jonit|i(?:o(?:vanni|an)|ăng)?)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Јован|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Івана|и(?:ца[\s\xa0]*Јованова|е[\s\xa0]*(?:на[\s\xa0]*апостол[\s\xa0]*Јован|Иоанна))))|ยอห์น|Yo(?:kanan|o(?:hanna|x(?:anaa)?)|h(?:an(?:a|es?))?)|соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|Послання[\s\xa0]*Івана|I(?:vanova[\s\xa0]*Poslanica|oan(?:nis)?|n)|य(?:ुहत्रा|ूहन्ना(?:को)?)|யோவான்|ی(?:ُوحنّا|وحنّا)|ଯୋହନଙ|J(?:a(?:[au]n|n(?:o(?:s|va?)|[uů]v|a)?)|o(?:phn|[aã]o|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s(?:brev(?:et)?)?)|[mn])?)?|h(?:[ho]n|n)?|phn|ean|áno[sv]|n|u[au]n|óh)?|І(?:оанна|вана)|Ио(?:хана|ан(?:ово|на)?)|Йоан(?:ово)?|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana))|Jana)|list[\s\xa0]*Jan[uů]v|y[uū]hann(?:[aā]ko))))|யோவ(?:ன்[\s\xa0]*எழுதிய[\s\xa0]*மூன்றாவது[\s\xa0]*நிருபம்|ான்[\s\xa0]*(?:எழுதிய[\s\xa0]*ம(?:ுன்றாம்[\s\xa0]*திருமுகம்|ூன்றாம்[\s\xa0]*கடிதம்)|மூன்றாம்[\s\xa0]*திருமுகம்))|요한(?:의[\s\xa0]*셋째[\s\xa0]*서간|[3삼]서)|تیسرا(?:-?یُوحنّا|[\s\xa0]*ی(?:ُوحنّا|وحنّا)|۔یوحنا)|Þriðja[\s\xa0]*(?:br[eé]f[\s\xa0]*J(?:[oó]hannesar)|J[oó]hannesarbr(?:[eé]f))|Barua[\s\xa0]*ya[\s\xa0]*Tatu[\s\xa0]*ya[\s\xa0]*Yohane|Тре(?:ћ(?:ом[\s\xa0]*(?:посланица[\s\xa0]*Јованова|Јованова)|а[\s\xa0]*(?:посланица[\s\xa0]*Јованова|Јованова))|т(?:а[\s\xa0]*(?:п(?:ослание[\s\xa0]*на[\s\xa0]*апостол[\s\xa0]*Јован|исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Јован)|Јован(?:ово)?)|(?:[яє][\s\xa0]*(?:соборне[\s\xa0]*послання[\s\xa0]*св(?:\.[\s\xa0]*апостола[\s\xa0]*Іоанна|[\s\xa0]*апостола[\s\xa0]*Іоанна)|послання[\s\xa0]*апостола[\s\xa0]*Івана|Послання[\s\xa0]*Івана|[ИЙ]оаново|І(?:оанна|вана)))|о[\s\xa0]*(?:съборно[\s\xa0]*послание[\s\xa0]*на[\s\xa0]*св(?:\.[\s\xa0]*ап(?:\.[\s\xa0]*Иоана[\s\xa0]*Богослова|[\s\xa0]*Иоана[\s\xa0]*Богослова)|[\s\xa0]*ап(?:\.[\s\xa0]*Иоана[\s\xa0]*Богослова|[\s\xa0]*Иоана[\s\xa0]*Богослова))|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Јован|ослание[\s\xa0]*на[\s\xa0]*(?:апостол[\s\xa0]*Јован|[ИЙ]оан))|Јован(?:ово)?|(?:[ИЙ]оан(?:ово)?))))|۳(?:-?یُوحنّا|[\s\xa0]*ی(?:ُوحنّا|وحنّا)|۔یوحنا)|M[uū](?:[nṉ](?:[rṛ](?:[aā]vatu[\s\xa0]*யோவான்)))|Epistula[\s\xa0]*I(?:II[\s\xa0]*Ioannis|oannis[\s\xa0]*III)|ଯୋହନଙ୍କ[\s\xa0]*ତୃତୀୟ[\s\xa0]*ପତ୍ର|三ヨハネ|ତୃତୀୟ[\s\xa0]*ଯୋହନଙ|D(?:ritte[\s\xa0]*Johannes|erde[\s\xa0]*Joh(?:annes)?)|ம(?:ூன்றாவது[\s\xa0]*யோவான்|ுன்றாம்[\s\xa0]*யோவான்)|ヨハネ(?:の(?:第三の(?:手紙|書)|手紙三)|[\s\xa0]*3)|y(?:uhann[aā]ko[\s\xa0]*testro[\s\xa0]*patra|oh[aā]n(?:[aā]ce(?:[mṃ][\s\xa0]*tisre[\s\xa0]*patra))|ū(?:ḥannā[\s\xa0]*kā[\s\xa0]*tīsrā[\s\xa0]*ʿām[\s\xa0]*ḫaṭ|h(?:ann[aā]ko[\s\xa0]*testro[\s\xa0]*patra|ãnā[\s\xa0]*dī[\s\xa0]*tījī[\s\xa0]*pattrī)))|رسالة[\s\xa0]*(?:القديس[\s\xa0]*يوحنا[\s\xa0]*الثالثة|يوحنا[\s\xa0]*(?:الثالثة|3))|《(?:伊望第三》|若望三書》|約(?:翰[三參]書》|三》)|约(?:翰[三叁]书》|三》))|ی(?:ُوحنّا[\s\xa0]*کا[\s\xa0]*تیسرا[\s\xa0]*عام[\s\xa0]*خط|وحن(?:ا[\s\xa0]*کا[\s\xa0]*تیسرا[\s\xa0]*عام[\s\xa0]*خط|ّا[\s\xa0]*کا[\s\xa0]*(?:تیسرا[\s\xa0]*خط|3(?:\.[\s\xa0]*خط|[\s\xa0]*خط)|۳[\s\xa0]*خط)))|Kolmas[\s\xa0]*Johanneksen[\s\xa0]*kirje|Harmadik[\s\xa0]*J(?:[aá]nos|n))|(?:3\.[oº](?:\.[\s\xa0]*J(?:[au](?:[au]n)|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n))))|Třet(?:[ií][\s\xa0]*J(?:an(?:ova|[uů]v)?)?))|3\.[oº][\s\xa0]*(?:San[\s\xa0]*J(?:[au](?:[au]n)|J[au](?:[au]n)))|3\.[oº][\s\xa0]*J(?:[au](?:[au]n))|(?:Kolmas[\s\xa0]*Johanneksen|3(?:\.[\s\xa0]*(?:Johanneksen|Ivanova)|[\s\xa0]*(?:Johanneksen|Ivanova))|伊望第三》?|约(?:翰[叁三]书》?|三》?)|《(?:若望三書|伊望第三|約(?:翰[參三]書|三)|约(?:翰[三叁]书|三))|Johannes’[\s\xa0]*tredje[\s\xa0]*brev|約(?:翰[參三]書》?|三》?)|若望三書》?|I(?:II(?:\.[\s\xa0]*(?:Johanneksen|Ivanova)|[\s\xa0]*(?:Johanneksen|I(?:oannis|vanova)))|oannis[\s\xa0]*III)|يوحنا[\s\xa0]*الثالثة|Tre(?:(?:[ćcæ]a[\s\xa0]*Ivanova(?:[\s\xa0]*poslanica)?)|t[íi][\s\xa0]*J(?:[aá]nov))))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["John"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(y(?:oh[aā]n(?:[aā]ne[\\s\\xa0]*lihilele[\\s\\xa0]*(?:[sŝ]ubʰavartam(?:[aā]n)))|uhannale[\\s\\xa0]*lekʰeko[\\s\\xa0]*susm[aā]c(?:[aā]r))|(?:யோவா(?:ன்[\\s\\xa0]*(?:எழுதிய[\\s\\xa0]*(?:சுவிசேஷம்|நற்செய்தி)|நற்செய்தி))?|הבשורה[\\s\\xa0]*על[\\s\\xa0\\-?]*פי[\\s\\xa0]*יוחנן|ヨハネ(?:による福音書|傳福音書|福音書|伝)|Sulat[\\s\\xa0]*ni[\\s\\xa0]*San[\\s\\xa0]*Juan|요한(?:[\\s\\xa0]*복음서?|복음서?)|J(?:ano(?:vo[\\s\\xa0]*evangelium|s)|e(?:van(?:helije[\\s\\xa0]*vid[\\s\\xa0]*Ivana|đelje[\\s\\xa0]*po[\\s\\xa0]*Ivanu)|an)|o(?:hann(?:is[\\s\\xa0]*evangelium|e(?:ksen[\\s\\xa0]*evankeliumi|s(?:arguðspjall|evangeliet)))|[aã]o)|án(?:os)?|óh(?:annesarguðspjall)?)|Євангелі(?:я[\\s\\xa0]*від[\\s\\xa0]*(?:св(?:\\.[\\s\\xa0]*Івана|[\\s\\xa0]*Івана)|Івана)|є[\\s\\xa0]*від[\\s\\xa0]*(?:св(?:\\.[\\s\\xa0]*[ИЙ]оана|[\\s\\xa0]*[ИЙ]оана)|Івана))|Еван(?:ђеље[\\s\\xa0]*по[\\s\\xa0]*Јовану|гелие(?:то[\\s\\xa0]*според[\\s\\xa0]*Јован|[\\s\\xa0]*(?:според[\\s\\xa0]*Јован|от[\\s\\xa0]*(?:Иоан(?:на)?|Йоан))))|y(?:uhannāle[\\s\\xa0]*lekʰeko[\\s\\xa0]*susm[aā]c(?:[aā]r)|ū(?:ḥannā[\\s\\xa0]*kī[\\s\\xa0]*injīl|h(?:ann[aā]le[\\s\\xa0]*lekʰeko[\\s\\xa0]*susm(?:[aā]c(?:[aā]r))|ãnā[\\s\\xa0]*dī[\\s\\xa0]*ĩjīl)))|E(?:banghelyo[\\s\\xa0]*(?:ayon[\\s\\xa0]*kay[\\s\\xa0]*(?:San[\\s\\xa0]*Juan|Juan)|ni[\\s\\xa0]*San[\\s\\xa0]*Juan)|l[\\s\\xa0]*Evangelio[\\s\\xa0]*de[\\s\\xa0]*J[au](?:[au]n)|van(?:keliumi[\\s\\xa0]*Johanneksen[\\s\\xa0]*mukaan|geli(?:e(?:[\\s\\xa0]*volgens[\\s\\xa0]*Johannes|t[\\s\\xa0]*etter[\\s\\xa0]*Johannes)|um[\\s\\xa0]*(?:secundum[\\s\\xa0]*Ioannem|podle[\\s\\xa0]*Jana))|jelium[\\s\\xa0]*Pod[lľ]a[\\s\\xa0]*J(?:[aá]na)|[ðđ]elje[\\s\\xa0]*po[\\s\\xa0]*Ivanu)|w(?:angelia[\\s\\xa0]*(?:w(?:edług[\\s\\xa0]*(?:[sś]w(?:\\.[\\s\\xa0]*Jana|[\\s\\xa0]*Jana))|g[\\s\\xa0]*(?:[sś]w(?:\\.[\\s\\xa0]*Jana|[\\s\\xa0]*Jana)))|Jana)|\\.[\\s\\xa0]*Jana|[\\s\\xa0]*Jana?))|พระวรสารนักบุญจอห์น|Ιω(?:[άα]ν(?:νης)?)?|ย(?:อห์น|[นฮ])|அருளப்பர்[\\s\\xa0]*நற்செய்தி|Vangelo[\\s\\xa0]*di[\\s\\xa0]*(?:San[\\s\\xa0]*Giovanni|Giovanni)|य(?:हून्ना|ुह(?:त्रा|न्ना)|ूह(?:ान्ना|न(?:्ना(?:ले[\\s\\xa0]*लेखेको[\\s\\xa0]*सुसमाचार|को[\\s\\xa0]*सुसमाचार)?|ा))|ोहान(?:ाने[\\s\\xa0]*लिहिलेले[\\s\\xa0]*शुभवर्तमान)?)|ی(?:ُوحنّا[\\s\\xa0]*کی[\\s\\xa0]*انجیل|وحنا[\\s\\xa0]*کی[\\s\\xa0]*انجیل)|Κατ[άα][\\s\\xa0]*Ιω(?:[άα]ννην)|إنجيل[\\s\\xa0]*يوحنا|ଯୋହନ[\\s\\xa0]*ଲିଖିତ[\\s\\xa0]*ସୁସମାଗ୍ଭର|G(?:jo(?:ni)?|[gv]|i(?:oan|ăng)?)|І[вн]|Y(?:ōv[aā](?:[nṉ][\\s\\xa0]*Na(?:[rṛ]ceyti))|uhanna|o(?:v[aā](?:[nṉ][\\s\\xa0]*Na(?:[rṛ]ceyti))|kanan|ox(?:anaa)?|h))|ਯੂਹ(?:ੰਨਾ[\\s\\xa0]*ਦੀ[\\s\\xa0]*ਇੰਜੀਲ|ਾਂਨਾ)|Ungjilli[\\s\\xa0]*i[\\s\\xa0]*Gjonit|И(?:охан|н)|I(?:njil(?:i[\\s\\xa0]*ya[\\s\\xa0]*Yohan[ae]|[\\s\\xa0]*Yohanes)|oan(?:nes)?|van)|《(?:若望福音》|伊望》|(?:[約约](?:翰福音》|》)))|Ј(?:еванђеље[\\s\\xa0]*по[\\s\\xa0]*Јовану|н)|От[\\s\\xa0]*Иоана[\\s\\xa0]*свето[\\s\\xa0]*Евангелие|The[\\s\\xa0]*Gospel[\\s\\xa0]*(?:according[\\s\\xa0]*to[\\s\\xa0]*(?:S(?:aint[\\s\\xa0]*J(?:phn|o(?:phn|nh|on|h[mn]?)|h(?:[ho]n|n)?|n)|t(?:\\.[\\s\\xa0]*J(?:phn|o(?:phn|nh|on|h[mn]?)|h(?:[ho]n|n)?|n)|[\\s\\xa0]*J(?:phn|o(?:phn|nh|on|h[mn]?)|h(?:[ho]n|n)?|n)))|J(?:phn|o(?:phn|nh|on|h[mn]?)|h(?:[ho]n|n)?|n))|of[\\s\\xa0]*(?:S(?:aint[\\s\\xa0]*J(?:phn|o(?:phn|nh|on|h[mn]?)|h(?:[ho]n|n)?|n)|t(?:\\.[\\s\\xa0]*J(?:phn|o(?:phn|nh|on|h[mn]?)|h(?:[ho]n|n)?|n)|[\\s\\xa0]*J(?:phn|o(?:phn|nh|on|h[mn]?)|h(?:[ho]n|n)?|n)))|J(?:phn|o(?:phn|nh|on|h[mn]?)|h(?:[ho]n|n)?|n)))|Mabuting[\\s\\xa0]*Balita[\\s\\xa0]*ayon[\\s\\xa0]*kay[\\s\\xa0]*(?:San[\\s\\xa0]*Juan|Juan)|يو|Ἰω)|Иоана|yohanane|(?:《(?:若望福音|伊望|(?:[約约](?:翰福音)?))|G(?:ospel[\\s\\xa0]*(?:according[\\s\\xa0]*to[\\s\\xa0]*(?:S(?:aint[\\s\\xa0]*J(?:phn|o(?:phn|nh|on|h[nm]?)|h(?:[oh]n|n)?|n)|t(?:\\.[\\s\\xa0]*J(?:phn|o(?:phn|nh|on|h[mn]?)|h(?:[oh]n|n)?|n)|[\\s\\xa0]*J(?:phn|o(?:phn|on|nh|h[mn]?)|h(?:[ho]n|n)?|n)))|J(?:phn|o(?:phn|on|nh|h[mn]?)|n|h(?:[ho]n|n)?))|of[\\s\\xa0]*(?:S(?:aint[\\s\\xa0]*J(?:phn|o(?:phn|nh|on|h[mn]?)|n|h(?:[ho]n|n)?)|t(?:\\.[\\s\\xa0]*J(?:phn|o(?:phn|nh|on|h[mn]?)|h(?:[ho]n|n)?|n)|[\\s\\xa0]*J(?:phn|o(?:phn|on|nh|h[nm]?)|h(?:[oh]n|n)?|n)))|J(?:phn|o(?:phn|on|nh|h[mn]?)|n|h(?:[oh]n|n)?)))|iovanni)|Йоана?|若望福音》|J(?:ohanne(?:ksen|s)|uun|ána|a(?:[ua]n|na))|Јован|Иоан|யோவான்|Y(?:o(?:han(?:a|es?)|v[āa][ṉn])|ōv[aā][nṉ])|يوحنا|ی(?:ُوحنّا|وحنا)|요한|(?:[約约](?:翰福音》|》))|От[\\s\\xa0]*Иоан(?:на|а)|Від[\\s\\xa0]*Івана|ਯੂਹੰਨਾ|य(?:ूहन्नाले|ोहानाने)|伊望》|y(?:uhann[āa]le|oh(?:anāne|ān[aā]ne)|ūh(?:ann[āa]le|ãnā))|ଯୋହନ|San[\\s\\xa0]*Juan)|(?:Івана|S(?:aint[\\s\\xa0]*J(?:phn|o(?:phn|nh|on|h[nm]?)|h(?:[oh]n|n)?|n)|t(?:\\.[\\s\\xa0]*J(?:phn|o(?:phn|on|nh|h[nm]?)|n|h(?:[oh]n|n)?)|[\\s\\xa0]*J(?:phn|o(?:phn|nh|on|h[nm]?)|n|h(?:[ho]n|n)?)))|約翰福音|若望福音|伊望|J(?:phn|uan|o(?:phn|on|nh|h[mn]?)|h(?:[oh]n|n)?|n)|约(?:翰福音)?))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Josh"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:ya(?:ho(?:s(?:[uū]ko[\\s\\xa0]*pustak|aw[aā])|ŝaw[aā]|š(?:ūko[\\s\\xa0]*pustak|u(?:ko[\\s\\xa0]*pustak|ā)))|šūʿ)|ਯਹੋਸ਼ੁਆ|І(?:сус[\\s\\xa0]*Навин|\\.[\\s\\xa0]*Нав|[\\s\\xa0]*Нав)|И(?:с(?:ус[\\s\\xa0]*Навин|\\.[\\s\\xa0]*Нав|[\\s\\xa0]*Нав)|\\.[\\s\\xa0]*Н|Нав|[\\s\\xa0]*Н|еш(?:уа)?)|I(?:sus[\\s\\xa0]*Navyn|os(?:ua[\\s\\xa0]*Navi)?)|Книга[\\s\\xa0]*(?:на[\\s\\xa0]*Исус[\\s\\xa0]*Н(?:авиев|евин)|Ісуса[\\s\\xa0]*Навина|Иисус(?:а[\\s\\xa0]*Навина|[\\s\\xa0]*Навин)|Єгошу[ії])|Ks(?:i[eę]g(?:[ai][\\s\\xa0]*Jozuego)|\\.[\\s\\xa0]*Jozuego|[\\s\\xa0]*Jozuego)|יהושע|여호(?:수아기?)?|யோசு(?:வா(?:வின்[\\s\\xa0]*புத்தகம்)?)?|ヨシュア記?|《(?:約書亞記》|约书亚记》|若蘇厄書》|[书書]》)|Ιη(?:σ(?:ο[υύ]ς[\\s\\xa0]*του[\\s\\xa0]*Ναυ[ήη]|[\\s\\xa0]*Ναυ[ήη]?))?|यहोश(?:वा|ु|ू(?:को[\\s\\xa0]*पुस्तक)?)|Li(?:ber[\\s\\xa0]*Iosue|v[\\s\\xa0]*Jozye[\\s\\xa0]*a)|J(?:o(?:us(?:hua|ua)|šu(?:ova|a)|os(?:uan[\\s\\xa0]*kirja)?|s(?:úab[oó]k|u(?:ova|a(?:b[oó]k|h)?|[eé])|va(?:s[\\s\\xa0]*(?:Bog|bok)|bog(?:en)?)?|h(?:ua)?)?|z(?:u(?:ova|a|eu?)|s(?:u[eé])?)?)|ó(?:z(?:u(?:ova|a)|s(?:u[eé])?)|s[uú]ab(?:[oó]k)?)|sh?|š)|ยชว|โยชูวา|Y(?:ōcuv[aā]|usak|a(?:hoshoo|sh(?:uuca)?)|o(?:cuv[aā]|s(?:hua|ua)?))|수|سفر[\\s\\xa0]*يشوع|Єг|ଯିହୋଶୂୟଙ୍କର[\\s\\xa0]*ପୁସ୍ତକ|يش|G(?:i(?:osu[eèé]|ô(?:-?su[aê]|s))|s(?:ua)?)|Ј[ео]шуа|Ἰη|یش(?:ُوع|وع))|Jós|(?:书》?|書》|И(?:исус(?:а[\\s\\xa0]*Навина|[\\s\\xa0]*Навин)|сус[\\s\\xa0]*Навиев)|約書亞記》?|约书亚记》?|Iosu[ae]|yaho[sš](?:[uū]ko)|Ісуса[\\s\\xa0]*Навина|Jo(?:osuan|svas|z(?:uego|ye))|Єгошу[ії]|यहोशूको|Нав|《(?:约书亚记|約書亞記|若蘇厄書|[书書])|يشوع|若蘇厄書》?|ଯିହୋଶୂୟଙ୍କର|Giô))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Judg"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:판관기?|士師|سفر[\\s\\xa0]*القضاة|Li(?:ber[\\s\\xa0]*Iudicum|v[\\s\\xa0]*Ch[eè]f[\\s\\xa0]*yo)|Huk|ق(?:ُضاۃ|ض(?:ا[ةہۃ])?)|Xaak(?:innada)?|ਨਿਆ(?:ਂਈਆਂ[\\s\\xa0]*ਦੀ[\\s\\xa0]*ਪੋਥੀ|ਈਆਂ[\\s\\xa0]*ਦੀ[\\s\\xa0]*ਪੋਥੀ)|Amu|Mga[\\s\\xa0]*(?:Maghuhukom|Hukom)|qużāh|K(?:n(?:jiga[\\s\\xa0]*o[\\s\\xa0]*Sucima|yha[\\s\\xa0]*Suddiv)|s(?:i[eę]g(?:[ai][\\s\\xa0]*S(?:[eę]dzi(?:[oó]w)))|\\.[\\s\\xa0]*S[eę]dzi(?:[oó]w)|[\\s\\xa0]*S[eę]dzi(?:[oó]w))|\\.[\\s\\xa0]*sudcov|[\\s\\xa0]*sudcov)|Iud|Para[\\s\\xa0]*Hakim|न्याय(?:कर्त(?:्ताहरूको[\\s\\xa0]*पुस्तक|ा(?:हरूको[\\s\\xa0]*पुस्तक)?)|िय(?:[\\s\\xa0]*का[\\s\\xa0]*विर्तान्त|ों))|שופטים|ந(?:ியா(?:யாதிபதிகள(?:ின்[\\s\\xa0]*புத்தகம்|்[\\s\\xa0]*ஆகமம்))?|ீத(?:ி(?:த்[\\s\\xa0]*தலைவர்கள்|பதிகள்))?)|n(?:y[aā]yakartt(?:[aā]har(?:[uū]ko[\\s\\xa0]*pustak))|iāīāṃ[\\s\\xa0]*dī[\\s\\xa0]*potʰī)|B(?:arn(?:wyr)?|(?:[ií]r(?:[aá]k)?))|《(?:民長紀》|士(?:师记》|師記》|》))|Κρ(?:ιτ(?:[έε]ς|α[ίι])?)?|ବିଗ୍ଭରକର୍ତ୍ତାମାନଙ୍କ[\\s\\xa0]*ବିବରଣ|T(?:hẩm[\\s\\xa0]*phán|uom(?:arien[\\s\\xa0]*kirja)?)|С(?:уд(?:иј[ае]|ьи)?|ъд)|Книга[\\s\\xa0]*(?:на[\\s\\xa0]*(?:израелеви[\\s\\xa0]*судии|съдиите)|С(?:ъдии[\\s\\xa0]*Израилеви|уд(?:е[ий][\\s\\xa0]*Израилевых|дів)))|G(?:iudici|dc|jy(?:qtar[eë]t)?)|N(?:iy[aā]y(?:[aā]tipatika[lḷ])|yayiyon)|วนฉ|삿|ผู้วินิจฉัย|शास्ते|Các[\\s\\xa0]*(?:Thủ[\\s\\xa0]*lãnh|quan[\\s\\xa0]*xét)|R(?:echt(?:ers)?|icht(?:er(?:en?)?)?)|S(?:oudc[uů]|[eę]dz|u(?:ci|d(?:covia)?)|d[cz]?)|D(?:om(?:ar(?:boken|ab(?:[oó]k(?:in)?))|mer(?:bogen|ne(?:s[\\s\\xa0]*bok)?)?)?|óm(?:arab(?:[oó]k(?:in)?))?)|Quan[\\s\\xa0]*án|[sŝ](?:[aā]ste)|J(?:dgs?|ij|u(?:d(?:ec(?:atorii?|ători)|g(?:es)?)|(?:[ií]z(?:es)?)|e(?:c(?:es)?)?|g(?:es)?)|[cz]|gs?)|사사기|Waam(?:uzi)?)|(?:С(?:ъдии(?:[\\s\\xa0]*Израилеви)?|уд(?:дів|ии|е[йи]))|Dommernes|Maghuhukom|《(?:民長紀|士(?:师记|師記)?)|n(?:y[āa]yakartt(?:[aā]har(?:[ūu]ko))|iāīāṃ)|Iudicum|士(?:師記》?|师记》?|》)?|T(?:uomarien|hủ(?:[\\s\\xa0]*lãnh)?)|நியாயாதிபதிகள்|民長紀》?|न्यायकर्त्ताहरूको|Quan|القضاة|S(?:[eę]dzi(?:[oó]w)|udcov)|Hukom|Книга[\\s\\xa0]*Суде[ий]))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["1Esd"],
        apocrypha: true,
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])((?:I(?:II(?:\.[\s\xa0]*E(?:sdras?|z(?:dra|ra))|[\s\xa0]*E(?:sdras?|z(?:dra|ra)))|\.[\s\xa0]*(?:Ks(?:i[eę]g(?:[ai][\s\xa0]*Ezdrasza)|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|Јездрина|Ésdras|Ездр(?:а|и(?:на)?)|E(?:s(?:ra|d(?:r(?:a[es]?)?)?)|z(?:ra|d(?:r(?:á(?:[sš](?:ova)?)|a(?:s(?:ova|za)?|š(?:ova)?)?))?)))|[\s\xa0]*(?:Ks(?:i[eę]g(?:[ai][\s\xa0]*Ezdrasza)|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|Јездрина|Ésdras|Ездр(?:а|и(?:на)?)|E(?:s(?:ra|d(?:r(?:as?)?)?)|z(?:ra|d(?:r(?:á(?:[sš](?:ova)?)|a(?:s(?:ova|za)?|š(?:ova)?)?))?))))|에스드라[\s\xa0]*1서|K(?:itabu[\s\xa0]*cha[\s\xa0]*Kwanza[\s\xa0]*cha[\s\xa0]*Ezra|wanza[\s\xa0]*Ezra)|П(?:рва[\s\xa0]*(?:Јездрина|Ездрина)|ерш[ае][\s\xa0]*Ездр[аи]|ърва[\s\xa0]*(?:книга[\s\xa0]*на[\s\xa0]*Ездра|Ездра))|《1Esd》|F(?:[oö]rsta[\s\xa0]*Esra|ørste[\s\xa0]*Es(?:dras(?:bog)?|ra)|irst[\s\xa0]*Esd(?:r(?:as)?)?)|1(?:°(?:\.[\s\xa0]*(?:Ésdras|Esdras?)|[\s\xa0]*(?:Ésdras|Esdras?))|-?(?:ше(?:\.[\s\xa0]*Ездр[аи]|[\s\xa0]*Ездр[аи])|(?:[ае](?:\.[\s\xa0]*Ездр[аи]|[\s\xa0]*Ездр[аи])))|ère(?:\.[\s\xa0]*Esdras|[\s\xa0]*Esdras)|re(?:\.[\s\xa0]*Esdras|[\s\xa0]*Esdras)|\.(?:(?:[oº](?:\.[\s\xa0]*Esdras|[\s\xa0]*Esdras))|[\s\xa0]*(?:Ks(?:i[eę]g(?:[ai][\s\xa0]*Ezdrasza)|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|Јездрина|Ésdras|Ездр(?:а|и(?:на)?)|E(?:z(?:ra|d(?:r(?:á(?:[sš](?:ova)?)|a(?:s(?:ova|za)?|š(?:ova)?)?))?)|s(?:d(?:r(?:a(?:e|s(?:bog)?)?)?)?|ra?)?)))|[\s\xa0]*(?:Ks(?:i[eę]g(?:[ai][\s\xa0]*Ezdrasza)|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|எஸ்திராஸ்|k(?:\.[\s\xa0]*Ezdr(?:[aá](?:[sš](?:ova)?))|[\s\xa0]*Ezdr(?:[aá](?:[sš](?:ova)?)))|Ésdras|Ездр(?:а|и(?:на)?)|Јез(?:дрина)?|E(?:z(?:ra|d(?:r(?:á(?:[sš](?:ova)?)|a(?:s(?:ova|za)?|š(?:ova)?)?))?)|s(?:d(?:r(?:a(?:e|s(?:bog)?)?)?)?|ra?)?))|e(?:r(?:\.[\s\xa0]*Esdras|e(?:\.[\s\xa0]*Esdras|[\s\xa0]*Esdras)|[\s\xa0]*Esdras)|\.[\s\xa0]*E(?:sdras|zra)|[\s\xa0]*E(?:sdras|zra))|(?:[oaº](?:\.[\s\xa0]*Esdras|[\s\xa0]*Esdras))|st(?:\.[\s\xa0]*Esd(?:r(?:as)?)?|[\s\xa0]*Esd(?:r(?:as)?)?))|إسدراس[\s\xa0]*الأول|エ[スズ](?:(?:[トド]ラ第一巻|ラ第一書))|Derde[\s\xa0]*E(?:sdras|zra)|T(?:erz[ao][\s\xa0]*Esdra|redje[\s\xa0]*Es(?:drasbog|ra))|Una(?:ng[\s\xa0]*E(?:sdras|zra)|[\s\xa0]*E(?:sdras|zra))|Α(?:['ʹʹ΄’][\s\xa0]*(?:[ΈΕ]σδ(?:ρ(?:ας)?)?))|E(?:nsimm[aä]inen[\s\xa0]*Esra|erste[\s\xa0]*E(?:sdras|zra)|sdra[\s\xa0]*greco|rste[\s\xa0]*Esra|ls[oő][\s\xa0]*Ezd(?:r(?:[aá]s)?)|zdr[aá]s[\s\xa0]*I)|2(?:-?(?:[ея](?:\.[\s\xa0]*Ездры|[\s\xa0]*Ездры))|\.[\s\xa0]*Ездры|(?:[ея](?:\.[\s\xa0]*Ездры|[\s\xa0]*Ездры))|[\s\xa0]*Езд(?:ры)?)|חזון[\s\xa0]*עזרא|Liber[\s\xa0]*(?:Esdrae[\s\xa0]*I|I[\s\xa0]*Esdrae)|P(?:ierwsz[aey][\s\xa0]*(?:Ks(?:i(?:[eę]g(?:[ai][\s\xa0]*Ezdrasza)|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|Ezdrasza))|r(?:emi(?:ère(?:s[\s\xa0]*Esdras|[\s\xa0]*Esdras)|er(?:e(?:s[\s\xa0]*Esdras|[\s\xa0]*Esdras)|s[\s\xa0]*Esdras|[\s\xa0]*Esdras))|im(?:e(?:ir[ao][\s\xa0]*Esdras|r(?:o[\s\xa0]*Esdras|[\s\xa0]*Esdras))|(?:[ao][\s\xa0]*(?:Ésdras|Esdras?)))|v(?:n[ií][\s\xa0]*Ezdr(?:[aá][sš])|(?:[aá][\s\xa0]*(?:kniha[\s\xa0]*Ezdr(?:[aá](?:[sš](?:ova)?))|Ezdr(?:[aá](?:[sš](?:ova)?))))|(?:[yý][\s\xa0]*(?:list[\s\xa0]*Ezdr(?:[aá](?:[sš](?:ova)?))|Ezdr(?:[aá](?:[sš](?:ova)?)))))))|3(?:°(?:\.[\s\xa0]*Esdra|[\s\xa0]*Esdra)|\.[\s\xa0]*E(?:s(?:dra(?:s(?:bog)?)?|ra)|z(?:dra|ra))|e(?:\.[\s\xa0]*E(?:s(?:dras|ra)|zra)|[\s\xa0]*E(?:s(?:dras|ra)|zra))|[\s\xa0]*E(?:s(?:dra(?:s(?:bog)?)?|ra)|z(?:dra|ra)))|[ΕΈ]σδρας[\s\xa0]*Α['ʹʹ΄’])|(?:Pierwsz(?:[aey][\s\xa0]*(?:Ks(?:\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|Ezdrasza))|Els[oő][\s\xa0]*Ezd)|(?:I[\s\xa0]*Esdrae|《1Esd|1Esd》?))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["2Esd"],
        apocrypha: true,
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])((?:Kitabu[\s\xa0]*cha[\s\xa0]*Pili[\s\xa0]*cha[\s\xa0]*Ezra|2(?:e(?:me(?:\.[\s\xa0]*Esdras|[\s\xa0]*Esdras)|\.[\s\xa0]*E(?:sdras|zra)|[\s\xa0]*E(?:sdras|zra))|[\s\xa0]*(?:Ks(?:i[eę]g(?:[ai][\s\xa0]*Ezdrasza)|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|книга[\s\xa0]*Ездри|எஸ்திராஸ்|k(?:\.[\s\xa0]*Ezdr(?:[aá](?:[sš](?:ova)?))|[\s\xa0]*Ezdr(?:[aá](?:[sš](?:ova)?)))|Ésdras|Ездр(?:а|и(?:на)?)|Јез(?:дрина)?|E(?:z(?:ra|d(?:r(?:á(?:[sš](?:ova)?)|a(?:s(?:ova|za)?|š(?:ova)?)?))?)|s(?:d(?:r(?:a(?:e|s(?:bog)?)?)?)?|ra?)?))|\.(?:(?:[oº](?:\.[\s\xa0]*Esdras|[\s\xa0]*Esdras))|[\s\xa0]*(?:Ks(?:i[eę]g(?:[ai][\s\xa0]*Ezdrasza)|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|книга[\s\xa0]*Ездри|Јездрина|Ésdras|Ездр(?:а|и(?:на)?)|E(?:z(?:ra|d(?:r(?:á(?:[sš](?:ova)?)|a(?:s(?:ova|za)?|š(?:ova)?)?))?)|s(?:d(?:r(?:a(?:e|s(?:bog)?)?)?)?|ra?)?)))|°(?:\.[\s\xa0]*(?:Ésdras|Esdras?)|[\s\xa0]*(?:Ésdras|Esdras?))|nd(?:\.[\s\xa0]*Esd(?:r(?:as)?)?|[\s\xa0]*Esd(?:r(?:as)?)?)|d(?:\.[\s\xa0]*Esdras|e(?:\.[\s\xa0]*Esdras|[\s\xa0]*Esdras)|[\s\xa0]*Esdras)|-?(?:ге(?:\.[\s\xa0]*(?:книга[\s\xa0]*Ездри|Ездр[аи])|[\s\xa0]*(?:книга[\s\xa0]*Ездри|Ездр[аи]))|(?:[ае](?:\.[\s\xa0]*(?:книга[\s\xa0]*Ездри|Ездр[аи])|[\s\xa0]*(?:книга[\s\xa0]*Ездри|Ездр[аи]))))|ème(?:\.[\s\xa0]*Esdras|[\s\xa0]*Esdras)|(?:[oaº](?:\.[\s\xa0]*Esdras|[\s\xa0]*Esdras)))|Друг(?:а[\s\xa0]*(?:книга[\s\xa0]*Ездри|Јездрина|Ездр(?:а|и(?:на)?))|е[\s\xa0]*(?:книга[\s\xa0]*Ездри|Ездр[аи]))|I(?:kalawang[\s\xa0]*E(?:sdras|zra)|V(?:\.[\s\xa0]*E(?:sdras?|z(?:dra|ra))|[\s\xa0]*E(?:sdras?|z(?:dra|ra)))|I(?:\.[\s\xa0]*(?:Ks(?:i[eę]g(?:[ai][\s\xa0]*Ezdrasza)|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|книга[\s\xa0]*Ездри|Јездрина|Ésdras|Ездр(?:а|и(?:на)?)|E(?:s(?:ra|d(?:r(?:a[es]?)?)?)|z(?:ra|d(?:r(?:á(?:[sš](?:ova)?)|a(?:s(?:ova|za)?|š(?:ova)?)?))?)))|[\s\xa0]*(?:Ks(?:i[eę]g(?:[ai][\s\xa0]*Ezdrasza)|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|книга[\s\xa0]*Ездри|Јездрина|Ésdras|Ездр(?:а|и(?:на)?)|E(?:s(?:ra|d(?:r(?:as?)?)?)|z(?:ra|d(?:r(?:á(?:[sš](?:ova)?)|a(?:s(?:ova|za)?|š(?:ova)?)?))?)))))|《2Esd》|Втора[\s\xa0]*(?:книга[\s\xa0]*на[\s\xa0]*Ездра|Ездра)|Quart[ao][\s\xa0]*Esdra|[ΕΈ]σδρας[\s\xa0]*Β['ʹʹ΄’]|Fj(?:[aä]rde[\s\xa0]*Esra|erde[\s\xa0]*Es(?:drasbog|ra))|And(?:en[\s\xa0]*Esdrasbog|r(?:a[\s\xa0]*Esra|e[\s\xa0]*Es(?:dras|ra)))|T(?:oinen[\s\xa0]*Esra|weede[\s\xa0]*E(?:sdras|zra))|Ezdr[aá]s[\s\xa0]*II|Β(?:['ʹʹ΄’][\s\xa0]*(?:[ΈΕ]σδ(?:ρ(?:ας)?)?))|Pili[\s\xa0]*Ezra|3(?:-?(?:[ея](?:\.[\s\xa0]*Ездры|[\s\xa0]*Ездры))|\.[\s\xa0]*Ездры|(?:[ея](?:\.[\s\xa0]*Ездры|[\s\xa0]*Ездры))|[\s\xa0]*Езд(?:ры)?)|Zweite[\s\xa0]*Esra|Vierde[\s\xa0]*E(?:sdras|zra)|エ[スズ](?:(?:[トド]ラ第二巻|ラ第二書))|Se(?:gund[ao][\s\xa0]*Esdras|cond(?:(?:[ao][\s\xa0]*(?:Ésdras|Esdras?))|[\s\xa0]*Esd(?:r(?:as)?)?))|M[aá]sodik[\s\xa0]*Ezd(?:r(?:[aá]s)?)|עזרא[\s\xa0]*החיצוני|에스드라[\s\xa0]*2서|إسدراس[\s\xa0]*الثاني|4(?:°(?:\.[\s\xa0]*Esdra|[\s\xa0]*Esdra)|\.[\s\xa0]*E(?:s(?:dra(?:s(?:bog)?)?|ra)|z(?:dra|ra))|[\s\xa0]*E(?:s(?:dra(?:s(?:bog)?)?|ra)|z(?:dra|ra)))|D(?:euxi(?:[eè]me(?:s[\s\xa0]*Esdras|[\s\xa0]*Esdras))|ru(?:g[ai][\s\xa0]*(?:Ks(?:i(?:[eę]g(?:[ai][\s\xa0]*Ezdrasza)|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|Ezdrasza))|h(?:(?:[aá][\s\xa0]*(?:kniha[\s\xa0]*Ezdr(?:[aá](?:[sš](?:ova)?))|Ezdr(?:[aá](?:[sš](?:ova)?))))|(?:[yý][\s\xa0]*(?:list[\s\xa0]*Ezdr(?:[aá](?:[sš](?:ova)?))|Ezdr(?:[aá](?:[sš](?:ova)?)))))))|Liber[\s\xa0]*(?:Esdrae[\s\xa0]*II|II[\s\xa0]*Esdrae))|(?:Drug(?:[ai][\s\xa0]*(?:Ks(?:\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|Ezdrasza))|M[aá]sodik[\s\xa0]*Ezd)|(?:II[\s\xa0]*Esdrae|《2Esd|2Esd》?))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["Isa"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:Ис(?:а(?:ја|и(?:ја)?|я))?|ﺃﺷﻌﻴﺎء|ஏசா(?:யா[\\s\\xa0]*தீர்க்கதரிசியின்[\\s\\xa0]*புத்தகம்)?|سفر[\\s\\xa0]*إشعياء|ישע(?:יהו?|ה)|Li(?:ber[\\s\\xa0]*Isaiae|v[\\s\\xa0]*Ezayi[\\s\\xa0]*a)|É(?:zs(?:ai[aá]s)?|s(?:a(?:i(?:[aá]s|e)|ïe)?)?)|य(?:ेशैया|श(?:ैया(?:को[\\s\\xa0]*पुस्तक)?|या|ा(?:य(?:ाह?)?)?))|イ[サザ]ヤ書?|Ἠσ|ଯ(?:ିଶାଇୟ[\\s\\xa0]*ଭବିଷ୍ୟ‌ଦ୍‌ବକ୍ତାଙ୍କର[\\s\\xa0]*ପୁସ୍ତକ|[ାୀ]ଶାଇୟ)|ya(?:šəiy[aā]ko[\\s\\xa0]*pustak|s(?:əiy[aā]ko[\\s\\xa0]*pustak|haayaah|āyāh|a(?:ʿyāh|y[aā]))|ŝay[aā])|ਯ(?:ਾਸਾਯਾਹ|ਸਾ(?:ਯਾਹ)?)|《(?:以(?:賽(?:亚书》|亞書》)|赛亚书》)|依撒意亞》|[賽赛]》)|எசா(?:யா)?|Іс(?:ая)?|이사(?:야서?)?|إش(?:َعْياء|عيا)|E(?:c[aā]y[aā]|s(?:eia|a(?:jas['’][\\s\\xa0]*Bog|ïe|i(?:as['’][\\s\\xa0]*bok|ás|e)?)?)|zs(?:ai[aá]s)?)|Y[eé]saya|อ(?:ิสยาห์|สย)|사|Ê-?sai|اش|I(?:-?sa(?:-?gia|i-?a)|a|s(?:i(?:[ai](?:(?:[ai](?:(?:[ai]ha?|ha?))|ha?))|ha)|sah|a(?:a(?:[ai](?:(?:[ai]ha?|ha?))|ha?)|[jy]a|ía[hs]?|ïe|ha?|i(?:i(?:[ai]ha?|ha?)|sha?|a(?:[ai]ha?|ha?|s)?|e|ha?)?)?|h(?:acyaah)?)?|z(?:a(?:i(?:[aá][sš]|ja)|j[aá][sš]))?)|Книга[\\s\\xa0]*(?:на[\\s\\xa0]*пророк[\\s\\xa0]*Исаия|пророка[\\s\\xa0]*(?:Исаии|Іса[ії])|Іса[ий][ії])|Η(?:ΣΑ(?:Ϊ́ΑΣ|[ΊΙ]ΑΣ)|σ(?:αΐας)?)|ی(?:سعیاہ|عسیاہ)|Jes(?:a(?:ia|ja(?:n[\\s\\xa0]*kirja|s[\\s\\xa0]*bok|bok(?:en|a))?))?|ୟ(?:ଶାଇୟ|ିଶାୟ)|Ks(?:i[eę]g(?:[ai][\\s\\xa0]*Izajasza)|\\.[\\s\\xa0]*Izajasza|[\\s\\xa0]*Izajasza))|(?:[赛賽]》?|ଯିଶାଇୟ|ya[šs]əiy(?:[aā]ko)|以(?:赛亚书》?|賽(?:亞書》?|亚书》?))|依撒意亞》?|Іса[їі]|Ησαιας|《(?:以(?:赛亚书|賽(?:亞書|亚书))|依撒意亞|[賽赛])|E(?:sa[ij]as|zayi)|I(?:zajasza|-?sa)|यशैयाको|ஏசாயா|Исаи[ия]|Jesajan))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["2Sam"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])((?:2(?:(?:[ея](?:\.[\s\xa0]*(?:Книга[\s\xa0]*Царств|Самуила|Царств)|[\s\xa0]*(?:Книга[\s\xa0]*Царств|Самуила|Царств)))|ème(?:\.[\s\xa0]*Samuel|[\s\xa0]*Samuel)|º(?:\.[\s\xa0]*Samuel|[\s\xa0]*Samuel)|\.(?:(?:[oº](?:\.[\s\xa0]*Samuel|[\s\xa0]*Samuel))|-?سموئیل|۔سموایل|[\s\xa0]*(?:K(?:ongerigernes[\s\xa0]*Bog|s(?:i(?:[eę]g(?:[ai][\s\xa0]*Samuel(?:owa|a)))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|ingdoms)|श(?:ामुएल|मू(?:एल(?:को)?)?)|к(?:нига[\s\xa0]*Сам(?:оилова|у[ії]лова)|раљевима)|ଶାମୁୟେଲଙ?|Re(?:g(?:norum|ilor)|inos)|[sš]am(?:[uū]elko)|سموئیل|S(?:hamooael|a(?:-?mu-?ên|m(?:weli|u(?:u['’]eel|al[ls]?|el(?:o[vw]a|[el]|i(?:n[\s\xa0]*kirja|[st])?|s(?:bo(?:g|k(?:en)?))?)?|[iëï]l)|y[eè]l)?)|ám(?:uel)?|ma?)?|Саму(?:ил(?:ова|а)?|(?:[ії]л(?:ова)?))|Цар(?:ства?|е)|kniha[\s\xa0]*Samuelova|ซ(?:ามูเอล|มอ)|Книга[\s\xa0]*(?:на[\s\xa0]*царете|Царств)))|d(?:\.[\s\xa0]*Samuel|e(?:\.[\s\xa0]*Samuel|[\s\xa0]*Samuel)|[\s\xa0]*Samuel)|e(?:me(?:\.[\s\xa0]*Samuel|[\s\xa0]*Samuel)|\.[\s\xa0]*Sam(?:u[eë]l)?|[\s\xa0]*Sam(?:u[eë]l)?)|°(?:\.[\s\xa0]*Samuele|[\s\xa0]*Samuele)|Sam|nd(?:\.[\s\xa0]*(?:Kingdoms|S(?:a(?:m(?:u[ae]l[ls]?)?)?|ma?))|[\s\xa0]*(?:Kingdoms|S(?:a(?:m(?:u[ae]l[ls]?)?)?|ma?)))|[\s\xa0]*(?:sam(?:u(?:elko|wel)|ū(?:ʾīl|el(?:ko)?))|K(?:ongerigernes[\s\xa0]*Bog|s(?:i(?:[eę]g(?:[ai][\s\xa0]*Samuel(?:owa|a)))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|ingdoms)|श(?:ामुएल|म(?:ुवेल|ू(?:एल(?:को)?)?))|அரசுகள்|k(?:niha[\s\xa0]*Samuelova|\.[\s\xa0]*Samuelova|[\s\xa0]*Samuelova)|к(?:нига[\s\xa0]*Сам(?:оилова|у[ії]лова)|раљевима)|சாமு(?:வேல்)?|ŝamuwel|ଶାମୁୟେଲଙ?|(?:[ie](?:\.[\s\xa0]*Samuelit|[\s\xa0]*Samuelit))|صم(?:وئيل)?|Re(?:g(?:norum|ilor)|inos)|Сам(?:у(?:ил(?:ова|а)?|(?:[ії]л(?:ова)?)))?|šam[uū]elko|سموئیل|S(?:hamooael|a(?:-?mu-?ên|m(?:weli|u(?:u['’]eel|al[ls]?|el(?:o[vw]a|[el]|i(?:n[\s\xa0]*kirja|[st])?|s(?:bo(?:g|k(?:en)?))?)?|[iëï]l)|y[eè]l)?)|ám(?:uel)?|ma?)?|C[aā]muv(?:[eē]l)|Ц(?:ар(?:ства?|е)?)?|ซ(?:ามูเอล|มอ)|Книга[\s\xa0]*(?:на[\s\xa0]*царете|Царств)|ਸਮੂਏਲ)|사무|-?(?:ге(?:\.[\s\xa0]*(?:книга[\s\xa0]*Саму[ії]лова|Samu[iï]l|Саму(?:[ії]л(?:ова)?))|[\s\xa0]*(?:книга[\s\xa0]*Саму[ії]лова|Samu[iï]l|Саму(?:[ії]л(?:ова)?)))|а(?:\.[\s\xa0]*(?:книга[\s\xa0]*Саму[ії]лова|Samu[iï]l|Саму(?:[ії]л(?:ова)?))|[\s\xa0]*(?:книга[\s\xa0]*Саму[ії]лова|Samu[iï]l|Саму(?:[ії]л(?:ова)?)))|е(?:\.[\s\xa0]*(?:книга[\s\xa0]*Саму[ії]лова|Книга[\s\xa0]*Царств|Samu[iï]l|Саму(?:ила|(?:[ії]л(?:ова)?))|Царств)|[\s\xa0]*(?:книга[\s\xa0]*Саму[ії]лова|Книга[\s\xa0]*Царств|Samu[iï]l|Саму(?:ила|(?:[ії]л(?:ова)?))|Царств))|я(?:\.[\s\xa0]*(?:Книга[\s\xa0]*Царств|Самуила|Царств)|[\s\xa0]*(?:Книга[\s\xa0]*Царств|Самуила|Царств))|سموئیل)|۔سموایل|(?:[oa](?:\.[\s\xa0]*(?:Reinos|Samuel)|[\s\xa0]*(?:Reinos|Samuel))))|サムエル(?:[\s\xa0]*2|後書|記下|下)|Втор(?:о[\s\xa0]*(?:книга[\s\xa0]*Самоилова|Самуил)|а[\s\xa0]*(?:Книга[\s\xa0]*на[\s\xa0]*царете|книга[\s\xa0]*(?:Самоилова|на[\s\xa0]*Самуил|Царства)|Самуил|Цар(?:ства|е)))|ଦ୍ୱିତୀୟ[\s\xa0]*ଶାମୁୟେଲଙ?|Liber[\s\xa0]*II[\s\xa0]*Samuelis|سفر[\s\xa0]*صموئيل[\s\xa0]*الثاني|And(?:en[\s\xa0]*(?:Kongerigernes[\s\xa0]*Bog|Sam(?:uel(?:sbog)?)?)|r(?:a[\s\xa0]*Samuelsboken|e[\s\xa0]*Sam(?:uel(?:sbok)?)?))|사무엘(?:[\s\xa0]*하|기(?:[\s\xa0]*하권|하)|하)|列王記第二巻|S(?:[ií]ðari[\s\xa0]*Sam(?:[uú]elsb(?:[oó]k))|amu(?:u['’]eel[\s\xa0]*Labaad|el(?:i(?:s[\s\xa0]*II|[\s\xa0]*II)|[\s\xa0]*II))|e(?:gund(?:[ao][\s\xa0]*(?:Reinos|Samuel))|cond(?:[ao][\s\xa0]*Samuele|[\s\xa0]*(?:Kingdoms|S(?:a(?:m(?:u[ae]l[ls]?)?)?|ma?))))|ámuel[\s\xa0]*II)|Kitabu[\s\xa0]*cha[\s\xa0]*Pili[\s\xa0]*cha[\s\xa0]*Samueli|δυτικ[οό]ς[\s\xa0]*Σαμου(?:[ήη]λ[\s\xa0]*Β['ʹʹ΄’])|I(?:kalawang[\s\xa0]*Samuel|I(?:\.[\s\xa0]*(?:kniha[\s\xa0]*Samuelova|Книга[\s\xa0]*на[\s\xa0]*царете|к(?:нига[\s\xa0]*Сам(?:оилова|у[ії]лова)|раљевима)|K(?:s(?:i(?:[eę]g(?:[ai][\s\xa0]*Samuel(?:owa|a)))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|ingdoms)|Re(?:g(?:norum|ilor)|inos)|Саму(?:[иії]л(?:ова)?)|Цар(?:ства|е)|S(?:a(?:-?mu-?ên|m(?:weli|u(?:u['’]eel|al[ls]?|el(?:o[vw]a|[els]|i(?:n[\s\xa0]*kirja|s)?)?|[iëï]l)|y[eè]l)?)|ám(?:uel)?|ma?)?)|[\s\xa0]*(?:kniha[\s\xa0]*Samuelova|Книга[\s\xa0]*на[\s\xa0]*царете|к(?:нига[\s\xa0]*Сам(?:оилова|у[ії]лова)|раљевима)|K(?:s(?:i(?:[eę]g(?:[ai][\s\xa0]*Samuel(?:owa|a)))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|ingdoms)|Re(?:g(?:norum|ilor)|inos)|Саму(?:[иії]л(?:ова)?)|Цар(?:ства|е)|S(?:a(?:-?mu-?ên|m(?:weli|u(?:u['’]eel|al[ls]?|el(?:o[vw]a|[els]|i(?:n[\s\xa0]*kirja)?)?|[iëï]l)|y[eè]l)?)|ám(?:uel)?|ma?)?)))|Zweite[\s\xa0]*Samuel|M(?:[aá]sodik[\s\xa0]*S(?:[aá]m(?:uel)?))|الممالك[\s\xa0]*الثاني|Cartea[\s\xa0]*(?:a[\s\xa0]*doua[\s\xa0]*a[\s\xa0]*Regilor|II[\s\xa0]*a[\s\xa0]*(?:lui[\s\xa0]*Samuel|Regilor))|D(?:e(?:uxi(?:[eè]me(?:s[\s\xa0]*Samuel|[\s\xa0]*Samuel))|zy[eè]m[\s\xa0]*(?:liv[\s\xa0]*Samy(?:[eè]l[\s\xa0]*la|Samy[eè]l)))|ru(?:g(?:a[\s\xa0]*(?:knjiga[\s\xa0]*o[\s\xa0]*Samuelu|Ks(?:i(?:[eę]g(?:[ai][\s\xa0]*Samuel(?:owa|a)))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|Samuelo(?:va[\s\xa0]*knjiga|wa))|i[\s\xa0]*(?:Ks(?:i(?:[eę]g(?:[ai][\s\xa0]*Samuel(?:owa|a)))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|Samuelowa))|h(?:(?:[aá][\s\xa0]*(?:kniha[\s\xa0]*Samuelova|S(?:am(?:uel(?:ova)?)?)?))|(?:[yý][\s\xa0]*(?:kniha[\s\xa0]*Samuelova|list[\s\xa0]*Samuelova|S(?:am(?:uel(?:ova)?)?)?)))))|दुसरे[\s\xa0]*शमुवेल|دوم(?:[\s\xa0\-?]*سموئیل|۔سموایل)|samūel[\s\xa0]*dī[\s\xa0]*dūjī[\s\xa0]*potʰī|삼하|ਸਮੂਏਲ[\s\xa0]*ਦੀ[\s\xa0]*ਦੂਜੀ[\s\xa0]*ਪੋਥੀ|शम(?:ूएलको[\s\xa0]*दोस्रो[\s\xa0]*पुस्तक|ुऐयल[\s\xa0]*की[\s\xa0]*[2२]री[\s\xa0]*पुस्तक)|ଶାମୁୟେଲଙ୍କ[\s\xa0]*ଦ୍ୱିତୀୟ[\s\xa0]*ପୁସ୍ତକ|Β(?:ασιλει[ωώ]ν[\s\xa0]*Β['ʹʹ΄’]|['ʹʹ΄’][\s\xa0]*Σαμ(?:ου(?:[ήη]λ)?))|T(?:oinen[\s\xa0]*Samuelin[\s\xa0]*kirja|weede[\s\xa0]*Sam(?:u[eë]l)?)|۲(?:[\s\xa0\-?]*سموئیل|۔سموایل)|சாமுவேலின்[\s\xa0]*இரண்டாம்[\s\xa0]*புத்தகம்|صموئيل[\s\xa0]*الثّاني|《撒(?:慕爾紀下》|母耳[記记]下》|下》)|Pili[\s\xa0]*Sam(?:[uw]eli)?|שמואל[\s\xa0]*ב['’]|Друг(?:а[\s\xa0]*(?:к(?:нига[\s\xa0]*Саму[ії]лова|раљевима)|Samu[iï]l|Саму(?:илова|(?:[ії]л(?:ова)?)))|е[\s\xa0]*(?:книга[\s\xa0]*Саму[ії]лова|Samu[iï]l|Саму(?:[ії]л(?:ова)?))))|(?:Dezy[eè]m[\s\xa0]*Samy(?:[eè]l)|Β['ʹʹ΄’][\s\xa0]*Σαμ)|(?:Druga[\s\xa0]*Samuelova|Toinen[\s\xa0]*Samuelin|صموئيل[\s\xa0]*الثاني|שמואל[\s\xa0]*ב|II(?:\.[\s\xa0]*Sa(?:muelin)?|[\s\xa0]*Sa(?:mueli[ns])?)|2(?:\.[\s\xa0]*Sa(?:muelin)?|[\s\xa0]*Sa(?:muelin)?)|《撒(?:母耳[記记]下|慕爾紀下|下)|撒(?:母耳[记記]下》?|慕爾紀下》?|下》?)))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["1Sam"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])((?:I(?:\.[\s\xa0]*(?:kniha[\s\xa0]*Samuelova|Книга[\s\xa0]*на[\s\xa0]*царете|к(?:нига[\s\xa0]*Сам(?:оилова|у[ії]лова)|раљевима)|K(?:s(?:i(?:[eę]g(?:[ai][\s\xa0]*Samuel(?:owa|a)))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|ingdoms)|Re(?:g(?:norum|ilor)|inos)|Саму(?:[иії]л(?:ова)?)|Цар(?:ства|е)|S(?:a(?:-?mu-?ên|m(?:weli|u(?:u['’]eel|al[ls]?|el(?:o[vw]a|[els]|i(?:n[\s\xa0]*kirja|s)?)?|[iëï]l)|y[eè]l)?)|ám(?:uel)?|ma?)?)|[\s\xa0]*(?:kniha[\s\xa0]*Samuelova|Книга[\s\xa0]*на[\s\xa0]*царете|к(?:нига[\s\xa0]*Сам(?:оилова|у[ії]лова)|раљевима)|K(?:s(?:i(?:[eę]g(?:[ai][\s\xa0]*Samuel(?:owa|a)))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|ingdoms)|Re(?:g(?:norum|ilor)|inos)|Саму(?:[иії]л(?:ова)?)|Цар(?:ства|е)|S(?:a(?:-?mu-?ên|m(?:weli|u(?:u['’]eel|al[ls]?|el(?:o[vw]a|[els]|i(?:n[\s\xa0]*kirja)?)?|[iëï]l)|y[eè]l)?)|ám(?:uel)?|ma?)?))|《撒(?:慕爾紀上》|母耳[記记]上》|上》)|שמואל[\s\xa0]*א['’]|Cartea[\s\xa0]*(?:[iî]nt(?:[aâ]i[\s\xa0]*a[\s\xa0]*Regilor)|I[\s\xa0]*a[\s\xa0]*(?:lui[\s\xa0]*Samuel|Regilor))|삼상|سفر[\s\xa0]*صموئيل[\s\xa0]*الأول|列王記第一巻|П(?:ерш[ае][\s\xa0]*(?:книга[\s\xa0]*Саму(?:[ії]лова|Samu[iï]l|Саму(?:[ії]л(?:ова)?)))|рв(?:а[\s\xa0]*(?:к(?:нига[\s\xa0]*Самоилова|раљевима)|Самуил(?:ова)?)|о[\s\xa0]*(?:книга[\s\xa0]*Самоилова|Самуил))|ърва[\s\xa0]*(?:Книга[\s\xa0]*на[\s\xa0]*царете|книга[\s\xa0]*(?:на[\s\xa0]*Самуил|Царства)|Самуил|Цар(?:ства|е)))|ପ୍ରଥମ[\s\xa0]*ଶାମୁୟେଲଙ?|ا(?:لممالك[\s\xa0]*الأول|وّل(?:[\s\xa0]*سموئ[يی]ل|-?سموئیل|۔سموایل))|사무엘(?:[\s\xa0]*상|기(?:[\s\xa0]*상권|상)|상)|Βασιλει[ωώ]ν[\s\xa0]*Α['ʹʹ΄’]|S(?:amu(?:u['’]eel[\s\xa0]*Kowaad|el(?:i(?:s[\s\xa0]*I|[\s\xa0]*I)|[\s\xa0]*I))|ámuel[\s\xa0]*I)|F(?:[oö]rsta[\s\xa0]*Samuelsboken|yrri[\s\xa0]*Sam[uú]elsb(?:[oó]k)|ørste[\s\xa0]*(?:Kongerigernes[\s\xa0]*Bog|Sam(?:uel(?:s(?:bo[gk])?)?)?)|irst[\s\xa0]*(?:Kingdoms|S(?:a(?:m(?:u[ae]l[ls]?)?)?|ma?)))|ଶାମୁୟେଲଙ୍କ[\s\xa0]*ପ୍ରଥମ[\s\xa0]*ପୁସ୍ତକ|ਸਮੂਏਲ[\s\xa0]*ਦੀ[\s\xa0]*ਪਹਿਲੀ[\s\xa0]*ਪੋਥੀ|K(?:itabu[\s\xa0]*cha[\s\xa0]*Kwanza[\s\xa0]*cha[\s\xa0]*Samueli|wanza[\s\xa0]*Sam(?:[uw]eli)?)|sam(?:uelko[\s\xa0]*pustak|ūel(?:[\s\xa0]*dī[\s\xa0]*pahilī[\s\xa0]*potʰī|ko[\s\xa0]*pustak))|۱(?:[\s\xa0]*سموئ[يی]ل|-?سموئیل|۔سموایل)|Una(?:ng[\s\xa0]*Samuel|[\s\xa0]*Samuel)|ﺻﻤﻮﺋﻴﻞ[\s\xa0]*ﺍﻷﻭﻝ|शम(?:ूएलको[\s\xa0]*पहिलो[\s\xa0]*पुस्तक|ुऐल[\s\xa0]*की[\s\xa0]*[1१]ली[\s\xa0]*पुस्तक)|1(?:\.(?:(?:[oº](?:\.[\s\xa0]*Samuel|[\s\xa0]*Samuel))|-?سموئیل|۔سموایل|[\s\xa0]*(?:K(?:ongerigernes[\s\xa0]*Bog|s(?:i(?:[eę]g(?:[ai][\s\xa0]*Samuel(?:owa|a)))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|ingdoms)|श(?:ामुएल|मू(?:एल(?:को)?)?)|к(?:нига[\s\xa0]*Сам(?:оилова|у[ії]лова)|раљевима)|ଶାମୁୟେଲଙ?|سموئ[يی]ل|Re(?:g(?:norum|ilor)|inos)|[sš]am(?:[uū]elko)|S(?:hamooael|a(?:-?mu-?ên|m(?:weli|u(?:u['’]eel|al[ls]?|el(?:o[vw]a|[el]|i(?:n[\s\xa0]*kirja|[st])?|s(?:bo(?:g|k(?:en)?))?)?|[iëï]l)|y[eè]l)?)|ám(?:uel)?|ma?)?|Саму(?:ил(?:ова|а)?|(?:[ії]л(?:ова)?))|Цар(?:ства?|е)|kniha[\s\xa0]*Samuelova|ซ(?:ามูเอล|มอ)|Книга[\s\xa0]*(?:на[\s\xa0]*царете|Царств)))|(?:[ея](?:\.[\s\xa0]*(?:Книга[\s\xa0]*Цар��тв|Самуила|Царств)|[\s\xa0]*(?:Книга[\s\xa0]*Царств|Самуила|Царств)))|st(?:\.[\s\xa0]*(?:Kingdoms|S(?:a(?:m(?:u[ae]l[ls]?)?)?|ma?))|[\s\xa0]*(?:Kingdoms|S(?:a(?:m(?:u[ae]l[ls]?)?)?|ma?)))|º(?:\.[\s\xa0]*Samuel|[\s\xa0]*Samuel)|°(?:\.[\s\xa0]*Samuele|[\s\xa0]*Samuele)|e(?:r(?:\.[\s\xa0]*Samuel|e(?:\.[\s\xa0]*Samuel|[\s\xa0]*Samuel)|[\s\xa0]*Samuel)|\.[\s\xa0]*Sam(?:u[eë]l)?|[\s\xa0]*Sam(?:u[eë]l)?)|Sam|[\s\xa0]*(?:sam(?:u(?:elko|wel)|ū(?:ʾīl|el(?:ko)?))|K(?:ongerigernes[\s\xa0]*Bog|s(?:i(?:[eę]g(?:[ai][\s\xa0]*Samuel(?:owa|a)))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|ingdoms)|श(?:ामुएल|म(?:ुवेल|ू(?:एल(?:को)?)?))|அரசுகள்|k(?:niha[\s\xa0]*Samuelova|\.[\s\xa0]*Samuelova|[\s\xa0]*Samuelova)|к(?:нига[\s\xa0]*Сам(?:оилова|у[ії]лова)|раљевима)|சாமு(?:வேல்)?|ŝamuwel|ଶାମୁୟେଲଙ?|(?:[ie](?:\.[\s\xa0]*Samuelit|[\s\xa0]*Samuelit))|صم(?:وئيل)?|سموئ[يی]ل|Re(?:g(?:norum|ilor)|inos)|Сам(?:у(?:ил(?:ова|а)?|(?:[ії]л(?:ова)?)))?|šam[uū]elko|S(?:hamooael|a(?:-?mu-?ên|m(?:weli|u(?:u['’]eel|al[ls]?|el(?:o[vw]a|[el]|i(?:n[\s\xa0]*kirja|[st])?|s(?:bo(?:g|k(?:en)?))?)?|[iëï]l)|y[eè]l)?)|ám(?:uel)?|ma?)?|C[aā]muv(?:[eē]l)|Ц(?:ар(?:ства?|е)?)?|ซ(?:ามูเอล|มอ)|Книга[\s\xa0]*(?:на[\s\xa0]*царете|Царств)|ਸਮੂਏਲ)|사무|ère(?:\.[\s\xa0]*Samuel|[\s\xa0]*Samuel)|re(?:\.[\s\xa0]*Samuel|[\s\xa0]*Samuel)|۔سموایل|(?:[oa](?:\.[\s\xa0]*(?:Reinos|Samuel)|[\s\xa0]*(?:Reinos|Samuel)))|-?(?:ше(?:\.[\s\xa0]*(?:книга[\s\xa0]*Саму[ії]лова|Samu[iï]l|Саму(?:[ії]л(?:ова)?))|[\s\xa0]*(?:книга[\s\xa0]*Саму[ії]лова|Samu[iï]l|Саму(?:[ії]л(?:ова)?)))|а(?:\.[\s\xa0]*(?:книга[\s\xa0]*Саму[ії]лова|Samu[iï]l|Саму(?:[ії]л(?:ова)?))|[\s\xa0]*(?:книга[\s\xa0]*Саму[ії]лова|Samu[iï]l|Саму(?:[ії]л(?:ова)?)))|е(?:\.[\s\xa0]*(?:книга[\s\xa0]*Саму[ії]лова|Книга[\s\xa0]*Царств|Samu[iï]l|Саму(?:ила|(?:[ії]л(?:ова)?))|Царств)|[\s\xa0]*(?:книга[\s\xa0]*Саму[ії]лова|Книга[\s\xa0]*Царств|Samu[iï]l|Саму(?:ила|(?:[ії]л(?:ова)?))|Царств))|я(?:\.[\s\xa0]*(?:Книга[\s\xa0]*Царств|Самуила|Царств)|[\s\xa0]*(?:Книга[\s\xa0]*Царств|Самуила|Царств))|سموئیل))|šam[uū]elko[\s\xa0]*pustak|Liber[\s\xa0]*I[\s\xa0]*Samuelis|δυτικ[οό]ς[\s\xa0]*Σαμου(?:[ήη]λ[\s\xa0]*Α['ʹʹ΄’])|சாமுவேலின்[\s\xa0]*முதலாம்[\s\xa0]*புத்தகம்|Α['ʹʹ΄’][\s\xa0]*Σαμ(?:ου(?:[ήη]λ)?)|サムエル(?:[\s\xa0]*1|前書|記上|上)|P(?:ierwsz(?:[aey][\s\xa0]*(?:Ks(?:i(?:[eę]g(?:[ai][\s\xa0]*Samuel(?:owa|a)))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|Samuelowa))|r(?:em(?:i(?:ère(?:s[\s\xa0]*Samuel|[\s\xa0]*Samuel)|er(?:e(?:s[\s\xa0]*Samuel|[\s\xa0]*Samuel)|s[\s\xa0]*Samuel|[\s\xa0]*Samuel))|ye[\s\xa0]*(?:liv[\s\xa0]*Samy[eè]l[\s\xa0]*la|Samy[eè]l))|im(?:[ao][\s\xa0]*Samuele|e(?:ir(?:[ao][\s\xa0]*(?:Reinos|Samuel))|r(?:o[\s\xa0]*Samuel|[\s\xa0]*Samuel)))|v(?:a[\s\xa0]*(?:Samuelova[\s\xa0]*knjiga|kn(?:jiga[\s\xa0]*o[\s\xa0]*Samuelu|iha[\s\xa0]*Samuelova))|(?:[yý][\s\xa0]*(?:list[\s\xa0]*Samuelova|Samuelova))|á[\s\xa0]*(?:kniha[\s\xa0]*Samuelova|Samuelova)|n(?:[ií][\s\xa0]*(?:kniha[\s\xa0]*Samuelova|S(?:am(?:uel(?:ova)?)?)?)))))|पहिले[\s\xa0]*शमुवेल|E(?:nsimm[aä]inen[\s\xa0]*Samuelin[\s\xa0]*kirja|rste[\s\xa0]*Samuel|erste[\s\xa0]*Sam(?:u[eë]l)?|ls(?:[oő][\s\xa0]*S(?:[aá]m(?:uel)?))))|(?:Перш[ае][\s\xa0]*(?:Samu(?:[iï]l|Саму(?:[ії]л(?:ова)?)))|Α['ʹʹ΄’][\s\xa0]*Σαμ)|Перш(?:[ае][\s\xa0]*Саму(?:[ії]л(?:ова)?))|(?:Prva[\s\xa0]*Samuelova|1(?:\.[\s\xa0]*Sa(?:muelin)?|[\s\xa0]*Sa(?:muelin)?)|I(?:\.[\s\xa0]*Sa(?:muelin)?|[\s\xa0]*Sa(?:mueli[sn])?)|صموئيل[\s\xa0]*الأول|שמואל[\s\xa0]*א|《撒(?:慕爾紀上|母耳[记記]上|上)|撒(?:母耳[记記]上》?|慕爾紀上》?|上》?)|Samu[ea]l[sl]?|Ensimm[äa]inen[\s\xa0]*Samuelin))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["2Chr"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(2[\s\xa0]*хрон(?:ика|іки)|2[\s\xa0]*Хрон(?:ик|іка?)|2(?:\.[\s\xa0]*itihasko|[\s\xa0]*(?:itihasko|хрон))|(?:Β(?:['ʹʹ΄’][\s\xa0]*(?:Παρ?|Χρ(?:ον(?:ικ[ωώ]ν)?)?))|Втор(?:о[\s\xa0]*(?:книга[\s\xa0]*летописи|Летописи)|а[\s\xa0]*(?:Книга[\s\xa0]*на[\s\xa0]*летописите|книга[\s\xa0]*летописи|Лет(?:описи)?))|ਇਤਹਾਸ[\s\xa0]*ਦੀ[\s\xa0]*ਦੂਜੀ[\s\xa0]*ਪੋਥੀ|역대(?:기[\s\xa0]*하권?|지하|하)|الأخبار[\s\xa0]*2|دوم(?:-?[\s\xa0]*توارِیخ|[\s\xa0]*تو[\s\xa0]*اریخ|۔تواریخ)|ଦ୍ୱିତୀୟ[\s\xa0]*ବଂଶାବଳୀର?|M(?:a(?:mbo[\s\xa0]*ya[\s\xa0]*Nyakati[\s\xa0]*II|sodik[\s\xa0]*Kr(?:[oó]n(?:ika)?))|ásodik[\s\xa0]*Kr(?:[oó]n(?:ika)?))|ବଂଶାବଳୀର[\s\xa0]*ଦ୍ୱିତୀୟ[\s\xa0]*ପୁସ୍ତକ|S(?:[ií]ðari[\s\xa0]*Kron(?:[ií]kub(?:[oó]k))|e(?:gund(?:a[\s\xa0]*Cr[oô]nicas|o[\s\xa0]*Cr[oóô]nicas)|cond(?:[ao][\s\xa0]*Cronache|[\s\xa0]*(?:Paralipomenon|C(?:oron[io]cles?|ron(?:[io]cles?)?|h(?:oron[io]cles?|r(?:n|o(?:n(?:ic(?:als|les?)|ocles?)?)?)?))))))|대하|۲(?:-?[\s\xa0]*توارِیخ|[\s\xa0]*تو[\s\xa0]*اریخ|۔تواریخ)|или[\s\xa0]*Втора[\s\xa0]*книга[\s\xa0]*Паралипоменон|Zweite[\s\xa0]*Chronik|2(?:-?(?:ге(?:\.[\s\xa0]*(?:книга[\s\xa0]*хроніки?|Літопису|[HȞ]roniky|хроніки|Хроніка?)|[\s\xa0]*(?:книга[\s\xa0]*хроніки?|Літопису|[HȞ]roniky|хроніки|Хроніка?))|[\s\xa0]*توارِیخ|а(?:\.[\s\xa0]*(?:книга[\s\xa0]*хроніки?|Літопису|[HȞ]roniky|хроніки|Хроніка?)|[\s\xa0]*(?:книга[\s\xa0]*хроніки?|Літопису|[HȞ]roniky|хроніки|Хроніка?))|е(?:\.[\s\xa0]*(?:Паралипоменон|книга[\s\xa0]*хроніки?|Л(?:етопись|ітопису)|[HȞ]roniky|хроніки|Хрон(?:ик|іка?))|[\s\xa0]*(?:Паралипоменон|книга[\s\xa0]*хроніки?|Л(?:етопись|ітопису)|[HȞ]roniky|хроніки|Хрон(?:ик|іка?)))|я(?:\.[\s\xa0]*(?:Паралипоменон|Летопись|Хроник)|[\s\xa0]*(?:Паралипоменон|Летопись|Хроник)))|(?:[ея](?:\.[\s\xa0]*(?:Паралипоменон|Летопись|Хроник)|[\s\xa0]*(?:Паралипоменон|Летопись|Хроник)))|ème(?:\.[\s\xa0]*Chroniques|[\s\xa0]*Chroniques)|\.(?:[oº](?:\.[\s\xa0]*Cr(?:[oó]nicas|[\s\xa0]*Cr[oó]nicas))|-?[\s\xa0]*توارِیخ|۔تواریخ|[\s\xa0]*(?:Паралипоменону?|Книга[\s\xa0]*на[\s\xa0]*летописите|I(?:tihas|stwa)|itihāsko|M(?:ambo[\s\xa0]*ya[\s\xa0]*Nyakati|ga[\s\xa0]*[CK]roni(?:[ck]a))|книга[\s\xa0]*(?:летописи|хроніки?)|Taar(?:iikhdii)?|تو[\s\xa0]*اریخ|Sử[\s\xa0]*(?:biên[\s\xa0]*niên|ký)|хрон(?:ика|іки)|K(?:s(?:i[eę]g(?:[ai][\s\xa0]*Kronik)|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|wonik|r(?:önikeboken|ón(?:ika)?|o(?:n(?:i(?:eken|c(?:k[aá]|a)|k(?:e(?:boken|l)|a(?:ve)?)?)|ík)?)?|ø(?:n(?:ikebo[gk])?)?))|[\s\xa0]*Sử[\s\xa0]*Ký|Pa(?:r(?:alipomen(?:a|on?))?)?|इति(?:हास(?:को)?)?|L(?:jetopisa|etopis[uů]|ịch[\s\xa0]*sử)|[ȞH]roniky|ବଂଶାବଳୀର?|дневника|Babad|kniha[\s\xa0]*kronik|Aikakirja|พ(?:งศาวดาร|ศด)|C(?:oron[io]cles?|r(?:[óô]nicas|on(?:ache|ocles?|i(?:c(?:as?|i(?:lor)?|l(?:es?)?)|ka))?)|h(?:oron[io]cles?|r(?:n|o(?:n(?:ocles?|i(?:ques|c(?:als|les?)|k))?)?)?))|Хрон(?:ик|іка?)|Nya|Л(?:ітопису|ет(?:опис[иь])?)))|d(?:\.[\s\xa0]*Chroniques|e(?:\.[\s\xa0]*Chroniques|[\s\xa0]*Chroniques)|[\s\xa0]*Chroniques)|[\s\xa0]*(?:Пар(?:алипоменону?)?|e(?:\.[\s\xa0]*Kronika(?:ve)?|[\s\xa0]*Kronika(?:ve)?)|k(?:niha[\s\xa0]*kronik|\.[\s\xa0]*(?:Paralipomenon|Kron(?:i(?:ck[aá]|k)|ík))|[\s\xa0]*(?:Paralipomenon|Kron(?:i(?:ck[aá]|k)|ík)))|أخ|Книга[\s\xa0]*на[\s\xa0]*летописите|I(?:tihas|st(?:wa)?)|Хр|M(?:ambo[\s\xa0]*ya[\s\xa0]*Nyakati|ga[\s\xa0]*[CK]roni(?:[ck]a))|книга[\s\xa0]*(?:летописи|хроніки?)|Taar(?:iikhdii)?|tavārīḫ|تو[\s\xa0]*اریخ|i(?:\.[\s\xa0]*Kronika(?:ve)?|[\s\xa0]*Kronika(?:ve)?|t(?:ahās|ihās(?:ko)?))|Sử[\s\xa0]*(?:biên[\s\xa0]*niên|ký)|N(?:[aā](?:[lḷ](?:[aā]kamam))|ya)|ਇਤਹਾਸ|[\s\xa0]*Sử[\s\xa0]*Ký|நாளா(?:கமம்)?|Pa(?:r(?:alipomen(?:a|on?))?)?|L(?:etopis[uů]|ịch[\s\xa0]*sử|jet(?:opisa)?)|इति(?:हास(?:को)?)?|Дн(?:евника)?|[ȞH]roniky|ବଂଶାବଳୀର?|Babad|குறி(?:ப்பேடு)?|Aik(?:ak(?:irja)?)?|พ(?:งศาวดาร|ศด)|C(?:oron[io]cles?|h(?:oron[io]cles?|r(?:n|o(?:n(?:ocles?|i(?:ques|c(?:als|les?)|k))?)?)?)?|r(?:o(?:n(?:ache|ocles?|i(?:c(?:as?|i(?:lor)?|l(?:es?)?)|ka))?)?|(?:[óô](?:n(?:icas)?)?))?)|K(?:s(?:i[eę]g(?:[ai][\s\xa0]*Kronik)|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|wonik|r(?:ón(?:ika)?|ön(?:ikeboken)?|n|o(?:n(?:i(?:eken|c(?:k[aá]|a)|k(?:e(?:boken|l)|a(?:ve)?)?)|ík)?)?|ø(?:n(?:ikebo[gk])?)?))|Л(?:ітопису|ет(?:опис[иь])?))|역대|nd(?:\.[\s\xa0]*(?:Paralipomenon|C(?:oron[io]cles?|ron(?:[io]cles?)?|h(?:oron[io]cles?|r(?:n|o(?:n(?:ic(?:als|les?)|ocles?)?)?)?)))|[\s\xa0]*(?:Paralipomenon|C(?:oron[io]cles?|ron(?:[io]cles?)?|h(?:oron[io]cles?|r(?:n|o(?:n(?:ic(?:als|les?)|ocles?)?)?)?))))|۔تواریخ|o(?:\.[\s\xa0]*Cr[oóô]nicas|[\s\xa0]*Cr[oóô]nicas)|a(?:\.[\s\xa0]*Cr[oô]nicas|[\s\xa0]*Cr[oô]nicas)|º(?:\.[\s\xa0]*Cr[oó]nicas|[\s\xa0]*Cr[oó]nicas)|°(?:\.[\s\xa0]*Cronache|[\s\xa0]*Cronache)|Chr|e(?:me(?:\.[\s\xa0]*Chroniques|[\s\xa0]*Chroniques)|\.[\s\xa0]*(?:Chroniques|Kron(?:ieken)?)|[\s\xa0]*(?:Chroniques|Kron(?:ieken)?)))|I(?:kalawang[\s\xa0]*(?:Paralipomeno|Mga[\s\xa0]*(?:Cronica|Kronika)|C(?:hronicle|ronica)|Kronik(?:el|a))|I(?:\.[\s\xa0]*(?:C(?:oron[io]cles?|r(?:[óô]nicas|on(?:ache|ocles?|ic(?:as?|i(?:lor)?|l(?:es?)?))?)|h(?:oron[io]cles?|r(?:n|o(?:n(?:i(?:ques|c(?:als|les?))|ocles?)?)?)?))|Книга[\s\xa0]*на[\s\xa0]*летописите|книга[\s\xa0]*(?:летописи|хроніки?)|Taar(?:iikhdii)?|K(?:s(?:i[eę]g(?:[ai][\s\xa0]*Kronik)|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|wonik|r(?:ón(?:ika)?|o(?:n(?:i(?:eken|ck[aá]|k(?:el|a)?)|ík)?)?))|Istwa|Sử[\s\xa0]*(?:biên[\s\xa0]*niên|ký)|хрон(?:ика|іки)|M(?:ambo[\s\xa0]*ya[\s\xa0]*Nyakati|ga[\s\xa0]*(?:Cronica|Kronika))|Хроніка?|[\s\xa0]*Sử[\s\xa0]*Ký|Pa(?:r(?:alipomen(?:a|on?))?)?|L(?:jetopisa|etopis[uů]|ịch[\s\xa0]*sử)|[ȞH]roniky|дневника|Babad|kniha[\s\xa0]*kronik|Л(?:ітопису|ет(?:описи)?)|Паралипоменону|Aikakirja|Nya)|[\s\xa0]*(?:C(?:oron[io]cles?|r(?:[óô]nicas|on(?:ache|ocles?|ic(?:as?|i(?:lor)?|l(?:es?)?))?)|h(?:oron[io]cles?|r(?:n|o(?:n(?:i(?:ques|c(?:als|les?))|ocles?)?)?)?))|Книга[\s\xa0]*на[\s\xa0]*летописите|книга[\s\xa0]*(?:летописи|хроніки?)|Taar(?:iikhdii)?|K(?:s(?:i[eę]g(?:[ai][\s\xa0]*Kronik)|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|wonik|r(?:ón(?:ika)?|o(?:n(?:i(?:eken|ck[aá]|k(?:el|a)?)|ík)?)?))|Istwa|Pa(?:r(?:alipomen[ao])?)?|Sử[\s\xa0]*(?:biên[\s\xa0]*niên|ký)|хрон(?:ика|іки)|M(?:ambo[\s\xa0]*ya[\s\xa0]*Nyakati|ga[\s\xa0]*(?:Cronica|Kronika))|Хроніка?|[\s\xa0]*Sử[\s\xa0]*Ký|L(?:jetopisa|etopis[uů]|ịch[\s\xa0]*sử)|[ȞH]roniky|дневника|Babad|kniha[\s\xa0]*kronik|Л(?:ітопису|ет(?:описи)?)|Паралипоменону|Aikakirja|Nya)))|Cartea[\s\xa0]*a[\s\xa0]*doua[\s\xa0]*Paralipomena|T(?:aariikhdii[\s\xa0]*Labaad|oinen[\s\xa0]*Aikakirja|weede[\s\xa0]*Kron(?:ieken)?)|itahās[\s\xa0]*dī[\s\xa0]*dūjī[\s\xa0]*potʰī|And(?:en[\s\xa0]*Kr(?:on|øn(?:ikebog)?)|r(?:a[\s\xa0]*Kr[oö]nikeboken|e[\s\xa0]*Krø(?:n(?:ikebok)?)?))|דברי[\s\xa0]*הימים[\s\xa0]*ב['’]|Liber[\s\xa0]*II[\s\xa0]*Paralipomenon|D(?:e(?:uxi(?:[eè]me(?:s[\s\xa0]*Chroniques|[\s\xa0]*Chroniques))|zy(?:[eè]m[\s\xa0]*(?:liv[\s\xa0]*Kwonik[\s\xa0]*la|Kwonik|Istwa)))|ru(?:g(?:a[\s\xa0]*(?:knjiga[\s\xa0]*Ljetopisa|Ljetopisa|K(?:s(?:i[eę]g(?:[ai][\s\xa0]*Kronik)|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|ronik))|i[\s\xa0]*K(?:s(?:i[eę]g(?:[ai][\s\xa0]*Kronik)|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|ronik))|h(?:(?:[aá][\s\xa0]*(?:kniha[\s\xa0]*(?:Paralipomenon|Kron(?:i(?:ck[aá]|k)|ík))|Letopis[uů]|Kron(?:i(?:ck[aá]|k)|ík)|Pa(?:ralipomenon)?))|(?:[yý][\s\xa0]*(?:kniha[\s\xa0]*kronik|list[\s\xa0]*(?:Paralipomenon|Kron(?:i(?:ck[aá]|k)|ík))|Letopis[uů]|Kron(?:i(?:ck[aá]|k)|ík)|Pa(?:ralipomenon)?)))))|Παραλειπομ[έε]νων[\s\xa0]*Β['ʹʹ΄’]|Kr[oó]nik(?:[aá]k[\s\xa0]*II)|《(?:[历歷]代志下》|編年紀下》|代下》)|歴(?:代(?:史下|志(?:略下|下)|誌(?:[\s\xa0]*2|下))|下)|سفر[\s\xa0]*أخبار[\s\xa0]*الأيام[\s\xa0]*الثاني|δυτικ[οό]ς[\s\xa0]*Χρονικ(?:[ωώ]ν[\s\xa0]*Β['ʹʹ΄’])|P(?:aralipomenon[\s\xa0]*II|ili[\s\xa0]*(?:Mambo[\s\xa0]*ya[\s\xa0]*Nyakati|Nya))|Друг(?:а[\s\xa0]*(?:Паралипоменону|книга[\s\xa0]*хроніки?|Літопису|дневника|[HȞ]roniky|хрон(?:ика|іки)|Хроніка?)|е[\s\xa0]*(?:книга[\s\xa0]*хроніки?|Літопису|[HȞ]roniky|хроніки|Хроніка?))|दुसरे[\s\xa0]*इतिहास|इतिहास(?:को[\s\xa0]*दोस्रो[\s\xa0]*पुस्तक|[\s\xa0]*[2२]रा[\s\xa0]*भाग)|நாளாகமத்தின்[\s\xa0]*இரண்டாம்[\s\xa0]*புத்தகம்|ﺃﺧﺒﺎﺭ[\s\xa0]*ﺍﻷﻳﺎﻡ[\s\xa0]*ﺍﻟﺜﺎﻥ)|2\.[oº][\s\xa0]*Cr(?:[oó]nicas)|(?:《(?:[历歷]代志下|編年紀下|代下)|Druh[áa][\s\xa0]*kniha[\s\xa0]*kronik|II(?:\.[\s\xa0]*Sử|[\s\xa0]*(?:Paralipomenon|Sử))|代下》?|Síðari[\s\xa0]*kroníkubók|Χρονικ[ώω]ν[\s\xa0]*Β[΄ʹ’'ʹ]|דברי[\s\xa0]*הימים[\s\xa0]*ב|2(?:\.[\s\xa0]*Sử|[\s\xa0]*(?:дневника|itihas|Sử))|أخبار[\s\xa0]*الأيام[\s\xa0]*الثاني|編年紀下》?|Втора[\s\xa0]*книга[\s\xa0]*(?:на[\s\xa0]*летописите|Паралипоменон)|[歷历]代志下》?))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["1Chr"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(1[\s\xa0]*хрон(?:ика|іки)|1[\s\xa0]*Хрон(?:ик|іка?)|1(?:\.[\s\xa0]*itihasko|[\s\xa0]*(?:itihasko|хрон))|(?:நாளாகமத்தின்[\s\xa0]*முதலாம்[\s\xa0]*புத்தகம்|Α(?:['ʹʹ΄’][\s\xa0]*(?:Παρ?|Χρ(?:ον(?:ικ[ωώ]ν)?)?))|《(?:[历歷]代志上》|編年紀上》|代上》)|E(?:nsimm[aä]inen[\s\xa0]*Aikakirja|rste[\s\xa0]*Chronik|erste[\s\xa0]*Kron(?:ieken)?|ls(?:[oő][\s\xa0]*Kr(?:[oó]n(?:ika)?)))|it(?:ahās[\s\xa0]*dī[\s\xa0]*pahilī[\s\xa0]*potʰī|ih[aā]sko[\s\xa0]*pustak)|Mambo[\s\xa0]*ya[\s\xa0]*Nyakati[\s\xa0]*I|대상|سفر[\s\xa0]*أخبار[\s\xa0]*الأيام[\s\xa0]*الأول|ବଂଶାବଳୀର[\s\xa0]*ପ୍ରଥମ[\s\xa0]*ପୁସ୍ତକ|F(?:[oö]rsta[\s\xa0]*Kr(?:[oö]nikeboken)|yrri[\s\xa0]*Kron[ií]kub(?:[oó]k)|ørste[\s\xa0]*Kr(?:on|ø(?:n(?:ikebo[gk])?)?)|irst[\s\xa0]*(?:Paralipomenon|C(?:oron[io]cles?|ron(?:[io]cles?)?|h(?:oron(?:icles|ocles?)|r(?:n|o(?:n(?:ic(?:als|les?)|ocles?)?)?)?))))|K(?:r[oó]nik(?:[aá]k[\s\xa0]*I)|wanza[\s\xa0]*(?:Mambo[\s\xa0]*ya[\s\xa0]*Nyakati|Nya))|역대(?:기[\s\xa0]*상권?|지상|상)|ପ୍ରଥମ[\s\xa0]*ବଂଶାବଳୀର?|Una(?:ng[\s\xa0]*(?:Paralipomeno|Mga[\s\xa0]*(?:Cronica|Kronika)|C(?:hronicle|ronica)|Kronik(?:el|a))|[\s\xa0]*(?:Paralipomeno|Mga[\s\xa0]*(?:Cronica|Kronika)|C(?:hronicle|ronica)|Kronik(?:el|a)))|или[\s\xa0]*Първа[\s\xa0]*книга[\s\xa0]*Паралипоменон|Liber[\s\xa0]*I[\s\xa0]*Paralipomenon|C(?:artea[\s\xa0]*[iî]nt(?:[aâ]i[\s\xa0]*Paralipomena)|horonicle)|I(?:\.[\s\xa0]*(?:C(?:oron[io]cles?|r(?:[óô]nicas|on(?:ache|ocles?|ic(?:as?|i(?:lor)?|l(?:es?)?))?)|h(?:oron(?:icles|ocles?)|r(?:n|o(?:n(?:i(?:ques|c(?:als|les?))|ocles?)?)?)?))|Книга[\s\xa0]*на[\s\xa0]*летописите|книга[\s\xa0]*(?:летописи|хроніки?)|Taar(?:iikhdii)?|Istwa|хрон(?:ика|іки)|M(?:ambo[\s\xa0]*ya[\s\xa0]*Nyakati|ga[\s\xa0]*(?:Cronica|Kronika))|Sử[\s\xa0]*(?:biên[\s\xa0]*niên|Ký)|Хроніка?|Pa(?:r(?:alipomen(?:a|on?))?)?|L(?:jetopisa|etopis[uů]|ịch[\s\xa0]*sử)|[ȞH]roniky|дневника|Babad|kniha[\s\xa0]*kronik|Л(?:ітопису|ет(?:описи)?)|Паралипоменону|Aikakirja|K(?:s(?:i[eę]g(?:[ai][\s\xa0]*Kronik)|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|wonik|r(?:ón(?:ika)?|o(?:n(?:i(?:eken|ck[aá]|k(?:el)?)|ík)?)?))|Nya)|[\s\xa0]*(?:C(?:oron[io]cles?|r(?:[óô]nicas|on(?:ache|ocles?|ic(?:as?|i(?:lor)?|l(?:es?)?))?)|h(?:oron(?:icles|ocles?)|r(?:n|o(?:n(?:i(?:ques|c(?:als|les?))|ocles?)?)?)?))|Книга[\s\xa0]*на[\s\xa0]*летописите|книга[\s\xa0]*(?:летописи|хроніки?)|Taar(?:iikhdii)?|Istwa|Pa(?:r(?:alipomen[ao])?)?|хрон(?:ика|іки)|M(?:ambo[\s\xa0]*ya[\s\xa0]*Nyakati|ga[\s\xa0]*(?:Cronica|Kronika))|Sử[\s\xa0]*(?:biên[\s\xa0]*niên|Ký)|Хроніка?|L(?:jetopisa|etopis[uů]|ịch[\s\xa0]*sử)|[ȞH]roniky|дневника|Babad|kniha[\s\xa0]*kronik|Л(?:ітопису|ет(?:описи)?)|Паралипоменону|Aikakirja|K(?:s(?:i[eę]g(?:[ai][\s\xa0]*Kronik)|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|wonik|r(?:ón(?:ika)?|o(?:n(?:i(?:eken|ck[aá]|k(?:el)?)|ík)?)?))|Nya))|δυτικ[οό]ς[\s\xa0]*Χρονικ(?:[ωώ]ν[\s\xa0]*Α['ʹʹ΄’])|पहिले[\s\xa0]*इतिहास|Παραλειπομ[έε]νων[\s\xa0]*Α['ʹʹ΄’]|इतिहास(?:को[\s\xa0]*पहिलो[\s\xa0]*पुस्तक|[\s\xa0]*[1१]ला[\s\xa0]*भाग)|P(?:aralipomenon[\s\xa0]*I|ierwsz[aey][\s\xa0]*K(?:s(?:i(?:[eę]g(?:[ai][\s\xa0]*Kronik)|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|ronik))|r(?:im(?:e(?:ir[ao][\s\xa0]*Cr(?:[oô]nicas)|r(?:o[\s\xa0]*Cr[oó]nicas|[\s\xa0]*Cr[oó]nicas))|[ao][\s\xa0]*Cronache)|em(?:i(?:ère(?:s[\s\xa0]*Chroniques|[\s\xa0]*Chroniques)|er(?:e(?:s[\s\xa0]*Chroniques|[\s\xa0]*Chroniques)|s[\s\xa0]*Chroniques|[\s\xa0]*Chroniques))|ye[\s\xa0]*(?:liv[\s\xa0]*Kwonik[\s\xa0]*la|Kwonik|Istwa))|v(?:a[\s\xa0]*(?:Paralipomenon|kn(?:jiga[\s\xa0]*Ljetopisa|iha[\s\xa0]*(?:Paralipomenon|Kron(?:i(?:ck[aá]|k)|ík)))|Ljetopisa|Kron(?:i(?:ck[aá]|k)|ík))|(?:[yý][\s\xa0]*(?:Paralipomenon|list[\s\xa0]*(?:Paralipomenon|Kron(?:i(?:ck[aá]|k)|ík))|Kron(?:i(?:ck[aá]|k)|ík)))|á[\s\xa0]*(?:Paralipomenon|kniha[\s\xa0]*(?:Paralipomenon|Kron(?:i(?:ck[aá]|k)|ík))|Kron(?:i(?:ck[aá]|k)|ík))|n(?:[ií][\s\xa0]*(?:kniha[\s\xa0]*kronik|Letopis[uů]|Kronik|Pa(?:ralipomenon)?)))))|1(?:(?:[ея](?:\.[\s\xa0]*(?:Паралипоменон|Летопись|Хроник)|[\s\xa0]*(?:Паралипоменон|Летопись|Хроник)))|\.(?:[oº](?:\.[\s\xa0]*Cr(?:[oó]nicas|[\s\xa0]*Cr[oó]nicas))|-?توارِیخ|۔تواریخ|[\s\xa0]*(?:تواریخ|Паралипоменону?|Книга[\s\xa0]*на[\s\xa0]*летописите|I(?:tihas|stwa)|itihāsko|M(?:ambo[\s\xa0]*ya[\s\xa0]*Nyakati|ga[\s\xa0]*[CK]roni(?:[ck]a))|книга[\s\xa0]*(?:летописи|хроніки?)|Taar(?:iikhdii)?|хрон(?:ика|іки)|Sử[\s\xa0]*(?:biên[\s\xa0]*niên|Ký)|K(?:s(?:i[eę]g(?:[ai][\s\xa0]*Kronik)|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|wonik|r(?:önikeboken|ón(?:ika)?|o(?:n(?:i(?:eken|c(?:k[aá]|a)|k(?:e(?:boken|l)|a(?:ve)?)?)|ík)?)?|ø(?:n(?:ikebo[gk])?)?))|Pa(?:r(?:alipomen(?:a|on?))?)?|इति(?:हास(?:को)?)?|L(?:jetopisa|etopis[uů]|ịch[\s\xa0]*sử)|[ȞH]roniky|ବଂଶାବଳୀର?|дневника|Babad|kniha[\s\xa0]*kronik|Aikakirja|พ(?:งศาวดาร|ศด)|Хрон(?:ик|іка?)|C(?:oron[io]cles?|r(?:[óô]nicas|on(?:ache|ocles?|i(?:c(?:as?|i(?:lor)?|l(?:es?)?)|ka))?)|h(?:oron(?:icles|ocles?)|r(?:n|o(?:n(?:ocles?|i(?:ques|c(?:als|les?)|k))?)?)?))|Nya|Л(?:ітопису|ет(?:опис[иь])?)))|역대|۔تواریخ|o(?:\.[\s\xa0]*Cr[oóô]nicas|[\s\xa0]*Cr[oóô]nicas)|a(?:\.[\s\xa0]*Cr[oô]nicas|[\s\xa0]*Cr[oô]nicas)|º(?:\.[\s\xa0]*Cr[oó]nicas|[\s\xa0]*Cr[oó]nicas)|st(?:\.[\s\xa0]*(?:Paralipomenon|C(?:oron[io]cles?|ron(?:[io]cles?)?|h(?:oron(?:icles|ocles?)|r(?:n|o(?:n(?:ic(?:als|les?)|ocles?)?)?)?)))|[\s\xa0]*(?:Paralipomenon|C(?:oron[io]cles?|ron(?:[io]cles?)?|h(?:oron(?:icles|ocles?)|r(?:n|o(?:n(?:ic(?:als|les?)|ocles?)?)?)?))))|ère(?:\.[\s\xa0]*Chroniques|[\s\xa0]*Chroniques)|[\s\xa0]*(?:Пар(?:алипоменону?)?|e(?:\.[\s\xa0]*Kronika(?:ve)?|[\s\xa0]*Kronika(?:ve)?)|تواریخ|k(?:niha[\s\xa0]*kronik|\.[\s\xa0]*(?:Paralipomenon|Kron(?:i(?:ck[aá]|k)|ík))|[\s\xa0]*(?:Paralipomenon|Kron(?:i(?:ck[aá]|k)|ík)))|أخ|Книга[\s\xa0]*на[\s\xa0]*летописите|I(?:tihas|st(?:wa)?)|Хр|M(?:ambo[\s\xa0]*ya[\s\xa0]*Nyakati|ga[\s\xa0]*[CK]roni(?:[ck]a))|книга[\s\xa0]*(?:летописи|хроніки?)|Taar(?:iikhdii)?|tavārīḫ|i(?:\.[\s\xa0]*Kronika(?:ve)?|[\s\xa0]*Kronika(?:ve)?|t(?:ahās|ihās(?:ko)?))|N(?:[aā](?:[lḷ](?:[aā]kamam))|ya)|Sử[\s\xa0]*(?:biên[\s\xa0]*niên|Ký)|ਇਤਹਾਸ|நாளா(?:கமம்)?|Pa(?:r(?:alipomen(?:a|on?))?)?|L(?:etopis[uů]|ịch[\s\xa0]*sử|jet(?:opisa)?)|इति(?:हास(?:को)?)?|Дн(?:евника)?|[ȞH]roniky|ବଂଶାବଳୀର?|Babad|குறி(?:ப்பேடு)?|Aik(?:ak(?:irja)?)?|พ(?:งศาวดาร|ศด)|K(?:s(?:i[eę]g(?:[ai][\s\xa0]*Kronik)|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|wonik|r(?:ón(?:ika)?|ön(?:ikeboken)?|n|o(?:n(?:i(?:eken|c(?:k[aá]|a)|k(?:e(?:boken|l)|a(?:ve)?)?)|ík)?)?|ø(?:n(?:ikebo[gk])?)?))|C(?:oron[io]cles?|h(?:oron(?:icles|ocles?)|r(?:n|o(?:n(?:ocles?|i(?:ques|c(?:als|les?)|k))?)?)?)?|r(?:o(?:n(?:ache|ocles?|i(?:c(?:as?|i(?:lor)?|l(?:es?)?)|ka))?)?|(?:[óô](?:n(?:icas)?)?))?)|Л(?:ітопису|ет(?:опис[иь])?))|re(?:\.[\s\xa0]*Chroniques|[\s\xa0]*Chroniques)|°(?:\.[\s\xa0]*Cronache|[\s\xa0]*Cronache)|-?(?:ше(?:\.[\s\xa0]*(?:книга[\s\xa0]*хроніки?|Літопису|[HȞ]roniky|хроніки|Хроніка?)|[\s\xa0]*(?:книга[\s\xa0]*хроніки?|Літопису|[HȞ]roniky|хроніки|Хроніка?))|а(?:\.[\s\xa0]*(?:книга[\s\xa0]*хроніки?|Літопису|[HȞ]roniky|хроніки|Хроніка?)|[\s\xa0]*(?:книга[\s\xa0]*хроніки?|Літопису|[HȞ]roniky|хроніки|Хроніка?))|е(?:\.[\s\xa0]*(?:Паралипоменон|книга[\s\xa0]*хроніки?|Л(?:етопись|ітопису)|[HȞ]roniky|хроніки|Хрон(?:ик|іка?))|[\s\xa0]*(?:Паралипоменон|книга[\s\xa0]*хроніки?|Л(?:етопись|ітопису)|[HȞ]roniky|хроніки|Хрон(?:ик|іка?)))|я(?:\.[\s\xa0]*(?:Паралипоменон|Летопись|Хроник)|[\s\xa0]*(?:Паралипоменон|Летопись|Хроник))|توارِیخ)|e(?:r(?:\.[\s\xa0]*Chroniques|e(?:\.[\s\xa0]*Chroniques|[\s\xa0]*Chroniques)|[\s\xa0]*Chroniques)|\.[\s\xa0]*Kron(?:ieken)?|[\s\xa0]*Kron(?:ieken)?)|Chr)|П(?:ерш(?:[ае][\s\xa0]*(?:книга[\s\xa0]*хроніки?|Літопису|[HȞ]roniky|хроніки|Хроніка?))|рв(?:о[\s\xa0]*(?:книга[\s\xa0]*летописи|Летописи)|а[\s\xa0]*(?:Паралипоменону|книга[\s\xa0]*летописи|Летописи|дневника|хроника))|ърва[\s\xa0]*(?:Книга[\s\xa0]*на[\s\xa0]*летописите|Лет(?:описи)?))|ﺃﺧﺒﺎﺭ[\s\xa0]*ﺍﻷﻳﺎﻡ[\s\xa0]*ﺍﻷ|歴(?:代(?:史上|志(?:略上|上)|誌(?:[\s\xa0]*1|上))|上)|۱(?:-?توارِیخ|[\s\xa0۔]*تواریخ)|דברי[\s\xa0]*הימים[\s\xa0]*א['’]|ا(?:وّل(?:-?توارِیخ|[\s\xa0۔]*تواریخ)|لأخبار[\s\xa0]*1)|Taariikhdii[\s\xa0]*Kowaad|ਇਤਹਾਸ[\s\xa0]*ਦੀ[\s\xa0]*ਪਹਿਲੀ[\s\xa0]*ਪੋਥੀ)|(?:Pierwsz(?:[aey][\s\xa0]*K(?:s(?:\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|ronik))|1\.[oº][\s\xa0]*Cr(?:[oó]nicas))|(?:Fyrri[\s\xa0]*kroníkubók|Χρονικ[ωώ]ν[\s\xa0]*Α[ʹ’'ʹ΄]|代上》?|דברי[\s\xa0]*הימים[\s\xa0]*א|Paralipomenon|1(?:\.[\s\xa0]*Sử(?:[\s\xa0]*ký)?|[\s\xa0]*(?:дневника|itihas|Sử(?:[\s\xa0]*ký)?))|C(?:h(?:oron(?:icles|ocles?)|ron(?:ocles?|ic(?:als|les?)))|oron[oi]cles?|ron[oi]cles?)|I(?:\.[\s\xa0]*(?:Kronika|Sử(?:[\s\xa0]*ký)?)|[\s\xa0]*(?:Paralipomenon|Kronika|Sử(?:[\s\xa0]*ký)?))|《(?:編年紀上|[历歷]代志上|代上)|編年紀上》?|Първа[\s\xa0]*книга[\s\xa0]*(?:Паралипоменон|на[\s\xa0]*летописите)|[歷历]代志上》?|أخبار[\s\xa0]*الأيام[\s\xa0]*الأول))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["Ezra"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])((?:ਅਜ਼ਰਾ|ع(?:ز[\s\xa0]*را|ـز)|Εσ(?:δρας)?|e(?:dzr[aā]|ǳr(?:[aā](?:ko)?))|Aejra|Έσδρας|Ê(?:-?xơ-?ra|xra)|Ces(?:r(?:aa)?)?|ʿizrā|Јездра|エ[スズ]ラ[書記]?|《(?:厄斯德拉上》|以斯拉[記记]》|拉》)|Ἔσ|Étra|1[\s\xa0]*Езд|E(?:-?xơ-?ra|s(?:ṛ[aā]|d(?:ra?)?|r(?:a(?:n[\s\xa0]*kirja|s[\s\xa0]*bok|b[oó]k)?|ā)?)|z(?:sd(?:r[aá]s)?|d(?:r(?:á[sš]|a[sš]?)?)?|r(?:a(?:s[\s\xa0]*Bog)?)?)|d)|Книга[\s\xa0]*(?:на[\s\xa0]*Ездра|Ездр[иы])|อสร|Езр(?:ина|а)?|एज्रा(?:को[\s\xa0]*पुस्तक)?|ଏଜ୍ରା|Li(?:v[\s\xa0]*Esdras[\s\xa0]*la|ber[\s\xa0]*Esdrae)|스|에(?:스라기?|즈(?:라기?)?)|K(?:njiga[\s\xa0]*Ezrina|s(?:i[eę]g(?:[ai][\s\xa0]*Ezdrasza)|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza))|سفر[\s\xa0]*عزرا|Первая[\s\xa0]*Ездры|เอสรา|எஸ்(?:ரா|றா(?:வின்[\s\xa0]*புத்தகம்)?)|Уза[ий]р|עזרא|Єзд(?:ри)?|azrā)|(?:एज्राको|厄斯德拉上》?|E(?:zdrasza|s(?:dra[es]|ra[sn]))|عزرا|以斯拉[記记]》?|Езд(?:р[аыи])?|拉》|《(?:厄斯德拉上|以斯拉[记記]|拉)))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["Ruth"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(rūtʰ(?:ko[\\s\\xa0]*pustak)?|(?:רות|Книга[\\s\\xa0]*Ру(?:фи|т)|R(?:oot|u(?:-?tơ|t(?:hs[\\s\\xa0]*Bog|s[\\s\\xa0]*bok|a(?:rb[oó]k)?|e)|u(?:d|t(?:in[\\s\\xa0]*kirja)?))|[úū]t|th?)|ଋତର[\\s\\xa0]*ବିବରଣ[\\s\\xa0]*ପୁସ୍ତକ|ரூத்(?:த(?:ின்[\\s\\xa0]*சரித்திரம்|ு))?|र(?:ुत|ू(?:त|थ(?:को[\\s\\xa0]*पुस्तक)?))|K(?:itabu[\\s\\xa0]*cha[\\s\\xa0]*Ruth[iu]|njiga[\\s\\xa0]*o[\\s\\xa0]*Ruti|s(?:i(?:[eę]g(?:[ai][\\s\\xa0]*Rut(?:hy)?))|\\.[\\s\\xa0]*Rut(?:hy)?|[\\s\\xa0]*Rut(?:hy)?))|سفر[\\s\\xa0]*راعوث|น(?:างรูธ|รธ)|Ру(?:та|фь?)|rutʰ(?:ko[\\s\\xa0]*pustak)?|ر(?:ُوت|وت|ا)|Li(?:ber[\\s\\xa0]*Ruth|v[\\s\\xa0]*Rit[\\s\\xa0]*la)|룻기?|ਰੂਥ|《(?:盧德傳》|路得[記记]》|得》)|῾Ρθ|Ρουθ|ルツ記?)|rutʰko|(?:R(?:it|u(?:utin|t(?:s|h[ui]?)?)?)|得》|路得[記记]》|盧德傳》|रूथको|راعوث|rūt(?:ʰko)?|Рут|《(?:盧德傳|路得[记記]|得))|(?:盧德傳|路得[記记]|得))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Neh"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(nahemyahko[\\s\\xa0]*pustak|Nahemyah|(?:느(?:헤(?:미(?:아|야기?))?)?|n(?:iḥimyāh|ah(?:amyāh|emy(?:a|ā(?:hko[\\s\\xa0]*pustak)?)))|நெகே(?:மியா(?:வின்[\\s\\xa0]*புத்தகம்)?)?|N(?:ê-?hê-?mi-?a|ơkhemia|e(?:k[eē]miy[aā]|em(?:i(?:ja|as?)?)?|h(?:amiah?|em(?:eia|ía(?:b[oó]k|[hs])|a(?:[ai](?:(?:[ai]h|h))|h)|i(?:i(?:[ai]h|h)|ja|á[sš]|a(?:n[\\s\\xa0]*kirja|s’[\\s\\xa0]*Bog|b[oó]k|[ai]h|[hš])?|[eh])|j(?:á[sš]|a(?:s[\\s\\xa0]*bok|š)?)|ya)|im(?:a(?:[ai](?:(?:[ai]h|h))|h)|i(?:i(?:[ai]h|h)|a(?:[ai]h|h)?|h))|émie)?|x(?:emyaah)?)?|é(?:h(?:[eé]mie)?)?)|ネヘミヤ記?|נחמיה|นหม|Νε(?:εμ[ίι]ας)?|न(?:्हेम्याह|हेम(?:्या(?:ह(?:को[\\s\\xa0]*पुस्तक)?)?|ा(?:याह)?))|Li(?:ber[\\s\\xa0]*Nehemiae|v[\\s\\xa0]*Neyemi[\\s\\xa0]*an)|ਨਹਮਯਾਹ|Книга[\\s\\xa0]*(?:на[\\s\\xa0]*Неемия|Неем(?:ии|і[ії]))|ନିହିମିୟାଙ୍କର[\\s\\xa0]*ପୁସ୍ତକ|เนหะมีย์|Не(?:хемија|ем(?:ија|ія)?|єм(?:і[ії])?|м(?:ија)?)|K(?:njiga[\\s\\xa0]*Nehemijina|s(?:i[eę]g(?:[ai][\\s\\xa0]*Nehemiasza)|\\.[\\s\\xa0]*Nehemiasza|[\\s\\xa0]*Nehemiasza))|《(?:厄斯德拉下》|尼(?:希米[記记]》|》))|نح(?:میاہ)?|سفر[\\s\\xa0]*نحميا)|(?:厄斯德拉下》?|नहेम्याहको|ନିହିମିୟାଙ୍କର|nahemy[aā]hko|N(?:e(?:hem(?:jas|ia(?:s(?:za)?|[en]))|yemi)|ê(?:-?hê-?mi)?)|尼(?:希米[記记]》?|》)?|نحميا|Неем(?:и[ия]|і[їі])|《(?:厄斯德拉下|尼(?:希米[记記])?)))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["GkEsth"],
        apocrypha: true,
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:에스[겔텔][\\s\\xa0]*추가본|Den[\\s\\xa0]*greske[\\s\\xa0]*Ester-?bok(?:en|a)|エステル(?:書殘篇|記補遺)|Es(?:zter[\\s\\xa0]*k[oö]nyv(?:[eé]nek[\\s\\xa0]*kieg(?:[eé]sz(?:[ií]t(?:[eé]se))))|t(?:er(?:arb[oó]k[\\s\\xa0]*hin[\\s\\xa0]*gr(?:[ií]ska)|[\\s\\xa0]*(?:enligt[\\s\\xa0]*den[\\s\\xa0]*grekiska[\\s\\xa0]*texten|(?:[rř]eck(?:[eé][\\s\\xa0]*(?:dodatky|[cč](?:[aá]sti))))|greco|\\((?:versione[\\s\\xa0]*greca\\)|řecké[\\s\\xa0]*(?:dodatky\\)|části\\))|greco\\)|Gr(?:i(?:yego\\)|e(?:chisch\\)|ks\\)|go\\)))|yego\\)|eg[ao]\\)|\\)))|Gr(?:i(?:yego|ego)|yego|eg[ao])?))|h(?:er[\\s\\xa0]*(?:\\(Gre(?:ek\\)|c\\))|graeca|Gr(?:ec)?)|[\\s\\xa0]*Gr)|[\\s\\xa0]*(?:\\(Gr\\)|Gr)|g))|Kr(?:eikkalainen[\\s\\xa0]*Esterin[\\s\\xa0]*kirja|\\.[\\s\\xa0]*Est|[\\s\\xa0]*Est)|எஸ்(?:தர்[\\s\\xa0]*\\(கி(?:ரேக்கம்\\)|\\))|[\\s\\xa0]*\\(கி\\))|《GkEsth》|תוספות[\\s\\xa0]*למגילת[\\s\\xa0]*אסתר|Εσθ[ήη]ρ[\\s\\xa0]*στα[\\s\\xa0]*ελληνικ[άα]|Дополнения[\\s\\xa0]*к[\\s\\xa0]*Есфири|G(?:k[\\s\\xa0]*Esth?|r(?:écke[\\s\\xa0]*[cč]asti[\\s\\xa0]*knihy[\\s\\xa0]*Ester|aeca[\\s\\xa0]*Esther|e(?:cke[\\s\\xa0]*[cč]asti[\\s\\xa0]*knihy[\\s\\xa0]*Ester|ek[\\s\\xa0]*Est(?:h(?:er)?)?)|[\\s\\xa0]*Esth?|Est)))|(?:Kreikkalainen[\\s\\xa0]*Esterin|எஸ்(?:தர்[\\s\\xa0]*\\(கி\\)|[\\s\\xa0]*\\(கி\\))|《GkEsth|GkEsth》?|Est(?:er[\\s\\xa0]*(?:\\((?:Grie(?:chisch\\)|ks\\))|gr(?:iego\\)|ega\\)))|gr(?:iego|ega)?)|h(?:er[\\s\\xa0]*(?:\\(grec\\)|gr(?:ec)?)|[\\s\\xa0]*gr)|[\\s\\xa0]*(?:\\(Gr\\)|gr))))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Esth"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(estarko[\\s\\xa0]*pustak|(?:آستر|《(?:艾斯德爾傳》|以斯帖[記记]》|斯》)|אסתר,[\\s\\xa0]*כולל[\\s\\xa0]*פרקים[\\s\\xa0]*גנוזים|Ks(?:i[eę]g(?:[ai][\\s\\xa0]*Estery)|\\.[\\s\\xa0]*Estery|[\\s\\xa0]*Estery)|ଏଷ୍ଟର[\\s\\xa0]*ବିବରଣ|ایستر|[aā]star|Li(?:ber[\\s\\xa0]*Esther|v[\\s\\xa0]*Est[eè][\\s\\xa0]*a)|E(?:s(?:zt(?:er)?|t(?:e(?:er|r(?:in[\\s\\xa0]*kirja|s[\\s\\xa0]*(?:Bog|bok)|ei|a(?:rb[oó]k)?)?)|[ah]r?)?)?|t)|Εσθ(?:[ήη]ρ)?|Ес(?:т(?:ира)?|ф(?:ирь)?)|เอสเธอร์|에(?:스(?:테르기|더기?|텔)?)?|سفر[\\s\\xa0]*أستير|Јест(?:ира)?|Книга[\\s\\xa0]*Ес(?:т[еи]р|ф(?:ири|ір))|อสธ|எஸ்(?:தர(?:ின்[\\s\\xa0]*சரித்திரம்|்))?|Ê-?xơ-?tê|एस्त(?:ेर|र(?:को[\\s\\xa0]*पुस्तक)?)|エステル[書記]?|أس|ਅਸਤਰ|ऐस्तेर|Aester)|Ester(?:in|[sy])|ester|(?:斯》|《(?:艾斯德爾傳|以斯帖[記记]|斯)|Ес(?:т[ие]р|фір)|Est(?:her|[eè])|أستير|艾斯德爾傳》|以斯帖[記记]》|एस्तरको|אסתר|estarko)|(?:艾斯德爾傳|以斯帖[记記]|斯))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Job"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:أي|ଆୟୁବ[\\s\\xa0]*ପୁସ୍ତକ|Аюб|ヨ[フブ]記?|ای(?:ُّوب|ّوب|وب)|Ι(?:[ωώ]β|β)|J(?:o(?:b(?:s(?:[\\s\\xa0]*(?:Bog|bok)|b[oó]k)|i(?:n[\\s\\xa0]*kirja)?)|v)|b|ób?)|G(?:i(?:obbe|óp)|b)|Ay(?:yoob|u(?:ub|b)?)|I(?:job|ov)|[iī]yob|Книга[\\s\\xa0]*(?:на[\\s\\xa0]*(?:Иова?|Йов)|[ІИЙ]ова)|איוב|سفر[\\s\\xa0]*أيوب|Јов|ayy(?:ubko[\\s\\xa0]*pustak|ūb(?:ko[\\s\\xa0]*pustak)?)|[ईइ]योब|K(?:itabu[\\s\\xa0]*cha[\\s\\xa0]*(?:Ayubu|Yobu)|n(?:jiga[\\s\\xa0]*o[\\s\\xa0]*Jobu|iha[\\s\\xa0]*J[oó]bova)|\\.[\\s\\xa0]*J[oó]bova|[\\s\\xa0]*J[oó]bova|s(?:i(?:[eę]g(?:[ai][\\s\\xa0]*(?:Hioba|Ijoba|Joba)))|\\.[\\s\\xa0]*(?:Hioba|Ijoba|Joba)|[\\s\\xa0]*(?:Hioba|Ijoba|Joba)))|अय(?:्यूब(?:को[\\s\\xa0]*पुस्तक)?|युब)|யோபு(?:டைய[\\s\\xa0]*சரித்திரம்)?|욥기?|Li(?:v[\\s\\xa0]*J[oò]b[\\s\\xa0]*la|ber[\\s\\xa0]*Iob)|《(?:約伯[傳記]》|约伯记》|伯》)|Ἰβ|ਅ(?:ੱਯੂਬ|ਯੂਬ)|Y(?:ōpu|o(?:pu|b))|โยบ|Hi(?:obi?)?)|(?:伯》|Ayubu|أيوب|約伯[記傳]》?|约伯记》?|Hioba|ଆୟୁବ|Іова|[ИЙ]ова?|《(?:約伯[傳記]|约伯记|伯)|Iob|ayy[uū]bko|Yobu|अय्यूबको|J(?:òb|ob(?:in|[sa])?)))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Mal"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:ม(?:าลาคี|ลค)|ମଲାଖି[\\s\\xa0]*ଭବିଷ୍ୟ‌ଦ୍‌ବକ୍ତାଙ୍କ[\\s\\xa0]*ପୁସ୍ତକ|ਮਲਾਕੀ|ﻣﻼﺥ|《(?:玛(?:拉基(?:书》|》)|》)|瑪(?:拉基[亞書]》|》))|மல(?:்கி(?:யா)?|ா(?:க்கி)?)|말(?:라(?:키서|기서?)?)?|مل(?:ا(?:کی)?)?|mal(?:ak(?:ʰ[iī]|ī)|āk(?:ʰ[iī]|[iī]))|எபிரேயம்|Liv[\\s\\xa0]*Malachi[\\s\\xa0]*a|Ks(?:i[eę]g(?:[ai][\\s\\xa0]*Malachiasza)|\\.[\\s\\xa0]*Malachiasza|[\\s\\xa0]*Malachiasza)|Мал(?:ах(?:ија|ія))?|Книга[\\s\\xa0]*(?:на[\\s\\xa0]*пророк[\\s\\xa0]*Малахия|пророка[\\s\\xa0]*Малах(?:ии|і[ії])|Малахі[ії])|سفر[\\s\\xa0]*ملاخي|マラ(?:キ書?)?|M(?:a(?:-?la-?(?:chi|ki)|l(?:ea(?:[ck]hi|hi)|ichi|kiy[aā]|a(?:akii|[hȟ]ija|k(?:ee|i(?:s[\\s\\xa0]*bok|ás|a(?:n[\\s\\xa0]*kirja|s’[\\s\\xa0]*Bog)?)?|í)|qu(?:[ií]as)?|c(?:h(?:i(?:á[sš]|a[sš]?|e))?|i)?)?|ch?)?)|l)|מלאכי|मल(?:ा(?:की(?:को[\\s\\xa0]*पुस्तक)?|खी)|की)|Μα(?:λ(?:αχ[ίι]ας)?)?|Pro(?:roctwo[\\s\\xa0]*Malachyaszowe|phetia[\\s\\xa0]*Malachiae))|(?:Mala(?:kia[sn]|chi(?:asza)?)|Малах(?:і[їі]|и[яи])|malaki|ମଲାଖି|ملاخي|《(?:玛(?:拉基书?)?|瑪(?:拉基[亞書])?)|瑪(?:拉基[書亞]》?|》)?|玛(?:拉基(?:书》?|》)?|》)?))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Matt"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:От[\\s\\xa0]*Матея[\\s\\xa0]*свето[\\s\\xa0]*Евангелие|Injil(?:i[\\s\\xa0]*ya[\\s\\xa0]*Mathayo|[\\s\\xa0]*Matius)|மத்(?:தேயு[\\s\\xa0]*(?:எழுதிய[\\s\\xa0]*(?:சுவிசேஷம்|நற்செய்தி)|நற்செய்தி))?|《(?:[馬马]太福音》|瑪(?:竇福音》|特斐》)|太》)|הבשורה[\\s\\xa0]*(?:הקדושה[\\s\\xa0]*על-?פי[\\s\\xa0]*מתי|על[\\s\\xa0\\-?]*פי[\\s\\xa0]*מתי|לפי[\\s\\xa0]*מתי)|Јеванђеље[\\s\\xa0]*по[\\s\\xa0]*Матеју|ਮੱਤੀ[\\s\\xa0]*ਦੀ[\\s\\xa0]*ਇੰਜੀਲ|Ungjilli[\\s\\xa0]*i[\\s\\xa0]*Mateut|Μ(?:ατθ(?:α[ίι]ος)?|θ)|The[\\s\\xa0]*Gospel[\\s\\xa0]*(?:according[\\s\\xa0]*to[\\s\\xa0]*(?:S(?:aint[\\s\\xa0]*M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:h(?:(?:[ht](?:iew|ew))|iew|ew|we)|iew|t(?:h(?:iew|ew)|iew|ew)|ew|we)?)?|t)|t(?:\\.[\\s\\xa0]*M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:h(?:(?:[ht](?:iew|ew))|iew|ew|we)|iew|t(?:h(?:iew|ew)|iew|ew)|ew|we)?)?|t)|[\\s\\xa0]*M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:h(?:(?:[ht](?:iew|ew))|iew|ew|we)|iew|t(?:h(?:iew|ew)|iew|ew)|ew|we)?)?|t)))|M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:h(?:(?:[ht](?:iew|ew))|iew|ew|we)|iew|t(?:h(?:iew|ew)|iew|ew)|ew|we)?)?|t))|of[\\s\\xa0]*(?:S(?:aint[\\s\\xa0]*M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:h(?:(?:[ht](?:iew|ew))|iew|ew|we)|iew|t(?:h(?:iew|ew)|iew|ew)|ew|we)?)?|t)|t(?:\\.[\\s\\xa0]*M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:h(?:(?:[ht](?:iew|ew))|iew|ew|we)|iew|t(?:h(?:iew|ew)|iew|ew)|ew|we)?)?|t)|[\\s\\xa0]*M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:h(?:(?:[ht](?:iew|ew))|iew|ew|we)|iew|t(?:h(?:iew|ew)|iew|ew)|ew|we)?)?|t)))|M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:h(?:(?:[ht](?:iew|ew))|iew|ew|we)|iew|t(?:h(?:iew|ew)|iew|ew)|ew|we)?)?|t)))|マタイ(?:による福音書|傳福音書|福音書|[伝書])|مت(?:ّی[\\s\\xa0]*کی[\\s\\xa0]*انجیل|ی[\\s\\xa0]*کی[\\s\\xa0]*انجیل)?|E(?:l[\\s\\xa0]*Evangelio[\\s\\xa0]*de[\\s\\xa0]*Mateo|banghelyo[\\s\\xa0]*(?:ayon[\\s\\xa0]*kay[\\s\\xa0]*Mateo|ni[\\s\\xa0]*(?:San[\\s\\xa0]*Mateo|Mateo))|van(?:keliumi[\\s\\xa0]*Matteuksen[\\s\\xa0]*mukaan|geli(?:e(?:[\\s\\xa0]*volgens[\\s\\xa0]*Matte[uü]s|t[\\s\\xa0]*etter[\\s\\xa0]*Matteus)|um[\\s\\xa0]*(?:secundum[\\s\\xa0]*Matthaeum|podle[\\s\\xa0]*Matou[sš]e))|jelium[\\s\\xa0]*Pod[lľ]a[\\s\\xa0]*Mat(?:[uú](?:[sš]a))|[ðđ]elje[\\s\\xa0]*po[\\s\\xa0]*Mateju)|w(?:angelia[\\s\\xa0]*(?:w(?:edług[\\s\\xa0]*(?:[sś]w(?:\\.[\\s\\xa0]*Mateusza|[\\s\\xa0]*Mateusza))|g[\\s\\xa0]*(?:[sś]w(?:\\.[\\s\\xa0]*Mateusza|[\\s\\xa0]*Mateusza)))|Mateusza)|\\.[\\s\\xa0]*Mateusza|[\\s\\xa0]*Mat(?:eusza)?))|Vangelo[\\s\\xa0]*di[\\s\\xa0]*(?:San[\\s\\xa0]*Matteo|Matteo)|matt(?:ay[aā]ne[\\s\\xa0]*lihilele[\\s\\xa0]*(?:[sŝ]ubʰavartam(?:[aā]n))|ile[\\s\\xa0]*lekʰeko[\\s\\xa0]*susm[aā]c(?:[aā]r)|ī(?:le[\\s\\xa0]*lekʰeko[\\s\\xa0]*susm[aā]c(?:[aā]r)|[\\s\\xa0]*(?:kī[\\s\\xa0]*injīl|dī[\\s\\xa0]*ĩjīl)))|M(?:a(?:buting[\\s\\xa0]*Balita[\\s\\xa0]*ayon[\\s\\xa0]*kay[\\s\\xa0]*(?:San[\\s\\xa0]*Mateo|Mateo)|-?thi-?ơ|t(?:h|[úu][sš]|é(?:us)?|ye|ou(?:[sš](?:ovo[\\s\\xa0]*evangelium)?)|ayos?|e(?:[ij]|u(?:sz?)?)?|t(?:æusevangeliet|ēyu[\\s\\xa0]*Na[rṛ]ceyti|e(?:i[\\s\\xa0]*evangelium|u(?:ksen[\\s\\xa0]*evankeliumi|s(?:arguðspjall|evangeliet))|yu[\\s\\xa0]*Na[rṛ]ceyti|e)|h(?:a(?:eus|us)|[eé](?:[uü]s)|ieu|äus|æus(?:evangeliet)?)?)))|át(?:thêu|[eé])|t[ht])|พระวรสารนักบุญแม็ทธิว|마태(?:오[\\s\\xa0]*복음서?|복음서?)?|إنجيل[\\s\\xa0]*متى|Еван(?:гелие(?:то[\\s\\xa0]*според[\\s\\xa0]*Матеј|[\\s\\xa0]*(?:според[\\s\\xa0]*Матеј|от[\\s\\xa0]*Мат(?:фея|е[ий])))|ђеље[\\s\\xa0]*по[\\s\\xa0]*Матеју)|Jevan(?:helije[\\s\\xa0]*vid[\\s\\xa0]*Matvija|đelje[\\s\\xa0]*po[\\s\\xa0]*Mateju)|Sulat[\\s\\xa0]*ni[\\s\\xa0]*San[\\s\\xa0]*Mateo|Κατ[άα][\\s\\xa0]*Ματθα(?:[ίι]ον)|ม(?:ัทธิว|ธ)|Євангелі(?:я[\\s\\xa0]*від[\\s\\xa0]*(?:св(?:\\.[\\s\\xa0]*Матвія|[\\s\\xa0]*Матвія)|Матвія)|є[\\s\\xa0]*від[\\s\\xa0]*(?:св(?:\\.[\\s\\xa0]*Матвія|[\\s\\xa0]*Матвія)|Мат(?:вія|ея)))|М(?:ат(?:еја|а[ий])?|[тф])|मत्त(?:य(?:ाने[\\s\\xa0]*लिहिलेले[\\s\\xa0]*शुभवर्तमान)?|ि|ी(?:ले[\\s\\xa0]*लेखेको[\\s\\xa0]*सुसमाचार|को[\\s\\xa0]*सुसमाचार)?)|ମାଥିଉ[\\s\\xa0]*ଲିଖିତ[\\s\\xa0]*ସୁସମାଗ୍ଭର)|(?:太》|Від[\\s\\xa0]*Матвія|ମାଥିଉ|मत्त(?:याने|ीले)|matt(?:ay[aā]ne|ile|ī(?:le)?)|Evangelio[\\s\\xa0]*de[\\s\\xa0]*Mateo|От[\\s\\xa0]*Мат(?:фея|ея)|《(?:[马馬]太福音|瑪(?:竇福音|特斐)|太)|Gospel[\\s\\xa0]*(?:according[\\s\\xa0]*to[\\s\\xa0]*(?:S(?:aint[\\s\\xa0]*M(?:at(?:h(?:(?:[ht](?:(?:[th](?:iew|ew))|iew|ew))|iew|ew)|t(?:t(?:h(?:iew|ew)|iew|ew)|h(?:(?:[ht](?:iew|ew))|iew|ew|we)|iew|we|ew)?)?|t)|t(?:\\.[\\s\\xa0]*M(?:at(?:h(?:(?:[th](?:iew|(?:[ht](?:iew|ew))|ew))|iew|ew)|t(?:h(?:iew|(?:[th](?:iew|ew))|ew|we)|t(?:h(?:iew|ew)|iew|ew)|iew|we|ew)?)?|t)|[\\s\\xa0]*M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:t(?:h(?:iew|ew)|iew|ew)|iew|h(?:iew|(?:[th](?:iew|ew))|we|ew)|we|ew)?)?|t)))|M(?:at(?:h(?:(?:[ht](?:(?:[th](?:iew|ew))|iew|ew))|iew|ew)|t(?:h(?:iew|(?:[th](?:iew|ew))|we|ew)|iew|t(?:h(?:iew|ew)|iew|ew)|ew|we)?)?|t))|of[\\s\\xa0]*(?:S(?:aint[\\s\\xa0]*M(?:at(?:h(?:(?:[th](?:(?:[th](?:iew|ew))|iew|ew))|iew|ew)|t(?:t(?:iew|h(?:iew|ew)|ew)|iew|h(?:(?:[ht](?:iew|ew))|iew|ew|we)|ew|we)?)?|t)|t(?:\\.[\\s\\xa0]*M(?:at(?:h(?:(?:[ht](?:iew|(?:[ht](?:iew|ew))|ew))|iew|ew)|t(?:iew|t(?:iew|h(?:iew|ew)|ew)|h(?:iew|(?:[th](?:iew|ew))|we|ew)|ew|we)?)?|t)|[\\s\\xa0]*M(?:at(?:h(?:(?:[th](?:(?:[th](?:iew|ew))|iew|ew))|iew|ew)|t(?:t(?:iew|h(?:iew|ew)|ew)|iew|h(?:iew|(?:[th](?:iew|ew))|ew|we)|ew|we)?)?|t)))|M(?:at(?:h(?:(?:[ht](?:iew|(?:[th](?:iew|ew))|ew))|iew|ew)|t(?:iew|h(?:(?:[th](?:iew|ew))|iew|ew|we)|t(?:h(?:iew|ew)|iew|ew)|we|ew)?)?|t)))|ਮੱਤੀ|[馬马]太福音》?|மத்தேயு|مت(?:ّی|[یى])|Мат(?:вія|е[йји])|M(?:at(?:[úu](?:[šs]a)|ius|h(?:ayo|(?:[ht](?:iew|(?:[ht](?:iew|ew))|ew))|iew|ew)|eo|t(?:t(?:iew|h(?:iew|ew)|ew)|ēyu|iew|h(?:iew|(?:[th](?:iew|ew))|ew|we)|we|e(?:yu|u(?:ksen|s)|üs|[wo]))?)?|t)|瑪(?:竇福音》?|特斐》?)|S(?:a(?:n[\\s\\xa0]*Mateo|int[\\s\\xa0]*M(?:at(?:h(?:(?:[ht](?:(?:[th](?:iew|ew))|iew|ew))|iew|ew)|t(?:t(?:h(?:iew|ew)|iew|ew)|h(?:(?:[ht](?:iew|ew))|iew|ew|we)|iew|we|ew)?)?|t))|t(?:\\.[\\s\\xa0]*M(?:at(?:h(?:(?:[th](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:iew|h(?:iew|(?:[th](?:iew|ew))|we|ew)|t(?:iew|h(?:iew|ew)|ew)|we|ew)?)?|t)|[\\s\\xa0]*M(?:at(?:h(?:(?:[th](?:(?:[th](?:iew|ew))|iew|ew))|iew|ew)|t(?:t(?:h(?:iew|ew)|iew|ew)|iew|h(?:(?:[th](?:iew|ew))|iew|we|ew)|we|ew)?)?|t)))))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Ps"],
        extra: "1",
        regexp: RegExp("(\\b)((?:(?:(?:1[02-5]|[2-9])?(?:1" + bcv_parser.prototype.regexps.space + "*st|2" + bcv_parser.prototype.regexps.space + "*nd|3" + bcv_parser.prototype.regexps.space + "*rd))|1?1[123]" + bcv_parser.prototype.regexps.space + "*th|(?:150|1[0-4][04-9]|[1-9][04-9]|[4-9])" + bcv_parser.prototype.regexps.space + "*th)" + bcv_parser.prototype.regexps.space + "*Psalm)\\b", "gi")
      }, {
        osis: ["Ps"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(zabūr|(?:M(?:ga[\\s\\xa0]*(?:Salmo|Awit)|asmur)|தி(?:ருப்பாடல்(?:கள்)?|பா)|Th(?:i[\\s\\xa0]*Thiên|ánh[\\s\\xa0]*(?:vịnh|Thi))|stotrasa[mṃ]hit[aā]|Книга[\\s\\xa0]*Псалмів|Ψα(?:λμ(?:ο(?:[ίι][\\s\\xa0]*του[\\s\\xa0]*Δαυ(?:[ίι]δ)|ς)|ός))?|詩(?:篇/聖詠|編)|Ž(?:al(?:t[aá]r|my?))?|مز(?:مور)?|Пс(?:ал(?:ти(?:́р|рь?)|[ао]м|м(?:и[\\s\\xa0]*Давидови|ы))?)?|시편?|מזמורים|زب(?:ور|ُور?)|Заб(?:ур)?|bʰaǳansa[mṃ]grah|สด(?:ุดี|ด)|S(?:álmarnir|a(?:buur(?:radii)?|l(?:m(?:a(?:rnir|u)|os|e(?:rne(?:s[\\s\\xa0]*Bog)?|ne(?:s[\\s\\xa0]*bok)?)?|[is])?)?)|lm?)|سفر[\\s\\xa0]*المزامير|Z(?:solt(?:[aá]rok)?|a(?:l(?:t[aá]r|my?)|b(?:uri?)?))?|स्त(?:्रोत्रसंहिता|ोत्र(?:संहिता)?)|சங(?:கீதம்|்(?:கீ(?:த(?:[\\s\\xa0]*புத்தகம்|ங்கள்|ம்))?)?)|ਜ(?:਼ਬੂਰ|ਬੂਰ)|ଗ(?:ାତସଂହିତା|ୀତ(?:ିସଂହିତା|ସଂହିତା))|Jabur|《(?:聖詠集》|(?:[詩诗](?:篇》|》)))|Ca(?:rtea[\\s\\xa0]*Psalmilor|[nṅ]k(?:[iī]tam))|תהילים|P(?:a(?:l(?:[lm]s|sms?)|m[ls]s|s(?:lms?|m(?:ls|s)|ss))|l(?:a(?:as?|m(?:as|s)?|s(?:m(?:as?|s)?|s)?)|ms|s(?:a(?:ms?)?|ms?|s(?:s(?:ss?)?)?))|s(?:l(?:a(?:lms?|ms?)?|m(?:as|[ms])?)|a(?:a(?:lms?|ms|a)|l(?:taren|lms?|a(?:ms?|s)?|m(?:u[ls]|a[su]?|e[nt]?|i(?:en[\\s\\xa0]*kirja|[it])?|[lm]s?|[sy])?|s)?|m(?:as|l(?:[as]|ms?)?|ms?|s)?|u(?:mes?)?)?|m(?:a(?:l(?:ms?|s)?)?|ls?|m)?|sm?)?)|Li(?:b(?:ri[\\s\\xa0]*i[\\s\\xa0]*Psalmeve|er[\\s\\xa0]*Psalmorum)|v[\\s\\xa0]*S[oò]m[\\s\\xa0]*yo)|भजन(?:-?सहिन्ता|[\\s\\xa0]*संहिता|स(?:ंग्रह|ग्रह))|K(?:niha[\\s\\xa0]*(?:[zž]alm(?:ov|[uů]))|s(?:i[eę]g(?:[ai][\\s\\xa0]*Psalm(?:[oó]w))|\\.[\\s\\xa0]*Psalm[oó]w|[\\s\\xa0]*Psalm[oó]w)|\\.[\\s\\xa0]*[zž]almov|[\\s\\xa0]*[zž]almov)|เพลงสดุดี|الم(?:َزمُور|زمور)|Bhjan)|(?:聖詠集》?|Awit|Thi|Ψαλμο[ίι]|المزامير|Псалм(?:ів|и)|《(?:聖詠集|[詩诗]篇?)|S(?:alm(?:enes|o)|[òo]m)|भजन|(?:[诗詩](?:篇》?|》)?)|Psalmien))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Eccl"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Ec(?:cless[ai](?:[ai]t(?:[eé]s?))|les(?:s[ai](?:[ai]t(?:[eé]s?))|a[ai]t(?:[eé]s?)))|(?:Проп(?:ов(?:ідника|едник))?|K(?:niha[\\s\\xa0]*kazate[lľ]ova|\\.[\\s\\xa0]*kazate[lľ]ova|[\\s\\xa0]*kazate[lľ]ova|s(?:i(?:[eę]g(?:[ai][\\s\\xa0]*(?:Eklezjastesa|K(?:aznodziei[\\s\\xa0]*Salomona|oheleta))))|\\.[\\s\\xa0]*(?:Eklezjastesa|K(?:aznodziei[\\s\\xa0]*Salomona|oheleta))|[\\s\\xa0]*(?:Eklezjastesa|K(?:aznodziei[\\s\\xa0]*Salomona|oheleta)))|a(?:alam|z(?:n(?:odziei[\\s\\xa0]*Salomonowego)?)?)|oh(?:elet(?:[\\s\\xa0]*—[\\s\\xa0]*Kazate[lľ]|h))?)|E(?:k(?:kle(?:siastes|zijast)|l(?:e(?:s[iy]ast(?:[eé]s)|z(?:yas[\\s\\xa0]*-?[\\s\\xa0]*Liv[\\s\\xa0]*Filoz[oò]f[\\s\\xa0]*la|iastes))|is[iy]astes)?)|c(?:c(?:l(?:es(?:s[ai](?:[ai]st(?:[eé]s?))|a(?:stes|a(?:st[eé]s?|t[eé]s?)|i(?:astes|st[eé]s?|t[eé]s?))|i(?:stes|a(?:i(?:astes|stes)|a(?:stes|tes)|st(?:i(?:c[eé]s|[eé]s)|ul|e|és?)?|t[eé]s?)|i(?:astes|st[eé]s?|t[eé]s?)|tes))?|és(?:iaste)?)?)?|l(?:is[iy]astes|e(?:ziast(?:ul)?|s(?:s[ai](?:[ai]st(?:[eé]s?))|yast[eé]s|a[ai]st(?:[eé]s?)|i(?:stes|a(?:iastes|st(?:i(?:c[eé]s|[eé]s)|ul|[eé]s?)|t[eé]s?)|i(?:st[eé]s?|t[eé]s?)))?))?)?)|Juru[\\s\\xa0]*Kotbah|سفر[\\s\\xa0]*الجامعة|전(?:도서)?|ச(?:ங்கத்[\\s\\xa0]*திருவுரை[\\s\\xa0]*ஆகமம்|பை[\\s\\xa0]*உரையாளர்|உ)|P(?:iraca[nṅ]ki|r(?:ad|e(?:d(?:i(?:ger|k(?:a(?:ntens[\\s\\xa0]*bok|r(?:boken|inn|en(?:s[\\s\\xa0]*bok)?)|tor)|uesi|átor|er(?:ens?)?)))?|g(?:ethwr)?)|op(?:ovjednik)?|æd(?:ikeren(?:s[\\s\\xa0]*Bog)?)?|éd(?:ik(?:a(?:rinn|tor)|átor))?))|vāʿẓ|К(?:нига[\\s\\xa0]*(?:на[\\s\\xa0]*Еклисиаста[\\s\\xa0]*или[\\s\\xa0]*Проповедника|Ек(?:лезіястова|кле(?:зіястова|сиаста)))|оге́лет)|ป(?:ัญญาจารย์|ญจ)|コヘレト(?:の(?:こと[はば]|言葉))?|பிரச(?:ங்கி)?|واع(?:ِظ|ظ)|ଉପଦେଶକ|उपदेशक(?:को[\\s\\xa0]*पुस्तक)?|جا|《(?:訓道篇》|传(?:道书》|》)|傳(?:道書》|》))|Εκ(?:κλησιαστ[ήη]ς)?|Ang[\\s\\xa0]*Mangangaral|Ἐκ|Truyền[\\s\\xa0]*đạo|המ(?:קהיל|רצה)|Ек(?:к(?:л(?:е(?:зіяста?|сиаст))?)?|л(?:[еи]сиаст)?)|Wac(?:diyah(?:ii|a))?|Fork(?:ynneren(?:s[\\s\\xa0]*bok)?)?|Разм(?:ышления)?|Sa(?:bhopadeshak|ar(?:n(?:aaja(?:n[\\s\\xa0]*kirja)?)?)?)|傳道之書|伝道の書|upade(?:(?:[sš]ak(?:ko[\\s\\xa0]*pustak)?)|ŝak)|קהלת|ਉਪਦੇਸ਼ਕ|Co[eé]let|코헬렛?|Liber[\\s\\xa0]*(?:Ecclesiastes|Qoelet)|सभो(?:पदेशक)?|Qo(?:èlet|h(?:eleth?|èlet)?)?|M(?:a(?:gwawali|nga)|hu(?:biri)?)|Gi(?:áo[\\s\\xa0]*huấn|ảng[\\s\\xa0]*Sư))|(?:《(?:訓道篇|传(?:道书)?|傳(?:道書)?)|K(?:azate[lľ]|ohelet)|upade[šs]akko|Ек(?:клезіястова|л(?:езіястова|исиаста))|Liv[\\s\\xa0]*Filoz[òo]f[\\s\\xa0]*la|Qoelet|الجامعة|उपदेशकको|訓道篇》?|Giáo|E(?:cclesiastes|klezyas)|传(?:道书》?|》)?|Filoz[oò]f|Mangangaral|Проповедника|傳(?:道書》?|》)?|Saarnaajan))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Ezek"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:《(?:以西(?:結[书書]》|结书》)|厄則克耳》|[結结]》)|hizkīel|Ιεζ(?:εκ(?:ι[ήη]λ)?|κ)?|iǳakielko[\\s\\xa0]*pustak|Јез(?:екиљ)?|ଯିହିଜିକଲ[\\s\\xa0]*ଭବିଷ୍ୟ‌ଦ୍‌ବକ୍ତାଙ୍କ[\\s\\xa0]*ପୁସ୍ତକ|Iezechiel|Y(?:ahejakel|éh[eè]zki(?:[eè]l)|e(?:h(?:e(?:skiel|zki[eè]l)|èzki[eè]l)|x(?:esqeel)?))|Книга[\\s\\xa0]*(?:на[\\s\\xa0]*пророк[\\s\\xa0]*(?:Иезекииля|Езекиил)|пророка[\\s\\xa0]*(?:Иезекииля|Єзекі[ії]ля))|yahe(?:dzkel|ǳkel)|יחזקאל|எசே(?:க்கியேல்[\\s\\xa0]*தீர்க்கதரிசியின்[\\s\\xa0]*புத்தகம்)?|ḥiziqīʾīl|यहेज(?:्केल|केल)?|Prophetia[\\s\\xa0]*Ezechielis|อสค|Éz(?:[eé]ch(?:iel)?)|᾿Ιζ|He(?:zechiel|s(?:ekiel(?:in[\\s\\xa0]*kirja|s[\\s\\xa0]*bok)?)?)|ح(?:ِزقی[\\s\\xa0]*ایل|ز(?:قی[\\s\\xa0‌]*ایل)?)|เอเสเคียล|Ks(?:i[eę]g(?:[ai][\\s\\xa0]*Ezechiela)|\\.[\\s\\xa0]*Ezechiela|[\\s\\xa0]*Ezechiela)|겔|سفر[\\s\\xa0]*حزقيال|E(?:c[eē]kkiy(?:[eē]l)|x(?:[ei](?:(?:[ei]k(?:iel|el))|k(?:iel|el)))|s(?:e(?:c(?:iel)?|k(?:iel(?:s[\\s\\xa0]*bok)?|[yí]el)?)|k)|z(?:i(?:(?:[ei](?:qu(?:iel|el)|k(?:iel|el)))|qu(?:iel|el)|k(?:iel|el))|e(?:(?:[ei](?:qu(?:iel|el)|k(?:iel|el)))|c(?:iel|h(?:i(?:ele?|ël))?)?|k(?:i(?:al|el(?:s(?:’[\\s\\xa0]*Bog|[\\s\\xa0]*Bog)|i)?)|el)?|q(?:u(?:i[ae]l|el)?)?)?|[kq]|é(?:kiel|ch(?:iel)?)?))|Єз(?:екі[ії]л[аь])?|Ê-?xê-?(?:chi(?:-?ên|ên)|ki-?ên)|에(?:스겔서?|제(?:키엘서?)?)|Езек(?:и(?:ел|л))?|इजकिएल(?:को[\\s\\xa0]*पुस्तक)?|Йез(?:екиил)?|エ[セゼ]キエル書?|Jezeki[iï]l['’]|Иез(?:екииль?)?|Liv[\\s\\xa0]*Ezeky[eè]l[\\s\\xa0]*la|ਹਿਜ਼ਕੀਏਲ)|(?:[結结]》?|iǳakielko|Иезекииля|इजकिएलको|Єзекі[їі]ля|以西(?:結[書书]》?|结书》?)|《(?:厄則克耳|以西(?:结书|結[書书])|[结結])|Eze(?:chiela|ky[èe]l)|حزقيال|Hesekielin|எசேக்கியேல்|Езекиил|ଯିହିଜିକଲ|Ê-?xê|厄則克耳》?))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Hos"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Ho(?:se(?:ias?|ás|a(?:s(?:’[\\s\\xa0]*Bog|[\\s\\xa0]*bok))?)|šea)|(?:Ōciy[aā]|Liv[\\s\\xa0]*Oze[\\s\\xa0]*a|سفر[\\s\\xa0]*هوشع|होशे(?:को[\\s\\xa0]*पुस्तक|य)?|O(?:ciy[aā]|s(?:ija|e(?:ia[hs]?|a[hs]?)|é(?:ias|e))?|z(?:e[aá][sš])?)|Ὠσ|Prophetia[\\s\\xa0]*Osee|ஒசேயா|Ô-?sê|Ks(?:i[eę]g(?:[ai][\\s\\xa0]*Ozeasza)|\\.[\\s\\xa0]*Ozeasza|[\\s\\xa0]*Ozeasza)|Книга[\\s\\xa0]*(?:на[\\s\\xa0]*пророк[\\s\\xa0]*Осия|пророка[\\s\\xa0]*Ос(?:ии|і[ії]))|ホセア(?:しょ|書)?|h(?:ūsīʿ|o(?:ŝey|sey?|šeā?))|ஓச(?:[ிே](?:யா)?)|ହୋଶ(?:େୟ[\\s\\xa0]*ଭବିଷ୍ୟ‌ଦ୍‌ବକ୍ତାଙ୍କ[\\s\\xa0]*ପୁସ୍ତକ|ହେ)|ฮชย|ہو(?:[\\s\\xa0]*سیعاہ|سیع(?:َِ)?)|הושע|H(?:ô-?sê-?a|ós(?:e(?:ás|as?))?|o(?:ze[aá][sš]|os(?:ean[\\s\\xa0]*kirja|h(?:eeca)?)?|s(?:ho)?|š)?|s)|โฮเชยา(?:ห์)?|《(?:歐瑟亞》|何(?:西阿[书書]》|》))|호(?:세(?:아서?)?)?|Ωσ(?:η[έε])?|ਹੋਸ਼ੇਆ|Хошеа|Ос(?:ија|ія)?|هو)|(?:Ho(?:osean|seas)|ହୋଶେୟ|Ос(?:и[яи]|і[ії])|هوشع|O(?:see|ze(?:asza)?)|歐瑟亞》?|《(?:歐瑟亞|何(?:西阿[書书])?)|何(?:西阿[书書]》?|》)?))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Obad"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:Авд(?:иј[ае]?)?|obad(?:iy[aā]|yāh|ʰ[aā])|Ов(?:адија|д(?:і[ий])?)?|ʿabadiyāh|ע(?:ובדיה|בדיה)|ओब(?:द(?:िया(?:को[\\s\\xa0]*पुस्तक)?|्(?:दाह|याह?))|ेधाह|धाह?)?|Ô-?ba-?đi-?a|Αβδ(?:ιο[υύ])?|โอบาดี[ยห]์|Cob(?:ad(?:yaah)?)?|《(?:亞北底亞》|俄(?:巴底(?:亚书》|亞書》)|》))|Liv[\\s\\xa0]*Abdyas[\\s\\xa0]*la|O(?:patiy[aā]|v(?:adia|dij)|b(?:edi[aá][sš]|idah|a(?:ja|d(?:eia|hah|i(?:ja|á[sš]|a(?:s['’][\\s\\xa0]*Bog|[hš])?)|ía|j(?:a(?:n[\\s\\xa0]*kirja|s[\\s\\xa0]*bok|š)?|á[sš]?)?)?)?|d)?)|오바(?:드야서|디야|댜서?)?|ଓବଦିଅ[\\s\\xa0]*ଭବିଷ୍ୟ‌ଦ୍‌ବକ୍ତାଙ୍କ[\\s\\xa0]*ପୁସ୍ତକ|อบด|Книга[\\s\\xa0]*(?:на[\\s\\xa0]*пророк[\\s\\xa0]*Авди[ий]|пророка[\\s\\xa0]*(?:Авд[иі]я|Овдія))|Áp-?đia|ਓਬਦਯਾਹ|ஒப(?:தி(?:யா)?)?|Ób(?:ad[ií]a)?|Pro(?:roctwo[\\s\\xa0]*Abdyaszowe|phetia[\\s\\xa0]*Abdiae)|Οβδ[ίι]ας|オ(?:[ハバ](?:[テデ](?:ア書|ヤ(?:しょ|書)?))?)|옵|Ἀβδ|سفر[\\s\\xa0]*عوبديا|ع(?:بدیاہ|و)|A(?:vdie|b(?:d(?:ías|i(?:j[aá][sš]|á[sš]|a[sš]?))?)?)|Ks(?:i[eę]g(?:[ai][\\s\\xa0]*Abdiasza)|\\.[\\s\\xa0]*Abdiasza|[\\s\\xa0]*Abdiasza))|(?:亞北底亞》?|ଓବଦିଅ|عوبديا|Овдія|俄(?:巴底(?:亚书》?|亞書》?)|》)?|Авд(?:ія|и[ийя])|Abd(?:iasza|yas)|Áp|Obad(?:ias|ja[ns])|《(?:亞北底亞|俄(?:巴底(?:亚书|亞書))?)))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Hag"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:Книга[\\s\\xa0]*(?:на[\\s\\xa0]*пророк[\\s\\xa0]*Аге[ий]|пророка[\\s\\xa0]*(?:Аггея|Огія)|Огія)|ହାଗୟ[\\s\\xa0]*ଭବିଷ୍ୟ‌ଦ୍‌ବକ୍ତାଙ୍କ[\\s\\xa0]*ପୁସ୍ତକ|حج(?:َّ[يی]|اي|يّ|ی)?|Ог(?:і[ий])?|ハ(?:[カガ]イ(?:しょ|書)?)|Хагај|ḥajjai|학(?:개서?)?|A(?:-?g(?:ai|hê)|k[aā]y|g(?:heu|ai|e(?:[jo]|us?)|g(?:a(?:eus|us)|äus|e(?:us|[eo])|ée)?)?)|Ohij|हाग्ग(?:[ये]|ै(?:को[\\s\\xa0]*पुस्तक)?)|سفر[\\s\\xa0]*حجي|h(?:a(?:gg(?:ay|əi)|jjaī)|āgg(?:ay|əi))|ஆகா(?:ய்)?|Āk[aā]y|Xag(?:g(?:ay)?)?|Αγ(?:γα[ίι]ος)?|חגי|ਹੱਜਈ|H(?:a(?:-?gai|g(?:a[ij]|e[jo]|g(?:ia[hi]|a(?:ai|i(?:n[\\s\\xa0]*kirja|s[\\s\\xa0]*bok)?|j(?:s[\\s\\xa0]*Bog)?|[íï])|e(?:us|o))?)?)|gg?)|Liv[\\s\\xa0]*Aje[\\s\\xa0]*a|Pro(?:roctwo[\\s\\xa0]*Aggieuszowe|phetia[\\s\\xa0]*Aggaei)|Ἀγ|Аг(?:еј|г(?:е[ий])?)?|Ks(?:i[eę]g(?:[ai][\\s\\xa0]*Aggeusza)|\\.[\\s\\xa0]*Aggeusza|[\\s\\xa0]*Aggeusza)|《(?:哈(?:該[书書]》|该书》|蓋》)|[該该]》)|ฮ(?:ักกัย|กก)|하(?:까(?:이서)?|깨))|(?:[該该]》?|《(?:哈(?:該[书書]|该书|蓋)|[該该])|حجي|Огія|Haggain|哈(?:该书》?|該[书書]》?|蓋》?)|Аг(?:гея|е[ий])|ହାଗୟ|A(?:ggeusza|je)))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Hab"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(habak(?:kūk|ūk)|(?:سفر[\\s\\xa0]*حبقوق|חבקוק|Xab(?:aquuq)?|ฮ(?:าบากุก|บก)|Pro(?:roctwo[\\s\\xa0]*Abakukowe|phetia[\\s\\xa0]*Habacuc)|A(?:pak[uū]k|va[ck]um|b(?:a(?:cuc|k(?:ouk|uka?)?)|k))|Ha(?:-?ba-?cúc|b(?:ba(?:c[au]c|k(?:k[au]kk?|[au]kk?))|a(?:c(?:uque|cuc|kuk|ac)?|k(?:k(?:ook|akk?|uk(?:s[\\s\\xa0]*(?:Bog|bok)|k)?)|akk?|uk(?:i(?:n[\\s\\xa0]*kirja)?|[ku])?)?)|[ck])?)|Ав(?:ак|в(?:акум)?)?|ḥabaqqūq|Āpak[uū]k|Α(?:μβακο[υύ]μ|β(?:βακο[υύ]μ)?)|Ks(?:i[eę]g(?:[ai][\\s\\xa0]*Habakuka)|\\.[\\s\\xa0]*Habakuka|[\\s\\xa0]*Habakuka)|Ха[бв]акук|《哈(?:巴谷(?:[书書]》|》)|》)|ハ(?:[ハバ]クク(?:しょ|書)?)|हबक(?:्कूक?|ूक(?:को[\\s\\xa0]*पुस्तक)?)?|ହବ(?:‌କ୍‌କୂକ[\\s\\xa0]*ଭବିଷ୍ୟ‌ଦ୍‌ବକ୍ତାଙ୍କ[\\s\\xa0]*ପୁସ୍ତକ|କ[ୁୂ]କ୍)|Liv[\\s\\xa0]*Abakik[\\s\\xa0]*la|حب(?:ق(?:ُّوق|ّوق))?|Ἀβ|합|하(?:박국서?|바(?:쿡서|꾹)?)|அப(?:க்கூக்கு)?|ਹਬ(?:ੱਕੂਕ|ਕ(?:ੱੂਕ|ੂਕ))|Книга[\\s\\xa0]*(?:на[\\s\\xa0]*пророк[\\s\\xa0]*Авакума?|пророка[\\s\\xa0]*Ав(?:вакума|акума))|ஆப(?:கூக்)?)|(?:ହବ‌କ୍‌କୂକ|Haba(?:kuk(?:in|a)|cuc)|habak(?:kuk|uk)|Abakik|Ав(?:вакума|акума?)|حبقوق|《哈(?:巴谷[書书]?)?|哈(?:巴谷(?:[書书]》?|》)?|》)?))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Mic"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(m(?:ikʰ[aā]|īkāh)|(?:م(?:ِیکاہ|یکاہ|ي)|mīkʰ[aā]|Liv[\\s\\xa0]*Miche[\\s\\xa0]*a|Μ(?:ΙΧΑ(?:Ϊ́ΑΣ|[ΊΙ]ΑΣ)|ιχαΐας|χ)|M(?:eeka|y[hȟ]ej|īk[aā]|i(?:-?c(?:hê|a)|ik(?:a(?:n[\\s\\xa0]*kirja|ah)?)?|c(?:ah?|h(?:äas|e(?:á[sš]|a[sš]?|e)|ée|a(?:eas|[aá][sš]|h)?)?)?|h(?:e(?:ia|j))?|k(?:ieas|e(?:yas|ás|as?)|ha|a(?:s[\\s\\xa0]*(?:Bog|bok)|h)?|ā)?|q(?:u(?:éias|e(?:ias|as)))?)|íka?|q)|М(?:их(?:еј|а)?|іх)|ମ(?:ୀଖା[\\s\\xa0]*ଭବିଷ୍ୟ‌ଦ୍‌ବକ୍ତାଙ୍କ[\\s\\xa0]*ପୁସ୍ତକ|ିଖା)|מיכה|மீக(?:ா|்(?:கா)?)|سفر[\\s\\xa0]*ميخا|《(?:米該亞》|弥(?:迦书》|》)|彌(?:迦書》|》))|ม(?:ีคาห์|คา)|ミカ(?:しょ|書)?|미(?:[가카]서?)?|Ks(?:i[eę]g(?:[ai][\\s\\xa0]*Micheasza)|\\.[\\s\\xa0]*Micheasza|[\\s\\xa0]*Micheasza)|Книга[\\s\\xa0]*(?:на[\\s\\xa0]*пророк[\\s\\xa0]*Михе[ий]|пророка[\\s\\xa0]*М[иі]хея)|म(?:िका|ी(?:का(?:को[\\s\\xa0]*पुस्तक)?|खा))|ਮੀਕਾਹ|Prophetia[\\s\\xa0]*Michaeae)|Mikas|(?:ميخا|Mi(?:ikan|che(?:asza)?)|ମୀଖା|m[īi]k[āa]|弥(?:迦书》|》)|彌(?:迦書》|》)|《(?:米該亞|彌(?:迦書)?|弥(?:迦书)?)|М(?:іхея|ихе[йия])|米該亞》|Μιχα[ιί]ας)|(?:米該亞|彌(?:迦書)?|弥(?:迦书)?))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Zech"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Zech[ae]ra(?:(?:[ai]h|h))|zakar(?:iyāh|yāh)|(?:ज(?:क(?:यार्ह|र(?:्याह|िया(?:को[\\s\\xa0]*पुस्तक)?))|ख[रऱ]्या)|Jakaryah|S(?:a(?:c(?:ar[ií]as|h(?:arja)?)|k(?:ar(?:ias?|ja(?:n[\\s\\xa0]*kirja|boken|s[\\s\\xa0]*bok)?|ía))?)|e(?:ch(?:areia)?|k(?:aryaah)?))|(?:[セゼ]カリヤ(?:しょ|書)?)|Prophetia[\\s\\xa0]*Zachariae|Ks(?:i[eę]g(?:[ai][\\s\\xa0]*Zachariasza)|\\.[\\s\\xa0]*Zachariasza|[\\s\\xa0]*Zachariasza)|Ζ(?:α(?:χ(?:αρ[ίι]ας)?)?|χ)|Книга[\\s\\xa0]*(?:на[\\s\\xa0]*пророк[\\s\\xa0]*Захария|пророка[\\s\\xa0]*Захар(?:ии|ія)|Захарі[ії])|《(?:匝加利亞》|撒(?:加利亞書》|迦利(?:亚书》|亞(?:書》|》)))|[亚亞]》)|Z(?:e(?:c(?:h(?:[ae]ri(?:ih|ah?|h))?)?|k(?:ariah?)?)|a(?:ȟarij|c(?:ar(?:[ií]as)?|c(?:aria|h(?:arie)?)?|h(?:ar(?:j[aá][sš]|a(?:[ai]h|h)|i(?:ih|á[sš]|a[hsš]?|[eh]))|er(?:a(?:[ai]h|h)|i(?:ih|ah?|h)))?)?|h(?:ari(?:a|ja?))?|k(?:haria|ari(?:ás|a(?:s['’][\\s\\xa0]*Bog|h)?))?)?|ch?)|За(?:к(?:ария)?|х(?:ар(?:ија|і[ий]))?)|זכריה|Liv[\\s\\xa0]*Zakari[\\s\\xa0]*a|jak(?:ariy[aā]|ʰary[aā])|ز(?:َكَرِيّا|کریاہ?|ك)|즈(?:가리야|카(?:르야서)?)|Cakariy[aā]|X(?:a-?cha-?ri-?a|ê-?ca-?ri-?a)|ਜ(?:਼ਕਰ[ਜਯ]ਾਹ|ਕਰਯਾਹ)|ଯିଖରିୟ[\\s\\xa0]*ଭବିଷ୍ୟ‌ଦ୍‌ବକ୍ତାଙ୍କ[\\s\\xa0]*ପୁସ୍ତକ|ศคย|슥|ச(?:கரி(?:யா)?|ெக்(?:கரியா)?)|سفر[\\s\\xa0]*زكريا|เศคาริยาห์|스가랴서?)|(?:[亞亚]》?|زكريا|Xa(?:-?cha-?ri)?|《(?:匝加利亞|撒(?:加利亞書|迦利(?:亚书|亞書?))|[亞亚])|撒(?:加利亞書》?|迦利(?:亚书》?|亞(?:書》?|》)?))|ଯିଖରିୟ|Za(?:chariasza|kari(?:as)?)|匝加利亞》?|Захар(?:и[яи]|і[їяі])|Sakarjan))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Zeph"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:ṣafaniyāh|sa(?:fanyāh|p(?:anyāh|ʰany[aā]))|صف(?:نیاہ)?|ศฟย|스바(?:니야서?|냐서?)?|Pro(?:roctwo[\\s\\xa0]*Sofoniaszowe|phetia[\\s\\xa0]*Sophoniae)|S(?:ô-?phô-?ni-?a|apanyah|z(?:efani[aá]s|of(?:oni[aá]s)?)|e(?:p(?:anias?|h)|f(?:an(?:yaah|i(?:ja|a(?:s['’][\\s\\xa0]*Bog)?)|ja(?:n[\\s\\xa0]*kirja|s[\\s\\xa0]*bok)?|ía)|f(?:aneia)?)?)|o(?:ph(?:oni(?:as|e))?|f(?:on(?:j[aá][sš]|ías|i(?:j[ae]|á[sš]|a[sš]?|e)))?)|f)|ସିଫନିୟ[\\s\\xa0]*ଭବିଷ୍ୟ‌ଦ୍‌ବକ୍ତାଙ୍କ[\\s\\xa0]*ପୁସ୍ତକ|Z(?:of[oó]ni(?:[aá]s)|a(?:phaniah?|faniah?)|e(?:f(?:an(?:ia[hs]?|[jy]a))?|p(?:anias|h(?:an(?:aiah?|ia[hs]?|ja)?)?)?)|ph?)|स(?:फन्या|पन(?:्याह(?:को[\\s\\xa0]*पुस्तक)?)?)|(?:[ŢȚT]ef(?:ania)?)|Книга[\\s\\xa0]*(?:на[\\s\\xa0]*пророк[\\s\\xa0]*Софония|пророка[\\s\\xa0]*Софон(?:ии|і[ії]))|Σ(?:οφον[ίι]ας|φν)|เศฟันยาห์|צפניה|செப்(?:பனியா)?|《(?:索福尼亞》|西番雅[书書]》|番》)|سفر[\\s\\xa0]*صفنيا|Liv[\\s\\xa0]*Sofoni[\\s\\xa0]*an|[セゼ](?:(?:[ハパ]ニヤ書|ファ(?:ニ(?:ヤ(?:しょ|書)|ア書?))?))|С(?:ефанија|оф(?:он(?:и(?:ј[ае]|й)|ія))?)|Ceppa[nṉ]iy[aā]|습|X(?:ê-?pha-?ni-?a|ô-?phô-?ni)|Ks(?:i[eę]g(?:[ai][\\s\\xa0]*Sofoniasza)|\\.[\\s\\xa0]*Sofoniasza|[\\s\\xa0]*Sofoniasza)|ਸਫ਼ਨਯਾਹ)|(?:番》?|S(?:ô-?phô-?ni|efan(?:jan|ias)|ofoni(?:asza)?)|sapanyah|《(?:西番雅[书書]|索福尼亞|番)|西番雅[書书]》?|Софон(?:і[їі]|и[яи])|صفنيا|ସିଫନିୟ|Xô|索福尼亞》?))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Luke"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(luk[aā]le[\\s\\xa0]*lekʰeko[\\s\\xa0]*susm(?:[aā]c(?:[aā]r))|(?:ଲୂକ[\\s\\xa0]*ଲିଖିତ[\\s\\xa0]*ସୁସମାଗ୍ଭର|Євангелі(?:я[\\s\\xa0]*від[\\s\\xa0]*(?:св(?:\\.[\\s\\xa0]*Луки|[\\s\\xa0]*Луки)|Луки)|є[\\s\\xa0]*від[\\s\\xa0]*(?:св(?:\\.[\\s\\xa0]*Луки|[\\s\\xa0]*Луки)|Лу(?:[\\s\\xa0]*ки|ки)))|லூ(?:க்(?:கா[\\s\\xa0]*(?:எழுதிய[\\s\\xa0]*(?:சுவிசேஷம்|நற்செய்தி)|நற்செய்தி))?)?|E(?:banghelyo[\\s\\xa0]*(?:ayon[\\s\\xa0]*kay[\\s\\xa0]*(?:San[\\s\\xa0]*Lu[ck]as|Lu[ck]as)|ni[\\s\\xa0]*San[\\s\\xa0]*Lu[ck]as)|l[\\s\\xa0]*Evangelio[\\s\\xa0]*de[\\s\\xa0]*Lucas|van(?:keliumi[\\s\\xa0]*Luukkaan[\\s\\xa0]*mukaan|jelium[\\s\\xa0]*Pod[lľ]a[\\s\\xa0]*Luk(?:[aá](?:[sš]a))|geli(?:um[\\s\\xa0]*(?:secundum[\\s\\xa0]*Lucam|podle[\\s\\xa0]*Luk[aá](?:[sš]e))|e(?:[\\s\\xa0]*volgens[\\s\\xa0]*Lu[ck]as|t[\\s\\xa0]*etter[\\s\\xa0]*Lukas))|[ðđ]elje[\\s\\xa0]*po[\\s\\xa0]*Luki)|w(?:angelia[\\s\\xa0]*(?:w(?:edług[\\s\\xa0]*(?:[sś]w(?:\\.[\\s\\xa0]*Łukasza|[\\s\\xa0]*Łukasza))|g[\\s\\xa0]*(?:[sś]w(?:\\.[\\s\\xa0]*Łukasza|[\\s\\xa0]*Łukasza)))|Łukasza)|\\.[\\s\\xa0]*Łukasza|[\\s\\xa0]*Łuk(?:asza)?))|ルカ(?:による福音書|傳福音書|福音書|[伝書])?|Еван(?:гелие(?:то[\\s\\xa0]*според[\\s\\xa0]*Лука|[\\s\\xa0]*(?:според[\\s\\xa0]*Лука|от[\\s\\xa0]*Лук[аи]))|ђеље[\\s\\xa0]*по[\\s\\xa0]*Луки)|누가(?:복음서?)?|Л(?:укa|к)|루카[\\s\\xa0]*복음서?|ล(?:ูกา|ก)|The[\\s\\xa0]*Gospel[\\s\\xa0]*(?:according[\\s\\xa0]*to[\\s\\xa0]*(?:S(?:aint[\\s\\xa0]*L(?:k|u(?:ke?)?)|t(?:\\.[\\s\\xa0]*L(?:k|u(?:ke?)?)|[\\s\\xa0]*L(?:k|u(?:ke?)?)))|L(?:k|u(?:ke?)?))|of[\\s\\xa0]*(?:S(?:aint[\\s\\xa0]*L(?:k|u(?:ke?)?)|t(?:\\.[\\s\\xa0]*L(?:k|u(?:ke?)?)|[\\s\\xa0]*L(?:k|u(?:ke?)?)))|L(?:k|u(?:ke?)?)))|От[\\s\\xa0]*Лука[\\s\\xa0]*свето[\\s\\xa0]*Евангелие|l(?:uk[aā]ne[\\s\\xa0]*lihilele[\\s\\xa0]*(?:[sŝ]ubʰavartam(?:[aā]n))|ū(?:qā[\\s\\xa0]*kī[\\s\\xa0]*injīl|k(?:a(?:ne[\\s\\xa0]*lihilele[\\s\\xa0]*[sŝ]ubʰavartam(?:[aā]n)|le[\\s\\xa0]*lekʰeko[\\s\\xa0]*susm[aā]c(?:[aā]r))|ā(?:ne[\\s\\xa0]*lihilele[\\s\\xa0]*[sŝ]ubʰavartam(?:[aā]n)|le[\\s\\xa0]*lekʰeko[\\s\\xa0]*susm[aā]c(?:[aā]r)|[\\s\\xa0]*dī[\\s\\xa0]*ĩjīl))))|Sulat[\\s\\xa0]*ni[\\s\\xa0]*San[\\s\\xa0]*Lucas|Јеванђеље[\\s\\xa0]*по[\\s\\xa0]*Луки|Ungjilli[\\s\\xa0]*i[\\s\\xa0]*Luk[eë]s|Ł(?:ukasz|k)|Injil(?:i[\\s\\xa0]*ya[\\s\\xa0]*Luka|[\\s\\xa0]*Lukas)|L(?:ūkk[aā][\\s\\xa0]*Na(?:[rṛ]ceyti)|ooka|ik|lu(?:ka)?|u(?:-?ca|k(?:k[aā][\\s\\xa0]*Na(?:[rṛ]ceyti)|a(?:s(?:ovo[\\s\\xa0]*evangelium|[\\s\\xa0]*evangelium|arguðspjall|evangeliet)|cs|š(?:ovo[\\s\\xa0]*evangelium)?)|á(?:cs|(?:[sš](?:ovo[\\s\\xa0]*evangelium)?)))|uk(?:kaan[\\s\\xa0]*evankeliumi|os)?|c)|úk(?:asarguðspjall)?|c)?|《(?:魯喀》|路(?:加福音》|》))|Jevan(?:helije[\\s\\xa0]*vid[\\s\\xa0]*Luky|đelje[\\s\\xa0]*po[\\s\\xa0]*Luki)|Λ(?:ουκ(?:[άα]ς)?|κ)|ਲੂਕਾ[\\s\\xa0]*ਦੀ[\\s\\xa0]*ਇੰਜੀਲ|พระวรสารนักบุญลูค|Mabuting[\\s\\xa0]*Balita[\\s\\xa0]*ayon[\\s\\xa0]*kay[\\s\\xa0]*(?:San[\\s\\xa0]*Lu[ck]as|Lu[ck]as)|ل(?:ُوقا[\\s\\xa0]*کی[\\s\\xa0]*انجیل|و(?:قا[\\s\\xa0]*کی[\\s\\xa0]*انجیل)?)|إنجيل[\\s\\xa0]*لوقا|הבשורה[\\s\\xa0]*על(?:[\\s\\xa0]*פי[\\s\\xa0]*לוקס|-?פי[\\s\\xa0]*לוק(?:אס|ס))|Κατ[άα][\\s\\xa0]*Λουκ(?:[άα]ν)|ल(?:ुका|ूक(?:ा(?:ने[\\s\\xa0]*लिहिलेले[\\s\\xa0]*शुभवर्तमान|ले[\\s\\xa0]*लेखेको[\\s\\xa0]*सुसमाचार|को[\\s\\xa0]*सुसमाचार)?)?)|Vangelo[\\s\\xa0]*di[\\s\\xa0]*(?:San[\\s\\xa0]*Luca|Luca))|(?:路(?:加福音》?|》)?|Łuk|ਲੂਕਾ|От[\\s\\xa0]*Лук[аи]|ଲୂକ|魯喀》?|லூக்கா|Gospel[\\s\\xa0]*(?:according[\\s\\xa0]*to[\\s\\xa0]*(?:S(?:aint[\\s\\xa0]*L(?:u(?:ke?)?|k)|t(?:\\.[\\s\\xa0]*L(?:u(?:ke?)?|k)|[\\s\\xa0]*L(?:u(?:ke?)?|k)))|L(?:u(?:ke?)?|k))|of[\\s\\xa0]*(?:S(?:aint[\\s\\xa0]*L(?:k|u(?:ke?)?)|t(?:\\.[\\s\\xa0]*L(?:k|u(?:ke?)?)|[\\s\\xa0]*L(?:k|u(?:ke?)?)))|L(?:u(?:ke?)?|k)))|Лук[иа]|《(?:魯喀|路(?:加福音)?)|लूका[नल]े|l(?:uk[āa](?:[ln]e)|ūk(?:a[ln]e|ā(?:[nl]e)?))|Від[\\s\\xa0]*Луки|ل(?:ُوقا|وقا)|루카|Evangelio[\\s\\xa0]*de[\\s\\xa0]*Lucas|L(?:ūkk[āa]|k|u(?:ukkaan|cas?|k(?:á[šs]a|k[aā]|e|a(?:ša|sa?)?)?)?)|S(?:a(?:n[\\s\\xa0]*Lucas|int[\\s\\xa0]*L(?:u(?:ke?)?|k))|t(?:\\.[\\s\\xa0]*L(?:k|u(?:ke?)?)|[\\s\\xa0]*L(?:u(?:ke?)?|k)))))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Jer"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Yirmayah|(?:Книга[\\s\\xa0]*(?:на[\\s\\xa0]*пророк[\\s\\xa0]*(?:[ИЙ]еремия|Еремия)|пророка[\\s\\xa0]*(?:Иеремии|Єремі[ії]))|Ιε(?:ρεμ[ίι]ας)?|エレミヤ書?|ヱレミヤ記|Ер(?:емија)?|أرميا|Јер(?:емија)?|Sulat[\\s\\xa0]*ni[\\s\\xa0]*Jeremias|[ИЙ]ер|எரே(?:மியா[\\s\\xa0]*தீர்க்கதரிசியின்[\\s\\xa0]*புத்தகம்)?|G(?:iê-?rê-?mi-?a|er(?:emia)?|r)|J(?:e(?:r(?:a(?:iah|m(?:a(?:ih|h)|i(?:ih|ah?|ha?)))|im(?:ah|i(?:[ai]h|h))|m[im]ah|ém(?:ie)?|e(?:m(?:eia|j[aá][sš]|a(?:i(?:ah|h)|h)|i(?:ih|ja|á[sš]|a(?:n[\\s\\xa0]*kirja|s(?:['’][\\s\\xa0]*Bog|[\\s\\xa0]*bok)|š)?|e|ha?)|ías?)?)?)?)?|r|é(?:r(?:[eé]m(?:ie)?)?)?)|H[ei]r(?:[ei]m(?:[iy]as))|Er[eē]miy[aā]|Ks(?:i[eę]g(?:[ai][\\s\\xa0]*Jeremiasza)|\\.[\\s\\xa0]*Jeremiasza|[\\s\\xa0]*Jeremiasza)|ﺃﺭﻣﻴﺎء|سفر[\\s\\xa0]*إرميا|y(?:armiy[aā]ko[\\s\\xa0]*pustak|irm(?:iyāh|ay(?:a|āh?)))|Aklat[\\s\\xa0]*ni[\\s\\xa0]*Jeremia[hs]|Єр(?:емія)?|예레(?:미(?:아|야서?))?|《耶(?:利米[书書]》|肋米亞》|》)|Y(?:ér[eé]mia|er(?:em(?:yaah|ia)|émia)?)|ירמיהו?|ஏரே(?:மியா)?|ار|ยรม|렘|य(?:र्मिया(?:को[\\s\\xa0]*पुस्तक)?|िर्म(?:याह?)?)|Li(?:ber[\\s\\xa0]*Ieremiae|v[\\s\\xa0]*Jeremi[\\s\\xa0]*an)|ਯਿਰਮਿਯਾਹ|Ier(?:emias?)?|یرم(?:ِیاہ|یاہ)|Ἰε|เยเรมีย(?:าห์|์)|ଯିରିମିୟ[\\s\\xa0]*ଭବିଷ୍ୟ‌ଦ୍‌ବକ୍ତାଙ୍କ[\\s\\xa0]*ପୁସ୍ତକ)|(?:Еремия|إرميا|Йеремия|Єремі[їі]|《耶(?:肋米亞|利米[书書])?|耶(?:利米[书書]》?|肋米亞》?|》)?|Jeremi(?:a(?:[nh]|s(?:za)?))?|yarmiy[aā]ko|Giê(?:-?rê-?mi)?|ଯିରିମିୟ|यर्मियाको|எரேமியா|Иереми[яи]))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["2Cor"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(2\.[\s\xa0]*Korinterbrevet|(?:II(?:\.[\s\xa0]*Коринтяни(?:те)?|[\s\xa0]*Коринтяни(?:те)?)|2(?:\.[\s\xa0]*Коринтяни(?:те)?|[\s\xa0]*(?:Korinterbrevet|Коринтяни(?:те)?)))|2(?:\.[\s\xa0]*коринтян|[\s\xa0]*коринтян)|(?:Β['ʹʹ΄’][\s\xa0]*Κο(?:ρ(?:ινθ(?:[ίι]ους)?)?)|S(?:ECOND[\s\xa0]*Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)|(?:[ií]ðara[\s\xa0]*(?:br(?:[eé]f[\s\xa0]*P(?:[aá]ls[\s\xa0]*til[\s\xa0]*Kori(?:ntumanna)?))|K[oó]rintubr(?:[eé]f)))|e(?:gund[ao][\s\xa0]*Cor(?:[ií]ntios)|cond(?:a[\s\xa0]*(?:lettera[\s\xa0]*ai[\s\xa0]*Corinzi|Corinzi)|o[\s\xa0]*Corinzi|[\s\xa0]*C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|t(?:i[ao]ns|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|ons|a(?:[ai]ns|n(?:[ao]s|s)?)|n(?:as|s)))?)?)?)|th(?:ians?)?)?)?))))|אגרת[\s\xa0]*פולוס[\s\xa0]*השנייה[\s\xa0]*אל-?הקורינ|コリント(?:の信徒への手紙二|人への(?:第二の手紙|後の書|手紙二)|[\s\xa0]*2|後書)|ک(?:ُرِنتھِیوں[\s\xa0]*کے[\s\xa0]*نام[\s\xa0]*کا[\s\xa0]*دوسرا[\s\xa0]*خط|رنتھ(?:ِیُوں[\s\xa0]*کے[\s\xa0]*نام[\s\xa0]*پولس[\s\xa0]*رسول[\s\xa0]*کا[\s\xa0]*دوسرا[\s\xa0]*خط|یوں[\s\xa0]*کے[\s\xa0]*نام[\s\xa0]*کا[\s\xa0]*دوسرا[\s\xa0]*خط))|Wa(?:raka[\s\xa0]*wa[\s\xa0]*Pili[\s\xa0]*kwa[\s\xa0]*Wakorint(?:ho|o)|korintho[\s\xa0]*II)|۲(?:-?کُرِنتھِیوں|[\s\xa0]*ک(?:ُرنتھِیوں|رنتھ(?:ِیُوں|یوں))|۔کرنتھیوں)|Korint(?:iyarukku[\s\xa0]*E[lḻ]utiya[\s\xa0]*Ira(?:[nṇ](?:[tṭ](?:[aā]vatu[\s\xa0]*Nirupam)))|os[\s\xa0]*Labaad)|Barua[\s\xa0]*ya[\s\xa0]*Pili[\s\xa0]*kwa[\s\xa0]*Wakorintho|क(?:ोरिन्थीहरूलाई[\s\xa0]*(?:पावलको[\s\xa0]*दोस्रो[\s\xa0]*पत्र|दोस्त्रो[\s\xa0]*पत्र)|रिंथकरांस[\s\xa0]*दुसरे[\s\xa0]*पत्र)|고린도[2후]서|கொரிந்தியருக்கு[\s\xa0]*எழுதிய[\s\xa0]*இரண்டா(?:வது[\s\xa0]*(?:திருமுகம்|நிருபம்)|ம்[\s\xa0]*(?:திருமுகம்|கடிதம்))|Προς[\s\xa0]*Κορινθ[ίι]ους[\s\xa0]*Β['ʹʹ΄’]|पौलाचे[\s\xa0]*करिंथकरांस[\s\xa0]*दूसरे[\s\xa0]*पत्र|ଦ୍ୱିତୀୟ[\s\xa0]*କରିନ୍ଥୀୟ(?:ଙ୍କ)?|And(?:e(?:t[\s\xa0]*Korintherbrev|n[\s\xa0]*Kor(?:int(?:herbrev|erne))?)|r(?:a[\s\xa0]*Korint(?:h(?:ierbrevet|erbrevet)|ierbrevet|erbrevet)|e[\s\xa0]*(?:korinterbrev|Kor(?:int(?:ierne|er))?)))|I(?:ka(?:-?[\s\xa0]*2[\s\xa0]*Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)|[\s\xa0]*2[\s\xa0]*Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)|lawang[\s\xa0]*(?:Mga[\s\xa0]*Taga(?:-?[\s\xa0]*Corinto|[\s\xa0]*Corinto)|(?:[CK]orint(?:io|o))))|I(?:\.[\s\xa0]*(?:п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Коринт|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|ица[\s\xa0]*Коринћанима))|коринтян|до[\s\xa0]*коринтян|Wakorint(?:ho|o)|K(?:irje[\s\xa0]*korinttilaisille|or(?:entyen|ynt(?:ian|[oó]w)|in(?:[cć]anima[\s\xa0]*Poslanica|ťanom|t(?:t(?:olaiskirje|ilaisille)|sk[yý]m|h(?:i[eë]rs?|us(?:iakhoz)?|e)|i(?:[eë]rs?|o)|usi?|a(?:nom)?|os?)?))?)|list[\s\xa0]*(?:do[\s\xa0]*Koryntian|Korin(?:tsk[yý]m|sk[yý]m))|Mga[\s\xa0]*Taga(?:-?[\s\xa0]*Corinto|[\s\xa0]*Corinto)|Послання[\s\xa0]*до[\s\xa0]*Коринтян|List[\s\xa0]*(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian))|Кор(?:ин(?:[кќ]аните|ћанима|тјани|фян))?|C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|ô(?:-?rinh-?tô|rintô)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|íntios|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|zi|t(?:eni|i(?:ans|e(?:ni|rs?)|ërs?|o(?:ns|s)?)|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|a(?:ans|i(?:ns|d)|n(?:[ao]s|s)?)|e(?:ns|rs?)|n(?:as|s)|o(?:ns|s)|ërs?)|e)?|o)?)?)|th(?:ians?)?)?)?))|[\s\xa0]*(?:п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Коринт|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|ица[\s\xa0]*Коринћанима))|коринтян|до[\s\xa0]*коринтян|Wakorint(?:ho|o)|K(?:irje[\s\xa0]*korinttilaisille|or(?:entyen|ynt(?:ian|[oó]w)|in(?:[cć]anima[\s\xa0]*Poslanica|ťanom|t(?:t(?:olaiskirje|ilaisille)|sk[yý]m|h(?:i[eë]rs?|us(?:iakhoz)?|e)|i(?:[eë]rs?|o)|usi?|a(?:nom)?|os?)?))?)|list[\s\xa0]*(?:do[\s\xa0]*Koryntian|Korin(?:tsk[yý]m|sk[yý]m))|Mga[\s\xa0]*Taga(?:-?[\s\xa0]*Corinto|[\s\xa0]*Corinto)|Послання[\s\xa0]*до[\s\xa0]*Коринтян|List[\s\xa0]*(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian))|Кор(?:ин(?:[кќ]аните|ћанима|тјани|фян))?|C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|ô(?:-?rinh-?tô|rintô)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|íntios|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|zi|t(?:eni|i(?:ans|e(?:ni|rs?)|ërs?|o(?:ns|s)?)|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|a(?:ans|i(?:ns|d)|n(?:[ao]s|s)?)|e(?:ns|rs?)|n(?:as|s)|o(?:ns|s)|ërs?)|e)?|o)?)?)|th(?:ians?)?)?)?))))|האיגרת[\s\xa0]*השנייה[\s\xa0]*אל[\s\xa0]*הקורינתים|كورنثوس[\s\xa0]*الثانية|코린토(?:[\s\xa0]*신자들에게[\s\xa0]*보낸[\s\xa0]*둘째[\s\xa0]*서간|2서)|D(?:e(?:uxi(?:[eè]me(?:s[\s\xa0]*Corinthiens|[\s\xa0]*Corinthiens))|zy(?:[eè]m[\s\xa0]*Kor(?:entyen|int)))|ru(?:g(?:a[\s\xa0]*(?:List[\s\xa0]*(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian))|poslanica[\s\xa0]*Korinæanima|list[\s\xa0]*do[\s\xa0]*Koryntian|Kor(?:in[cć]anima[\s\xa0]*Poslanica|ynt(?:ian|[oó]w)))|i[\s\xa0]*(?:List[\s\xa0]*(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian))|list[\s\xa0]*do[\s\xa0]*Koryntian|Korynt(?:ian|[oó]w)))|h(?:e[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*korynfjan|(?:[aá](?:[\s\xa0]*(?:kniha[\s\xa0]*Korin(?:t(?:anom|sk[yý]m)|ťanom)|list[\s\xa0]*Korin(?:tsk[yý]m|sk[yý]m)|K(?:orin(?:t(?:anom|sk[yý]m)|ťanom))?)|K))|(?:[yý](?:[\s\xa0]*(?:list[\s\xa0]*Korin(?:t(?:anom|sk[yý]m)|ťanom|sk[yý]m)|K(?:orin(?:t(?:anom|sk[yý]m)|ťanom))?)|K)))))|Друг(?:а[\s\xa0]*(?:послан(?:ня[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|ица[\s\xa0]*Коринћанима)|Послання[\s\xa0]*до[\s\xa0]*Коринтян|до[\s\xa0]*коринтян|Корин(?:ћанима|тяни|фян)|коринтян)|е[\s\xa0]*(?:послання[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|Послання[\s\xa0]*до[\s\xa0]*Коринтян|до[\s\xa0]*коринтян|Корин(?:тяни|фян)|коринтян))|T(?:oinen[\s\xa0]*K(?:irje[\s\xa0]*korinttilaisille|orintt(?:olaiskirje|ilaisille))|weede[\s\xa0]*(?:Corint(?:i[eë]rs?|h(?:i[eë]rs?|e))|Kor(?:int(?:i[eë]rs?|h(?:i[eë]rs?|e)))?))|Zweite[\s\xa0]*Korinther|Втор(?:о[\s\xa0]*(?:п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Коринт|ослание[\s\xa0]*(?:на[\s\xa0]*св(?:\.[\s\xa0]*ап(?:\.[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Коринтяни|[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Коринтяни)|[\s\xa0]*ап(?:\.[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Коринтяни|[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Коринтяни))|към[\s\xa0]*коринтяните))|Корин(?:[кќ]аните|тјани))|а[\s\xa0]*(?:писмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Коринт|Кор(?:ин(?:[кќ]аните|т(?:јани|яни(?:те)?)))?))|رسالة[\s\xa0]*بولس[\s\xa0]*الرسول[\s\xa0]*الثانية[\s\xa0]*إلى[\s\xa0]*أهل[\s\xa0]*كورنثوس|କରିନ୍ଥୀୟଙ୍କ[\s\xa0]*ପ୍ରତି[\s\xa0]*ଦ୍ୱିତୀୟ[\s\xa0]*ପତ୍ର|k(?:orintʰ[iī]har(?:[uū]l(?:[aā](?:[iī][\s\xa0]*dostro[\s\xa0]*patra)))|ari[mṃ]tʰkar(?:[aā](?:[mṃ]s[\s\xa0]*dusre[\s\xa0]*patra))|ur(?:intʰiyōṅ[\s\xa0]*ke[\s\xa0]*nām[\s\xa0]*kā[\s\xa0]*dūsrā[\s\xa0]*ḫaṭ|ĩtʰīāṃ[\s\xa0]*nū̃[\s\xa0]*dūjī[\s\xa0]*pattrī))|Epistula[\s\xa0]*(?:II[\s\xa0]*ad[\s\xa0]*Corinthios|ad[\s\xa0]*Corinthios[\s\xa0]*II)|2(?:-?(?:я(?:\.[\s\xa0]*(?:к[\s\xa0]*Коринфянам|Коринфянам)|[\s\xa0]*(?:к[\s\xa0]*Коринфянам|Коринфянам))|ге(?:\.[\s\xa0]*(?:послання[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|Послання[\s\xa0]*до[\s\xa0]*Коринтян|до[\s\xa0]*коринтян|Корин(?:тяни|фян)|коринтян)|[\s\xa0]*(?:послання[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|Послання[\s\xa0]*до[\s\xa0]*Коринтян|до[\s\xa0]*коринтян|Корин(?:тяни|фян)|коринтян))|کُرِنتھِیوں|а(?:\.[\s\xa0]*(?:послання[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|Послання[\s\xa0]*до[\s\xa0]*Коринтян|до[\s\xa0]*коринтян|Корин(?:тяни|фян)|коринтян)|[\s\xa0]*(?:послання[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|Послання[\s\xa0]*до[\s\xa0]*Коринтян|до[\s\xa0]*коринтян|Корин(?:тяни|фян)|коринтян))|е(?:\.[\s\xa0]*(?:послання[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|Послання[\s\xa0]*до[\s\xa0]*Коринтян|до[\s\xa0]*коринтян|Корин(?:тяни|фян(?:ам)?)|к(?:[\s\xa0]*Коринфянам|оринтян))|[\s\xa0]*(?:послання[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|Послання[\s\xa0]*до[\s\xa0]*Коринтян|до[\s\xa0]*коринтян|Корин(?:тяни|фян(?:ам)?)|к(?:[\s\xa0]*Коринфянам|оринтян))))|\.(?:-?کُرِنتھِیوں|(?:[oº](?:\.[\s\xa0]*Corintios|[\s\xa0]*Corintios))|۔کرنتھیوں|[\s\xa0]*(?:କରିନ୍ଥୀୟ(?:ଙ୍କ)?|к[\s\xa0]*Коринфянам|korint(?:ʰ[iī]har(?:[uū]l(?:[aā][iī]))|erbrev)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Коринт|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|ица[\s\xa0]*Коринћанима))|K(?:irje[\s\xa0]*korinttilaisille|urinthiayon|or(?:entyen|ynt(?:ian|[oó]w)|i(?:tasve|n(?:[cć]anima[\s\xa0]*Poslanica|ťanom|t(?:t(?:olaiskirje|ilaisille)|sk[yý]m|er(?:ne)?|h(?:i(?:er(?:brevet|s)?|ërs?)|us(?:iakhoz)?|e(?:r(?:brev(?:et)?)?)?)|i(?:er(?:brevet|ne|s)?|ërs?|o)|usi?|a(?:nom|sve)?|os?)?)))?)|до[\s\xa0]*коринтян|Wakorint(?:ho|o)|Mga[\s\xa0]*Taga(?:[\s\xa0]*Corinto|-?(?:[\s\xa0]*Corinto|Corinto))|Taga-?Corinto|โครินธ์|list[\s\xa0]*(?:do[\s\xa0]*Koryntian|Korin(?:tsk[yý]m|sk[yý]m))|Кор(?:ин(?:[кќ]аните|ћанима|тјани|фян(?:ам)?))?|क(?:ोरिन्(?:‍थी|थी(?:हरूलाई)?)|ुर(?:न्थियों|िन्(?:यि़यों|थ(?:ियों?)?)))|ک(?:ُرنتھِیوں|رنتھ(?:ِیُوں|یوں))|Послання[\s\xa0]*до[\s\xa0]*Коринтян|List[\s\xa0]*(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian))|C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|ô(?:-?rinh-?tô|rintô)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|íntios|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|zi|t(?:eni|i(?:ans|e(?:ni|rs?)|ërs?|o(?:ns|s)?)|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|a(?:ans|i(?:ns|d)|n(?:[ao]s|s)?)|e(?:ns|rs?)|n(?:as|s)|o(?:ns|s)|ërs?)|e)?|o)?)?)|th(?:ians?)?)?)?)))|[KC]or|ème(?:\.[\s\xa0]*Corinthiens|[\s\xa0]*Corinthiens)|e(?:me(?:\.[\s\xa0]*Corinthiens|[\s\xa0]*Corinthiens)|\.[\s\xa0]*(?:Corint(?:i[eë]rs?|h(?:i(?:e(?:ns|rs?)|ërs?)|e))|Kor(?:int(?:i[eë]rs?|h(?:i[eë]rs?|e)))?)|[\s\xa0]*(?:Corint(?:i[eë]rs?|h(?:i(?:e(?:ns|rs?)|ërs?)|e))|Kor(?:int(?:i[eë]rs?|h(?:i[eë]rs?|e)))?))|nd(?:\.[\s\xa0]*C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|t(?:i[ao]ns|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|ons|a(?:[ai]ns|n(?:[ao]s|s)?)|n(?:as|s)))?)?)?)|th(?:ians?)?)?)?)|[\s\xa0]*C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|t(?:i[ao]ns|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|ons|a(?:[ai]ns|n(?:[ao]s|s)?)|n(?:as|s)))?)?)?)|th(?:ians?)?)?)?))|°(?:\.[\s\xa0]*Corinzi|[\s\xa0]*Corinzi)|۔کرنتھیوں|[\s\xa0]*(?:କରିନ୍ଥୀୟ(?:ଙ୍କ)?|k(?:\.[\s\xa0]*Korin(?:t(?:anom|sk[yý]m)|ťanom)|ari[mṃ]tʰkar(?:[aā](?:[mṃ]s))|[\s\xa0]*Korin(?:t(?:anom|sk[yý]m)|ťanom)|orint(?:ʰ[iī]har(?:[uū]l(?:[aā][iī]))|erbrev)|urĩtʰīāṃ)|к[\s\xa0]*Коринфянам|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Коринт|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|ица[\s\xa0]*Коринћанима))|கொ(?:ரி(?:ந்தியர்)?)?|K(?:irje[\s\xa0]*korinttilaisille|urinthiayon|or(?:entyen|ynt(?:ian|[oó]w)|i(?:tasve|n(?:[cć]anima[\s\xa0]*Poslanica|ťanom|t(?:t(?:olaiskirje|ilaisille)|sk[yý]m|er(?:ne)?|h(?:i(?:er(?:brevet|s)?|ërs?)|us(?:iakhoz)?|e(?:r(?:brev(?:et)?)?)?)|i(?:yarukku|er(?:brevet|ne|s)?|ërs?|o)|usi?|a(?:nom|sve)?|os?)?)))?)|क(?:रिंथकरांस|ोरिन्(?:‍थी|थी(?:हरूलाई)?)|ुर(?:न्थियों|िन्(?:यि़यों|थ(?:ियों?)?)))|до[\s\xa0]*коринтян|Wakorint(?:ho|o)|Mga[\s\xa0]*Taga(?:[\s\xa0]*Corinto|-?(?:[\s\xa0]*Corinto|Corinto))|Taga-?Corinto|โครินธ์|list[\s\xa0]*(?:do[\s\xa0]*Koryntian|Korin(?:tsk[yý]m|sk[yý]m))|Кор(?:ин(?:[кќ]аните|ћанима|тјани|фян(?:ам)?))?|ک(?:ُرنتھِیوں|رنتھ(?:ِیُوں|یوں))|ਕੁਰਿੰਥੀਆਂ[\s\xa0]*ਨੂੰ|Послання[\s\xa0]*до[\s\xa0]*Коринтян|List[\s\xa0]*(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian))|قور|(?:[ie](?:\.[\s\xa0]*Kori(?:ntasve|tasve)|[\s\xa0]*Kori(?:ntasve|tasve)))|C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|ô(?:-?rinh-?tô|rintô)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|íntios|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|zi|i(?:th(?:i(?:ans|nas)|a(?:ins|ns)))?|t(?:eni|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|a(?:ans|i(?:ns|d)|n(?:[ao]s|s)?)|e(?:ns|rs?)|n(?:as|s)|o(?:ns|s)|ërs?)|e)?|i(?:ans|e(?:ni|rs?)|ërs?|o(?:ns|s)?)?|o)?)?)|th(?:ians?)?)?)?)|ค[ธร])|d(?:\.[\s\xa0]*Corinthiens|e(?:\.[\s\xa0]*Corinthiens|[\s\xa0]*Corinthiens)|[\s\xa0]*Corinthiens)|코린|º(?:\.[\s\xa0]*Corintios|[\s\xa0]*Corintios)|[oa](?:\.[\s\xa0]*Cor(?:[ií]ntios|[\s\xa0]*Cor[ií]ntios))|(?:[ея](?:\.[\s\xa0]*(?:к[\s\xa0]*Коринфянам|Коринфянам)|[\s\xa0]*(?:к[\s\xa0]*Коринфянам|Коринфянам)))|كو)|ਕੁਰਿੰਥੀਆਂ[\s\xa0]*ਨੂੰ[\s\xa0]*ਦੂਜੀ[\s\xa0]*ਪੱਤ੍ਰੀ|الرسالة[\s\xa0]*الثانية[\s\xa0]*إلى[\s\xa0]*أهل[\s\xa0]*كورنثوس|《(?:哥林多(?:后书》|後書》)|[格歌]林多後書》|适凌爾福後》|林[后後]》)|M(?:[aá]sodik[\s\xa0]*Kor(?:int(?:hus(?:iakhoz)?|usi))?)|P(?:a(?:vlova[\s\xa0]*druga[\s\xa0]*poslanica[\s\xa0]*Korin[cć]anima|ulus(?:'[\s\xa0]*Andet[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Korintherne|’[\s\xa0]*(?:Andet[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Korintherne|andre[\s\xa0]*brev[\s\xa0]*til[\s\xa0]*korinterne)))|ili[\s\xa0]*(?:Wakorint(?:ho|o)|Kor))|دوم(?:-?کُرِنتھِیوں|[\s\xa0]*ک(?:ُرنتھِیوں|رنتھ(?:ِیُوں|یوں))|۔کرنتھیوں))|(?:2[ao][\s\xa0]*Cor(?:[ií]ntios)|Β['ʹʹ΄’][\s\xa0]*Κο)|(?:哥林多(?:後書》?|后书》?)|השנייה[\s\xa0]*אל[\s\xa0]*הקורינתים|Corinthios[\s\xa0]*II|《(?:[格歌]林多後書|哥林多(?:后书|後書)|适凌爾福後|林[後后])|ad[\s\xa0]*Corinthios[\s\xa0]*II|2(?:\.[\s\xa0]*(?:Korin[cć]anima|Cô(?:-?rinh)?)|[\s\xa0]*(?:Korin[ćc]anima|ਕੁਰਿੰਥੀਆਂ|Cô(?:-?rinh)?))|Druga[\s\xa0]*(?:poslanica[\s\xa0]*Korin[ćc]anima|Korin[cć]anima)|[歌格]林多後書》?|II(?:\.[\s\xa0]*(?:Korin[cć]anima|Cô(?:-?rinh)?)|[\s\xa0]*(?:Korin[cć]anima|Cô(?:-?rinh)?))|适凌爾福後》?|林[後后]》?))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["1Cor"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(1\.[\s\xa0]*Korinterbrevet|(?:1(?:\.[\s\xa0]*Коринтяни(?:те)?|[\s\xa0]*(?:Korinterbrevet|Коринтяни(?:те)?))|I(?:\.[\s\xa0]*Коринтяни(?:те)?|[\s\xa0]*Коринтяни(?:те)?)|Prvn[ií][\s\xa0]*Kor(?:intsk(?:[yý]m)?))|Prvn(?:[ií][\s\xa0]*Kor)|1(?:\.[\s\xa0]*коринтян|[\s\xa0]*коринтян)|(?:Α['ʹʹ΄’][\s\xa0]*Κο(?:ρ(?:ινθ(?:[ίι]ους)?)?)|I(?:ka(?:-?[\s\xa0]*1[\s\xa0]*Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)|[\s\xa0]*1[\s\xa0]*Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o))|\.[\s\xa0]*(?:п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Коринт|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|ица[\s\xa0]*Коринћанима))|коринтян|до[\s\xa0]*коринтян|Wakorint(?:ho|o)|K(?:irje[\s\xa0]*korinttilaisille|or(?:entyen|ynt(?:ian|[oó]w)|in(?:[cć]anima[\s\xa0]*Poslanica|ťanom|t(?:t(?:olaiskirje|ilaisille)|sk[yý]m|h(?:i[eë]rs?|us(?:iakhoz)?|e)|i(?:[eë]rs?|o)|usi?|a(?:nom)?|os?)?))?)|list[\s\xa0]*(?:do[\s\xa0]*Koryntian|Korin(?:tsk[yý]m|sk[yý]m))|Mga[\s\xa0]*Taga(?:-?[\s\xa0]*Corinto|[\s\xa0]*Corinto)|Послання[\s\xa0]*до[\s\xa0]*Коринтян|List[\s\xa0]*(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian))|Кор(?:ин(?:[кќ]аните|ћанима|тјани|фян))?|C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|ô(?:-?rinh-?tô|rintô)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|íntios|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|zi|t(?:eni|i(?:ans|e(?:ni|rs?)|ërs?|o(?:ns|s)?)|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|a(?:ans|i(?:ns|d)|n(?:[ao]s|s)?)|e(?:ns|rs?)|n(?:as|s)|o(?:ns|s)|ërs?)|e)?|o)?)?)|th(?:ians?)?)?)?)|Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o))|[\s\xa0]*(?:п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Коринт|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|ица[\s\xa0]*Коринћанима))|коринтян|до[\s\xa0]*коринтян|Wakorint(?:ho|o)|K(?:irje[\s\xa0]*korinttilaisille|or(?:entyen|ynt(?:ian|[oó]w)|in(?:[cć]anima[\s\xa0]*Poslanica|ťanom|t(?:t(?:olaiskirje|ilaisille)|sk[yý]m|h(?:i[eë]rs?|us(?:iakhoz)?|e)|i(?:[eë]rs?|o)|usi?|a(?:nom)?|os?)?))?)|list[\s\xa0]*(?:do[\s\xa0]*Koryntian|Korin(?:tsk[yý]m|sk[yý]m))|Mga[\s\xa0]*Taga(?:-?[\s\xa0]*Corinto|[\s\xa0]*Corinto)|Послання[\s\xa0]*до[\s\xa0]*Коринтян|List[\s\xa0]*(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian))|Кор(?:ин(?:[кќ]аните|ћанима|тјани|фян))?|C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|ô(?:-?rinh-?tô|rintô)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|íntios|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|zi|t(?:eni|i(?:ans|e(?:ni|rs?)|ërs?|o(?:ns|s)?)|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|a(?:ans|i(?:ns|d)|n(?:[ao]s|s)?)|e(?:ns|rs?)|n(?:as|s)|o(?:ns|s)|ërs?)|e)?|o)?)?)|th(?:ians?)?)?)?)|Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)))|고린도[1전]서|П(?:рв(?:а[\s\xa0]*(?:п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Коринт|осланица[\s\xa0]*Коринћанима)|Корин(?:[кќ]аните|ћанима|тјани))|о[\s\xa0]*(?:писмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Коринт|Корин(?:[кќ]аните|тјани)))|ерш(?:[ае][\s\xa0]*(?:послання[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|Послання[\s\xa0]*до[\s\xa0]*Коринтян|до[\s\xa0]*коринтян|Корин(?:тяни|фян)|коринтян))|ърв(?:о[\s\xa0]*послание[\s\xa0]*(?:на[\s\xa0]*св(?:\.[\s\xa0]*ап(?:\.[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Коринтяни|[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Коринтяни)|[\s\xa0]*ап(?:\.[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Коринтяни|[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Коринтяни))|към[\s\xa0]*коринтяните)|а[\s\xa0]*Кор(?:интяни(?:те)?)?))|ک(?:ُرِنتھِیوں[\s\xa0]*کے[\s\xa0]*نام[\s\xa0]*کا[\s\xa0]*پہلا[\s\xa0]*خط|رنتھ(?:ِیُوں[\s\xa0]*کے[\s\xa0]*نام[\s\xa0]*پولس[\s\xa0]*رسول[\s\xa0]*کا[\s\xa0]*پہلا[\s\xa0]*خط|یوں[\s\xa0]*کے[\s\xa0]*نام[\s\xa0]*کا[\s\xa0]*پہلا[\s\xa0]*خط))|k(?:orintʰ[iī]har(?:[uū]l(?:[aā](?:[iī][\s\xa0]*pahilo[\s\xa0]*patra)))|ur(?:intʰiyōṅ[\s\xa0]*ke[\s\xa0]*nām[\s\xa0]*kā[\s\xa0]*pahlā[\s\xa0]*ḫaṭ|ĩtʰīāṃ[\s\xa0]*nū̃[\s\xa0]*pahilī[\s\xa0]*pattrī)|ari[mṃ]tʰkar(?:[aā](?:[mṃ]s[\s\xa0]*pahile[\s\xa0]*patra)))|۱(?:-?کُرِنتھِیوں|[\s\xa0]*ک(?:رنتھِیُوں|ُرنتھِیوں)|۔کرنتھیوں)|رسالة[\s\xa0]*بولس[\s\xa0]*الرسول[\s\xa0]*الأولى[\s\xa0]*إلى[\s\xa0]*أهل[\s\xa0]*كورنثوس|אגרת[\s\xa0]*פולוס[\s\xa0]*הראשונה[\s\xa0]*אל-?הקורי|ا(?:لرسالة[\s\xa0]*الأولى[\s\xa0]*إلى[\s\xa0]*أهل[\s\xa0]*كورنثوس|وّل(?:-?کُرِنتھِیوں|[\s\xa0]*ک(?:رنتھِیُوں|ُرنتھِیوں)|۔کرنتھیوں))|Una(?:ng[\s\xa0]*(?:Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)|Mga[\s\xa0]*Taga(?:-?[\s\xa0]*Corinto|[\s\xa0]*Corinto)|(?:[CK]orint(?:io|o)))|[\s\xa0]*(?:Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)|Mga[\s\xa0]*Taga(?:-?[\s\xa0]*Corinto|[\s\xa0]*Corinto)|(?:[CK]orint(?:io|o))))|האיגרת[\s\xa0]*הראשונה[\s\xa0]*אל[\s\xa0]*הקורינתים|E(?:nsimm(?:[aä]inen[\s\xa0]*K(?:irje[\s\xa0]*korinttilaisille|orintt(?:olaiskirje|ilaisille)))|pistula[\s\xa0]*(?:I[\s\xa0]*ad[\s\xa0]*Corinthios|ad[\s\xa0]*Corinthios[\s\xa0]*I)|rste[\s\xa0]*Korinther|erste[\s\xa0]*(?:Corint(?:i[eë]rs?|h(?:i[eë]rs?|e))|Kor(?:int(?:i[eë]rs?|h(?:i[eë]rs?|e)))?)|ls(?:[oő][\s\xa0]*Kor(?:int(?:hus(?:iakhoz)?|usi))?))|କରିନ୍ଥୀୟଙ୍କ[\s\xa0]*ପ୍ରତି[\s\xa0]*ପ୍ରଥମ[\s\xa0]*ପତ୍ର|Wa(?:raka[\s\xa0]*wa[\s\xa0]*Kwanza[\s\xa0]*kwa[\s\xa0]*Wakorint(?:ho|o)|korintho[\s\xa0]*I)|पौलाचे[\s\xa0]*करिंथकरांस[\s\xa0]*पहिले[\s\xa0]*पत्र|ପ୍ରଥମ[\s\xa0]*କରିନ୍ଥୀୟ(?:ଙ୍କ)?|코린토(?:[\s\xa0]*신자들에게[\s\xa0]*보낸[\s\xa0]*첫째[\s\xa0]*서간|1서)|கொரிந்தியருக்கு[\s\xa0]*எழுதிய[\s\xa0]*முதல(?:்[\s\xa0]*திருமுகம்|ா(?:வது[\s\xa0]*(?:திருமுகம்|நிருபம்)|ம்))|K(?:orint(?:iyarukku[\s\xa0]*E[lḻ]utiya[\s\xa0]*Mutal(?:[aā]vatu[\s\xa0]*Nirupam)|os[\s\xa0]*Kowaad)|wanza[\s\xa0]*(?:Wakorint(?:ho|o)|Kor))|ਕੁਰਿੰਥੀਆਂ[\s\xa0]*ਨੂੰ[\s\xa0]*ਪਹਿਲੀ[\s\xa0]*ਪੱਤ੍ਰੀ|1(?:re(?:\.[\s\xa0]*Corinthiens|[\s\xa0]*Corinthiens)|Cor|-?(?:я(?:\.[\s\xa0]*(?:к[\s\xa0]*Коринфянам|Коринфянам)|[\s\xa0]*(?:к[\s\xa0]*Коринфянам|Коринфянам))|ше(?:\.[\s\xa0]*(?:послання[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|Послання[\s\xa0]*до[\s\xa0]*Коринтян|до[\s\xa0]*коринтян|Корин(?:тяни|фян)|коринтян)|[\s\xa0]*(?:послання[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|Послання[\s\xa0]*до[\s\xa0]*Коринтян|до[\s\xa0]*коринтян|Корин(?:тяни|фян)|коринтян))|کُرِنتھِیوں|а(?:\.[\s\xa0]*(?:послання[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|Послання[\s\xa0]*до[\s\xa0]*Коринтян|до[\s\xa0]*коринтян|Корин(?:тяни|фян)|коринтян)|[\s\xa0]*(?:послання[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|Послання[\s\xa0]*до[\s\xa0]*Коринтян|до[\s\xa0]*коринтян|Корин(?:тяни|фян)|коринтян))|е(?:\.[\s\xa0]*(?:послання[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|Послання[\s\xa0]*до[\s\xa0]*Коринтян|до[\s\xa0]*коринтян|Корин(?:тяни|фян(?:ам)?)|к(?:[\s\xa0]*Коринфянам|оринтян))|[\s\xa0]*(?:послання[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|Послання[\s\xa0]*до[\s\xa0]*Коринтян|до[\s\xa0]*коринтян|Корин(?:тяни|фян(?:ам)?)|к(?:[\s\xa0]*Коринфянам|оринтян))))|\.(?:-?کُرِنتھِیوں|(?:[oº](?:\.[\s\xa0]*Corintios|[\s\xa0]*Corintios))|۔کرنتھیوں|[\s\xa0]*(?:କରିନ୍ଥୀୟ(?:ଙ୍କ)?|к[\s\xa0]*Коринфянам|korint(?:ʰ[iī]har(?:[uū]l(?:[aā][iī]))|erbrev)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Коринт|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|ица[\s\xa0]*Коринћанима))|K(?:irje[\s\xa0]*korinttilaisille|urinthiayon|or(?:entyen|ynt(?:ian|[oó]w)|i(?:tasve|n(?:[cć]anima[\s\xa0]*Poslanica|ťanom|t(?:t(?:olaiskirje|ilaisille)|sk[yý]m|er(?:ne)?|h(?:i(?:er(?:brevet|s)?|ërs?)|us(?:iakhoz)?|e(?:r(?:brev(?:et)?)?)?)|i(?:er(?:brevet|ne|s)?|ërs?|o)|usi?|a(?:nom|sve)?|os?)?)))?)|до[\s\xa0]*коринтян|Wakorint(?:ho|o)|Mga[\s\xa0]*Taga(?:[\s\xa0]*Corinto|-?(?:[\s\xa0]*Corinto|Corinto))|Taga-?Corinto|โครินธ์|list[\s\xa0]*(?:do[\s\xa0]*Koryntian|Korin(?:tsk[yý]m|sk[yý]m))|Кор(?:ин(?:[кќ]аните|ћанима|тјани|фян(?:ам)?))?|क(?:ोरिन्(?:‍थी|थी(?:हरूलाई)?)|ुर(?:न्थियों|िन्(?:यि़यों|थ(?:ियों?)?)))|Послання[\s\xa0]*до[\s\xa0]*Коринтян|List[\s\xa0]*(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian))|ک(?:رنتھِیُوں|ُرنتھِیوں)|C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|ô(?:-?rinh-?tô|rintô)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|íntios|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|zi|t(?:eni|i(?:ans|e(?:ni|rs?)|ërs?|o(?:ns|s)?)|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|a(?:ans|i(?:ns|d)|n(?:[ao]s|s)?)|e(?:ns|rs?)|n(?:as|s)|o(?:ns|s)|ërs?)|e)?|o)?)?)|th(?:ians?)?)?)?)|Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)))|°(?:\.[\s\xa0]*Corinzi|[\s\xa0]*Corinzi)|۔کرنتھیوں|코린|[\s\xa0]*(?:କରିନ୍ଥୀୟ(?:ଙ୍କ)?|k(?:\.[\s\xa0]*Korin(?:t(?:anom|sk[yý]m)|ťanom)|ari[mṃ]tʰkar(?:[aā](?:[mṃ]s))|[\s\xa0]*Korin(?:t(?:anom|sk[yý]m)|ťanom)|orint(?:ʰ[iī]har(?:[uū]l(?:[aā][iī]))|erbrev)|urĩtʰīāṃ)|к[\s\xa0]*Коринфянам|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*христијаните[\s\xa0]*во[\s\xa0]*Коринт|ослан(?:ня[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*коринфян|ица[\s\xa0]*Коринћанима))|கொ(?:ரி(?:ந்தியர்)?)?|K(?:irje[\s\xa0]*korinttilaisille|urinthiayon|or(?:entyen|ynt(?:ian|[oó]w)|i(?:tasve|n(?:[cć]anima[\s\xa0]*Poslanica|ťanom|t(?:t(?:olaiskirje|ilaisille)|sk[yý]m|er(?:ne)?|h(?:i(?:er(?:brevet|s)?|ërs?)|us(?:iakhoz)?|e(?:r(?:brev(?:et)?)?)?)|i(?:yarukku|er(?:brevet|ne|s)?|ërs?|o)|usi?|a(?:nom|sve)?|os?)?)))?)|क(?:रिंथकरांस|ोरिन्(?:‍थी|थी(?:हरूलाई)?)|ुर(?:न्थियों|िन्(?:यि़यों|थ(?:ियों?)?)))|до[\s\xa0]*коринтян|Wakorint(?:ho|o)|Mga[\s\xa0]*Taga(?:[\s\xa0]*Corinto|-?(?:[\s\xa0]*Corinto|Corinto))|Taga-?Corinto|โครินธ์|list[\s\xa0]*(?:do[\s\xa0]*Koryntian|Korin(?:tsk[yý]m|sk[yý]m))|Кор(?:ин(?:[кќ]аните|ћанима|тјани|фян(?:ам)?))?|ਕੁਰਿੰਥੀਆਂ[\s\xa0]*ਨੂੰ|Послання[\s\xa0]*до[\s\xa0]*Коринтян|List[\s\xa0]*(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian))|ک(?:رنتھِیُوں|ُرنتھِیوں)|قور|(?:[ie](?:\.[\s\xa0]*Kori(?:ntasve|tasve)|[\s\xa0]*Kori(?:ntasve|tasve)))|C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|ô(?:-?rinh-?tô|rintô)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|íntios|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|zi|i(?:th(?:i(?:ans|nas)|a(?:ins|ns)))?|t(?:eni|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|a(?:ans|i(?:ns|d)|n(?:[ao]s|s)?)|e(?:ns|rs?)|n(?:as|s)|o(?:ns|s)|ërs?)|e)?|i(?:ans|e(?:ni|rs?)|ërs?|o(?:ns|s)?)?|o)?)?)|th(?:ians?)?)?)?)|ค[ธร])|º(?:\.[\s\xa0]*Corintios|[\s\xa0]*Corintios)|[oa](?:\.[\s\xa0]*Cor(?:[ií]ntios|[\s\xa0]*Cor[ií]ntios))|(?:[ея](?:\.[\s\xa0]*(?:к[\s\xa0]*Коринфянам|Коринфянам)|[\s\xa0]*(?:к[\s\xa0]*Коринфянам|Коринфянам)))|كو|ère(?:\.[\s\xa0]*Corinthiens|[\s\xa0]*Corinthiens)|e(?:r(?:\.[\s\xa0]*Corinthiens|e(?:\.[\s\xa0]*Corinthiens|[\s\xa0]*Corinthiens)|[\s\xa0]*Corinthiens)|\.[\s\xa0]*(?:Corint(?:i[eë]rs?|h(?:i[eë]rs?|e))|Kor(?:int(?:i[eë]rs?|h(?:i[eë]rs?|e)))?)|[\s\xa0]*(?:Corint(?:i[eë]rs?|h(?:i[eë]rs?|e))|Kor(?:int(?:i[eë]rs?|h(?:i[eë]rs?|e)))?))|st(?:\.[\s\xa0]*C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|t(?:i[ao]ns|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|ons|a(?:[ai]ns|n(?:[ao]s|s)?)|n(?:as|s)))?)?)?)|th(?:ians?)?)?)?)|[\s\xa0]*C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|t(?:i[ao]ns|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|ons|a(?:[ai]ns|n(?:[ao]s|s)?)|n(?:as|s)))?)?)?)|th(?:ians?)?)?)?)))|P(?:er[sš]e[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*korynfjan|a(?:vlova[\s\xa0]*prva[\s\xa0]*poslanica[\s\xa0]*Korin[cć]anima|ulus(?:'[\s\xa0]*(?:Første[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Korintherne|1(?:\.[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Korintherne|[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Korintherne))|’[\s\xa0]*(?:Første[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Korintherne|første[\s\xa0]*brev[\s\xa0]*til[\s\xa0]*korinterne|1(?:\.[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Korintherne|[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Korintherne))))|ierwsz(?:[aey][\s\xa0]*(?:List[\s\xa0]*(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Koryntian))|list[\s\xa0]*do[\s\xa0]*Koryntian|Korynt(?:ian|[oó]w)))|r(?:em(?:i(?:ère(?:s[\s\xa0]*Corinthiens|[\s\xa0]*Corinthiens)|er(?:e(?:s[\s\xa0]*Corinthiens|[\s\xa0]*Corinthiens)|s[\s\xa0]*Corinthiens|[\s\xa0]*Corinthiens))|ye[\s\xa0]*Kor(?:entyen|int))|im(?:e(?:ir[ao][\s\xa0]*Cor(?:[ií]ntios)|r(?:o[\s\xa0]*Corintios|[\s\xa0]*Corintios))|a[\s\xa0]*(?:lettera[\s\xa0]*ai[\s\xa0]*Corinzi|Corinzi)|o[\s\xa0]*Corinzi)|v(?:a[\s\xa0]*(?:poslanica[\s\xa0]*Korinæanima|kniha[\s\xa0]*Korin(?:t(?:anom|sk[yý]m)|ťanom)|Korin(?:[cć]anima[\s\xa0]*Poslanica|t(?:anom|sk[yý]m)|ťanom))|(?:[yý][\s\xa0]*(?:list[\s\xa0]*Korin(?:t(?:anom|sk[yý]m)|ťanom)|Korin(?:t(?:anom|sk[yý]m)|ťanom)))|á[\s\xa0]*(?:kniha[\s\xa0]*Korin(?:t(?:anom|sk[yý]m)|ťanom)|Korin(?:t(?:anom|sk[yý]m)|ťanom))|n[ií](?:[\s\xa0]*(?:list[\s\xa0]*Korin(?:tsk(?:[yý]m|sk[yý]m)|K)|K)))))|ﻛﻮﺭﻧﺜﻮﺱ[\s\xa0]*ﺍﻻﻭﻝ|コリント(?:の信徒への手紙一|人への(?:第一の手紙|前の書|手紙一)|[\s\xa0]*1|前書)|Προς[\s\xa0]*Κορινθ[ίι]ους[\s\xa0]*Α['ʹʹ΄’]|कोरिन्थीहरूलाई[\s\xa0]*प(?:ावलको[\s\xa0]*पहिलो[\s\xa0]*पत्र|हिलो[\s\xa0]*पत्र)|كورنثوس[\s\xa0]*الأولى|《(?:哥林多前[书書]》|[格歌]林多前書》|适凌爾福前》|林前》)|F(?:(?:[oö]rsta[\s\xa0]*Korint(?:h(?:ierbrevet|erbrevet)|ierbrevet|erbrevet))|yrra[\s\xa0]*(?:br(?:[eé]f[\s\xa0]*P(?:[aá]ls[\s\xa0]*til[\s\xa0]*Korin(?:tumanna)?))|Korintubr[eé]f)|ørste[\s\xa0]*(?:korinterbrev|Kor(?:int(?:herbrev|ierne|er(?:ne)?))?)|irst[\s\xa0]*C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|t(?:i[ao]ns|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|ons|a(?:[ai]ns|n(?:[ao]s|s)?)|n(?:as|s)))?)?)?)|th(?:ians?)?)?)?))|Barua[\s\xa0]*ya[\s\xa0]*Kwanza[\s\xa0]*kwa[\s\xa0]*Wakorintho)|(?:1[ao][\s\xa0]*Cor(?:[ií]ntios)|Prvn[ií](?:[\s\xa0]*list[\s\xa0]*Korinsk(?:[yý]m|K))|Α['ʹʹ΄’][\s\xa0]*Κο)|Prvn(?:[ií]K)|(?:Prva[\s\xa0]*(?:poslanica[\s\xa0]*Korin[ćc]anima|Korin[ćc]anima)|《(?:[格歌]林多前書|哥林多前[書书]|适凌爾福前|林前)|林前》?|ad[\s\xa0]*Corinthios[\s\xa0]*I|करिंथकरांस[\s\xa0]*पहिले[\s\xa0]*पत्र|I(?:\.[\s\xa0]*(?:Korin[ćc]anima|Cô(?:-?rinh)?)|[\s\xa0]*(?:Korin[ćc]anima|Cô(?:-?rinh)?))|哥林多前[书書]》?|C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|or(?:ri(?:nth(?:ians|ains)|th(?:ains|ians))|i(?:inthi(?:ians|ans)|n(?:[na]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|t(?:h(?:o(?:ians|ans)|i(?:ians|o(?:s[\s\xa0]*I|ns)|a(?:[ia]ns|n(?:[oa]s|s)?)|n(?:as|s))|a(?:i(?:ans|ns)|ns))|i[ao]ns))|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns)))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))))|ਕੁਰਿੰਥੀਆਂ[\s\xa0]*ਨੂੰ|1(?:\.[\s\xa0]*(?:Korin[cć]anima|Cô(?:-?rinh)?)|[\s\xa0]*(?:Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)|Korin[ćc]anima|ਕੁਰਿੰਥੀਆਂ|Cô(?:-?rinh)?))|适凌爾福前》?|[歌格]林多前書》?|הראשונה[\s\xa0]*אל[\s\xa0]*הקורינתים))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["Gal"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(gal(?:āt(?:ihar[uū]l(?:[aā](?:[iī][\\s\\xa0]*patra))|ī(?:har[uū]l(?:[aā](?:[iī][\\s\\xa0]*patra))|āṃ[\\s\\xa0]*nū̃[\\s\\xa0]*pattrī))|at(?:i(?:yōṅ[\\s\\xa0]*ke[\\s\\xa0]*nām[\\s\\xa0]*kā[\\s\\xa0]*ḫaṭ|har[uū]l(?:[aā](?:[iī][\\s\\xa0]*patra))|kar[aā](?:[mṃ]s[\\s\\xa0]*patra))|ī(?:har[uū]l(?:[aā](?:[iī][\\s\\xa0]*patra))|kar[aā](?:[mṃ]s[\\s\\xa0]*patra))))|(?:رسالة[\\s\\xa0]*(?:بولس[\\s\\xa0]*الرسول[\\s\\xa0]*إلى[\\s\\xa0]*أهل[\\s\\xa0]*غلاطية|غلاطية)|पौलाचे[\\s\\xa0]*गलतीकरांस[\\s\\xa0]*पत्र|אגרת[\\s\\xa0]*פולוס[\\s\\xa0]*השליח[\\s\\xa0]*אל-?הגלטים|ﻏﻼﻃﻲ|갈라(?:티아[\\s\\xa0]*신자들에게[\\s\\xa0]*보낸[\\s\\xa0]*서간|디아서)?|ଗାଲାତୀୟଙ୍କ[\\s\\xa0]*ପ୍ରତି[\\s\\xa0]*ପତ୍ର|П(?:исмо[\\s\\xa0]*од[\\s\\xa0]*апостол[\\s\\xa0]*Павле[\\s\\xa0]*до[\\s\\xa0]*христијаните[\\s\\xa0]*во[\\s\\xa0]*Галатија|о(?:[\\s\\xa0]*слання[\\s\\xa0]*до[\\s\\xa0]*Галатів|слан(?:ня[\\s\\xa0]*(?:св(?:\\.[\\s\\xa0]*апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*галатів|[\\s\\xa0]*апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*галатів)|апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*галатів|до[\\s\\xa0]*галатів)|и(?:е[\\s\\xa0]*(?:на[\\s\\xa0]*св(?:\\.[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Галатяни|[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Галатяни)|[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Галатяни|[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Галатяни))|к(?:ъм[\\s\\xa0]*галатяните|[\\s\\xa0]*Галатам))|ца[\\s\\xa0]*Гала(?:ћанима|тима)))))|K(?:al[aā]ttiyarukku[\\s\\xa0]*E(?:[lḻ]utiya[\\s\\xa0]*Nirupam)|irje[\\s\\xa0]*galatalaisille)|Гал(?:ат(?:јани|ите))?|غل|L(?:ayang[\\s\\xa0]*Paulus[\\s\\xa0]*Galatia|ettera[\\s\\xa0]*ai[\\s\\xa0]*Galati|ist[\\s\\xa0]*(?:(?:[sś]w(?:\\.[\\s\\xa0]*Pawła[\\s\\xa0]*do[\\s\\xa0]*Galacjan|[\\s\\xa0]*Pawła[\\s\\xa0]*do[\\s\\xa0]*Galacjan))|do[\\s\\xa0]*Gala(?:cjan|t[oó]w)|Gala(?:t(?:anom|sk[yý]m)|ťanom)))|الرسالة[\\s\\xa0]*إلى[\\s\\xa0]*أهل[\\s\\xa0]*غلاطية|Sulat[\\s\\xa0]*sa[\\s\\xa0]*mga[\\s\\xa0]*(?:taga[\\s\\xa0]*Galacia|Galacia)|G(?:àlati|a(?:-?la-?ti|l(?:lati(?:[ao]ns|ns)|át|a(?:s(?:y(?:ano|en)|ia?)|t(?:ákhoz|i(?:i(?:[ao]ns|ns)|a(?:ans|i(?:ns|d)|n(?:[ai]s|s)?|s)|n(?:a(?:ns|s)|s)|o(?:ans|n(?:[an]s|s)|s)|y(?:on|a))|o(?:ans|ns)|e(?:n(?:brief|i)?|r(?:bre(?:fvet|vet))?|s)|ns|a(?:laiskirj|br[eé]fið|khoz|[ao]ns|i(?:[ao]ns|ns)|sve|ns)?)?)?)?)|l|á(?:l(?:at(?:as)?)?)?)|ก(?:าลาเทีย|ท)|《(?:戛拉提亞》|迦拉達書》|加(?:拉太[书書]》|》))|B(?:r(?:éf[\\s\\xa0]*P[aá]ls[\\s\\xa0]*til[\\s\\xa0]*Galatamanna|e(?:f[\\s\\xa0]*P[aá]ls[\\s\\xa0]*til[\\s\\xa0]*Galatamanna|vet[\\s\\xa0]*til[\\s\\xa0]*Galaterne))|arua[\\s\\xa0]*kwa[\\s\\xa0]*Wagalatia)|P(?:a(?:vlova[\\s\\xa0]*poslanica[\\s\\xa0]*Gala[cć]anima|ulus['’][\\s\\xa0]*Brev[\\s\\xa0]*til[\\s\\xa0]*Galaterne)|oslan(?:nja[\\s\\xa0]*apostola[\\s\\xa0]*Pavla[\\s\\xa0]*do[\\s\\xa0]*halativ|ica[\\s\\xa0]*Galaæanima))|Mga[\\s\\xa0]*Taga(?:[\\s\\xa0]*Galasya|-?(?:[\\s\\xa0]*Gala(?:cia|sya)|Galacia))|கலா(?:த்(?:தியர(?:ுக்கு[\\s\\xa0]*எழுதிய[\\s\\xa0]*(?:திருமுகம்|நிருபம்|கடிதம்)|்))?)?|Epistula[\\s\\xa0]*ad[\\s\\xa0]*Galatas|Γα(?:λ(?:[άα]τες)?)?|(?:[カガ]ラテヤ(?:の信徒への手紙|人への(?:手紙|書)|書)?)|Προς[\\s\\xa0]*Γαλ[άα]τας|गल(?:तियों|ात(?:ि(?:यों)?|ी(?:हरूलाई[\\s\\xa0]*प(?:ावलको[\\s\\xa0]*पत्र|त्र))?))|האיגרת[\\s\\xa0]*אל[\\s\\xa0]*הגלטים|ਗਲਾਤੀਆਂ[\\s\\xa0]*ਨੂੰ[\\s\\xa0]*ਪੱਤ੍ਰੀ|گلت(?:ِیوں[\\s\\xa0]*کے[\\s\\xa0]*نام[\\s\\xa0]*کا[\\s\\xa0]*خط|یوں[\\s\\xa0]*کے[\\s\\xa0]*نام[\\s\\xa0]*(?:پولُس[\\s\\xa0]*رسول[\\s\\xa0]*کا[\\s\\xa0]*خط|کا[\\s\\xa0]*خط)))|Gala(?:ćanima|c(?:anima|ia)|t(?:erne|as))|gal(?:at[iī](?:har(?:[ūu]l(?:[aā][īi])|kar[āa](?:[ṃm]s)))|āt(?:ihar[uū]l(?:[aā][īi])|ī(?:har[uū]l(?:[āa][iī])|āṃ)))|galat[iī]kar(?:[āa](?:[ṃm]s))|(?:До[\\s\\xa0]*галатів|迦拉達書》|Ga(?:la(?:ťanom|cjan|t(?:a(?:laisille|nom)|sk[ýy]m|[oó]w|ia?)))?|ad[\\s\\xa0]*Galatas|戛拉提亞》|Mga[\\s\\xa0]*Taga[\\s\\xa0]*Galacia|ଗାଲାତୀୟଙ୍କ|ਗਲਾਤੀਆਂ[\\s\\xa0]*ਨੂੰ|Гала(?:ћанима|т(?:има|яни(?:те)?))|加(?:拉太[书書]》|》)|Kal[āa]ttiyarukku|گلت(?:ِیوں|یوں)|Wagalatia|אל[\\s\\xa0]*הגלטים|Taga-?(?:[\\s\\xa0]*Galacia|Galacia)|К[\\s\\xa0]*Галатам|P(?:aulus’[\\s\\xa0]*brev[\\s\\xa0]*til[\\s\\xa0]*galaterne|oslanica[\\s\\xa0]*Gala[cć]anima)|गल(?:तीकरांस[\\s\\xa0]*पत्र|ातीहरूलाई)|《(?:戛拉提亞|迦拉達書|加(?:拉太[书書])?))|(?:Taga[\\s\\xa0]*Galacia|गलतीकरांस|Галат(?:ів|ам)|迦拉達書|戛拉提亞|加(?:拉太[书書])?))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Eph"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:Προς[\\s\\xa0]*Εφεσ[ίι]ους|П(?:исмо[\\s\\xa0]*од[\\s\\xa0]*апостол[\\s\\xa0]*Павле[\\s\\xa0]*до[\\s\\xa0]*христијаните[\\s\\xa0]*во[\\s\\xa0]*Ефес|о(?:[\\s\\xa0]*слан[\\s\\xa0]*ня[\\s\\xa0]*до[\\s\\xa0]*Єфесян|слан(?:и(?:е[\\s\\xa0]*(?:на[\\s\\xa0]*св(?:\\.[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Ефесяни|[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Ефесяни)|[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Ефесяни|[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Ефесяни))|к(?:ъм[\\s\\xa0]*ефесяните|[\\s\\xa0]*Ефесянам))|ца[\\s\\xa0]*Ефесцима)|ня[\\s\\xa0]*(?:св(?:\\.[\\s\\xa0]*апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*ефесян|[\\s\\xa0]*апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*ефесян)|апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*ефесян|до[\\s\\xa0]*ефесян))))|أف|ਅਫ਼ਸੀਆਂ[\\s\\xa0]*ਨੂੰ[\\s\\xa0]*ਪੱਤ੍ਰੀ|எபே(?:சி(?:யர(?:ுக்கு[\\s\\xa0]*எழுதிய[\\s\\xa0]*(?:திருமுகம்|நிருபம்|கடிதம்)|்))?)?|Єф|エ(?:フェソ(?:の信徒への手紙|人への手紙|書)?|(?:[ヘペ]ソ(?:人への(?:手紙|書)|書)))|L(?:ayang[\\s\\xa0]*Paulus[\\s\\xa0]*Efesus|ettera[\\s\\xa0]*agli[\\s\\xa0]*Efesini|ist[\\s\\xa0]*(?:[SŚ]wi(?:[eę]tego[\\s\\xa0]*Pawła[\\s\\xa0]*Apostoła[\\s\\xa0]*do[\\s\\xa0]*Efez(?:[oó]w))|(?:[sś]w(?:\\.[\\s\\xa0]*Pawła[\\s\\xa0]*do[\\s\\xa0]*Efezjan|[\\s\\xa0]*Pawła[\\s\\xa0]*do[\\s\\xa0]*Efezjan))|do[\\s\\xa0]*Efezjan|Ef(?:ez(?:an[ouů]m|sk[yý]m)|ézsk[yý]m)))|Εφ|אגרת[\\s\\xa0]*פולוס[\\s\\xa0]*השליח[\\s\\xa0]*אל-?האפסים|᾿Εφ|P(?:oslannja[\\s\\xa0]*apostola[\\s\\xa0]*Pavla[\\s\\xa0]*do[\\s\\xa0]*efesjan|a(?:vlova[\\s\\xa0]*poslanica[\\s\\xa0]*Efe[zž]anima|ulus['’][\\s\\xa0]*Brev[\\s\\xa0]*til[\\s\\xa0]*Efeserne))|رسالة[\\s\\xa0]*(?:بولس[\\s\\xa0]*الرسول[\\s\\xa0]*إلى[\\s\\xa0]*أهل[\\s\\xa0]*أفسس|أفسس)|पौलाचे[\\s\\xa0]*इफिसकरांस[\\s\\xa0]*पत्र|Kirje[\\s\\xa0]*efesolaisille|afasīāṃ[\\s\\xa0]*nū̃[\\s\\xa0]*pattrī|ا(?:لرسالة[\\s\\xa0]*إلى[\\s\\xa0]*أهل[\\s\\xa0]*أفسس|فسیوں[\\s\\xa0]*کے[\\s\\xa0]*نام[\\s\\xa0]*(?:پو[\\s\\xa0]*لس[\\s\\xa0]*رسول[\\s\\xa0]*کا[\\s\\xa0]*خط|کا[\\s\\xa0]*خط)|ِف(?:ِسِیوں[\\s\\xa0]*کے[\\s\\xa0]*نام[\\s\\xa0]*کا[\\s\\xa0]*خط|س(?:ِیوں|یوں)))|Эф(?:есянам)?|Waraka[\\s\\xa0]*kwa[\\s\\xa0]*Waefeso|Iafisiyon|อฟ|epʰis[iī]har(?:[uū]l(?:[aā](?:[iī][\\s\\xa0]*patra)))|ଏଫିସୀୟଙ୍କ[\\s\\xa0]*ପ୍ରତି[\\s\\xa0]*ପତ୍ର|E(?:sphesians|hp(?:[ei]sians)?|f(?:é(?:zusiakhoz|s(?:ios|e))|èz|e(?:s(?:usbr[eé]fið|i(?:erbrevet|an[eë]ve|os)|k[yý]m|o(?:laiskirje|s)|e(?:rbrevet|ni)?)?|z(?:i[eë]rs|yen|us(?:iakhoz)?)?)?|f(?:esiaid)?)?|p(?:ēciyarukku[\\s\\xa0]*E[lḻ]utiya[\\s\\xa0]*Nirupam|istula[\\s\\xa0]*ad[\\s\\xa0]*Ephesios|e(?:ciyarukku[\\s\\xa0]*E[lḻ]utiya[\\s\\xa0]*Nirupam|hesians|sians)|h(?:isians?|e(?:s(?:zosziakhoz|ains?|i(?:[eo]ns|a(?:id|n[ds]?))|er)?)?|s(?:ians?)?|é(?:s(?:iens)?)?)?)?)|ﺃﻓﺴﺲ|Sulat[\\s\\xa0]*sa[\\s\\xa0]*mga[\\s\\xa0]*E(?:[fp]es(?:io|o))|एफिसी(?:हरूलाई[\\s\\xa0]*प(?:ावलको[\\s\\xa0]*पत्र|त्र))?|《(?:以弗所[书書]》|厄弗所書》|耶斐斯》|弗》)|Ép(?:h(?:[eé](?:s(?:iens)?)?)?)?|เอเฟซัส|에(?:베소서|페(?:소(?:[\\s\\xa0]*신자들에게[\\s\\xa0]*보낸[\\s\\xa0]*서간|서))?)|B(?:r[eé]f[\\s\\xa0]*P(?:[aá]ls[\\s\\xa0]*til[\\s\\xa0]*Efesusmanna)|arua[\\s\\xa0]*kwa[\\s\\xa0]*Waefeso)|Ê(?:-?phê-?sô|ph(?:êsô)?)|इफिस(?:ि(?:यों)?|ी)|i(?:fisiyōṅ[\\s\\xa0]*ke[\\s\\xa0]*nām[\\s\\xa0]*kā[\\s\\xa0]*ḫaṭ|pʰiskar[aā](?:[mṃ]s[\\s\\xa0]*patra))|האיגרת[\\s\\xa0]*אל[\\s\\xa0]*האפסים|Еф(?:е(?:шаните|сјани))?|Mga[\\s\\xa0]*Taga(?:[\\s\\xa0]*E(?:[fp]es(?:io|o))|-?(?:[\\s\\xa0]*E(?:[fp]es(?:io|o))|[EÉ]feso)))|(?:弗》?|К[\\s\\xa0]*Ефесянам|以弗所[書书]》?|P(?:aulus’[\\s\\xa0]*brev[\\s\\xa0]*til[\\s\\xa0]*efeserne|oslanica[\\s\\xa0]*Efe[žz]anima)|厄弗所書》?|ipʰiskar[aā](?:[mṃ]s)|Mga[\\s\\xa0]*E(?:[pf]es(?:io|o))|افسیوں|Waefeso|До[\\s\\xa0]*ефесян|耶斐斯》?|Éfeso|《(?:厄弗所書|以弗所[書书]|耶斐斯|弗)|E(?:p(?:[eē]ciyarukku|hesios)|fe(?:žanima|z(?:an(?:ima|om)|sk[ýy]m|jan|[óo]w)|s(?:erne|ini|us|o(?:laisille)?)))|Taga(?:[\\s\\xa0]*E(?:[fp]es(?:io|o))|-?(?:[\\s\\xa0]*E(?:[fp]es(?:io|o))|[ÉE]feso))|אל[\\s\\xa0]*האפסים|ਅਫ਼ਸੀਆਂ[\\s\\xa0]*ਨੂੰ|epʰis[īi]har(?:[ūu]l(?:[aā][iī]))|a(?:d[\\s\\xa0]*Ephesios|fasīāṃ)|Εφεσ[ιί]ους|Ефес(?:цима|ян(?:ам|и(?:те)?)?)|इफिसकरांस(?:[\\s\\xa0]*पत्र)?|ଏଫିସୀୟଙ୍କ|एफिसीहरूलाई))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Col"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:คส|पौलाचे[\\s\\xa0]*कलस्सैकरांस[\\s\\xa0]*पत्र|Προς[\\s\\xa0]*Κολοσσαε[ίι]ς|C(?:al(?:l(?:asi[ao]ns|os(?:sians|i[ao]ns))|[ao]s(?:si(?:[ao]ns|i[ao]ns)))|ô(?:-?lô-?se|l(?:ôxê)?)|l|o(?:l(?:l[ao]si(?:[ao]ns)|as(?:si[ao]ns|i[ao]ns)|os(?:i(?:a(?:id|ns)|ons)|en(?:ses|i)|s(?:enzen|ans|i(?:[eo]ns|a(?:id|ns?)))?)?)?)?)|B(?:r[eé]f[\\s\\xa0]*P(?:[aá]ls[\\s\\xa0]*til[\\s\\xa0]*K(?:[oó]lossumanna?))|arua[\\s\\xa0]*kwa[\\s\\xa0]*Wakolosai)|Κ(?:ολ|λ)|क(?:ुलुस्(?:‍सी|सि(?:यों)?)|लस(?:ैकरांस|्सी(?:हरूलाई[\\s\\xa0]*प(?:ावलको[\\s\\xa0]*पत्र|त्र))?))|Mga[\\s\\xa0]*Taga(?:[\\s\\xa0]*[CK]olosas|-?(?:[\\s\\xa0]*[CK]olosas|Colosas))|ک(?:لسیوں[\\s\\xa0]*کے[\\s\\xa0]*نام[\\s\\xa0]*کا[\\s\\xa0]*خط|ُل(?:ِسّیوں[\\s\\xa0]*کے[\\s\\xa0]*نام[\\s\\xa0]*پولُس[\\s\\xa0]*رسُول[\\s\\xa0]*کا[\\s\\xa0]*خط|ُسِّیوں[\\s\\xa0]*کے[\\s\\xa0]*نام[\\s\\xa0]*کا[\\s\\xa0]*خط|س[ِّ]یوں))|الرسالة[\\s\\xa0]*إلى[\\s\\xa0]*أهل[\\s\\xa0]*كولوسي|ﻛﻮﻟﻮﺳﻲ|コロサイ(?:の信徒への手紙|人への(?:手紙|書)|書)?|Waraka[\\s\\xa0]*kwa[\\s\\xa0]*Wakolosai|До[\\s\\xa0]*колоссян|콜로(?:새(?:[\\s\\xa0]*신자들에게[\\s\\xa0]*보낸[\\s\\xa0]*서간|서))?|P(?:oslannja[\\s\\xa0]*apostola[\\s\\xa0]*Pavla[\\s\\xa0]*do[\\s\\xa0]*kolosjan|a(?:vlova[\\s\\xa0]*poslanica[\\s\\xa0]*Kolo[sš]anima|ulus(?:'[\\s\\xa0]*Brev[\\s\\xa0]*til[\\s\\xa0]*Kolossenserne|’[\\s\\xa0]*(?:Brev[\\s\\xa0]*til[\\s\\xa0]*Kolossenserne|brev[\\s\\xa0]*til[\\s\\xa0]*kolosserne))))|قول|골로새서|האיגרת[\\s\\xa0]*אל[\\s\\xa0]*הקולוסים|କଲସୀୟଙ୍କ[\\s\\xa0]*ପ୍ରତି[\\s\\xa0]*ପତ୍ର|Epistula[\\s\\xa0]*ad[\\s\\xa0]*Colossenses|《(?:哥羅森書》|歌(?:罗西书》|羅西書》)|适羅斯》|西》)|โคโลสี|אגרת[\\s\\xa0]*פולוס[\\s\\xa0]*השליח[\\s\\xa0]*אל-?הקולוסי|k(?:alass(?:aikar[aā](?:[mṃ]s[\\s\\xa0]*patra)|[iī]har(?:[uū]l(?:[aā](?:[iī][\\s\\xa0]*patra))))|uluss(?:iyōṅ[\\s\\xa0]*ke[\\s\\xa0]*nām[\\s\\xa0]*kā[\\s\\xa0]*ḫaṭ|īāṃ[\\s\\xa0]*nū̃[\\s\\xa0]*pattrī))|رسالة[\\s\\xa0]*(?:بولس[\\s\\xa0]*الرسول[\\s\\xa0]*إلى[\\s\\xa0]*أهل[\\s\\xa0]*كولوسي|كولوسي)|L(?:ayang[\\s\\xa0]*Paulus[\\s\\xa0]*Kolos[eé]|ettera[\\s\\xa0]*ai[\\s\\xa0]*Colossesi|ist[\\s\\xa0]*(?:(?:[sś]w(?:\\.[\\s\\xa0]*Pawła[\\s\\xa0]*do[\\s\\xa0]*Kolosan|[\\s\\xa0]*Pawła[\\s\\xa0]*do[\\s\\xa0]*Kolosan))|do[\\s\\xa0]*Kolosan|Kolos(?:an[ouů]m|k[yý]m)))|K(?:irje[\\s\\xa0]*kolossalaisille|ulussaiyon|ól[ou]ssubr(?:[eé]fið)?|o(?:l(?:ōceyarukku[\\s\\xa0]*E[lḻ]utiya[\\s\\xa0]*Nirupam|ussubr[eé]fið|o(?:ceyarukku[\\s\\xa0]*E[lḻ]utiya[\\s\\xa0]*Nirupam|s(?:ian[eë]ve|ens(?:k[yý]m|[oó]w)|yen|ay|s(?:alaiskirje|z(?:ébeliekhez|e(?:beliekhez|ieknek))|ubr[eé]fið|e(?:iakhoz|n(?:s(?:er(?:brevet|n)|k[yý]m)|zen)|r(?:brevet)?)?|é(?:iakhoz)?))?)|òs)?)?)|கொலோ(?:ச(?:ெயர(?:ுக்கு[\\s\\xa0]*எழுதிய[\\s\\xa0]*(?:நிருபம்|கடிதம்)|்)|ையர(?:ுக்கு[\\s\\xa0]*எழுதிய[\\s\\xa0]*திருமுகம்|்)))?|П(?:исмо[\\s\\xa0]*од[\\s\\xa0]*апостол[\\s\\xa0]*Павле[\\s\\xa0]*до[\\s\\xa0]*христијаните[\\s\\xa0]*во[\\s\\xa0]*Колос|ослан(?:и(?:е[\\s\\xa0]*(?:на[\\s\\xa0]*св(?:\\.[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Колосяни|[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Колосяни)|[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Колосяни|[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Колосяни))|к(?:ъм[\\s\\xa0]*колосяните|[\\s\\xa0]*Колоссянам))|ца[\\s\\xa0]*Колошанима)|ня[\\s\\xa0]*(?:св(?:\\.[\\s\\xa0]*апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*колосян|[\\s\\xa0]*апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*колосян)|апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*колосян|до[\\s\\xa0]*Колосян)))|Кол(?:о(?:шаните|сјани))?|كو|Sulat[\\s\\xa0]*sa[\\s\\xa0]*mga[\\s\\xa0]*(?:[CK]olo(?:nsense|sense))|ਕੁਲੁੱਸੀਆਂ[\\s\\xa0]*ਨੂੰ[\\s\\xa0]*ਪੱਤ੍ਰੀ)|(?:Cal[ao]si(?:[ao]ns)|Kól)|(?:适羅斯》?|西》?|Colos(?:se(?:nses|si)|as)|Wakolosai|कलस्स(?:ीहरूलाई|ैकरांस(?:[\\s\\xa0]*पत्र)?)|ک(?:ُلِسّیوں|لسیوں)|《(?:歌(?:罗西书|羅西書)|哥羅森書|适羅斯|西)|Κολοσσαε[ίι]ς|k(?:alass(?:[īi]har(?:[ūu]l(?:[aā][iī]))|aikar[āa](?:[mṃ]s))|ulussīāṃ)|Taga(?:-?(?:[\\s\\xa0]*Colosas|Colosas)|[\\s\\xa0]*Colosas)|ਕੁਲੁੱਸੀਆਂ[\\s\\xa0]*ਨੂੰ|אל[\\s\\xa0]*הקולוסים|哥羅森書》?|Mga[\\s\\xa0]*(?:[CK]olo(?:nsense|sense))|କଲସୀୟଙ୍କ|К(?:[\\s\\xa0]*Колоссянам|оло(?:шанима|с(?:сян(?:ам)?|ян(?:и(?:те)?)?)))|Kol(?:ōceyarukku|o(?:ceyarukku|šanima|s(?:s(?:alaisille|e(?:nserne|rne))|k[ýy]m|an(?:ima|[ouů]m)?|[eé])))|ad[\\s\\xa0]*Colossenses|Poslanica[\\s\\xa0]*Kolo[sš]anima|歌(?:羅西書》?|罗西书》?)))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["2Tim"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])((?:《(?:弟茂德後書》|提(?:摩(?:太(?:后书》|後書》)|斐後》)|[后後]》))|دوم(?:-?تِیمُتھِیُس|[\s\xa0]*ت(?:ِیمُتھِیُس|ی(?:ِمُتھِیُس|مِتھُیس))|۔تیمتھیس)|t(?:im(?:atʰtʰ[aā]l(?:[aā][\s\xa0]*dusre[\s\xa0]*patra)|otʰ(?:i(?:us[\s\xa0]*nū̃[\s\xa0]*dūjī[\s\xa0]*pattrī|l[aā](?:[iī][\s\xa0]*dostro[\s\xa0]*patra))|īl[aā](?:[iī][\s\xa0]*dostro[\s\xa0]*patra)))|īm(?:utʰiyus[\s\xa0]*ke[\s\xa0]*nām[\s\xa0]*kā[\s\xa0]*dūsrā[\s\xa0]*ḫaṭ|atʰtʰ[aā]l(?:[aā][\s\xa0]*dusre[\s\xa0]*patra)))|ت(?:ِیمُتھِیُس[\s\xa0]*کے[\s\xa0]*نام[\s\xa0]*کا[\s\xa0]*دوسرا[\s\xa0]*خط|ی(?:ِمُتھِیُس[\s\xa0]*کے[\s\xa0]*نام[\s\xa0]*پولس[\s\xa0]*رسول[\s\xa0]*کا[\s\xa0]*دوسرا[\s\xa0]*خط|متھیس[\s\xa0]*کے[\s\xa0]*نام[\s\xa0]*کا[\s\xa0]*دوسرا[\s\xa0]*خط)|يموثاوس[\s\xa0]*الثانية)|த(?:ிம[ொோ]த்தேயுவுக்கு[\s\xa0]*எழுதிய[\s\xa0]*இரண்டாம்[\s\xa0]*திருமுகம்|ீமோத்தேயுவுக்கு[\s\xa0]*எழுதிய[\s\xa0]*இரண்டா(?:வது[\s\xa0]*நிருபம்|ம்[\s\xa0]*கடிதம்))|رسالة[\s\xa0]*بولس[\s\xa0]*الرسول[\s\xa0]*الثانية[\s\xa0]*إلى[\s\xa0]*تيموثاوس|पौलाचे[\s\xa0]*तीमथ्थाला[\s\xa0]*दुसरे[\s\xa0]*पत्र|אגרת[\s\xa0]*פולוס[\s\xa0]*השנייה[\s\xa0]*אל-?טימותי|テモテ(?:ヘの第二の手紙|への(?:後の書|手紙二)|[\s\xa0]*2|後書)|तिमोथीलाई[\s\xa0]*(?:पावलको[\s\xa0]*दोस्रो[\s\xa0]*पत्र|दोस्त्रो[\s\xa0]*पत्र)|M(?:[aá]sodik[\s\xa0]*Tim(?:[oó]t(?:heosz|eus(?:hoz|nak)?))?)|۲(?:-?تِیمُتھِیُس|[\s\xa0]*ت(?:ِیمُتھِیُس|ی(?:ِمُتھِیُس|مِتھُیس))|۔تیمتھیس)|ﺍﻟﺜﺎﻧﻴﺔ[\s\xa0]*ﺗﻴﻤﻮﺛﺎﻭﺱ|P(?:a(?:vlova[\s\xa0]*druga[\s\xa0]*poslanica[\s\xa0]*Timoteju|ulus(?:'[\s\xa0]*Andet[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Timotheus|’[\s\xa0]*(?:Andet[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Timotheus|andre[\s\xa0]*brev[\s\xa0]*til[\s\xa0]*Timoteus)))|ili[\s\xa0]*Tim(?:otheo)?)|الرسالة[\s\xa0]*الثانية[\s\xa0]*إلى[\s\xa0]*تيموثاوس|D(?:e(?:uxi[eè]me(?:s[\s\xa0]*Timoth(?:[eé]e|[\s\xa0]*Timoth[eé]e))|zy[eè]m[\s\xa0]*Timote)|ru(?:g(?:a[\s\xa0]*(?:List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza))|do[\s\xa0]*Tymoteusza)|T(?:imoteju[\s\xa0]*Poslanica|ymoteusza))|i[\s\xa0]*(?:List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza))|do[\s\xa0]*Tymoteusza)|Tymoteusza))|h(?:e[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*Tymofija|(?:[aá][\s\xa0]*(?:kniha[\s\xa0]*Timote(?:jovi|ovi)|list[\s\xa0]*Tim[eo]teovi|T(?:im(?:ote(?:jovi|ovi|us))?|m)))|(?:[yý][\s\xa0]*(?:list[\s\xa0]*Tim(?:eteovi|ote(?:jovi|ovi))|T(?:im(?:ote(?:jovi|ovi|us))?|m))))))|二テモテ|ਤਿਮੋਥਿਉਸ[\s\xa0]*ਨੂੰ[\s\xa0]*ਦੂਜੀ[\s\xa0]*ਪੱਤ੍ਰੀ|I(?:kalawang[\s\xa0]*(?:Kay[\s\xa0]*Timoteo|Timoteo)|I(?:\.[\s\xa0]*(?:List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza))|do[\s\xa0]*Tymoteusza)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*Тимотеј|ослан(?:ица[\s\xa0]*Тимотеју|ня[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)))|list[\s\xa0]*Tim[eo]teovi|K(?:irje[\s\xa0]*Timoteukselle|ay[\s\xa0]*Timoteo)|Ти(?:­мофія|м(?:о(?:те(?:[ий]|ју?)|фію))?)|T(?:ymoteusza|himot(?:hy|y)|omothy|i(?:-?mô-?thê|m(?:ót(?:heosz|e(?:us(?:hoz|nak)?|o))|ôthê|ot(?:ius|e(?:j(?:u[\s\xa0]*Poslanica|ovi)|yos|u(?:kselle|s(?:kirje|hoz|nak)?)|üs|i|o(?:vi)?)?|h(?:e(?:u[ms]|üs|e|o(?:sz)?)|ée|y)?|y))?)|ím|m))|[\s\xa0]*(?:List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza))|do[\s\xa0]*Tymoteusza)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*Тимотеј|ослан(?:ица[\s\xa0]*Тимотеју|ня[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)))|list[\s\xa0]*Tim[eo]teovi|K(?:irje[\s\xa0]*Timoteukselle|ay[\s\xa0]*Timoteo)|Ти(?:­мофія|м(?:о(?:те(?:[ий]|ју?)|фію))?)|T(?:ymoteusza|himot(?:hy|y)|omothy|i(?:-?mô-?thê|m(?:ót(?:heosz|e(?:us(?:hoz|nak)?|o))|ôthê|ot(?:ius|e(?:j(?:u[\s\xa0]*Poslanica|ovi)|yos|u(?:kselle|s(?:kirje|hoz|nak)?)|üs|i|o(?:vi)?)?|h(?:e(?:u[ms]|üs|e|o(?:sz)?)|ée|y)?|y))?)|ím|m))))|Zweite[\s\xa0]*Timotheus|Epistula[\s\xa0]*(?:II[\s\xa0]*ad[\s\xa0]*Timotheum|ad[\s\xa0]*Timotheum[\s\xa0]*II)|2(?:(?:[ея](?:\.[\s\xa0]*(?:к[\s\xa0]*Тимофею|Тим(?:етею|офею))|[\s\xa0]*(?:к[\s\xa0]*Тимофею|Тим(?:етею|офею))))|\.(?:-?تِیمُتھِیُس|(?:[oº](?:\.[\s\xa0]*Timoteo|[\s\xa0]*Timoteo))|۔تیمتھیس|[\s\xa0]*(?:к[\s\xa0]*Тимофею|ତୀମଥିଙ୍କ|ت(?:ِیمُتھِیُس|ی(?:ِمُتھِیُس|مِتھُیس))|Ти(?:­мофія|м(?:етею|о(?:те(?:[ий]|ју?)|ф[еі]ю))?)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*Тимотеј|ослан(?:ица[\s\xa0]*Тимотеју|ня[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)))|timotʰ[iī]l(?:[aā][iī])|K(?:irje[\s\xa0]*Timoteukselle|a(?:ng[\s\xa0]*Timoteo|y[\s\xa0]*Timoteo))|ทิโมธี|त(?:िम(?:ुथियुस|ोथी(?:लाई)?)|ीम(?:ु(?:ाथैयुस|थियुस))?)|list[\s\xa0]*Tim[eo]teovi|T(?:eemuathaiyus|ymoteusza|himot(?:hy|y)|omothy|i(?:-?mô-?thê|m(?:ót(?:heosz|e(?:us(?:hoz|nak)?|o))|ôthê|ot(?:ius|e(?:j(?:u[\s\xa0]*Poslanica|ovi)|yos|u(?:kselle|s(?:kirje|brev(?:et)?|hoz|nak)?|t)|üs|i|o(?:vi)?)?|h(?:e(?:u(?:m|s(?:brev)?)|üs|e|o(?:s(?:brevet|z))?)|ée|y)?|y))?)|ím|m)|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza))|do[\s\xa0]*Tymoteusza)))|۔تیمتھیس|Tim|e(?:me(?:\.[\s\xa0]*Timoth[eé]e|[\s\xa0]*Timoth[eé]e)|\.[\s\xa0]*Tim(?:ot(?:e[uü]s|h(?:e(?:[uü]s|e)|ée)))?|[\s\xa0]*Tim(?:ot(?:e[uü]s|h(?:e(?:[uü]s|e)|ée)))?)|nd(?:\.[\s\xa0]*T(?:himot(?:hy|y)|omothy|i(?:m(?:ot(?:hy?|y))?)?|m)|[\s\xa0]*T(?:himot(?:hy|y)|omothy|i(?:m(?:ot(?:hy?|y))?)?|m))|[\s\xa0]*(?:к[\s\xa0]*Тимофею|ତୀମଥିଙ୍କ|ت(?:ِیمُتھِیُس|ی(?:ِمُتھِیُس|مِتھُیس))|ท(?:ิโมธี|ธ)|(?:[ie](?:\.[\s\xa0]*Timoteut|[\s\xa0]*Timoteut))|ਤਿਮੋਥਿਉਸ[\s\xa0]*ਨੂੰ|k(?:\.[\s\xa0]*Timote(?:jovi|ovi)|[\s\xa0]*Timote(?:jovi|ovi))|Ти(?:­мофія|м(?:етею|о(?:те(?:[ий]|ју?)|ф[еі]ю))?)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*Тимотеј|ослан(?:ица[\s\xa0]*Тимотеју|ня[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)))|t(?:īmatʰtʰ[aā]l[aā]|im(?:atʰtʰ[aā]l[aā]|otʰ(?:īl[aā][iī]|i(?:l[aā][iī]|us))))|K(?:irje[\s\xa0]*Timoteukselle|a(?:ng[\s\xa0]*Timoteo|y[\s\xa0]*Timoteo))|त(?:िम(?:ुथियुस|ोथी(?:लाई)?)|ीम(?:थ्थाला|ु(?:ाथैयुस|थियुस))?)|طيم|list[\s\xa0]*Tim[eo]teovi|T(?:īm[oō]tt(?:[eē]yuvukku)|eemuathaiyus|himot(?:hy|y)|omothy|i(?:-?mô-?thê|m(?:ōtt[eē]yuvukku|ót(?:heosz|e(?:us(?:hoz|nak)?|o))|ôthê|ot(?:t[eē]yuvukku|ius|e(?:j(?:u[\s\xa0]*Poslanica|ovi)|yos|u(?:kselle|s(?:kirje|brev(?:et)?|hoz|nak)?|t)|üs|i|o(?:vi)?)?|h(?:e(?:u(?:m|s(?:brev)?)|üs|e|o(?:s(?:brevet|z))?)|ée|y)?|y))?)|ym(?:oteusza)?|ím|m)|த(?:ீமோத்(?:தேயு)?|ிமொ(?:த்தேயு)?)|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza))|do[\s\xa0]*Tymoteusza))|[oa](?:\.[\s\xa0]*Tim(?:[oó]teo|[\s\xa0]*Tim[oó]teo))|(?:[º°](?:\.[\s\xa0]*Timoteo|[\s\xa0]*Timoteo))|-?(?:تِیمُتھِیُس|ге(?:\.[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)|Ти(?:­мофія|мо(?:те[ий]|фію)))|[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)|Ти(?:­мофія|мо(?:те[ий]|фію))))|а(?:\.[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)|Ти(?:­мофія|мо(?:те[ий]|фію)))|[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)|Ти(?:­мофія|мо(?:те[ий]|фію))))|е(?:\.[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)|к[\s\xa0]*Тимофею|Ти(?:­мофія|м(?:етею|о(?:те[ий]|ф[еі]ю))))|[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)|к[\s\xa0]*Тимофею|Ти(?:­мофія|м(?:етею|о(?:те[ий]|ф[еі]ю)))))|я(?:\.[\s\xa0]*(?:к[\s\xa0]*Тимофею|Тим(?:етею|офею))|[\s\xa0]*(?:к[\s\xa0]*Тимофею|Тим(?:етею|офею))))|d(?:\.[\s\xa0]*Timoth[eé]e|e(?:\.[\s\xa0]*Timoth[eé]e|[\s\xa0]*Timoth[eé]e)|[\s\xa0]*Timoth[eé]e)|ème(?:\.[\s\xa0]*Timoth[eé]e|[\s\xa0]*Timoth[eé]e)|티모)|S(?:(?:[ií]ðara[\s\xa0]*(?:br(?:[eé]f[\s\xa0]*P(?:[aá]ls[\s\xa0]*til[\s\xa0]*T(?:[ií]m(?:[oó](?:teusar)?))))|T[ií]m(?:[oó]teusarbr(?:[eé]f))))|e(?:gund[ao][\s\xa0]*Tim(?:[oó]teo)|cond(?:a[\s\xa0]*(?:lettera[\s\xa0]*a[\s\xa0]*Timoteo|Timoteo)|o[\s\xa0]*Timoteo|[\s\xa0]*T(?:himot(?:hy|y)|omothy|i(?:m(?:ot(?:hy?|y))?)?|m))))|ତୀମଥିଙ୍କ[\s\xa0]*ପ୍ରତି[\s\xa0]*ଦ୍ୱିତୀୟ[\s\xa0]*ପତ୍ର|ה(?:איגרת[\s\xa0]*השנייה[\s\xa0]*אל[\s\xa0]*טימותיוס|שנייה[\s\xa0]*אל[\s\xa0]*טימותיאוס)|Друг(?:а[\s\xa0]*(?:послан(?:ица[\s\xa0]*Тимотеју|ня[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію))|Ти(?:­мофія|мо(?:те(?:ју|[ий])|фію)))|е[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)|Ти(?:­мофія|мо(?:те[ий]|фію))))|Barua[\s\xa0]*ya[\s\xa0]*Pili[\s\xa0]*kwa[\s\xa0]*Timotheo|T(?:īm[oō]tt(?:[eē]yuvukku[\s\xa0]*E(?:[lḻ]utiya[\s\xa0]*Ira(?:[nṇ](?:[tṭ](?:[aā]vatu[\s\xa0]*Nirupam)))))|oinen[\s\xa0]*(?:Kirje[\s\xa0]*Timoteukselle|Timoteu(?:kselle|skirje))|im(?:ōtt[eē]yuvukku[\s\xa0]*E(?:[lḻ]utiya[\s\xa0]*Ira(?:[nṇ](?:[tṭ](?:[aā]vatu[\s\xa0]*Nirupam))))|ot(?:t[eē]yuvukku[\s\xa0]*E(?:[lḻ]utiya[\s\xa0]*Ira(?:[nṇ](?:[tṭ](?:[aā]vatu[\s\xa0]*Nirupam))))|eyos[\s\xa0]*Labaad|heo[\s\xa0]*II))|weede[\s\xa0]*Tim(?:ot(?:he[uü]s|e[uü]s))?)|Waraka[\s\xa0]*wa[\s\xa0]*Pili[\s\xa0]*kwa[\s\xa0]*Timotheo|Втор(?:о[\s\xa0]*(?:п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*Тимотеј|ослание[\s\xa0]*(?:на[\s\xa0]*св(?:\.[\s\xa0]*ап(?:\.[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимотея|[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимотея)|[\s\xa0]*ап(?:\.[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимотея|[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимотея))|към[\s\xa0]*Тимоте[ий]))|Тимотеј)|а[\s\xa0]*(?:писмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*Тимотеј|Тим(?:оте[ийј])?))|디모데[2후]서|Προς[\s\xa0]*Τιμ[οό]θεον[\s\xa0]*Β['ʹʹ΄’]|And(?:e(?:t[\s\xa0]*Timotheusbrev|n[\s\xa0]*Tim(?:ot(?:heusbrev|eus))?)|r(?:a[\s\xa0]*Timot(?:heosbrevet|eusbrevet)|e[\s\xa0]*Tim(?:oteus(?:brev)?)?))|Β(?:['ʹʹ΄’][\s\xa0]*Τι(?:μ(?:[οό]θεο)?)?)|ଦ୍ୱିତୀୟ[\s\xa0]*ତୀମଥିଙ୍କ|티모테오(?:에게[\s\xa0]*보낸[\s\xa0]*둘째[\s\xa0]*서간|2서))|(?:Deuxi[eè]me[\s\xa0]*Timoth(?:[eé]e)|2[ao][\s\xa0]*Tim(?:[oó]teo))|(?:提(?:摩(?:太(?:後書》?|后书》?)|斐後》?)|[後后]》?)|《(?:弟茂德後書|提(?:摩(?:太(?:后书|後書)|斐後)|[后後]))|השנייה[\s\xa0]*אל[\s\xa0]*טימותיוס|2(?:\.[\s\xa0]*Ti(?:moteju)?|[\s\xa0]*Ti(?:moteju)?)|II(?:\.[\s\xa0]*Ti(?:moteju)?|[\s\xa0]*Ti(?:moteju)?)|ad[\s\xa0]*Timotheum[\s\xa0]*II|弟茂德後書》?|Timotheum[\s\xa0]*II|तीमथ्थाला[\s\xa0]*दुसरे[\s\xa0]*पत्र|Druga[\s\xa0]*(?:poslanica[\s\xa0]*Timoteju|Timoteju)))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["1Tim"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])((?:رسالة[\s\xa0]*بولس[\s\xa0]*الرسول[\s\xa0]*الأولى[\s\xa0]*إلى[\s\xa0]*تيموثاوس|I(?:\.[\s\xa0]*(?:List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza))|do[\s\xa0]*Tymoteusza)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*Тимотеј|ослан(?:ица[\s\xa0]*Тимотеју|ня[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)))|list[\s\xa0]*Tim[eo]teovi|K(?:irje[\s\xa0]*Timoteukselle|ay[\s\xa0]*Timoteo)|Ти(?:­мофія|м(?:о(?:те(?:[ий]|ју?)|фію))?)|T(?:himot(?:hy|y)|omothy|i(?:-?mô-?thê|m(?:ót(?:heosz|e(?:us(?:hoz|nak)?|o))|ôthê|ot(?:ius|e(?:j(?:u[\s\xa0]*Poslanica|ovi)|yos|u(?:kselle|s(?:kirje|hoz|nak)?)|üs|i|o(?:vi)?)?|h(?:e(?:u[ms]|üs|e|o(?:sz)?)|ée|y)?|y))?)|ym(?:oteusza)?|ím|m))|[\s\xa0]*(?:List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza))|do[\s\xa0]*Tymoteusza)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*Тимотеј|ослан(?:ица[\s\xa0]*Тимотеју|ня[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)))|list[\s\xa0]*Tim[eo]teovi|K(?:irje[\s\xa0]*Timoteukselle|ay[\s\xa0]*Timoteo)|Ти(?:­мофія|м(?:о(?:те(?:[ий]|ју?)|фію))?)|T(?:himot(?:hy|y)|omothy|i(?:-?mô-?thê|m(?:ót(?:heosz|e(?:us(?:hoz|nak)?|o))|ôthê|ot(?:ius|e(?:j(?:u[\s\xa0]*Poslanica|ovi)|yos|u(?:kselle|s(?:kirje|hoz|nak)?)|üs|i|o(?:vi)?)?|h(?:e(?:u[ms]|üs|e|o(?:sz)?)|ée|y)?|y))?)|ym(?:oteusza)?|ím|m)))|《(?:弟茂德前書》|提(?:摩(?:太前[书書]》|斐前》)|前》))|Kwanza[\s\xa0]*Tim(?:otheo)?|E(?:nsimm(?:[aä]inen[\s\xa0]*(?:Kirje[\s\xa0]*Timoteukselle|Timoteu(?:kselle|skirje)))|pistula[\s\xa0]*(?:I[\s\xa0]*ad[\s\xa0]*Timotheum|ad[\s\xa0]*Timotheum[\s\xa0]*I)|rste[\s\xa0]*Timotheus|erste[\s\xa0]*Tim(?:ot(?:he[uü]s|e[uü]s))?|ls(?:[oő][\s\xa0]*Tim(?:[oó]t(?:heosz|eus(?:hoz|nak)?))?))|ପ୍ରଥମ[\s\xa0]*ତୀମଥିଙ୍କ|T(?:īm[oō]tt(?:[eē]yuvukku[\s\xa0]*E(?:[lḻ]utiya[\s\xa0]*Mutal(?:[aā]vatu[\s\xa0]*Nirupam)))|im(?:ōtt[eē]yuvukku[\s\xa0]*E(?:[lḻ]utiya[\s\xa0]*Mutal(?:[aā]vatu[\s\xa0]*Nirupam))|ot(?:t[eē]yuvukku[\s\xa0]*E(?:[lḻ]utiya[\s\xa0]*Mutal(?:[aā]vatu[\s\xa0]*Nirupam))|eyos[\s\xa0]*Kowaad|heo[\s\xa0]*I)))|F(?:(?:[oö]rsta[\s\xa0]*Timot(?:heosbrevet|eusbrevet))|yrra[\s\xa0]*(?:br(?:[eé]f[\s\xa0]*P(?:[aá]ls[\s\xa0]*til[\s\xa0]*T(?:[ií]m(?:[oó]t(?:eusar)?))))|T[ií]m(?:[oó]teusarbr(?:[eé]f)))|ørste[\s\xa0]*Tim(?:ot(?:heusbrev|eus(?:brev)?))?|irst[\s\xa0]*T(?:himot(?:hy|y)|omothy|i(?:m(?:ot(?:hy?|y))?)?|m))|ਤਿਮੋਥਿਉਸ[\s\xa0]*ਨੂੰ[\s\xa0]*ਪਹਿਲੀ[\s\xa0]*ਪੱਤ੍ਰੀ|一テモテ|Una(?:ng[\s\xa0]*(?:Kay[\s\xa0]*Timoteo|Timoteo)|[\s\xa0]*(?:Kay[\s\xa0]*Timoteo|Timoteo))|ﺍﻻﻭﻝ[\s\xa0]*ﺗﻴﻤﻮﺛﺎﻭﺱ|ତୀମଥିଙ୍କ[\s\xa0]*ପ୍ରତି[\s\xa0]*ପ୍ରଥମ[\s\xa0]*ପତ୍ର|Barua[\s\xa0]*ya[\s\xa0]*Kwanza[\s\xa0]*kwa[\s\xa0]*Timotheo|1(?:(?:[ея](?:\.[\s\xa0]*(?:к[\s\xa0]*Тимофею|Тим(?:етею|офею))|[\s\xa0]*(?:к[\s\xa0]*Тимофею|Тим(?:етею|офею))))|e(?:r(?:\.[\s\xa0]*Timoth[eé]e|e(?:\.[\s\xa0]*Timoth[eé]e|[\s\xa0]*Timoth[eé]e)|[\s\xa0]*Timoth[eé]e)|\.[\s\xa0]*Tim(?:ot(?:he[uü]s|e[uü]s))?|[\s\xa0]*Tim(?:ot(?:he[uü]s|e[uü]s))?)|[\s\xa0]*(?:к[\s\xa0]*Тимофею|ତୀମଥିଙ୍କ|ท(?:ิโมธี|ธ)|(?:[ie](?:\.[\s\xa0]*Timoteut|[\s\xa0]*Timoteut))|ਤਿਮੋਥਿਉਸ[\s\xa0]*ਨੂੰ|k(?:\.[\s\xa0]*Timote(?:jovi|ovi)|[\s\xa0]*Timote(?:jovi|ovi))|Ти(?:­мофія|м(?:етею|о(?:те(?:[ий]|ју?)|ф[еі]ю))?)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*Тимотеј|ослан(?:ица[\s\xa0]*Тимотеју|ня[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)))|t(?:īmatʰtʰ[aā]l[aā]|im(?:atʰtʰ[aā]l[aā]|otʰ(?:īl[aā][iī]|i(?:l[aā][iī]|us))))|त(?:िम(?:ुथियुस|ोथी(?:लाई)?)|ीम(?:थ्[थय]ाला|ु(?:ाथैयुस|थियुस))?)|K(?:irje[\s\xa0]*Timoteukselle|a(?:ng[\s\xa0]*Timoteo|y[\s\xa0]*Timoteo))|طيم|list[\s\xa0]*Tim[eo]teovi|T(?:īm[oō]tt(?:[eē]yuvukku)|eemuathaiyus|himot(?:hy|y)|omothy|i(?:-?mô-?thê|m(?:ōtt[eē]yuvukku|ót(?:heosz|e(?:us(?:hoz|nak)?|o))|ôthê|ot(?:t[eē]yuvukku|ius|e(?:j(?:u[\s\xa0]*Poslanica|ovi)|yos|u(?:kselle|s(?:kirje|brev(?:et)?|hoz|nak)?|t)|üs|i|o(?:vi)?)?|h(?:e(?:u(?:m|s(?:brev)?)|üs|e|o(?:s(?:brevet|z))?)|ée|y)?|y))?)|ym(?:oteusza)?|ím|m)|ت(?:ِیمُتھِیُس|یمِتھُیس)|த(?:ீமோத்(?:தேயு)?|ிமொ(?:த்தேயு)?)|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza))|do[\s\xa0]*Tymoteusza))|۔تیمتھیس|Tim|ère(?:\.[\s\xa0]*Timoth[eé]e|[\s\xa0]*Timoth[eé]e)|re(?:\.[\s\xa0]*Timoth[eé]e|[\s\xa0]*Timoth[eé]e)|[oa](?:\.[\s\xa0]*Tim(?:[oó]teo|[\s\xa0]*Tim[oó]teo))|(?:[º°](?:\.[\s\xa0]*Timoteo|[\s\xa0]*Timoteo))|\.(?:-?تِیمُتھِیُس|(?:[oº](?:\.[\s\xa0]*Timoteo|[\s\xa0]*Timoteo))|۔تیمتھیس|[\s\xa0]*(?:к[\s\xa0]*Тимофею|ତୀମଥିଙ୍କ|Ти(?:­мофія|м(?:етею|о(?:те(?:[ий]|ју?)|ф[еі]ю))?)|п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*Тимотеј|ослан(?:ица[\s\xa0]*Тимотеју|ня[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)))|timotʰ[iī]l(?:[aā][iī])|K(?:irje[\s\xa0]*Timoteukselle|a(?:ng[\s\xa0]*Timoteo|y[\s\xa0]*Timoteo))|ทิโมธี|त(?:िम(?:ुथियुस|ोथी(?:लाई)?)|ीम(?:ु(?:ाथैयुस|थियुस))?)|list[\s\xa0]*Tim[eo]teovi|ت(?:ِیمُتھِیُس|یمِتھُیس)|List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza))|do[\s\xa0]*Tymoteusza)|T(?:eemuathaiyus|himot(?:hy|y)|omothy|i(?:-?mô-?thê|m(?:ót(?:heosz|e(?:us(?:hoz|nak)?|o))|ôthê|ot(?:ius|e(?:j(?:u[\s\xa0]*Poslanica|ovi)|yos|u(?:kselle|s(?:kirje|brev(?:et)?|hoz|nak)?|t)|üs|i|o(?:vi)?)?|h(?:e(?:u(?:m|s(?:brev)?)|üs|e|o(?:s(?:brevet|z))?)|ée|y)?|y))?)|ym(?:oteusza)?|ím|m)))|티모|st(?:\.[\s\xa0]*T(?:himot(?:hy|y)|omothy|i(?:m(?:ot(?:hy?|y))?)?|m)|[\s\xa0]*T(?:himot(?:hy|y)|omothy|i(?:m(?:ot(?:hy?|y))?)?|m))|-?(?:تِیمُتھِیُس|ше(?:\.[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)|Ти(?:­мофія|мо(?:те[ий]|фію)))|[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)|Ти(?:­мофія|мо(?:те[ий]|фію))))|а(?:\.[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)|Ти(?:­мофія|мо(?:те[ий]|фію)))|[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)|Ти(?:­мофія|мо(?:те[ий]|фію))))|е(?:\.[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)|к[\s\xa0]*Тимофею|Ти(?:­мофія|м(?:етею|о(?:те[ий]|ф[еі]ю))))|[\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)|к[\s\xa0]*Тимофею|Ти(?:­мофія|м(?:етею|о(?:те[ий]|ф[еі]ю)))))|я(?:\.[\s\xa0]*(?:к[\s\xa0]*Тимофею|Тим(?:етею|офею))|[\s\xa0]*(?:к[\s\xa0]*Тимофею|Тим(?:етею|офею)))))|ت(?:ِیمُتھِیُس[\s\xa0]*کے[\s\xa0]*نام[\s\xa0]*(?:پولُس[\s\xa0]*رسول[\s\xa0]*کا[\s\xa0]*پہلا[\s\xa0]*خط|کا[\s\xa0]*پہلا[\s\xa0]*خط)|یمتھیس[\s\xa0]*کے[\s\xa0]*نام[\s\xa0]*کا[\s\xa0]*پہلا[\s\xa0]*خط|يموثاوس[\s\xa0]*الأولى)|ה(?:איגרת[\s\xa0]*הראשונה[\s\xa0]*אל[\s\xa0]*טימותיוס|ראשונה[\s\xa0]*אל[\s\xa0]*טימותיאוס)|П(?:ерш(?:[ае][\s\xa0]*(?:послання[\s\xa0]*(?:св(?:\.[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія|[\s\xa0]*апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Ти­мофія)|апостола[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимофія|до[\s\xa0]*Тимо(?:тея|фія)|Тимофію)|Ти(?:­мофія|мо(?:те[ий]|фію))))|рв(?:а[\s\xa0]*(?:п(?:исмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*Тимотеј|осланица[\s\xa0]*Тимотеју)|Тимотеју?)|о[\s\xa0]*(?:писмо[\s\xa0]*од[\s\xa0]*апостол[\s\xa0]*Павле[\s\xa0]*до[\s\xa0]*Тимотеј|Тимотеј))|ърв(?:о[\s\xa0]*послание[\s\xa0]*(?:на[\s\xa0]*св(?:\.[\s\xa0]*ап(?:\.[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимотея|[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимотея)|[\s\xa0]*ап(?:\.[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимотея|[\s\xa0]*Павла[\s\xa0]*до[\s\xa0]*Тимотея))|към[\s\xa0]*Тимоте[ий])|а[\s\xa0]*Тим(?:оте[ий])?))|디모데1서|テモテ(?:ヘの第一の手紙|への(?:前の書|手紙一)|[\s\xa0]*1|前書)|ا(?:لرسالة[\s\xa0]*الأولى[\s\xa0]*إلى[\s\xa0]*تيموثاوس|وّل(?:-?تِیمُتھِیُس|[\s\xa0]*ت(?:ِیمُتھِیُس|یمِتھُیس)|۔تیمتھیس))|P(?:er[sš]e[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*Tymofija|a(?:vlova[\s\xa0]*prva[\s\xa0]*poslanica[\s\xa0]*Timoteju|ulus(?:'[\s\xa0]*(?:Første[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Timotheus|1(?:\.[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Timotheus|[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Timotheus))|’[\s\xa0]*(?:Første[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Timotheus|første[\s\xa0]*brev[\s\xa0]*til[\s\xa0]*Timoteus|1(?:\.[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Timotheus|[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Timotheus))))|ierwsz(?:[aey][\s\xa0]*(?:List[\s\xa0]*(?:(?:[sś]w(?:\.[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza|[\s\xa0]*Pawła[\s\xa0]*do[\s\xa0]*Tymoteusza))|do[\s\xa0]*Tymoteusza)|Tym(?:oteusza)?))|r(?:em(?:i(?:ère(?:s[\s\xa0]*Timoth[eé]e|[\s\xa0]*Timoth[eé]e)|er(?:e(?:s[\s\xa0]*Timoth[eé]e|[\s\xa0]*Timoth[eé]e)|s[\s\xa0]*Timoth[eé]e|[\s\xa0]*Timoth[eé]e))|ye[\s\xa0]*Timote)|im(?:e(?:ir[ao][\s\xa0]*Tim(?:[oó]teo)|r(?:o[\s\xa0]*Timoteo|[\s\xa0]*Timoteo))|a[\s\xa0]*(?:lettera[\s\xa0]*a[\s\xa0]*Timoteo|Timoteo)|o[\s\xa0]*Timoteo)|v(?:a[\s\xa0]*(?:kniha[\s\xa0]*Timote(?:jovi|ovi)|Timote(?:j(?:u[\s\xa0]*Poslanica|ovi)|ovi))|(?:[yý][\s\xa0]*(?:list[\s\xa0]*Timote(?:jovi|ovi)|Timote(?:jovi|ovi)))|á[\s\xa0]*(?:kniha[\s\xa0]*Timote(?:jovi|ovi)|Timote(?:jovi|ovi))|n[ií][\s\xa0]*(?:list[\s\xa0]*Tim(?:[eo]teovi|T(?:im(?:ote(?:ovi|us))?|m))))))|אגרת[\s\xa0]*פולוס[\s\xa0]*הראשונה[\s\xa0]*אל-?טימות|Waraka[\s\xa0]*wa[\s\xa0]*Kwanza[\s\xa0]*kwa[\s\xa0]*Timotheo|த(?:ிம[ொோ]த்தேயுவுக்கு[\s\xa0]*எழுதிய[\s\xa0]*முதல்[\s\xa0]*திருமுகம்|ீமோத்தேயுவுக்கு[\s\xa0]*எழுதிய[\s\xa0]*முதலா(?:வது[\s\xa0]*நிருபம்|ம்[\s\xa0]*கடிதம்))|Προς[\s\xa0]*Τιμ[οό]θεον[\s\xa0]*Α['ʹʹ΄’]|पौलाचे[\s\xa0]*तीमथ्याला[\s\xa0]*पहिले[\s\xa0]*पत्र|۱(?:-?تِیمُتھِیُس|[\s\xa0]*ت(?:ِیمُتھِیُس|یمِتھُیس)|۔تیمتھیس)|티모테오(?:에게[\s\xa0]*보낸[\s\xa0]*첫째[\s\xa0]*서간|1서)|त(?:िमोथीलाई(?:र्[\s\xa0]*पावलको[\s\xa0]*पहिलो[\s\xa0]*पत्र|[\s\xa0]*पहिलो[\s\xa0]*पत्र)|ीमथ्थाला[\s\xa0]*पहिले[\s\xa0]*पत्र)|Α(?:['ʹʹ΄’][\s\xa0]*Τι(?:μ(?:[οό]θεο)?)?)|t(?:īm(?:utʰiyus[\s\xa0]*ke[\s\xa0]*nām[\s\xa0]*kā[\s\xa0]*pahlā[\s\xa0]*ḫaṭ|atʰtʰ[aā]l(?:[aā][\s\xa0]*pahile[\s\xa0]*patra))|im(?:atʰtʰ[aā]l(?:[aā][\s\xa0]*pahile[\s\xa0]*patra)|otʰ(?:i(?:us[\s\xa0]*nū̃[\s\xa0]*pahilī[\s\xa0]*pattrī|l[aā](?:[iī][\s\xa0]*pahilo[\s\xa0]*patra))|īl[aā](?:[iī][\s\xa0]*pahilo[\s\xa0]*patra)))))|(?:1[ao][\s\xa0]*Tim(?:[oó]teo)|Prvn(?:[ií][\s\xa0]*T(?:im(?:ote(?:ovi|us))?|m)))|(?:《(?:弟茂德前書|提(?:摩(?:太前[书書]|斐前)|前))|ad[\s\xa0]*Timotheum[\s\xa0]*I|הראשונה[\s\xa0]*אל[\s\xa0]*טימותיוס|Timoth(?:eum[\s\xa0]*I|y)?|Prva[\s\xa0]*(?:poslanica[\s\xa0]*Timoteju|Timoteju)|提(?:摩(?:太前[書书]》?|斐前》?)|前》?)|(?:[1I](?:\.[\s\xa0]*Ti(?:moteju)?|[\s\xa0]*Ti(?:moteju)?))|弟茂德前書》?))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["Deut"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])((?:M(?:[aá]sodik[\s\xa0]*t(?:[oö]rv(?:[eé]nyk(?:[oö]nyv)))|[oó]zes[\s\xa0]*(?:(?:[oö]t(?:[oö]dik[\s\xa0]*k(?:[oö]nyve))|V))|T[oö]rv)|இ(?:ணைச்[\s\xa0]*சட்டம்|ச)|K(?:itabu[\s\xa0]*cha[\s\xa0]*Tano[\s\xa0]*cha[\s\xa0]*Musa|s(?:i[eę]g(?:[ai][\s\xa0]*Powt(?:(?:[oó]rzonego[\s\xa0]*Prawa|[\s\xa0]*Prawa)))|\.[\s\xa0]*Powt(?:[oó]rzonego[\s\xa0]*Prawa|[\s\xa0]*Prawa)|[\s\xa0]*Powt(?:[oó]rzonego[\s\xa0]*Prawa|[\s\xa0]*Prawa))|um(?:b(?:ukumbu[\s\xa0]*la[\s\xa0]*(?:Sheria|Torati))?)?)|ฉธบ|Li(?:ber[\s\xa0]*Deuteronomii|gji[\s\xa0]*i[\s\xa0]*P[eë]rt(?:[eë]rir[eë])|P)|ବିବରଣି|Up[aā]kamam|سفر[\s\xa0]*التثنية|신(?:명기?)?|ଦ୍ୱିତୀୟ[\s\xa0]*ବିବରଣୀ?|anuw[aā]d|5(?:\.[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Buch[\s\xa0]*Mose|Мојс(?:ијева)?|M(?:ós(?:eb[oó]k)?|o(?:oseksen[\s\xa0]*kirja|zes|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)|s(?:e(?:b(?:o(?:g|k(?:en)?)|ók))?)?)?))|Mós|[\s\xa0]*(?:Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|k(?:niha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|\.[\s\xa0]*Moj[zž]i(?:[sš]ova)|[\s\xa0]*Moj[zž]i(?:[sš]ova))|Buch[\s\xa0]*Mose|M(?:ó(?:s(?:eb[oó]k)?|z(?:es)?)|o(?:os(?:eksen[\s\xa0]*kirja)?|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)?|s(?:e(?:b(?:o(?:g|k(?:en)?)|ók))?)?|z(?:es)?)?|z)?|М(?:о(?:исеева|јс(?:ијева)?))?))|דברים|व्य(?:्वस्थाविवरन|वस्था(?:को[\s\xa0]*पुस्तक|[\s\xa0]*विवरण|विवरण)|ावस्था)|П(?:['’]ята[\s\xa0]*книга[\s\xa0]*Мо(?:[ий]сеева)|ет(?:та[\s\xa0]*книга[\s\xa0]*Мојсеева|а[\s\xa0]*(?:книга[\s\xa0]*Моисеева|Мојс(?:ијева)?))|о(?:вт(?:орен(?:ня[\s\xa0]*Закону|и[\s\xa0]*закони)|\.[\s\xa0]*Закону|[\s\xa0]*Закону)|н(?:овљени[\s\xa0]*закони|з)))|משנה[\s\xa0]*תורה|เฉลย(?:​ธรรม​บัญญัติ|ธรรมบัญญัติ)|Δε(?:υτ(?:ερ(?:ον[οό]μιον?)?)?)?|ا(?:ِستِثنا|ستثناء?)|V(?:yavasthaavivaran|i(?:ides[\s\xa0]*Mooseksen[\s\xa0]*kirja|jfde[\s\xa0]*Mozes)|\.[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Мојс(?:ијева)?|M(?:o(?:oseksen[\s\xa0]*kirja|zes|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)|s(?:eb[oó]k)?)|ós(?:eb[oó]k)?))|[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž](?:[ií](?:[sš]ova))|Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Мојс(?:ијева)?|M(?:o(?:oseksen[\s\xa0]*kirja|zes|j(?:ž[ií](?:[sš]ova)|z(?:eszowa|[ií](?:[sš]ova))?|ż(?:eszowa)?)?|s(?:eb[oó]k)?)|ós(?:eb[oó]k)?)))|ਬਿਵਸਥਾ[\s\xa0]*ਸਾਰ|F(?:immta[\s\xa0]*(?:b[oó]k[\s\xa0]*M(?:[oó]se)|M[oó]seb(?:[oó]k))|(?:[uü]nfte[\s\xa0]*(?:Buch[\s\xa0]*Mose|Mose))|emte[\s\xa0]*Mos(?:ebo(?:g|k(?:en)?))?)|ت(?:َثنِيَة|ث(?:نية[\s\xa0]*الإشتراع)?)|Вт(?:ор(?:озак(?:он(?:ие|ня))?)?)?|P(?:hục[\s\xa0]*truyền[\s\xa0]*luật[\s\xa0]*lệ[\s\xa0]*ký|o(?:vtorennja[\s\xa0]*Zakonu|novljeni[\s\xa0]*zakon)|a(?:ngandharing[\s\xa0]*Toret|t[aá][\s\xa0]*(?:kniha[\s\xa0]*Moj(?:[zž](?:[ií](?:[sš]ova))|Moj[zž](?:[ií](?:[sš]ova)))))|át[aá][\s\xa0]*(?:kniha[\s\xa0]*Moj(?:[zž](?:[ií](?:[sš]ova))|Moj[zž](?:[ií](?:[sš]ova))))|i(?:ata[\s\xa0]*(?:kniha[\s\xa0]*Moj[zž]i(?:[sš]ova)|Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Moj(?:ži[sš]ova|z(?:eszowa|i[sš]ova)?|ż(?:eszowa)?))|ąta[\s\xa0]*(?:Ks(?:i[eę]g(?:[ai][\s\xa0]*Moj(?:[zż]eszowa))|\.[\s\xa0]*Moj[zż]eszowa|[\s\xa0]*Moj[zż]eszowa)|Moj(?:[zż](?:eszowa)?)))|nz|wt)|vyavastʰ[aā]ko[\s\xa0]*pustak|《申(?:命[紀記记]》|》)|Đệ[\s\xa0]*nhị[\s\xa0]*luật|Andharaning[\s\xa0]*Tor[eè]t|istis̱nā|bivastʰā[\s\xa0]*sār|अनुवाद|Sharci(?:ga[\s\xa0]*Kunoqoshadiisa)?|D(?:iyuteronomyo|yuteronomyo|u(?:ut(?:(?:[eo]ron(?:omy|my))|ron(?:omy|my))|et(?:eron(?:om(?:io|y)|my)|oron(?:omy|my)|ron(?:omy|my))?)|e(?:zy[eè]m[\s\xa0]*liv[\s\xa0]*Lalwa[\s\xa0]*a|yuteronomyo|et(?:(?:[eo]ron(?:omy|my))|ron(?:omy|my))|wariem|t(?:e[rw]on(?:[oò]m))?|u(?:t(?:éronome|eron(?:ómi(?:um|o)|ômio|m(?:io|y)|om(?:ul|[ae]|i(?:um|y[ao]|[ao])?|ya?)?)|oron(?:om(?:io|y)|m(?:io|y))|ron(?:om(?:io|y)|m(?:io|y)))?)?)?|tn?)|உபா(?:கமம்)?)|P[aá]t(?:[aá][\s\xa0]*Moj(?:[zž](?:[ií](?:[sš]ova))))|(?:V(?:iides[\s\xa0]*Mooseksen|\.[\s\xa0]*Mooseksen|[\s\xa0]*Mooseksen)|Повт|व्यवस्था(?:को)?|5(?:\.[\s\xa0]*Mooseksen|[\s\xa0]*Mooseksen)|申(?:命[紀記记]》?|》)?|《申(?:命[紀記记])?|Phục(?:[\s\xa0]*Truyền(?:[\s\xa0]*Luật[\s\xa0]*Lệ)?)?|vyavastʰ[āa]ko|ਬਿਵਸਥਾ|التثنية|Ligji[\s\xa0]*i[\s\xa0]*përtërirë|Kumbukumbu))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["Titus"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(tit(?:a(?:sl[aā](?:[iī][\\s\\xa0]*patra)|l[aā][\\s\\xa0]*patra)|āl[aā][\\s\\xa0]*patra)|(?:تي|L(?:ettera[\\s\\xa0]*a[\\s\\xa0]*Tito|ist[\\s\\xa0]*(?:(?:[sś]w(?:\\.[\\s\\xa0]*Pawła[\\s\\xa0]*do[\\s\\xa0]*Tytusa|[\\s\\xa0]*Pawła[\\s\\xa0]*do[\\s\\xa0]*Tytusa))|do[\\s\\xa0]*Tytusa|T[ií]tovi))|Προς[\\s\\xa0]*Τ[ίι]τον|디도서|B(?:r(?:éf[\\s\\xa0]*P[aá]ls[\\s\\xa0]*til[\\s\\xa0]*T(?:[ií]tusar)|e(?:f[\\s\\xa0]*P[aá]ls[\\s\\xa0]*til[\\s\\xa0]*T(?:[ií]tusar)|vet[\\s\\xa0]*til(?:l[\\s\\xa0]*Titus|[\\s\\xa0]*Titus)))|arua[\\s\\xa0]*kwa[\\s\\xa0]*Tito)|T(?:īttuvukku[\\s\\xa0]*E[lḻ]utiya[\\s\\xa0]*Nirupam|eetus|yt|í(?:ch|t(?:usarbr(?:[eé]f(?:ið)?))?)|i(?:it(?:os)?|t(?:tuvukku[\\s\\xa0]*E[lḻ]utiya[\\s\\xa0]*Nirupam|us(?:arbr(?:[eé]f(?:ið)?)|brevet|hoz|z(?:hoz)?)|[eô]|it?)?)?|t)|ท(?:ิตัส|ต)|ତୀତସଙ୍କ[\\s\\xa0]*ପ୍ରତି[\\s\\xa0]*ପତ୍ର|テ(?:ィトに達する書|トス(?:ヘの手紙|への(?:て[かが]み|手紙|書)|書)?)|Τ(?:[ίι]το?|τ)|Epistula[\\s\\xa0]*ad[\\s\\xa0]*Titum|الرسالة[\\s\\xa0]*إلى[\\s\\xa0]*تيطس|ﺗﻴﻄﺲ|तीत(?:ुस|स(?:लाई[\\s\\xa0]*प(?:ावलको[\\s\\xa0]*पत्र|त्र))?)|ਤੀਤੁਸ[\\s\\xa0]*ਨੂੰ[\\s\\xa0]*ਪੱਤ੍ਰੀ|पौलाचे[\\s\\xa0]*तीताला[\\s\\xa0]*पत्र|אגרת[\\s\\xa0]*פולוס[\\s\\xa0]*אל-?טיטוס|П(?:исмо[\\s\\xa0]*од[\\s\\xa0]*апостол[\\s\\xa0]*Павле[\\s\\xa0]*до[\\s\\xa0]*Тит|ослан(?:ня[\\s\\xa0]*(?:св(?:\\.[\\s\\xa0]*апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Тита|[\\s\\xa0]*апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Тита)|апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Тита)|[\\s\\xa0]*ня[\\s\\xa0]*до[\\s\\xa0]*Тита|и(?:е[\\s\\xa0]*(?:на[\\s\\xa0]*св(?:\\.[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Тита|[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Тита)|[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Тита|[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Тита))|к(?:ъм[\\s\\xa0]*Тит|[\\s\\xa0]*Титу))|ца[\\s\\xa0]*Титу)))|《(?:弟鐸書》|提(?:多[书書]》|特書》)|多》)|P(?:oslannja[\\s\\xa0]*apostola[\\s\\xa0]*Pavla[\\s\\xa0]*do[\\s\\xa0]*Tyta|a(?:ulus['’][\\s\\xa0]*Brev[\\s\\xa0]*til[\\s\\xa0]*Titus|vlova[\\s\\xa0]*poslanica[\\s\\xa0]*Titu))|Waraka[\\s\\xa0]*kwa[\\s\\xa0]*Tito|tīt(?:us[\\s\\xa0]*nū̃[\\s\\xa0]*pattrī|a(?:sl[aā](?:[iī][\\s\\xa0]*patra)|l[aā][\\s\\xa0]*patra)|āl[aā][\\s\\xa0]*patra)|K(?:irje[\\s\\xa0]*Titukselle|a(?:ng[\\s\\xa0]*Tito|y[\\s\\xa0]*Tito))|ṭiṭus[\\s\\xa0]*ke[\\s\\xa0]*nām[\\s\\xa0]*kā[\\s\\xa0]*ḫaṭ|티토(?:에게[\\s\\xa0]*보낸[\\s\\xa0]*서간|서)?|தீத்(?:து(?:க்கு[\\s\\xa0]*எழுதிய[\\s\\xa0]*திருமுகம்|வுக்கு[\\s\\xa0]*எழுதிய[\\s\\xa0]*(?:திருமுகம்|நிருபம்|கடிதம்))?)?|האיגרת[\\s\\xa0]*אל[\\s\\xa0]*טיטוס|ط(?:ِطُس[\\s\\xa0]*کے[\\s\\xa0]*نام[\\s\\xa0]*(?:پولس[\\s\\xa0]*رسُول[\\s\\xa0]*کا[\\s\\xa0]*خط|کا[\\s\\xa0]*خط)|طس[\\s\\xa0]*کے[\\s\\xa0]*نام[\\s\\xa0]*کا[\\s\\xa0]*خط|ي(?:طس)?)|رسالة[\\s\\xa0]*بولس[\\s\\xa0]*الرسول[\\s\\xa0]*إلى[\\s\\xa0]*تيطس)|(?:多》?|t(?:it(?:a(?:sl[aā][iī]|l[āa])|āl[āa])|īt(?:a(?:sl[aā][iī]|l[āa])|āl[āa]|us))|T(?:īttuvukku|ytusa|ítovi|it(?:tuvukku|u(?:kselle|[ms])?|o(?:vi)?))|Тит[ау]?|弟鐸書》?|तीत(?:सलाई|ाला(?:[\\s\\xa0]*पत्र)?)|ط(?:ِطُس|طس)|До[\\s\\xa0]*Тита|К[\\s\\xa0]*Титу|ad[\\s\\xa0]*Titum|אל[\\s\\xa0]*טיטוס|ତୀତସଙ୍କ|ਤੀਤੁਸ(?:[\\s\\xa0]*ਨੂੰ)?|P(?:aulus’[\\s\\xa0]*brev[\\s\\xa0]*til[\\s\\xa0]*Titus|oslanica[\\s\\xa0]*Titu)|提(?:多[书書]》?|特書》?)|《(?:弟鐸書|提(?:特書|多[書书])|多)))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Heb"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:E(?:pi(?:reyarukku[\\s\\xa0]*E[lḻ]utiya[\\s\\xa0]*Nirupam|stula[\\s\\xa0]*ad[\\s\\xa0]*Hebraeos)|vr(?:ei)?|b(?:re?)?)|히브(?:리(?:인들에게[\\s\\xa0]*보낸[\\s\\xa0]*서간|서))?|P(?:avlova[\\s\\xa0]*poslanica[\\s\\xa0]*Hebrejima|oslannja[\\s\\xa0]*do[\\s\\xa0]*jevre[iï]v)|ع(?:ِبرانیوں[\\s\\xa0]*کے[\\s\\xa0]*نام[\\s\\xa0]*کا[\\s\\xa0]*خط|ب(?:رانیوں[\\s\\xa0]*کے[\\s\\xa0]*نام[\\s\\xa0]*(?:پولس[\\s\\xa0]*رسول[\\s\\xa0]*کا[\\s\\xa0]*خط|کا[\\s\\xa0]*خط))?)|Εβρ?|Προς[\\s\\xa0]*Εβρα[ίι]ους|hibr[uū]har(?:[uū]ko[\\s\\xa0]*nimti[\\s\\xa0]*patra)|Mga[\\s\\xa0]*(?:Hebr(?:ohanon|eo)|Ebreo)|ʿibrāniyōṅ[\\s\\xa0]*ke[\\s\\xa0]*nām[\\s\\xa0]*kā[\\s\\xa0]*ḫaṭ|Do[\\s\\xa0]*Thái|H(?:ê-?bơ-?rơ|w(?:(?:[ew]brew(?:ws|s))|brew(?:ws|s))|br(?:ew(?:ws|s))?|e(?:(?:[ew]brew(?:ws|s))|pr(?:ealaiskirje)?|b(?:w(?:ers|res)|e(?:w[erw]s|[eo](?:(?:[eor]s|s))|r(?:[\\s\\xa0]*lev[eé]l|[eorw]s|s)|s)|o(?:[eor](?:(?:[eor]s|s))|s)|r(?:s|äer|r(?:[eorw]s|s)|e(?:njve|a(?:br[eé]fið|id)|e(?:rbrevet|[eë]n|s)|o(?:hanon|s)|rs|u[sx]|s|w(?:ws|s)?)|[éæ]erbrevet|o(?:[eor]s|s)|ae(?:er|r)|w(?:es|s))?)?)?|é(?:b(?:er[\\s\\xa0]*lev[eé]l|r(?:eux)?)?)?)|הא(?:יגרת[\\s\\xa0]*אל[\\s\\xa0]*העברים|גרת[\\s\\xa0]*אל-?העברים)|इब्र(?:ी[\\s\\xa0]*लोकांस[\\s\\xa0]*पत्र|ान(?:ि(?:यों)?|ी))|Євр(?:е[ії])?|ฮ(?:ีบรู|บ)|Ibraaaniyon|ヘ(?:[フブ](?:ライ(?:人への手紙|書)?|ル(?:人への(?:手紙|書)|書)))|П(?:ослан(?:[\\s\\xa0]*ня[\\s\\xa0]*до[\\s\\xa0]*Євре[ії]в|ня[\\s\\xa0]*до[\\s\\xa0]*євре[ії]в|и(?:ца[\\s\\xa0]*Јеврејима|е[\\s\\xa0]*(?:на[\\s\\xa0]*св(?:\\.[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Евреите|[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Евреите)|[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Евреите|[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Евреите))|к(?:ъм[\\s\\xa0]*евреите|[\\s\\xa0]*Евреям))))|исмо[\\s\\xa0]*до[\\s\\xa0]*Евреите)|ଏବ୍ରୀ|ਇਬਰਾਨੀਆਂ[\\s\\xa0]*ਨੂੰ[\\s\\xa0]*ਪੱਤ੍ਰੀ|Ž(?:id(?:om)?|d)|Ἑβ|Z(?:sid[oó]k(?:hoz[\\s\\xa0]*(?:[ií]rt[\\s\\xa0]*lev(?:[eé]l))?)?|id(?:om)?|yd|d)|الرسالة[\\s\\xa0]*إلى[\\s\\xa0]*العبرانيين|Јев|B(?:arua[\\s\\xa0]*kwa[\\s\\xa0]*Waebrania|r(?:e(?:vet[\\s\\xa0]*til[\\s\\xa0]*(?:Hebræerne|hebreerne)|fið[\\s\\xa0]*til[\\s\\xa0]*Hebrea)|éfið[\\s\\xa0]*til[\\s\\xa0]*Hebrea))|ibr(?:ānīāṃ[\\s\\xa0]*nū̃[\\s\\xa0]*pattrī|[iī][\\s\\xa0]*lok(?:[aā](?:[mṃ]s[\\s\\xa0]*patra)))|हिब्रू(?:हरूको[\\s\\xa0]*निम्ति[\\s\\xa0]*पत्र)?|《(?:希伯(?:來[书書]》|来书》)|耶烏雷爾》|[來来]》)|Евр(?:еи)?|Cib(?:raaniyada)?|எபி(?:ர(?:ெயருக்கு[\\s\\xa0]*எழுதிய[\\s\\xa0]*நிருபம்|ே(?:யர(?:ுக்கு[\\s\\xa0]*எழுதிய[\\s\\xa0]*(?:திருமுகம்|கடிதம்)|்))?))?|L(?:ettera[\\s\\xa0]*agli[\\s\\xa0]*Ebrei|ayang[\\s\\xa0]*Ibrani|ist[\\s\\xa0]*(?:Hebrej[ouů]m|do[\\s\\xa0]*(?:Hebrajczyk[oó]w|[ZŻ]yd(?:[oó]w))|[ZŽ]id(?:[uů]m)))|Waraka[\\s\\xa0]*kwa[\\s\\xa0]*Waebrania|Kirje[\\s\\xa0]*he[bp]realaisille|Żyd)|Zsid|(?:《(?:希伯(?:来书|來[书書])|耶烏雷爾|[来來])|[来來]》?|ਇਬਰਾਨੀਆਂ[\\s\\xa0]*ਨੂੰ|אל[\\s\\xa0]*העברים|इब्री(?:[\\s\\xa0]*लोकांस)?|Ibrani|العبرانيين|Јеврејима|E(?:pireyarukku|brei)|ad[\\s\\xa0]*Hebraeos|ع(?:ِبرانیوں|برانیوں)|H(?:e(?:prealaisille|br(?:æerne|a(?:jczyk[óo]w|eos)|e(?:erne|j(?:ima|[uoů]m)|o)))|ê)|Євре[їі]в|耶烏雷爾》?|hibr[uū]har(?:[uū]ko[\\s\\xa0]*nimti)|Евре(?:ите|ям)|हिब्रूहरूको[\\s\\xa0]*निम्ति|Waebrania|Poslanica[\\s\\xa0]*Hebrejima|Žid[uů]m|До[\\s\\xa0]*євре[ії]в|Żyd[óo]w|Z(?:sid[óo]khoz|id[uů]m|yd[óo]w)|К[\\s\\xa0]*Евреям|ibr(?:[iī][\\s\\xa0]*lok(?:[āa](?:[mṃ]s))|ānīāṃ)|希伯(?:來[书書]》?|来书》?)|Εβρα[ίι]ους))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Phil"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:पौलाचे[\\s\\xa0]*फिलिप्पैकरांस[\\s\\xa0]*पत्र|ﻓﻴﻠﻴﺒﻲ|Sulat[\\s\\xa0]*sa[\\s\\xa0]*mga[\\s\\xa0]*(?:Filipense|Pilip(?:ense|yano))|filipp(?:iyōṅ[\\s\\xa0]*ke[\\s\\xa0]*nām[\\s\\xa0]*kā[\\s\\xa0]*ḫaṭ|īāṃ[\\s\\xa0]*nū̃[\\s\\xa0]*pattrī)|(?:[ヒピ]リ(?:[ヒピ](?:人への(?:手紙|書)|書)))|Mga[\\s\\xa0]*Taga(?:[\\s\\xa0]*[FP]ilipos|-?(?:[\\s\\xa0]*[FP]ilipos|Filipos))|ਫ਼ਿਲਿੱਪੀਆਂ[\\s\\xa0]*ਨੂੰ[\\s\\xa0]*ਪੱਤ੍ਰੀ|L(?:ayang[\\s\\xa0]*Paulus[\\s\\xa0]*Filipi|ettera[\\s\\xa0]*ai[\\s\\xa0]*Filippesi|ist[\\s\\xa0]*(?:(?:[sś]w(?:\\.[\\s\\xa0]*Pawła[\\s\\xa0]*do[\\s\\xa0]*Filipian|[\\s\\xa0]*Pawła[\\s\\xa0]*do[\\s\\xa0]*Filipian))|do[\\s\\xa0]*Filipian|Filip(?:anom|sk[yý]m)))|الرسالة[\\s\\xa0]*إلى[\\s\\xa0]*أهل[\\s\\xa0]*فيلبي|フィリ(?:[ヒピ](?:の信徒への手紙|人への手紙|書)?)|फिलिप्(?:‍पी|प(?:ि(?:यों)?|ी(?:हरूलाई[\\s\\xa0]*प(?:ावलको[\\s\\xa0]*पत्र|त्र))?))|빌립보서|B(?:r[eé]f[\\s\\xa0]*P(?:[aá]ls[\\s\\xa0]*til[\\s\\xa0]*Filipp(?:[ií]manna?))|arua[\\s\\xa0]*kwa[\\s\\xa0]*Wafilipi)|Epistula[\\s\\xa0]*ad[\\s\\xa0]*Philippenses|Φι|필리(?:피(?:[\\s\\xa0]*신자들에게[\\s\\xa0]*보낸[\\s\\xa0]*서간|서))?|《(?:斐理伯書》|肥利批》|腓(?:立比[书書]》|》))|ف(?:ِل(?:ِپ(?:ّیُوں[\\s\\xa0]*کے[\\s\\xa0]*نام[\\s\\xa0]*پو[\\s\\xa0]*لس[\\s\\xa0]*رسُول[\\s\\xa0]*کا[\\s\\xa0]*خط|ِّیوں[\\s\\xa0]*کے[\\s\\xa0]*نام[\\s\\xa0]*کا[\\s\\xa0]*خط)|پّیوں)|ل(?:پیوں[\\s\\xa0]*کے[\\s\\xa0]*نام[\\s\\xa0]*کا[\\s\\xa0]*خط)?|ي)|האיגרת[\\s\\xa0]*אל[\\s\\xa0]*הפיליפים|Kirje[\\s\\xa0]*filippil[aä]isille|pʰilipp(?:aikar[aā](?:[mṃ]s[\\s\\xa0]*patra)|[iī]har(?:[uū]l(?:[aā](?:[iī][\\s\\xa0]*patra))))|F(?:ili(?:boy|p(?:ian[eë]ve|en(?:s(?:k[yý]m|es|[oó]w)|i)|yen|p(?:íbr[eé]fið|aiyon|e(?:rbrevet|n(?:serne|zen))|i(?:l[aä]iskirje|br[eé]fið|ekhez)?))?)?|l(?:ippiekhez|p)?|p)|ฟ(?:ีลิปปี|ป)|П(?:исмо[\\s\\xa0]*од[\\s\\xa0]*апостол[\\s\\xa0]*Павле[\\s\\xa0]*до[\\s\\xa0]*христијаните[\\s\\xa0]*во[\\s\\xa0]*Филипи|ослан(?:и(?:е[\\s\\xa0]*(?:на[\\s\\xa0]*св(?:\\.[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Филипяни|[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Филипяни)|[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Филипяни|[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*Филипяни))|к(?:ъм[\\s\\xa0]*филипяните|[\\s\\xa0]*Филиппи[ий]цам))|ца[\\s\\xa0]*Филипљанима)|ня[\\s\\xa0]*(?:св(?:\\.[\\s\\xa0]*апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*филип['’]ян|[\\s\\xa0]*апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*филип['’]ян)|апостола[\\s\\xa0]*Павла[\\s\\xa0]*до[\\s\\xa0]*филип['’]ян|до[\\s\\xa0]*(?:Філіп['’]ян|филип['’]ян))))|Ф(?:ил(?:ип(?:['’]яни|јани(?:те)?))?|лп)|אגרת[\\s\\xa0]*פולוס[\\s\\xa0]*השליח[\\s\\xa0]*אל-?הפיליפי|رسالة[\\s\\xa0]*(?:بولس[\\s\\xa0]*الرسول[\\s\\xa0]*إلى[\\s\\xa0]*أهل[\\s\\xa0]*فيلبي|فيلبي)|பிலி(?:ப்(?:பியர(?:ுக்கு[\\s\\xa0]*எழுதிய[\\s\\xa0]*(?:திருமுகம்|நிருபம்|கடிதம்)|்))?)?|ଫିଲି‌ପ୍‌ପୀୟଙ୍କ[\\s\\xa0]*ପ୍ରତି[\\s\\xa0]*ପତ୍ର|Προς[\\s\\xa0]*Φιλιππησ[ίι]ους|Waraka[\\s\\xa0]*kwa[\\s\\xa0]*Wafilipi|P(?:oslannja[\\s\\xa0]*apostola[\\s\\xa0]*Pavla[\\s\\xa0]*do[\\s\\xa0]*fylyp['’]jan|ilippiyarukku[\\s\\xa0]*E[lḻ]utiya[\\s\\xa0]*Nirupam|a(?:vlova[\\s\\xa0]*poslanica[\\s\\xa0]*Filipljanima|ulus['’][\\s\\xa0]*Brev[\\s\\xa0]*til[\\s\\xa0]*Filipperne)|h(?:i(?:-?líp|l(?:ípphê|l(?:l(?:ip(?:pians|i(?:ians|ans?))|p(?:pians|ians))|p(?:pians?|ans|i(?:ens|ans?))|i(?:p(?:p(?:pians|a(?:ins|ns)|eans?|i(?:[ei]ans|a(?:ins|ns?)|ns))|eans?|i(?:ians|e(?:ans|ns)|a(?:[ai]ns|ns?)|ns)|a(?:i(?:ans|ns?)|ns?))?)?)|i(?:p(?:e(?:ans|ns)|i(?:ians|ens|a(?:id|ns?)|ns)|a(?:i(?:ans|ns?)|ns?)|p(?:pians?|a(?:i(?:ans|ns)|ns?)|e(?:ans?|r)|i(?:beliekhez|ians|ens|a(?:[ai]ns|ns?)|ns?))?)?)?|p(?:eans|i(?:ans?|ns)|a(?:ins|n)|p(?:pians|i(?:ians|ans?))?)?)?)|l(?:ip(?:ians|p(?:ians)?)?|pp?)|p)))|(?:pʰilipp(?:[īi]har(?:[uū]l(?:[āa][īi]))|aikar[āa](?:[mṃ]s))|फिलिप्प(?:ीहरूलाई|ैकरांस(?:[\\s\\xa0]*पत्र)?)|ଫିଲି‌ପ୍‌ପୀୟଙ୍କ|腓(?:立比[書书]》?|》)?|Φιλιππησ[ιί]ους|До[\\s\\xa0]*филип[’']ян|《(?:斐理伯書|肥利批|腓(?:立比[書书])?)|P(?:aulus’[\\s\\xa0]*brev[\\s\\xa0]*til[\\s\\xa0]*filipperne|oslanica[\\s\\xa0]*Filipljanima|ilippiyarukku|hi(?:lippenses)?)|filippīāṃ|ਫ਼ਿਲਿੱਪੀਆਂ[\\s\\xa0]*ਨੂੰ|אל[\\s\\xa0]*הפיליפים|ad[\\s\\xa0]*Philippenses|Wafilipi|斐理伯書》?|Филип(?:љанима|пи[йи]цам|['’]ян|яни(?:те)?)|Mga[\\s\\xa0]*(?:Pilip(?:ense|yano)|Filipense)|ف(?:ِلِپّیُوں|لپیوں)|Taga(?:-?(?:[\\s\\xa0]*[PF]ilipos|Filipos)|[\\s\\xa0]*[PF]ilipos)|К[\\s\\xa0]*Филиппи[йи]цам|Filip(?:ljanima|anom|p(?:il[aä]isille|e(?:rne|si))|sk[ýy]m|os|i(?:an)?)|肥利批》?))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Dan"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(dan(?:iyalko[\\s\\xa0]*pustak|īel)|(?:Δ(?:α(?:ν(?:ι[ήη]λ)?)?|ν)|दान(?:ीएल(?:्र)?|ि(?:य(?:्य(?:ेल|ल)|ल(?:को[\\s\\xa0]*पुस्तक)?))?)|Liv[\\s\\xa0]*Dany[eè]l[\\s\\xa0]*la|Ks(?:i[eę]g(?:[ai][\\s\\xa0]*Daniela)|\\.[\\s\\xa0]*Daniela|[\\s\\xa0]*Daniela)|D(?:haniel|án(?:iel)?|a(?:an(?:iyyel|yeel)?|n(?:i(?:[aèë]l|el(?:s[\\s\\xa0]*(?:Bog|bok)|e|i(?:n[\\s\\xa0]*kirja)?)?)|y[iï]l|íel)?)?|[ln])|ด(?:าเนียล|นล)|다니(?:엘서?)?|Prophetia[\\s\\xa0]*Danielis|தானி(?:யேல(?:ின்[\\s\\xa0]*புத்தகம்|்))?|T[aā](?:[nṉ]iy(?:[eē]l))|דניאל|ਦਾਨੀਏਲ|Д(?:ан(?:аил|и(?:[еяії]л|ло?))?|он)|سفر[\\s\\xa0]*دانيال|《(?:達尼爾》|但(?:以理[书書]》|》))|단|Книга[\\s\\xa0]*(?:на[\\s\\xa0]*пророк[\\s\\xa0]*Даниила?|пророка[\\s\\xa0]*Дани[иії]ла)|Đa(?:-?ni(?:-?ên|ên)|nien)|Ða-?ni-?ên|ଦାନିୟେଲଙ(?:୍କ[\\s\\xa0]*ପୁସ୍ତକ)?|dān(?:i(?:yalko[\\s\\xa0]*pustak|el)|ī(?:ʾīl|el))|[タダ]ニエル書?|دا(?:نی(?:[\\s\\xa0‌]*ایل|ال))?)|(?:但(?:以理[書书]》?|》)?|Đa|दानियलको|《(?:達尼爾|但(?:以理[書书])?)|دانيال|Dan(?:iel(?:in|a)|y[èe]l)|達尼爾》?|d(?:āniyalko|ani(?:yalko|el))|Дани(?:[ії]ла|ила?)))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Jude"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:H(?:ið[\\s\\xa0]*almenna[\\s\\xa0]*br[eé]f[\\s\\xa0]*J(?:[uú]dasar)|udas)|Y(?:ūt[aā][\\s\\xa0]*E(?:[lḻ]utiya[\\s\\xa0]*Nirupam)|ahooda|u(?:t[aā][\\s\\xa0]*E(?:[lḻ]utiya[\\s\\xa0]*Nirupam)|ud(?:as)?|d))|ਯਹੂਦਾਹ[\\s\\xa0]*ਦੀ[\\s\\xa0]*ਪੱਤ੍ਰੀ|[ІИ]уд|yah(?:ud[aā](?:ce(?:[mṃ][\\s\\xa0]*patra|ko[\\s\\xa0]*patra))|ūd(?:a(?:ce[mṃ][\\s\\xa0]*patra|ko[\\s\\xa0]*patra)|ā(?:h[\\s\\xa0]*(?:kā[\\s\\xa0]*ʿām[\\s\\xa0]*ḫaṭ|dī[\\s\\xa0]*pattrī)|ce[mṃ][\\s\\xa0]*patra|ko[\\s\\xa0]*patra)))|San[\\s\\xa0]*Judas|ユ(?:[タダ](?:からの手紙|の(?:手紙|書))?)|ย(?:ูดา|ด)|यहूदा(?:चें[\\s\\xa0]*पत्र|को[\\s\\xa0]*पत्र)?|᾿Ιδ|J(?:u(?:d(?:ina[\\s\\xa0]*poslanica|ov(?:[\\s\\xa0]*List|a)|ás|a(?:s(?:['’][\\s\\xa0]*Brev|arbr(?:[eé]f(?:ið)?)|brevet|[\\s\\xa0]*(?:epistel|brev)))?)|ud(?:aksen[\\s\\xa0]*kirje)?)|d(?:as|e)|id|wd(?:as)?|úd(?:ov[\\s\\xa0]*List|as(?:arbr(?:[eé]f(?:ið)?))?|ás)?)|Barua[\\s\\xa0]*ya[\\s\\xa0]*Yuda|يهو?|Poslan(?:ica[\\s\\xa0]*Jude[\\s\\xa0]*apostola|nja[\\s\\xa0]*apostola[\\s\\xa0]*Judy)|یہ(?:ُوداہ[\\s\\xa0]*کا[\\s\\xa0]*عام[\\s\\xa0]*خط|وداہ[\\s\\xa0]*کا[\\s\\xa0]*عام[\\s\\xa0]*خط)|Ιο[υύ]δα|Ј(?:аковљевог|уде|д)|L(?:ettera[\\s\\xa0]*di[\\s\\xa0]*Giuda|ayang[\\s\\xa0]*Yudas|ist[\\s\\xa0]*(?:powszechny[\\s\\xa0]*[SŚ]wi(?:[eę]tego[\\s\\xa0]*Iudasa[\\s\\xa0]*Apostoła)|(?:[sś]w(?:\\.[\\s\\xa0]*Judy|[\\s\\xa0]*Judy))|Jud(?:[uů]v|y)))|ଯିହୂଦାଙ୍କ[\\s\\xa0]*ପତ୍ର|П(?:исмо[\\s\\xa0]*од[\\s\\xa0]*апостол[\\s\\xa0]*Јуда|ослан(?:и(?:ца[\\s\\xa0]*Јудина|е[\\s\\xa0]*(?:на[\\s\\xa0]*(?:апостол[\\s\\xa0]*Јуда|Юда)|Иуды))|ня[\\s\\xa0]*(?:апостола[\\s\\xa0]*Юди|Іуди)))|א(?:יגרת[\\s\\xa0]*יהודה|גרת[\\s\\xa0]*יהודה)|G(?:iu(?:-?đe|đa)|d)|유다(?:[\\s\\xa0]*서간|서)|Epistula[\\s\\xa0]*Iudae|رسال(?:ى[\\s\\xa0]*القديس[\\s\\xa0]*يهوذا|ة[\\s\\xa0]*يهوذا)|Юд|யூதா[\\s\\xa0]*(?:எழுதிய[\\s\\xa0]*(?:நிருபம்|கடிதம்)|திருமுகம்)|Iuda|《(?:伊屋達》|犹(?:大书》|》)|猶(?:[大達]書》|》))|С(?:ъборно[\\s\\xa0]*послание[\\s\\xa0]*на[\\s\\xa0]*св(?:\\.[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Иуда|[\\s\\xa0]*Иуда)|[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Иуда|[\\s\\xa0]*Иуда))|оборне[\\s\\xa0]*послання[\\s\\xa0]*(?:св(?:\\.[\\s\\xa0]*апостола[\\s\\xa0]*Юди|[\\s\\xa0]*апостола[\\s\\xa0]*Юди)|Юди)))|yahud(?:[aā]ko[\\s\\xa0]*patra)|(?:Y(?:ūt[aā]|u(?:das?|t[aā]))|Giuda|Послання[\\s\\xa0]*Юди|《(?:伊屋達|猶(?:[大達]書)?|犹(?:大书)?)|ਯਹੂਦਾਹ|يهوذا|伊屋達》?|유다|Iudae|ଯିହୂଦାଙ୍କ|यहूदा(?:चें|को)|Иуд[ыа]|犹(?:大书》?|》)?|猶(?:[大達]書》?|》)?|J(?:údov|u(?:udaksen|d(?:ina|ov|as(?:’[\\s\\xa0]*brev)?|[ye])))|Јуд(?:ина|а)|யூதா|yah(?:ud(?:[āa](?:ce[ṃm]|ko))|ūd(?:a(?:ce[ṃm]|ko)|ā(?:ce[ṃm]|ko|h)))|Юда|یہ(?:ُوداہ|وداہ)))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["2Macc"],
        apocrypha: true,
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(2[\s\xa0]*makkabilaiskirja|(?:And(?:en[\s\xa0]*Makk(?:abæerbog)?|r(?:a[\s\xa0]*Mackab[eé]erboken|e[\s\xa0]*Makk(?:abeerbok)?))|マカ(?:[ヒビ]ー第二書|(?:[ハバ]イ(?:[\s\xa0]*2|記[2下]|下)))|2(?:\.(?:(?:[oº](?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))))|[\s\xa0]*(?:makkabilaiskirja|Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|книга[\s\xa0]*Макаве[ії]в|Wamakabayo|Мак(?:кавеев|а(?:бејаца|ве(?:[ії]в|ј(?:ска|а)|и)))|มัคคาบี|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:kab[eé]erboken|hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:ées|b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:j(?:cov|sk[aá]))?|k(?:ab(?:æerbog|e(?:usok|e(?:rbok|[eë]n))|[aä]er))?)?))))|e(?:me(?:\.[\s\xa0]*Maccab[eé]es|[\s\xa0]*Maccab[eé]es)|\.[\s\xa0]*Ma(?:ccab[eé]es|k(?:kabee[eë]n)?)|[\s\xa0]*Ma(?:ccab[eé]es|k(?:kabee[eë]n)?))|Macc|o(?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|us|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|us|os?))))|º(?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?))))|[\s\xa0]*(?:المكابيين|книга[\s\xa0]*Макаве[ії]в|Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|مك|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:ées|b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?|h(?:ab(?:aeorum|ejcov))?|k(?:ab[eé]erboken)?)?|k(?:abe(?:j(?:cov|sk[aá]))?|k(?:ab(?:æerbog|e(?:usok|e(?:rbok|[eë]n))|[aä]er))?)?)?|c[bh]?)?|மக்(?:கபேயர்)?|Wamakabayo|มัคคาบี|k(?:\.[\s\xa0]*Ma(?:chabejcov|kabejcov)|[\s\xa0]*Ma(?:chabejcov|kabejcov))|М(?:ак(?:а(?:бејаца|ве(?:[ії]в|ј(?:ска|а)|и))|к(?:авеев)?)?|к))|nd(?:\.[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?)|-?(?:ге(?:\.[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Макаве[ії]в)|[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Макаве[ії]в))|я(?:\.[\s\xa0]*Маккавеев|[\s\xa0]*Маккавеев)|а(?:\.[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Макаве[ії]в)|[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Макаве[ії]в))|е(?:\.[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Мак(?:кавеев|аве[ії]в))|[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Мак(?:кавеев|аве[ії]в))))|(?:[яе](?:\.[\s\xa0]*Маккавеев|[\s\xa0]*Маккавеев))|a(?:\.[\s\xa0]*Macabeus|[\s\xa0]*Macabeus)|°(?:\.[\s\xa0]*Maccabei|[\s\xa0]*Maccabei)|마카|d(?:\.[\s\xa0]*Maccab[eé]es|e(?:\.[\s\xa0]*Maccab[eé]es|[\s\xa0]*Maccab[eé]es)|[\s\xa0]*Maccab[eé]es)|ème(?:\.[\s\xa0]*Maccab[eé]es|[\s\xa0]*Maccab[eé]es))|Μακκαβα[ίι]ων[\s\xa0]*Β['ʹʹ΄’]|ספר[\s\xa0]*מקבים[\s\xa0]*ב['’]|חשמונאים[\s\xa0]*ב['’]|《瑪加伯下》|Друг(?:а[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Мака(?:бејаца|ве(?:[ії]в|ј(?:ска|а))))|е[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Макаве[ії]в))|[OÖ]nnur[\s\xa0]*Makkabeab(?:[oó]k)|I(?:kalawang[\s\xa0]*M(?:ga[\s\xa0]*Macabeo|acabeos?)|I(?:\.[\s\xa0]*(?:makkabilaiskirja|Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|книга[\s\xa0]*Макаве[ії]в|Wamakabayo|Мака(?:бејаца|ве(?:[ії]в|ј(?:ска|а)|и))|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:ées|b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:j(?:cov|sk[aá]))?|k(?:abe(?:usok|e[eë]n))?)?)))|[\s\xa0]*(?:makkabilaiskirja|Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|книга[\s\xa0]*Макаве[ії]в|Wamakabayo|Мака(?:бејаца|ве(?:[ії]в|ј(?:ска|а)|и))|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:ées|b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:j(?:cov|sk[aá]))?|k(?:abe(?:usok|e[eë]n))?)?)))))|M(?:a(?:chabaeorum[\s\xa0]*II|kkabeusok[\s\xa0]*II|sodik[\s\xa0]*Mak(?:kabeusok)?)|ásodik[\s\xa0]*Mak(?:kabeusok)?)|سفر[\s\xa0]*المكابين[\s\xa0]*الثاني|마카베오(?:기[\s\xa0]*하권|하)|D(?:euxi[eè]me(?:s[\s\xa0]*Maccab(?:[eé]es|[\s\xa0]*Maccab[eé]es))|ru(?:g(?:a[\s\xa0]*(?:knjiga[\s\xa0]*o[\s\xa0]*Makabejcima|Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska))|i[\s\xa0]*Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska))|h(?:(?:[aá][\s\xa0]*(?:kniha[\s\xa0]*Ma(?:chabejcov|kabejcov)|Ma(?:chabejcov|k(?:abej(?:cov|sk[aá]))?)))|(?:[yý][\s\xa0]*(?:list[\s\xa0]*Ma(?:chabejcov|kabejcov)|Ma(?:chabejcov|k(?:abej(?:cov|sk[aá]))?))))))|Kitabu[\s\xa0]*cha[\s\xa0]*Wamakabayo[\s\xa0]*II|Β['ʹʹ΄’][\s\xa0]*Μακκ(?:αβα(?:[ίι]ων)?)|Liber[\s\xa0]*(?:II[\s\xa0]*Maccabaeorum|Maccabaeorum[\s\xa0]*II)|Втора(?:я[\s\xa0]*книга[\s\xa0]*Маккаве[ий]ская|[\s\xa0]*(?:книга[\s\xa0]*(?:на[\s\xa0]*Макавеите|Макаве[ий]ска)|Макавеи))|Zweite[\s\xa0]*Makkab[aä]er|Pili[\s\xa0]*(?:Wamakabayo|Mak)|T(?:oinen[\s\xa0]*makkabilaiskirja|weede[\s\xa0]*Mak(?:kabee[eë]n)?)|Se(?:gund(?:a[\s\xa0]*Macabeus|o[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|us|os?))))|cond(?:a[\s\xa0]*Maccabei|o[\s\xa0]*(?:libro[\s\xa0]*dei[\s\xa0]*Maccabei|Maccabei)|[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?)))|(?:Deuxi[eè]me[\s\xa0]*Maccab(?:[eé]es)|Β['ʹʹ΄’][\s\xa0]*Μακκ)|(?:المكابين[\s\xa0]*الثاني|Wamakabayo[\s\xa0]*II|מקבים[\s\xa0]*ב|2[\s\xa0]*makk|《瑪加伯下|瑪加伯下》?))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["3Macc"],
        apocrypha: true,
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(3[\s\xa0]*makkabilaiskirja|(?:Μακκαβα[ίι]ων[\s\xa0]*Γ['ʹʹ΄’]|K(?:itabu[\s\xa0]*cha[\s\xa0]*Wamakabayo[\s\xa0]*III|olmas[\s\xa0]*makkabilaiskirja)|마카베오[\s\xa0]*3서|Liber[\s\xa0]*(?:III[\s\xa0]*Maccabaeorum|Maccabaeorum[\s\xa0]*III)|T(?:er(?:ce(?:ir[ao][\s\xa0]*Macabeus|r(?:o[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))))|z(?:a[\s\xa0]*Maccabei|o[\s\xa0]*(?:libro[\s\xa0]*dei[\s\xa0]*Maccabei|Maccabei)))|hird[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|r(?:zeci(?:a[\s\xa0]*Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|[\s\xa0]*Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska))|oisi[eè]me(?:s[\s\xa0]*Maccab(?:[eé]es|[\s\xa0]*Maccab[eé]es))|e(?:[cć]a[\s\xa0]*knjiga[\s\xa0]*o[\s\xa0]*Makabejcima|dje[\s\xa0]*Ma(?:ckab[eé]erboken|kk(?:ab(?:eerbok|æerbog))?)|t(?:i(?:a[\s\xa0]*(?:kniha[\s\xa0]*Machabejcov|Machabejcov)|[\s\xa0]*Ma(?:chabejcov|k(?:abejsk[aá])?))|í[\s\xa0]*Ma(?:chabejcov|k(?:abejsk[aá])?))))|řet(?:[ií][\s\xa0]*Mak(?:abejsk[aá])?)|atu[\s\xa0]*(?:Wamakabayo|Mak))|I(?:katlong[\s\xa0]*M(?:ga[\s\xa0]*Macabeo|acabeos?)|II(?:\.[\s\xa0]*(?:makkabilaiskirja|Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|книга[\s\xa0]*Макаве[ії]в|Wamakabayo|Мака(?:бејаца|ве(?:[ії]в|ј(?:ска|а)|и))|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:ées|b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:jsk[aá])?|k(?:abe(?:usok|e[eë]n))?)?)))|[\s\xa0]*(?:makkabilaiskirja|Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|книга[\s\xa0]*Макаве[ії]в|Wamakabayo|Мака(?:бејаца|ве(?:[ії]в|ј(?:ска|а)|и))|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:ées|b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:jsk[aá])?|k(?:abe(?:usok|e[eë]n))?)?)))))|المكابين[\s\xa0]*الثالث|Ma(?:chabaeorum[\s\xa0]*III|kkabeusok[\s\xa0]*III)|Тре(?:ћ(?:ом[\s\xa0]*Мака(?:бејаца|веј(?:ска|а))|а[\s\xa0]*Мака(?:бејаца|веј(?:ска|а)))|т(?:ья[\s\xa0]*книга[\s\xa0]*Маккаве[ий]ская|а[\s\xa0]*книга[\s\xa0]*Макаве[ий]ска|[яє][\s\xa0]*(?:книга[\s\xa0]*Макаве(?:[ії]в|Макаве[ії]в))|о[\s\xa0]*(?:книга[\s\xa0]*на[\s\xa0]*Макавеите|Макавеи)))|חשמונאים[\s\xa0]*ג['’]|3(?:-?(?:тє(?:\.[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Макаве[ії]в)|[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Макаве[ії]в))|я(?:\.[\s\xa0]*Маккавеев|[\s\xa0]*Маккавеев)|а(?:\.[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Макаве[ії]в)|[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Макаве[ії]в))|е(?:\.[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Мак(?:кавеев|аве[ії]в))|[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Мак(?:кавеев|аве[ії]в))))|o(?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|us|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|us|os?))))|º(?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?))))|e(?:me(?:\.[\s\xa0]*Maccab[eé]es|[\s\xa0]*Maccab[eé]es)|\.[\s\xa0]*Ma(?:c(?:kab[eé]erboken|cab[eé]es)|k(?:kabee[eë]n)?)|[\s\xa0]*Ma(?:c(?:kab[eé]erboken|cab[eé]es)|k(?:kabee[eë]n)?))|\.(?:(?:[oº](?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))))|[\s\xa0]*(?:makkabilaiskirja|Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|книга[\s\xa0]*Макаве[ії]в|Wamakabayo|Мак(?:кавеев|а(?:бејаца|ве(?:[ії]в|ј(?:ска|а)|и)))|มัคคาบี|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:kab[eé]erboken|hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:ées|b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:jsk[aá])?|k(?:ab(?:æerbog|e(?:usok|e(?:rbok|[eë]n))|[aä]er))?)?))))|rd(?:\.[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?)|(?:[яе](?:\.[\s\xa0]*Маккавеев|[\s\xa0]*Маккавеев))|a(?:\.[\s\xa0]*Macabeus|[\s\xa0]*Macabeus)|[\s\xa0]*(?:Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|книга[\s\xa0]*Макаве[ії]в|k(?:\.[\s\xa0]*Machabejcov|[\s\xa0]*Machabejcov)|Wamakabayo|มัคคาบี|மக்(?:கபேயர்)?|М(?:ак(?:а(?:бејаца|ве(?:[ії]в|ј(?:ска|а)|и))|к(?:авеев)?)?|к)|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:ées|b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?|h(?:ab(?:aeorum|ejcov))?|k(?:ab[eé]erboken)?)?|k(?:abe(?:jsk[aá])?|k(?:ab(?:æerbog|e(?:usok|e(?:rbok|[eë]n))|[aä]er))?)?)|c[bh]?)?)|°(?:\.[\s\xa0]*Maccabei|[\s\xa0]*Maccabei)|마카|ème(?:\.[\s\xa0]*Maccab[eé]es|[\s\xa0]*Maccab[eé]es))|Þriðja[\s\xa0]*Makkabeab[oó]k|ספר[\s\xa0]*מקבים[\s\xa0]*ג['’]|Γ['ʹʹ΄’][\s\xa0]*Μακκ(?:αβα(?:[ίι]ων)?)|マカ(?:[ヒビ]ー第三書|[ハバ]イ(?:[\s\xa0記]*3))|《3Macc》|D(?:ritte[\s\xa0]*Makkab[aä]er|erde[\s\xa0]*Mak(?:kabee[eë]n)?)|Harmadik[\s\xa0]*Mak(?:kabeusok)?)|(?:Troisi[eè]me[\s\xa0]*Maccab(?:[eé]es)|Трет[яє][\s\xa0]*Макаве(?:[ії]в)|Γ['ʹʹ΄’][\s\xa0]*Μακκ)|(?:Wamakabayo[\s\xa0]*III|מקבים[\s\xa0]*ג|《3Macc|3(?:[\s\xa0]*makk|Macc》?)))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["4Macc"],
        apocrypha: true,
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(4[\s\xa0]*makkabilaiskirja|(?:Четв(?:ерта[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Макаве[ії]в)|рта[\s\xa0]*Мака(?:бејаца|веј(?:ска|а))|ърта[\s\xa0]*(?:книга[\s\xa0]*на[\s\xa0]*Макавеите|Макавеи))|I(?:kaapat[\s\xa0]*M(?:ga[\s\xa0]*Macabeo|acabeos?)|V(?:\.[\s\xa0]*(?:makkabilaiskirja|Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|книга[\s\xa0]*Макаве[ії]в|Wamakabayo|Мака(?:бејаца|ве(?:[ії]в|ј(?:ска|а)|и))|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:ées|b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:jsk[aá])?|k(?:abe(?:usok|e[eë]n))?)?)))|[\s\xa0]*(?:makkabilaiskirja|Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|книга[\s\xa0]*Макаве[ії]в|Wamakabayo|Мака(?:бејаца|ве(?:[ії]в|ј(?:ска|а)|и))|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:ées|b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:jsk[aá])?|k(?:abe(?:usok|e[eë]n))?)?)))))|Qua(?:tri[eè]me(?:s[\s\xa0]*Maccab(?:[eé]es|[\s\xa0]*Maccab[eé]es))|rt(?:a[\s\xa0]*Mac(?:abeus|cabei)|o[\s\xa0]*(?:libro[\s\xa0]*dei[\s\xa0]*Maccabei|Mac(?:abeus|cabei))))|(?:[SŠ]tvrt(?:[aá][\s\xa0]*(?:kniha[\s\xa0]*Machabejcov|Machabejcov)))|Μακκαβα[ίι]ων[\s\xa0]*Δ['ʹʹ΄’]|ספר[\s\xa0]*מקבים[\s\xa0]*ד['’]|חשמונאים[\s\xa0]*ד['’]|Liber[\s\xa0]*(?:IV[\s\xa0]*Maccabaeorum|Maccabaeorum[\s\xa0]*IV)|Kitabu[\s\xa0]*cha[\s\xa0]*Wamakabayo[\s\xa0]*IV|Čtvrt(?:[aá][\s\xa0]*Mak(?:abejsk[aá])?)|Ma(?:chabaeorum[\s\xa0]*IV|kkabeusok[\s\xa0]*IV)|N(?:elj[aä]s[\s\xa0]*makkabilaiskirja|ne[\s\xa0]*(?:Wamakabayo|Mak))|F(?:j(?:[aä]rde[\s\xa0]*Mackab(?:[eé]erboken)|[oó]rða[\s\xa0]*Makkabeab(?:[oó]k)|erde[\s\xa0]*Makk(?:ab(?:eerbok|æerbog))?)|ourth[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?)|マカ(?:[ヒビ]ー第四書|[ハバ]イ(?:[\s\xa0記]*4))|Δ['ʹʹ΄’][\s\xa0]*Μακκ(?:αβα(?:[ίι]ων)?)|C(?:zwarta[\s\xa0]*Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|uarto[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))|tvrt(?:[aá][\s\xa0]*Mak(?:abejsk[aá])?))|마카베오[\s\xa0]*4서|《4Macc》|4(?:-?(?:[ея](?:\.[\s\xa0]*Маккавеев|[\s\xa0]*Маккавеев))|e(?:me(?:\.[\s\xa0]*Maccab[eé]es|[\s\xa0]*Maccab[eé]es)|\.[\s\xa0]*Maccab[eé]es|[\s\xa0]*Maccab[eé]es)|o(?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|us|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|us|os?))))|º(?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?))))|\.(?:(?:[oº](?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))))|[\s\xa0]*(?:makkabilaiskirja|Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|книга[\s\xa0]*Макаве[ії]в|Wamakabayo|Мак(?:кавеев|а(?:бејаца|ве(?:[ії]в|ј(?:ска|а)|и)))|มัคคาบี|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:kab[eé]erboken|hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:ées|b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:jsk[aá])?|k(?:ab(?:æerbog|e(?:usok|e(?:rbok|[eë]n))|[aä]er))?)?))))|(?:[яе](?:\.[\s\xa0]*Маккавеев|[\s\xa0]*Маккавеев))|a(?:\.[\s\xa0]*Macabeus|[\s\xa0]*Macabeus)|[\s\xa0]*(?:Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|книга[\s\xa0]*Макаве[ії]в|k(?:\.[\s\xa0]*Machabejcov|[\s\xa0]*Machabejcov)|Wamakabayo|มัคคาบี|மக்(?:கபேயர்)?|М(?:ак(?:а(?:бејаца|ве(?:[ії]в|ј(?:ска|а)|и))|к(?:авеев)?)?|к)|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:ées|b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?|h(?:ab(?:aeorum|ejcov))?|k(?:ab[eé]erboken)?)?|k(?:abe(?:jsk[aá])?|k(?:ab(?:æerbog|e(?:usok|e(?:rbok|[eë]n))|[aä]er))?)?)|c[bh]?)?)|°(?:\.[\s\xa0]*Maccabei|[\s\xa0]*Maccabei)|마카|ème(?:\.[\s\xa0]*Maccab[eé]es|[\s\xa0]*Maccab[eé]es)|th(?:\.[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?))|المكابين[\s\xa0]*الرابع|Vier(?:te[\s\xa0]*Makkab[aä]er|de[\s\xa0]*Mak(?:kabee[eë]n)?))|(?:Quatri[eè]me[\s\xa0]*Maccab(?:[eé]es)|Δ['ʹʹ΄’][\s\xa0]*Μακκ)|(?:Wamakabayo[\s\xa0]*IV|מקבים[\s\xa0]*ד|《4Macc|4(?:[\s\xa0]*makk|Macc》?)))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["1Macc"],
        apocrypha: true,
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(1[\s\xa0]*makkabilaiskirja|(?:سفر[\s\xa0]*المكابين[\s\xa0]*الأول|1(?:Macc|o(?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|us|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|us|os?))))|º(?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?))))|\.(?:(?:[oº](?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))))|[\s\xa0]*(?:makkabilaiskirja|Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|книга[\s\xa0]*Макаве[ії]в|Wamakabayo|Мак(?:кавеев|а(?:бејаца|ве(?:[ії]в|ј(?:ска|а)|и)))|มัคคาบี|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:kab[eé]erboken|hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:ées|b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:jsk[aá])?|k(?:ab(?:æerbog|e(?:usok|e(?:rbok|[eë]n))|[aä]er))?)?))))|e(?:r(?:\.[\s\xa0]*Maccab[eé]es|e(?:\.[\s\xa0]*Maccab[eé]es|[\s\xa0]*Maccab[eé]es)|[\s\xa0]*Maccab[eé]es)|\.[\s\xa0]*Mak(?:kabee[eë]n)?|[\s\xa0]*Mak(?:kabee[eë]n)?)|ère(?:\.[\s\xa0]*Maccab[eé]es|[\s\xa0]*Maccab[eé]es)|re(?:\.[\s\xa0]*Maccab[eé]es|[\s\xa0]*Maccab[eé]es)|(?:[яе](?:\.[\s\xa0]*Маккавеев|[\s\xa0]*Маккавеев))|a(?:\.[\s\xa0]*Macabeus|[\s\xa0]*Macabeus)|[\s\xa0]*(?:k(?:\.[\s\xa0]*Machabejcov|[\s\xa0]*Machabejcov)|المكابيين|книга[\s\xa0]*Макаве[ії]в|Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|مك|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:ées|b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?|h(?:ab(?:aeorum|ejcov))?|k(?:ab[eé]erboken)?)?|k(?:abe(?:jsk[aá])?|k(?:ab(?:æerbog|e(?:usok|e(?:rbok|[eë]n))|[aä]er))?)?)?|c[bh]?)?|மக்(?:கபேயர்)?|Wamakabayo|มัคคาบี|М(?:ак(?:а(?:бејаца|ве(?:[ії]в|ј(?:ска|а)|и))|к(?:авеев)?)?|к))|°(?:\.[\s\xa0]*Maccabei|[\s\xa0]*Maccabei)|마카|-?(?:ше(?:\.[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Макаве[ії]в)|[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Макаве[ії]в))|я(?:\.[\s\xa0]*Маккавеев|[\s\xa0]*Маккавеев)|а(?:\.[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Макаве[ії]в)|[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Макаве[ії]в))|е(?:\.[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Мак(?:кавеев|аве[ії]в))|[\s\xa0]*(?:книга[\s\xa0]*Макаве[ії]в|Мак(?:кавеев|аве[ії]в))))|st(?:\.[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?))|P(?:ierwsz[aey][\s\xa0]*Ks(?:i(?:[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska))|r(?:emi(?:ère(?:s[\s\xa0]*Maccab[eé]es|[\s\xa0]*Maccab[eé]es)|er(?:e(?:s[\s\xa0]*Maccab[eé]es|[\s\xa0]*Maccab[eé]es)|s[\s\xa0]*Maccab[eé]es|[\s\xa0]*Maccab[eé]es))|im(?:a[\s\xa0]*Maccabei|e(?:ir[ao][\s\xa0]*Macabeus|r(?:o[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))))|o[\s\xa0]*(?:libro[\s\xa0]*dei[\s\xa0]*Maccabei|Maccabei))|v(?:(?:[yý][\s\xa0]*(?:list[\s\xa0]*Machabejcov|Machabejcov))|a[\s\xa0]*(?:kn(?:jiga[\s\xa0]*o[\s\xa0]*Makabejcima|iha[\s\xa0]*Machabejcov)|Ma(?:chabejcov|kabejcov))|á[\s\xa0]*(?:kniha[\s\xa0]*Machabejcov|Ma(?:chabejcov|kabejcov))|n(?:[ií][\s\xa0]*Mak(?:abejsk[aá])?))))|E(?:nsimm[aä]inen[\s\xa0]*makkabilaiskirja|rste[\s\xa0]*Makkab[aä]er|erste[\s\xa0]*Mak(?:kabee[eë]n)?|ls(?:[oő][\s\xa0]*Mak(?:kabeusok)?))|《瑪加伯上》|マカ(?:[ヒビ]ー第一書|(?:[ハバ]イ(?:[\s\xa0]*1|記[1上]|上)))|마카베오(?:기[\s\xa0]*상권|상)|Liber[\s\xa0]*(?:I[\s\xa0]*Maccabaeorum|Maccabaeorum[\s\xa0]*I)|חשמונאים[\s\xa0]*א['’]|Ma(?:chabaeorum[\s\xa0]*I|kkabeusok[\s\xa0]*I)|I(?:\.[\s\xa0]*(?:makkabilaiskirja|Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|книга[\s\xa0]*Макаве[ії]в|Wamakabayo|Мака(?:бејаца|ве(?:[ії]в|ј(?:ска|а)|и))|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:ées|b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:jsk[aá])?|k(?:abe(?:usok|e[eë]n))?)?)))|[\s\xa0]*(?:makkabilaiskirja|Ks(?:i[eę]g(?:[ai][\s\xa0]*Machabejska)|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|книга[\s\xa0]*Макаве[ії]в|Wamakabayo|Мака(?:бејаца|ве(?:[ії]в|ј(?:ска|а)|и))|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:ées|b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:jsk[aá])?|k(?:abe(?:usok|e[eë]n))?)?))))|Una(?:ng[\s\xa0]*M(?:ga[\s\xa0]*Macabeo|acabeos?)|[\s\xa0]*M(?:ga[\s\xa0]*Macabeo|acabeos?))|F(?:[oö]rsta[\s\xa0]*Mackab(?:[eé]erboken)|yrsta[\s\xa0]*Makkabeab[oó]k|ørste[\s\xa0]*Makk(?:ab(?:eerbok|æerbog))?|irst[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?)|ספר[\s\xa0]*מקבים[\s\xa0]*א['’]|Α['ʹʹ΄’][\s\xa0]*Μακκ(?:αβα(?:[ίι]ων)?)|Μακκαβα[ίι]ων[\s\xa0]*Α['ʹʹ΄’]|K(?:itabu[\s\xa0]*cha[\s\xa0]*Wamakabayo[\s\xa0]*I|wanza[\s\xa0]*(?:Wamakabayo|Mak))|П(?:ер(?:вая[\s\xa0]*книга[\s\xa0]*Маккаве[ий]ская|ш[ае][\s\xa0]*(?:книга[\s\xa0]*Макаве(?:[ії]в|Макаве[ії]в)))|рва[\s\xa0]*Мака(?:бејаца|веј(?:ска|а))|ърва[\s\xa0]*(?:книга[\s\xa0]*(?:на[\s\xa0]*Макавеите|Макаве[ий]ска)|Макавеи)))|(?:Pierwsz(?:[aey][\s\xa0]*Ks(?:\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska))|Перш[ае][\s\xa0]*Макаве(?:[ії]в)|Α['ʹʹ΄’][\s\xa0]*Μακκ)|(?:المكابين[\s\xa0]*الأول|Wamakabayo[\s\xa0]*I|Maccabees|מקבים[\s\xa0]*א|1[\s\xa0]*makk|《瑪加伯上|瑪加伯上》?))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["Mark"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:От[\\s\\xa0]*Марка[\\s\\xa0]*свето[\\s\\xa0]*Евангелие|《(?:馬(?:爾谷福音》|可福音》)|马可福音》|瑪爾克》|可》)|र्मक(?:ूस|स)|マルコ(?:による福音書|傳福音書|福音書|[伝書])|М(?:аркo?|[кр])|Јеванђеље[\\s\\xa0]*по[\\s\\xa0]*Марку|Vangelo[\\s\\xa0]*di[\\s\\xa0]*(?:San[\\s\\xa0]*Marco|Marco)|Μ(?:(?:[άα]ρκ(?:ος)?)|ρ)|ਮਰਕੁਸ[\\s\\xa0]*ਦੀ[\\s\\xa0]*ਇੰਜੀਲ|Κατ[άα][\\s\\xa0]*Μ(?:[άα]ρκον)|M(?:ā[rṛ]ku[\\s\\xa0]*Na(?:[rṛ]ceyti)|a(?:buting[\\s\\xa0]*Balita[\\s\\xa0]*ayon[\\s\\xa0]*kay[\\s\\xa0]*(?:San[\\s\\xa0]*Mar[ck]os|Mar[ck]os)|ṛku[\\s\\xa0]*Na[rṛ]ceyti|r(?:k(?:ovo[\\s\\xa0]*evangelium|úsarguðspjall|u(?:ksen[\\s\\xa0]*evankeliumi|s(?:[\\s\\xa0]*evangelium|arguðspjall|evangeliet)|[\\s\\xa0]*Na[rṛ]ceyti))|akus|ek|cu?))|rc(?:os)?|á(?:rk|c(?:cô)?)|c)|E(?:l[\\s\\xa0]*Evangelio[\\s\\xa0]*de[\\s\\xa0]*Marcos|banghelyo[\\s\\xa0]*(?:ayon[\\s\\xa0]*kay[\\s\\xa0]*Marcos|ni[\\s\\xa0]*(?:San[\\s\\xa0]*Mar[ck]os|Mar[ck]os))|van(?:keliumi[\\s\\xa0]*Markuksen[\\s\\xa0]*mukaan|geli(?:e(?:[\\s\\xa0]*volgens[\\s\\xa0]*Mar[ck]us|t[\\s\\xa0]*etter[\\s\\xa0]*Markus)|um[\\s\\xa0]*(?:secundum[\\s\\xa0]*Marcum|podle[\\s\\xa0]*Marka))|jelium[\\s\\xa0]*Pod[lľ]a[\\s\\xa0]*Marka|[ðđ]elje[\\s\\xa0]*po[\\s\\xa0]*Marku)|w(?:angelia[\\s\\xa0]*(?:w(?:edług[\\s\\xa0]*(?:[sś]w(?:\\.[\\s\\xa0]*Marka|[\\s\\xa0]*Marka))|g[\\s\\xa0]*(?:[sś]w(?:\\.[\\s\\xa0]*Marka|[\\s\\xa0]*Marka)))|Marka)|\\.[\\s\\xa0]*Marka|[\\s\\xa0]*Mar(?:ka)?))|مر(?:ق(?:ُس[\\s\\xa0]*کی[\\s\\xa0]*انجیل|س[\\s\\xa0]*کی[\\s\\xa0]*انجیل))?|Євангелі(?:[яє][\\s\\xa0]*від[\\s\\xa0]*(?:св(?:\\.[\\s\\xa0]*Марка|[\\s\\xa0]*Марка)|Марка))|ม(?:าระโก|ก)|ମାର୍କ[\\s\\xa0]*ଲିଖିତ[\\s\\xa0]*ସୁସମାଗ୍ଭର|m(?:ārk[aā]ne[\\s\\xa0]*lihilele[\\s\\xa0]*(?:[sŝ]ubʰavartam(?:[aā]n))|ar(?:qus[\\s\\xa0]*kī[\\s\\xa0]*injīl|k(?:[aā]ne[\\s\\xa0]*lihilele[\\s\\xa0]*(?:[sŝ]ubʰavartam(?:[aā]n))|ūsle[\\s\\xa0]*lekʰeko[\\s\\xa0]*susm[aā]c(?:[aā]r)|us(?:le[\\s\\xa0]*lekʰeko[\\s\\xa0]*susm[aā]c(?:[aā]r)|[\\s\\xa0]*dī[\\s\\xa0]*ĩjīl))))|Еван(?:гелие(?:то[\\s\\xa0]*според[\\s\\xa0]*Марко|[\\s\\xa0]*(?:според[\\s\\xa0]*Марко|от[\\s\\xa0]*Марк[ао]))|ђеље[\\s\\xa0]*по[\\s\\xa0]*Марку)|พระวรสารนักบุญมาร์ค|마(?:가(?:복음서?)?|르(?:코[\\s\\xa0]*복음서?)?)|Injil(?:i[\\s\\xa0]*ya[\\s\\xa0]*Marko|[\\s\\xa0]*Markus)|म(?:र(?:्क(?:ुस|ू(?:श|स(?:ले[\\s\\xa0]*लेखेको[\\s\\xa0]*सुसमाचार|को[\\s\\xa0]*सुसमाचार)?))|कुस)|ार्क(?:ाने[\\s\\xa0]*लिहिलेले[\\s\\xa0]*शुभवर्तमान)?)|Sulat[\\s\\xa0]*ni[\\s\\xa0]*San[\\s\\xa0]*Marcos|The[\\s\\xa0]*Gospel[\\s\\xa0]*(?:according[\\s\\xa0]*to[\\s\\xa0]*(?:S(?:aint[\\s\\xa0]*M(?:ark?|k|rk?)|t(?:\\.[\\s\\xa0]*M(?:ark?|k|rk?)|[\\s\\xa0]*M(?:ark?|k|rk?)))|M(?:ark?|k|rk?))|of[\\s\\xa0]*(?:S(?:aint[\\s\\xa0]*M(?:ark?|k|rk?)|t(?:\\.[\\s\\xa0]*M(?:ark?|k|rk?)|[\\s\\xa0]*M(?:ark?|k|rk?)))|M(?:ark?|k|rk?)))|Jevan(?:helije[\\s\\xa0]*vid[\\s\\xa0]*Marka|đelje[\\s\\xa0]*po[\\s\\xa0]*Marku)|Ungjilli[\\s\\xa0]*i[\\s\\xa0]*Markut|மாற்(?:கு[\\s\\xa0]*(?:எழுதிய[\\s\\xa0]*(?:சுவிசேஷம்|நற்செய்தி)|நற்செய்தி))?|إنجيل[\\s\\xa0]*مرقس|הבשורה[\\s\\xa0]*על[\\s\\xa0\\-?]*פי[\\s\\xa0]*מרקוס)|Marcos|mark(?:usle|ane)|(?:《(?:马可福音|馬(?:爾谷福音|可福音)|瑪爾克|可)|可》|Gospel[\\s\\xa0]*(?:according[\\s\\xa0]*to[\\s\\xa0]*(?:S(?:aint[\\s\\xa0]*M(?:ark?|k|rk?)|t(?:\\.[\\s\\xa0]*M(?:ark?|rk?|k)|[\\s\\xa0]*M(?:ark?|k|rk?)))|M(?:ark?|rk?|k))|of[\\s\\xa0]*(?:S(?:aint[\\s\\xa0]*M(?:ark?|rk?|k)|t(?:\\.[\\s\\xa0]*M(?:ark?|rk?|k)|[\\s\\xa0]*M(?:ark?|k|rk?)))|M(?:ark?|k|rk?)))|瑪爾克》|M(?:ā[rṛ]ku|a(?:ṛku|r(?:c(?:us|o)|k(?:a|os?|u(?:ksen|s)?))))|Evangelio[\\s\\xa0]*de[\\s\\xa0]*Marcos|От[\\s\\xa0]*Марка|مرقس|மாற்கு|馬(?:爾谷福音》|可福音》)|m(?:ārk[aā]ne|ark(?:ūsle|āne))|Марко|San[\\s\\xa0]*Marcos|म(?:र्कूसले|ार्काने)|ਮਰਕੁਸ|Від[\\s\\xa0]*Марка|马可福音》|ମାର୍କ)|(?:markus|Марка|S(?:aint[\\s\\xa0]*M(?:ark?|rk?|k)|t(?:\\.[\\s\\xa0]*M(?:ark?|k|rk?)|[\\s\\xa0]*M(?:ark?|rk?|k)))|馬(?:爾谷福音|可福音)|马可福音|瑪爾克|M(?:ark?|k|rk?)|可))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Jas"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:யாக(?:ப்பர்[\\s\\xa0]*திருமுகம்|்(?:கோபு[\\s\\xa0]*(?:எழுதிய[\\s\\xa0]*(?:திருமுகம்|நிருபம்|கடிதம்)|திருமுகம்))?)|T(?:iago|g)|Hið[\\s\\xa0]*almenna[\\s\\xa0]*br[eé]f[\\s\\xa0]*Jakobs|《(?:亞适烏》|雅(?:各(?:伯書》|[书書]》)|》))|Epistula[\\s\\xa0]*Iacobi|ਯਾਕੂਬ[\\s\\xa0]*ਦੀ[\\s\\xa0]*ਪੱਤ੍ਰੀ|ย(?:ากอบ|[กบ])|Waraka[\\s\\xa0]*wa[\\s\\xa0]*Yakobo|Иак|Barua[\\s\\xa0]*ya[\\s\\xa0]*Yakobo|᾿Ια|يع|رسالة[\\s\\xa0]*(?:القديس[\\s\\xa0]*يعقوب|يعقوب)|G(?:ia(?:côbê|-?cơ)|[cm])|Ia(?:c(?:o[bv])?|go?)|Poslannja[\\s\\xa0]*apostola[\\s\\xa0]*Jakova|J(?:a(?:ques|ak(?:obin[\\s\\xa0]*kirje)?|c(?:obo|q(?:ues)?)?|k(?:ab|o(?:vljeva[\\s\\xa0]*poslanica|b(?:s(?:br(?:e(?:fið|vet)|éfið)|[\\s\\xa0]*(?:epistel|Brev))|us(?:brief)?|it?)?)|ub(?:ov[\\s\\xa0]*List)?)?|m(?:es?)?|s)?|k|ms?)|א(?:יגרת[\\s\\xa0]*יעקב|גרת[\\s\\xa0]*יעקב)|L(?:ettera[\\s\\xa0]*di[\\s\\xa0]*Giacomo|ayang[\\s\\xa0]*Yakobus|ist[\\s\\xa0]*(?:powszechny[\\s\\xa0]*[SŚ]wi(?:[eę]tego[\\s\\xa0]*Iakuba[\\s\\xa0]*Apostoła)|(?:[sś]w(?:\\.[\\s\\xa0]*Jakuba|[\\s\\xa0]*Jakuba))|Jakub(?:[uů]v|a)))|Ιακ[ωώ]βου|ヤコ(?:[フブ](?:からの手紙|の(?:手紙|書)|書)?)|야고(?:보(?:[\\s\\xa0]*서간|서))?|С(?:ъборно[\\s\\xa0]*послание[\\s\\xa0]*на[\\s\\xa0]*св(?:\\.[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Иакова|[\\s\\xa0]*Иакова)|[\\s\\xa0]*ап(?:\\.[\\s\\xa0]*Иакова|[\\s\\xa0]*Иакова))|оборне[\\s\\xa0]*послання[\\s\\xa0]*(?:св(?:\\.[\\s\\xa0]*апостола[\\s\\xa0]*Якова|[\\s\\xa0]*апостола[\\s\\xa0]*Якова)|Якова))|याक(?:ूब(?:को[\\s\\xa0]*पत्र)?|ोब(?:ाचें[\\s\\xa0]*पत्र)?)|Јак(?:овова)?|y(?:a(?:ʿqūb[\\s\\xa0]*kā[\\s\\xa0]*ʿām[\\s\\xa0]*ḫaṭ|k(?:ob[aā]ce(?:[mṃ][\\s\\xa0]*patra)|[uū]bko[\\s\\xa0]*patra))|āk(?:ob[aā]ce(?:[mṃ][\\s\\xa0]*patra)|ubko[\\s\\xa0]*patra|ūb(?:[\\s\\xa0]*dī[\\s\\xa0]*pattrī|ko[\\s\\xa0]*patra)))|یعق(?:ُوب[\\s\\xa0]*کا[\\s\\xa0]*عام[\\s\\xa0]*خط|وب[\\s\\xa0]*کا[\\s\\xa0]*عا(?:[\\s\\xa0]*م[\\s\\xa0]*خط|م[\\s\\xa0]*خط))|S(?:an(?:t(?:iago)?)?|tg?)|П(?:исмо[\\s\\xa0]*од[\\s\\xa0]*апостол[\\s\\xa0]*Јаков|ослан(?:ня[\\s\\xa0]*апостола[\\s\\xa0]*Якова|и(?:ца[\\s\\xa0]*Јаковљева|е[\\s\\xa0]*(?:на[\\s\\xa0]*(?:апостол[\\s\\xa0]*Јаков|Яков)|Иакова))))|ଯାକୁବଙ୍କ[\\s\\xa0]*ପତ୍ର|Як(?:уб)?|Y(?:ākk[oō]pu[\\s\\xa0]*E(?:[lḻ]utiya[\\s\\xa0]*Nirupam)|a(?:c(?:q(?:uub)?)?|k(?:k[oō]pu[\\s\\xa0]*E(?:[lḻ]utiya[\\s\\xa0]*Nirupam)|oob)?)))|(?:Giacomo|याक(?:ोबाचें|ूबको)|Иакова|யாக்கோபு|Ja(?:akobin|k(?:o(?:vljeva|bs(?:[\\s\\xa0]*brev)?)|ub(?:ov|a)))|يعقوب|Якова?|y(?:ak(?:ob[āa]ce[mṃ]|[uū]bko)|āk(?:ob[aā]ce[mṃ]|ubko|ūb(?:ko)?))|ਯਾਕੂਬ|Y(?:ākk[oō]pu|ak(?:k[oō]pu|ob(?:us|o)))|ଯାକୁବଙ୍କ|雅(?:各(?:伯書》?|[書书]》?)|》)?|یعق(?:ُوب|وب)|Iacobi|Послання[\\s\\xa0]*Якова|Јаков(?:љева)?|亞适烏》?|《(?:亞适烏|雅(?:各(?:伯書|[書书]))?)))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Amos"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:अमोस|ਆਮੋਸ|आमोस(?:को[\\s\\xa0]*पुस्तक)?|《(?:阿摩司[书書]》|亞毛斯》|摩》)|Ám(?:osz?|ós)?|עמוס|아모(?:스서?)?|Ks(?:i[eę]g(?:[ai][\\s\\xa0]*Amosa)|\\.[\\s\\xa0]*Amosa|[\\s\\xa0]*Amosa)|ஆமோ(?:ஸ்)?|アモス(?:しょ|書)?|Книга[\\s\\xa0]*(?:на[\\s\\xa0]*пророк[\\s\\xa0]*Амоса?|пророка[\\s\\xa0]*Амоса)|A(?:-?mốt|am(?:oksen[\\s\\xa0]*kirja)?|m(?:ōs|o(?:s(?:(?:['’][\\s\\xa0]*(?:Bog|bok))|[iz]))?|s|ós?)?)|عا(?:مُوس)?|อ(?:าโมส|มส)|Ἀμ|Ам|سفر[\\s\\xa0]*عاموس|Caam(?:oos)?|암|Liv[\\s\\xa0]*Am[oò]s[\\s\\xa0]*la|Ām[oō]s|ଆମୋଷ[\\s\\xa0]*ଭବିଷ୍ୟ‌ଦ୍‌ବକ୍ତାଙ୍କ[\\s\\xa0]*ପୁସ୍ତକ|ʿāmōs|Αμ(?:[ωώ]ς)?|Prophetia[\\s\\xa0]*Amos)|(?:摩》?|عاموس|亞毛斯》?|A(?:amoksen|m(?:òs|osa?))|阿摩司[書书]》?|[aā]mos|ଆମୋଷ|Амоса?|《(?:阿摩司[書书]|亞毛斯|摩)))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Tob"],
        apocrypha: true,
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:《多俾亞傳》|T(?:ho|ob(?:í(?:tsb[oó]k|as?)|i(?:olo|j(?:á[sš]|a[sš]?)|t(?:s(?:[\\s\\xa0]*(?:Bog|bok)|b[oó]k)|i(?:n[\\s\\xa0]*kirja)?)|á[sš]|a(?:an[\\s\\xa0]*kirja|n[\\s\\xa0]*kirja|s['’][\\s\\xa0]*bok|š)?|e)?|t)?|ób(?:ítsb[oó]k|i(?:j[aá][sš]|[aá]s|t(?:sb[oó]k)?))?|b)|טוביה|Cartea[\\s\\xa0]*lui[\\s\\xa0]*Tobit|Liber[\\s\\xa0]*T(?:hobis|obiae)|ト[ヒビ]ト[書記]?|То(?:бија|в)|த(?:ொபியாசு[\\s\\xa0]*ஆகமம்|ோபி(?:த்து)?)|К(?:њига[\\s\\xa0]*Товијина|нига[\\s\\xa0]*(?:за[\\s\\xa0]*Тобия|на[\\s\\xa0]*Товита?|Товита))|โทบิต|토(?:비트|빗기?)|طو|سفر[\\s\\xa0]*طوبيا|Τωβ(?:[ίι]τ)?|Ks(?:i(?:[eę]g(?:[ai][\\s\\xa0]*Tobi(?:asza|ta)))|\\.[\\s\\xa0]*Tobi(?:asza|ta)|[\\s\\xa0]*Tobi(?:asza|ta)))|(?:طوبيا|Tobi(?:a(?:an|[esn])|t(?:in)?)|То(?:вита?|бия)|《多俾亞傳|多俾亞傳》?))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Jdt"],
        apocrypha: true,
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:Yud(?:it(?:hi?|i)|t)|K(?:niha[\\s\\xa0]*Juditina|\\.[\\s\\xa0]*Juditina|itab[\\s\\xa0]*Yudit|[\\s\\xa0]*Juditina|s(?:i[eę]g(?:[ai][\\s\\xa0]*Judyty)|\\.[\\s\\xa0]*Judyty|[\\s\\xa0]*Judyty))|ยูดิธ|ユ(?:[テデ](?:ィト記?|ト書))|J(?:ud(?:ítarb[oó]k|it(?:in[\\s\\xa0]*kirja|s[\\s\\xa0]*(?:Bog|bok)|a(?:rb[oó]k)?|[eh])?|th?)|úd(?:ítarb[oó]k|it(?:arb[oó]k)?|t)|d(?:ith?|th?))|Юди(?:фь)?|Јуд(?:ита)?|유딧기?|Ι(?:ουδ[ίι]θ|δθ)|《友弟德傳》|سفر[\\s\\xa0]*يهوديت|யூதி(?:த்து)?|Liber[\\s\\xa0]*Iudith|I(?:udita|dt)|יהודית|G(?:iuditta|dt)|К(?:њига[\\s\\xa0]*о[\\s\\xa0]*Јудити|нига[\\s\\xa0]*(?:за[\\s\\xa0]*Юдита|Иудит|Юдити))|يـه)|(?:يهوديت|Iudith|Jud(?:itin|yty)|Юдити|Yudit|Иудит|《友弟德傳|友弟德傳》?))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Bar"],
        apocrypha: true,
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:Книга[\\s\\xa0]*(?:пророка[\\s\\xa0]*Вару́ха|на[\\s\\xa0]*(?:пророк[\\s\\xa0]*Варуха|Барух)|Варуха)|با(?:روك)?|K(?:niha[\\s\\xa0]*B(?:[aá]ru(?:chova|kova))|itab[\\s\\xa0]*Barukh|s(?:i[eę]g(?:[ai][\\s\\xa0]*Barucha)|\\.[\\s\\xa0]*Barucha|[\\s\\xa0]*Barucha))|Вар(?:ух)?|Proroctvo[\\s\\xa0]*Baruchovo|ワルフの預言書|บารุค|Бару́ха|พระธรรมบารุค|Β(?:αρ(?:ο[υύ]χ)?|ρ)|바룩서?|سفر[\\s\\xa0]*باروخ|ספר[\\s\\xa0]*ברוך|《巴路克》|B(?:ár(?:u(?:ch|k))?|a(?:arukin[\\s\\xa0]*kirja|r(?:úksb[oó]k|u(?:que|[ch]|k(?:in[\\s\\xa0]*kirja|s(?:[\\s\\xa0]*(?:Bog|bok)|b[oó]k)|u)?))?)?|r)|பாரூ(?:க்கு)?|Liber[\\s\\xa0]*Baruch|[バハ]ルク書?)|(?:Варуха|Ba(?:arukin|ru(?:k(?:in|h)|cha?))|Барух|《巴路克|ברוך|巴路克》?))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["1Kgs"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])((?:1(?:\.[\s\xa0]*(?:Ks|Re)|[\s\xa0]*(?:Ks|Re))|I(?:\.[\s\xa0]*Ks|[\s\xa0]*Ks)))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["2Kgs"],
        regexp: /(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])((?:II(?:\.[\s\xa0]*Ks|[\s\xa0]*Ks)|2(?:\.[\s\xa0]*(?:Ks|Re)|[\s\xa0]*(?:Ks|Re))))(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]\/"'\*=~\-\u2013\u2014])|$)/gi
      }, {
        osis: ["Acts"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Апостол)(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Ezek", "Ezra"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:Ez|Ез))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Ezra"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(拉)(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Hab", "Hag"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Ha)(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Heb", "Hab"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Hb)(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Job"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(伯)(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["John"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:Jan|約))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["John", "Jonah"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Yn)(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["John", "Jonah", "Job", "Josh", "Joel"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Jo)(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["John", "Josh", "Joel", "Jonah"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(யோ)(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Jonah", "Joel"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Yoo)(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Josh"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(書)(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Jude", "Judg"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(J(?:d|ud?))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Lam"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(La)(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Lev"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(利)(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Matt"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(太)(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Matt", "Mark", "Mal"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Ma)(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Mic"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Mi)(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Phil", "Phlm"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:Fil|Phl?))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Rev"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Re)(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Song"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")((?:Songs|歌))(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }, {
        osis: ["Zeph", "Zech"],
        regexp: RegExp("(^|" + bcv_parser.prototype.regexps.pre_book + ")(Ze)(?:(?=[\\d\\s\\xa0.:,;\\x1e\\x1f&\\(\\)（）\\[\\]/\"'\\*=~\\-\\u2013\\u2014])|$)", "gi")
      }
    ];
    if (include_apocrypha === true && case_sensitive === "none") {
      return books;
    }
    out = [];
    for (k = 0, len = books.length; k < len; k++) {
      book = books[k];
      if (include_apocrypha === false && (book.apocrypha != null) && book.apocrypha === true) {
        continue;
      }
      if (case_sensitive === "books") {
        book.regexp = new RegExp(book.regexp.source, "g");
      }
      out.push(book);
    }
    return out;
  };

  bcv_parser.prototype.regexps.books = bcv_parser.prototype.regexps.get_books(false, "none");
var grammar = (function() {
  /*
   * Generated by PEG.js 0.8.0.
   *
   * http://pegjs.majda.cz/
   */

  function peg$subclass(child, parent) {
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor();
  }

  function SyntaxError(message, expected, found, offset, line, column) {
    this.message  = message;
    this.expected = expected;
    this.found    = found;
    this.offset   = offset;
    this.line     = line;
    this.column   = column;

    this.name     = "SyntaxError";
  }

  peg$subclass(SyntaxError, Error);

  function parse(input) {
    var options = arguments.length > 1 ? arguments[1] : {},

        peg$FAILED = {},

        peg$startRuleFunctions = { start: peg$parsestart },
        peg$startRuleFunction  = peg$parsestart,

        peg$c0 = [],
        peg$c1 = peg$FAILED,
        peg$c2 = null,
        peg$c3 = function(val_1, val_2) { val_2.unshift([val_1]); return {"type": "sequence", "value": val_2, "indices": [offset(), peg$currPos - 1]} },
        peg$c4 = "(",
        peg$c5 = { type: "literal", value: "(", description: "\"(\"" },
        peg$c6 = ")",
        peg$c7 = { type: "literal", value: ")", description: "\")\"" },
        peg$c8 = function(val_1, val_2) { if (typeof(val_2) === "undefined") val_2 = []; val_2.unshift([val_1]); return {"type": "sequence_post_enclosed", "value": val_2, "indices": [offset(), peg$currPos - 1]} },
        peg$c9 = void 0,
        peg$c10 = function(val_1, val_2) { if (val_1.length && val_1.length === 2) val_1 = val_1[0]; // for `b`, which returns [object, undefined]
              return {"type": "range", "value": [val_1, val_2], "indices": [offset(), peg$currPos - 1]} },
        peg$c11 = "\x1F",
        peg$c12 = { type: "literal", value: "\x1F", description: "\"\\x1F\"" },
        peg$c13 = "/",
        peg$c14 = { type: "literal", value: "/", description: "\"/\"" },
        peg$c15 = /^[1-8]/,
        peg$c16 = { type: "class", value: "[1-8]", description: "[1-8]" },
        peg$c17 = function(val) { return {"type": "b", "value": val.value, "indices": [offset(), peg$currPos - 1]} },
        peg$c18 = function(val_1, val_2) { return {"type": "bc", "value": [val_1, val_2], "indices": [offset(), peg$currPos - 1]} },
        peg$c19 = ",",
        peg$c20 = { type: "literal", value: ",", description: "\",\"" },
        peg$c21 = function(val_1, val_2) { return {"type": "bc_title", "value": [val_1, val_2], "indices": [offset(), peg$currPos - 1]} },
        peg$c22 = ".",
        peg$c23 = { type: "literal", value: ".", description: "\".\"" },
        peg$c24 = function(val_1, val_2) { return {"type": "bcv", "value": [val_1, val_2], "indices": [offset(), peg$currPos - 1]} },
        peg$c25 = "-",
        peg$c26 = { type: "literal", value: "-", description: "\"-\"" },
        peg$c27 = function(val_1, val_2, val_3, val_4) { return {"type": "range", "value": [{"type": "bcv", "value": [{"type": "bc", "value": [val_1, val_2], "indices": [val_1.indices[0], val_2.indices[1]]}, val_3], "indices": [val_1.indices[0], val_3.indices[1]]}, val_4], "indices": [offset(), peg$currPos - 1]} },
        peg$c28 = function(val_1, val_2) { return {"type": "bv", "value": [val_1, val_2], "indices": [offset(), peg$currPos - 1]} },
        peg$c29 = function(val_1, val_2) { return {"type": "bc", "value": [val_2, val_1], "indices": [offset(), peg$currPos - 1]} },
        peg$c30 = function(val_1, val_2, val_3) { return {"type": "cb_range", "value": [val_3, val_1, val_2], "indices": [offset(), peg$currPos - 1]} },
        peg$c31 = "th",
        peg$c32 = { type: "literal", value: "th", description: "\"th\"" },
        peg$c33 = "nd",
        peg$c34 = { type: "literal", value: "nd", description: "\"nd\"" },
        peg$c35 = "st",
        peg$c36 = { type: "literal", value: "st", description: "\"st\"" },
        peg$c37 = "/1\x1F",
        peg$c38 = { type: "literal", value: "/1\x1F", description: "\"/1\\x1F\"" },
        peg$c39 = function(val) { return {"type": "c_psalm", "value": val.value, "indices": [offset(), peg$currPos - 1]} },
        peg$c40 = function(val_1, val_2) { return {"type": "cv_psalm", "value": [val_1, val_2], "indices": [offset(), peg$currPos - 1]} },
        peg$c41 = function(val_1, val_2) { return {"type": "c_title", "value": [val_1, val_2], "indices": [offset(), peg$currPos - 1]} },
        peg$c42 = function(val_1, val_2) { return {"type": "cv", "value": [val_1, val_2], "indices": [offset(), peg$currPos - 1]} },
        peg$c43 = function(val) { return {"type": "c", "value": [val], "indices": [offset(), peg$currPos - 1]} },
        peg$c44 = "ff",
        peg$c45 = { type: "literal", value: "ff", description: "\"ff\"" },
        peg$c46 = /^[a-z0-9]/,
        peg$c47 = { type: "class", value: "[a-z0-9]", description: "[a-z0-9]" },
        peg$c48 = "f",
        peg$c49 = { type: "literal", value: "f", description: "\"f\"" },
        peg$c50 = /^[a-z]/,
        peg$c51 = { type: "class", value: "[a-z]", description: "[a-z]" },
        peg$c52 = function(val_1) { return {"type": "ff", "value": [val_1], "indices": [offset(), peg$currPos - 1]} },
        peg$c53 = "title",
        peg$c54 = { type: "literal", value: "title", description: "\"title\"" },
        peg$c55 = function(val_1) { return {"type": "integer_title", "value": [val_1], "indices": [offset(), peg$currPos - 1]} },
        peg$c56 = "/9\x1F",
        peg$c57 = { type: "literal", value: "/9\x1F", description: "\"/9\\x1F\"" },
        peg$c58 = function(val) { return {"type": "context", "value": val.value, "indices": [offset(), peg$currPos - 1]} },
        peg$c59 = "/2\x1F",
        peg$c60 = { type: "literal", value: "/2\x1F", description: "\"/2\\x1F\"" },
        peg$c61 = ".1",
        peg$c62 = { type: "literal", value: ".1", description: "\".1\"" },
        peg$c63 = /^[0-9]/,
        peg$c64 = { type: "class", value: "[0-9]", description: "[0-9]" },
        peg$c65 = function(val) { return {"type": "bc", "value": [val, {"type": "c", "value": [{"type": "integer", "value": 151, "indices": [peg$currPos - 2, peg$currPos - 1]}], "indices": [peg$currPos - 2, peg$currPos - 1]}], "indices": [offset(), peg$currPos - 1]} },
        peg$c66 = function(val_1, val_2) { return {"type": "bcv", "value": [val_1, {"type": "v", "value": [val_2], "indices": [val_2.indices[0], val_2.indices[1]]}], "indices": [offset(), peg$currPos - 1]} },
        peg$c67 = /^[a-e]/,
        peg$c68 = { type: "class", value: "[a-e]", description: "[a-e]" },
        peg$c69 = function(val) { return {"type": "v", "value": [val], "indices": [offset(), peg$currPos - 1]} },
        peg$c70 = "chapters",
        peg$c71 = { type: "literal", value: "chapters", description: "\"chapters\"" },
        peg$c72 = "chapter",
        peg$c73 = { type: "literal", value: "chapter", description: "\"chapter\"" },
        peg$c74 = "chapts",
        peg$c75 = { type: "literal", value: "chapts", description: "\"chapts\"" },
        peg$c76 = "chpts",
        peg$c77 = { type: "literal", value: "chpts", description: "\"chpts\"" },
        peg$c78 = "chapt",
        peg$c79 = { type: "literal", value: "chapt", description: "\"chapt\"" },
        peg$c80 = "chaps",
        peg$c81 = { type: "literal", value: "chaps", description: "\"chaps\"" },
        peg$c82 = "chap",
        peg$c83 = { type: "literal", value: "chap", description: "\"chap\"" },
        peg$c84 = "chp",
        peg$c85 = { type: "literal", value: "chp", description: "\"chp\"" },
        peg$c86 = "chs",
        peg$c87 = { type: "literal", value: "chs", description: "\"chs\"" },
        peg$c88 = "cha",
        peg$c89 = { type: "literal", value: "cha", description: "\"cha\"" },
        peg$c90 = "ch",
        peg$c91 = { type: "literal", value: "ch", description: "\"ch\"" },
        peg$c92 = function() { return {"type": "c_explicit"} },
        peg$c93 = "verses",
        peg$c94 = { type: "literal", value: "verses", description: "\"verses\"" },
        peg$c95 = "verse",
        peg$c96 = { type: "literal", value: "verse", description: "\"verse\"" },
        peg$c97 = "ver",
        peg$c98 = { type: "literal", value: "ver", description: "\"ver\"" },
        peg$c99 = "vss",
        peg$c100 = { type: "literal", value: "vss", description: "\"vss\"" },
        peg$c101 = "vs",
        peg$c102 = { type: "literal", value: "vs", description: "\"vs\"" },
        peg$c103 = "vv",
        peg$c104 = { type: "literal", value: "vv", description: "\"vv\"" },
        peg$c105 = "v",
        peg$c106 = { type: "literal", value: "v", description: "\"v\"" },
        peg$c107 = function() { return {"type": "v_explicit"} },
        peg$c108 = /^["']/,
        peg$c109 = { type: "class", value: "[\"']", description: "[\"']" },
        peg$c110 = /^[;\/:&\-\u2013\u2014~]/,
        peg$c111 = { type: "class", value: "[;\\/:&\\-\\u2013\\u2014~]", description: "[;\\/:&\\-\\u2013\\u2014~]" },
        peg$c112 = "and",
        peg$c113 = { type: "literal", value: "and", description: "\"and\"" },
        peg$c114 = "compare",
        peg$c115 = { type: "literal", value: "compare", description: "\"compare\"" },
        peg$c116 = "cf",
        peg$c117 = { type: "literal", value: "cf", description: "\"cf\"" },
        peg$c118 = "see",
        peg$c119 = { type: "literal", value: "see", description: "\"see\"" },
        peg$c120 = "also",
        peg$c121 = { type: "literal", value: "also", description: "\"also\"" },
        peg$c122 = function() { return "" },
        peg$c123 = /^[\-\u2013\u2014]/,
        peg$c124 = { type: "class", value: "[\\-\\u2013\\u2014]", description: "[\\-\\u2013\\u2014]" },
        peg$c125 = "through",
        peg$c126 = { type: "literal", value: "through", description: "\"through\"" },
        peg$c127 = "thru",
        peg$c128 = { type: "literal", value: "thru", description: "\"thru\"" },
        peg$c129 = "to",
        peg$c130 = { type: "literal", value: "to", description: "\"to\"" },
        peg$c131 = function(val) { return {type:"title", value: [val], "indices": [offset(), peg$currPos - 1]} },
        peg$c132 = "from",
        peg$c133 = { type: "literal", value: "from", description: "\"from\"" },
        peg$c134 = "of",
        peg$c135 = { type: "literal", value: "of", description: "\"of\"" },
        peg$c136 = "in",
        peg$c137 = { type: "literal", value: "in", description: "\"in\"" },
        peg$c138 = "the",
        peg$c139 = { type: "literal", value: "the", description: "\"the\"" },
        peg$c140 = "book",
        peg$c141 = { type: "literal", value: "book", description: "\"book\"" },
        peg$c142 = /^[([]/,
        peg$c143 = { type: "class", value: "[([]", description: "[([]" },
        peg$c144 = /^[)\]]/,
        peg$c145 = { type: "class", value: "[)\\]]", description: "[)\\]]" },
        peg$c146 = function(val) { return {"type": "translation_sequence", "value": val, "indices": [offset(), peg$currPos - 1]} },
        peg$c147 = "\x1E",
        peg$c148 = { type: "literal", value: "\x1E", description: "\"\\x1E\"" },
        peg$c149 = function(val) { return {"type": "translation", "value": val.value, "indices": [offset(), peg$currPos - 1]} },
        peg$c150 = ",000",
        peg$c151 = { type: "literal", value: ",000", description: "\",000\"" },
        peg$c152 = function(val) { return {"type": "integer", "value": parseInt(val.join(""), 10), "indices": [offset(), peg$currPos - 1]} },
        peg$c153 = /^[^\x1F\x1E([]/,
        peg$c154 = { type: "class", value: "[^\\x1F\\x1E([]", description: "[^\\x1F\\x1E([]" },
        peg$c155 = function(val) { return {"type": "word", "value": val.join(""), "indices": [offset(), peg$currPos - 1]} },
        peg$c156 = function(val) { return {"type": "stop", "value": val, "indices": [offset(), peg$currPos - 1]} },
        peg$c157 = /^[\s\xa0*]/,
        peg$c158 = { type: "class", value: "[\\s\\xa0*]", description: "[\\s\\xa0*]" },

        peg$currPos          = 0,
        peg$reportedPos      = 0,
        peg$cachedPos        = 0,
        peg$cachedPosDetails = { line: 1, column: 1, seenCR: false },
        peg$maxFailPos       = 0,
        peg$maxFailExpected  = [],
        peg$silentFails      = 0,

        peg$result;

    if ("startRule" in options) {
      if (!(options.startRule in peg$startRuleFunctions)) {
        throw new Error("Can't start parsing from rule \"" + options.startRule + "\".");
      }

      peg$startRuleFunction = peg$startRuleFunctions[options.startRule];
    }

    function text() {
      return input.substring(peg$reportedPos, peg$currPos);
    }

    function offset() {
      return peg$reportedPos;
    }

    function line() {
      return peg$computePosDetails(peg$reportedPos).line;
    }

    function column() {
      return peg$computePosDetails(peg$reportedPos).column;
    }

    function expected(description) {
      throw peg$buildException(
        null,
        [{ type: "other", description: description }],
        peg$reportedPos
      );
    }

    function error(message) {
      throw peg$buildException(message, null, peg$reportedPos);
    }

    function peg$computePosDetails(pos) {
      function advance(details, startPos, endPos) {
        var p, ch;

        for (p = startPos; p < endPos; p++) {
          ch = input.charAt(p);
          if (ch === "\n") {
            if (!details.seenCR) { details.line++; }
            details.column = 1;
            details.seenCR = false;
          } else if (ch === "\r" || ch === "\u2028" || ch === "\u2029") {
            details.line++;
            details.column = 1;
            details.seenCR = true;
          } else {
            details.column++;
            details.seenCR = false;
          }
        }
      }

      if (peg$cachedPos !== pos) {
        if (peg$cachedPos > pos) {
          peg$cachedPos = 0;
          peg$cachedPosDetails = { line: 1, column: 1, seenCR: false };
        }
        advance(peg$cachedPosDetails, peg$cachedPos, pos);
        peg$cachedPos = pos;
      }

      return peg$cachedPosDetails;
    }

    function peg$fail(expected) {
      if (peg$currPos < peg$maxFailPos) { return; }

      if (peg$currPos > peg$maxFailPos) {
        peg$maxFailPos = peg$currPos;
        peg$maxFailExpected = [];
      }

      peg$maxFailExpected.push(expected);
    }

    function peg$buildException(message, expected, pos) {
      function cleanupExpected(expected) {
        var i = 1;

        expected.sort(function(a, b) {
          if (a.description < b.description) {
            return -1;
          } else if (a.description > b.description) {
            return 1;
          } else {
            return 0;
          }
        });

        while (i < expected.length) {
          if (expected[i - 1] === expected[i]) {
            expected.splice(i, 1);
          } else {
            i++;
          }
        }
      }

      function buildMessage(expected, found) {
        function stringEscape(s) {
          function hex(ch) { return ch.charCodeAt(0).toString(16).toUpperCase(); }

          return s
            .replace(/\\/g,   '\\\\')
            .replace(/"/g,    '\\"')
            .replace(/\x08/g, '\\b')
            .replace(/\t/g,   '\\t')
            .replace(/\n/g,   '\\n')
            .replace(/\f/g,   '\\f')
            .replace(/\r/g,   '\\r')
            .replace(/[\x00-\x07\x0B\x0E\x0F]/g, function(ch) { return '\\x0' + hex(ch); })
            .replace(/[\x10-\x1F\x80-\xFF]/g,    function(ch) { return '\\x'  + hex(ch); })
            .replace(/[\u0180-\u0FFF]/g,         function(ch) { return '\\u0' + hex(ch); })
            .replace(/[\u1080-\uFFFF]/g,         function(ch) { return '\\u'  + hex(ch); });
        }

        var expectedDescs = new Array(expected.length),
            expectedDesc, foundDesc, i;

        for (i = 0; i < expected.length; i++) {
          expectedDescs[i] = expected[i].description;
        }

        expectedDesc = expected.length > 1
          ? expectedDescs.slice(0, -1).join(", ")
              + " or "
              + expectedDescs[expected.length - 1]
          : expectedDescs[0];

        foundDesc = found ? "\"" + stringEscape(found) + "\"" : "end of input";

        return "Expected " + expectedDesc + " but " + foundDesc + " found.";
      }

      var posDetails = peg$computePosDetails(pos),
          found      = pos < input.length ? input.charAt(pos) : null;

      if (expected !== null) {
        cleanupExpected(expected);
      }

      return new SyntaxError(
        message !== null ? message : buildMessage(expected, found),
        expected,
        found,
        pos,
        posDetails.line,
        posDetails.column
      );
    }

    function peg$parsestart() {
      var s0, s1;

      s0 = [];
      s1 = peg$parsebcv_hyphen_range();
      if (s1 === peg$FAILED) {
        s1 = peg$parsesequence();
        if (s1 === peg$FAILED) {
          s1 = peg$parsecb_range();
          if (s1 === peg$FAILED) {
            s1 = peg$parserange();
            if (s1 === peg$FAILED) {
              s1 = peg$parseff();
              if (s1 === peg$FAILED) {
                s1 = peg$parsebcv_comma();
                if (s1 === peg$FAILED) {
                  s1 = peg$parsebc_title();
                  if (s1 === peg$FAILED) {
                    s1 = peg$parseps151_bcv();
                    if (s1 === peg$FAILED) {
                      s1 = peg$parsebcv();
                      if (s1 === peg$FAILED) {
                        s1 = peg$parsebcv_weak();
                        if (s1 === peg$FAILED) {
                          s1 = peg$parseps151_bc();
                          if (s1 === peg$FAILED) {
                            s1 = peg$parsebc();
                            if (s1 === peg$FAILED) {
                              s1 = peg$parsecv_psalm();
                              if (s1 === peg$FAILED) {
                                s1 = peg$parsebv();
                                if (s1 === peg$FAILED) {
                                  s1 = peg$parsec_psalm();
                                  if (s1 === peg$FAILED) {
                                    s1 = peg$parseb();
                                    if (s1 === peg$FAILED) {
                                      s1 = peg$parsecbv();
                                      if (s1 === peg$FAILED) {
                                        s1 = peg$parsecbv_ordinal();
                                        if (s1 === peg$FAILED) {
                                          s1 = peg$parsecb();
                                          if (s1 === peg$FAILED) {
                                            s1 = peg$parsecb_ordinal();
                                            if (s1 === peg$FAILED) {
                                              s1 = peg$parsetranslation_sequence_enclosed();
                                              if (s1 === peg$FAILED) {
                                                s1 = peg$parsetranslation_sequence();
                                                if (s1 === peg$FAILED) {
                                                  s1 = peg$parsesequence_sep();
                                                  if (s1 === peg$FAILED) {
                                                    s1 = peg$parsec_title();
                                                    if (s1 === peg$FAILED) {
                                                      s1 = peg$parseinteger_title();
                                                      if (s1 === peg$FAILED) {
                                                        s1 = peg$parsecv();
                                                        if (s1 === peg$FAILED) {
                                                          s1 = peg$parsecv_weak();
                                                          if (s1 === peg$FAILED) {
                                                            s1 = peg$parsev_letter();
                                                            if (s1 === peg$FAILED) {
                                                              s1 = peg$parseinteger();
                                                              if (s1 === peg$FAILED) {
                                                                s1 = peg$parsec();
                                                                if (s1 === peg$FAILED) {
                                                                  s1 = peg$parsev();
                                                                  if (s1 === peg$FAILED) {
                                                                    s1 = peg$parseword();
                                                                    if (s1 === peg$FAILED) {
                                                                      s1 = peg$parseword_parenthesis();
                                                                      if (s1 === peg$FAILED) {
                                                                        s1 = peg$parsecontext();
                                                                      }
                                                                    }
                                                                  }
                                                                }
                                                              }
                                                            }
                                                          }
                                                        }
                                                      }
                                                    }
                                                  }
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
      if (s1 !== peg$FAILED) {
        while (s1 !== peg$FAILED) {
          s0.push(s1);
          s1 = peg$parsebcv_hyphen_range();
          if (s1 === peg$FAILED) {
            s1 = peg$parsesequence();
            if (s1 === peg$FAILED) {
              s1 = peg$parsecb_range();
              if (s1 === peg$FAILED) {
                s1 = peg$parserange();
                if (s1 === peg$FAILED) {
                  s1 = peg$parseff();
                  if (s1 === peg$FAILED) {
                    s1 = peg$parsebcv_comma();
                    if (s1 === peg$FAILED) {
                      s1 = peg$parsebc_title();
                      if (s1 === peg$FAILED) {
                        s1 = peg$parseps151_bcv();
                        if (s1 === peg$FAILED) {
                          s1 = peg$parsebcv();
                          if (s1 === peg$FAILED) {
                            s1 = peg$parsebcv_weak();
                            if (s1 === peg$FAILED) {
                              s1 = peg$parseps151_bc();
                              if (s1 === peg$FAILED) {
                                s1 = peg$parsebc();
                                if (s1 === peg$FAILED) {
                                  s1 = peg$parsecv_psalm();
                                  if (s1 === peg$FAILED) {
                                    s1 = peg$parsebv();
                                    if (s1 === peg$FAILED) {
                                      s1 = peg$parsec_psalm();
                                      if (s1 === peg$FAILED) {
                                        s1 = peg$parseb();
                                        if (s1 === peg$FAILED) {
                                          s1 = peg$parsecbv();
                                          if (s1 === peg$FAILED) {
                                            s1 = peg$parsecbv_ordinal();
                                            if (s1 === peg$FAILED) {
                                              s1 = peg$parsecb();
                                              if (s1 === peg$FAILED) {
                                                s1 = peg$parsecb_ordinal();
                                                if (s1 === peg$FAILED) {
                                                  s1 = peg$parsetranslation_sequence_enclosed();
                                                  if (s1 === peg$FAILED) {
                                                    s1 = peg$parsetranslation_sequence();
                                                    if (s1 === peg$FAILED) {
                                                      s1 = peg$parsesequence_sep();
                                                      if (s1 === peg$FAILED) {
                                                        s1 = peg$parsec_title();
                                                        if (s1 === peg$FAILED) {
                                                          s1 = peg$parseinteger_title();
                                                          if (s1 === peg$FAILED) {
                                                            s1 = peg$parsecv();
                                                            if (s1 === peg$FAILED) {
                                                              s1 = peg$parsecv_weak();
                                                              if (s1 === peg$FAILED) {
                                                                s1 = peg$parsev_letter();
                                                                if (s1 === peg$FAILED) {
                                                                  s1 = peg$parseinteger();
                                                                  if (s1 === peg$FAILED) {
                                                                    s1 = peg$parsec();
                                                                    if (s1 === peg$FAILED) {
                                                                      s1 = peg$parsev();
                                                                      if (s1 === peg$FAILED) {
                                                                        s1 = peg$parseword();
                                                                        if (s1 === peg$FAILED) {
                                                                          s1 = peg$parseword_parenthesis();
                                                                          if (s1 === peg$FAILED) {
                                                                            s1 = peg$parsecontext();
                                                                          }
                                                                        }
                                                                      }
                                                                    }
                                                                  }
                                                                }
                                                              }
                                                            }
                                                          }
                                                        }
                                                      }
                                                    }
                                                  }
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      } else {
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsesequence() {
      var s0, s1, s2, s3, s4, s5;

      s0 = peg$currPos;
      s1 = peg$parsecb_range();
      if (s1 === peg$FAILED) {
        s1 = peg$parsebcv_hyphen_range();
        if (s1 === peg$FAILED) {
          s1 = peg$parserange();
          if (s1 === peg$FAILED) {
            s1 = peg$parseff();
            if (s1 === peg$FAILED) {
              s1 = peg$parsebcv_comma();
              if (s1 === peg$FAILED) {
                s1 = peg$parsebc_title();
                if (s1 === peg$FAILED) {
                  s1 = peg$parseps151_bcv();
                  if (s1 === peg$FAILED) {
                    s1 = peg$parsebcv();
                    if (s1 === peg$FAILED) {
                      s1 = peg$parsebcv_weak();
                      if (s1 === peg$FAILED) {
                        s1 = peg$parseps151_bc();
                        if (s1 === peg$FAILED) {
                          s1 = peg$parsebc();
                          if (s1 === peg$FAILED) {
                            s1 = peg$parsecv_psalm();
                            if (s1 === peg$FAILED) {
                              s1 = peg$parsebv();
                              if (s1 === peg$FAILED) {
                                s1 = peg$parsec_psalm();
                                if (s1 === peg$FAILED) {
                                  s1 = peg$parseb();
                                  if (s1 === peg$FAILED) {
                                    s1 = peg$parsecbv();
                                    if (s1 === peg$FAILED) {
                                      s1 = peg$parsecbv_ordinal();
                                      if (s1 === peg$FAILED) {
                                        s1 = peg$parsecb();
                                        if (s1 === peg$FAILED) {
                                          s1 = peg$parsecb_ordinal();
                                          if (s1 === peg$FAILED) {
                                            s1 = peg$parsecontext();
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$currPos;
        s4 = peg$parsesequence_sep();
        if (s4 === peg$FAILED) {
          s4 = peg$c2;
        }
        if (s4 !== peg$FAILED) {
          s5 = peg$parsesequence_post();
          if (s5 !== peg$FAILED) {
            s4 = [s4, s5];
            s3 = s4;
          } else {
            peg$currPos = s3;
            s3 = peg$c1;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$c1;
        }
        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$currPos;
            s4 = peg$parsesequence_sep();
            if (s4 === peg$FAILED) {
              s4 = peg$c2;
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parsesequence_post();
              if (s5 !== peg$FAILED) {
                s4 = [s4, s5];
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$c1;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c1;
            }
          }
        } else {
          s2 = peg$c1;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c3(s1, s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsesequence_post_enclosed() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8;

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 40) {
        s1 = peg$c4;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c5); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parsesp();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsesequence_sep();
          if (s3 === peg$FAILED) {
            s3 = peg$c2;
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$parsesequence_post();
            if (s4 !== peg$FAILED) {
              s5 = [];
              s6 = peg$currPos;
              s7 = peg$parsesequence_sep();
              if (s7 === peg$FAILED) {
                s7 = peg$c2;
              }
              if (s7 !== peg$FAILED) {
                s8 = peg$parsesequence_post();
                if (s8 !== peg$FAILED) {
                  s7 = [s7, s8];
                  s6 = s7;
                } else {
                  peg$currPos = s6;
                  s6 = peg$c1;
                }
              } else {
                peg$currPos = s6;
                s6 = peg$c1;
              }
              while (s6 !== peg$FAILED) {
                s5.push(s6);
                s6 = peg$currPos;
                s7 = peg$parsesequence_sep();
                if (s7 === peg$FAILED) {
                  s7 = peg$c2;
                }
                if (s7 !== peg$FAILED) {
                  s8 = peg$parsesequence_post();
                  if (s8 !== peg$FAILED) {
                    s7 = [s7, s8];
                    s6 = s7;
                  } else {
                    peg$currPos = s6;
                    s6 = peg$c1;
                  }
                } else {
                  peg$currPos = s6;
                  s6 = peg$c1;
                }
              }
              if (s5 !== peg$FAILED) {
                s6 = peg$parsesp();
                if (s6 !== peg$FAILED) {
                  if (input.charCodeAt(peg$currPos) === 41) {
                    s7 = peg$c6;
                    peg$currPos++;
                  } else {
                    s7 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c7); }
                  }
                  if (s7 !== peg$FAILED) {
                    peg$reportedPos = s0;
                    s1 = peg$c8(s4, s5);
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c1;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c1;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c1;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsesequence_post() {
      var s0;

      s0 = peg$parsesequence_post_enclosed();
      if (s0 === peg$FAILED) {
        s0 = peg$parsecb_range();
        if (s0 === peg$FAILED) {
          s0 = peg$parsebcv_hyphen_range();
          if (s0 === peg$FAILED) {
            s0 = peg$parserange();
            if (s0 === peg$FAILED) {
              s0 = peg$parseff();
              if (s0 === peg$FAILED) {
                s0 = peg$parsebcv_comma();
                if (s0 === peg$FAILED) {
                  s0 = peg$parsebc_title();
                  if (s0 === peg$FAILED) {
                    s0 = peg$parseps151_bcv();
                    if (s0 === peg$FAILED) {
                      s0 = peg$parsebcv();
                      if (s0 === peg$FAILED) {
                        s0 = peg$parsebcv_weak();
                        if (s0 === peg$FAILED) {
                          s0 = peg$parseps151_bc();
                          if (s0 === peg$FAILED) {
                            s0 = peg$parsebc();
                            if (s0 === peg$FAILED) {
                              s0 = peg$parsecv_psalm();
                              if (s0 === peg$FAILED) {
                                s0 = peg$parsebv();
                                if (s0 === peg$FAILED) {
                                  s0 = peg$parsec_psalm();
                                  if (s0 === peg$FAILED) {
                                    s0 = peg$parseb();
                                    if (s0 === peg$FAILED) {
                                      s0 = peg$parsecbv();
                                      if (s0 === peg$FAILED) {
                                        s0 = peg$parsecbv_ordinal();
                                        if (s0 === peg$FAILED) {
                                          s0 = peg$parsecb();
                                          if (s0 === peg$FAILED) {
                                            s0 = peg$parsecb_ordinal();
                                            if (s0 === peg$FAILED) {
                                              s0 = peg$parsec_title();
                                              if (s0 === peg$FAILED) {
                                                s0 = peg$parseinteger_title();
                                                if (s0 === peg$FAILED) {
                                                  s0 = peg$parsecv();
                                                  if (s0 === peg$FAILED) {
                                                    s0 = peg$parsecv_weak();
                                                    if (s0 === peg$FAILED) {
                                                      s0 = peg$parsev_letter();
                                                      if (s0 === peg$FAILED) {
                                                        s0 = peg$parseinteger();
                                                        if (s0 === peg$FAILED) {
                                                          s0 = peg$parsec();
                                                          if (s0 === peg$FAILED) {
                                                            s0 = peg$parsev();
                                                          }
                                                        }
                                                      }
                                                    }
                                                  }
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }

      return s0;
    }

    function peg$parserange() {
      var s0, s1, s2, s3, s4, s5, s6;

      s0 = peg$currPos;
      s1 = peg$parsebcv_comma();
      if (s1 === peg$FAILED) {
        s1 = peg$parsebc_title();
        if (s1 === peg$FAILED) {
          s1 = peg$parseps151_bcv();
          if (s1 === peg$FAILED) {
            s1 = peg$parsebcv();
            if (s1 === peg$FAILED) {
              s1 = peg$parsebcv_weak();
              if (s1 === peg$FAILED) {
                s1 = peg$parseps151_bc();
                if (s1 === peg$FAILED) {
                  s1 = peg$parsebc();
                  if (s1 === peg$FAILED) {
                    s1 = peg$parsecv_psalm();
                    if (s1 === peg$FAILED) {
                      s1 = peg$parsebv();
                      if (s1 === peg$FAILED) {
                        s1 = peg$currPos;
                        s2 = peg$parseb();
                        if (s2 !== peg$FAILED) {
                          s3 = peg$currPos;
                          peg$silentFails++;
                          s4 = peg$currPos;
                          s5 = peg$parserange_sep();
                          if (s5 !== peg$FAILED) {
                            s6 = peg$parsebcv_comma();
                            if (s6 === peg$FAILED) {
                              s6 = peg$parsebc_title();
                              if (s6 === peg$FAILED) {
                                s6 = peg$parseps151_bcv();
                                if (s6 === peg$FAILED) {
                                  s6 = peg$parsebcv();
                                  if (s6 === peg$FAILED) {
                                    s6 = peg$parsebcv_weak();
                                    if (s6 === peg$FAILED) {
                                      s6 = peg$parseps151_bc();
                                      if (s6 === peg$FAILED) {
                                        s6 = peg$parsebc();
                                        if (s6 === peg$FAILED) {
                                          s6 = peg$parsebv();
                                          if (s6 === peg$FAILED) {
                                            s6 = peg$parseb();
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                            if (s6 !== peg$FAILED) {
                              s5 = [s5, s6];
                              s4 = s5;
                            } else {
                              peg$currPos = s4;
                              s4 = peg$c1;
                            }
                          } else {
                            peg$currPos = s4;
                            s4 = peg$c1;
                          }
                          peg$silentFails--;
                          if (s4 !== peg$FAILED) {
                            peg$currPos = s3;
                            s3 = peg$c9;
                          } else {
                            s3 = peg$c1;
                          }
                          if (s3 !== peg$FAILED) {
                            s2 = [s2, s3];
                            s1 = s2;
                          } else {
                            peg$currPos = s1;
                            s1 = peg$c1;
                          }
                        } else {
                          peg$currPos = s1;
                          s1 = peg$c1;
                        }
                        if (s1 === peg$FAILED) {
                          s1 = peg$parsecbv();
                          if (s1 === peg$FAILED) {
                            s1 = peg$parsecbv_ordinal();
                            if (s1 === peg$FAILED) {
                              s1 = peg$parsec_psalm();
                              if (s1 === peg$FAILED) {
                                s1 = peg$parsecb();
                                if (s1 === peg$FAILED) {
                                  s1 = peg$parsecb_ordinal();
                                  if (s1 === peg$FAILED) {
                                    s1 = peg$parsec_title();
                                    if (s1 === peg$FAILED) {
                                      s1 = peg$parseinteger_title();
                                      if (s1 === peg$FAILED) {
                                        s1 = peg$parsecv();
                                        if (s1 === peg$FAILED) {
                                          s1 = peg$parsecv_weak();
                                          if (s1 === peg$FAILED) {
                                            s1 = peg$parsev_letter();
                                            if (s1 === peg$FAILED) {
                                              s1 = peg$parseinteger();
                                              if (s1 === peg$FAILED) {
                                                s1 = peg$parsec();
                                                if (s1 === peg$FAILED) {
                                                  s1 = peg$parsev();
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parserange_sep();
        if (s2 !== peg$FAILED) {
          s3 = peg$parseff();
          if (s3 === peg$FAILED) {
            s3 = peg$parsebcv_comma();
            if (s3 === peg$FAILED) {
              s3 = peg$parsebc_title();
              if (s3 === peg$FAILED) {
                s3 = peg$parseps151_bcv();
                if (s3 === peg$FAILED) {
                  s3 = peg$parsebcv();
                  if (s3 === peg$FAILED) {
                    s3 = peg$parsebcv_weak();
                    if (s3 === peg$FAILED) {
                      s3 = peg$parseps151_bc();
                      if (s3 === peg$FAILED) {
                        s3 = peg$parsebc();
                        if (s3 === peg$FAILED) {
                          s3 = peg$parsecv_psalm();
                          if (s3 === peg$FAILED) {
                            s3 = peg$parsebv();
                            if (s3 === peg$FAILED) {
                              s3 = peg$parseb();
                              if (s3 === peg$FAILED) {
                                s3 = peg$parsecbv();
                                if (s3 === peg$FAILED) {
                                  s3 = peg$parsecbv_ordinal();
                                  if (s3 === peg$FAILED) {
                                    s3 = peg$parsec_psalm();
                                    if (s3 === peg$FAILED) {
                                      s3 = peg$parsecb();
                                      if (s3 === peg$FAILED) {
                                        s3 = peg$parsecb_ordinal();
                                        if (s3 === peg$FAILED) {
                                          s3 = peg$parsec_title();
                                          if (s3 === peg$FAILED) {
                                            s3 = peg$parseinteger_title();
                                            if (s3 === peg$FAILED) {
                                              s3 = peg$parsecv();
                                              if (s3 === peg$FAILED) {
                                                s3 = peg$parsev_letter();
                                                if (s3 === peg$FAILED) {
                                                  s3 = peg$parseinteger();
                                                  if (s3 === peg$FAILED) {
                                                    s3 = peg$parsecv_weak();
                                                    if (s3 === peg$FAILED) {
                                                      s3 = peg$parsec();
                                                      if (s3 === peg$FAILED) {
                                                        s3 = peg$parsev();
                                                      }
                                                    }
                                                  }
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c10(s1, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseb() {
      var s0, s1, s2, s3, s4, s5;

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 31) {
        s1 = peg$c11;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c12); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseany_integer();
        if (s2 !== peg$FAILED) {
          s3 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 47) {
            s4 = peg$c13;
            peg$currPos++;
          } else {
            s4 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c14); }
          }
          if (s4 !== peg$FAILED) {
            if (peg$c15.test(input.charAt(peg$currPos))) {
              s5 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c16); }
            }
            if (s5 !== peg$FAILED) {
              s4 = [s4, s5];
              s3 = s4;
            } else {
              peg$currPos = s3;
              s3 = peg$c1;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c1;
          }
          if (s3 === peg$FAILED) {
            s3 = peg$c2;
          }
          if (s3 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 31) {
              s4 = peg$c11;
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c12); }
            }
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c17(s2);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsebc() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8;

      s0 = peg$currPos;
      s1 = peg$parseb();
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        s3 = peg$parsev_explicit();
        if (s3 !== peg$FAILED) {
          s4 = peg$currPos;
          peg$silentFails++;
          s5 = peg$currPos;
          s6 = peg$parsec();
          if (s6 !== peg$FAILED) {
            s7 = peg$parsecv_sep();
            if (s7 !== peg$FAILED) {
              s8 = peg$parsev();
              if (s8 !== peg$FAILED) {
                s6 = [s6, s7, s8];
                s5 = s6;
              } else {
                peg$currPos = s5;
                s5 = peg$c1;
              }
            } else {
              peg$currPos = s5;
              s5 = peg$c1;
            }
          } else {
            peg$currPos = s5;
            s5 = peg$c1;
          }
          peg$silentFails--;
          if (s5 !== peg$FAILED) {
            peg$currPos = s4;
            s4 = peg$c9;
          } else {
            s4 = peg$c1;
          }
          if (s4 !== peg$FAILED) {
            s3 = [s3, s4];
            s2 = s3;
          } else {
            peg$currPos = s2;
            s2 = peg$c1;
          }
        } else {
          peg$currPos = s2;
          s2 = peg$c1;
        }
        if (s2 === peg$FAILED) {
          s2 = [];
          s3 = peg$parsecv_sep();
          if (s3 !== peg$FAILED) {
            while (s3 !== peg$FAILED) {
              s2.push(s3);
              s3 = peg$parsecv_sep();
            }
          } else {
            s2 = peg$c1;
          }
          if (s2 === peg$FAILED) {
            s2 = [];
            s3 = peg$parsecv_sep_weak();
            if (s3 !== peg$FAILED) {
              while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parsecv_sep_weak();
              }
            } else {
              s2 = peg$c1;
            }
            if (s2 === peg$FAILED) {
              s2 = [];
              s3 = peg$parserange_sep();
              if (s3 !== peg$FAILED) {
                while (s3 !== peg$FAILED) {
                  s2.push(s3);
                  s3 = peg$parserange_sep();
                }
              } else {
                s2 = peg$c1;
              }
              if (s2 === peg$FAILED) {
                s2 = peg$parsesp();
              }
            }
          }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parsec();
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c18(s1, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsebc_comma() {
      var s0, s1, s2, s3, s4, s5;

      s0 = peg$currPos;
      s1 = peg$parseb();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsesp();
        if (s2 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 44) {
            s3 = peg$c19;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c20); }
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$parsesp();
            if (s4 !== peg$FAILED) {
              s5 = peg$parsec();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c18(s1, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c1;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsebc_title() {
      var s0, s1, s2;

      s0 = peg$currPos;
      s1 = peg$parseps151_bc();
      if (s1 === peg$FAILED) {
        s1 = peg$parsebc();
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parsetitle();
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c21(s1, s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsebcv() {
      var s0, s1, s2, s3, s4, s5, s6;

      s0 = peg$currPos;
      s1 = peg$parseps151_bc();
      if (s1 === peg$FAILED) {
        s1 = peg$parsebc();
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        s3 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 46) {
          s4 = peg$c22;
          peg$currPos++;
        } else {
          s4 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c23); }
        }
        if (s4 !== peg$FAILED) {
          s5 = peg$parsev_explicit();
          if (s5 !== peg$FAILED) {
            s6 = peg$parsev();
            if (s6 !== peg$FAILED) {
              s4 = [s4, s5, s6];
              s3 = s4;
            } else {
              peg$currPos = s3;
              s3 = peg$c1;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c1;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$c1;
        }
        if (s3 === peg$FAILED) {
          s3 = peg$currPos;
          s4 = peg$parsesequence_sep();
          if (s4 === peg$FAILED) {
            s4 = peg$c2;
          }
          if (s4 !== peg$FAILED) {
            s5 = peg$parsev_explicit();
            if (s5 !== peg$FAILED) {
              s6 = peg$parsecv();
              if (s6 !== peg$FAILED) {
                s4 = [s4, s5, s6];
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$c1;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c1;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c1;
          }
        }
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c9;
        } else {
          peg$currPos = s2;
          s2 = peg$c1;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$currPos;
          s4 = peg$parsecv_sep();
          if (s4 === peg$FAILED) {
            s4 = peg$parsesequence_sep();
          }
          if (s4 === peg$FAILED) {
            s4 = peg$c2;
          }
          if (s4 !== peg$FAILED) {
            s5 = peg$parsev_explicit();
            if (s5 !== peg$FAILED) {
              s4 = [s4, s5];
              s3 = s4;
            } else {
              peg$currPos = s3;
              s3 = peg$c1;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c1;
          }
          if (s3 === peg$FAILED) {
            s3 = peg$parsecv_sep();
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$parsev_letter();
            if (s4 === peg$FAILED) {
              s4 = peg$parsev();
            }
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c24(s1, s4);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsebcv_weak() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      s0 = peg$currPos;
      s1 = peg$parseps151_bc();
      if (s1 === peg$FAILED) {
        s1 = peg$parsebc();
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parsecv_sep_weak();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsev_letter();
          if (s3 === peg$FAILED) {
            s3 = peg$parsev();
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$currPos;
            peg$silentFails++;
            s5 = peg$currPos;
            s6 = peg$parsecv_sep();
            if (s6 !== peg$FAILED) {
              s7 = peg$parsev();
              if (s7 !== peg$FAILED) {
                s6 = [s6, s7];
                s5 = s6;
              } else {
                peg$currPos = s5;
                s5 = peg$c1;
              }
            } else {
              peg$currPos = s5;
              s5 = peg$c1;
            }
            peg$silentFails--;
            if (s5 === peg$FAILED) {
              s4 = peg$c9;
            } else {
              peg$currPos = s4;
              s4 = peg$c1;
            }
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c24(s1, s3);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsebcv_comma() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

      s0 = peg$currPos;
      s1 = peg$parsebc_comma();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsesp();
        if (s2 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 44) {
            s3 = peg$c19;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c20); }
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$parsesp();
            if (s4 !== peg$FAILED) {
              s5 = peg$parsev_letter();
              if (s5 === peg$FAILED) {
                s5 = peg$parsev();
              }
              if (s5 !== peg$FAILED) {
                s6 = peg$currPos;
                peg$silentFails++;
                s7 = peg$currPos;
                s8 = peg$parsecv_sep();
                if (s8 !== peg$FAILED) {
                  s9 = peg$parsev();
                  if (s9 !== peg$FAILED) {
                    s8 = [s8, s9];
                    s7 = s8;
                  } else {
                    peg$currPos = s7;
                    s7 = peg$c1;
                  }
                } else {
                  peg$currPos = s7;
                  s7 = peg$c1;
                }
                peg$silentFails--;
                if (s7 === peg$FAILED) {
                  s6 = peg$c9;
                } else {
                  peg$currPos = s6;
                  s6 = peg$c1;
                }
                if (s6 !== peg$FAILED) {
                  peg$reportedPos = s0;
                  s1 = peg$c24(s1, s5);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$c1;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c1;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsebcv_hyphen_range() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      s0 = peg$currPos;
      s1 = peg$parseb();
      if (s1 !== peg$FAILED) {
        if (input.charCodeAt(peg$currPos) === 45) {
          s2 = peg$c25;
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c26); }
        }
        if (s2 === peg$FAILED) {
          s2 = peg$parsespace();
        }
        if (s2 === peg$FAILED) {
          s2 = peg$c2;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parsec();
          if (s3 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 45) {
              s4 = peg$c25;
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c26); }
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parsev();
              if (s5 !== peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 45) {
                  s6 = peg$c25;
                  peg$currPos++;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c26); }
                }
                if (s6 !== peg$FAILED) {
                  s7 = peg$parsev();
                  if (s7 !== peg$FAILED) {
                    peg$reportedPos = s0;
                    s1 = peg$c27(s1, s3, s5, s7);
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$c1;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$c1;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c1;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsebv() {
      var s0, s1, s2, s3, s4, s5;

      s0 = peg$currPos;
      s1 = peg$parseb();
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parsecv_sep();
        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$parsecv_sep();
          }
        } else {
          s2 = peg$c1;
        }
        if (s2 === peg$FAILED) {
          s2 = [];
          s3 = peg$parsecv_sep_weak();
          if (s3 !== peg$FAILED) {
            while (s3 !== peg$FAILED) {
              s2.push(s3);
              s3 = peg$parsecv_sep_weak();
            }
          } else {
            s2 = peg$c1;
          }
          if (s2 === peg$FAILED) {
            s2 = [];
            s3 = peg$parserange_sep();
            if (s3 !== peg$FAILED) {
              while (s3 !== peg$FAILED) {
                s2.push(s3);
                s3 = peg$parserange_sep();
              }
            } else {
              s2 = peg$c1;
            }
            if (s2 === peg$FAILED) {
              s2 = peg$currPos;
              s3 = [];
              s4 = peg$parsesequence_sep();
              if (s4 !== peg$FAILED) {
                while (s4 !== peg$FAILED) {
                  s3.push(s4);
                  s4 = peg$parsesequence_sep();
                }
              } else {
                s3 = peg$c1;
              }
              if (s3 !== peg$FAILED) {
                s4 = peg$currPos;
                peg$silentFails++;
                s5 = peg$parsev_explicit();
                peg$silentFails--;
                if (s5 !== peg$FAILED) {
                  peg$currPos = s4;
                  s4 = peg$c9;
                } else {
                  s4 = peg$c1;
                }
                if (s4 !== peg$FAILED) {
                  s3 = [s3, s4];
                  s2 = s3;
                } else {
                  peg$currPos = s2;
                  s2 = peg$c1;
                }
              } else {
                peg$currPos = s2;
                s2 = peg$c1;
              }
              if (s2 === peg$FAILED) {
                s2 = peg$parsesp();
              }
            }
          }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parsev_letter();
          if (s3 === peg$FAILED) {
            s3 = peg$parsev();
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c28(s1, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsecb() {
      var s0, s1, s2, s3, s4;

      s0 = peg$currPos;
      s1 = peg$parsec_explicit();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsec();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsein_book_of();
          if (s3 === peg$FAILED) {
            s3 = peg$c2;
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$parseb();
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c29(s2, s4);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsecb_range() {
      var s0, s1, s2, s3, s4, s5, s6;

      s0 = peg$currPos;
      s1 = peg$parsec_explicit();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsec();
        if (s2 !== peg$FAILED) {
          s3 = peg$parserange_sep();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsec();
            if (s4 !== peg$FAILED) {
              s5 = peg$parsein_book_of();
              if (s5 === peg$FAILED) {
                s5 = peg$c2;
              }
              if (s5 !== peg$FAILED) {
                s6 = peg$parseb();
                if (s6 !== peg$FAILED) {
                  peg$reportedPos = s0;
                  s1 = peg$c30(s2, s4, s6);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$c1;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c1;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsecbv() {
      var s0, s1, s2, s3, s4;

      s0 = peg$currPos;
      s1 = peg$parsecb();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsesequence_sep();
        if (s2 === peg$FAILED) {
          s2 = peg$c2;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parsev_explicit();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsev();
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c24(s1, s4);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsecb_ordinal() {
      var s0, s1, s2, s3, s4, s5;

      s0 = peg$currPos;
      s1 = peg$parsec();
      if (s1 !== peg$FAILED) {
        if (input.substr(peg$currPos, 2) === peg$c31) {
          s2 = peg$c31;
          peg$currPos += 2;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c32); }
        }
        if (s2 === peg$FAILED) {
          if (input.substr(peg$currPos, 2) === peg$c33) {
            s2 = peg$c33;
            peg$currPos += 2;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c34); }
          }
          if (s2 === peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c35) {
              s2 = peg$c35;
              peg$currPos += 2;
            } else {
              s2 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c36); }
            }
          }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parsec_explicit();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsein_book_of();
            if (s4 === peg$FAILED) {
              s4 = peg$c2;
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parseb();
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c29(s1, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c1;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsecbv_ordinal() {
      var s0, s1, s2, s3, s4;

      s0 = peg$currPos;
      s1 = peg$parsecb_ordinal();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsesequence_sep();
        if (s2 === peg$FAILED) {
          s2 = peg$c2;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parsev_explicit();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsev();
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c24(s1, s4);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsec_psalm() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 31) {
        s1 = peg$c11;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c12); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseany_integer();
        if (s2 !== peg$FAILED) {
          if (input.substr(peg$currPos, 3) === peg$c37) {
            s3 = peg$c37;
            peg$currPos += 3;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c38); }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c39(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsecv_psalm() {
      var s0, s1, s2, s3, s4;

      s0 = peg$currPos;
      s1 = peg$parsec_psalm();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsesequence_sep();
        if (s2 === peg$FAILED) {
          s2 = peg$c2;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parsev_explicit();
          if (s3 !== peg$FAILED) {
            s4 = peg$parsev();
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c40(s1, s4);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsec_title() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      s1 = peg$parsec_explicit();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsec();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsetitle();
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c41(s2, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsecv() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      s0 = peg$currPos;
      s1 = peg$parsev_explicit();
      if (s1 === peg$FAILED) {
        s1 = peg$c2;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parsec();
        if (s2 !== peg$FAILED) {
          s3 = peg$currPos;
          peg$silentFails++;
          s4 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 46) {
            s5 = peg$c22;
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c23); }
          }
          if (s5 !== peg$FAILED) {
            s6 = peg$parsev_explicit();
            if (s6 !== peg$FAILED) {
              s7 = peg$parsev();
              if (s7 !== peg$FAILED) {
                s5 = [s5, s6, s7];
                s4 = s5;
              } else {
                peg$currPos = s4;
                s4 = peg$c1;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c1;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$c1;
          }
          peg$silentFails--;
          if (s4 === peg$FAILED) {
            s3 = peg$c9;
          } else {
            peg$currPos = s3;
            s3 = peg$c1;
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$currPos;
            s5 = peg$parsecv_sep();
            if (s5 === peg$FAILED) {
              s5 = peg$c2;
            }
            if (s5 !== peg$FAILED) {
              s6 = peg$parsev_explicit();
              if (s6 !== peg$FAILED) {
                s5 = [s5, s6];
                s4 = s5;
              } else {
                peg$currPos = s4;
                s4 = peg$c1;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c1;
            }
            if (s4 === peg$FAILED) {
              s4 = peg$parsecv_sep();
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parsev_letter();
              if (s5 === peg$FAILED) {
                s5 = peg$parsev();
              }
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c42(s2, s5);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c1;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsecv_weak() {
      var s0, s1, s2, s3, s4, s5, s6, s7;

      s0 = peg$currPos;
      s1 = peg$parsec();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsecv_sep_weak();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsev_letter();
          if (s3 === peg$FAILED) {
            s3 = peg$parsev();
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$currPos;
            peg$silentFails++;
            s5 = peg$currPos;
            s6 = peg$parsecv_sep();
            if (s6 !== peg$FAILED) {
              s7 = peg$parsev();
              if (s7 !== peg$FAILED) {
                s6 = [s6, s7];
                s5 = s6;
              } else {
                peg$currPos = s5;
                s5 = peg$c1;
              }
            } else {
              peg$currPos = s5;
              s5 = peg$c1;
            }
            peg$silentFails--;
            if (s5 === peg$FAILED) {
              s4 = peg$c9;
            } else {
              peg$currPos = s4;
              s4 = peg$c1;
            }
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c42(s1, s3);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsec() {
      var s0, s1, s2;

      s0 = peg$currPos;
      s1 = peg$parsec_explicit();
      if (s1 === peg$FAILED) {
        s1 = peg$c2;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseinteger();
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c43(s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseff() {
      var s0, s1, s2, s3, s4, s5, s6;

      s0 = peg$currPos;
      s1 = peg$parsebcv();
      if (s1 === peg$FAILED) {
        s1 = peg$parsebcv_weak();
        if (s1 === peg$FAILED) {
          s1 = peg$parsebc();
          if (s1 === peg$FAILED) {
            s1 = peg$parsebv();
            if (s1 === peg$FAILED) {
              s1 = peg$parsecv();
              if (s1 === peg$FAILED) {
                s1 = peg$parsecv_weak();
                if (s1 === peg$FAILED) {
                  s1 = peg$parseinteger();
                  if (s1 === peg$FAILED) {
                    s1 = peg$parsec();
                    if (s1 === peg$FAILED) {
                      s1 = peg$parsev();
                    }
                  }
                }
              }
            }
          }
        }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parsesp();
        if (s2 !== peg$FAILED) {
          s3 = peg$currPos;
          if (input.substr(peg$currPos, 2) === peg$c44) {
            s4 = peg$c44;
            peg$currPos += 2;
          } else {
            s4 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c45); }
          }
          if (s4 !== peg$FAILED) {
            s5 = peg$currPos;
            peg$silentFails++;
            if (peg$c46.test(input.charAt(peg$currPos))) {
              s6 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c47); }
            }
            peg$silentFails--;
            if (s6 === peg$FAILED) {
              s5 = peg$c9;
            } else {
              peg$currPos = s5;
              s5 = peg$c1;
            }
            if (s5 !== peg$FAILED) {
              s4 = [s4, s5];
              s3 = s4;
            } else {
              peg$currPos = s3;
              s3 = peg$c1;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c1;
          }
          if (s3 === peg$FAILED) {
            s3 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 102) {
              s4 = peg$c48;
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c49); }
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$currPos;
              peg$silentFails++;
              if (peg$c46.test(input.charAt(peg$currPos))) {
                s6 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c47); }
              }
              peg$silentFails--;
              if (s6 === peg$FAILED) {
                s5 = peg$c9;
              } else {
                peg$currPos = s5;
                s5 = peg$c1;
              }
              if (s5 !== peg$FAILED) {
                s4 = [s4, s5];
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$c1;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c1;
            }
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$parseabbrev();
            if (s4 === peg$FAILED) {
              s4 = peg$c2;
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$currPos;
              peg$silentFails++;
              if (peg$c50.test(input.charAt(peg$currPos))) {
                s6 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c51); }
              }
              peg$silentFails--;
              if (s6 === peg$FAILED) {
                s5 = peg$c9;
              } else {
                peg$currPos = s5;
                s5 = peg$c1;
              }
              if (s5 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c52(s1);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$c1;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseinteger_title() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      s1 = peg$parseinteger();
      if (s1 !== peg$FAILED) {
        s2 = peg$parsecv_sep();
        if (s2 === peg$FAILED) {
          s2 = peg$parsesequence_sep();
        }
        if (s2 === peg$FAILED) {
          s2 = peg$c2;
        }
        if (s2 !== peg$FAILED) {
          if (input.substr(peg$currPos, 5) === peg$c53) {
            s3 = peg$c53;
            peg$currPos += 5;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c54); }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c55(s1);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsecontext() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 31) {
        s1 = peg$c11;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c12); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseany_integer();
        if (s2 !== peg$FAILED) {
          if (input.substr(peg$currPos, 3) === peg$c56) {
            s3 = peg$c56;
            peg$currPos += 3;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c57); }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c58(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseps151_b() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 31) {
        s1 = peg$c11;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c12); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseany_integer();
        if (s2 !== peg$FAILED) {
          if (input.substr(peg$currPos, 3) === peg$c59) {
            s3 = peg$c59;
            peg$currPos += 3;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c60); }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c17(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseps151_bc() {
      var s0, s1, s2, s3, s4;

      s0 = peg$currPos;
      s1 = peg$parseps151_b();
      if (s1 !== peg$FAILED) {
        if (input.substr(peg$currPos, 2) === peg$c61) {
          s2 = peg$c61;
          peg$currPos += 2;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c62); }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$currPos;
          peg$silentFails++;
          if (peg$c63.test(input.charAt(peg$currPos))) {
            s4 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s4 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c64); }
          }
          peg$silentFails--;
          if (s4 === peg$FAILED) {
            s3 = peg$c9;
          } else {
            peg$currPos = s3;
            s3 = peg$c1;
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c65(s1);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseps151_bcv() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      s1 = peg$parseps151_bc();
      if (s1 !== peg$FAILED) {
        if (input.charCodeAt(peg$currPos) === 46) {
          s2 = peg$c22;
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c23); }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parseinteger();
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c66(s1, s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsev_letter() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8;

      s0 = peg$currPos;
      s1 = peg$parsev_explicit();
      if (s1 === peg$FAILED) {
        s1 = peg$c2;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseinteger();
        if (s2 !== peg$FAILED) {
          s3 = peg$parsesp();
          if (s3 !== peg$FAILED) {
            s4 = peg$currPos;
            peg$silentFails++;
            s5 = peg$currPos;
            if (input.substr(peg$currPos, 2) === peg$c44) {
              s6 = peg$c44;
              peg$currPos += 2;
            } else {
              s6 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c45); }
            }
            if (s6 !== peg$FAILED) {
              s7 = peg$currPos;
              peg$silentFails++;
              if (peg$c46.test(input.charAt(peg$currPos))) {
                s8 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s8 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c47); }
              }
              peg$silentFails--;
              if (s8 === peg$FAILED) {
                s7 = peg$c9;
              } else {
                peg$currPos = s7;
                s7 = peg$c1;
              }
              if (s7 !== peg$FAILED) {
                s6 = [s6, s7];
                s5 = s6;
              } else {
                peg$currPos = s5;
                s5 = peg$c1;
              }
            } else {
              peg$currPos = s5;
              s5 = peg$c1;
            }
            if (s5 === peg$FAILED) {
              s5 = peg$currPos;
              if (input.charCodeAt(peg$currPos) === 102) {
                s6 = peg$c48;
                peg$currPos++;
              } else {
                s6 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c49); }
              }
              if (s6 !== peg$FAILED) {
                s7 = peg$currPos;
                peg$silentFails++;
                if (peg$c46.test(input.charAt(peg$currPos))) {
                  s8 = input.charAt(peg$currPos);
                  peg$currPos++;
                } else {
                  s8 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c47); }
                }
                peg$silentFails--;
                if (s8 === peg$FAILED) {
                  s7 = peg$c9;
                } else {
                  peg$currPos = s7;
                  s7 = peg$c1;
                }
                if (s7 !== peg$FAILED) {
                  s6 = [s6, s7];
                  s5 = s6;
                } else {
                  peg$currPos = s5;
                  s5 = peg$c1;
                }
              } else {
                peg$currPos = s5;
                s5 = peg$c1;
              }
            }
            peg$silentFails--;
            if (s5 === peg$FAILED) {
              s4 = peg$c9;
            } else {
              peg$currPos = s4;
              s4 = peg$c1;
            }
            if (s4 !== peg$FAILED) {
              if (peg$c67.test(input.charAt(peg$currPos))) {
                s5 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s5 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c68); }
              }
              if (s5 !== peg$FAILED) {
                s6 = peg$currPos;
                peg$silentFails++;
                if (peg$c50.test(input.charAt(peg$currPos))) {
                  s7 = input.charAt(peg$currPos);
                  peg$currPos++;
                } else {
                  s7 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c51); }
                }
                peg$silentFails--;
                if (s7 === peg$FAILED) {
                  s6 = peg$c9;
                } else {
                  peg$currPos = s6;
                  s6 = peg$c1;
                }
                if (s6 !== peg$FAILED) {
                  peg$reportedPos = s0;
                  s1 = peg$c69(s2);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$c1;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c1;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsev() {
      var s0, s1, s2;

      s0 = peg$currPos;
      s1 = peg$parsev_explicit();
      if (s1 === peg$FAILED) {
        s1 = peg$c2;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseinteger();
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c69(s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsec_explicit() {
      var s0, s1, s2, s3, s4;

      s0 = peg$currPos;
      s1 = peg$parsesp();
      if (s1 !== peg$FAILED) {
        if (input.substr(peg$currPos, 8) === peg$c70) {
          s2 = peg$c70;
          peg$currPos += 8;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c71); }
        }
        if (s2 === peg$FAILED) {
          if (input.substr(peg$currPos, 7) === peg$c72) {
            s2 = peg$c72;
            peg$currPos += 7;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c73); }
          }
          if (s2 === peg$FAILED) {
            s2 = peg$currPos;
            if (input.substr(peg$currPos, 6) === peg$c74) {
              s3 = peg$c74;
              peg$currPos += 6;
            } else {
              s3 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c75); }
            }
            if (s3 !== peg$FAILED) {
              s4 = peg$parseabbrev();
              if (s4 === peg$FAILED) {
                s4 = peg$c2;
              }
              if (s4 !== peg$FAILED) {
                s3 = [s3, s4];
                s2 = s3;
              } else {
                peg$currPos = s2;
                s2 = peg$c1;
              }
            } else {
              peg$currPos = s2;
              s2 = peg$c1;
            }
            if (s2 === peg$FAILED) {
              s2 = peg$currPos;
              if (input.substr(peg$currPos, 5) === peg$c76) {
                s3 = peg$c76;
                peg$currPos += 5;
              } else {
                s3 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c77); }
              }
              if (s3 !== peg$FAILED) {
                s4 = peg$parseabbrev();
                if (s4 === peg$FAILED) {
                  s4 = peg$c2;
                }
                if (s4 !== peg$FAILED) {
                  s3 = [s3, s4];
                  s2 = s3;
                } else {
                  peg$currPos = s2;
                  s2 = peg$c1;
                }
              } else {
                peg$currPos = s2;
                s2 = peg$c1;
              }
              if (s2 === peg$FAILED) {
                s2 = peg$currPos;
                if (input.substr(peg$currPos, 5) === peg$c78) {
                  s3 = peg$c78;
                  peg$currPos += 5;
                } else {
                  s3 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c79); }
                }
                if (s3 !== peg$FAILED) {
                  s4 = peg$parseabbrev();
                  if (s4 === peg$FAILED) {
                    s4 = peg$c2;
                  }
                  if (s4 !== peg$FAILED) {
                    s3 = [s3, s4];
                    s2 = s3;
                  } else {
                    peg$currPos = s2;
                    s2 = peg$c1;
                  }
                } else {
                  peg$currPos = s2;
                  s2 = peg$c1;
                }
                if (s2 === peg$FAILED) {
                  s2 = peg$currPos;
                  if (input.substr(peg$currPos, 5) === peg$c80) {
                    s3 = peg$c80;
                    peg$currPos += 5;
                  } else {
                    s3 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c81); }
                  }
                  if (s3 !== peg$FAILED) {
                    s4 = peg$parseabbrev();
                    if (s4 === peg$FAILED) {
                      s4 = peg$c2;
                    }
                    if (s4 !== peg$FAILED) {
                      s3 = [s3, s4];
                      s2 = s3;
                    } else {
                      peg$currPos = s2;
                      s2 = peg$c1;
                    }
                  } else {
                    peg$currPos = s2;
                    s2 = peg$c1;
                  }
                  if (s2 === peg$FAILED) {
                    s2 = peg$currPos;
                    if (input.substr(peg$currPos, 4) === peg$c82) {
                      s3 = peg$c82;
                      peg$currPos += 4;
                    } else {
                      s3 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$c83); }
                    }
                    if (s3 !== peg$FAILED) {
                      s4 = peg$parseabbrev();
                      if (s4 === peg$FAILED) {
                        s4 = peg$c2;
                      }
                      if (s4 !== peg$FAILED) {
                        s3 = [s3, s4];
                        s2 = s3;
                      } else {
                        peg$currPos = s2;
                        s2 = peg$c1;
                      }
                    } else {
                      peg$currPos = s2;
                      s2 = peg$c1;
                    }
                    if (s2 === peg$FAILED) {
                      s2 = peg$currPos;
                      if (input.substr(peg$currPos, 3) === peg$c84) {
                        s3 = peg$c84;
                        peg$currPos += 3;
                      } else {
                        s3 = peg$FAILED;
                        if (peg$silentFails === 0) { peg$fail(peg$c85); }
                      }
                      if (s3 !== peg$FAILED) {
                        s4 = peg$parseabbrev();
                        if (s4 === peg$FAILED) {
                          s4 = peg$c2;
                        }
                        if (s4 !== peg$FAILED) {
                          s3 = [s3, s4];
                          s2 = s3;
                        } else {
                          peg$currPos = s2;
                          s2 = peg$c1;
                        }
                      } else {
                        peg$currPos = s2;
                        s2 = peg$c1;
                      }
                      if (s2 === peg$FAILED) {
                        s2 = peg$currPos;
                        if (input.substr(peg$currPos, 3) === peg$c86) {
                          s3 = peg$c86;
                          peg$currPos += 3;
                        } else {
                          s3 = peg$FAILED;
                          if (peg$silentFails === 0) { peg$fail(peg$c87); }
                        }
                        if (s3 !== peg$FAILED) {
                          s4 = peg$parseabbrev();
                          if (s4 === peg$FAILED) {
                            s4 = peg$c2;
                          }
                          if (s4 !== peg$FAILED) {
                            s3 = [s3, s4];
                            s2 = s3;
                          } else {
                            peg$currPos = s2;
                            s2 = peg$c1;
                          }
                        } else {
                          peg$currPos = s2;
                          s2 = peg$c1;
                        }
                        if (s2 === peg$FAILED) {
                          s2 = peg$currPos;
                          if (input.substr(peg$currPos, 3) === peg$c88) {
                            s3 = peg$c88;
                            peg$currPos += 3;
                          } else {
                            s3 = peg$FAILED;
                            if (peg$silentFails === 0) { peg$fail(peg$c89); }
                          }
                          if (s3 !== peg$FAILED) {
                            s4 = peg$parseabbrev();
                            if (s4 === peg$FAILED) {
                              s4 = peg$c2;
                            }
                            if (s4 !== peg$FAILED) {
                              s3 = [s3, s4];
                              s2 = s3;
                            } else {
                              peg$currPos = s2;
                              s2 = peg$c1;
                            }
                          } else {
                            peg$currPos = s2;
                            s2 = peg$c1;
                          }
                          if (s2 === peg$FAILED) {
                            s2 = peg$currPos;
                            if (input.substr(peg$currPos, 2) === peg$c90) {
                              s3 = peg$c90;
                              peg$currPos += 2;
                            } else {
                              s3 = peg$FAILED;
                              if (peg$silentFails === 0) { peg$fail(peg$c91); }
                            }
                            if (s3 !== peg$FAILED) {
                              s4 = peg$parseabbrev();
                              if (s4 === peg$FAILED) {
                                s4 = peg$c2;
                              }
                              if (s4 !== peg$FAILED) {
                                s3 = [s3, s4];
                                s2 = s3;
                              } else {
                                peg$currPos = s2;
                                s2 = peg$c1;
                              }
                            } else {
                              peg$currPos = s2;
                              s2 = peg$c1;
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parsesp();
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c92();
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsev_explicit() {
      var s0, s1, s2, s3, s4;

      s0 = peg$currPos;
      s1 = peg$parsesp();
      if (s1 !== peg$FAILED) {
        if (input.substr(peg$currPos, 6) === peg$c93) {
          s2 = peg$c93;
          peg$currPos += 6;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c94); }
        }
        if (s2 === peg$FAILED) {
          if (input.substr(peg$currPos, 5) === peg$c95) {
            s2 = peg$c95;
            peg$currPos += 5;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c96); }
          }
          if (s2 === peg$FAILED) {
            s2 = peg$currPos;
            if (input.substr(peg$currPos, 3) === peg$c97) {
              s3 = peg$c97;
              peg$currPos += 3;
            } else {
              s3 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c98); }
            }
            if (s3 !== peg$FAILED) {
              s4 = peg$parseabbrev();
              if (s4 === peg$FAILED) {
                s4 = peg$c2;
              }
              if (s4 !== peg$FAILED) {
                s3 = [s3, s4];
                s2 = s3;
              } else {
                peg$currPos = s2;
                s2 = peg$c1;
              }
            } else {
              peg$currPos = s2;
              s2 = peg$c1;
            }
            if (s2 === peg$FAILED) {
              s2 = peg$currPos;
              if (input.substr(peg$currPos, 3) === peg$c99) {
                s3 = peg$c99;
                peg$currPos += 3;
              } else {
                s3 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c100); }
              }
              if (s3 !== peg$FAILED) {
                s4 = peg$parseabbrev();
                if (s4 === peg$FAILED) {
                  s4 = peg$c2;
                }
                if (s4 !== peg$FAILED) {
                  s3 = [s3, s4];
                  s2 = s3;
                } else {
                  peg$currPos = s2;
                  s2 = peg$c1;
                }
              } else {
                peg$currPos = s2;
                s2 = peg$c1;
              }
              if (s2 === peg$FAILED) {
                s2 = peg$currPos;
                if (input.substr(peg$currPos, 2) === peg$c101) {
                  s3 = peg$c101;
                  peg$currPos += 2;
                } else {
                  s3 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c102); }
                }
                if (s3 !== peg$FAILED) {
                  s4 = peg$parseabbrev();
                  if (s4 === peg$FAILED) {
                    s4 = peg$c2;
                  }
                  if (s4 !== peg$FAILED) {
                    s3 = [s3, s4];
                    s2 = s3;
                  } else {
                    peg$currPos = s2;
                    s2 = peg$c1;
                  }
                } else {
                  peg$currPos = s2;
                  s2 = peg$c1;
                }
                if (s2 === peg$FAILED) {
                  s2 = peg$currPos;
                  if (input.substr(peg$currPos, 2) === peg$c103) {
                    s3 = peg$c103;
                    peg$currPos += 2;
                  } else {
                    s3 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c104); }
                  }
                  if (s3 !== peg$FAILED) {
                    s4 = peg$parseabbrev();
                    if (s4 === peg$FAILED) {
                      s4 = peg$c2;
                    }
                    if (s4 !== peg$FAILED) {
                      s3 = [s3, s4];
                      s2 = s3;
                    } else {
                      peg$currPos = s2;
                      s2 = peg$c1;
                    }
                  } else {
                    peg$currPos = s2;
                    s2 = peg$c1;
                  }
                  if (s2 === peg$FAILED) {
                    s2 = peg$currPos;
                    if (input.charCodeAt(peg$currPos) === 118) {
                      s3 = peg$c105;
                      peg$currPos++;
                    } else {
                      s3 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$c106); }
                    }
                    if (s3 !== peg$FAILED) {
                      s4 = peg$parseabbrev();
                      if (s4 === peg$FAILED) {
                        s4 = peg$c2;
                      }
                      if (s4 !== peg$FAILED) {
                        s3 = [s3, s4];
                        s2 = s3;
                      } else {
                        peg$currPos = s2;
                        s2 = peg$c1;
                      }
                    } else {
                      peg$currPos = s2;
                      s2 = peg$c1;
                    }
                  }
                }
              }
            }
          }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$currPos;
          peg$silentFails++;
          if (peg$c50.test(input.charAt(peg$currPos))) {
            s4 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s4 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c51); }
          }
          peg$silentFails--;
          if (s4 === peg$FAILED) {
            s3 = peg$c9;
          } else {
            peg$currPos = s3;
            s3 = peg$c1;
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$parsesp();
            if (s4 !== peg$FAILED) {
              peg$reportedPos = s0;
              s1 = peg$c107();
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsecv_sep() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      s1 = peg$parsesp();
      if (s1 !== peg$FAILED) {
        if (input.charCodeAt(peg$currPos) === 44) {
          s2 = peg$c19;
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c20); }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parsesp();
          if (s3 !== peg$FAILED) {
            s1 = [s1, s2, s3];
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsecv_sep_weak() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      s1 = peg$parsesp();
      if (s1 !== peg$FAILED) {
        if (peg$c108.test(input.charAt(peg$currPos))) {
          s2 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c109); }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parsesp();
          if (s3 !== peg$FAILED) {
            s1 = [s1, s2, s3];
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$parsespace();
      }

      return s0;
    }

    function peg$parsesequence_sep() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

      s0 = peg$currPos;
      s1 = [];
      if (peg$c110.test(input.charAt(peg$currPos))) {
        s2 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s2 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c111); }
      }
      if (s2 === peg$FAILED) {
        s2 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 46) {
          s3 = peg$c22;
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c23); }
        }
        if (s3 !== peg$FAILED) {
          s4 = peg$currPos;
          peg$silentFails++;
          s5 = peg$currPos;
          s6 = peg$parsesp();
          if (s6 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 46) {
              s7 = peg$c22;
              peg$currPos++;
            } else {
              s7 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c23); }
            }
            if (s7 !== peg$FAILED) {
              s8 = peg$parsesp();
              if (s8 !== peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 46) {
                  s9 = peg$c22;
                  peg$currPos++;
                } else {
                  s9 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c23); }
                }
                if (s9 !== peg$FAILED) {
                  s6 = [s6, s7, s8, s9];
                  s5 = s6;
                } else {
                  peg$currPos = s5;
                  s5 = peg$c1;
                }
              } else {
                peg$currPos = s5;
                s5 = peg$c1;
              }
            } else {
              peg$currPos = s5;
              s5 = peg$c1;
            }
          } else {
            peg$currPos = s5;
            s5 = peg$c1;
          }
          peg$silentFails--;
          if (s5 === peg$FAILED) {
            s4 = peg$c9;
          } else {
            peg$currPos = s4;
            s4 = peg$c1;
          }
          if (s4 !== peg$FAILED) {
            s3 = [s3, s4];
            s2 = s3;
          } else {
            peg$currPos = s2;
            s2 = peg$c1;
          }
        } else {
          peg$currPos = s2;
          s2 = peg$c1;
        }
        if (s2 === peg$FAILED) {
          if (input.substr(peg$currPos, 3) === peg$c112) {
            s2 = peg$c112;
            peg$currPos += 3;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c113); }
          }
          if (s2 === peg$FAILED) {
            if (input.substr(peg$currPos, 7) === peg$c114) {
              s2 = peg$c114;
              peg$currPos += 7;
            } else {
              s2 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c115); }
            }
            if (s2 === peg$FAILED) {
              s2 = peg$currPos;
              if (input.substr(peg$currPos, 2) === peg$c116) {
                s3 = peg$c116;
                peg$currPos += 2;
              } else {
                s3 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c117); }
              }
              if (s3 !== peg$FAILED) {
                s4 = peg$parseabbrev();
                if (s4 === peg$FAILED) {
                  s4 = peg$c2;
                }
                if (s4 !== peg$FAILED) {
                  s3 = [s3, s4];
                  s2 = s3;
                } else {
                  peg$currPos = s2;
                  s2 = peg$c1;
                }
              } else {
                peg$currPos = s2;
                s2 = peg$c1;
              }
              if (s2 === peg$FAILED) {
                s2 = peg$currPos;
                if (input.substr(peg$currPos, 3) === peg$c118) {
                  s3 = peg$c118;
                  peg$currPos += 3;
                } else {
                  s3 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c119); }
                }
                if (s3 !== peg$FAILED) {
                  s4 = peg$parsespace();
                  if (s4 !== peg$FAILED) {
                    if (input.substr(peg$currPos, 4) === peg$c120) {
                      s5 = peg$c120;
                      peg$currPos += 4;
                    } else {
                      s5 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$c121); }
                    }
                    if (s5 !== peg$FAILED) {
                      s3 = [s3, s4, s5];
                      s2 = s3;
                    } else {
                      peg$currPos = s2;
                      s2 = peg$c1;
                    }
                  } else {
                    peg$currPos = s2;
                    s2 = peg$c1;
                  }
                } else {
                  peg$currPos = s2;
                  s2 = peg$c1;
                }
                if (s2 === peg$FAILED) {
                  if (input.substr(peg$currPos, 4) === peg$c120) {
                    s2 = peg$c120;
                    peg$currPos += 4;
                  } else {
                    s2 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c121); }
                  }
                  if (s2 === peg$FAILED) {
                    if (input.substr(peg$currPos, 3) === peg$c118) {
                      s2 = peg$c118;
                      peg$currPos += 3;
                    } else {
                      s2 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$c119); }
                    }
                    if (s2 === peg$FAILED) {
                      s2 = peg$parsespace();
                    }
                  }
                }
              }
            }
          }
        }
      }
      if (s2 !== peg$FAILED) {
        while (s2 !== peg$FAILED) {
          s1.push(s2);
          if (peg$c110.test(input.charAt(peg$currPos))) {
            s2 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c111); }
          }
          if (s2 === peg$FAILED) {
            s2 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 46) {
              s3 = peg$c22;
              peg$currPos++;
            } else {
              s3 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c23); }
            }
            if (s3 !== peg$FAILED) {
              s4 = peg$currPos;
              peg$silentFails++;
              s5 = peg$currPos;
              s6 = peg$parsesp();
              if (s6 !== peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 46) {
                  s7 = peg$c22;
                  peg$currPos++;
                } else {
                  s7 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c23); }
                }
                if (s7 !== peg$FAILED) {
                  s8 = peg$parsesp();
                  if (s8 !== peg$FAILED) {
                    if (input.charCodeAt(peg$currPos) === 46) {
                      s9 = peg$c22;
                      peg$currPos++;
                    } else {
                      s9 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$c23); }
                    }
                    if (s9 !== peg$FAILED) {
                      s6 = [s6, s7, s8, s9];
                      s5 = s6;
                    } else {
                      peg$currPos = s5;
                      s5 = peg$c1;
                    }
                  } else {
                    peg$currPos = s5;
                    s5 = peg$c1;
                  }
                } else {
                  peg$currPos = s5;
                  s5 = peg$c1;
                }
              } else {
                peg$currPos = s5;
                s5 = peg$c1;
              }
              peg$silentFails--;
              if (s5 === peg$FAILED) {
                s4 = peg$c9;
              } else {
                peg$currPos = s4;
                s4 = peg$c1;
              }
              if (s4 !== peg$FAILED) {
                s3 = [s3, s4];
                s2 = s3;
              } else {
                peg$currPos = s2;
                s2 = peg$c1;
              }
            } else {
              peg$currPos = s2;
              s2 = peg$c1;
            }
            if (s2 === peg$FAILED) {
              if (input.substr(peg$currPos, 3) === peg$c112) {
                s2 = peg$c112;
                peg$currPos += 3;
              } else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c113); }
              }
              if (s2 === peg$FAILED) {
                if (input.substr(peg$currPos, 7) === peg$c114) {
                  s2 = peg$c114;
                  peg$currPos += 7;
                } else {
                  s2 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c115); }
                }
                if (s2 === peg$FAILED) {
                  s2 = peg$currPos;
                  if (input.substr(peg$currPos, 2) === peg$c116) {
                    s3 = peg$c116;
                    peg$currPos += 2;
                  } else {
                    s3 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c117); }
                  }
                  if (s3 !== peg$FAILED) {
                    s4 = peg$parseabbrev();
                    if (s4 === peg$FAILED) {
                      s4 = peg$c2;
                    }
                    if (s4 !== peg$FAILED) {
                      s3 = [s3, s4];
                      s2 = s3;
                    } else {
                      peg$currPos = s2;
                      s2 = peg$c1;
                    }
                  } else {
                    peg$currPos = s2;
                    s2 = peg$c1;
                  }
                  if (s2 === peg$FAILED) {
                    s2 = peg$currPos;
                    if (input.substr(peg$currPos, 3) === peg$c118) {
                      s3 = peg$c118;
                      peg$currPos += 3;
                    } else {
                      s3 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$c119); }
                    }
                    if (s3 !== peg$FAILED) {
                      s4 = peg$parsespace();
                      if (s4 !== peg$FAILED) {
                        if (input.substr(peg$currPos, 4) === peg$c120) {
                          s5 = peg$c120;
                          peg$currPos += 4;
                        } else {
                          s5 = peg$FAILED;
                          if (peg$silentFails === 0) { peg$fail(peg$c121); }
                        }
                        if (s5 !== peg$FAILED) {
                          s3 = [s3, s4, s5];
                          s2 = s3;
                        } else {
                          peg$currPos = s2;
                          s2 = peg$c1;
                        }
                      } else {
                        peg$currPos = s2;
                        s2 = peg$c1;
                      }
                    } else {
                      peg$currPos = s2;
                      s2 = peg$c1;
                    }
                    if (s2 === peg$FAILED) {
                      if (input.substr(peg$currPos, 4) === peg$c120) {
                        s2 = peg$c120;
                        peg$currPos += 4;
                      } else {
                        s2 = peg$FAILED;
                        if (peg$silentFails === 0) { peg$fail(peg$c121); }
                      }
                      if (s2 === peg$FAILED) {
                        if (input.substr(peg$currPos, 3) === peg$c118) {
                          s2 = peg$c118;
                          peg$currPos += 3;
                        } else {
                          s2 = peg$FAILED;
                          if (peg$silentFails === 0) { peg$fail(peg$c119); }
                        }
                        if (s2 === peg$FAILED) {
                          s2 = peg$parsespace();
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      } else {
        s1 = peg$c1;
      }
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c122();
      }
      s0 = s1;

      return s0;
    }

    function peg$parserange_sep() {
      var s0, s1, s2, s3, s4, s5;

      s0 = peg$currPos;
      s1 = peg$parsesp();
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$currPos;
        if (peg$c123.test(input.charAt(peg$currPos))) {
          s4 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s4 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c124); }
        }
        if (s4 !== peg$FAILED) {
          s5 = peg$parsesp();
          if (s5 !== peg$FAILED) {
            s4 = [s4, s5];
            s3 = s4;
          } else {
            peg$currPos = s3;
            s3 = peg$c1;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$c1;
        }
        if (s3 === peg$FAILED) {
          s3 = peg$currPos;
          if (input.substr(peg$currPos, 7) === peg$c125) {
            s4 = peg$c125;
            peg$currPos += 7;
          } else {
            s4 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c126); }
          }
          if (s4 !== peg$FAILED) {
            s5 = peg$parsesp();
            if (s5 !== peg$FAILED) {
              s4 = [s4, s5];
              s3 = s4;
            } else {
              peg$currPos = s3;
              s3 = peg$c1;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c1;
          }
          if (s3 === peg$FAILED) {
            s3 = peg$currPos;
            if (input.substr(peg$currPos, 4) === peg$c127) {
              s4 = peg$c127;
              peg$currPos += 4;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c128); }
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parsesp();
              if (s5 !== peg$FAILED) {
                s4 = [s4, s5];
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$c1;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c1;
            }
            if (s3 === peg$FAILED) {
              s3 = peg$currPos;
              if (input.substr(peg$currPos, 2) === peg$c129) {
                s4 = peg$c129;
                peg$currPos += 2;
              } else {
                s4 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c130); }
              }
              if (s4 !== peg$FAILED) {
                s5 = peg$parsesp();
                if (s5 !== peg$FAILED) {
                  s4 = [s4, s5];
                  s3 = s4;
                } else {
                  peg$currPos = s3;
                  s3 = peg$c1;
                }
              } else {
                peg$currPos = s3;
                s3 = peg$c1;
              }
            }
          }
        }
        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            s3 = peg$currPos;
            if (peg$c123.test(input.charAt(peg$currPos))) {
              s4 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c124); }
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parsesp();
              if (s5 !== peg$FAILED) {
                s4 = [s4, s5];
                s3 = s4;
              } else {
                peg$currPos = s3;
                s3 = peg$c1;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$c1;
            }
            if (s3 === peg$FAILED) {
              s3 = peg$currPos;
              if (input.substr(peg$currPos, 7) === peg$c125) {
                s4 = peg$c125;
                peg$currPos += 7;
              } else {
                s4 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c126); }
              }
              if (s4 !== peg$FAILED) {
                s5 = peg$parsesp();
                if (s5 !== peg$FAILED) {
                  s4 = [s4, s5];
                  s3 = s4;
                } else {
                  peg$currPos = s3;
                  s3 = peg$c1;
                }
              } else {
                peg$currPos = s3;
                s3 = peg$c1;
              }
              if (s3 === peg$FAILED) {
                s3 = peg$currPos;
                if (input.substr(peg$currPos, 4) === peg$c127) {
                  s4 = peg$c127;
                  peg$currPos += 4;
                } else {
                  s4 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c128); }
                }
                if (s4 !== peg$FAILED) {
                  s5 = peg$parsesp();
                  if (s5 !== peg$FAILED) {
                    s4 = [s4, s5];
                    s3 = s4;
                  } else {
                    peg$currPos = s3;
                    s3 = peg$c1;
                  }
                } else {
                  peg$currPos = s3;
                  s3 = peg$c1;
                }
                if (s3 === peg$FAILED) {
                  s3 = peg$currPos;
                  if (input.substr(peg$currPos, 2) === peg$c129) {
                    s4 = peg$c129;
                    peg$currPos += 2;
                  } else {
                    s4 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c130); }
                  }
                  if (s4 !== peg$FAILED) {
                    s5 = peg$parsesp();
                    if (s5 !== peg$FAILED) {
                      s4 = [s4, s5];
                      s3 = s4;
                    } else {
                      peg$currPos = s3;
                      s3 = peg$c1;
                    }
                  } else {
                    peg$currPos = s3;
                    s3 = peg$c1;
                  }
                }
              }
            }
          }
        } else {
          s2 = peg$c1;
        }
        if (s2 !== peg$FAILED) {
          s1 = [s1, s2];
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsetitle() {
      var s0, s1, s2;

      s0 = peg$currPos;
      s1 = peg$parsecv_sep();
      if (s1 === peg$FAILED) {
        s1 = peg$parsesequence_sep();
      }
      if (s1 === peg$FAILED) {
        s1 = peg$c2;
      }
      if (s1 !== peg$FAILED) {
        if (input.substr(peg$currPos, 5) === peg$c53) {
          s2 = peg$c53;
          peg$currPos += 5;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c54); }
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c131(s2);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsein_book_of() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10;

      s0 = peg$currPos;
      s1 = peg$parsesp();
      if (s1 !== peg$FAILED) {
        if (input.substr(peg$currPos, 4) === peg$c132) {
          s2 = peg$c132;
          peg$currPos += 4;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c133); }
        }
        if (s2 === peg$FAILED) {
          if (input.substr(peg$currPos, 2) === peg$c134) {
            s2 = peg$c134;
            peg$currPos += 2;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c135); }
          }
          if (s2 === peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c136) {
              s2 = peg$c136;
              peg$currPos += 2;
            } else {
              s2 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c137); }
            }
          }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parsesp();
          if (s3 !== peg$FAILED) {
            s4 = peg$currPos;
            if (input.substr(peg$currPos, 3) === peg$c138) {
              s5 = peg$c138;
              peg$currPos += 3;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c139); }
            }
            if (s5 !== peg$FAILED) {
              s6 = peg$parsesp();
              if (s6 !== peg$FAILED) {
                if (input.substr(peg$currPos, 4) === peg$c140) {
                  s7 = peg$c140;
                  peg$currPos += 4;
                } else {
                  s7 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c141); }
                }
                if (s7 !== peg$FAILED) {
                  s8 = peg$parsesp();
                  if (s8 !== peg$FAILED) {
                    if (input.substr(peg$currPos, 2) === peg$c134) {
                      s9 = peg$c134;
                      peg$currPos += 2;
                    } else {
                      s9 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$c135); }
                    }
                    if (s9 !== peg$FAILED) {
                      s10 = peg$parsesp();
                      if (s10 !== peg$FAILED) {
                        s5 = [s5, s6, s7, s8, s9, s10];
                        s4 = s5;
                      } else {
                        peg$currPos = s4;
                        s4 = peg$c1;
                      }
                    } else {
                      peg$currPos = s4;
                      s4 = peg$c1;
                    }
                  } else {
                    peg$currPos = s4;
                    s4 = peg$c1;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$c1;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c1;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c1;
            }
            if (s4 === peg$FAILED) {
              s4 = peg$c2;
            }
            if (s4 !== peg$FAILED) {
              s1 = [s1, s2, s3, s4];
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseabbrev() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8;

      s0 = peg$currPos;
      s1 = peg$parsesp();
      if (s1 !== peg$FAILED) {
        if (input.charCodeAt(peg$currPos) === 46) {
          s2 = peg$c22;
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c23); }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$currPos;
          peg$silentFails++;
          s4 = peg$currPos;
          s5 = peg$parsesp();
          if (s5 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 46) {
              s6 = peg$c22;
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$c23); }
            }
            if (s6 !== peg$FAILED) {
              s7 = peg$parsesp();
              if (s7 !== peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 46) {
                  s8 = peg$c22;
                  peg$currPos++;
                } else {
                  s8 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c23); }
                }
                if (s8 !== peg$FAILED) {
                  s5 = [s5, s6, s7, s8];
                  s4 = s5;
                } else {
                  peg$currPos = s4;
                  s4 = peg$c1;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$c1;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c1;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$c1;
          }
          peg$silentFails--;
          if (s4 === peg$FAILED) {
            s3 = peg$c9;
          } else {
            peg$currPos = s3;
            s3 = peg$c1;
          }
          if (s3 !== peg$FAILED) {
            s1 = [s1, s2, s3];
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsetranslation_sequence_enclosed() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

      s0 = peg$currPos;
      s1 = peg$parsesp();
      if (s1 !== peg$FAILED) {
        if (peg$c142.test(input.charAt(peg$currPos))) {
          s2 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c143); }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parsesp();
          if (s3 !== peg$FAILED) {
            s4 = peg$currPos;
            s5 = peg$parsetranslation();
            if (s5 !== peg$FAILED) {
              s6 = [];
              s7 = peg$currPos;
              s8 = peg$parsesequence_sep();
              if (s8 !== peg$FAILED) {
                s9 = peg$parsetranslation();
                if (s9 !== peg$FAILED) {
                  s8 = [s8, s9];
                  s7 = s8;
                } else {
                  peg$currPos = s7;
                  s7 = peg$c1;
                }
              } else {
                peg$currPos = s7;
                s7 = peg$c1;
              }
              while (s7 !== peg$FAILED) {
                s6.push(s7);
                s7 = peg$currPos;
                s8 = peg$parsesequence_sep();
                if (s8 !== peg$FAILED) {
                  s9 = peg$parsetranslation();
                  if (s9 !== peg$FAILED) {
                    s8 = [s8, s9];
                    s7 = s8;
                  } else {
                    peg$currPos = s7;
                    s7 = peg$c1;
                  }
                } else {
                  peg$currPos = s7;
                  s7 = peg$c1;
                }
              }
              if (s6 !== peg$FAILED) {
                s5 = [s5, s6];
                s4 = s5;
              } else {
                peg$currPos = s4;
                s4 = peg$c1;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$c1;
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parsesp();
              if (s5 !== peg$FAILED) {
                if (peg$c144.test(input.charAt(peg$currPos))) {
                  s6 = input.charAt(peg$currPos);
                  peg$currPos++;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$c145); }
                }
                if (s6 !== peg$FAILED) {
                  peg$reportedPos = s0;
                  s1 = peg$c146(s4);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$c1;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$c1;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$c1;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsetranslation_sequence() {
      var s0, s1, s2, s3, s4, s5, s6, s7, s8;

      s0 = peg$currPos;
      s1 = peg$parsesp();
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 44) {
          s3 = peg$c19;
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c20); }
        }
        if (s3 !== peg$FAILED) {
          s4 = peg$parsesp();
          if (s4 !== peg$FAILED) {
            s3 = [s3, s4];
            s2 = s3;
          } else {
            peg$currPos = s2;
            s2 = peg$c1;
          }
        } else {
          peg$currPos = s2;
          s2 = peg$c1;
        }
        if (s2 === peg$FAILED) {
          s2 = peg$c2;
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$currPos;
          s4 = peg$parsetranslation();
          if (s4 !== peg$FAILED) {
            s5 = [];
            s6 = peg$currPos;
            s7 = peg$parsesequence_sep();
            if (s7 !== peg$FAILED) {
              s8 = peg$parsetranslation();
              if (s8 !== peg$FAILED) {
                s7 = [s7, s8];
                s6 = s7;
              } else {
                peg$currPos = s6;
                s6 = peg$c1;
              }
            } else {
              peg$currPos = s6;
              s6 = peg$c1;
            }
            while (s6 !== peg$FAILED) {
              s5.push(s6);
              s6 = peg$currPos;
              s7 = peg$parsesequence_sep();
              if (s7 !== peg$FAILED) {
                s8 = peg$parsetranslation();
                if (s8 !== peg$FAILED) {
                  s7 = [s7, s8];
                  s6 = s7;
                } else {
                  peg$currPos = s6;
                  s6 = peg$c1;
                }
              } else {
                peg$currPos = s6;
                s6 = peg$c1;
              }
            }
            if (s5 !== peg$FAILED) {
              s4 = [s4, s5];
              s3 = s4;
            } else {
              peg$currPos = s3;
              s3 = peg$c1;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$c1;
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c146(s3);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parsetranslation() {
      var s0, s1, s2, s3;

      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 30) {
        s1 = peg$c147;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c148); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseany_integer();
        if (s2 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 30) {
            s3 = peg$c147;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c148); }
          }
          if (s3 !== peg$FAILED) {
            peg$reportedPos = s0;
            s1 = peg$c149(s2);
            s0 = s1;
          } else {
            peg$currPos = s0;
            s0 = peg$c1;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseinteger() {
      var s0, s1, s2, s3, s4;

      s0 = peg$currPos;
      s1 = peg$currPos;
      if (peg$c63.test(input.charAt(peg$currPos))) {
        s2 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s2 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c64); }
      }
      if (s2 !== peg$FAILED) {
        if (peg$c63.test(input.charAt(peg$currPos))) {
          s3 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c64); }
        }
        if (s3 === peg$FAILED) {
          s3 = peg$c2;
        }
        if (s3 !== peg$FAILED) {
          if (peg$c63.test(input.charAt(peg$currPos))) {
            s4 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s4 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c64); }
          }
          if (s4 === peg$FAILED) {
            s4 = peg$c2;
          }
          if (s4 !== peg$FAILED) {
            s2 = [s2, s3, s4];
            s1 = s2;
          } else {
            peg$currPos = s1;
            s1 = peg$c1;
          }
        } else {
          peg$currPos = s1;
          s1 = peg$c1;
        }
      } else {
        peg$currPos = s1;
        s1 = peg$c1;
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$currPos;
        peg$silentFails++;
        if (peg$c63.test(input.charAt(peg$currPos))) {
          s3 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$c64); }
        }
        if (s3 === peg$FAILED) {
          if (input.substr(peg$currPos, 4) === peg$c150) {
            s3 = peg$c150;
            peg$currPos += 4;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c151); }
          }
        }
        peg$silentFails--;
        if (s3 === peg$FAILED) {
          s2 = peg$c9;
        } else {
          peg$currPos = s2;
          s2 = peg$c1;
        }
        if (s2 !== peg$FAILED) {
          peg$reportedPos = s0;
          s1 = peg$c152(s1);
          s0 = s1;
        } else {
          peg$currPos = s0;
          s0 = peg$c1;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$c1;
      }

      return s0;
    }

    function peg$parseany_integer() {
      var s0, s1, s2;

      s0 = peg$currPos;
      s1 = [];
      if (peg$c63.test(input.charAt(peg$currPos))) {
        s2 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s2 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c64); }
      }
      if (s2 !== peg$FAILED) {
        while (s2 !== peg$FAILED) {
          s1.push(s2);
          if (peg$c63.test(input.charAt(peg$currPos))) {
            s2 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c64); }
          }
        }
      } else {
        s1 = peg$c1;
      }
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c152(s1);
      }
      s0 = s1;

      return s0;
    }

    function peg$parseword() {
      var s0, s1, s2;

      s0 = peg$currPos;
      s1 = [];
      if (peg$c153.test(input.charAt(peg$currPos))) {
        s2 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s2 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c154); }
      }
      if (s2 !== peg$FAILED) {
        while (s2 !== peg$FAILED) {
          s1.push(s2);
          if (peg$c153.test(input.charAt(peg$currPos))) {
            s2 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c154); }
          }
        }
      } else {
        s1 = peg$c1;
      }
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c155(s1);
      }
      s0 = s1;

      return s0;
    }

    function peg$parseword_parenthesis() {
      var s0, s1;

      s0 = peg$currPos;
      if (peg$c142.test(input.charAt(peg$currPos))) {
        s1 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c143); }
      }
      if (s1 !== peg$FAILED) {
        peg$reportedPos = s0;
        s1 = peg$c156(s1);
      }
      s0 = s1;

      return s0;
    }

    function peg$parsesp() {
      var s0;

      s0 = peg$parsespace();
      if (s0 === peg$FAILED) {
        s0 = peg$c2;
      }

      return s0;
    }

    function peg$parsespace() {
      var s0, s1;

      s0 = [];
      if (peg$c157.test(input.charAt(peg$currPos))) {
        s1 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$c158); }
      }
      if (s1 !== peg$FAILED) {
        while (s1 !== peg$FAILED) {
          s0.push(s1);
          if (peg$c157.test(input.charAt(peg$currPos))) {
            s1 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$c158); }
          }
        }
      } else {
        s0 = peg$c1;
      }

      return s0;
    }

    peg$result = peg$startRuleFunction();

    if (peg$result !== peg$FAILED && peg$currPos === input.length) {
      return peg$result;
    } else {
      if (peg$result !== peg$FAILED && peg$currPos < input.length) {
        peg$fail({ type: "end", description: "end of input" });
      }

      throw peg$buildException(null, peg$maxFailExpected, peg$maxFailPos);
    }
  }

  return {
    SyntaxError: SyntaxError,
    parse:       parse
  };
})();


}).call(this);
