bcv_parser::regexps.space = "[\\s\\xa0]"
bcv_parser::regexps.escaped_passage = ///
	(?:^ | [^\x1f\x1e\dA-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ] )	# Beginning of string or not in the middle of a word or immediately following another book. Only count a book if it's part of a sequence: `Matt5John3` is OK, but not `1Matt5John3`
		(
			# Start inverted book/chapter (cb)
			(?:
				  (?: ch (?: apters? | a?pts?\.? | a?p?s?\.? )? \s*
					\d+ \s* (?: [\u2013\u2014\-] | through | thru | to) \s* \d+ \s*
					(?: from | of | in ) (?: \s+ the \s+ book \s+ of )?\s* )
				| (?: ch (?: apters? | a?pts?\.? | a?p?s?\.? )? \s*
					\d+ \s*
					(?: from | of | in ) (?: \s+ the \s+ book \s+ of )?\s* )
				| (?: \d+ (?: th | nd | st ) \s*
					ch (?: apter | a?pt\.? | a?p?\.? )? \s* #no plurals here since it's a single chapter
					(?: from | of | in ) (?: \s+ the \s+ book \s+ of )? \s* )
			)? # End inverted book/chapter (cb)
			\x1f(\d+)(?:/\d+)?\x1f		#book
				(?:
				    /\d+\x1f				#special Psalm chapters
				  | [\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014]
				  | title (?! [a-z] )		#could be followed by a number
				  | see#{bcv_parser::regexps.space}+also | ff(?![a-z0-9]) | f(?![a-z0-9]) | chapters | chapter | through | compare | chapts | verses | chpts | chapt | chaps | verse | chap | thru | also | chp | chs | cha | and | see | ver | vss | ch | to | cf | vs | vv | v
				  | [a-e] (?! \w )			#a-e allows 1:1a
				  | $						#or the end of the string
				 )+
		)
	///gi
# These are the only valid ways to end a potential passage match. The closing parenthesis allows for fully capturing parentheses surrounding translations (ESV**)**. The last one, `[\d\x1f]` needs not to be +; otherwise `Gen5ff` becomes `\x1f0\x1f5ff`, and `adjust_regexp_end` matches the `\x1f5` and incorrectly dangles the ff.
bcv_parser::regexps.match_end_split = ///
	  \d \W* title
	| \d \W* (?:ff(?![a-z0-9])|f(?![a-z0-9])) (?: [\s\xa0*]* \.)?
	| \d [\s\xa0*]* [a-e] (?! \w )
	| \x1e (?: [\s\xa0*]* [)\]\uff09] )? #ff09 is a full-width closing parenthesis
	| [\d\x1f]
	///gi
bcv_parser::regexps.control = /[\x1e\x1f]/g
bcv_parser::regexps.pre_book = "[^A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ]"

bcv_parser::regexps.first = "(?:1st|1|I|First)\\.?#{bcv_parser::regexps.space}*"
bcv_parser::regexps.second = "(?:2nd|2|II|Second)\\.?#{bcv_parser::regexps.space}*"
bcv_parser::regexps.third = "(?:3rd|3|III|Third)\\.?#{bcv_parser::regexps.space}*"
bcv_parser::regexps.range_and = "(?:[&\u2013\u2014-]|(?:and|compare|cf|see#{bcv_parser::regexps.space}+also|also|see)|(?:through|thru|to))"
bcv_parser::regexps.range_only = "(?:[\u2013\u2014-]|(?:through|thru|to))"
# Each book regexp should return two parenthesized objects: an optional preliminary character and the book itself.
bcv_parser::regexps.get_books = (include_apocrypha, case_sensitive) ->
	books = [
		osis: ["Ps"]
		apocrypha: true
		extra: "2"
		regexp: ///(\b)( # Don't match a preceding \d like usual because we only want to match a valid OSIS, which will never have a preceding digit.
			Ps151
			# Always follwed by ".1"; the regular Psalms parser can handle `Ps151` on its own.
			)(?=\.1)///g # Case-sensitive because we only want to match a valid OSIS.
	,
		osis: ["Gen"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:E(?:nsimmainen[\s\xa0]*Mooseksen[\s\xa0]*kirja|erste[\s\xa0]*Mozes|lso[\s\xa0]*Mozes|rste[\s\xa0]*(?:Buch[\s\xa0]*Mose|Mose))|P(?:urwaning[\s\xa0]*Dumadi|rv(?:ni[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Mojzisova)|a[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Mojzisova)|y[\s\xa0]*(?:list[\s\xa0]*Mojzisova|Mojzisova))|ierwsz(?:[aey][\s\xa0]*(?:Ks(?:ieg(?:[ai][\s\xa0]*Mo(?:jzeszowa|yzeszowe))|\.[\s\xa0]*Mo(?:jzeszowa|yzeszowe)|[\s\xa0]*Mo(?:jzeszowa|yzeszowe))|Mojz(?:eszowa)?))|ost(?:anak)?)|M(?:ozes[\s\xa0]*I|wa(?:nzo)?)|F(?:orsta[\s\xa0]*Mosebok(?:en)?|yrsta[\s\xa0]*(?:bok[\s\xa0]*Mose|Mosebok)|acerea)|I(?:\.[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Ks(?:ieg(?:[ai][\s\xa0]*Mo(?:jzeszowa|yzeszowe))|\.[\s\xa0]*Mo(?:jzeszowa|yzeszowe)|[\s\xa0]*Mo(?:jzeszowa|yzeszowe))|Mo(?:oseksen[\s\xa0]*kirja|zes|jz(?:eszowa|isova)?|s(?:ebok)?))|[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Ks(?:ieg(?:[ai][\s\xa0]*Mo(?:jzeszowa|yzeszowe))|\.[\s\xa0]*Mo(?:jzeszowa|yzeszowe)|[\s\xa0]*Mo(?:jzeszowa|yzeszowe))|Mo(?:oseksen[\s\xa0]*kirja|zes|j(?:z(?:eszowa|isova)?)?|s(?:ebok)?)))|1(?:e(?:\.[\s\xa0]*Mozes|[\s\xa0]*Mozes)|\.[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Ks(?:ieg(?:[ai][\s\xa0]*Mo(?:jzeszowa|yzeszowe))|\.[\s\xa0]*Mo(?:jzeszowa|yzeszowe)|[\s\xa0]*Mo(?:jzeszowa|yzeszowe))|Buch[\s\xa0]*Mose|Mo(?:oseksen[\s\xa0]*kirja|zes|jz(?:eszowa|isova)?|s(?:e(?:bo(?:g|k(?:en)?))?)?)?)|[\s\xa0]*(?:Ks(?:ieg(?:[ai][\s\xa0]*Mo(?:jzeszowa|yzeszowe))|\.[\s\xa0]*Mo(?:jzeszowa|yzeszowe)|[\s\xa0]*Mo(?:jzeszowa|yzeszowe))|k(?:niha[\s\xa0]*Mojzisova|\.[\s\xa0]*Mojzisova|[\s\xa0]*Mojzisova)|Buch[\s\xa0]*Mose|M(?:o(?:os(?:eksen[\s\xa0]*kirja)?|j(?:z(?:eszowa|isova)?)?|s(?:e(?:bo(?:g|k(?:en)?))?)?|z(?:es)?)?|z)))|Henesis|G(?:e(?:n(?:i(?:[ei]s(?:[eiu]s)|s[eiu]s)|n(?:i(?:[ei]s(?:[eiu]s)|s[eiu]s)|e(?:es[eiu]s|s[eiu]s|is(?:[eiu]s)?)|sis)|e(?:es[eiu]s|is(?:[eiu]s)?|s(?:us|[ai]|es?)|z(?:is|a))|sis)?)?|n)|R(?:odz|dz)|Liber[\s\xa0]*Genesis|B(?:eresjiet|ilowgii|uttja)|liv[\s\xa0]*Konmansman[\s\xa0]*an|Ter(?:emtes)?|K(?:itabu[\s\xa0]*cha[\s\xa0]*Kwanza[\s\xa0]*cha[\s\xa0]*Musa|n(?:jiga[\s\xa0]*Postanka|iha[\s\xa0]*(?:stvorenia|povodu))|s(?:ieg[ai][\s\xa0]*Rodzaju|\.[\s\xa0]*Rodzaju|[\s\xa0]*Rodzaju)|\.[\s\xa0]*(?:stvorenia|povodu)|[\s\xa0]*(?:stvorenia|povodu))|Zan(?:afilla)?|Atiyakamam|utpat(?:ti(?:ko[\s\xa0]*pustak)?)?|Utpaati|Jen(?:ez)?)|(?:Ensimmainen[\s\xa0]*Mooseksen|(?:[I1](?:\.[\s\xa0]*Mooseksen|[\s\xa0]*Mooseksen))|Konmansman|utpattiko|Genesis)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Exod"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:Onnur[\s\xa0]*(?:bok[\s\xa0]*Mose|Mosebok)|Nirgaman|An(?:nen[\s\xa0]*Mosebok|d(?:en[\s\xa0]*Mos(?:ebog)?|r(?:a[\s\xa0]*Mosebok(?:en)?|e[\s\xa0]*Mos(?:ebok)?)))|I(?:esirea|I(?:\.[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|Mo(?:oseksen[\s\xa0]*kirja|zes|jz(?:eszowa|isova)?|s(?:ebok)?))|[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|Mo(?:oseksen[\s\xa0]*kirja|zes|j(?:z(?:eszowa|isova)?)?|s(?:ebok)?)))|zl(?:azak)?)|T(?:oinen[\s\xa0]*Mooseksen[\s\xa0]*kirja|weede[\s\xa0]*Mozes)|M(?:asodik[\s\xa0]*Mozes|ozes[\s\xa0]*II)|Bax(?:niintii)?|Sjemot|nirgam|Vyhid|Pangentasan|D(?:ru(?:h(?:a[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Mojzisova)|y[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|list[\s\xa0]*Mojzisova|Mojzisova))|g[ai][\s\xa0]*(?:Ks(?:ieg(?:[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|Mojz(?:eszowa)?)))|al(?:ja)?)|liv[\s\xa0]*delivrans[\s\xa0]*lan|2(?:e(?:\.[\s\xa0]*Mozes|[\s\xa0]*Mozes)|\.[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|Buch[\s\xa0]*Mose|Mo(?:oseksen[\s\xa0]*kirja|zes|jz(?:eszowa|isova)?|s(?:e(?:bo(?:g|k(?:en)?))?)?)?)|[\s\xa0]*(?:Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|k(?:niha[\s\xa0]*Mojzisova|\.[\s\xa0]*Mojzisova|[\s\xa0]*Mojzisova)|Buch[\s\xa0]*Mose|M(?:o(?:os(?:eksen[\s\xa0]*kirja)?|j(?:z(?:eszowa|isova)?)?|s(?:e(?:bo(?:g|k(?:en)?))?)?|z(?:es)?)?|z)))|Liber[\s\xa0]*Exodus|K(?:njiga[\s\xa0]*Izlaska|s(?:ieg[ai][\s\xa0]*Wyjscia|\.[\s\xa0]*Wyjscia|[\s\xa0]*Wyjscia)|i(?:tabu[\s\xa0]*cha[\s\xa0]*Pili[\s\xa0]*cha[\s\xa0]*Musa|v(?:onulas)?)|ut(?:oka)?)|Yattirakamam|Zweite[\s\xa0]*(?:Buch[\s\xa0]*Mose|Mose)|W(?:yj|j)|E(?:sodo|cs(?:odus)?|gz(?:od(?:us)?)?|ks(?:od[io])?|x(?:d|o(?:d(?:is|ul|[eos])?)?)?))|Drug(?:[ai][\s\xa0]*(?:Ks(?:\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|Mojz(?:eszowa)?))|(?:Toinen[\s\xa0]*Mooseksen|II(?:\.[\s\xa0]*Mooseksen|[\s\xa0]*Mooseksen)|2(?:\.[\s\xa0]*Mooseksen|[\s\xa0]*Mooseksen)|Delivrans|Exodus)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Bel"]
		apocrypha: true
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Danieli[\s\xa0]*na[\s\xa0]*Makuhani[\s\xa0]*wa[\s\xa0]*Beli|Opowiadaniem[\s\xa0]*o[\s\xa0]*Belu[\s\xa0]*i[\s\xa0]*wezu|Histoia[\s\xa0]*Beli[\s\xa0]*et[\s\xa0]*draconis|Si[\s\xa0]*Bel[\s\xa0]*at[\s\xa0]*ang[\s\xa0]*Dragon|Istoria[\s\xa0]*(?:omorarii[\s\xa0]*balaurului[\s\xa0]*si[\s\xa0]*a[\s\xa0]*sfaramarii[\s\xa0]*lui[\s\xa0]*Bel|Balaurului)|B(?:aal[\s\xa0]*es[\s\xa0]*a[\s\xa0]*sarkany|el(?:a[\s\xa0]*i[\s\xa0]*weza|[\s\xa0]*(?:und[\s\xa0]*Vom[\s\xa0]*Drachen|ja[\s\xa0]*lohikaarme|si[\s\xa0]*dragonul|y[\s\xa0]*el[\s\xa0]*(?:Serpiente|Dragon)|e(?:s[\s\xa0]*a[\s\xa0]*sarkany|n[\s\xa0]*de[\s\xa0]*draak|t[\s\xa0]*(?:le[\s\xa0]*(?:Serpent|Dragon)|draconis)|[\s\xa0]*(?:il[\s\xa0]*Drago|o[\s\xa0]*Dragao))|o(?:ch[\s\xa0]*Ormguden|g[\s\xa0]*dr(?:ekinn|a(?:gen[\s\xa0]*i[\s\xa0]*Babylon|ken)))|&[\s\xa0]*(?:the[\s\xa0]*(?:Dragon|S(?:erpent|nake))|Dragon|S(?:erpent|nake))|a(?:['’]r[\s\xa0]*Ddraig|nd[\s\xa0]*(?:the[\s\xa0]*(?:Dragon|S(?:erpent|nake))|Dragon|S(?:erpent|nake))|[\s\xa0]*drak)))))|Bel(?:[\s\xa0]*(?:at[\s\xa0]*ang[\s\xa0]*Dragon|e(?:t[\s\xa0]*le[\s\xa0]*(?:serpent|dragon)|[\s\xa0]*o[\s\xa0]*dragao)|og[\s\xa0]*Dragen))?
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Phlm"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Epistula(?:m[\s\xa0]*ad[\s\xa0]*Philemonem|[\s\xa0]*ad[\s\xa0]*Philemonem)|Waraka[\s\xa0]*kwa[\s\xa0]*Filemoni|B(?:arua[\s\xa0]*kwa[\s\xa0]*Filemoni|re(?:f[\s\xa0]*Pals[\s\xa0]*til[\s\xa0]*Filemons|vet[\s\xa0]*til(?:l[\s\xa0]*Filemon|[\s\xa0]*Filemon)))|L(?:ettera[\s\xa0]*a[\s\xa0]*Filemone|ist[\s\xa0]*(?:do[\s\xa0]*Filemona|Filemonovi))|K(?:irje[\s\xa0]*Filemonille|a(?:ng[\s\xa0]*Filemon|y[\s\xa0]*Filemon))|P(?:oslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*Fylymona|ilemonukku[\s\xa0]*Elutiya[\s\xa0]*Nirupam|a(?:vlova[\s\xa0]*poslanica[\s\xa0]*Filemonu|ulus['’][\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Filemon)|h(?:ile(?:m(?:on(?:hoz)?)?)?|l(?:[ei]mon|mn?)|mn?))|F(?:lmn?|i(?:l(?:em(?:o(?:n(?:brevet|hoz|it)|m))?|im(?:on)?|m))?|mn?))|(?:ad[\s\xa0]*Philemonem|P(?:aulus’[\s\xa0]*brev[\s\xa0]*til[\s\xa0]*Filemon|oslanica[\s\xa0]*Filemonu|ilemonukku|hilemonem)|Filemon(?:ovi|i(?:lle)?|[uae])?)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Lev"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		le(?:viharuko[\s\xa0]*pustak|wiy)|(?:K(?:itabu[\s\xa0]*cha[\s\xa0]*Tatu[\s\xa0]*cha[\s\xa0]*Musa|olmas[\s\xa0]*Mooseksen[\s\xa0]*kirja|a(?:imaman|pl)|pl)|D(?:erde[\s\xa0]*Mozes|ritte[\s\xa0]*(?:Buch[\s\xa0]*Mose|Mose))|L(?:i(?:ber[\s\xa0]*Leviticus|v[ei]t(?:(?:[ei]cus|cus)))|a(?:a(?:ivyavyavastha|w(?:iyiintii)?)|w)|e(?:b(?:iti(?:co|k(?:us|o)))?|f(?:iticus)?|v(?:et(?:[ei]cus|cus)|yt|i(?:yarakamam|t(?:ski[\s\xa0]*zakonik|ecus|cus|ak|i(?:que|c(?:u(?:si|l)|os?)?|k(?:et|us?)?)))?)?)?|v)|Harmadik[\s\xa0]*Mozes|Vajikra|Wa(?:jikra|l)|liv[\s\xa0]*Prensip[\s\xa0]*lavi[\s\xa0]*nan[\s\xa0]*Bondye|M(?:ambo[\s\xa0]*ya[\s\xa0]*Walawi|ozes[\s\xa0]*III)|3(?:e(?:\.[\s\xa0]*Mo(?:sebok(?:en)?|zes)|[\s\xa0]*Mo(?:sebok(?:en)?|zes))|\.[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|Buch[\s\xa0]*Mose|Mo(?:oseksen[\s\xa0]*kirja|zes|jz(?:eszowa|isova)?|s(?:e(?:bo(?:g|k(?:en)?))?)?)?)|[\s\xa0]*(?:Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|k(?:niha[\s\xa0]*Mojzisova|\.[\s\xa0]*Mojzisova|[\s\xa0]*Mojzisova)|Buch[\s\xa0]*Mose|M(?:o(?:os(?:eksen[\s\xa0]*kirja)?|j(?:z(?:eszowa|isova)?)?|s(?:e(?:bo(?:g|k(?:en)?))?)?|z(?:es)?)?|z)))|III(?:\.[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|Mo(?:oseksen[\s\xa0]*kirja|zes|jz(?:eszowa|isova)?|s(?:ebok)?))|[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|Mo(?:oseksen[\s\xa0]*kirja|zes|j(?:z(?:eszowa|isova)?)?|s(?:ebok)?)))|Tr(?:zeci(?:a[\s\xa0]*(?:Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|Mojz(?:eszowa)?)|[\s\xa0]*(?:Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|Mojz(?:eszowa)?))|e(?:ti(?:a[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Mojzisova)|[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Mojzisova))|dje[\s\xa0]*Mos(?:ebo(?:g|k(?:en)?))?)))|(?:Kolmas[\s\xa0]*Mooseksen|III(?:\.[\s\xa0]*Mooseksen|[\s\xa0]*Mooseksen)|3(?:\.[\s\xa0]*Mooseksen|[\s\xa0]*Mooseksen)|leviharuko|Leviticus|Walawi)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["2Thess"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		2[\s\xa0]*Tessalonikerbrevet|2(?:\.[\s\xa0]*Tessalonikerbrevet|[\s\xa0]*tessalonikerbrev)|(?:D(?:e(?:uxieme(?:s[\s\xa0]*Thes(?:saloniciens|aloniciens)|[\s\xa0]*Thes(?:saloniciens|aloniciens))|zyem[\s\xa0]*Tesalonik(?:yen)?)|ru(?:g(?:a[\s\xa0]*(?:Solunjanima[\s\xa0]*Poslanica|List[\s\xa0]*do[\s\xa0]*Tesaloniczan|Tesalonic(?:ensow|zan))|i[\s\xa0]*(?:List[\s\xa0]*do[\s\xa0]*Tesaloniczan|Tesalonic(?:ensow|zan)))|h(?:e[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*solunjan|a[\s\xa0]*(?:kniha[\s\xa0]*(?:Tesalonic(?:anom|kym)|Solun(?:canom|skym))|list[\s\xa0]*(?:Tesalonickym|Solunskym)|Sol(?:un(?:canom|skym))?|Te(?:s(?:salonicenskym|alonic(?:anom|kym)))?)|y[\s\xa0]*(?:list[\s\xa0]*(?:Tesalonic(?:anom|kym)|Solun(?:canom|skym))|Sol(?:un(?:canom|skym))?|Te(?:s(?:salonicenskym|alonic(?:anom|kym)))?))))|Zweite[\s\xa0]*Thessalonicher|Se(?:gund(?:a[\s\xa0]*Tessalonicenses|o[\s\xa0]*Tes(?:salonicenses|aloni[cs]enses?))|cond(?:a[\s\xa0]*(?:lettera[\s\xa0]*ai[\s\xa0]*Tessalonicesi|Tessalonicesi)|o[\s\xa0]*Tessalonicesi|[\s\xa0]*Th(?:es(?:al(?:lonians|oni(?:[ci]ans|ons|ans?|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:i[ae]ns|ans)|ions|ens|(?:[ao](?:ans|ns?))|ns)))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s)?)?|s(?:ss?)?)?))|And(?:e(?:t[\s\xa0]*Thessalonikerbrev|n[\s\xa0]*T(?:essalonikerne|hess(?:alonikerbrev)?))|r(?:a[\s\xa0]*T(?:hessalonikerbrevet|essalonikerbrevet)|e[\s\xa0]*(?:tessalonikerbrev|Tess(?:aloniker(?:ne)?)?)))|Epistula[\s\xa0]*(?:II[\s\xa0]*ad[\s\xa0]*Thessalonicenses|ad[\s\xa0]*Thessalonicenses[\s\xa0]*II)|Barua[\s\xa0]*ya[\s\xa0]*Pili[\s\xa0]*kwa[\s\xa0]*Wathesalonike|Masodik[\s\xa0]*T(?:hessz(?:alonika(?:iakhoz)?)?|essz(?:alonika(?:iakhoz)?)?)|2(?:a(?:\.[\s\xa0]*Tessalonicenses|[\s\xa0]*Tessalonicenses)|d(?:\.[\s\xa0]*Thes(?:saloniciens|aloniciens)|e(?:\.[\s\xa0]*Thes(?:saloniciens|aloniciens)|[\s\xa0]*Thes(?:saloniciens|aloniciens))|[\s\xa0]*Thes(?:saloniciens|aloniciens))|o(?:\.[\s\xa0]*Tes(?:salonicenses|aloni[cs]enses?)|[\s\xa0]*Tes(?:salonicenses|aloni[cs]enses?))|Thess|e(?:me(?:\.[\s\xa0]*Thes(?:saloniciens|aloniciens)|[\s\xa0]*Thes(?:saloniciens|aloniciens))|\.[\s\xa0]*T(?:hes(?:aloniciens|s(?:alonic(?:enzen|iens))?)|es(?:s(?:alonicenzen)?)?)|[\s\xa0]*T(?:hes(?:aloniciens|s(?:alonic(?:enzen|iens))?)|es(?:s(?:alonicenzen)?)?))|nd(?:\.[\s\xa0]*Th(?:es(?:al(?:lonians|oni(?:[ci]ans|ons|ans?|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:i[ae]ns|ans)|ions|ens|(?:[ao](?:ans|ns?))|ns)))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s)?)?|s(?:ss?)?)?|[\s\xa0]*Th(?:es(?:al(?:lonians|oni(?:[ci]ans|ons|ans?|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:i[ae]ns|ans)|ions|ens|(?:[ao](?:ans|ns?))|ns)))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s)?)?|s(?:ss?)?)?)|\.(?:o(?:\.[\s\xa0]*Tesaloni[cs]enses?|[\s\xa0]*Tesaloni[cs]enses?)|[\s\xa0]*(?:Kirje[\s\xa0]*tessalonikalaisille|List[\s\xa0]*do[\s\xa0]*Tesaloniczan|Mga[\s\xa0]*T(?:aga(?:[\s\xa0]*Tesaloni[ck]a|-?(?:[\s\xa0]*Tesaloni[ck]a|Tesaloni[ck]a))|esaloni[cs]ense)|tessalonikerbrev|list[\s\xa0]*(?:Tesalonickym|Solunskym)|Wathesalonike|S(?:elanikasve|ol(?:un(?:janima[\s\xa0]*Poslanica|canom|skym))?)|T(?:aga-?Tesaloni[ck]a|e(?:s(?:aloni(?:senses?|ika|c(?:en(?:s(?:ow|es?)|i)|kym|zan|a(?:nom)?)|k(?:yen|a)?)|s(?:aloni(?:ce(?:n(?:s(?:kym|es)|zen)|si)|k(?:alais(?:kirje|ille)|er(?:ne)?))|z(?:alonika(?:iakhoz)?)?)?)?)?|h(?:aissaluneekiyon|e(?:s(?:al(?:lonians|oni(?:kasve|c(?:iens|ans)|ians|ons|a(?:id|ns?)|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:kerbrev(?:et)?|c(?:en(?:ses|zen)|i[ae]ns|ans|her)|ions|ens|a(?:ans|id|ns?)|ns|o(?:ans|ns?))))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s|z(?:alonika(?:iakhoz)?)?)?)?)?|s(?:ss?)?)?)))|[\s\xa0]*(?:Mga[\s\xa0]*T(?:aga(?:[\s\xa0]*Tesaloni[ck]a|-?(?:[\s\xa0]*Tesaloni[ck]a|Tesaloni[ck]a))|esaloni[cs]ense)|Kirje[\s\xa0]*tessalonikalaisille|k(?:\.[\s\xa0]*(?:Tesalonic(?:anom|kym)|Solun(?:canom|skym))|[\s\xa0]*(?:Tesalonic(?:anom|kym)|Solun(?:canom|skym)))|T(?:aga-?Tesaloni[ck]a|e(?:calonikkiyarukku|s(?:aloni(?:senses?|ika|c(?:en(?:s(?:ow|es?)|i)|kym|zan|a(?:nom)?)|k(?:yen|a)?)|s(?:aloni(?:ce(?:n(?:s(?:kym|es)|zen)|si)|k(?:alais(?:kirje|ille)|er(?:ne)?))|z(?:alonika(?:iakhoz)?)?)?)?)?|h(?:aissaluneekiyon|e(?:s(?:al(?:lonians|oni(?:kasve|c(?:iens|ans)|ians|ons|a(?:id|ns?)|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:kerbrev(?:et)?|c(?:en(?:ses|zen)|i[ae]ns|ans|her)|ions|ens|a(?:ans|id|ns?)|ns|o(?:ans|ns?))))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s|z(?:alonika(?:iakhoz)?)?)?)?)?|s(?:ss?)?)?|s)|Wathesalonike|list[\s\xa0]*(?:Tesalonickym|Solunskym)|(?:[ie](?:\.[\s\xa0]*(?:Thesalonikasve|Selanikasve)|[\s\xa0]*(?:Thesalonikasve|Selanikasve)))|List[\s\xa0]*do[\s\xa0]*Tesaloniczan|S(?:elanikasve|ol(?:un(?:janima[\s\xa0]*Poslanica|canom|skym))?)))|P(?:a(?:ulus(?:'[\s\xa0]*Andet[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Thessalonikerne|’[\s\xa0]*(?:Andet[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Thessalonikerne|andre[\s\xa0]*brev[\s\xa0]*til[\s\xa0]*tessalonikerne))|vlova[\s\xa0]*druga[\s\xa0]*poslanica[\s\xa0]*Solunjanima)|ili[\s\xa0]*(?:Wathesalonike|Th(?:es?)?))|T(?:oinen[\s\xa0]*(?:Kirje[\s\xa0]*tessalonikalaisille|Tessalonikalais(?:kirje|ille))|e(?:calonikkiyarukku[\s\xa0]*Elutiya[\s\xa0]*Irantavatu[\s\xa0]*Nirupam|soloniika[\s\xa0]*Labaad)|weede[\s\xa0]*T(?:hess(?:alonicenzen)?|es(?:s(?:alonicenzen)?)?))|I(?:kalawang[\s\xa0]*(?:Mga[\s\xa0]*T(?:aga(?:-?[\s\xa0]*Tesaloni[ck]a|[\s\xa0]*Tesaloni[ck]a)|esaloni[cs]ense)|Tesaloni(?:sense|c(?:ense|a)|ka))|I(?:\.[\s\xa0]*(?:Kirje[\s\xa0]*tessalonikalaisille|List[\s\xa0]*do[\s\xa0]*Tesaloniczan|Mga[\s\xa0]*T(?:aga(?:-?[\s\xa0]*Tesaloni[ck]a|[\s\xa0]*Tesaloni[ck]a)|esaloni[cs]ense)|list[\s\xa0]*(?:Tesalonickym|Solunskym)|Wathesalonike|Sol(?:un(?:janima[\s\xa0]*Poslanica|canom|skym))?|T(?:e(?:s(?:aloni(?:senses?|ika|c(?:en(?:s(?:ow|es?)|i)|kym|zan|a(?:nom)?)|k(?:yen|a)?)|s(?:aloni(?:kalais(?:kirje|ille)|ce(?:n(?:s(?:kym|es)|zen)|si))|z(?:alonika(?:iakhoz)?)?)?)?)?|h(?:e(?:s(?:al(?:lonians|oni(?:c(?:iens|ans)|ians|ons|a(?:id|ns?)|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:en(?:ses|zen)|i[ae]ns|ans)|ions|ens|a(?:ans|id|ns?)|ns|o(?:ans|ns?))))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s|z(?:alonika(?:iakhoz)?)?)?)?)?|s(?:ss?)?)?))|[\s\xa0]*(?:Kirje[\s\xa0]*tessalonikalaisille|List[\s\xa0]*do[\s\xa0]*Tesaloniczan|Mga[\s\xa0]*T(?:aga(?:-?[\s\xa0]*Tesaloni[ck]a|[\s\xa0]*Tesaloni[ck]a)|esaloni[cs]ense)|list[\s\xa0]*(?:Tesalonickym|Solunskym)|Wathesalonike|Sol(?:un(?:janima[\s\xa0]*Poslanica|canom|skym))?|T(?:e(?:s(?:aloni(?:senses?|ika|c(?:en(?:s(?:ow|es?)|i)|kym|zan|a(?:nom)?)|k(?:yen|a)?)|s(?:aloni(?:kalais(?:kirje|ille)|ce(?:n(?:s(?:kym|es)|zen)|si))|z(?:alonika(?:iakhoz)?)?)?)?)?|h(?:e(?:s(?:al(?:lonians|oni(?:c(?:iens|ans)|ians|ons|a(?:id|ns?)|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:en(?:ses|zen)|i[ae]ns|ans)|ions|ens|a(?:ans|id|ns?)|ns|o(?:ans|ns?))))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s|z(?:alonika(?:iakhoz)?)?)?)?)?|s(?:ss?)?)?))))|Wa(?:raka[\s\xa0]*wa[\s\xa0]*Pili[\s\xa0]*kwa[\s\xa0]*Wathesalonik[ei]|thesalonike[\s\xa0]*II))|(?:ad[\s\xa0]*Thessalonicenses[\s\xa0]*II|Thessalonicenses[\s\xa0]*II|Druga[\s\xa0]*(?:poslanica[\s\xa0]*Solunjanima|Solunjanima)|II(?:\.[\s\xa0]*Solunjanima|[\s\xa0]*Solunjanima)|2(?:\.[\s\xa0]*Solunjanima|[\s\xa0]*Solunjanima))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["1Thess"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		1[\s\xa0]*Tessalonikerbrevet|1(?:\.[\s\xa0]*Tessalonikerbrevet|[\s\xa0]*tessalonikerbrev)|(?:F(?:orsta[\s\xa0]*T(?:hessalonikerbrevet|essalonikerbrevet)|irst[\s\xa0]*Th(?:es(?:al(?:lonians|oni(?:[ci]ans|ons|ans?|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:i[ae]ns|ans)|ions|ens|(?:[ao](?:ans|ns?))|ns)))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s)?)?|s(?:ss?)?)?)|1(?:a(?:\.[\s\xa0]*Tessalonicenses|[\s\xa0]*Tessalonicenses)|re(?:\.[\s\xa0]*Thes(?:saloniciens|aloniciens)|[\s\xa0]*Thes(?:saloniciens|aloniciens))|o(?:\.[\s\xa0]*Tes(?:salonicenses|aloni[cs]enses?)|[\s\xa0]*Tes(?:salonicenses|aloni[cs]enses?))|Thess|e(?:r(?:\.[\s\xa0]*Thes(?:saloniciens|aloniciens)|e(?:\.[\s\xa0]*Thes(?:saloniciens|aloniciens)|[\s\xa0]*Thes(?:saloniciens|aloniciens))|[\s\xa0]*Thes(?:saloniciens|aloniciens))|\.[\s\xa0]*T(?:hess(?:alonicenzen)?|es(?:s(?:alonicenzen)?)?)|[\s\xa0]*T(?:hess(?:alonicenzen)?|es(?:s(?:alonicenzen)?)?))|st(?:\.[\s\xa0]*Th(?:es(?:al(?:lonians|oni(?:[ci]ans|ons|ans?|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:i[ae]ns|ans)|ions|ens|(?:[ao](?:ans|ns?))|ns)))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s)?)?|s(?:ss?)?)?|[\s\xa0]*Th(?:es(?:al(?:lonians|oni(?:[ci]ans|ons|ans?|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:i[ae]ns|ans)|ions|ens|(?:[ao](?:ans|ns?))|ns)))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s)?)?|s(?:ss?)?)?)|\.(?:o(?:\.[\s\xa0]*Tesaloni[cs]enses?|[\s\xa0]*Tesaloni[cs]enses?)|[\s\xa0]*(?:Kirje[\s\xa0]*tessalonikalaisille|List[\s\xa0]*do[\s\xa0]*Tesaloniczan|Mga[\s\xa0]*T(?:aga(?:[\s\xa0]*Tesaloni[ck]a|-?(?:[\s\xa0]*Tesaloni[ck]a|Tesaloni[ck]a))|esaloni[cs]ense)|tessalonikerbrev|list[\s\xa0]*(?:Tesalonickym|Solunskym)|Wathesalonike|S(?:elanikasve|ol(?:un(?:janima[\s\xa0]*Poslanica|canom|skym))?)|T(?:aga-?Tesaloni[ck]a|e(?:s(?:aloni(?:senses?|ika|c(?:en(?:s(?:ow|es?)|i)|kym|zan|a(?:nom)?)|k(?:yen|a)?)|s(?:aloni(?:ce(?:n(?:s(?:kym|es)|zen)|si)|k(?:alais(?:kirje|ille)|er(?:ne)?))|z(?:alonika(?:iakhoz)?)?)?)?)?|h(?:aissaluneekiyon|e(?:s(?:al(?:lonians|oni(?:kasve|c(?:iens|ans)|ians|ons|a(?:id|ns?)|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:kerbrev(?:et)?|c(?:en(?:ses|zen)|i[ae]ns|ans|her)|ions|ens|a(?:ans|id|ns?)|ns|o(?:ans|ns?))))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s|z(?:alonika(?:iakhoz)?)?)?)?)?|s(?:ss?)?)?)))|[\s\xa0]*(?:Mga[\s\xa0]*T(?:aga(?:[\s\xa0]*Tesaloni[ck]a|-?(?:[\s\xa0]*Tesaloni[ck]a|Tesaloni[ck]a))|esaloni[cs]ense)|Kirje[\s\xa0]*tessalonikalaisille|k(?:\.[\s\xa0]*(?:Tesalonic(?:anom|kym)|Solun(?:canom|skym))|[\s\xa0]*(?:Tesalonic(?:anom|kym)|Solun(?:canom|skym)))|T(?:aga-?Tesaloni[ck]a|e(?:calonikkiyarukku|s(?:aloni(?:senses?|ika|c(?:en(?:s(?:ow|es?)|i)|kym|zan|a(?:nom)?)|k(?:yen|a)?)|s(?:aloni(?:ce(?:n(?:s(?:kym|es)|zen)|si)|k(?:alais(?:kirje|ille)|er(?:ne)?))|z(?:alonika(?:iakhoz)?)?)?)?)?|h(?:aissaluneekiyon|e(?:s(?:al(?:lonians|oni(?:kasve|c(?:iens|ans)|ians|ons|a(?:id|ns?)|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:kerbrev(?:et)?|c(?:en(?:ses|zen)|i[ae]ns|ans|her)|ions|ens|a(?:ans|id|ns?)|ns|o(?:ans|ns?))))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s|z(?:alonika(?:iakhoz)?)?)?)?)?|s(?:ss?)?)?|s)|Wathesalonike|list[\s\xa0]*(?:Tesalonickym|Solunskym)|(?:[ie](?:\.[\s\xa0]*(?:Thesalonikasve|Selanikasve)|[\s\xa0]*(?:Thesalonikasve|Selanikasve)))|List[\s\xa0]*do[\s\xa0]*Tesaloniczan|S(?:elanikasve|ol(?:un(?:janima[\s\xa0]*Poslanica|canom|skym))?)))|Barua[\s\xa0]*ya[\s\xa0]*Kwanza[\s\xa0]*kwa[\s\xa0]*Wathesalonike|Wa(?:raka[\s\xa0]*wa[\s\xa0]*Kwanza[\s\xa0]*kwa[\s\xa0]*Wathesalonik[ei]|thesalonike[\s\xa0]*I)|Una(?:ng[\s\xa0]*(?:Mga[\s\xa0]*T(?:aga(?:-?[\s\xa0]*Tesaloni[ck]a|[\s\xa0]*Tesaloni[ck]a)|esaloni[cs]ense)|Tesaloni(?:sense|c(?:ense|a)|ka))|[\s\xa0]*(?:Mga[\s\xa0]*T(?:aga(?:-?[\s\xa0]*Tesaloni[ck]a|[\s\xa0]*Tesaloni[ck]a)|esaloni[cs]ense)|Tesaloni(?:sense|c(?:ense|a)|ka)))|E(?:nsimmainen[\s\xa0]*(?:Kirje[\s\xa0]*tessalonikalaisille|Tessalonikalais(?:kirje|ille))|pistula[\s\xa0]*(?:I[\s\xa0]*ad[\s\xa0]*Thessalonicenses|ad[\s\xa0]*Thessalonicenses[\s\xa0]*I)|rste[\s\xa0]*Thessalonicher|erste[\s\xa0]*T(?:hess(?:alonicenzen)?|es(?:s(?:alonicenzen)?)?)|lso[\s\xa0]*T(?:hessz(?:alonika(?:iakhoz)?)?|essz(?:alonika(?:iakhoz)?)?))|I(?:\.[\s\xa0]*(?:Kirje[\s\xa0]*tessalonikalaisille|List[\s\xa0]*do[\s\xa0]*Tesaloniczan|Mga[\s\xa0]*T(?:aga(?:-?[\s\xa0]*Tesaloni[ck]a|[\s\xa0]*Tesaloni[ck]a)|esaloni[cs]ense)|list[\s\xa0]*(?:Tesalonickym|Solunskym)|Wathesalonike|Sol(?:un(?:janima[\s\xa0]*Poslanica|canom|skym))?|T(?:e(?:s(?:aloni(?:senses?|ika|c(?:en(?:s(?:ow|es?)|i)|kym|zan|a(?:nom)?)|k(?:yen|a)?)|s(?:aloni(?:kalais(?:kirje|ille)|ce(?:n(?:s(?:kym|es)|zen)|si))|z(?:alonika(?:iakhoz)?)?)?)?)?|h(?:e(?:s(?:al(?:lonians|oni(?:c(?:iens|ans)|ians|ons|a(?:id|ns?)|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:en(?:ses|zen)|i[ae]ns|ans)|ions|ens|a(?:ans|id|ns?)|ns|o(?:ans|ns?))))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s|z(?:alonika(?:iakhoz)?)?)?)?)?|s(?:ss?)?)?))|[\s\xa0]*(?:Kirje[\s\xa0]*tessalonikalaisille|List[\s\xa0]*do[\s\xa0]*Tesaloniczan|Mga[\s\xa0]*T(?:aga(?:-?[\s\xa0]*Tesaloni[ck]a|[\s\xa0]*Tesaloni[ck]a)|esaloni[cs]ense)|list[\s\xa0]*(?:Tesalonickym|Solunskym)|Wathesalonike|Sol(?:un(?:janima[\s\xa0]*Poslanica|canom|skym))?|T(?:e(?:s(?:aloni(?:senses?|ika|c(?:en(?:s(?:ow|es?)|i)|kym|zan|a(?:nom)?)|k(?:yen|a)?)|s(?:aloni(?:kalais(?:kirje|ille)|ce(?:n(?:s(?:kym|es)|zen)|si))|z(?:alonika(?:iakhoz)?)?)?)?)?|h(?:e(?:s(?:al(?:lonians|oni(?:c(?:iens|ans)|ians|ons|a(?:id|ns?)|ns))|elon(?:ains|ians?)|olonians?|s(?:al(?:lonians|on(?:ciens|eans|o(?:ians|ans)|a(?:i(?:ans|ns?)|ns)|i(?:c(?:en(?:ses|zen)|i[ae]ns|ans)|ions|ens|a(?:ans|id|ns?)|ns|o(?:ans|ns?))))|elon(?:ains|ians?)|oloni(?:ans?|ns)|s|z(?:alonika(?:iakhoz)?)?)?)?)?|s(?:ss?)?)?)))|P(?:erse[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*solunjan|a(?:ulus(?:['’][\s\xa0]*1(?:\.[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Thessalonikerne|[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Thessalonikerne))|vlova[\s\xa0]*prva[\s\xa0]*poslanica[\s\xa0]*Solunjanima)|ierwsz(?:[aey][\s\xa0]*(?:List[\s\xa0]*do[\s\xa0]*Tesaloniczan|Tesalonic(?:ensow|zan)))|r(?:im(?:e(?:ir[ao][\s\xa0]*Tessalonicenses|r(?:o[\s\xa0]*Tesaloni[cs]enses?|[\s\xa0]*Tesaloni[cs]enses?))|a[\s\xa0]*(?:lettera[\s\xa0]*ai[\s\xa0]*Tessalonicesi|Tessalonicesi)|o[\s\xa0]*Tessalonicesi)|em(?:ier(?:e(?:s[\s\xa0]*Thes(?:saloniciens|aloniciens)|[\s\xa0]*Thes(?:saloniciens|aloniciens))|s[\s\xa0]*Thes(?:saloniciens|aloniciens)|[\s\xa0]*Thes(?:saloniciens|aloniciens))|ye[\s\xa0]*Tesalonik(?:yen)?)|v(?:a[\s\xa0]*(?:kniha[\s\xa0]*(?:Tesalonic(?:anom|kym)|Solun(?:canom|skym))|Tesalonic(?:anom|kym)|Solun(?:janima[\s\xa0]*Poslanica|canom|skym))|y[\s\xa0]*(?:list[\s\xa0]*(?:Tesalonic(?:anom|kym)|Solun(?:canom|skym))|Tesalonic(?:anom|kym)|Solun(?:canom|skym))|ni[\s\xa0]*(?:list[\s\xa0]*(?:Tesalonickym|Solunskym)|Sol(?:unskym)?|Te(?:s(?:salonicenskym|alonickym))?))))|Kwanza[\s\xa0]*(?:Wathesalonike|Th(?:es?)?)|Te(?:calonikkiyarukku[\s\xa0]*Elutiya[\s\xa0]*Mutalavatu[\s\xa0]*Nirupam|soloniika[\s\xa0]*Kowaad))|(?:ad[\s\xa0]*Thessalonicenses[\s\xa0]*I|Prva[\s\xa0]*(?:poslanica[\s\xa0]*Solunjanima|Solunjanima)|(?:[I1](?:\.[\s\xa0]*Solunjanima|[\s\xa0]*Solunjanima))|Thes(?:s(?:oloni(?:ans?|ns)|elon(?:ains|ians?)|al(?:lonians|on(?:ciens|o(?:ians|ans)|eans|a(?:ns|i(?:ans|ns?))|i(?:ions|c(?:enses[\s\xa0]*I|i[ae]ns|ans)|(?:[oa](?:ans|ns?))|ns))))|olonians?|elon(?:ains|ians?)|al(?:lonians|oni(?:[ci]ans|ons|ns|ans?))))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["2Kgs"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:2\.[\s\xa0]*kniha[\s\xa0]*kralovska|II(?:\.[\s\xa0]*kniha[\s\xa0]*kralovska|[\s\xa0]*kniha[\s\xa0]*kralovska))|(?:2(?:a(?:\.[\s\xa0]*Reis|[\s\xa0]*Reis)|d(?:\.[\s\xa0]*Rois|e(?:\.[\s\xa0]*Rois|[\s\xa0]*Rois)|[\s\xa0]*Rois)|o(?:\.[\s\xa0]*Re(?:yes|is)|[\s\xa0]*Re(?:yes|is))|\.(?:o(?:\.[\s\xa0]*Reyes|[\s\xa0]*Reyes)|[\s\xa0]*(?:Imp(?:arati)?|Para[\s\xa0]*Raja|K(?:un(?:inkaiden[\s\xa0]*kirja|gaboken)|s(?:ieg(?:[ai][\s\xa0]*Krol(?:ewska|ow))|\.[\s\xa0]*Krol(?:ewska|ow)|[\s\xa0]*Krol(?:ewska|ow))|gs?|i(?:gs?|n(?:gs?|s)?|r(?:alyok)?|s)?|n(?:gs?|s)?|o(?:enige|n(?:ungaboken|i(?:ngen|ge)|g(?:ebo[gk])?)?)?|r(?:olewska|al(?:jevima|ov(?:ska)?)?)?)|M(?:breterve|ga[\s\xa0]*Hari)|Vua|Wa(?:falme)?|Hari|Fal|Cariv|B(?:ren(?:hinoedd|inoedd)|oq(?:orradii)?)|R(?:aja|ois|e(?:yes|is|g(?:um|i)?))))|e(?:me(?:\.[\s\xa0]*Rois|[\s\xa0]*Rois)|\.[\s\xa0]*(?:Rois|Ko(?:n(?:ingen)?)?)|[\s\xa0]*(?:Rois|Ko(?:n(?:ingen)?)?))|nd(?:\.[\s\xa0]*K(?:gs?|i(?:gs?|n(?:gs?|s)?|s)?|n(?:gs?|s)?|s)?|[\s\xa0]*K(?:gs?|i(?:gs?|n(?:gs?|s)?|s)?|n(?:gs?|s)?|s)?)|Kgs|[\s\xa0]*(?:Para[\s\xa0]*Raja|(?:[ie](?:\.[\s\xa0]*Mbreterve|[\s\xa0]*Mbreterve))|M(?:ga[\s\xa0]*Hari|b(?:reterve)?)|I(?:rajakkal|mp(?:arati)?)|Vua|Ha(?:ri)?|Wa(?:falme)?|k(?:niha[\s\xa0]*kralovska|\.[\s\xa0]*Kralov|[\s\xa0]*Kralov)|Fal|Cariv|K(?:s(?:ieg(?:[ai][\s\xa0]*Krol(?:ewska|ow))|\.[\s\xa0]*Krol(?:ewska|ow)|[\s\xa0]*Krol(?:ewska|ow))|un(?:inkaiden[\s\xa0]*kirja|g(?:aboken)?)?|gs?|i(?:gs?|n(?:gs?|s)?|r(?:alyok)?|s)?|n(?:gs?|s)?|o(?:enige|n(?:ungaboken|i(?:ngen|ge)|g(?:ebo[gk])?)?)?|r(?:al(?:jevima|ov(?:ska)?)?|ol(?:ewska)?|l)?)|R(?:aja|ois|e(?:is|es?|g(?:um|i)?|s|y(?:es?|s)?)|s|y(?:es?|s)?)?|B(?:ren(?:hinoedd|inoedd)?|oq(?:orradii)?)))|Regum[\s\xa0]*II|Wafalme[\s\xa0]*II|4(?:th(?:\.[\s\xa0]*Kingdoms|[\s\xa0]*Kingdoms)|(?:[ao](?:\.[\s\xa0]*Reinos|[\s\xa0]*Reinos))|\.[\s\xa0]*(?:M(?:breterve|ga[\s\xa0]*Hari)|K(?:ongerigernes[\s\xa0]*Bog|s(?:ieg[ai][\s\xa0]*Krolewska|\.[\s\xa0]*Krolewska|[\s\xa0]*Krolewska)|ingdoms|ralov)|Re(?:inos|g(?:norum|i)))|[\s\xa0]*(?:(?:[ei](?:\.[\s\xa0]*Mbreterve|[\s\xa0]*Mbreterve))|M(?:breterve|ga[\s\xa0]*Hari)|k(?:\.[\s\xa0]*Kralov|[\s\xa0]*Kralov)|K(?:ongerigernes[\s\xa0]*Bog|s(?:ieg[ai][\s\xa0]*Krolewska|\.[\s\xa0]*Krolewska|[\s\xa0]*Krolewska)|ingdoms|ralov)|Re(?:inos|g(?:norum|i))))|Zweite[\s\xa0]*Ko(?:enige|nige)|Masodik[\s\xa0]*Kir(?:alyok)?|D(?:e(?:uxieme(?:s[\s\xa0]*Rois|[\s\xa0]*Rois)|zyem[\s\xa0]*(?:liv[\s\xa0]*Wa[\s\xa0]*yo|Wa))|ru(?:g(?:a[\s\xa0]*(?:knjiga[\s\xa0]*o[\s\xa0]*Kraljevima|K(?:r(?:aljevima|olewska)|s(?:ieg(?:[ai][\s\xa0]*Krol(?:ewska|ow))|\.[\s\xa0]*Krol(?:ewska|ow)|[\s\xa0]*Krol(?:ewska|ow))))|i[\s\xa0]*K(?:rolewska|s(?:ieg(?:[ai][\s\xa0]*Krol(?:ewska|ow))|\.[\s\xa0]*Krol(?:ewska|ow)|[\s\xa0]*Krol(?:ewska|ow))))|h(?:a[\s\xa0]*(?:kniha[\s\xa0]*(?:kralovska|Kralov)|Kr(?:al(?:ov(?:ska)?)?)?)|y[\s\xa0]*(?:kniha[\s\xa0]*kralovska|list[\s\xa0]*Kralov|Kr(?:al(?:ov(?:ska)?)?)?))))|Liber[\s\xa0]*II[\s\xa0]*Regum|T(?:oinen[\s\xa0]*Kuninkaiden[\s\xa0]*kirja|weede[\s\xa0]*Ko(?:n(?:ingen)?)?)|Quart[ao][\s\xa0]*Reinos|Boqorradii[\s\xa0]*Labaad|F(?:jerde[\s\xa0]*Kongerigernes[\s\xa0]*Bog|ourth[\s\xa0]*Kingdoms)|And(?:en[\s\xa0]*Kong(?:ebog)?|r(?:a[\s\xa0]*K(?:onungaboken|ungaboken)|e[\s\xa0]*Kong(?:ebok)?))|C(?:zwarta[\s\xa0]*Ks(?:ieg[ai][\s\xa0]*Krolewska|\.[\s\xa0]*Krolewska|[\s\xa0]*Krolewska)|artea[\s\xa0]*(?:a[\s\xa0]*patra[\s\xa0]*a[\s\xa0]*Regilor|IV[\s\xa0]*a[\s\xa0]*Regilor))|S(?:tvrta[\s\xa0]*(?:kniha[\s\xa0]*Kralov|Kralov)|e(?:gund(?:a[\s\xa0]*Reis|o[\s\xa0]*Re(?:yes|is))|cond(?:[ao][\s\xa0]*Re|[\s\xa0]*K(?:gs?|i(?:gs?|n(?:gs?|s)?|s)?|n(?:gs?|s)?|s)?)))|I(?:ka(?:apat[\s\xa0]*Mga[\s\xa0]*Hari|lawang[\s\xa0]*(?:Mga[\s\xa0]*Hari|Hari))|V(?:\.[\s\xa0]*(?:Mga[\s\xa0]*Hari|K(?:s(?:ieg[ai][\s\xa0]*Krolewska|\.[\s\xa0]*Krolewska|[\s\xa0]*Krolewska)|ingdoms|ralov)|Re(?:inos|g(?:norum|i)))|[\s\xa0]*(?:Mga[\s\xa0]*Hari|K(?:s(?:ieg[ai][\s\xa0]*Krolewska|\.[\s\xa0]*Krolewska|[\s\xa0]*Krolewska)|ingdoms|ralov)|Re(?:inos|g(?:norum|i))))|I(?:\.[\s\xa0]*(?:Mga[\s\xa0]*Hari|Imp(?:arati)?|Para[\s\xa0]*Raja|K(?:uninkaiden[\s\xa0]*kirja|s(?:ieg(?:[ai][\s\xa0]*Krol(?:ewska|ow))|\.[\s\xa0]*Krol(?:ewska|ow)|[\s\xa0]*Krol(?:ewska|ow))|gs?|i(?:gs?|n(?:gs?|s)?|r(?:alyok)?|s)?|n(?:gs?|s)?|o(?:n(?:ingen)?)?|r(?:olewska|al(?:jevima|ov(?:ska)?)?)?)|Vua|Wa(?:falme)?|Hari|Fal|Cariv|R(?:ois|e(?:yes|is|g(?:um|i)?)?)|B(?:ren(?:hinoedd|inoedd)|oq(?:orradii)?))|[\s\xa0]*(?:Mga[\s\xa0]*Hari|Imp(?:arati)?|K(?:uninkaiden[\s\xa0]*kirja|s(?:ieg(?:[ai][\s\xa0]*Krol(?:ewska|ow))|\.[\s\xa0]*Krol(?:ewska|ow)|[\s\xa0]*Krol(?:ewska|ow))|gs?|i(?:gs?|n(?:gs?|s)?|r(?:alyok)?|s)?|n(?:gs?|s)?|o(?:n(?:ingen)?)?|r(?:olewska|al(?:jevima|ov(?:ska)?)?)?)?|R(?:ois|e(?:yes|is|gi?)?)|Para[\s\xa0]*Raja|a[\s\xa0]*Imparatilor|Vua|Wa(?:falme)?|Hari|Fal|Cariv|B(?:ren(?:hinoedd|inoedd)|oq(?:orradii)?))))|Ki(?:tabu[\s\xa0]*cha[\s\xa0]*Pili[\s\xa0]*cha[\s\xa0]*Wafalme|ralyok[\s\xa0]*II)|Pili[\s\xa0]*(?:Wafalme|Fal))|(?:Toinen[\s\xa0]*Kuninkaiden|2(?:\.[\s\xa0]*Kuninkaiden|[\s\xa0]*Kuninkaiden)|II(?:\.[\s\xa0]*Kuninkaiden|[\s\xa0]*(?:Kuninkaiden|Regum)))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["1Kgs"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:1\.[\s\xa0]*kniha[\s\xa0]*kralovska|I(?:\.[\s\xa0]*kniha[\s\xa0]*kralovska|[\s\xa0]*kniha[\s\xa0]*kralovska))|(?:F(?:orsta[\s\xa0]*K(?:onungaboken|ungaboken)|yrri[\s\xa0]*(?:bok[\s\xa0]*konunganna|Konungabok)|irst[\s\xa0]*K(?:gs?|i(?:gs?|n(?:gs?|s)?)?|n(?:gs?|s)?|s)?)|Wafalme[\s\xa0]*I|K(?:i(?:tabu[\s\xa0]*cha[\s\xa0]*Kwanza[\s\xa0]*cha[\s\xa0]*Wafalme|ralyok[\s\xa0]*I)|wanza[\s\xa0]*(?:Wafalme|Fal))|1(?:re(?:\.[\s\xa0]*Rois|[\s\xa0]*Rois)|a(?:\.[\s\xa0]*Reis|[\s\xa0]*Reis)|o(?:\.[\s\xa0]*Re(?:yes|is)|[\s\xa0]*Re(?:yes|is))|\.(?:o(?:\.[\s\xa0]*Reyes|[\s\xa0]*Reyes)|[\s\xa0]*(?:Imp(?:arati)?|Para[\s\xa0]*Raja|M(?:breterve|ga[\s\xa0]*Hari)|Vua|K(?:un(?:inkaiden[\s\xa0]*kirja|gaboken)|s(?:ieg(?:[ai][\s\xa0]*Krol(?:ewska|ow))|\.[\s\xa0]*Krol(?:ewska|ow)|[\s\xa0]*Krol(?:ewska|ow))|gs?|i(?:gs?|n(?:gs?|s)?|r(?:alyok)?)?|n(?:gs?|s)?|o(?:enige|n(?:ungaboken|i(?:ngen|ge)|g(?:ebo[gk])?)?)?|r(?:olewska|al(?:jevima|ov(?:ska)?)?)?)|Wa(?:falme)?|Hari|Fal|Cariv|B(?:ren(?:hinoedd|inoedd)|oq(?:orradii)?)|R(?:aja|ois|e(?:yes|is|g(?:um|i)?))))|e(?:r(?:\.[\s\xa0]*Rois|e(?:\.[\s\xa0]*Rois|[\s\xa0]*Rois)|[\s\xa0]*Rois)|\.[\s\xa0]*Ko(?:n(?:ingen)?)?|[\s\xa0]*Ko(?:n(?:ingen)?)?)|st(?:\.[\s\xa0]*K(?:gs?|i(?:gs?|n(?:gs?|s)?)?|n(?:gs?|s)?|s)?|[\s\xa0]*K(?:gs?|i(?:gs?|n(?:gs?|s)?)?|n(?:gs?|s)?|s)?)|Kgs|[\s\xa0]*(?:Para[\s\xa0]*Raja|(?:[ie](?:\.[\s\xa0]*Mbreterve|[\s\xa0]*Mbreterve))|M(?:ga[\s\xa0]*Hari|b(?:reterve)?)|I(?:rajakkal|mp(?:arati)?)|Vua|Ha(?:ri)?|Wa(?:falme)?|k(?:niha[\s\xa0]*kralovska|\.[\s\xa0]*Kralov|[\s\xa0]*Kralov)|Fal|Cariv|K(?:s(?:ieg(?:[ai][\s\xa0]*Krol(?:ewska|ow))|\.[\s\xa0]*Krol(?:ewska|ow)|[\s\xa0]*Krol(?:ewska|ow))|un(?:inkaiden[\s\xa0]*kirja|g(?:aboken)?)?|gs?|i(?:gs?|n(?:gs?|s)?|r(?:alyok)?)?|n(?:gs?|s)?|o(?:enige|n(?:ungaboken|i(?:ngen|ge)|g(?:ebo[gk])?)?)?|r(?:al(?:jevima|ov(?:ska)?)?|ol(?:ewska)?|l)?)|R(?:aja|ois|e(?:is|es?|g(?:um|i)?|s|y(?:es?|s)?)|s|y(?:es?|s)?)?|B(?:ren(?:hinoedd|inoedd)?|oq(?:orradii)?)))|Boqorradii[\s\xa0]*Kowaad|Cartea[\s\xa0]*(?:a[\s\xa0]*treia[\s\xa0]*a[\s\xa0]*Regilor|III[\s\xa0]*a[\s\xa0]*Regilor)|P(?:ierwsz(?:[aey][\s\xa0]*K(?:rolewska|s(?:ieg(?:[ai][\s\xa0]*Krol(?:ewska|ow))|\.[\s\xa0]*Krol(?:ewska|ow)|[\s\xa0]*Krol(?:ewska|ow))))|r(?:em(?:ier(?:e(?:s[\s\xa0]*Rois|[\s\xa0]*Rois)|s[\s\xa0]*Rois|[\s\xa0]*Rois)|ye[\s\xa0]*(?:liv[\s\xa0]*Wa[\s\xa0]*yo|Wa))|im(?:e(?:ir[ao][\s\xa0]*Reis|r(?:o[\s\xa0]*Reyes|[\s\xa0]*Reyes))|[ao][\s\xa0]*Re)|v(?:a[\s\xa0]*(?:kn(?:jiga[\s\xa0]*o[\s\xa0]*Kraljevima|iha[\s\xa0]*Kralov)|Kral(?:jevima|ov))|y[\s\xa0]*(?:list[\s\xa0]*Kralov|Kralov)|ni[\s\xa0]*(?:kniha[\s\xa0]*kralovska|Kr(?:al(?:ovska)?)?))))|Liber[\s\xa0]*I[\s\xa0]*Regum|3(?:rd(?:\.[\s\xa0]*Kingdoms|[\s\xa0]*Kingdoms)|(?:[ao](?:\.[\s\xa0]*Reinos|[\s\xa0]*Reinos))|\.[\s\xa0]*(?:M(?:breterve|ga[\s\xa0]*Hari)|K(?:ongerigernes[\s\xa0]*Bog|s(?:ieg[ai][\s\xa0]*Krolewska|\.[\s\xa0]*Krolewska|[\s\xa0]*Krolewska)|ingdoms|ralov)|Re(?:inos|g(?:norum|i)))|[\s\xa0]*(?:(?:[ei](?:\.[\s\xa0]*Mbreterve|[\s\xa0]*Mbreterve))|M(?:breterve|ga[\s\xa0]*Hari)|k(?:\.[\s\xa0]*Kralov|[\s\xa0]*Kralov)|K(?:ongerigernes[\s\xa0]*Bog|s(?:ieg[ai][\s\xa0]*Krolewska|\.[\s\xa0]*Krolewska|[\s\xa0]*Krolewska)|ingdoms|ralov)|Re(?:inos|g(?:norum|i))))|T(?:erceir[ao][\s\xa0]*Reinos|hird[\s\xa0]*Kingdoms|r(?:zeci(?:a[\s\xa0]*Ks(?:ieg[ai][\s\xa0]*Krolewska|\.[\s\xa0]*Krolewska|[\s\xa0]*Krolewska)|[\s\xa0]*Ks(?:ieg[ai][\s\xa0]*Krolewska|\.[\s\xa0]*Krolewska|[\s\xa0]*Krolewska))|e(?:dje[\s\xa0]*Kongerigernes[\s\xa0]*Bog|ti(?:a[\s\xa0]*(?:kniha[\s\xa0]*Kralov|Kralov)|[\s\xa0]*Kralov))))|I(?:katlong[\s\xa0]*Mga[\s\xa0]*Hari|II(?:\.[\s\xa0]*(?:Mga[\s\xa0]*Hari|K(?:s(?:ieg[ai][\s\xa0]*Krolewska|\.[\s\xa0]*Krolewska|[\s\xa0]*Krolewska)|ingdoms|ralov)|Re(?:inos|g(?:norum|i)))|[\s\xa0]*(?:Mga[\s\xa0]*Hari|K(?:s(?:ieg[ai][\s\xa0]*Krolewska|\.[\s\xa0]*Krolewska|[\s\xa0]*Krolewska)|ingdoms|ralov)|Re(?:inos|g(?:norum|i))))|\.[\s\xa0]*(?:Mga[\s\xa0]*Hari|Imp(?:arati)?|Para[\s\xa0]*Raja|K(?:uninkaiden[\s\xa0]*kirja|s(?:ieg(?:[ai][\s\xa0]*Krol(?:ewska|ow))|\.[\s\xa0]*Krol(?:ewska|ow)|[\s\xa0]*Krol(?:ewska|ow))|gs?|i(?:gs?|n(?:gs?|s)?|r(?:alyok)?)?|n(?:gs?|s)?|o(?:n(?:ingen)?)?|r(?:olewska|al(?:jevima|ov(?:ska)?)?)?)|Vua|Wa(?:falme)?|Hari|Fal|Cariv|R(?:ois|e(?:yes|is|g(?:um|i)?)?)|B(?:ren(?:hinoedd|inoedd)|oq(?:orradii)?))|[\s\xa0]*(?:Mga[\s\xa0]*Hari|Imp(?:arati)?|K(?:uninkaiden[\s\xa0]*kirja|s(?:ieg(?:[ai][\s\xa0]*Krol(?:ewska|ow))|\.[\s\xa0]*Krol(?:ewska|ow)|[\s\xa0]*Krol(?:ewska|ow))|gs?|i(?:gs?|n(?:gs?|s)?|r(?:alyok)?)?|n(?:gs?|s)?|o(?:n(?:ingen)?)?|r(?:olewska|al(?:jevima|ov(?:ska)?)?)?)?|R(?:ois|e(?:yes|is|gi?)?)|Para[\s\xa0]*Raja|a[\s\xa0]*Imparatilor|Vua|Wa(?:falme)?|Hari|Fal|Cariv|B(?:ren(?:hinoedd|inoedd)|oq(?:orradii)?)))|Una(?:ng[\s\xa0]*(?:Mga[\s\xa0]*Hari|Hari)|[\s\xa0]*(?:Mga[\s\xa0]*Hari|Hari))|E(?:nsimmainen[\s\xa0]*Kuninkaiden[\s\xa0]*kirja|rste[\s\xa0]*Ko(?:enige|nige)|erste[\s\xa0]*Ko(?:n(?:ingen)?)?|lso[\s\xa0]*Kir(?:alyok)?)|Regum[\s\xa0]*I)|(?:Ensimmainen[\s\xa0]*Kuninkaiden|1(?:\.[\s\xa0]*Kuninkaiden|[\s\xa0]*Kuninkaiden)|I(?:\.[\s\xa0]*Kuninkaiden|[\s\xa0]*(?:Kuninkaiden|Regum))|K(?:ngs|gs|in(?:gs)?))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["EpJer"]
		apocrypha: true
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Cart(?:\.[\s\xa0]*Jer|a[\s\xa0]*Jer(?:emias)?|[\s\xa0]*Jer)|Jer(?:emi(?:jino[\s\xa0]*pismo|a(?:n[\s\xa0]*kirje|s(?:ov[\s\xa0]*list|['’][\s\xa0]*Brev|[\s\xa0]*(?:levele|brev))))|[\s\xa0]*br|br)|Ang[\s\xa0]*Liham[\s\xa0]*ni[\s\xa0]*Jeremias|B(?:arua[\s\xa0]*ya[\s\xa0]*Yeremia|r(?:ief[\s\xa0]*(?:des[\s\xa0]*Jeremia|van[\s\xa0]*Jeremia)|ef[\s\xa0]*Jeremia|[\s\xa0]*Jer)|Jer)|Pismo[\s\xa0]*Jeremije[\s\xa0]*proroka|Or(?:atio[\s\xa0]*Ieremiae|\.[\s\xa0]*Ier|[\s\xa0]*Ier)|L(?:a[\s\xa0]*Carta[\s\xa0]*de[\s\xa0]*Jeremias|lythyr[\s\xa0]*Jeremeia|et(?:tera[\s\xa0]*di[\s\xa0]*Geremia|-?ger)|i(?:st[\s\xa0]*Jerem(?:iasza|jasuv)|h[\s\xa0]*Jer))|Ep(?:i(?:st(?:ola[\s\xa0]*lui[\s\xa0]*Ieremia|le[\s\xa0]*of[\s\xa0]*Jeremy)|tre[\s\xa0]*de[\s\xa0]*Jeremie)|\.[\s\xa0]*Jer(?:emie)?|[\s\xa0]*Jer(?:emie)?|Jer)|The[\s\xa0]*(?:Let(?:ter[\s\xa0]*of[\s\xa0]*Jeremiah|\.[\s\xa0]*of[\s\xa0]*Jeremiah|[\s\xa0]*of[\s\xa0]*Jeremiah)|Ep(?:istle[\s\xa0]*of[\s\xa0]*Jeremiah|\.[\s\xa0]*of[\s\xa0]*Jeremiah|[\s\xa0]*of[\s\xa0]*Jeremiah)))|(?:Carta[\s\xa0]*de[\s\xa0]*Jeremias|L(?:iham[\s\xa0]*ni[\s\xa0]*Jeremias|et(?:ter[\s\xa0]*of[\s\xa0]*Jeremiah|\.[\s\xa0]*of[\s\xa0]*Jeremiah|[\s\xa0]*of[\s\xa0]*Jeremiah))|Ep(?:istle[\s\xa0]*of[\s\xa0]*Jeremiah|\.[\s\xa0]*of[\s\xa0]*Jeremiah|[\s\xa0]*of[\s\xa0]*Jeremiah))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Lam"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:K(?:idung[\s\xa0]*Pa(?:ngadhuh|sambat)|s(?:ieg[ai][\s\xa0]*Lamentacji|\.[\s\xa0]*Lamentacji|[\s\xa0]*Lamentacji)|niha[\s\xa0]*nar(?:ekov|ku)|\.[\s\xa0]*narekov|[\s\xa0]*narekov|l(?:a(?:agl(?:iederen)?|g(?:ovisorna|e(?:lieder[\s\xa0]*Jeremias|s(?:angene)?))?)|gl)?)|M(?:ga[\s\xa0]*(?:Lamentasyon|Pa(?:gbangotan|naghoy))|ao(?:mbolezo[\s\xa0]*ya[\s\xa0]*Yeremia)?)|Baroor(?:ashadii[\s\xa0]*Yeremyaah)?|Chante[\s\xa0]*pou[\s\xa0]*plenn[\s\xa0]*So[\s\xa0]*lavil[\s\xa0]*Jerizalem|Jeremi(?:jine[\s\xa0]*tuzaljke|as(?:ov[\s\xa0]*Plac|[\s\xa0]*sir(?:almai)?))|Zalosp(?:evy)?|Hlj|P(?:ulampal|anag|l(?:a(?:c[\s\xa0]*Jerem(?:jasuv|i(?:as[ou]v|i))|ng(?:eri(?:le[\s\xa0]*(?:profetului[\s\xa0]*Ieremia|lui[\s\xa0]*Ieremia))?)?))?)|wilapgit|Omb|Siral(?:m(?:ak)?)?|A(?:klat[\s\xa0]*ng[\s\xa0]*Pa(?:nanaghoy|gtaghoy)|i[\s\xa0]*Ca)|Nar(?:eky)?|yarmiyako[\s\xa0]*vilap|L(?:am(?:antasyon|enta(?:zioni|c(?:oes[\s\xa0]*de[\s\xa0]*Jeremias|je[\s\xa0]*Jeremiasza|i(?:ones?|je))|tion(?:s[\s\xa0]*de[\s\xa0]*Jeremie|es)?)|inta(?:ciones?|tions?))?|m)|T(?:uz|r(?:eny[\s\xa0]*Jeremiasza)?)|Galar(?:nad[\s\xa0]*Jeremiah)?|V(?:ilapageet|a(?:lit(?:usvirret)?|j(?:timet)?)))|(?:Baroorashadii|Klagelieder|Maombolezo|Lamenta(?:tions|c(?:oes|je))|Galarnad|T(?:uzaljke|reny)|P(?:a(?:gbangotan|naghoy)|l(?:enn|ac)))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Num"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:Vier(?:de[\s\xa0]*Mozes|te[\s\xa0]*(?:Buch[\s\xa0]*Mose|Mose))|N(?:eljas[\s\xa0]*Mooseksen[\s\xa0]*kirja|[bm]|o(?:nb|m(?:b(?:res)?)?)?|u(?:m(?:erii|rat|b(?:er[is]?)?)?)?)|S(?:tvrta[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Mojzisova)|zam(?:ok)?)|Fj(?:arde[\s\xa0]*Mosebok(?:en)?|erde[\s\xa0]*Mos(?:ebo[gk])?)|liv[\s\xa0]*Resansman[\s\xa0]*an|L(?:iber[\s\xa0]*Numeri|b)|Hesabu|Res|Wilangan|K(?:itabu[\s\xa0]*cha[\s\xa0]*Nne[\s\xa0]*cha[\s\xa0]*Musa|njiga[\s\xa0]*Brojeva|s(?:ieg[ai][\s\xa0]*Liczb|\.[\s\xa0]*Liczb|[\s\xa0]*Liczb))|IV(?:\.[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|Mo(?:oseksen[\s\xa0]*kirja|zes|jz(?:eszowa|isova)?|s(?:ebok)?))|[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|Mo(?:oseksen[\s\xa0]*kirja|zes|j(?:z(?:eszowa|isova)?)?|s(?:ebok)?)))|C(?:tvrta[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Mojzisova)|zwarta[\s\xa0]*(?:Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|Mojz(?:eszowa)?)|ysla)|B(?:[ae]midbar|rojevi|il)|Ennakamam|M(?:ga[\s\xa0]*(?:Bilang|Numeros?)|ozes[\s\xa0]*IV)|gan(?:tiko[\s\xa0]*pustak|ana)|Tir(?:intii)?|4(?:\.[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|Buch[\s\xa0]*Mose|Mo(?:oseksen[\s\xa0]*kirja|zes|jz(?:eszowa|isova)?|s(?:e(?:bo(?:g|k(?:en)?))?)?)?)|[\s\xa0]*(?:Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|k(?:niha[\s\xa0]*Mojzisova|\.[\s\xa0]*Mojzisova|[\s\xa0]*Mojzisova)|Buch[\s\xa0]*Mose|M(?:o(?:os(?:eksen[\s\xa0]*kirja)?|j(?:z(?:eszowa|isova)?)?|s(?:e(?:bo(?:g|k(?:en)?))?)?|z(?:es)?)?|z)))|Ginatee)|(?:IV(?:\.[\s\xa0]*Mooseksen|[\s\xa0]*Mooseksen)|4(?:\.[\s\xa0]*Mooseksen|[\s\xa0]*Mooseksen)|Resansman|gantiko|N(?:eljas[\s\xa0]*Mooseksen|umer(?:os?|i))|Liczb)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Sus"]
		apocrypha: true
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Fortellingen[\s\xa0]*om[\s\xa0]*Susanna|Opowiadaniem[\s\xa0]*o[\s\xa0]*Zuzannie|Historia[\s\xa0]*(?:de[\s\xa0]*Susana|Susannae)|Istoria[\s\xa0]*Susanei|Z(?:suz(?:s(?:anna[\s\xa0]*es[\s\xa0]*a[\s\xa0]*venek)?)?|uz(?:an(?:na|[ae]))?)|S(?:toria[\s\xa0]*di[\s\xa0]*Susanna|i[\s\xa0]*Susana|hoshana|wsanna|u(?:s(?:ann(?:e[\s\xa0]*(?:et[\s\xa0]*les[\s\xa0]*(?:deux[\s\xa0]*vieillards|vieillards)|au[\s\xa0]*bain)|a(?:[\s\xa0]*(?:und[\s\xa0]*die[\s\xa0]*Alten|ja[\s\xa0]*vanhimmat|i(?:[\s\xa0]*badet|m[\s\xa0]*Bade))|h)))?|z(?:an(?:ne[\s\xa0]*(?:et[\s\xa0]*les[\s\xa0]*(?:deux[\s\xa0]*vieillards|vieillards)|au[\s\xa0]*bain)|a))?)?))|(?:Zsuzsanna|Su(?:zanne|san(?:ei|n(?:ae?|e)|a)))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Sir"]
		apocrypha: true
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:S(?:apienza[\s\xa0]*di[\s\xa0]*Sirac(?:ide|h)|yr(?:ak)?|i(?:r(?:a(?:c(?:hovec|id(?:es|as?))|k(?:[\s\xa0]*(?:bolcsessege|fia)|s(?:[\s\xa0]*(?:Bog|bok)|bok)|i(?:n[\s\xa0]*kirja|d[ae]s?))))?)?)|Ang[\s\xa0]*Karunungan[\s\xa0]*ni[\s\xa0]*Jesus(?:,[\s\xa0]*Anak[\s\xa0]*ni[\s\xa0]*Sirac|[\s\xa0]*Anak[\s\xa0]*ni[\s\xa0]*Sirac)|Madrosc[\s\xa0]*Syracha|Wijsheid[\s\xa0]*van[\s\xa0]*(?:J(?:ozua[\s\xa0]*Ben[\s\xa0]*Sirach|ezus[\s\xa0]*Sirach)|Ben[\s\xa0]*Sirach)|Oratio[\s\xa0]*Iesu[\s\xa0]*filii[\s\xa0]*Sirach|E(?:c(?:le(?:siastico|ziastic)|c(?:l(?:esiasti(?:que|c(?:ul|o))|us(?:iasticus)?)|s))|k(?:kle(?:s(?:[iy]astik(?:us|o))|ziastik)|l(?:e(?:s(?:[iy]astik(?:us|o))|zjastyka?)|i)))|L(?:a[\s\xa0]*Sagesse[\s\xa0]*de[\s\xa0]*Ben[\s\xa0]*Sira|iber[\s\xa0]*Ecclesiasticus)|The[\s\xa0]*Wisdom[\s\xa0]*of[\s\xa0]*Jesus(?:,[\s\xa0]*Son[\s\xa0]*of[\s\xa0]*Sirach|[\s\xa0]*(?:Son[\s\xa0]*of[\s\xa0]*Sirach|ben[\s\xa0]*Sirach))|Y(?:oshua[\s\xa0]*bin[\s\xa0]*Sira|bS)|K(?:arunungan[\s\xa0]*ng[\s\xa0]*Anak[\s\xa0]*ni[\s\xa0]*Sirac|itab[\s\xa0]*Yesus[\s\xa0]*bin[\s\xa0]*Sirakh|n(?:iha[\s\xa0]*(?:Ekleziastikus|Sirachov(?:ho[\s\xa0]*syna|c(?:ova|a)))|jiga[\s\xa0]*Sirahova)|\.[\s\xa0]*(?:Ekleziastikus|Sirachov(?:ho[\s\xa0]*syna|c(?:ova|a)))|[\s\xa0]*(?:Ekleziastikus|Sirachov(?:ho[\s\xa0]*syna|c(?:ova|a))))|Cartea[\s\xa0]*intelepciunii[\s\xa0]*lui[\s\xa0]*Isus,[\s\xa0]*fiul[\s\xa0]*lui[\s\xa0]*Sirah|Je(?:esus[\s\xa0]*Siirakin[\s\xa0]*kirja|sus[\s\xa0]*S(?:yraks[\s\xa0]*vishet|i(?:irakin[\s\xa0]*kirja|rach))))|(?:Wisdom[\s\xa0]*of[\s\xa0]*Jesus(?:,[\s\xa0]*Son[\s\xa0]*of[\s\xa0]*Sirach|[\s\xa0]*(?:Son[\s\xa0]*of[\s\xa0]*Sirach|ben[\s\xa0]*Sirach))|Ecclesiasticus|Jezus[\s\xa0]*Sirach|Ben[\s\xa0]*Sira|S(?:agesse[\s\xa0]*de[\s\xa0]*Ben[\s\xa0]*Sira|yracha|i(?:irakin(?:[\s\xa0]*kirja)?|ra(?:k(?:in|h)?|c(?:ide|h(?:ovcova)?)?)?)))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["PrMan"]
		apocrypha: true
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:La[\s\xa0]*(?:Oracion[\s\xa0]*de[\s\xa0]*Manases|Priere[\s\xa0]*de[\s\xa0]*Manasse)|Da(?:langin[\s\xa0]*ni[\s\xa0]*Manases|sal[\s\xa0]*ni[\s\xa0]*Manases)|Rugaciunea[\s\xa0]*(?:regelui[\s\xa0]*Manase|lui[\s\xa0]*Manase)|Pr(?:e(?:ghiera[\s\xa0]*di[\s\xa0]*Manasse|ce[\s\xa0]*de[\s\xa0]*Manasses)|\.[\s\xa0]*Man(?:asse)?|[\s\xa0]*Man(?:asse)?|Man)|BMn|G(?:weddi[\s\xa0]*Manasse|eb(?:et[\s\xa0]*(?:des[\s\xa0]*Manasse|Manasses?)|[\s\xa0]*Man))|The[\s\xa0]*Pr(?:ayer(?:s[\s\xa0]*(?:of[\s\xa0]*Manasseh|Manasseh)|[\s\xa0]*(?:of[\s\xa0]*Manasseh|Manasseh))|[\s\xa0]*(?:of[\s\xa0]*Manasseh|Manasseh))|Or(?:a(?:zione[\s\xa0]*di[\s\xa0]*Manasse[\s\xa0]*Re[\s\xa0]*di[\s\xa0]*Giuda|tio[\s\xa0]*(?:regis[\s\xa0]*Manassae|Manassae))|\.[\s\xa0]*Man|[\s\xa0]*Man)|M(?:odlit(?:wa[\s\xa0]*Manassesa|bu[\s\xa0]*Manasse)|an(?:as(?:esova[\s\xa0]*modlitba|s(?:ze[\s\xa0]*imaja|e(?:n[\s\xa0]*rukouksen|s(?:’[\s\xa0]*bon|[\s\xa0]*bon)|[\s\xa0]*(?:imadsaga|bon))))|[\s\xa0]*ru))|Ang[\s\xa0]*Panalangin[\s\xa0]*ni[\s\xa0]*Manases)|(?:Ora(?:zione[\s\xa0]*di[\s\xa0]*Manasse|cion[\s\xa0]*de[\s\xa0]*Manases)|P(?:analangin[\s\xa0]*ni[\s\xa0]*Manases|r(?:iere[\s\xa0]*de[\s\xa0]*Manasse|ayer(?:s[\s\xa0]*(?:of[\s\xa0]*Manasseh|Manasseh)|[\s\xa0]*(?:of[\s\xa0]*Manasseh|Manasseh))|[\s\xa0]*(?:of[\s\xa0]*Manasseh|Manasseh)))|Man(?:as(?:se|e))?)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Acts"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		Fapt(?:e(?:le[\s\xa0]*Apostolilor|[\s\xa0]*Apostolilor))?|(?:B(?:uhat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Apostoles|in)|A(?:ng[\s\xa0]*Mga[\s\xa0]*Binuhatan|k(?:syon[\s\xa0]*apot[\s\xa0]*yo|dezapot)|z[\s\xa0]*(?:apostolok[\s\xa0]*cselekedetei|ApCsel)|p(?:ost(?:l(?:enes(?:[\s\xa0]*(?:gjerninger|Gerninger)|-?gjerninge)|agarningarna)|elg(?:jerningene|eschichte)|olien[\s\xa0]*teot)|postalar[\s\xa0]*Pani|[\s\xa0]*(?:Csel|t)|\.(?:[\s\xa0]*(?:Csel|t)|[Gt])|[Gt])|c(?:t(?:es[\s\xa0]*des[\s\xa0]*Apotres|us[\s\xa0]*Apostolorum|sss?|a(?:u['’]r[\s\xa0]*Apostolion)?)?)?|t(?:ti[\s\xa0]*degli[\s\xa0]*Apostoli|os[\s\xa0]*dos[\s\xa0]*Apostolos)?)|H(?:and(?:elingen[\s\xa0]*(?:van[\s\xa0]*de[\s\xa0]*apostelen|der[\s\xa0]*apostelen))?|ech?|nd|ch?)|Ebanghelyo[\s\xa0]*ng[\s\xa0]*Espiritu[\s\xa0]*Santo|Sk(?:utky[\s\xa0]*apostol(?:ske|ov|u))?|preritharuka[\s\xa0]*kam|T(?:he[\s\xa0]*Acts[\s\xa0]*of[\s\xa0]*the[\s\xa0]*Apostles|ravay[\s\xa0]*apot[\s\xa0]*yo)|P(?:raeriton[\s\xa0]*Ke[\s\xa0]*Kam|ostulasagan)|F(?:[\s\xa0]*Ap|\.(?:[\s\xa0]*Ap|A)|a(?:l(?:imaha[\s\xa0]*Rasuullada)?|p)|A)|L(?:os[\s\xa0]*Hechos[\s\xa0]*de[\s\xa0]*los[\s\xa0]*Apostoles|elakone[\s\xa0]*Para[\s\xa0]*Rasul)|Vep(?:rat[\s\xa0]*e[\s\xa0]*Apostujve)?|G(?:awa[\s\xa0]*ng[\s\xa0]*Apostoles|w)|M(?:a(?:buting[\s\xa0]*Balita[\s\xa0]*(?:ayon[\s\xa0]*sa[\s\xa0]*Espiritu[\s\xa0]*Santo|ng[\s\xa0]*Espiritu[\s\xa0]*Santo)|tendo[\s\xa0]*ya[\s\xa0]*Mitume)|ga[\s\xa0]*Gawa(?:[\s\xa0]*ng[\s\xa0]*mga[\s\xa0]*A(?:postol(?:es)?|lagad)|in)|do)|Cselekedetek|D(?:ijannja[\s\xa0]*svjatyh[\s\xa0]*apostoliv|z(?:iej(?:ach[\s\xa0]*Apostolskich|e[\s\xa0]*Apost(?:olskie)?)|[\s\xa0]*Ap)|j(?:ela[\s\xa0]*apostolska)?))|(?:Skutky|Dz(?:ieje)?|A(?:ct(?:[eu]s|au|s(?:[\s\xa0]*of[\s\xa0]*the[\s\xa0]*Apostles)?)|t(?:ti|os)|p(?:ostolok(?:[\s\xa0]*cselekedetei)?|Csel|g))|M(?:ga[\s\xa0]*Gawa|atendo)|Los[\s\xa0]*Hechos|G(?:erninger|awa(?:[\s\xa0]*ng[\s\xa0]*mga[\s\xa0]*Apostol)?)|T(?:ravay|eot)|H(?:andelingen|echos(?:[\s\xa0]*de[\s\xa0]*los[\s\xa0]*Apostoles)?)|Veprat(?:[\s\xa0]*e[\s\xa0]*apostujve)?|Fapte(?:le)?|Para[\s\xa0]*Rasul|Binuhatan)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Rev"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Muuj(?:intii)?|O(?:ff(?:enbarung|b)|b(?:['’]javlennja[\s\xa0]*Ivana[\s\xa0]*Bohoslova|j(?:awienie[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana))?)|tk(?:rivenje[\s\xa0]*Ivanovo)?|p(?:inberun(?:[\s\xa0]*Johannesar|arbok(?:[\s\xa0]*Johannesar|in))|enb(?:aring(?:[\s\xa0]*van[\s\xa0]*Johannes|en))?|b)?)|K(?:niha[\s\xa0]*Zjeveni|s(?:ieg(?:[ai][\s\xa0]*(?:Apokalipsy|Objawienia))|\.[\s\xa0]*(?:Apokalipsy|Objawienia)|[\s\xa0]*(?:Apokalipsy|Objawienia))|itab[\s\xa0]*Wahyu)|Gipadayag|Dat(?:gudd(?:iad)?)?|J(?:anos[\s\xa0]*jelenesei|oh(?:anne(?:ksen[\s\xa0]*ilmestys|s(?:(?:['’][\s\xa0]*(?:Abenbaring|apenbaring))|apokalypsen|[\s\xa0]*(?:Uppenbarelse|apokalyps)))|s(?:\.[\s\xa0]*Abenbaring|[\s\xa0]*Abenbaring))|el(?:enesek)?)|A(?:abenbaringen|benbaring(?:sbogen|en)|p(?:enbaring(?:sboken|en)|[ck]|o(?:kal(?:yps(?:en|a)|ips(?:is[\s\xa0]*ni[\s\xa0]*Juan|a[\s\xa0]*(?:Swietego[\s\xa0]*Jana|sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana))|zis)?)|c(?:al(?:i(?:sse[\s\xa0]*di[\s\xa0]*Giovanni|ps(?:a[\s\xa0]*lui[\s\xa0]*Ioan|is[\s\xa0]*ni[\s\xa0]*Juan|e[\s\xa0]*de[\s\xa0]*(?:Sao[\s\xa0]*Joao|Joao)))|yps(?:is[\s\xa0]*Ioannis[\s\xa0]*Apostoli|e[\s\xa0]*de[\s\xa0]*Jean)?))?)?)?)|prakatikaran|R(?:e(?:belasyon|v(?:[ao]lations?|lations?|el(?:a(?:syon|tions?))?)?)|iv(?:elazione)?|v)|Velippatuttina[\s\xa0]*Vicetankal|U(?:pp(?:enbarelseboken)?|f(?:u(?:nu(?:a[\s\xa0]*wa[\s\xa0]*Yohana|o[\s\xa0]*wa[\s\xa0]*Yohan[ae]))?)?)|El[\s\xa0]*Apocalipsis|P(?:rakashaitavakya|a(?:medaran|h(?:ayag[\s\xa0]*kay[\s\xa0]*Juan)?))|Z(?:b(?:u(?:lesa)?)?|j(?:eveni[\s\xa0]*(?:svateho[\s\xa0]*Jana|Janovo)|av(?:enie[\s\xa0]*(?:Apostola[\s\xa0]*Jana|svateho[\s\xa0]*Jana|Jana))?|v)?)|Ilm(?:estyskirja)?)|(?:Velippatuttina|Ap(?:enbaring|o(?:cal(?:i(?:sse|ps(?:is|[ea]))|yps(?:is(?:[\s\xa0]*Ioannis)?|e))|kalips(?:is|a)))|O(?:penbaring|tkrivenje|bjawienie)|Ilmestys|Zj(?:avenie|eveni)|Pahayag|Ufunuo|Wahyu)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["PrAzar"]
		apocrypha: true
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:G(?:weddi[\s\xa0]*Asarias|eb(?:e(?:d[\s\xa0]*van[\s\xa0]*Azarja|t[\s\xa0]*des[\s\xa0]*Asarja)|[\s\xa0]*As))|A(?:ng[\s\xa0]*Panalangin[\s\xa0]*ni[\s\xa0]*Azarias|zar(?:jasova[\s\xa0]*modlitba|ias[\s\xa0]*ima(?:dsaga|ja))|sar(?:ias(?:’[\s\xa0]*bon|[\s\xa0]*bon)|ja(?:n[\s\xa0]*rukous|s(?:’[\s\xa0]*bon|[\s\xa0]*bon))|[\s\xa0]*ru))|Sal(?:mo[\s\xa0]*de[\s\xa0]*Azarias|[\s\xa0]*Azar)|Rugaciunea[\s\xa0]*lui[\s\xa0]*Azaria|P(?:iesn[\s\xa0]*Azariasza|r(?:eghiera[\s\xa0]*di[\s\xa0]*Azaria|\.[\s\xa0]*Azar|[\s\xa0]*Azar|Az(?:ar|r)))|The[\s\xa0]*Pr(?:ayer(?:s[\s\xa0]*of[\s\xa0]*Azariah?|[\s\xa0]*of[\s\xa0]*Azariah?)|[\s\xa0]*of[\s\xa0]*Azariah?)|Modlitwa[\s\xa0]*Azariasza|La[\s\xa0]*Priere[\s\xa0]*d['’]Azaria[hs]|Or(?:a(?:cion[\s\xa0]*de[\s\xa0]*Azarias|tio[\s\xa0]*Azariae)|\.[\s\xa0]*Azar|[\s\xa0]*Az(?:ar)?)|Cantico[\s\xa0]*de[\s\xa0]*Azarias)|(?:P(?:analangin[\s\xa0]*ni[\s\xa0]*Azarias|r(?:iere[\s\xa0]*d['’]Azaria[hs]|ayer(?:s[\s\xa0]*of[\s\xa0]*Azariah?|[\s\xa0]*of[\s\xa0]*Azariah?)|[\s\xa0]*of[\s\xa0]*Azariah?))|Azaria[sh]?)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["SgThree"]
		apocrypha: true
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:Gezang[\s\xa0]*der[\s\xa0]*drie[\s\xa0]*mannen[\s\xa0]*in[\s\xa0]*het[\s\xa0]*vuur|L(?:obgesang[\s\xa0]*der[\s\xa0]*(?:drei[\s\xa0]*jungen[\s\xa0]*Manner[\s\xa0]*im[\s\xa0]*Feuerofen|3[\s\xa0]*jungen[\s\xa0]*Manner)|ied[\s\xa0]*van[\s\xa0]*de[\s\xa0]*drie[\s\xa0]*jongemannen|3J)|Pi(?:esen[\s\xa0]*mladencov[\s\xa0]*v[\s\xa0]*ohnivej[\s\xa0]*peci|sen[\s\xa0]*mladencu[\s\xa0]*v[\s\xa0]*horici[\s\xa0]*peci)|El[\s\xa0]*(?:Canto[\s\xa0]*de[\s\xa0]*los[\s\xa0]*(?:Tres[\s\xa0]*Jovenes[\s\xa0]*(?:Hebreos|Judios)|3[\s\xa0]*Jovenes[\s\xa0]*(?:Hebreos|Judios))|Himno[\s\xa0]*de[\s\xa0]*los[\s\xa0]*(?:Tres[\s\xa0]*Jovenes[\s\xa0]*(?:Hebreos|Judios)|3[\s\xa0]*Jovenes[\s\xa0]*(?:Hebreos|Judios)))|De(?:r[\s\xa0]*Gesang[\s\xa0]*der[\s\xa0]*Drei[\s\xa0]*Manner[\s\xa0]*im[\s\xa0]*feurigen[\s\xa0]*Ofen|[\s\xa0]*tre[\s\xa0]*m(?:annens[\s\xa0]*lovsang|enns[\s\xa0]*sang))|3[\s\xa0]*tineri|Aw(?:it[\s\xa0]*ng[\s\xa0]*(?:Tatlong[\s\xa0]*(?:Kabataan(?:g[\s\xa0]*Banal)?|B(?:anal[\s\xa0]*na[\s\xa0]*Kabataan|inata))|3[\s\xa0]*Kabataan)|[\s\xa0]*ng[\s\xa0]*3[\s\xa0]*Kab)|S(?:ong[\s\xa0]*Three|ng[\s\xa0]*Three|\.[\s\xa0]*(?:of[\s\xa0]*(?:Th(?:ree(?:\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y))|\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y))|3(?:\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y)))|Th(?:ree(?:\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y))|\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y))|3(?:\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y)))|g(?:Three|[\s\xa0]*Thr(?:ee)?)|[\s\xa0]*(?:of[\s\xa0]*(?:Th(?:ree(?:\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y))|\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y))|3(?:\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y)))|Th(?:ree(?:\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y))|\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y))|3(?:\.[\s\xa0]*(?:Ch|Y)|[\s\xa0]*(?:Ch|Y))))|H(?:arom[\s\xa0]*fiatalember[\s\xa0]*eneke|ymnus[\s\xa0]*trium[\s\xa0]*puerorum)|T(?:r(?:aja[\s\xa0]*mladenci[\s\xa0]*v[\s\xa0]*rozpalenej[\s\xa0]*peci|i[\s\xa0]*muzi[\s\xa0]*v[\s\xa0]*rozpalene[\s\xa0]*peci)|he[\s\xa0]*Song[\s\xa0]*of[\s\xa0]*(?:Three[\s\xa0]*(?:Holy[\s\xa0]*Children|You(?:ng[\s\xa0]*Men|ths)|Jews)|the[\s\xa0]*(?:Three[\s\xa0]*(?:Holy[\s\xa0]*Children|You(?:ng[\s\xa0]*Men|ths)|Jews)|3[\s\xa0]*(?:Holy[\s\xa0]*Children|You(?:ng[\s\xa0]*Men|ths)|Jews))|3[\s\xa0]*(?:Holy[\s\xa0]*Children|You(?:ng[\s\xa0]*Men|ths)|Jews)))|Wimbo[\s\xa0]*wa[\s\xa0]*Vijana[\s\xa0]*Watatu|Kolmen[\s\xa0]*(?:nuoren[\s\xa0]*miehen[\s\xa0]*ollessa[\s\xa0]*tulisessa[\s\xa0]*patsissa|miehen[\s\xa0]*kiitosvirsi[\s\xa0]*tulessa)|C(?:an(?:t(?:area[\s\xa0]*celor[\s\xa0]*trei[\s\xa0]*(?:tineri|evrei)|i(?:que[\s\xa0]*des[\s\xa0]*(?:Trois[\s\xa0]*Enfants|3[\s\xa0]*Enfants)|co[\s\xa0]*d(?:ei[\s\xa0]*tre[\s\xa0]*(?:giovani[\s\xa0]*nella[\s\xa0]*fornace|fanciulli)|os[\s\xa0]*(?:Tres[\s\xa0]*Jovens|3[\s\xa0]*Jovens))))|[\s\xa0]*y[\s\xa0]*Tri[\s\xa0]*L(?:lanc|anc))|t[\s\xa0]*3[\s\xa0]*(?:Jo|E)|3J))|(?:T(?:atlong[\s\xa0]*Kabataan|re(?:s[\s\xa0]*Jovenes|i[\s\xa0]*tineri))|Lobgesang[\s\xa0]*der[\s\xa0]*drei[\s\xa0]*jungen[\s\xa0]*Manner|Der[\s\xa0]*Gesang[\s\xa0]*der[\s\xa0]*Drei|Kolmen[\s\xa0]*(?:nuoren[\s\xa0]*miehen|miehen(?:[\s\xa0]*kiitosvirsi)?)|3[\s\xa0]*Jovenes|Canto[\s\xa0]*de[\s\xa0]*los[\s\xa0]*(?:Tres[\s\xa0]*Jovenes(?:[\s\xa0]*(?:Hebreos|Judios))?|3[\s\xa0]*Jovenes(?:[\s\xa0]*(?:Hebreos|Judios))?)|Song[\s\xa0]*of[\s\xa0]*(?:the[\s\xa0]*(?:Three[\s\xa0]*(?:Holy[\s\xa0]*Children|You(?:ng[\s\xa0]*Men|ths)|Jews)|3[\s\xa0]*(?:Holy[\s\xa0]*Children|You(?:ng[\s\xa0]*Men|ths)|Jews))|Three[\s\xa0]*(?:Holy[\s\xa0]*Children|You(?:ng[\s\xa0]*Men|ths)|Jews)|3[\s\xa0]*(?:Holy[\s\xa0]*Children|You(?:ng[\s\xa0]*Men|ths)|Jews))|Himno[\s\xa0]*de[\s\xa0]*los[\s\xa0]*(?:Tres[\s\xa0]*Jovenes(?:[\s\xa0]*Judios)?|3[\s\xa0]*Jovenes(?:[\s\xa0]*(?:Hebreos|Judios))?)|Gesang[\s\xa0]*der[\s\xa0]*Drei)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["2Pet"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		2[\s\xa0]*p(?:etracem|atr(?:usko|as))|(?:Masodik[\s\xa0]*Pet(?:er)?|Epistula[\s\xa0]*(?:II[\s\xa0]*Petri|Petri[\s\xa0]*II)|Zweite[\s\xa0]*Petrus|Se(?:gund(?:a[\s\xa0]*Pedro|o[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro))|cond(?:a[\s\xa0]*(?:lettera[\s\xa0]*di[\s\xa0]*Pietro|Pietro)|o[\s\xa0]*Pietro|[\s\xa0]*P(?:e(?:r|t(?:er?|r)?)?|tr?)?))|p(?:atrusko[\s\xa0]*dostro[\s\xa0]*patra|etracem[\s\xa0]*dusre[\s\xa0]*patra)|B(?:arua[\s\xa0]*ya[\s\xa0]*Pili[\s\xa0]*ya[\s\xa0]*Petro|utros[\s\xa0]*Labaad)|Waraka[\s\xa0]*wa[\s\xa0]*Pili[\s\xa0]*wa[\s\xa0]*Petro|P(?:et(?:uru[\s\xa0]*Elutiya[\s\xa0]*Irantavatu[\s\xa0]*Nirupam|ers[\s\xa0]*(?:Andet[\s\xa0]*Brev|andre[\s\xa0]*brev)|r(?:us[\s\xa0]*andra[\s\xa0]*brev|o[\s\xa0]*II))|ili[\s\xa0]*Pet(?:ro)?)|T(?:oinen[\s\xa0]*Pietarin[\s\xa0]*kirje|weede[\s\xa0]*Pet(?:r(?:us)?)?)|And(?:e(?:t[\s\xa0]*Petersbrev|n[\s\xa0]*Pet(?:er(?:sbrev)?)?)|r(?:a[\s\xa0]*Petrusbrevet|e[\s\xa0]*Pet(?:er(?:s(?:brev)?)?)?))|2(?:d(?:\.[\s\xa0]*Pierre|e(?:\.[\s\xa0]*Pierre|[\s\xa0]*Pierre)|[\s\xa0]*Pierre)|a(?:\.[\s\xa0]*Pedro|[\s\xa0]*Pedro)|o(?:\.[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro)|[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro))|e(?:me(?:\.[\s\xa0]*Pierre|[\s\xa0]*Pierre)|\.[\s\xa0]*P(?:ierre|et(?:r(?:us)?)?)|[\s\xa0]*P(?:ierre|et(?:r(?:us)?)?))|nd(?:\.[\s\xa0]*P(?:e(?:r|t(?:er?|r)?)?|tr?)?|[\s\xa0]*P(?:e(?:r|t(?:er?|r)?)?|tr?)?)|\.(?:o(?:\.[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro)|[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro))|[\s\xa0]*(?:List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra)|Piotra)|list[\s\xa0]*Petruv|San[\s\xa0]*Pedro|patrusko|But(?:ros)?|P(?:ataras|jetrit|hia|i(?:otra?|e(?:rre|t(?:arin[\s\xa0]*kirje|ro))?)|ye|e(?:dro?|r|t(?:e(?:r(?:s(?:brev)?)?)?|r(?:i|o(?:v(?:a[\s\xa0]*Poslanica)?)?|u(?:s(?:brevet)?|v)?)?)?)?|tr?)?))|Pet|[\s\xa0]*(?:List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra)|Piotra)|list[\s\xa0]*Petruv|San[\s\xa0]*Pedro|(?:[ei](?:\.[\s\xa0]*Pjetrit|[\s\xa0]*Pjetrit))|k(?:\.[\s\xa0]*Petrov|[\s\xa0]*Petrov)|But(?:ros)?|P(?:ataras|hia|ye|d|e(?:d(?:ro?)?|r|t(?:uru|e(?:r(?:s(?:brev)?)?)?|r(?:i|o(?:v(?:a[\s\xa0]*Poslanica)?)?|u(?:s(?:brevet)?|v)?)?)?)?|i(?:otra?|e(?:rre|t(?:arin[\s\xa0]*kirje|ro)?)?)?|j(?:e(?:trit)?)?|tr?)?))|I(?:kalawang[\s\xa0]*Pedro|I(?:\.[\s\xa0]*(?:List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra)|Piotra)|list[\s\xa0]*Petruv|San[\s\xa0]*Pedro|But(?:ros)?|P(?:hia|i(?:otra?|e(?:rre|t(?:arin[\s\xa0]*kirje|ro))?)|ye|e(?:dro?|r|t(?:er?|r(?:i|o(?:v(?:a[\s\xa0]*Poslanica)?)?|u[sv]?)?)?)?|tr?)?)|[\s\xa0]*(?:List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra)|Piotra)|list[\s\xa0]*Petruv|San[\s\xa0]*Pedro|But(?:ros)?|P(?:hia|i(?:otra?|e(?:rre|t(?:arin[\s\xa0]*kirje|ro))?)|ye|e(?:dro?|r|t(?:er?|r(?:o(?:v(?:a[\s\xa0]*Poslanica)?)?|u[sv]?)?)?)?|tr?)?)))|D(?:e(?:uxieme(?:s[\s\xa0]*Pierre|[\s\xa0]*Pierre)|zyem[\s\xa0]*P[iy]e)|ru(?:g(?:a[\s\xa0]*(?:List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra)|Piotra)|P(?:etrova[\s\xa0]*Poslanica|iotra?))|i[\s\xa0]*(?:List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra)|Piotra)|Piotra?))|h(?:e[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Petra|a[\s\xa0]*(?:kniha[\s\xa0]*Petrov|list[\s\xa0]*Petruv|P(?:etr(?:ova?|uv)?|t)?)|y[\s\xa0]*(?:list[\s\xa0]*Petr[ou]v|P(?:etr(?:ov(?:[\s\xa0]*list|a)|uv)?|t)?)))))|(?:Toinen[\s\xa0]*Pietarin|Dru(?:ga[\s\xa0]*Petrova(?:[\s\xa0]*poslanica)?|hy[\s\xa0]*Petrov)|2(?:\.[\s\xa0]*P(?:ietarin|etrova)|[\s\xa0]*P(?:ietarin|etrova))|II(?:\.[\s\xa0]*P(?:ietarin|etrova)|[\s\xa0]*P(?:ietarin|etr(?:ova|i)))|Petri[\s\xa0]*II)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["1Pet"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		1[\s\xa0]*p(?:etracem|atr(?:usko|as))|(?:Una(?:ng[\s\xa0]*Pedro|[\s\xa0]*Pedro)|Kwanza[\s\xa0]*Pet(?:ro)?|E(?:nsimmainen[\s\xa0]*Pietarin[\s\xa0]*kirje|pistula[\s\xa0]*(?:I[\s\xa0]*Petri|Petri[\s\xa0]*I)|rste[\s\xa0]*Petrus|erste[\s\xa0]*Pet(?:r(?:us)?)?|lso[\s\xa0]*Pet(?:er)?)|1(?:re(?:\.[\s\xa0]*Pierre|[\s\xa0]*Pierre)|a(?:\.[\s\xa0]*Pedro|[\s\xa0]*Pedro)|o(?:\.[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro)|[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro))|e(?:r(?:\.[\s\xa0]*Pierre|e(?:\.[\s\xa0]*Pierre|[\s\xa0]*Pierre)|[\s\xa0]*Pierre)|\.[\s\xa0]*Pet(?:r(?:us)?)?|[\s\xa0]*Pet(?:r(?:us)?)?)|st(?:\.[\s\xa0]*P(?:e(?:r|t(?:er?|r)?)?|tr?)?|[\s\xa0]*P(?:e(?:r|t(?:er?|r)?)?|tr?)?)|\.(?:o(?:\.[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro)|[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro))|[\s\xa0]*(?:List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra)|Piotra)|list[\s\xa0]*Petruv|San[\s\xa0]*Pedro|patrusko|But(?:ros)?|P(?:ataras|jetrit|hia|i(?:otra?|e(?:rre|t(?:arin[\s\xa0]*kirje|ro))?)|ye|e(?:dro?|r|t(?:e(?:r(?:s(?:brev)?)?)?|r(?:i|o(?:v(?:a[\s\xa0]*Poslanica)?)?|u(?:s(?:brevet)?|v)?)?)?)?|tr?)?))|Pet|[\s\xa0]*(?:List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra)|Piotra)|list[\s\xa0]*Petruv|San[\s\xa0]*Pedro|(?:[ei](?:\.[\s\xa0]*Pjetrit|[\s\xa0]*Pjetrit))|k(?:\.[\s\xa0]*Petrov|[\s\xa0]*Petrov)|But(?:ros)?|P(?:ataras|hia|ye|d|e(?:d(?:ro?)?|r|t(?:uru|e(?:r(?:s(?:brev)?)?)?|r(?:i|o(?:v(?:a[\s\xa0]*Poslanica)?)?|u(?:s(?:brevet)?|v)?)?)?)?|i(?:otra?|e(?:rre|t(?:arin[\s\xa0]*kirje|ro)?)?)?|j(?:e(?:trit)?)?|tr?)?))|Waraka[\s\xa0]*wa[\s\xa0]*Kwanza[\s\xa0]*wa[\s\xa0]*Petro|P(?:ierwsz(?:[aey][\s\xa0]*(?:List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra)|Piotra)|Piotra?))|e(?:rse[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Petra|t(?:uru[\s\xa0]*Elutiya[\s\xa0]*Mutalavatu[\s\xa0]*Nirupam|ers[\s\xa0]*1(?:\.[\s\xa0]*Brev|[\s\xa0]*Brev)|r(?:us[\s\xa0]*forsta[\s\xa0]*brev|o[\s\xa0]*I)))|r(?:im(?:a[\s\xa0]*(?:lettera[\s\xa0]*di[\s\xa0]*Pietro|Pietro)|e(?:ir[ao][\s\xa0]*Pedro|r(?:o[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro)|[\s\xa0]*(?:San[\s\xa0]*Pedro|Pedro)))|o[\s\xa0]*Pietro)|em(?:ier(?:e(?:s[\s\xa0]*Pierre|[\s\xa0]*Pierre)|s[\s\xa0]*Pierre|[\s\xa0]*Pierre)|ye[\s\xa0]*P[iy]e)|v(?:y[\s\xa0]*(?:Petrov[\s\xa0]*list|list[\s\xa0]*Petrov)|a[\s\xa0]*(?:kniha[\s\xa0]*Petrov|Petrov(?:a[\s\xa0]*Poslanica)?)|ni[\s\xa0]*(?:list[\s\xa0]*Petruv|P(?:etr(?:ova|uv)?|t)?))))|p(?:atrusko[\s\xa0]*pahilo[\s\xa0]*patra|etracem[\s\xa0]*pahile[\s\xa0]*patra)|B(?:arua[\s\xa0]*ya[\s\xa0]*Kwanza[\s\xa0]*ya[\s\xa0]*Petro|utros[\s\xa0]*Kowaad)|I(?:\.[\s\xa0]*(?:List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra)|Piotra)|list[\s\xa0]*Petruv|San[\s\xa0]*Pedro|But(?:ros)?|P(?:hia|i(?:otra?|e(?:rre|t(?:arin[\s\xa0]*kirje|ro))?)|ye|e(?:dro?|r|t(?:er?|r(?:i|o(?:v(?:a[\s\xa0]*Poslanica)?)?|u[sv]?)?)?)?|tr?)?)|[\s\xa0]*(?:List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Piotra|[\s\xa0]*Piotra)|Piotra)|list[\s\xa0]*Petruv|San[\s\xa0]*Pedro|But(?:ros)?|P(?:hia|i(?:otra?|e(?:rre|t(?:arin[\s\xa0]*kirje|ro))?)|ye|e(?:dro?|r|t(?:er?|r(?:o(?:v(?:a[\s\xa0]*Poslanica)?)?|u[sv]?)?)?)?|tr?)?))|F(?:orsta[\s\xa0]*Petrusbrevet|yrra[\s\xa0]*(?:almenna[\s\xa0]*bref[\s\xa0]*Peturs|Petursbref)|irst[\s\xa0]*P(?:e(?:r|t(?:er?|r)?)?|tr?)?))|(?:Ensimmainen[\s\xa0]*Pietarin|1(?:\.[\s\xa0]*P(?:ietarin|etrova)|[\s\xa0]*P(?:ietarin|etrova))|I(?:\.[\s\xa0]*P(?:ietarin|etrova)|[\s\xa0]*P(?:ietarin|etr(?:ova|i)))|P(?:rv(?:a[\s\xa0]*Petrova(?:[\s\xa0]*poslanica)?|y[\s\xa0]*Petrov)|et(?:ri[\s\xa0]*I|er)))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Rom"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		rom(?:iharulai[\s\xa0]*patra|karams[\s\xa0]*patra)|(?:P(?:oslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*rymljan|a(?:vlova[\s\xa0]*poslanica[\s\xa0]*Rimljanima|ulus['’][\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Romerne))|R(?:pmans|huf(?:einiaid)?|im(?:skym)?|um|m(?:ns?|s)?|o(?:amns|emer|om(?:a(?:laiskirje)?)?|m(?:iyon|a(?:rbrevet|keve|i(?:akhoz|ns)|sn|n(?:ds|s)?)|e(?:inen(?:brief)?|n|r(?:brevet)?)|s)?|s)?|z(?:ym)?)?|Waraka[\s\xa0]*kwa[\s\xa0]*War(?:oma|umi)|Epistula[\s\xa0]*ad[\s\xa0]*Romanos|Mga[\s\xa0]*Taga(?:[\s\xa0]*Roma|-?(?:[\s\xa0]*Roma|Roma))|B(?:ref[\s\xa0]*Pals[\s\xa0]*til[\s\xa0]*Romverja|arua[\s\xa0]*kwa[\s\xa0]*Waroma)|Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Romano|L(?:ayang[\s\xa0]*Paulus[\s\xa0]*Roma|ettera[\s\xa0]*ai[\s\xa0]*Romani|ist[\s\xa0]*(?:do[\s\xa0]*Rzymian|Riman[ou]m))|Uromarukku[\s\xa0]*Elutiya[\s\xa0]*Nirupam|Kirje[\s\xa0]*roomalaisille)|(?:P(?:aulus’[\s\xa0]*brev[\s\xa0]*til[\s\xa0]*romerne|oslanica[\s\xa0]*Rimljanima)|ad[\s\xa0]*Romanos|Uromarukku|Taga(?:-?[\s\xa0]*Roma|[\s\xa0]*Roma)|rom(?:iharulai|karams)|War(?:oma|umi)|R(?:zymian|im(?:ljanima|an[ou]m)|o(?:omalaisille|m(?:erne|a(?:n(?:os?|i))?))))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Song"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:C(?:hante[\s\xa0]*Salomon|an(?:iad(?:[\s\xa0]*Solomon|au)|t(?:i(?:que[\s\xa0]*des[\s\xa0]*Cantiques|c(?:um[\s\xa0]*Canticorum|o(?:s[\s\xa0]*dos[\s\xa0]*Canticos|[\s\xa0]*(?:Superlativo|d(?:os[\s\xa0]*Canticos|i[\s\xa0]*Salomone|e(?:i[\s\xa0]*Cantici|[\s\xa0]*Salomao))))))|\.[\s\xa0]*Cantic|[\s\xa0]*Cantic|ar(?:e(?:[\s\xa0]*de[\s\xa0]*los[\s\xa0]*Cantares|a[\s\xa0]*(?:lui[\s\xa0]*Solomon|Cantarilor)|s[\s\xa0]*de[\s\xa0]*Salomao)|i)))?|nt|t)|H(?:o(?:he(?:lied[\s\xa0]*Salomonis|s(?:lied[\s\xa0]*Salomos|[\s\xa0]*Lied))|ga(?:[\s\xa0]*(?:visan|V)|v)|ogl(?:ied)?|js)|ld?)|S(?:alamon[\s\xa0]*eneke|[\s\xa0]*of[\s\xa0]*S|ngs?|S|gs?|o[Sln]?)|gitratna|Gab(?:aygii[\s\xa0]*Sulaymaan)?|E(?:l[\s\xa0]*Cantar[\s\xa0]*de[\s\xa0]*los[\s\xa0]*Cantares|nekek[\s\xa0]*eneke)|Wim(?:bo[\s\xa0]*(?:Ulio[\s\xa0]*Bora|Bora))?|The[\s\xa0]*Song(?:s[\s\xa0]*of[\s\xa0]*S(?:alom[ao]ns?|o(?:lom[ao]ns?|ngs?))|[\s\xa0]*of[\s\xa0]*S(?:alom[ao]ns?|o(?:lom[ao]ns?|ngs?)))|L(?:aul(?:ujen[\s\xa0]*laulu|\.[\s\xa0]*l|[\s\xa0]*l)|jl)|P(?:NP|i(?:es(?:n[\s\xa0]*(?:nad[\s\xa0]*Piesniami|Salomona)|en[\s\xa0]*(?:Salamunova|piesni))?|s(?:nja[\s\xa0]*nad[\s\xa0]*pisnjamy|en[\s\xa0]*(?:Salamounova|pisni))?)|j(?:esma[\s\xa0]*nad[\s\xa0]*pjesmama)?)|A(?:ng[\s\xa0]*Awit[\s\xa0]*n(?:g[\s\xa0]*mga[\s\xa0]*Awit|i[\s\xa0]*S[ao]lomon)|w(?:it[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Awit|[\s\xa0]*ni[\s\xa0]*S))|V(?:elp(?:iesen[\s\xa0]*Salamunova)?|lp)|Unnatappattu|Reshthageet|Musthikaning[\s\xa0]*Kidung|K(?:idung[\s\xa0]*Agung|orkea[\s\xa0]*veisu|ant(?:i(?:d[\s\xa0]*de[\s\xa0]*Kantik|k(?:u(?:[\s\xa0]*i[\s\xa0]*Kantikeve|lo)|o)))?))|(?:Awit[\s\xa0]*n(?:g[\s\xa0]*mga[\s\xa0]*Awit|i[\s\xa0]*S[oa]lomon)|Velpiesen|Gabaygii|Ho(?:he(?:slied|lied)|ga(?:[\s\xa0]*v)?)|Song(?:s[\s\xa0]*of[\s\xa0]*S(?:alom[ao]ns?|o(?:lom[ao]ns?|ngs?))|[\s\xa0]*of[\s\xa0]*S(?:alom[oa]ns?|o(?:lom[oa]ns?|ngs?)))?|C(?:hante|ant(?:ar(?:[\s\xa0]*de[\s\xa0]*los[\s\xa0]*Cantares|e(?:a[\s\xa0]*cantarilor|s))|i(?:que(?:[\s\xa0]*des[\s\xa0]*cantiques|s)?|c(?:um[\s\xa0]*canticorum|o(?:[\s\xa0]*dei[\s\xa0]*cantici|s)?)))?)|P(?:i(?:esen|sen)|np))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Prov"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Li(?:ber[\s\xa0]*Proverbiorum|v[\s\xa0]*Pwoveb[\s\xa0]*yo)|P(?:ildele[\s\xa0]*lui[\s\xa0]*Solomon|o(?:slovice|rverb(?:ios|s)|verb(?:ios|s))|eld(?:abeszedek)?|r(?:ypovisti|everb(?:ios?|s)?|is(?:lovi(?:[\s\xa0]*Salomounova|a))?|o(?:b(?:verb(?:ios|s)|erb(?:ios|s))|v(?:e(?:b(?:ios|s)|rb(?:e(?:le[\s\xa0]*lui[\s\xa0]*Solomon|s)?|i(?:a|os?)?|s)?))?)?|v(?:erb(?:ios?|s)?|b(?:os?|s)?)?|z(?:y(?:p(?:owiesci[\s\xa0]*Salomonowych)?)?)?)?|[vw])|Fjalet[\s\xa0]*e[\s\xa0]*urta|Diar(?:hebion|ebion)?|hitopadesko[\s\xa0]*pustak|Izr|O(?:r(?:overbs|ds(?:p(?:r(?:ak(?:sboken|ene)|ogene(?:s[\s\xa0]*Bog)?))?)?)|kv)|Wulang[\s\xa0]*Bebasan|N(?:eetivachan|itimolikal)|K(?:s(?:ieg[ai][\s\xa0]*Przypowiesci[\s\xa0]*Salomona|\.[\s\xa0]*Przypowiesci[\s\xa0]*Salomona|[\s\xa0]*Przypowiesci[\s\xa0]*Salomona)|niha[\s\xa0]*prislovi|\.[\s\xa0]*prislovi|[\s\xa0]*prislovi|aw)|S(?:a(?:lomos[\s\xa0]*Ordspr(?:ak|og)|nanl(?:asku(?:jen[\s\xa0]*kirja|t))?)|nl|pr(?:ichworter|euken|u(?:eche|che))?)|nitisutre|M(?:ga[\s\xa0]*(?:Panultihon|Kawikaan)|udre[\s\xa0]*izreke|aah(?:maahyadii)?|eth(?:ali)?|it(?:h(?:ali)?)?))|(?:Sananlaskujen|hitopadesko|Kawikaan|P(?:anultihon|r(?:overbele|islovi)|woveb))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Wis"]
		apocrypha: true
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Vi(?:is(?:auden[\s\xa0]*kirja)?|s(?:d(?:ommen(?:s[\s\xa0]*(?:Bog|bok))?)?|h(?:eten(?:s[\s\xa0]*bok)?)?))|Intelepciunea[\s\xa0]*lui[\s\xa0]*Solomon|Liber[\s\xa0]*Sapientiae|S(?:peki[\s\xa0]*Salomons|Sal|a(?:gesse[\s\xa0]*de[\s\xa0]*Salomon|l(?:amon[\s\xa0]*bolcsessege|omo(?:n[\s\xa0]*viisaus|s[\s\xa0]*(?:Visdom|vishet)))|b(?:edoria[\s\xa0]*de[\s\xa0]*Salomao|iduria)?|p(?:ien(?:za[\s\xa0]*di[\s\xa0]*Salomone|t(?:ia[\s\xa0]*Salomonis)?))?)|b)|K(?:n(?:iha[\s\xa0]*Moudrosti|jiga[\s\xa0]*Mudrosti)|s(?:ieg[ai][\s\xa0]*Madrosci|\.[\s\xa0]*Madrosci|[\s\xa0]*Madrosci)|a(?:wicaksanan[\s\xa0]*Salomo|r))|D(?:e[\s\xa0]*wijsheid[\s\xa0]*van[\s\xa0]*Salomo|oethineb[\s\xa0]*Solomon)|M(?:oudrost[\s\xa0]*Salomounova|adr(?:osc[\s\xa0]*Salomona)?|dr|ud(?:r(?:ost)?)?)|Cartea[\s\xa0]*intelepciunii[\s\xa0]*lui[\s\xa0]*Solomon|Weish(?:eit[\s\xa0]*Salomos)?|Bolcs(?:esseg)?|He(?:t[\s\xa0]*boek[\s\xa0]*der[\s\xa0]*wijsheid|k(?:ima[\s\xa0]*ya[\s\xa0]*Solomoni)?)|Ang[\s\xa0]*Karunungan[\s\xa0]*ni[\s\xa0]*S[ao]lomon|The[\s\xa0]*Wis(?:om[\s\xa0]*of[\s\xa0]*Solomon|d(?:om[\s\xa0]*of[\s\xa0]*Solomon|[\s\xa0]*of[\s\xa0]*Solomon)|[\s\xa0]*of[\s\xa0]*Solomon))|(?:Cartea[\s\xa0]*Intelepciunii|K(?:niha[\s\xa0]*moudrosti|a(?:wicaksanan|runungan(?:[\s\xa0]*ni[\s\xa0]*S[ao]lomon)?))|M(?:oudrost|udrosti)|S(?:olomon|a(?:bedoria|pien(?:tia|za)|lomon|gesse))|Hekima|W(?:eisheit|i(?:jsheid(?:[\s\xa0]*van[\s\xa0]*Salomo)?|s(?:om[\s\xa0]*of[\s\xa0]*Solomon|[\s\xa0]*of[\s\xa0]*Solomon|d(?:[\s\xa0]*of[\s\xa0]*Solomon|om(?:[\s\xa0]*of[\s\xa0]*Solomon)?)?)?)))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Joel"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Pro(?:roctwo[\s\xa0]*Ioelowe|phetia[\s\xa0]*Ioel)|Liv[\s\xa0]*Jowel[\s\xa0]*la|Ks(?:ieg[ai][\s\xa0]*Joela|\.[\s\xa0]*Joela|[\s\xa0]*Joela)|Gioe(?:le)?|Ioil|Yo(?:[av]el|le|o(?:['’]eel|l)|e(?:li?)?)|J(?:o(?:il|e(?:l(?:s[\s\xa0]*(?:Bog|bok)|i(?:n[\s\xa0]*kirja)?)?)?)|l))|(?:Jo(?:wel|el(?:in|a))|[Iy]oel)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Jonah"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Pro(?:roctwo[\s\xa0]*Ionaszowe|phetia[\s\xa0]*Ionae)|Liv[\s\xa0]*Jonas[\s\xa0]*la|Ks(?:ieg[ai][\s\xa0]*Jonasza|\.[\s\xa0]*Jonasza|[\s\xa0]*Jonasza)|Ionas?|Gio(?:na)?|J(?:n[hs]|o(?:ona(?:n[\s\xa0]*kirja)?|n(?:a(?:s(?:['’][\s\xa0]*Bog|[\s\xa0]*bok)|[\s\xa0]*bok|h))?))|Y(?:unus|o(?:on(?:is)?|na?)))|(?:Jo(?:onan|na(?:s(?:za)?)?)|yona)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Nah"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Pro(?:roctwo[\s\xa0]*Nahumowe|phetia[\s\xa0]*Nahum)|Liv[\s\xa0]*Nawoum[\s\xa0]*lan|Ks(?:ieg[ai][\s\xa0]*Nahuma|\.[\s\xa0]*Nahuma|[\s\xa0]*Nahuma)|N(?:a(?:-?hum|kum|ch|um|h(?:oom|u(?:m(?:s[\s\xa0]*(?:Bog|bok)|i(?:n[\s\xa0]*kirja)?|u))?)?|w(?:oun)?|x(?:uum)?)|h))|Nahum(?:in|a)|(?:nahum|Na(?:woum|hum)?)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["1John"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		1[\s\xa0]*yohanacem|(?:1(?:re(?:\.[\s\xa0]*Jean|[\s\xa0]*Jean)|a(?:\.[\s\xa0]*Joao|[\s\xa0]*Joao)|o(?:\.[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J(?:[au](?:[au]n)|oao))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J(?:[au](?:[au]n)|oao)))|e(?:r(?:\.[\s\xa0]*Jean|e(?:\.[\s\xa0]*Jean|[\s\xa0]*Jean)|[\s\xa0]*Jean)|\.[\s\xa0]*Joh(?:annes)?|[\s\xa0]*Joh(?:annes)?)|st(?:\.[\s\xa0]*J(?:phn|h(?:[ho]n|n)?|n|o(?:phn|nh|on|h[mn]?)?)|[\s\xa0]*J(?:phn|h(?:[ho]n|n)?|n|o(?:phn|nh|on|h[mn]?)?))|John|\.(?:o(?:\.[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n)))|[\s\xa0]*(?:list[\s\xa0]*Januv|List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana)|yuhannako|San[\s\xa0]*J[au](?:[au]n)|Yo(?:kanan|o(?:hanna|x(?:anaa)?)|h(?:an(?:a|es?))?)|G(?:jonit|i(?:o(?:vanni|an))?)|I(?:vanova[\s\xa0]*Poslanica|oan(?:nis)?|n)|J(?:ean|phn|u[au]n|a(?:[au]n|n(?:o(?:s|va?)|uv|a)?)|h(?:[ho]n|n)?|n|o(?:phn|ao|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s(?:brev(?:et)?)?)|[mn])?)?)?))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|yuhannako|Yo(?:kanan|van|o(?:hanna|x(?:anaa)?)|h(?:an(?:a|es?))?)|I(?:oan(?:nis)?|n|v(?:anova[\s\xa0]*Poslanica)?)|list[\s\xa0]*Januv|(?:[ei](?:\.[\s\xa0]*Gjonit|[\s\xa0]*Gjonit))|G(?:i(?:o(?:vanni|an))?|j(?:onit)?|v)|k(?:\.[\s\xa0]*Janov|[\s\xa0]*Janov)|J(?:ean|phn|u[au]n|a(?:[au]n|n(?:o(?:s|va?)|uv|a)?)|h(?:[ho]n|n)?|n|o(?:phn|ao|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s(?:brev(?:et)?)?)|[mn])?)?)?|List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana)))|J(?:ohannes(?:[\s\xa0]*forsta[\s\xa0]*brev|(?:['’][\s\xa0]*1(?:\.[\s\xa0]*Brev|[\s\xa0]*Brev)))|anos[\s\xa0]*I)|I(?:\.[\s\xa0]*(?:list[\s\xa0]*Januv|List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana)|San[\s\xa0]*J[au](?:[au]n)|Yo(?:kanan|ox(?:anaa)?|h(?:an(?:a|es?))?)|Gi(?:o(?:vanni|an))?|I(?:vanova[\s\xa0]*Poslanica|oan(?:nis)?|n)|J(?:ean|phn|u[au]n|a(?:[au]n|n(?:o(?:s|va?)|uv|a)?)|h(?:[ho]n|n)?|n|o(?:phn|ao|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s)|[mn])?)?)?)|[\s\xa0]*(?:list[\s\xa0]*Januv|List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana)|San[\s\xa0]*J[au](?:[au]n)|Yo(?:kanan|ox(?:anaa)?|h(?:an(?:a|es?))?)|Gi(?:o(?:vanni|an))?|I(?:vanova[\s\xa0]*Poslanica|oan|n)|J(?:ean|phn|u[au]n|a(?:[au]n|n(?:o(?:s|va?)|uv|a)?)|h(?:[ho]n|n)?|n|o(?:phn|ao|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s)|[mn])?)?)?))|Yo(?:van[\s\xa0]*Elutiya[\s\xa0]*Mutalavatu[\s\xa0]*Nirupam|oxanaa[\s\xa0]*Kowaad|hane[\s\xa0]*I)|Kwanza[\s\xa0]*Yoh(?:an[ae])?|Barua[\s\xa0]*ya[\s\xa0]*Kwanza[\s\xa0]*ya[\s\xa0]*Yohane|Una(?:ng[\s\xa0]*Juan|[\s\xa0]*Juan)|P(?:erse[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Ivana|ierwsz(?:[aey][\s\xa0]*(?:List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana)|Jana))|r(?:im(?:a[\s\xa0]*(?:lettera[\s\xa0]*di[\s\xa0]*Giovanni|Giovanni)|o[\s\xa0]*Giovanni|e(?:ir[ao][\s\xa0]*Joao|r(?:o[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n)))))|em(?:ier(?:e(?:s[\s\xa0]*Jean|[\s\xa0]*Jean)|s[\s\xa0]*Jean|[\s\xa0]*Jean)|ye[\s\xa0]*Jan)|v(?:y[\s\xa0]*(?:Janov[\s\xa0]*list|list[\s\xa0]*Janov)|a[\s\xa0]*(?:Ivanova[\s\xa0]*Poslanica|kniha[\s\xa0]*Janov|Janov)|ni[\s\xa0]*(?:list[\s\xa0]*Januv|J(?:an(?:ova|uv)?)?))))|y(?:ohanacem[\s\xa0]*pahile[\s\xa0]*patra|uhannako[\s\xa0]*pahilo[\s\xa0]*patra)|F(?:orsta[\s\xa0]*Johannesbrevet|yrsta[\s\xa0]*(?:bref[\s\xa0]*Johannesar|Johannesarbref)|irst[\s\xa0]*J(?:phn|h(?:[ho]n|n)?|n|o(?:phn|nh|on|h[mn]?)?))|E(?:nsimmainen[\s\xa0]*Johanneksen[\s\xa0]*kirje|pistula[\s\xa0]*I(?:[\s\xa0]*Ioannis|oannis[\s\xa0]*I)|rste[\s\xa0]*Johannes|erste[\s\xa0]*Joh(?:annes)?|lso[\s\xa0]*J(?:anos|n))|Waraka[\s\xa0]*wa[\s\xa0]*Kwanza[\s\xa0]*wa[\s\xa0]*Yohane)|(?:Ensimmainen[\s\xa0]*Johanneksen|Prv(?:a[\s\xa0]*Ivanova(?:[\s\xa0]*poslanica)?|y[\s\xa0]*Janov)|1(?:\.[\s\xa0]*(?:Johanneksen|Ivanova)|[\s\xa0]*(?:Johanneksen|Ivanova))|I(?:\.[\s\xa0]*(?:Johanneksen|Ivanova)|oannis[\s\xa0]*I|[\s\xa0]*(?:Johanneksen|I(?:vanova|oannis))))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["2John"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		2[\s\xa0]*yohanacem|(?:Zweite[\s\xa0]*Johannes|Waraka[\s\xa0]*wa[\s\xa0]*Pili[\s\xa0]*wa[\s\xa0]*Yohane|Epistula[\s\xa0]*I(?:I[\s\xa0]*Ioannis|oannis[\s\xa0]*II)|y(?:uhannako[\s\xa0]*dostro[\s\xa0]*patra|ohanacem[\s\xa0]*dusre[\s\xa0]*patra)|2(?:a(?:\.[\s\xa0]*Joao|[\s\xa0]*Joao)|d(?:\.[\s\xa0]*Jean|e(?:\.[\s\xa0]*Jean|[\s\xa0]*Jean)|[\s\xa0]*Jean)|o(?:\.[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J(?:[au](?:[au]n)|oao))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J(?:[au](?:[au]n)|oao)))|e(?:me(?:\.[\s\xa0]*Jean|[\s\xa0]*Jean)|\.[\s\xa0]*J(?:ean|oh(?:annes)?)|[\s\xa0]*J(?:ean|oh(?:annes)?))|nd(?:\.[\s\xa0]*J(?:phn|h(?:[ho]n|n)?|n|o(?:phn|nh|on|h[mn]?)?)|[\s\xa0]*J(?:phn|h(?:[ho]n|n)?|n|o(?:phn|nh|on|h[mn]?)?))|John|\.(?:o(?:\.[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n)))|[\s\xa0]*(?:list[\s\xa0]*Januv|List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana)|yuhannako|San[\s\xa0]*J[au](?:[au]n)|Yo(?:kanan|o(?:hanna|x(?:anaa)?)|h(?:an(?:a|es?))?)|G(?:jonit|i(?:o(?:vanni|an))?)|I(?:vanova[\s\xa0]*Poslanica|oan(?:nis)?|n)|J(?:ean|phn|u[au]n|a(?:[au]n|n(?:o(?:s|va?)|uv|a)?)|h(?:[ho]n|n)?|n|o(?:phn|ao|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s(?:brev(?:et)?)?)|[mn])?)?)?))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|yuhannako|Yo(?:kanan|van|o(?:hanna|x(?:anaa)?)|h(?:an(?:a|es?))?)|I(?:oan(?:nis)?|n|v(?:anova[\s\xa0]*Poslanica)?)|list[\s\xa0]*Januv|(?:[ei](?:\.[\s\xa0]*Gjonit|[\s\xa0]*Gjonit))|G(?:i(?:o(?:vanni|an))?|j(?:onit)?|v)|k(?:\.[\s\xa0]*Janov|[\s\xa0]*Janov)|J(?:ean|phn|u[au]n|a(?:[au]n|n(?:o(?:s|va?)|uv|a)?)|h(?:[ho]n|n)?|n|o(?:phn|ao|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s(?:brev(?:et)?)?)|[mn])?)?)?|List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana)))|T(?:oinen[\s\xa0]*Joh(?:anneksen[\s\xa0]*kirje)?|weede[\s\xa0]*Joh(?:annes)?)|Masodik[\s\xa0]*J(?:anos|n)|Barua[\s\xa0]*ya[\s\xa0]*Pili[\s\xa0]*ya[\s\xa0]*Yohane|Yo(?:van[\s\xa0]*Elutiya[\s\xa0]*Irantavatu[\s\xa0]*Nirupam|oxanaa[\s\xa0]*Labaad|hane[\s\xa0]*II)|I(?:kalawang[\s\xa0]*Juan|I(?:\.[\s\xa0]*(?:list[\s\xa0]*Januv|List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana)|San[\s\xa0]*J[au](?:[au]n)|Yo(?:kanan|ox(?:anaa)?|h(?:an(?:a|es?))?)|Gi(?:o(?:vanni|an))?|I(?:vanova[\s\xa0]*Poslanica|oan(?:nis)?|n)|J(?:ean|phn|u[au]n|a(?:[au]n|n(?:o(?:s|va?)|uv|a)?)|h(?:[ho]n|n)?|n|o(?:phn|ao|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s)|[mn])?)?)?)|[\s\xa0]*(?:list[\s\xa0]*Januv|List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana)|San[\s\xa0]*J[au](?:[au]n)|Yo(?:kanan|ox(?:anaa)?|h(?:an(?:a|es?))?)|Gi(?:o(?:vanni|an))?|I(?:vanova[\s\xa0]*Poslanica|oan|n)|J(?:ean|phn|u[au]n|a(?:[au]n|n(?:o(?:s|va?)|uv|a)?)|h(?:[ho]n|n)?|n|o(?:phn|ao|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s)|[mn])?)?)?)))|D(?:e(?:uxieme(?:s[\s\xa0]*Jean|[\s\xa0]*Jean)|zyem[\s\xa0]*Jan)|ru(?:g(?:a[\s\xa0]*(?:Ivanova[\s\xa0]*Poslanica|List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana)|Jana)|i[\s\xa0]*(?:List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana)|Jana))|h(?:e[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Ivana|a[\s\xa0]*(?:kniha[\s\xa0]*Janov|list[\s\xa0]*Januv|J(?:an(?:ova?|uv)?)?)|y[\s\xa0]*(?:list[\s\xa0]*Jan[ou]v|J(?:an(?:ov(?:[\s\xa0]*list|a)|uv)?)?))))|Pili[\s\xa0]*Yoh(?:an[ae])?|Se(?:gund(?:a[\s\xa0]*Joao|o[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J(?:[au](?:[au]n)|oao)))|cond(?:a[\s\xa0]*(?:lettera[\s\xa0]*di[\s\xa0]*Giovanni|Giovanni)|o[\s\xa0]*Giovanni|[\s\xa0]*J(?:phn|h(?:[ho]n|n)?|n|o(?:phn|nh|on|h[mn]?)?)))|And(?:e(?:t[\s\xa0]*Johannesbrev|n[\s\xa0]*Joh(?:annes(?:brev)?)?)|r(?:a[\s\xa0]*Johannesbrevet|e[\s\xa0]*Joh(?:annes)?))|J(?:ohannes(?:'[\s\xa0]*Andet[\s\xa0]*Brev|’[\s\xa0]*(?:Andet[\s\xa0]*Brev|andre[\s\xa0]*brev)|[\s\xa0]*andra[\s\xa0]*brev)|anos[\s\xa0]*II))|(?:Toinen[\s\xa0]*Johanneksen|Dru(?:ga[\s\xa0]*Ivanova(?:[\s\xa0]*poslanica)?|hy[\s\xa0]*Janov)|I(?:oannis[\s\xa0]*II|I(?:\.[\s\xa0]*(?:Johanneksen|Ivanova)|[\s\xa0]*(?:Johanneksen|I(?:vanova|oannis))))|2(?:\.[\s\xa0]*(?:Johanneksen|Ivanova)|[\s\xa0]*(?:Johanneksen|Ivanova)))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["3John"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		3[\s\xa0]*yohanacem|(?:J(?:ohannes(?:[\s\xa0]*tredje[\s\xa0]*brev|(?:['’][\s\xa0]*(?:Tredje[\s\xa0]*Brev|3(?:\.[\s\xa0]*Brev|[\s\xa0]*Brev))))|anos[\s\xa0]*III)|Waraka[\s\xa0]*wa[\s\xa0]*Tatu[\s\xa0]*wa[\s\xa0]*Yohane|Yo(?:van[\s\xa0]*Elutiya[\s\xa0]*Munravatu[\s\xa0]*Nirupam|oxanaa[\s\xa0]*Saddexaad|hane[\s\xa0]*III)|3(?:a(?:\.[\s\xa0]*Joao|[\s\xa0]*Joao)|o(?:\.[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J(?:[au](?:[au]n)|oao))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J(?:[au](?:[au]n)|oao)))|e(?:me(?:\.[\s\xa0]*Jean|[\s\xa0]*Jean)|\.[\s\xa0]*J(?:ean|oh(?:annes(?:brevet)?)?)|[\s\xa0]*J(?:ean|oh(?:annes(?:brevet)?)?))|rd(?:\.[\s\xa0]*J(?:phn|h(?:[ho]n|n)?|n|o(?:phn|nh|on|h[mn]?)?)|[\s\xa0]*J(?:phn|h(?:[ho]n|n)?|n|o(?:phn|nh|on|h[mn]?)?))|John|\.(?:o(?:\.[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n)))|[\s\xa0]*(?:list[\s\xa0]*Januv|List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana)|yuhannako|San[\s\xa0]*J[au](?:[au]n)|Yo(?:kanan|o(?:hanna|x(?:anaa)?)|h(?:an(?:a|es?))?)|G(?:jonit|i(?:o(?:vanni|an))?)|I(?:vanova[\s\xa0]*Poslanica|oan(?:nis)?|n)|J(?:ean|phn|u[au]n|a(?:[au]n|n(?:o(?:s|va?)|uv|a)?)|h(?:[ho]n|n)?|n|o(?:phn|ao|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s(?:brev(?:et)?)?)|[mn])?)?)?))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|yuhannako|Yo(?:kanan|van|o(?:hanna|x(?:anaa)?)|h(?:an(?:a|es?))?)|I(?:oan(?:nis)?|n|v(?:anova[\s\xa0]*Poslanica)?)|list[\s\xa0]*Januv|(?:[ei](?:\.[\s\xa0]*Gjonit|[\s\xa0]*Gjonit))|G(?:i(?:o(?:vanni|an))?|j(?:onit)?|v)|k(?:\.[\s\xa0]*Janov|[\s\xa0]*Janov)|J(?:ean|phn|u[au]n|a(?:[au]n|n(?:o(?:s|va?)|uv|a)?)|h(?:[ho]n|n)?|n|o(?:phn|ao|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s(?:brev(?:et)?)?)|[mn])?)?)?|List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana)))|I(?:katlong[\s\xa0]*Juan|II(?:\.[\s\xa0]*(?:list[\s\xa0]*Januv|List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana)|San[\s\xa0]*J[au](?:[au]n)|Yo(?:kanan|ox(?:anaa)?|h(?:an(?:a|es?))?)|Gi(?:o(?:vanni|an))?|I(?:vanova[\s\xa0]*Poslanica|oan(?:nis)?|n)|J(?:ean|phn|u[au]n|a(?:[au]n|n(?:o(?:s|va?)|uv|a)?)|h(?:[ho]n|n)?|n|o(?:phn|ao|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s)|[mn])?)?)?)|[\s\xa0]*(?:list[\s\xa0]*Januv|List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana)|San[\s\xa0]*J[au](?:[au]n)|Yo(?:kanan|ox(?:anaa)?|h(?:an(?:a|es?))?)|Gi(?:o(?:vanni|an))?|I(?:vanova[\s\xa0]*Poslanica|oan|n)|J(?:ean|phn|u[au]n|a(?:[au]n|n(?:o(?:s|va?)|uv|a)?)|h(?:[ho]n|n)?|n|o(?:phn|ao|nh|on|h(?:anne(?:ksen[\s\xa0]*kirje|s)|[mn])?)?)?)))|T(?:er(?:z(?:a[\s\xa0]*(?:lettera[\s\xa0]*di[\s\xa0]*Giovanni|Giovanni)|o[\s\xa0]*Giovanni)|ce(?:ir[ao][\s\xa0]*Joao|r(?:o[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n))|[\s\xa0]*(?:San[\s\xa0]*J[au](?:[au]n)|J[au](?:[au]n)))))|atu[\s\xa0]*Yoh(?:an[ae])?|hird[\s\xa0]*J(?:phn|h(?:[ho]n|n)?|n|o(?:phn|nh|on|h[mn]?)?)|r(?:oisieme(?:s[\s\xa0]*Jean|[\s\xa0]*Jean)|zeci(?:a[\s\xa0]*(?:List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana)|Jana)|[\s\xa0]*(?:List[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana)|Jana))|e(?:ca[\s\xa0]*Ivanova[\s\xa0]*Poslanica|dje[\s\xa0]*Joh(?:annes(?:brev(?:et)?)?)?|t(?:je[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Ivana|i(?:a[\s\xa0]*(?:kniha[\s\xa0]*Janov|Janov)|[\s\xa0]*(?:list[\s\xa0]*Januv|J(?:an(?:ov(?:[\s\xa0]*list|a)|uv)?)?))))))|y(?:uhannako[\s\xa0]*testro[\s\xa0]*patra|ohanacem[\s\xa0]*tisre[\s\xa0]*patra)|Barua[\s\xa0]*ya[\s\xa0]*Tatu[\s\xa0]*ya[\s\xa0]*Yohane|Epistula[\s\xa0]*I(?:II[\s\xa0]*Ioannis|oannis[\s\xa0]*III)|D(?:ritte[\s\xa0]*Johannes|erde[\s\xa0]*Joh(?:annes)?)|Harmadik[\s\xa0]*J(?:anos|n)|Kolmas[\s\xa0]*Johanneksen[\s\xa0]*kirje)|(?:Johannes’[\s\xa0]*tredje[\s\xa0]*brev|Kolmas[\s\xa0]*Johanneksen|Tre(?:ca[\s\xa0]*Ivanova(?:[\s\xa0]*poslanica)?|ti[\s\xa0]*Janov)|I(?:oannis[\s\xa0]*III|II(?:\.[\s\xa0]*(?:Johanneksen|Ivanova)|[\s\xa0]*(?:Johanneksen|I(?:oannis|vanova))))|3(?:\.[\s\xa0]*(?:Johanneksen|Ivanova)|[\s\xa0]*(?:Johanneksen|Ivanova)))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["John"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Sulat[\s\xa0]*ni[\s\xa0]*San[\s\xa0]*Juan|y(?:uhannale|ohanane)|J(?:ano(?:vo[\s\xa0]*evangelium|s)|e(?:vanhelije[\s\xa0]*vid[\s\xa0]*Ivana|an)|o(?:hann(?:is[\s\xa0]*evangelium|e(?:ksen[\s\xa0]*evankeliumi|sevangeliet))|ao))|Vangelo[\s\xa0]*di[\s\xa0]*(?:San[\s\xa0]*Giovanni|Giovanni)|Y(?:uhanna|o(?:van[\s\xa0]*Narceyti|kanan|ox(?:anaa)?|h))|Ungjilli[\s\xa0]*i[\s\xa0]*Gjonit|I(?:njil(?:i[\s\xa0]*ya[\s\xa0]*Yohan[ae]|[\s\xa0]*Yohanes)|oan(?:nes)?|van)|E(?:banghelyo[\s\xa0]*(?:ayon[\s\xa0]*kay[\s\xa0]*(?:San[\s\xa0]*Juan|Juan)|ni[\s\xa0]*San[\s\xa0]*Juan)|van(?:keliumi[\s\xa0]*Johanneksen[\s\xa0]*mukaan|geli(?:e(?:[\s\xa0]*volgens[\s\xa0]*Johannes|t[\s\xa0]*etter[\s\xa0]*Johannes)|um[\s\xa0]*(?:secundum[\s\xa0]*Ioannem|podle[\s\xa0]*Jana))|jelium[\s\xa0]*Podla[\s\xa0]*Jana)|l[\s\xa0]*Evangelio[\s\xa0]*de[\s\xa0]*J[au](?:[au]n)|w(?:angelia[\s\xa0]*(?:wg[\s\xa0]*sw(?:\.[\s\xa0]*Jana|[\s\xa0]*Jana)|Jana)|\.[\s\xa0]*Jana|[\s\xa0]*Jana?))|The[\s\xa0]*Gospel[\s\xa0]*(?:according[\s\xa0]*to[\s\xa0]*(?:S(?:aint[\s\xa0]*J(?:phn|o(?:phn|nh|on|h[mn]?)|h(?:[ho]n|n)?|n)|t(?:\.[\s\xa0]*J(?:phn|o(?:phn|nh|on|h[mn]?)|h(?:[ho]n|n)?|n)|[\s\xa0]*J(?:phn|o(?:phn|nh|on|h[mn]?)|h(?:[ho]n|n)?|n)))|J(?:phn|o(?:phn|nh|on|h[mn]?)|h(?:[ho]n|n)?|n))|of[\s\xa0]*(?:S(?:aint[\s\xa0]*J(?:phn|o(?:phn|nh|on|h[mn]?)|h(?:[ho]n|n)?|n)|t(?:\.[\s\xa0]*J(?:phn|o(?:phn|nh|on|h[mn]?)|h(?:[ho]n|n)?|n)|[\s\xa0]*J(?:phn|o(?:phn|nh|on|h[mn]?)|h(?:[ho]n|n)?|n)))|J(?:phn|o(?:phn|nh|on|h[mn]?)|h(?:[ho]n|n)?|n)))|Mabuting[\s\xa0]*Balita[\s\xa0]*ayon[\s\xa0]*kay[\s\xa0]*(?:San[\s\xa0]*Juan|Juan)|G(?:jo(?:ni)?|[gv]|i(?:oan)?))|(?:G(?:ospel[\s\xa0]*(?:according[\s\xa0]*to[\s\xa0]*(?:S(?:aint[\s\xa0]*J(?:phn|o(?:phn|nh|on|h[nm]?)|n|h(?:[ho]n|n)?)|t(?:\.[\s\xa0]*J(?:phn|o(?:phn|on|nh|h[nm]?)|h(?:[ho]n|n)?|n)|[\s\xa0]*J(?:phn|o(?:phn|on|nh|h[nm]?)|n|h(?:[oh]n|n)?)))|J(?:phn|o(?:phn|nh|on|h[nm]?)|h(?:[oh]n|n)?|n))|of[\s\xa0]*(?:S(?:aint[\s\xa0]*J(?:phn|o(?:phn|nh|on|h[nm]?)|n|h(?:[oh]n|n)?)|t(?:\.[\s\xa0]*J(?:phn|o(?:phn|on|nh|h[mn]?)|n|h(?:[oh]n|n)?)|[\s\xa0]*J(?:phn|o(?:phn|nh|on|h[nm]?)|h(?:[ho]n|n)?|n)))|J(?:phn|o(?:phn|on|nh|h[nm]?)|n|h(?:[ho]n|n)?)))|iovanni)|Yo(?:han(?:a|es?)|van)|S(?:a(?:int[\s\xa0]*J(?:phn|o(?:phn|on|nh|h[mn]?)|n|h(?:[oh]n|n)?)|n[\s\xa0]*Juan)|t(?:\.[\s\xa0]*J(?:phn|o(?:phn|nh|on|h[nm]?)|h(?:[oh]n|n)?|n)|[\s\xa0]*J(?:phn|o(?:phn|on|nh|h[nm]?)|h(?:[oh]n|n)?|n)))|J(?:phn|a(?:[ua]n|na)|u[au]n|o(?:phn|nh|on|h(?:anne(?:ksen|s)|[mn])?)|n|h(?:[ho]n|n)?))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Josh"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Li(?:ber[\s\xa0]*Iosue|v[\s\xa0]*Jozye[\s\xa0]*a)|Ks(?:ieg[ai][\s\xa0]*Jozuego|\.[\s\xa0]*Jozuego|[\s\xa0]*Jozuego)|yahos(?:uko[\s\xa0]*pustak|awa)|I(?:sus[\s\xa0]*Navyn|os(?:ua[\s\xa0]*Navi)?)|Y(?:usak|a(?:hoshoo|sh(?:uuca)?)|o(?:cuva|s(?:hua|ua)?))|G(?:iosue|s(?:ua)?)|J(?:o(?:us(?:hua|ua)|os(?:uan[\s\xa0]*kirja)?|s(?:u(?:ova|a(?:bok|h)?|e)|va(?:s[\s\xa0]*(?:Bog|bok)|bog(?:en)?)?|h(?:ua)?)?|z(?:u(?:ova|a|eu?)|s(?:ue)?)?)|sh?))|(?:yahosuko|Jo(?:osuan|svas|z(?:uego|ye))|Iosu[ae])
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Judg"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Huk|Xaak(?:innada)?|B(?:arn(?:wyr)?|ir(?:ak)?)|Amu|Mga[\s\xa0]*(?:Maghuhukom|Hukom)|J(?:dgs?|ij|u(?:d(?:ecatorii?|g(?:es)?)|iz(?:es)?|e(?:c(?:es)?)?|g(?:es)?)|[cz]|gs?)|Iud|Para[\s\xa0]*Hakim|G(?:iudici|dc|jy(?:qtaret)?)|N(?:iyayatipatikal|yayiyon)|nyayakarttaharuko[\s\xa0]*pustak|S(?:oudcu|edz|u(?:ci|d(?:covia)?)|d[cz]?)|Dom(?:ar(?:boken|abok(?:in)?)|mer(?:bogen|ne(?:s[\s\xa0]*bok)?)?)?|Tuom(?:arien[\s\xa0]*kirja)?|Quan|R(?:echt(?:ers)?|icht(?:er(?:en?)?)?)|Li(?:ber[\s\xa0]*Iudicum|v[\s\xa0]*Chef[\s\xa0]*yo)|saste|K(?:n(?:jiga[\s\xa0]*o[\s\xa0]*Sucima|yha[\s\xa0]*Suddiv)|s(?:ieg[ai][\s\xa0]*Sedziow|\.[\s\xa0]*Sedziow|[\s\xa0]*Sedziow)|\.[\s\xa0]*sudcov|[\s\xa0]*sudcov)|Waam(?:uzi)?)|(?:nyayakarttaharuko|Maghuhukom|Tuomarien|Dommernes|Iudicum|S(?:edziow|udcov)|Hukom)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["1Esd"]
		apocrypha: true
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:P(?:ierwsz[aey][\s\xa0]*(?:Ks(?:ieg(?:[ai][\s\xa0]*Ezdrasza|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|Ezdrasza))|r(?:emier(?:e(?:s[\s\xa0]*Esdras|[\s\xa0]*Esdras)|s[\s\xa0]*Esdras|[\s\xa0]*Esdras)|im(?:e(?:ir[ao][\s\xa0]*Esdras|r(?:o[\s\xa0]*Esdras|[\s\xa0]*Esdras))|[ao][\s\xa0]*Esdras?)|v(?:ni[\s\xa0]*Ezdras|a[\s\xa0]*(?:kniha[\s\xa0]*Ezdras(?:ova)?|Ezdras(?:ova)?)|y[\s\xa0]*(?:list[\s\xa0]*Ezdras(?:ova)?|Ezdras(?:ova)?))))|F(?:orsta[\s\xa0]*Esra|irst[\s\xa0]*Esd(?:r(?:as)?)?)|K(?:itabu[\s\xa0]*cha[\s\xa0]*Kwanza[\s\xa0]*cha[\s\xa0]*Ezra|wanza[\s\xa0]*Ezra)|1(?:re(?:\.[\s\xa0]*Esdras|[\s\xa0]*Esdras)|(?:[ao](?:\.[\s\xa0]*Esdras|[\s\xa0]*Esdras))|e(?:r(?:\.[\s\xa0]*Esdras|e(?:\.[\s\xa0]*Esdras|[\s\xa0]*Esdras)|[\s\xa0]*Esdras)|\.[\s\xa0]*E(?:sdras|zra)|[\s\xa0]*E(?:sdras|zra))|st(?:\.[\s\xa0]*Esd(?:r(?:as)?)?|[\s\xa0]*Esd(?:r(?:as)?)?)|\.(?:o(?:\.[\s\xa0]*Esdras|[\s\xa0]*Esdras)|[\s\xa0]*(?:Ks(?:ieg[ai][\s\xa0]*Ezdrasza|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|E(?:z(?:ra|d(?:ra(?:s(?:ova|za)?)?)?)|s(?:d(?:r(?:a(?:e|s(?:bog)?)?)?)?|ra?)?)))|[\s\xa0]*(?:Ks(?:ieg[ai][\s\xa0]*Ezdrasza|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|k(?:\.[\s\xa0]*Ezdras(?:ova)?|[\s\xa0]*Ezdras(?:ova)?)|E(?:z(?:ra|d(?:ra(?:s(?:ova|za)?)?)?)|s(?:d(?:r(?:a(?:e|s(?:bog)?)?)?)?|ra?)?))|Esd)|E(?:nsimmainen[\s\xa0]*Esra|erste[\s\xa0]*E(?:sdras|zra)|sdra[\s\xa0]*greco|rste[\s\xa0]*Esra|lso[\s\xa0]*Ezd(?:ras)?|zdras[\s\xa0]*I)|Derde[\s\xa0]*E(?:sdras|zra)|3(?:\.[\s\xa0]*E(?:s(?:dra(?:s(?:bog)?)?|ra)|z(?:dra|ra))|e(?:\.[\s\xa0]*E(?:s(?:dras|ra)|zra)|[\s\xa0]*E(?:s(?:dras|ra)|zra))|[\s\xa0]*E(?:s(?:dra(?:s(?:bog)?)?|ra)|z(?:dra|ra)))|T(?:erz[ao][\s\xa0]*Esdra|redje[\s\xa0]*Es(?:drasbog|ra))|Una(?:ng[\s\xa0]*E(?:sdras|zra)|[\s\xa0]*E(?:sdras|zra))|I(?:II(?:\.[\s\xa0]*E(?:sdras?|z(?:dra|ra))|[\s\xa0]*E(?:sdras?|z(?:dra|ra)))|\.[\s\xa0]*(?:Ks(?:ieg[ai][\s\xa0]*Ezdrasza|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|E(?:s(?:ra|d(?:r(?:a[es]?)?)?)|z(?:ra|d(?:ra(?:s(?:ova|za)?)?)?)))|[\s\xa0]*(?:Ks(?:ieg[ai][\s\xa0]*Ezdrasza|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|E(?:s(?:ra|d(?:r(?:as?)?)?)|z(?:ra|d(?:ra(?:s(?:ova|za)?)?)?))))|Liber[\s\xa0]*(?:Esdrae[\s\xa0]*I|I[\s\xa0]*Esdrae))|Pierwsz(?:[aey][\s\xa0]*(?:Ks(?:\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|Ezdrasza))|I[\s\xa0]*Esdrae
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["2Esd"]
		apocrypha: true
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:Kitabu[\s\xa0]*cha[\s\xa0]*Pili[\s\xa0]*cha[\s\xa0]*Ezra|Masodik[\s\xa0]*Ezd(?:ras)?|Ezdras[\s\xa0]*II|Quart[ao][\s\xa0]*Esdra|Fj(?:arde[\s\xa0]*Esra|erde[\s\xa0]*Es(?:drasbog|ra))|And(?:en[\s\xa0]*Esdrasbog|r(?:a[\s\xa0]*Esra|e[\s\xa0]*Es(?:dras|ra)))|D(?:euxieme(?:s[\s\xa0]*Esdras|[\s\xa0]*Esdras)|ru(?:g[ai][\s\xa0]*(?:Ks(?:ieg(?:[ai][\s\xa0]*Ezdrasza|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|Ezdrasza))|h(?:a[\s\xa0]*(?:kniha[\s\xa0]*Ezdras(?:ova)?|Ezdras(?:ova)?)|y[\s\xa0]*(?:list[\s\xa0]*Ezdras(?:ova)?|Ezdras(?:ova)?))))|T(?:oinen[\s\xa0]*Esra|weede[\s\xa0]*E(?:sdras|zra))|Pili[\s\xa0]*Ezra|Zweite[\s\xa0]*Esra|I(?:kalawang[\s\xa0]*E(?:sdras|zra)|V(?:\.[\s\xa0]*E(?:sdras?|z(?:dra|ra))|[\s\xa0]*E(?:sdras?|z(?:dra|ra)))|I(?:\.[\s\xa0]*(?:Ks(?:ieg[ai][\s\xa0]*Ezdrasza|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|E(?:s(?:ra|d(?:r(?:a[es]?)?)?)|z(?:ra|d(?:ra(?:s(?:ova|za)?)?)?)))|[\s\xa0]*(?:Ks(?:ieg[ai][\s\xa0]*Ezdrasza|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|E(?:s(?:ra|d(?:r(?:as?)?)?)|z(?:ra|d(?:ra(?:s(?:ova|za)?)?)?)))))|Vierde[\s\xa0]*E(?:sdras|zra)|4(?:\.[\s\xa0]*E(?:s(?:dra(?:s(?:bog)?)?|ra)|z(?:dra|ra))|[\s\xa0]*E(?:s(?:dra(?:s(?:bog)?)?|ra)|z(?:dra|ra)))|Se(?:gund[ao][\s\xa0]*Esdras|cond(?:[ao][\s\xa0]*Esdras?|[\s\xa0]*Esd(?:r(?:as)?)?))|2(?:(?:[ao](?:\.[\s\xa0]*Esdras|[\s\xa0]*Esdras))|d(?:\.[\s\xa0]*Esdras|e(?:\.[\s\xa0]*Esdras|[\s\xa0]*Esdras)|[\s\xa0]*Esdras)|e(?:me(?:\.[\s\xa0]*Esdras|[\s\xa0]*Esdras)|\.[\s\xa0]*E(?:sdras|zra)|[\s\xa0]*E(?:sdras|zra))|nd(?:\.[\s\xa0]*Esd(?:r(?:as)?)?|[\s\xa0]*Esd(?:r(?:as)?)?)|\.(?:o(?:\.[\s\xa0]*Esdras|[\s\xa0]*Esdras)|[\s\xa0]*(?:Ks(?:ieg[ai][\s\xa0]*Ezdrasza|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|E(?:z(?:ra|d(?:ra(?:s(?:ova|za)?)?)?)|s(?:d(?:r(?:a(?:e|s(?:bog)?)?)?)?|ra?)?)))|[\s\xa0]*(?:Ks(?:ieg[ai][\s\xa0]*Ezdrasza|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|k(?:\.[\s\xa0]*Ezdras(?:ova)?|[\s\xa0]*Ezdras(?:ova)?)|E(?:z(?:ra|d(?:ra(?:s(?:ova|za)?)?)?)|s(?:d(?:r(?:a(?:e|s(?:bog)?)?)?)?|ra?)?))|Esd)|Liber[\s\xa0]*(?:Esdrae[\s\xa0]*II|II[\s\xa0]*Esdrae))|Drug(?:[ai][\s\xa0]*(?:Ks(?:\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza)|Ezdrasza))|II[\s\xa0]*Esdrae
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Isa"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Ks(?:ieg[ai][\s\xa0]*Izajasza|\.[\s\xa0]*Izajasza|[\s\xa0]*Izajasza)|Li(?:ber[\s\xa0]*Isaiae|v[\s\xa0]*Ezayi[\s\xa0]*a)|Yesaya|yas(?:haayaah|aya)|E(?:caya|s(?:eia|a(?:jas['’][\s\xa0]*Bog|i(?:as['’][\s\xa0]*bok|e)?)?)|zs(?:aias)?)|Jes(?:a(?:ia|ja(?:n[\s\xa0]*kirja|s[\s\xa0]*bok|bok(?:en|a))?))?|I(?:-?sa(?:-?gia|i-?a)|a|s(?:i(?:[ai](?:(?:[ai](?:(?:[ai]ha?|ha?))|ha?))|ha)|sah|a(?:a(?:[ai](?:(?:[ai]ha?|ha?))|ha?)|[jy]a|ha?|i(?:i(?:[ai]ha?|ha?)|sha?|a(?:[ai]ha?|ha?|s)?|e|ha?)?)?|h(?:acyaah)?)?|z(?:a(?:i(?:as|ja)|jas))?))|(?:Jesajan|E(?:sa[ji]as|zayi)|I(?:zajasza|-?sa))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["2Sam"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:Liber[\s\xa0]*II[\s\xa0]*Samuelis|And(?:en[\s\xa0]*(?:Kongerigernes[\s\xa0]*Bog|Sam(?:uel(?:sbog)?)?)|r(?:a[\s\xa0]*Samuelsboken|e[\s\xa0]*Sam(?:uel(?:sbok)?)?))|T(?:oinen[\s\xa0]*Samuelin[\s\xa0]*kirja|weede[\s\xa0]*Sam(?:uel)?)|S(?:amu(?:u['’]eel[\s\xa0]*Labaad|el(?:i(?:s[\s\xa0]*II|[\s\xa0]*II)|[\s\xa0]*II))|e(?:gund(?:[ao][\s\xa0]*(?:Reinos|Samuel))|cond(?:[ao][\s\xa0]*Samuele|[\s\xa0]*(?:Kingdoms|S(?:a(?:m(?:u[ae]l[ls]?)?)?|ma?)))))|Kitabu[\s\xa0]*cha[\s\xa0]*Pili[\s\xa0]*cha[\s\xa0]*Samueli|D(?:e(?:uxieme(?:s[\s\xa0]*Samuel|[\s\xa0]*Samuel)|zyem[\s\xa0]*(?:liv[\s\xa0]*Samyel[\s\xa0]*la|Samyel))|ru(?:g(?:a[\s\xa0]*(?:knjiga[\s\xa0]*o[\s\xa0]*Samuelu|Ks(?:ieg(?:[ai][\s\xa0]*Samuel(?:owa|a))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|Samuelo(?:va[\s\xa0]*knjiga|wa))|i[\s\xa0]*(?:Ks(?:ieg(?:[ai][\s\xa0]*Samuel(?:owa|a))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|Samuelowa))|h(?:a[\s\xa0]*(?:kniha[\s\xa0]*Samuelova|S(?:am(?:uel(?:ova)?)?)?)|y[\s\xa0]*(?:kniha[\s\xa0]*Samuelova|list[\s\xa0]*Samuelova|S(?:am(?:uel(?:ova)?)?)?))))|I(?:kalawang[\s\xa0]*Samuel|I(?:\.[\s\xa0]*(?:kniha[\s\xa0]*Samuelova|K(?:s(?:ieg(?:[ai][\s\xa0]*Samuel(?:owa|a))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|ingdoms)|Re(?:g(?:norum|ilor)|inos)|S(?:a(?:m(?:weli|u(?:u['’]eel|al[ls]?|el(?:o[vw]a|[els]|i(?:n[\s\xa0]*kirja|s)?)?|il)|yel)?)?|ma?)?)|[\s\xa0]*(?:kniha[\s\xa0]*Samuelova|K(?:s(?:ieg(?:[ai][\s\xa0]*Samuel(?:owa|a))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|ingdoms)|Re(?:g(?:norum|ilor)|inos)|S(?:a(?:m(?:weli|u(?:u['’]eel|al[ls]?|el(?:o[vw]a|[els]|i(?:n[\s\xa0]*kirja)?)?|il)|yel)?)?|ma?)?)))|Zweite[\s\xa0]*Samuel|Cartea[\s\xa0]*(?:a[\s\xa0]*doua[\s\xa0]*a[\s\xa0]*Regilor|II[\s\xa0]*a[\s\xa0]*(?:lui[\s\xa0]*Samuel|Regilor))|Masodik[\s\xa0]*Sam(?:uel)?|2(?:(?:[ao](?:\.[\s\xa0]*(?:Reinos|Samuel)|[\s\xa0]*(?:Reinos|Samuel)))|d(?:\.[\s\xa0]*Samuel|e(?:\.[\s\xa0]*Samuel|[\s\xa0]*Samuel)|[\s\xa0]*Samuel)|e(?:me(?:\.[\s\xa0]*Samuel|[\s\xa0]*Samuel)|\.[\s\xa0]*Sam(?:uel)?|[\s\xa0]*Sam(?:uel)?)|nd(?:\.[\s\xa0]*(?:Kingdoms|S(?:a(?:m(?:u[ae]l[ls]?)?)?|ma?))|[\s\xa0]*(?:Kingdoms|S(?:a(?:m(?:u[ae]l[ls]?)?)?|ma?)))|\.(?:o(?:\.[\s\xa0]*Samuel|[\s\xa0]*Samuel)|[\s\xa0]*(?:kniha[\s\xa0]*Samuelova|K(?:ongerigernes[\s\xa0]*Bog|s(?:ieg(?:[ai][\s\xa0]*Samuel(?:owa|a))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|ingdoms)|samuelko|Re(?:g(?:norum|ilor)|inos)|S(?:hamooael|a(?:m(?:weli|u(?:u['’]eel|al[ls]?|el(?:o[vw]a|[el]|i(?:n[\s\xa0]*kirja|[st])?|s(?:bo(?:g|k(?:en)?))?)?|il)|yel)?)?|ma?)?))|Sam|[\s\xa0]*(?:k(?:niha[\s\xa0]*Samuelova|\.[\s\xa0]*Samuelova|[\s\xa0]*Samuelova)|(?:[ei](?:\.[\s\xa0]*Samuelit|[\s\xa0]*Samuelit))|K(?:ongerigernes[\s\xa0]*Bog|s(?:ieg(?:[ai][\s\xa0]*Samuel(?:owa|a))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|ingdoms)|Camuvel|samu(?:elko|wel)|Re(?:g(?:norum|ilor)|inos)|S(?:hamooael|a(?:m(?:weli|u(?:u['’]eel|al[ls]?|el(?:o[vw]a|[el]|i(?:n[\s\xa0]*kirja|[st])?|s(?:bo(?:g|k(?:en)?))?)?|il)|yel)?)?|ma?)?))|Pili[\s\xa0]*Sam(?:[uw]eli)?)|(?:Toinen[\s\xa0]*Samuelin|Druga[\s\xa0]*Samuelova|II(?:\.[\s\xa0]*Samuelin|[\s\xa0]*Samueli[ns])|2(?:\.[\s\xa0]*Samuelin|[\s\xa0]*Samuelin))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["1Sam"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:I(?:\.[\s\xa0]*(?:kniha[\s\xa0]*Samuelova|K(?:s(?:ieg(?:[ai][\s\xa0]*Samuel(?:owa|a))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|ingdoms)|Re(?:g(?:norum|ilor)|inos)|S(?:a(?:m(?:weli|u(?:u['’]eel|al[ls]?|el(?:o[vw]a|[els]|i(?:n[\s\xa0]*kirja|s)?)?|il)|yel)?)?|ma?)?)|[\s\xa0]*(?:kniha[\s\xa0]*Samuelova|K(?:s(?:ieg(?:[ai][\s\xa0]*Samuel(?:owa|a))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|ingdoms)|Re(?:g(?:norum|ilor)|inos)|S(?:a(?:m(?:weli|u(?:u['’]eel|al[ls]?|el(?:o[vw]a|[els]|i(?:n[\s\xa0]*kirja)?)?|il)|yel)?)?|ma?)?))|samuelko[\s\xa0]*pustak|Samu(?:u['’]eel[\s\xa0]*Kowaad|el(?:i(?:s[\s\xa0]*I|[\s\xa0]*I)|[\s\xa0]*I))|Cartea[\s\xa0]*(?:intai[\s\xa0]*a[\s\xa0]*Regilor|I[\s\xa0]*a[\s\xa0]*(?:lui[\s\xa0]*Samuel|Regilor))|E(?:nsimmainen[\s\xa0]*Samuelin[\s\xa0]*kirja|rste[\s\xa0]*Samuel|erste[\s\xa0]*Sam(?:uel)?|lso[\s\xa0]*Sam(?:uel)?)|F(?:orsta[\s\xa0]*Samuelsboken|yrri[\s\xa0]*Samuelsbok|irst[\s\xa0]*(?:Kingdoms|S(?:a(?:m(?:u[ae]l[ls]?)?)?|ma?)))|K(?:itabu[\s\xa0]*cha[\s\xa0]*Kwanza[\s\xa0]*cha[\s\xa0]*Samueli|wanza[\s\xa0]*Sam(?:[uw]eli)?)|P(?:ierwsz(?:[aey][\s\xa0]*(?:Ks(?:ieg(?:[ai][\s\xa0]*Samuel(?:owa|a))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|Samuelowa))|r(?:em(?:ier(?:e(?:s[\s\xa0]*Samuel|[\s\xa0]*Samuel)|s[\s\xa0]*Samuel|[\s\xa0]*Samuel)|ye[\s\xa0]*(?:liv[\s\xa0]*Samyel[\s\xa0]*la|Samyel))|im(?:[ao][\s\xa0]*Samuele|e(?:ir(?:[ao][\s\xa0]*(?:Reinos|Samuel))|r(?:o[\s\xa0]*Samuel|[\s\xa0]*Samuel)))|v(?:a[\s\xa0]*(?:Samuelova[\s\xa0]*knjiga|kn(?:jiga[\s\xa0]*o[\s\xa0]*Samuelu|iha[\s\xa0]*Samuelova))|y[\s\xa0]*(?:list[\s\xa0]*Samuelova|Samuelova)|ni[\s\xa0]*(?:kniha[\s\xa0]*Samuelova|S(?:am(?:uel(?:ova)?)?)?))))|Una(?:ng[\s\xa0]*Samuel|[\s\xa0]*Samuel)|Liber[\s\xa0]*I[\s\xa0]*Samuelis|1(?:re(?:\.[\s\xa0]*Samuel|[\s\xa0]*Samuel)|(?:[ao](?:\.[\s\xa0]*(?:Reinos|Samuel)|[\s\xa0]*(?:Reinos|Samuel)))|e(?:r(?:\.[\s\xa0]*Samuel|e(?:\.[\s\xa0]*Samuel|[\s\xa0]*Samuel)|[\s\xa0]*Samuel)|\.[\s\xa0]*Sam(?:uel)?|[\s\xa0]*Sam(?:uel)?)|st(?:\.[\s\xa0]*(?:Kingdoms|S(?:a(?:m(?:u[ae]l[ls]?)?)?|ma?))|[\s\xa0]*(?:Kingdoms|S(?:a(?:m(?:u[ae]l[ls]?)?)?|ma?)))|\.(?:o(?:\.[\s\xa0]*Samuel|[\s\xa0]*Samuel)|[\s\xa0]*(?:kniha[\s\xa0]*Samuelova|K(?:ongerigernes[\s\xa0]*Bog|s(?:ieg(?:[ai][\s\xa0]*Samuel(?:owa|a))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|ingdoms)|samuelko|Re(?:g(?:norum|ilor)|inos)|S(?:hamooael|a(?:m(?:weli|u(?:u['’]eel|al[ls]?|el(?:o[vw]a|[el]|i(?:n[\s\xa0]*kirja|[st])?|s(?:bo(?:g|k(?:en)?))?)?|il)|yel)?)?|ma?)?))|Sam|[\s\xa0]*(?:k(?:niha[\s\xa0]*Samuelova|\.[\s\xa0]*Samuelova|[\s\xa0]*Samuelova)|(?:[ei](?:\.[\s\xa0]*Samuelit|[\s\xa0]*Samuelit))|K(?:ongerigernes[\s\xa0]*Bog|s(?:ieg(?:[ai][\s\xa0]*Samuel(?:owa|a))|\.[\s\xa0]*Samuel(?:owa|a)|[\s\xa0]*Samuel(?:owa|a))|ingdoms)|Camuvel|samu(?:elko|wel)|Re(?:g(?:norum|ilor)|inos)|S(?:hamooael|a(?:m(?:weli|u(?:u['’]eel|al[ls]?|el(?:o[vw]a|[el]|i(?:n[\s\xa0]*kirja|[st])?|s(?:bo(?:g|k(?:en)?))?)?|il)|yel)?)?|ma?)?)))|(?:Ensimmainen[\s\xa0]*Samuelin|Prva[\s\xa0]*Samuelova|I(?:\.[\s\xa0]*Samuelin|[\s\xa0]*Samueli[ns])|1(?:\.[\s\xa0]*Samuelin|[\s\xa0]*Samuelin)|Samu[ae]l[ls]?)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["2Chr"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		2(?:\.[\s\xa0]*itihasko|[\s\xa0]*itihasko)|(?:Ma(?:mbo[\s\xa0]*ya[\s\xa0]*Nyakati[\s\xa0]*II|sodik[\s\xa0]*Kron(?:ika)?)|Kronikak[\s\xa0]*II|Zweite[\s\xa0]*Chronik|I(?:kalawang[\s\xa0]*(?:Paralipomeno|Mga[\s\xa0]*(?:Cronica|Kronika)|C(?:hronicle|ronica)|Kronik(?:el|a))|I(?:\.[\s\xa0]*(?:C(?:oron[io]cles?|ron(?:ache|ocles?|ic(?:as?|i(?:lor)?|l(?:es?)?))?|h(?:oron[io]cles?|r(?:n|o(?:n(?:i(?:ques|c(?:als|les?))|ocles?)?)?)?))|Taar(?:iikhdii)?|Istwa|M(?:ambo[\s\xa0]*ya[\s\xa0]*Nyakati|ga[\s\xa0]*(?:Cronica|Kronika))|Pa(?:r(?:alipomen(?:a|on?))?)?|Hroniky|L(?:jetopisa|etopisu)|K(?:s(?:ieg[ai][\s\xa0]*Kronik|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|wonik|ro(?:n(?:i(?:eken|cka|k(?:el|a)?))?)?)|Babad|kniha[\s\xa0]*kronik|Aikakirja|Nya)|[\s\xa0]*(?:C(?:oron[io]cles?|ron(?:ache|ocles?|ic(?:as?|i(?:lor)?|l(?:es?)?))?|h(?:oron[io]cles?|r(?:n|o(?:n(?:i(?:ques|c(?:als|les?))|ocles?)?)?)?))|Taar(?:iikhdii)?|Istwa|Pa(?:r(?:alipomen[ao])?)?|M(?:ambo[\s\xa0]*ya[\s\xa0]*Nyakati|ga[\s\xa0]*(?:Cronica|Kronika))|Hroniky|L(?:jetopisa|etopisu)|K(?:s(?:ieg[ai][\s\xa0]*Kronik|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|wonik|ro(?:n(?:i(?:eken|cka|k(?:el|a)?))?)?)|Babad|kniha[\s\xa0]*kronik|Aikakirja|Nya)))|Cartea[\s\xa0]*a[\s\xa0]*doua[\s\xa0]*Paralipomena|Se(?:gund[ao][\s\xa0]*Cronicas|cond(?:[ao][\s\xa0]*Cronache|[\s\xa0]*(?:Paralipomenon|C(?:oron[io]cles?|ron(?:[io]cles?)?|h(?:oron[io]cles?|r(?:n|o(?:n(?:ic(?:als|les?)|ocles?)?)?)?)))))|T(?:aariikhdii[\s\xa0]*Labaad|oinen[\s\xa0]*Aikakirja|weede[\s\xa0]*Kron(?:ieken)?)|And(?:ra[\s\xa0]*Kronikeboken|en[\s\xa0]*Kron)|Liber[\s\xa0]*II[\s\xa0]*Paralipomenon|2(?:d(?:\.[\s\xa0]*Chroniques|e(?:\.[\s\xa0]*Chroniques|[\s\xa0]*Chroniques)|[\s\xa0]*Chroniques)|(?:[ao](?:\.[\s\xa0]*Cronicas|[\s\xa0]*Cronicas))|e(?:me(?:\.[\s\xa0]*Chroniques|[\s\xa0]*Chroniques)|\.[\s\xa0]*(?:Chroniques|Kron(?:ieken)?)|[\s\xa0]*(?:Chroniques|Kron(?:ieken)?))|nd(?:\.[\s\xa0]*(?:Paralipomenon|C(?:oron[io]cles?|ron(?:[io]cles?)?|h(?:oron[io]cles?|r(?:n|o(?:n(?:ic(?:als|les?)|ocles?)?)?)?)))|[\s\xa0]*(?:Paralipomenon|C(?:oron[io]cles?|ron(?:[io]cles?)?|h(?:oron[io]cles?|r(?:n|o(?:n(?:ic(?:als|les?)|ocles?)?)?)?))))|\.(?:o(?:\.[\s\xa0]*Cronicas|[\s\xa0]*Cronicas)|[\s\xa0]*(?:C(?:oron[io]cles?|ron(?:ache|ocles?|i(?:c(?:as?|i(?:lor)?|l(?:es?)?)|ka))?|h(?:oron[io]cles?|r(?:n|o(?:n(?:ocles?|i(?:ques|c(?:als|les?)|k))?)?)?))|I(?:tihas|stwa)|M(?:ambo[\s\xa0]*ya[\s\xa0]*Nyakati|ga[\s\xa0]*[CK]roni(?:[ck]a))|Taar(?:iikhdii)?|Pa(?:r(?:alipomen(?:a|on?))?)?|Hroniky|L(?:jetopisa|etopisu)|Babad|kniha[\s\xa0]*kronik|K(?:s(?:ieg[ai][\s\xa0]*Kronik|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|wonik|ro(?:n(?:i(?:eken|c(?:ka|a)|k(?:e(?:boken|l)|a(?:ve)?)?))?)?)|Aikakirja|Nya))|[\s\xa0]*(?:(?:[ie](?:\.[\s\xa0]*Kronika(?:ve)?|[\s\xa0]*Kronika(?:ve)?))|K(?:s(?:ieg[ai][\s\xa0]*Kronik|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|wonik|r(?:n|o(?:n(?:i(?:eken|c(?:ka|a)|k(?:e(?:boken|l)|a(?:ve)?)?))?)?))|I(?:tihas|st(?:wa)?)|M(?:ambo[\s\xa0]*ya[\s\xa0]*Nyakati|ga[\s\xa0]*[CK]roni(?:[ck]a))|Taar(?:iikhdii)?|Pa(?:r(?:alipomen(?:a|on?))?)?|Hroniky|L(?:etopisu|jet(?:opisa)?)|Babad|Aik(?:ak(?:irja)?)?|N(?:alakamam|ya)|k(?:niha[\s\xa0]*kronik|\.[\s\xa0]*(?:Paralipomenon|Kroni(?:cka|k))|[\s\xa0]*(?:Paralipomenon|Kroni(?:cka|k)))|C(?:oron[io]cles?|h(?:oron[io]cles?|r(?:n|o(?:n(?:ocles?|i(?:ques|c(?:als|les?)|k))?)?)?)?|r(?:o(?:n(?:ache|ocles?|i(?:c(?:as?|i(?:lor)?|l(?:es?)?)|ka))?)?)?))|Chr)|P(?:aralipomenon[\s\xa0]*II|ili[\s\xa0]*(?:Mambo[\s\xa0]*ya[\s\xa0]*Nyakati|Nya))|D(?:e(?:uxieme(?:s[\s\xa0]*Chroniques|[\s\xa0]*Chroniques)|zyem[\s\xa0]*(?:liv[\s\xa0]*Kwonik[\s\xa0]*la|Kwonik|Istwa))|ru(?:g(?:a[\s\xa0]*(?:knjiga[\s\xa0]*Ljetopisa|Ljetopisa|K(?:s(?:ieg[ai][\s\xa0]*Kronik|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|ronik))|i[\s\xa0]*K(?:s(?:ieg[ai][\s\xa0]*Kronik|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|ronik))|h(?:a[\s\xa0]*(?:kniha[\s\xa0]*(?:Paralipomenon|Kroni(?:cka|k))|Letopisu|Kroni(?:cka|k)|Pa(?:ralipomenon)?)|y[\s\xa0]*(?:kniha[\s\xa0]*kronik|list[\s\xa0]*(?:Paralipomenon|Kroni(?:cka|k))|Letopisu|Kroni(?:cka|k)|Pa(?:ralipomenon)?)))))|(?:Druha[\s\xa0]*kniha[\s\xa0]*kronik|II[\s\xa0]*Paralipomenon|2[\s\xa0]*itihas)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["1Chr"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		1(?:\.[\s\xa0]*itihasko|[\s\xa0]*itihasko)|(?:itihasko[\s\xa0]*pustak|Mambo[\s\xa0]*ya[\s\xa0]*Nyakati[\s\xa0]*I|C(?:artea[\s\xa0]*intai[\s\xa0]*Paralipomena|horonicle)|P(?:aralipomenon[\s\xa0]*I|ierwsz[aey][\s\xa0]*K(?:s(?:ieg(?:[ai][\s\xa0]*Kronik|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|ronik))|r(?:im(?:e(?:ir[ao][\s\xa0]*Cronicas|r(?:o[\s\xa0]*Cronicas|[\s\xa0]*Cronicas))|[ao][\s\xa0]*Cronache)|em(?:ier(?:e(?:s[\s\xa0]*Chroniques|[\s\xa0]*Chroniques)|s[\s\xa0]*Chroniques|[\s\xa0]*Chroniques)|ye[\s\xa0]*(?:liv[\s\xa0]*Kwonik[\s\xa0]*la|Kwonik|Istwa))|v(?:a[\s\xa0]*(?:Paralipomenon|kn(?:jiga[\s\xa0]*Ljetopisa|iha[\s\xa0]*(?:Paralipomenon|Kroni(?:cka|k)))|Ljetopisa|Kroni(?:cka|k))|y[\s\xa0]*(?:Paralipomenon|list[\s\xa0]*(?:Paralipomenon|Kroni(?:cka|k))|Kroni(?:cka|k))|ni[\s\xa0]*(?:kniha[\s\xa0]*kronik|Letopisu|Kronik|Pa(?:ralipomenon)?))))|Una(?:ng[\s\xa0]*(?:Paralipomeno|Mga[\s\xa0]*(?:Cronica|Kronika)|C(?:hronicle|ronica)|Kronik(?:el|a))|[\s\xa0]*(?:Paralipomeno|Mga[\s\xa0]*(?:Cronica|Kronika)|C(?:hronicle|ronica)|Kronik(?:el|a)))|Liber[\s\xa0]*I[\s\xa0]*Paralipomenon|K(?:ronikak[\s\xa0]*I|wanza[\s\xa0]*(?:Mambo[\s\xa0]*ya[\s\xa0]*Nyakati|Nya))|I(?:\.[\s\xa0]*(?:C(?:oron[io]cles?|ron(?:ache|ocles?|ic(?:as?|i(?:lor)?|l(?:es?)?))?|h(?:oron(?:icles|ocles?)|r(?:n|o(?:n(?:i(?:ques|c(?:als|les?))|ocles?)?)?)?))|K(?:s(?:ieg[ai][\s\xa0]*Kronik|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|wonik|ro(?:n(?:i(?:eken|cka|k(?:el)?))?)?)|Taar(?:iikhdii)?|Istwa|M(?:ambo[\s\xa0]*ya[\s\xa0]*Nyakati|ga[\s\xa0]*(?:Cronica|Kronika))|Pa(?:r(?:alipomen(?:a|on?))?)?|Hroniky|L(?:jetopisa|etopisu)|Babad|kniha[\s\xa0]*kronik|Aikakirja|Nya)|[\s\xa0]*(?:C(?:oron[io]cles?|ron(?:ache|ocles?|ic(?:as?|i(?:lor)?|l(?:es?)?))?|h(?:oron(?:icles|ocles?)|r(?:n|o(?:n(?:i(?:ques|c(?:als|les?))|ocles?)?)?)?))|K(?:s(?:ieg[ai][\s\xa0]*Kronik|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|wonik|ro(?:n(?:i(?:eken|cka|k(?:el)?))?)?)|Taar(?:iikhdii)?|Istwa|Pa(?:r(?:alipomen[ao])?)?|M(?:ambo[\s\xa0]*ya[\s\xa0]*Nyakati|ga[\s\xa0]*(?:Cronica|Kronika))|Hroniky|L(?:jetopisa|etopisu)|Babad|kniha[\s\xa0]*kronik|Aikakirja|Nya))|E(?:nsimmainen[\s\xa0]*Aikakirja|rste[\s\xa0]*Chronik|erste[\s\xa0]*Kron(?:ieken)?|lso[\s\xa0]*Kron(?:ika)?)|1(?:re(?:\.[\s\xa0]*Chroniques|[\s\xa0]*Chroniques)|(?:[ao](?:\.[\s\xa0]*Cronicas|[\s\xa0]*Cronicas))|e(?:r(?:\.[\s\xa0]*Chroniques|e(?:\.[\s\xa0]*Chroniques|[\s\xa0]*Chroniques)|[\s\xa0]*Chroniques)|\.[\s\xa0]*Kron(?:ieken)?|[\s\xa0]*Kron(?:ieken)?)|st(?:\.[\s\xa0]*(?:Paralipomenon|C(?:oron[io]cles?|ron(?:[io]cles?)?|h(?:oron(?:icles|ocles?)|r(?:n|o(?:n(?:ic(?:als|les?)|ocles?)?)?)?)))|[\s\xa0]*(?:Paralipomenon|C(?:oron[io]cles?|ron(?:[io]cles?)?|h(?:oron(?:icles|ocles?)|r(?:n|o(?:n(?:ic(?:als|les?)|ocles?)?)?)?))))|\.(?:o(?:\.[\s\xa0]*Cronicas|[\s\xa0]*Cronicas)|[\s\xa0]*(?:C(?:oron[io]cles?|ron(?:ache|ocles?|i(?:c(?:as?|i(?:lor)?|l(?:es?)?)|ka))?|h(?:oron(?:icles|ocles?)|r(?:n|o(?:n(?:ocles?|i(?:ques|c(?:als|les?)|k))?)?)?))|I(?:tihas|stwa)|M(?:ambo[\s\xa0]*ya[\s\xa0]*Nyakati|ga[\s\xa0]*[CK]roni(?:[ck]a))|Taar(?:iikhdii)?|Pa(?:r(?:alipomen(?:a|on?))?)?|Hroniky|L(?:jetopisa|etopisu)|Babad|kniha[\s\xa0]*kronik|K(?:s(?:ieg[ai][\s\xa0]*Kronik|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|wonik|ro(?:n(?:i(?:eken|c(?:ka|a)|k(?:e(?:boken|l)|a(?:ve)?)?))?)?)|Aikakirja|Nya))|[\s\xa0]*(?:(?:[ie](?:\.[\s\xa0]*Kronika(?:ve)?|[\s\xa0]*Kronika(?:ve)?))|K(?:s(?:ieg[ai][\s\xa0]*Kronik|\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|wonik|r(?:n|o(?:n(?:i(?:eken|c(?:ka|a)|k(?:e(?:boken|l)|a(?:ve)?)?))?)?))|I(?:tihas|st(?:wa)?)|M(?:ambo[\s\xa0]*ya[\s\xa0]*Nyakati|ga[\s\xa0]*[CK]roni(?:[ck]a))|Taar(?:iikhdii)?|Pa(?:r(?:alipomen(?:a|on?))?)?|Hroniky|L(?:etopisu|jet(?:opisa)?)|Babad|Aik(?:ak(?:irja)?)?|N(?:alakamam|ya)|k(?:niha[\s\xa0]*kronik|\.[\s\xa0]*(?:Paralipomenon|Kroni(?:cka|k))|[\s\xa0]*(?:Paralipomenon|Kroni(?:cka|k)))|C(?:oron[io]cles?|h(?:oron(?:icles|ocles?)|r(?:n|o(?:n(?:ocles?|i(?:ques|c(?:als|les?)|k))?)?)?)?|r(?:o(?:n(?:ache|ocles?|i(?:c(?:as?|i(?:lor)?|l(?:es?)?)|ka))?)?)?))|Chr)|Taariikhdii[\s\xa0]*Kowaad|F(?:orsta[\s\xa0]*Kronikeboken|yrri[\s\xa0]*Kronikubok|irst[\s\xa0]*(?:Paralipomenon|C(?:oron[io]cles?|ron(?:[io]cles?)?|h(?:oron(?:icles|ocles?)|r(?:n|o(?:n(?:ic(?:als|les?)|ocles?)?)?)?)))))|Pierwsz(?:[aey][\s\xa0]*K(?:s(?:\.[\s\xa0]*Kronik|[\s\xa0]*Kronik)|ronik))|(?:Paralipomenon|I(?:\.[\s\xa0]*Kronika|[\s\xa0]*(?:Paralipomenon|Kronika))|1[\s\xa0]*itihas|C(?:oron[oi]cles?|h(?:oron(?:icles|ocles?)|ron(?:ocles?|ic(?:als|les?)))|ron[oi]cles?))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Ezra"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Li(?:v[\s\xa0]*Esdras[\s\xa0]*la|ber[\s\xa0]*Esdrae)|K(?:njiga[\s\xa0]*Ezrina|s(?:ieg[ai][\s\xa0]*Ezdrasza|\.[\s\xa0]*Ezdrasza|[\s\xa0]*Ezdrasza))|Aejra|edzra|Ces(?:r(?:aa)?)?|E(?:s(?:d(?:ra?)?|r(?:a(?:n[\s\xa0]*kirja|s[\s\xa0]*bok|bok)?)?)|z(?:sd(?:ras)?|d(?:r(?:as?)?)?|r(?:a(?:s[\s\xa0]*Bog)?)?)|d))|E(?:zdrasza|s(?:dra[se]|ra[sn]))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Ruth"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Li(?:ber[\s\xa0]*Ruth|v[\s\xa0]*Rit[\s\xa0]*la)|K(?:itabu[\s\xa0]*cha[\s\xa0]*Ruth[iu]|njiga[\s\xa0]*o[\s\xa0]*Ruti|s(?:ieg(?:[ai][\s\xa0]*Rut(?:hy)?)|\.[\s\xa0]*Rut(?:hy)?|[\s\xa0]*Rut(?:hy)?))|R(?:oot|th?|u(?:t(?:hs[\s\xa0]*Bog|s[\s\xa0]*bok|a(?:rbok)?|e)|u(?:d|t(?:in[\s\xa0]*kirja)?))?))|R(?:u(?:utin|t(?:s|h[ui]?)?)|it)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Neh"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		nahemyahko[\s\xa0]*pustak|Nahemyah|(?:K(?:njiga[\s\xa0]*Nehemijina|s(?:ieg[ai][\s\xa0]*Nehemiasza|\.[\s\xa0]*Nehemiasza|[\s\xa0]*Nehemiasza))|Li(?:ber[\s\xa0]*Nehemiae|v[\s\xa0]*Neyemi[\s\xa0]*an)|nahemya|Ne(?:kemiya|em(?:i(?:ja|as?)?)?|h(?:amiah?|em(?:eia|a(?:[ai](?:(?:[ai]h|h))|h)|i(?:i(?:[ai]h|h)|ja|a(?:n[\s\xa0]*kirja|s’[\s\xa0]*Bog|bok|[ai]h|h)?|[eh])|ja(?:s[\s\xa0]*bok)?|ya)|im(?:a(?:[ai](?:(?:[ai]h|h))|h)|i(?:i(?:[ai]h|h)|a(?:[ai]h|h)?|h)))?|x(?:emyaah)?)?)|(?:nahemyahko|Ne(?:hem(?:ia(?:[en]|s(?:za)?)|jas)|yemi))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["GkEsth"]
		apocrypha: true
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Den[\s\xa0]*greske[\s\xa0]*Ester-?bok(?:en|a)|Kr(?:eikkalainen[\s\xa0]*Esterin[\s\xa0]*kirja|\.[\s\xa0]*Est|[\s\xa0]*Est)|G(?:k(?:[\s\xa0]*Esth?|Esth)|r(?:aeca[\s\xa0]*Esther|e(?:cke[\s\xa0]*casti[\s\xa0]*knihy[\s\xa0]*Ester|ek[\s\xa0]*Est(?:h(?:er)?)?)|[\s\xa0]*Esth?|Est))|Es(?:zter[\s\xa0]*konyvenek[\s\xa0]*kiegeszitese|t(?:er(?:arbok[\s\xa0]*hin[\s\xa0]*griska|[\s\xa0]*(?:enligt[\s\xa0]*den[\s\xa0]*grekiska[\s\xa0]*texten|recke[\s\xa0]*(?:dodatky|casti)|greco|\((?:versione[\s\xa0]*greca\)|greco\)|Gr(?:i(?:yego\)|e(?:chisch\)|ks\)|go\)))|yego\)|eg[ao]\)|\)))|Gr(?:i(?:yego|ego)|yego|eg[ao])?))|h(?:er[\s\xa0]*(?:\(Gre(?:ek\)|c\))|graeca|Gr(?:ec)?)|[\s\xa0]*Gr)|[\s\xa0]*(?:\(Gr\)|Gr)|g)))|(?:Kreikkalainen[\s\xa0]*Esterin|Est(?:er[\s\xa0]*(?:\((?:Grie(?:chisch\)|ks\))|gr(?:iego\)|ega\)))|gr(?:iego|ega)?)|h(?:er[\s\xa0]*(?:\(grec\)|gr(?:ec)?)|[\s\xa0]*gr)|[\s\xa0]*(?:\(Gr\)|gr)))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Esth"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:estarko[\s\xa0]*pustak|Li(?:ber[\s\xa0]*Esther|v[\s\xa0]*Este[\s\xa0]*a)|Ks(?:ieg[ai][\s\xa0]*Estery|\.[\s\xa0]*Estery|[\s\xa0]*Estery)|Aester|astar|E(?:s(?:zt(?:er)?|t(?:e(?:er|r(?:in[\s\xa0]*kirja|s[\s\xa0]*(?:Bog|bok)|ei|a(?:rbok)?)?)|[ah]r?)?)?|t))|Ester(?:in|[sy])|(?:est(?:arko|er)|Est(?:her|e))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Job"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Li(?:v[\s\xa0]*Job[\s\xa0]*la|ber[\s\xa0]*Iob)|K(?:itabu[\s\xa0]*cha[\s\xa0]*(?:Ayubu|Yobu)|n(?:jiga[\s\xa0]*o[\s\xa0]*Jobu|iha[\s\xa0]*Jobova)|\.[\s\xa0]*Jobova|[\s\xa0]*Jobova|s(?:ieg(?:[ai][\s\xa0]*(?:Hioba|Ijoba|Joba))|\.[\s\xa0]*(?:Hioba|Ijoba|Joba)|[\s\xa0]*(?:Hioba|Ijoba|Joba)))|Ay(?:yoob|u(?:ub|b)?)|I(?:job|ov)|ayyubko[\s\xa0]*pustak|iyob|J(?:o(?:b(?:s(?:[\s\xa0]*(?:Bog|bok)|bok)|i(?:n[\s\xa0]*kirja)?)|v)|b)|G(?:iobbe|b)|Yo(?:pu|b)|Hi(?:obi?)?)|(?:ayyubko|Hioba|Ayubu|Yobu|Job(?:in|[as])?|Iob)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Mal"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Pro(?:roctwo[\s\xa0]*Malachyaszowe|phetia[\s\xa0]*Malachiae)|Ks(?:ieg[ai][\s\xa0]*Malachiasza|\.[\s\xa0]*Malachiasza|[\s\xa0]*Malachiasza)|Liv[\s\xa0]*Malachi[\s\xa0]*a|M(?:a(?:-?la-?(?:chi|ki)|l(?:ea(?:[ck]hi|hi)|ichi|kiya|a(?:akii|hija|k(?:ee|i(?:s[\s\xa0]*bok|a(?:n[\s\xa0]*kirja|s’[\s\xa0]*Bog)?)?)|qu(?:ias)?|c(?:h(?:i(?:as?|e))?|i)?)?|ch?)?)|l))|(?:Mala(?:kia[sn]|chi(?:asza)?)|malaki)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Matt"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:matt(?:ayane|ile)|Injil(?:i[\s\xa0]*ya[\s\xa0]*Mathayo|[\s\xa0]*Matius)|Ungjilli[\s\xa0]*i[\s\xa0]*Mateut|The[\s\xa0]*Gospel[\s\xa0]*(?:according[\s\xa0]*to[\s\xa0]*(?:S(?:aint[\s\xa0]*M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:h(?:(?:[ht](?:iew|ew))|iew|ew|we)|iew|t(?:h(?:iew|ew)|iew|ew)|ew|we)?)?|t)|t(?:\.[\s\xa0]*M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:h(?:(?:[ht](?:iew|ew))|iew|ew|we)|iew|t(?:h(?:iew|ew)|iew|ew)|ew|we)?)?|t)|[\s\xa0]*M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:h(?:(?:[ht](?:iew|ew))|iew|ew|we)|iew|t(?:h(?:iew|ew)|iew|ew)|ew|we)?)?|t)))|M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:h(?:(?:[ht](?:iew|ew))|iew|ew|we)|iew|t(?:h(?:iew|ew)|iew|ew)|ew|we)?)?|t))|of[\s\xa0]*(?:S(?:aint[\s\xa0]*M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:h(?:(?:[ht](?:iew|ew))|iew|ew|we)|iew|t(?:h(?:iew|ew)|iew|ew)|ew|we)?)?|t)|t(?:\.[\s\xa0]*M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:h(?:(?:[ht](?:iew|ew))|iew|ew|we)|iew|t(?:h(?:iew|ew)|iew|ew)|ew|we)?)?|t)|[\s\xa0]*M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:h(?:(?:[ht](?:iew|ew))|iew|ew|we)|iew|t(?:h(?:iew|ew)|iew|ew)|ew|we)?)?|t)))|M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:h(?:(?:[ht](?:iew|ew))|iew|ew|we)|iew|t(?:h(?:iew|ew)|iew|ew)|ew|we)?)?|t)))|E(?:van(?:keliumi[\s\xa0]*Matteuksen[\s\xa0]*mukaan|geli(?:e(?:[\s\xa0]*volgens[\s\xa0]*Matteus|t[\s\xa0]*etter[\s\xa0]*Matteus)|um[\s\xa0]*(?:secundum[\s\xa0]*Matthaeum|podle[\s\xa0]*Matouse))|jelium[\s\xa0]*Podla[\s\xa0]*Matusa)|l[\s\xa0]*Evangelio[\s\xa0]*de[\s\xa0]*Mateo|banghelyo[\s\xa0]*(?:ayon[\s\xa0]*kay[\s\xa0]*Mateo|ni[\s\xa0]*(?:San[\s\xa0]*Mateo|Mateo))|w(?:angelia[\s\xa0]*(?:wg[\s\xa0]*sw(?:\.[\s\xa0]*Mateusza|[\s\xa0]*Mateusza)|Mateusza)|\.[\s\xa0]*Mateusza|[\s\xa0]*Mat(?:eusza)?))|Jevanhelije[\s\xa0]*vid[\s\xa0]*Matvija|Vangelo[\s\xa0]*di[\s\xa0]*(?:San[\s\xa0]*Matteo|Matteo)|M(?:a(?:buting[\s\xa0]*Balita[\s\xa0]*ayon[\s\xa0]*kay[\s\xa0]*(?:San[\s\xa0]*Mateo|Mateo)|t(?:ayos?|ous(?:ovo[\s\xa0]*evangelium)?|t(?:e(?:i[\s\xa0]*evangelium|u(?:ksen[\s\xa0]*evankeliumi|sevangeliet)|yu[\s\xa0]*Narceyti|e)|h(?:a(?:eus|us)|eus|ieu)?)|us|ye|e(?:[ij]|u(?:sz?)?)?|h))|t[ht])|Sulat[\s\xa0]*ni[\s\xa0]*San[\s\xa0]*Mateo)|(?:Evangelio[\s\xa0]*de[\s\xa0]*Mateo|Gospel[\s\xa0]*(?:according[\s\xa0]*to[\s\xa0]*(?:S(?:aint[\s\xa0]*M(?:at(?:h(?:(?:[th](?:(?:[th](?:iew|ew))|iew|ew))|iew|ew)|t(?:t(?:h(?:iew|ew)|iew|ew)|h(?:iew|(?:[ht](?:iew|ew))|ew|we)|iew|we|ew)?)?|t)|t(?:\.[\s\xa0]*M(?:at(?:h(?:(?:[ht](?:iew|(?:[ht](?:iew|ew))|ew))|iew|ew)|t(?:iew|t(?:iew|h(?:iew|ew)|ew)|h(?:iew|(?:[th](?:iew|ew))|we|ew)|we|ew)?)?|t)|[\s\xa0]*M(?:at(?:h(?:(?:[ht](?:(?:[th](?:iew|ew))|iew|ew))|iew|ew)|t(?:t(?:h(?:iew|ew)|iew|ew)|h(?:(?:[th](?:iew|ew))|iew|ew|we)|iew|ew|we)?)?|t)))|M(?:at(?:h(?:(?:[th](?:(?:[th](?:iew|ew))|iew|ew))|iew|ew)|t(?:t(?:h(?:iew|ew)|iew|ew)|iew|h(?:(?:[ht](?:iew|ew))|iew|we|ew)|ew|we)?)?|t))|of[\s\xa0]*(?:S(?:aint[\s\xa0]*M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:iew|t(?:h(?:iew|ew)|iew|ew)|h(?:iew|(?:[ht](?:iew|ew))|ew|we)|ew|we)?)?|t)|t(?:\.[\s\xa0]*M(?:at(?:h(?:(?:[th](?:iew|(?:[th](?:iew|ew))|ew))|iew|ew)|t(?:t(?:iew|h(?:iew|ew)|ew)|iew|h(?:(?:[ht](?:iew|ew))|iew|ew|we)|we|ew)?)?|t)|[\s\xa0]*M(?:at(?:h(?:(?:[th](?:iew|(?:[ht](?:iew|ew))|ew))|iew|ew)|t(?:t(?:iew|h(?:iew|ew)|ew)|iew|h(?:iew|(?:[th](?:iew|ew))|we|ew)|ew|we)?)?|t)))|M(?:at(?:h(?:(?:[ht](?:(?:[ht](?:iew|ew))|iew|ew))|iew|ew)|t(?:iew|t(?:iew|h(?:iew|ew)|ew)|h(?:(?:[th](?:iew|ew))|iew|we|ew)|ew|we)?)?|t)))|S(?:a(?:n[\s\xa0]*Mateo|int[\s\xa0]*M(?:at(?:h(?:(?:[th](?:(?:[th](?:iew|ew))|iew|ew))|iew|ew)|t(?:t(?:iew|h(?:iew|ew)|ew)|iew|h(?:(?:[ht](?:iew|ew))|iew|ew|we)|ew|we)?)?|t))|t(?:\.[\s\xa0]*M(?:at(?:h(?:(?:[th](?:iew|(?:[ht](?:iew|ew))|ew))|iew|ew)|t(?:t(?:h(?:iew|ew)|iew|ew)|iew|h(?:(?:[th](?:iew|ew))|iew|we|ew)|we|ew)?)?|t)|[\s\xa0]*M(?:at(?:h(?:iew|(?:[th](?:iew|(?:[ht](?:iew|ew))|ew))|ew)|t(?:t(?:iew|h(?:iew|ew)|ew)|h(?:iew|(?:[th](?:iew|ew))|we|ew)|iew|ew|we)?)?|t)))|M(?:at(?:ius|h(?:ayo|(?:[th](?:(?:[th](?:iew|ew))|iew|ew))|iew|ew)|usa|eo|t(?:iew|t(?:h(?:iew|ew)|iew|ew)|h(?:(?:[ht](?:iew|ew))|iew|we|ew)|we|e(?:u(?:ksen|s)|yu|[wo]))?)?|t))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Ps"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Ca(?:rtea[\s\xa0]*Psalmilor|nkitam)|Li(?:b(?:ri[\s\xa0]*i[\s\xa0]*Psalmeve|er[\s\xa0]*Psalmorum)|v[\s\xa0]*Som[\s\xa0]*yo)|stotrasamhita|M(?:ga[\s\xa0]*(?:Salmo|Awit)|asmur)|Thi|Z(?:solt(?:arok)?|a(?:l(?:tar|my?)|b(?:uri?)?))?|K(?:niha[\s\xa0]*zalm(?:ov|u)|s(?:ieg[ai][\s\xa0]*Psalmow|\.[\s\xa0]*Psalmow|[\s\xa0]*Psalmow)|\.[\s\xa0]*zalmov|[\s\xa0]*zalmov)|S(?:a(?:buur(?:radii)?|l(?:m(?:a(?:rnir|u)|os|e(?:rne(?:s[\s\xa0]*Bog)?|ne(?:s[\s\xa0]*bok)?)?|[is])?)?)|lm?)|Jabur|P(?:a(?:l(?:[lm]s|sms?)|m[ls]s|s(?:lms?|m(?:ls|s)|ss))|l(?:a(?:as?|m(?:as|s)?|s(?:m(?:as?|s)?|s)?)|ms|s(?:a(?:ms?)?|ms?|s(?:s(?:ss?)?)?))|s(?:l(?:a(?:lms?|ms?)?|m(?:as|[ms])?)|a(?:a(?:lms?|ms|a)|l(?:taren|lms?|a(?:ms?|s)?|m(?:u[ls]|a[su]?|e[nt]?|i(?:en[\s\xa0]*kirja|[it])?|[lm]s?|[sy])?|s)?|m(?:as|l(?:[as]|ms?)?|ms?|s)?|u(?:mes?)?)?|m(?:a(?:l(?:ms?|s)?)?|ls?|m)?|sm?)?)|Bhjan)|(?:Psalmien|Awit|S(?:alm(?:enes|o)|om))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Eccl"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Juru[\s\xa0]*Kotbah|K(?:niha[\s\xa0]*kazatelova|\.[\s\xa0]*kazatelova|[\s\xa0]*kazatelova|s(?:ieg(?:[ai][\s\xa0]*(?:Eklezjastesa|K(?:aznodziei[\s\xa0]*Salomona|oheleta)))|\.[\s\xa0]*(?:Eklezjastesa|K(?:aznodziei[\s\xa0]*Salomona|oheleta))|[\s\xa0]*(?:Eklezjastesa|K(?:aznodziei[\s\xa0]*Salomona|oheleta)))|a(?:alam|z(?:n(?:odziei[\s\xa0]*Salomonowego)?)?)|oh(?:elet(?:[\s\xa0]*—[\s\xa0]*Kazatel|h))?)|Ang[\s\xa0]*Mangangaral|upadesak(?:ko[\s\xa0]*pustak)?|Wac(?:diyah(?:ii|a))?|Coelet|Fork(?:ynneren(?:s[\s\xa0]*bok)?)?|Sa(?:bhopadeshak|ar(?:n(?:aaja(?:n[\s\xa0]*kirja)?)?)?)|Qo(?:h(?:eleth?)?)?|Liber[\s\xa0]*(?:Ecclesiastes|Qoelet)|P(?:iracanki|r(?:ad|e(?:d(?:i(?:ger|k(?:a(?:ntens[\s\xa0]*bok|r(?:boken|inn|en(?:s[\s\xa0]*bok)?)|tor)|uesi|er(?:ens?)?)))?|g(?:ethwr)?)|op(?:ovjednik)?))|M(?:a(?:gwawali|nga)|hu(?:biri)?)|E(?:k(?:kle(?:siastes|zijast)|l(?:e(?:s[iy]astes|z(?:yas[\s\xa0]*-?[\s\xa0]*Liv[\s\xa0]*Filozof[\s\xa0]*la|iastes))|is[iy]astes)?)|c(?:c(?:l(?:es(?:s(?:[ai](?:[ai](?:stes?|tes?)))|a(?:stes|a(?:stes?|tes?)|i(?:astes|stes?|tes?))|i(?:stes|a(?:i(?:astes|stes)|a(?:stes|tes)|st(?:i(?:ces|es)|ul|e)?|tes?)|i(?:astes|stes?|tes?)|tes))?)?)?|l(?:is[iy]astes|e(?:ziast(?:ul)?|s(?:yastes|s(?:[ai](?:[ai](?:stes?|tes?)))|a(?:[ai](?:stes?|tes?))|i(?:stes|a(?:iastes|st(?:i(?:ces|es)|ul|es?)|tes?)|i(?:stes?|tes?)))?))?)?))|(?:Liv[\s\xa0]*Filozof[\s\xa0]*la|Mangangaral|Saarnaajan|upadesakko|E(?:cclesiastes|klezyas)|Filozof|K(?:ohelet|azatel)|Qoelet)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Ezek"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Iezechiel|yahedzkel|E(?:cekkiyel|x(?:[ei](?:(?:[ei]k(?:iel|el))|k(?:iel|el)))|s(?:e(?:c(?:iel)?|k(?:iel(?:s[\s\xa0]*bok)?|yel)?)|k)|z(?:i(?:(?:[ei](?:qu(?:iel|el)|k(?:iel|el)))|qu(?:iel|el)|k(?:iel|el))|e(?:(?:[ei](?:qu(?:iel|el)|k(?:iel|el)))|c(?:iel|h(?:iele?)?)?|k(?:i(?:al|el(?:s(?:’[\s\xa0]*Bog|[\s\xa0]*Bog)|i)?)|el)?|q(?:u(?:i[ae]l|el)?)?)?|[kq]))|Liv[\s\xa0]*Ezekyel[\s\xa0]*la|Prophetia[\s\xa0]*Ezechielis|He(?:zechiel|s(?:ekiel(?:in[\s\xa0]*kirja|s[\s\xa0]*bok)?)?)|Y(?:ahejakel|e(?:he[sz]kiel|x(?:esqeel)?))|Ks(?:ieg[ai][\s\xa0]*Ezechiela|\.[\s\xa0]*Ezechiela|[\s\xa0]*Ezechiela)|Jezekiil['’])|(?:Hesekielin|Eze(?:chiela|kyel))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Hos"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		Hose(?:ias?|a(?:s(?:’[\s\xa0]*Bog|[\s\xa0]*bok))?)|(?:Prophetia[\s\xa0]*Osee|Ks(?:ieg[ai][\s\xa0]*Ozeasza|\.[\s\xa0]*Ozeasza|[\s\xa0]*Ozeasza)|Liv[\s\xa0]*Oze[\s\xa0]*a|hosey?|H(?:o(?:zeas|os(?:ean[\s\xa0]*kirja|h(?:eeca)?)?|s(?:ho)?)?|s)|O(?:ciya|s(?:ija|e(?:ia[hs]?|a[hs]?))?|z(?:eas)?))|(?:Ho(?:osean|seas)|O(?:see|ze(?:asza)?))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Obad"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Pro(?:roctwo[\s\xa0]*Abdyaszowe|phetia[\s\xa0]*Abdiae)|Liv[\s\xa0]*Abdyas[\s\xa0]*la|Ks(?:ieg[ai][\s\xa0]*Abdiasza|\.[\s\xa0]*Abdiasza|[\s\xa0]*Abdiasza)|obadiya|Cob(?:ad(?:yaah)?)?|A(?:vdie|b(?:d(?:i(?:jas|as?))?)?)|O(?:patiya|v(?:adia|dij)|b(?:edias|idah|a(?:ja|d(?:eia|hah|i(?:ja|a(?:s['’][\s\xa0]*Bog|h)?)|j(?:a(?:n[\s\xa0]*kirja|s[\s\xa0]*bok)?)?)?)?|d)?))|(?:Obad(?:ja[sn]|ias)|Abd(?:iasza|yas))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Hag"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Pro(?:roctwo[\s\xa0]*Aggieuszowe|phetia[\s\xa0]*Aggaei)|Ks(?:ieg[ai][\s\xa0]*Aggeusza|\.[\s\xa0]*Aggeusza|[\s\xa0]*Aggeusza)|Liv[\s\xa0]*Aje[\s\xa0]*a|haggay|Ohij|Xag(?:g(?:ay)?)?|A(?:-?gai|kay|g(?:heu|ai|e(?:[jo]|us?)|g(?:a(?:eus|us)|e(?:us|[eo]))?)?)|H(?:a(?:-?gai|g(?:a[ij]|e[jo]|g(?:ia[hi]|a(?:ai|i(?:n[\s\xa0]*kirja|s[\s\xa0]*bok)?|j(?:s[\s\xa0]*Bog)?)|e(?:us|o))?)?)|gg?))|(?:Haggain|A(?:ggeusza|je))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Hab"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Pro(?:roctwo[\s\xa0]*Abakukowe|phetia[\s\xa0]*Habacuc)|Liv[\s\xa0]*Abakik[\s\xa0]*la|Ks(?:ieg[ai][\s\xa0]*Habakuka|\.[\s\xa0]*Habakuka|[\s\xa0]*Habakuka)|A(?:pakuk|va[ck]um|b(?:a(?:cuc|k(?:ouk|uka?)?)|k))|Hab(?:ba(?:c[au]c|k(?:k[au]kk?|[au]kk?))|a(?:c(?:uque|cuc|kuk|ac)?|k(?:k(?:ook|akk?|uk(?:s[\s\xa0]*(?:Bog|bok)|k)?)|akk?|uk(?:i(?:n[\s\xa0]*kirja)?|[ku])?)?)|[ck])?|Xab(?:aquuq)?)|Habakuk(?:in|a)|(?:habak(?:kuk|uk)|Habacuc|Abakik)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Mic"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Prophetia[\s\xa0]*Michaeae|Ks(?:ieg[ai][\s\xa0]*Micheasza|\.[\s\xa0]*Micheasza|[\s\xa0]*Micheasza)|Liv[\s\xa0]*Miche[\s\xa0]*a|M(?:eeka|yhej|i(?:-?ca|ik(?:a(?:n[\s\xa0]*kirja|ah)?)?|c(?:ah?|h(?:e(?:as?|e)|a(?:eas|as|h)?)?)?|h(?:e(?:ia|j))?|k(?:ieas|e(?:yas|as?)|ha|a(?:s[\s\xa0]*(?:Bog|bok)|h)?)?|q(?:ue(?:ias|as))?)|q))|(?:Mi(?:ikan|kas|che(?:asza)?)|mika)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Zech"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		Zech[ae]ra(?:(?:[ai]h|h))|(?:Prophetia[\s\xa0]*Zachariae|Z(?:e(?:c(?:h(?:[ae]ri(?:ih|ah?|h))?)?|k(?:ariah?)?)|a(?:c(?:ar(?:ias)?|c(?:aria|h(?:arie)?)?|h(?:ar(?:jas|a(?:[ai]h|h)|i(?:ih|a[hs]?|[eh]))|er(?:a(?:[ai]h|h)|i(?:ih|ah?|h)))?)?|h(?:ari(?:a|ja?))?|k(?:haria|aria(?:s['’][\s\xa0]*Bog|h)?)?)?|ch?)|Jakaryah|[jC]akariya|Ks(?:ieg[ai][\s\xa0]*Zachariasza|\.[\s\xa0]*Zachariasza|[\s\xa0]*Zachariasza)|Xa-?cha-?ri-?a|S(?:a(?:c(?:arias|h(?:arja)?)|k(?:ar(?:ias?|ja(?:n[\s\xa0]*kirja|boken|s[\s\xa0]*bok)?))?)|e(?:ch(?:areia)?|k(?:aryaah)?))|Liv[\s\xa0]*Zakari[\s\xa0]*a)|(?:Sakarjan|Za(?:chariasza|kari(?:as)?)|Xa(?:-?cha-?ri)?)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Zeph"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Pro(?:roctwo[\s\xa0]*Sofoniaszowe|phetia[\s\xa0]*Sophoniae)|Ks(?:ieg[ai][\s\xa0]*Sofoniasza|\.[\s\xa0]*Sofoniasza|[\s\xa0]*Sofoniasza)|Liv[\s\xa0]*Sofoni[\s\xa0]*an|Ceppaniya|Tef(?:ania)?|S(?:apanyah|z(?:efanias|of(?:onias)?)|e(?:p(?:anias?|h)|f(?:an(?:yaah|i(?:ja|a(?:s['’][\s\xa0]*Bog)?)|ja(?:n[\s\xa0]*kirja|s[\s\xa0]*bok)?)|f(?:aneia)?)?)|o(?:ph(?:oni(?:as|e))?|f(?:on(?:jas|i(?:j[ae]|as?|e)))?)|f)|Z(?:ofonias|a(?:phaniah?|faniah?)|e(?:f(?:an(?:ia[hs]?|[jy]a))?|p(?:anias|h(?:an(?:aiah?|ia[hs]?|ja)?)?)?)|ph?))|(?:sapanyah|S(?:efan(?:jan|ias)|ofoni(?:asza)?))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Luke"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		luka(?:[ln]e)|(?:Ungjilli[\s\xa0]*i[\s\xa0]*Lukes|L(?:ooka|ik|lu(?:ka)?|u(?:k(?:ka[\s\xa0]*Narceyti|a(?:s(?:ovo[\s\xa0]*evangelium|[\s\xa0]*evangelium|evangeliet)|cs))|-?ca|uk(?:kaan[\s\xa0]*evankeliumi|os)?|c)|c)?|Jevanhelije[\s\xa0]*vid[\s\xa0]*Luky|The[\s\xa0]*Gospel[\s\xa0]*(?:according[\s\xa0]*to[\s\xa0]*(?:S(?:aint[\s\xa0]*L(?:k|u(?:ke?)?)|t(?:\.[\s\xa0]*L(?:k|u(?:ke?)?)|[\s\xa0]*L(?:k|u(?:ke?)?)))|L(?:k|u(?:ke?)?))|of[\s\xa0]*(?:S(?:aint[\s\xa0]*L(?:k|u(?:ke?)?)|t(?:\.[\s\xa0]*L(?:k|u(?:ke?)?)|[\s\xa0]*L(?:k|u(?:ke?)?)))|L(?:k|u(?:ke?)?)))|Sulat[\s\xa0]*ni[\s\xa0]*San[\s\xa0]*Lucas|Injil(?:i[\s\xa0]*ya[\s\xa0]*Luka|[\s\xa0]*Lukas)|Mabuting[\s\xa0]*Balita[\s\xa0]*ayon[\s\xa0]*kay[\s\xa0]*(?:San[\s\xa0]*Lu[ck]as|Lu[ck]as)|E(?:banghelyo[\s\xa0]*(?:ayon[\s\xa0]*kay[\s\xa0]*(?:San[\s\xa0]*Lu[ck]as|Lu[ck]as)|ni[\s\xa0]*San[\s\xa0]*Lu[ck]as)|van(?:keliumi[\s\xa0]*Luukkaan[\s\xa0]*mukaan|jelium[\s\xa0]*Podla[\s\xa0]*Lukasa|geli(?:um[\s\xa0]*(?:secundum[\s\xa0]*Lucam|podle[\s\xa0]*Lukase)|e(?:[\s\xa0]*volgens[\s\xa0]*Lu[ck]as|t[\s\xa0]*etter[\s\xa0]*Lukas)))|l[\s\xa0]*Evangelio[\s\xa0]*de[\s\xa0]*Lucas)|Vangelo[\s\xa0]*di[\s\xa0]*(?:San[\s\xa0]*Luca|Luca))|(?:Evangelio[\s\xa0]*de[\s\xa0]*Lucas|Gospel[\s\xa0]*(?:according[\s\xa0]*to[\s\xa0]*(?:S(?:aint[\s\xa0]*L(?:k|u(?:ke?)?)|t(?:\.[\s\xa0]*L(?:k|u(?:ke?)?)|[\s\xa0]*L(?:u(?:ke?)?|k)))|L(?:u(?:ke?)?|k))|of[\s\xa0]*(?:S(?:aint[\s\xa0]*L(?:k|u(?:ke?)?)|t(?:\.[\s\xa0]*L(?:k|u(?:ke?)?)|[\s\xa0]*L(?:k|u(?:ke?)?)))|L(?:k|u(?:ke?)?)))|S(?:a(?:n[\s\xa0]*Lucas|int[\s\xa0]*L(?:u(?:ke?)?|k))|t(?:\.[\s\xa0]*L(?:k|u(?:ke?)?)|[\s\xa0]*L(?:u(?:ke?)?|k)))|L(?:u(?:ukkaan|cas?|k(?:ka|a(?:sa?)?|e)?)?|k))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Jer"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		Yirmayah|(?:Sulat[\s\xa0]*ni[\s\xa0]*Jeremias|H[ei]r(?:[ei]m(?:[iy]as))|y(?:armiyako[\s\xa0]*pustak|irmaya)|Yer(?:em(?:yaah|ia))?|Aklat[\s\xa0]*ni[\s\xa0]*Jeremia[hs]|J(?:e(?:r(?:a(?:iah|m(?:a(?:ih|h)|i(?:ih|ah?|ha?)))|im(?:ah|i(?:[ai]h|h))|m[im]ah|e(?:m(?:eia|jas|a(?:i(?:ah|h)|h)|i(?:ih|ja|a(?:n[\s\xa0]*kirja|s(?:['’][\s\xa0]*Bog|[\s\xa0]*bok))?|e|ha?))?)?)?)?|r)|Ks(?:ieg[ai][\s\xa0]*Jeremiasza|\.[\s\xa0]*Jeremiasza|[\s\xa0]*Jeremiasza)|G(?:er(?:emia)?|r)|Li(?:ber[\s\xa0]*Ieremiae|v[\s\xa0]*Jeremi[\s\xa0]*an)|Ier(?:emias?)?|Eremiya)|(?:yarmiyako|Jeremi(?:a(?:[hn]|s(?:za)?))?)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["2Cor"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		2[\s\xa0]*Korinterbrevet|2\.[\s\xa0]*Korinterbrevet|(?:Wa(?:raka[\s\xa0]*wa[\s\xa0]*Pili[\s\xa0]*kwa[\s\xa0]*Wakorint(?:ho|o)|korintho[\s\xa0]*II)|D(?:e(?:uxieme(?:s[\s\xa0]*Corinthiens|[\s\xa0]*Corinthiens)|zyem[\s\xa0]*Kor(?:entyen|int))|ru(?:g(?:a[\s\xa0]*(?:list[\s\xa0]*do[\s\xa0]*Koryntian|Kor(?:incanima[\s\xa0]*Poslanica|ynt(?:ian|ow)))|i[\s\xa0]*(?:list[\s\xa0]*do[\s\xa0]*Koryntian|Korynt(?:ian|ow)))|h(?:e[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*korynfjan|a(?:[\s\xa0]*(?:kniha[\s\xa0]*Korint(?:anom|skym)|list[\s\xa0]*Korin(?:tskym|skym)|K(?:orint(?:anom|skym))?)|K)|y(?:[\s\xa0]*(?:list[\s\xa0]*Korin(?:t(?:anom|skym)|skym)|K(?:orint(?:anom|skym))?)|K))))|Barua[\s\xa0]*ya[\s\xa0]*Pili[\s\xa0]*kwa[\s\xa0]*Wakorintho|And(?:e(?:t[\s\xa0]*Korintherbrev|n[\s\xa0]*Kor(?:int(?:herbrev|erne))?)|r(?:a[\s\xa0]*Korint(?:h(?:ierbrevet|erbrevet)|ierbrevet|erbrevet)|e[\s\xa0]*(?:korinterbrev|Kor(?:int(?:ierne|er))?)))|S(?:ECOND[\s\xa0]*Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)|e(?:gund[ao][\s\xa0]*Corintios|cond(?:a[\s\xa0]*(?:lettera[\s\xa0]*ai[\s\xa0]*Corinzi|Corinzi)|o[\s\xa0]*Corinzi|[\s\xa0]*C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|t(?:i[ao]ns|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|ons|a(?:[ai]ns|n(?:[ao]s|s)?)|n(?:as|s)))?)?)?)|th(?:ians?)?)?)?))))|2(?:nd(?:\.[\s\xa0]*C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|t(?:i[ao]ns|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|ons|a(?:[ai]ns|n(?:[ao]s|s)?)|n(?:as|s)))?)?)?)|th(?:ians?)?)?)?)|[\s\xa0]*C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|t(?:i[ao]ns|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|ons|a(?:[ai]ns|n(?:[ao]s|s)?)|n(?:as|s)))?)?)?)|th(?:ians?)?)?)?))|\.(?:o(?:\.[\s\xa0]*Corintios|[\s\xa0]*Corintios)|[\s\xa0]*(?:Mga[\s\xa0]*Taga(?:[\s\xa0]*Corinto|-?(?:[\s\xa0]*Corinto|Corinto))|list[\s\xa0]*(?:do[\s\xa0]*Koryntian|Korin(?:tskym|skym))|Taga-?Corinto|korinterbrev|Wakorint(?:ho|o)|K(?:irje[\s\xa0]*korinttilaisille|urinthiayon|or(?:entyen|ynt(?:ian|ow)|i(?:tasve|n(?:canima[\s\xa0]*Poslanica|t(?:t(?:olaiskirje|ilaisille)|skym|er(?:ne)?|h(?:ier(?:brevet|s)?|us(?:iakhoz)?|e(?:r(?:brev(?:et)?)?)?)|i(?:er(?:brevet|ne|s)?|o)|usi?|a(?:nom|sve)?|os?)?)))?)|C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|zi|t(?:eni|i(?:ans|e(?:ni|rs?)|o(?:ns|s)?)|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|a(?:ans|i(?:ns|d)|n(?:[ao]s|s)?)|e(?:ns|rs?)|n(?:as|s)|o(?:ns|s))|e)?|o)?)?)|th(?:ians?)?)?)?)))|d(?:\.[\s\xa0]*Corinthiens|e(?:\.[\s\xa0]*Corinthiens|[\s\xa0]*Corinthiens)|[\s\xa0]*Corinthiens)|(?:[oa](?:\.[\s\xa0]*Corintios|[\s\xa0]*Corintios))|[KC]or|e(?:me(?:\.[\s\xa0]*Corinthiens|[\s\xa0]*Corinthiens)|\.[\s\xa0]*(?:Corint(?:iers?|h(?:ie(?:ns|rs?)|e))|Kor(?:int(?:iers?|h(?:iers?|e)))?)|[\s\xa0]*(?:Corint(?:iers?|h(?:ie(?:ns|rs?)|e))|Kor(?:int(?:iers?|h(?:iers?|e)))?))|[\s\xa0]*(?:C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|zi|i(?:th(?:i(?:ans|nas)|a(?:ins|ns)))?|t(?:eni|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|a(?:ans|i(?:ns|d)|n(?:[ao]s|s)?)|e(?:ns|rs?)|n(?:as|s)|o(?:ns|s))|e)?|i(?:ans|e(?:ni|rs?)|o(?:ns|s)?)?|o)?)?)|th(?:ians?)?)?)?)|(?:[ie](?:\.[\s\xa0]*Kori(?:ntasve|tasve)|[\s\xa0]*Kori(?:ntasve|tasve)))|list[\s\xa0]*(?:do[\s\xa0]*Koryntian|Korin(?:tskym|skym))|Taga-?Corinto|k(?:\.[\s\xa0]*Korint(?:anom|skym)|[\s\xa0]*Korint(?:anom|skym)|orinterbrev)|Wakorint(?:ho|o)|K(?:irje[\s\xa0]*korinttilaisille|urinthiayon|or(?:entyen|ynt(?:ian|ow)|i(?:tasve|n(?:canima[\s\xa0]*Poslanica|t(?:t(?:olaiskirje|ilaisille)|skym|er(?:ne)?|h(?:ier(?:brevet|s)?|us(?:iakhoz)?|e(?:r(?:brev(?:et)?)?)?)|i(?:yarukku|er(?:brevet|ne|s)?|o)|usi?|a(?:nom|sve)?|os?)?)))?)|Mga[\s\xa0]*Taga(?:[\s\xa0]*Corinto|-?(?:[\s\xa0]*Corinto|Corinto))))|I(?:ka(?:-?[\s\xa0]*2[\s\xa0]*Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)|[\s\xa0]*2[\s\xa0]*Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)|lawang[\s\xa0]*(?:Mga[\s\xa0]*Taga(?:-?[\s\xa0]*Corinto|[\s\xa0]*Corinto)|(?:[CK]orint(?:io|o))))|I(?:\.[\s\xa0]*(?:Mga[\s\xa0]*Taga(?:-?[\s\xa0]*Corinto|[\s\xa0]*Corinto)|list[\s\xa0]*(?:do[\s\xa0]*Koryntian|Korin(?:tskym|skym))|Wakorint(?:ho|o)|K(?:irje[\s\xa0]*korinttilaisille|or(?:entyen|ynt(?:ian|ow)|in(?:canima[\s\xa0]*Poslanica|t(?:t(?:olaiskirje|ilaisille)|skym|h(?:iers?|us(?:iakhoz)?|e)|i(?:ers?|o)|usi?|a(?:nom)?|os?)?))?)|C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|zi|t(?:eni|i(?:ans|e(?:ni|rs?)|o(?:ns|s)?)|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|a(?:ans|i(?:ns|d)|n(?:[ao]s|s)?)|e(?:ns|rs?)|n(?:as|s)|o(?:ns|s))|e)?|o)?)?)|th(?:ians?)?)?)?))|[\s\xa0]*(?:Mga[\s\xa0]*Taga(?:-?[\s\xa0]*Corinto|[\s\xa0]*Corinto)|list[\s\xa0]*(?:do[\s\xa0]*Koryntian|Korin(?:tskym|skym))|Wakorint(?:ho|o)|K(?:irje[\s\xa0]*korinttilaisille|or(?:entyen|ynt(?:ian|ow)|in(?:canima[\s\xa0]*Poslanica|t(?:t(?:olaiskirje|ilaisille)|skym|h(?:iers?|us(?:iakhoz)?|e)|i(?:ers?|o)|usi?|a(?:nom)?|os?)?))?)|C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|zi|t(?:eni|i(?:ans|e(?:ni|rs?)|o(?:ns|s)?)|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|a(?:ans|i(?:ns|d)|n(?:[ao]s|s)?)|e(?:ns|rs?)|n(?:as|s)|o(?:ns|s))|e)?|o)?)?)|th(?:ians?)?)?)?))))|P(?:a(?:vlova[\s\xa0]*druga[\s\xa0]*poslanica[\s\xa0]*Korincanima|ulus(?:'[\s\xa0]*Andet[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Korintherne|’[\s\xa0]*(?:Andet[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Korintherne|andre[\s\xa0]*brev[\s\xa0]*til[\s\xa0]*korinterne)))|ili[\s\xa0]*(?:Wakorint(?:ho|o)|Kor))|Zweite[\s\xa0]*Korinther|Korint(?:iyarukku[\s\xa0]*Elutiya[\s\xa0]*Irantavatu[\s\xa0]*Nirupam|os[\s\xa0]*Labaad)|Epistula[\s\xa0]*(?:II[\s\xa0]*ad[\s\xa0]*Corinthios|ad[\s\xa0]*Corinthios[\s\xa0]*II)|T(?:oinen[\s\xa0]*K(?:irje[\s\xa0]*korinttilaisille|orintt(?:olaiskirje|ilaisille))|weede[\s\xa0]*(?:Corint(?:iers?|h(?:iers?|e))|Kor(?:int(?:iers?|h(?:iers?|e)))?))|Masodik[\s\xa0]*Kor(?:int(?:hus(?:iakhoz)?|usi))?)|(?:Druga[\s\xa0]*(?:poslanica[\s\xa0]*Korincanima|Korincanima)|ad[\s\xa0]*Corinthios[\s\xa0]*II|II(?:\.[\s\xa0]*Korincanima|[\s\xa0]*Korincanima)|2(?:\.[\s\xa0]*Korincanima|[\s\xa0]*Korincanima)|Corinthios[\s\xa0]*II)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["1Cor"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		1[\s\xa0]*Korinterbrevet|1\.[\s\xa0]*Korinterbrevet|(?:E(?:nsimmainen[\s\xa0]*K(?:irje[\s\xa0]*korinttilaisille|orintt(?:olaiskirje|ilaisille))|pistula[\s\xa0]*(?:I[\s\xa0]*ad[\s\xa0]*Corinthios|ad[\s\xa0]*Corinthios[\s\xa0]*I)|rste[\s\xa0]*Korinther|erste[\s\xa0]*(?:Corint(?:iers?|h(?:iers?|e))|Kor(?:int(?:iers?|h(?:iers?|e)))?)|lso[\s\xa0]*Kor(?:int(?:hus(?:iakhoz)?|usi))?)|F(?:orsta[\s\xa0]*Korint(?:h(?:ierbrevet|erbrevet)|ierbrevet|erbrevet)|yrra[\s\xa0]*(?:bref[\s\xa0]*Pals[\s\xa0]*til[\s\xa0]*Korin(?:tumanna)?|Korintubref)|irst[\s\xa0]*C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|t(?:i[ao]ns|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|ons|a(?:[ai]ns|n(?:[ao]s|s)?)|n(?:as|s)))?)?)?)|th(?:ians?)?)?)?))|K(?:orint(?:iyarukku[\s\xa0]*Elutiya[\s\xa0]*Mutalavatu[\s\xa0]*Nirupam|os[\s\xa0]*Kowaad)|wanza[\s\xa0]*(?:Wakorint(?:ho|o)|Kor))|I(?:ka(?:-?[\s\xa0]*1[\s\xa0]*Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)|[\s\xa0]*1[\s\xa0]*Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o))|\.[\s\xa0]*(?:Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)|Mga[\s\xa0]*Taga(?:-?[\s\xa0]*Corinto|[\s\xa0]*Corinto)|list[\s\xa0]*(?:do[\s\xa0]*Koryntian|Korin(?:tskym|skym))|Wakorint(?:ho|o)|K(?:irje[\s\xa0]*korinttilaisille|or(?:entyen|ynt(?:ian|ow)|in(?:canima[\s\xa0]*Poslanica|t(?:t(?:olaiskirje|ilaisille)|skym|h(?:iers?|us(?:iakhoz)?|e)|i(?:ers?|o)|usi?|a(?:nom)?|os?)?))?)|C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|zi|t(?:eni|i(?:ans|e(?:ni|rs?)|o(?:ns|s)?)|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|a(?:ans|i(?:ns|d)|n(?:[ao]s|s)?)|e(?:ns|rs?)|n(?:as|s)|o(?:ns|s))|e)?|o)?)?)|th(?:ians?)?)?)?))|[\s\xa0]*(?:Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)|Mga[\s\xa0]*Taga(?:-?[\s\xa0]*Corinto|[\s\xa0]*Corinto)|list[\s\xa0]*(?:do[\s\xa0]*Koryntian|Korin(?:tskym|skym))|Wakorint(?:ho|o)|K(?:irje[\s\xa0]*korinttilaisille|or(?:entyen|ynt(?:ian|ow)|in(?:canima[\s\xa0]*Poslanica|t(?:t(?:olaiskirje|ilaisille)|skym|h(?:iers?|us(?:iakhoz)?|e)|i(?:ers?|o)|usi?|a(?:nom)?|os?)?))?)|C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|zi|t(?:eni|i(?:ans|e(?:ni|rs?)|o(?:ns|s)?)|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|a(?:ans|i(?:ns|d)|n(?:[ao]s|s)?)|e(?:ns|rs?)|n(?:as|s)|o(?:ns|s))|e)?|o)?)?)|th(?:ians?)?)?)?)))|P(?:erse[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*korynfjan|a(?:vlova[\s\xa0]*prva[\s\xa0]*poslanica[\s\xa0]*Korincanima|ulus(?:['’][\s\xa0]*1(?:\.[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Korintherne|[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Korintherne)))|ierwsz(?:[aey][\s\xa0]*(?:list[\s\xa0]*do[\s\xa0]*Koryntian|Korynt(?:ian|ow)))|r(?:em(?:ier(?:e(?:s[\s\xa0]*Corinthiens|[\s\xa0]*Corinthiens)|s[\s\xa0]*Corinthiens|[\s\xa0]*Corinthiens)|ye[\s\xa0]*Kor(?:entyen|int))|im(?:e(?:ir[ao][\s\xa0]*Corintios|r(?:o[\s\xa0]*Corintios|[\s\xa0]*Corintios))|a[\s\xa0]*(?:lettera[\s\xa0]*ai[\s\xa0]*Corinzi|Corinzi)|o[\s\xa0]*Corinzi)|v(?:a[\s\xa0]*(?:kniha[\s\xa0]*Korint(?:anom|skym)|Korin(?:canima[\s\xa0]*Poslanica|t(?:anom|skym)))|y[\s\xa0]*(?:list[\s\xa0]*Korint(?:anom|skym)|Korint(?:anom|skym))|ni(?:[\s\xa0]*(?:list[\s\xa0]*Korin(?:tskym|skym)|K(?:or(?:intskym)?)?)|K))))|1(?:re(?:\.[\s\xa0]*Corinthiens|[\s\xa0]*Corinthiens)|(?:[ao](?:\.[\s\xa0]*Corintios|[\s\xa0]*Corintios))|e(?:r(?:\.[\s\xa0]*Corinthiens|e(?:\.[\s\xa0]*Corinthiens|[\s\xa0]*Corinthiens)|[\s\xa0]*Corinthiens)|\.[\s\xa0]*(?:Corint(?:iers?|h(?:iers?|e))|Kor(?:int(?:iers?|h(?:iers?|e)))?)|[\s\xa0]*(?:Corint(?:iers?|h(?:iers?|e))|Kor(?:int(?:iers?|h(?:iers?|e)))?))|st(?:\.[\s\xa0]*C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|t(?:i[ao]ns|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|ons|a(?:[ai]ns|n(?:[ao]s|s)?)|n(?:as|s)))?)?)?)|th(?:ians?)?)?)?)|[\s\xa0]*C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|t(?:i[ao]ns|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|ons|a(?:[ai]ns|n(?:[ao]s|s)?)|n(?:as|s)))?)?)?)|th(?:ians?)?)?)?))|\.(?:o(?:\.[\s\xa0]*Corintios|[\s\xa0]*Corintios)|[\s\xa0]*(?:Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)|Mga[\s\xa0]*Taga(?:[\s\xa0]*Corinto|-?(?:[\s\xa0]*Corinto|Corinto))|list[\s\xa0]*(?:do[\s\xa0]*Koryntian|Korin(?:tskym|skym))|Taga-?Corinto|korinterbrev|Wakorint(?:ho|o)|K(?:irje[\s\xa0]*korinttilaisille|urinthiayon|or(?:entyen|ynt(?:ian|ow)|i(?:tasve|n(?:canima[\s\xa0]*Poslanica|t(?:t(?:olaiskirje|ilaisille)|skym|er(?:ne)?|h(?:ier(?:brevet|s)?|us(?:iakhoz)?|e(?:r(?:brev(?:et)?)?)?)|i(?:er(?:brevet|ne|s)?|o)|usi?|a(?:nom|sve)?|os?)?)))?)|C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|zi|t(?:eni|i(?:ans|e(?:ni|rs?)|o(?:ns|s)?)|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|a(?:ans|i(?:ns|d)|n(?:[ao]s|s)?)|e(?:ns|rs?)|n(?:as|s)|o(?:ns|s))|e)?|o)?)?)|th(?:ians?)?)?)?)))|[\s\xa0]*(?:C(?:hor(?:anthians|i(?:nth(?:ains|i(?:ans|ns))|thians)|nthians)|o(?:r(?:anthians|ri(?:nth(?:ains|ians)|th(?:ains|ians))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns)))|i(?:inthi(?:ians|ans)|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns))|n(?:[an]thians|zi|i(?:th(?:i(?:ans|nas)|a(?:ins|ns)))?|t(?:eni|h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|a(?:ans|i(?:ns|d)|n(?:[ao]s|s)?)|e(?:ns|rs?)|n(?:as|s)|o(?:ns|s))|e)?|i(?:ans|e(?:ni|rs?)|o(?:ns|s)?)?|o)?)?)|th(?:ians?)?)?)?)|(?:[ie](?:\.[\s\xa0]*Kori(?:ntasve|tasve)|[\s\xa0]*Kori(?:ntasve|tasve)))|list[\s\xa0]*(?:do[\s\xa0]*Koryntian|Korin(?:tskym|skym))|Taga-?Corinto|k(?:\.[\s\xa0]*Korint(?:anom|skym)|[\s\xa0]*Korint(?:anom|skym)|orinterbrev)|Wakorint(?:ho|o)|K(?:irje[\s\xa0]*korinttilaisille|urinthiayon|or(?:entyen|ynt(?:ian|ow)|i(?:tasve|n(?:canima[\s\xa0]*Poslanica|t(?:t(?:olaiskirje|ilaisille)|skym|er(?:ne)?|h(?:ier(?:brevet|s)?|us(?:iakhoz)?|e(?:r(?:brev(?:et)?)?)?)|i(?:yarukku|er(?:brevet|ne|s)?|o)|usi?|a(?:nom|sve)?|os?)?)))?)|Mga[\s\xa0]*Taga(?:[\s\xa0]*Corinto|-?(?:[\s\xa0]*Corinto|Corinto)))|Cor)|Una(?:ng[\s\xa0]*(?:Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)|Mga[\s\xa0]*Taga(?:-?[\s\xa0]*Corinto|[\s\xa0]*Corinto)|(?:[CK]orint(?:io|o)))|[\s\xa0]*(?:Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)|Mga[\s\xa0]*Taga(?:-?[\s\xa0]*Corinto|[\s\xa0]*Corinto)|(?:[CK]orint(?:io|o))))|Wa(?:raka[\s\xa0]*wa[\s\xa0]*Kwanza[\s\xa0]*kwa[\s\xa0]*Wakorint(?:ho|o)|korintho[\s\xa0]*I)|Barua[\s\xa0]*ya[\s\xa0]*Kwanza[\s\xa0]*kwa[\s\xa0]*Wakorintho)|(?:Prva[\s\xa0]*(?:poslanica[\s\xa0]*Korincanima|Korincanima)|ad[\s\xa0]*Corinthios[\s\xa0]*I|1(?:\.[\s\xa0]*Korincanima|[\s\xa0]*(?:Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*Corint(?:io|o)|Korincanima))|I(?:\.[\s\xa0]*Korincanima|[\s\xa0]*Korincanima)|C(?:hor(?:anthians|nthians|i(?:thians|nth(?:ains|i(?:ans|ns))))|or(?:ri(?:nth(?:ians|ains)|th(?:ains|ians))|i(?:inthi(?:ians|ans)|n(?:[na]thians|ith(?:i(?:ans|nas)|a(?:ins|ns))|t(?:h(?:o(?:ians|ans)|a(?:i(?:ans|ns)|ns)|i(?:ians|o(?:s[\s\xa0]*I|ns)|n(?:as|s)|a(?:[ai]ns|n(?:[ao]s|s)?)))|i[oa]ns))|th(?:oans|a(?:ins|ns)|i(?:ians|ans|ns)))|n(?:i(?:nth(?:ians|a(?:ins|ns))|th(?:ians|a(?:i(?:ans|ns)|ns)))|th(?:ains|i(?:ians|ans|ns))))))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Gal"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		galati(?:harulai[\s\xa0]*patra|karams[\s\xa0]*patra)|(?:P(?:oslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*halativ|a(?:vlova[\s\xa0]*poslanica[\s\xa0]*Galacanima|ulus['’][\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Galaterne))|K(?:alattiyarukku[\s\xa0]*Elutiya[\s\xa0]*Nirupam|irje[\s\xa0]*galatalaisille)|Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*(?:taga[\s\xa0]*Galacia|Galacia)|B(?:re(?:f[\s\xa0]*Pals[\s\xa0]*til[\s\xa0]*Galatamanna|vet[\s\xa0]*til[\s\xa0]*Galaterne)|arua[\s\xa0]*kwa[\s\xa0]*Wagalatia)|Epistula[\s\xa0]*ad[\s\xa0]*Galatas|Mga[\s\xa0]*Taga(?:[\s\xa0]*Galasya|-?(?:[\s\xa0]*Gala(?:cia|sya)|Galacia))|L(?:ayang[\s\xa0]*Paulus[\s\xa0]*Galatia|ettera[\s\xa0]*ai[\s\xa0]*Galati|ist[\s\xa0]*(?:do[\s\xa0]*Gala(?:cjan|tow)|Galat(?:anom|skym)))|G(?:a(?:-?la-?ti|l(?:lati(?:[ao]ns|ns)|a(?:s(?:y(?:ano|en)|ia?)|t(?:i(?:i(?:[ao]ns|ns)|a(?:ans|i(?:ns|d)|n(?:[ai]s|s)?|s)|n(?:a(?:ns|s)|s)|o(?:ans|n(?:[an]s|s)|s)|y(?:on|a))|o(?:ans|ns)|e(?:n(?:brief|i)?|r(?:bre(?:fvet|vet))?|s)|ns|a(?:laiskirj|khoz|[ao]ns|i(?:[ao]ns|ns)|sve|ns)?)?)?)?)|l))|(?:P(?:aulus’[\s\xa0]*brev[\s\xa0]*til[\s\xa0]*galaterne|oslanica[\s\xa0]*Galacanima)|Mga[\s\xa0]*Taga[\s\xa0]*Galacia|Kalattiyarukku|galati(?:harulai|karams)|Taga(?:[\s\xa0]*Galacia|-?(?:[\s\xa0]*Galacia|Galacia))|ad[\s\xa0]*Galatas|Wagalatia|Ga(?:la(?:c(?:anima|jan|ia)|t(?:erne|skym|ow|a(?:laisille|nom|s)|ia?)))?)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Eph"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:E(?:sphesians|hp(?:[ei]sians)?|f(?:e(?:s(?:i(?:erbrevet|aneve|os)|kym|o(?:laiskirje|s)|e(?:rbrevet|ni)?)?|z(?:iers|yen|ow|us(?:iakhoz)?)?)?|f(?:esiaid)?)?|p(?:istula[\s\xa0]*ad[\s\xa0]*Ephesios|e(?:ciyarukku[\s\xa0]*Elutiya[\s\xa0]*Nirupam|hesians|sians)|h(?:isians?|e(?:s(?:zosziakhoz|ains?|i(?:[eo]ns|a(?:id|n[ds]?))|er)?)?|s(?:ians?)?)?)?)|L(?:ayang[\s\xa0]*Paulus[\s\xa0]*Efesus|ettera[\s\xa0]*agli[\s\xa0]*Efesini|ist[\s\xa0]*(?:do[\s\xa0]*Efezjan|Efez(?:an[ou]m|skym)))|Mga[\s\xa0]*Taga(?:[\s\xa0]*E(?:[fp]es(?:io|o))|-?(?:[\s\xa0]*E(?:[fp]es(?:io|o))|Efeso))|B(?:ref[\s\xa0]*Pals[\s\xa0]*til[\s\xa0]*Efesusmanna|arua[\s\xa0]*kwa[\s\xa0]*Waefeso)|Kirje[\s\xa0]*efesolaisille|Waraka[\s\xa0]*kwa[\s\xa0]*Waefeso|Iafisiyon|P(?:oslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*efesjan|a(?:vlova[\s\xa0]*poslanica[\s\xa0]*Efezanima|ulus['’][\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Efeserne))|Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*E(?:[fp]es(?:io|o)))|(?:P(?:aulus’[\s\xa0]*brev[\s\xa0]*til[\s\xa0]*efeserne|oslanica[\s\xa0]*Efezanima)|ad[\s\xa0]*Ephesios|Taga(?:-?(?:[\s\xa0]*E(?:[fp]es(?:io|o))|Efeso)|[\s\xa0]*E(?:[fp]es(?:io|o)))|Mga[\s\xa0]*E(?:[fp]es(?:io|o))|Waefeso|E(?:p(?:eciyarukku|hesios)|fe(?:z(?:an(?:ima|om)|skym|jan)|s(?:erne|ini|us|o(?:laisille)?))))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Col"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:kalass(?:aikarams[\s\xa0]*patra|iharulai[\s\xa0]*patra)|K(?:irje[\s\xa0]*kolossalaisille|ulussaiyon|o(?:l(?:o(?:ceyarukku[\s\xa0]*Elutiya[\s\xa0]*Nirupam|s(?:ianeve|ens(?:kym|ow)|yen|ay|s(?:alaiskirje|ze(?:beliekhez|ieknek)|e(?:iakhoz|n(?:s(?:er(?:brevet|n)|kym)|zen)|r(?:brevet)?)?))?))?)?)|P(?:oslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*kolosjan|a(?:vlova[\s\xa0]*poslanica[\s\xa0]*Kolosanima|ulus(?:'[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Kolossenserne|’[\s\xa0]*(?:Brev[\s\xa0]*til[\s\xa0]*Kolossenserne|brev[\s\xa0]*til[\s\xa0]*kolosserne))))|Mga[\s\xa0]*Taga(?:[\s\xa0]*[CK]olosas|-?(?:[\s\xa0]*[CK]olosas|Colosas))|Waraka[\s\xa0]*kwa[\s\xa0]*Wakolosai|C(?:al(?:l(?:asi[ao]ns|os(?:sians|i[ao]ns))|[ao]s(?:si(?:[ao]ns|i[ao]ns)))|l|o(?:l(?:l[ao]si(?:[ao]ns)|as(?:si[ao]ns|i[ao]ns)|os(?:i(?:a(?:id|ns)|ons)|en(?:ses|i)|s(?:enzen|ans|i(?:[eo]ns|a(?:id|ns?)))?)?)?)?)|B(?:ref[\s\xa0]*Pals[\s\xa0]*til[\s\xa0]*Kolossumanna?|arua[\s\xa0]*kwa[\s\xa0]*Wakolosai)|Epistula[\s\xa0]*ad[\s\xa0]*Colossenses|L(?:ayang[\s\xa0]*Paulus[\s\xa0]*Kolose|ettera[\s\xa0]*ai[\s\xa0]*Colossesi|ist[\s\xa0]*(?:do[\s\xa0]*Kolosan|Kolos(?:an[ou]m|kym)))|Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*(?:[CK]olo(?:nsense|sense)))|Cal[ao]si(?:[ao]ns)|(?:Poslanica[\s\xa0]*Kolosanima|ad[\s\xa0]*Colossenses|kalass(?:iharulai|aikarams)|Mga[\s\xa0]*(?:[KC]olo(?:nsense|sense))|Taga(?:-?(?:[\s\xa0]*Colosas|Colosas)|[\s\xa0]*Colosas)|Wakolosai|Colos(?:se(?:nses|si)|as)|Kolo(?:ceyarukku|s(?:s(?:alaisille|e(?:nserne|rne))|kym|an(?:ima|[uo]m)?|e)))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["2Tim"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:I(?:kalawang[\s\xa0]*(?:Kay[\s\xa0]*Timoteo|Timoteo)|I(?:\.[\s\xa0]*(?:List[\s\xa0]*do[\s\xa0]*Tymoteusza|list[\s\xa0]*Tim[eo]teovi|K(?:irje[\s\xa0]*Timoteukselle|ay[\s\xa0]*Timoteo)|T(?:ymoteusza|himot(?:hy|y)|omothy|i(?:m(?:ot(?:ius|e(?:j(?:u[\s\xa0]*Poslanica|ovi)|yos|u(?:kselle|s(?:kirje|hoz|nak)?)|i|o(?:vi)?)?|h(?:e(?:u[ms]|e|o(?:sz)?)|y)?|y))?)?|m))|[\s\xa0]*(?:List[\s\xa0]*do[\s\xa0]*Tymoteusza|list[\s\xa0]*Tim[eo]teovi|K(?:irje[\s\xa0]*Timoteukselle|ay[\s\xa0]*Timoteo)|T(?:ymoteusza|himot(?:hy|y)|omothy|i(?:m(?:ot(?:ius|e(?:j(?:u[\s\xa0]*Poslanica|ovi)|yos|u(?:kselle|s(?:kirje|hoz|nak)?)|i|o(?:vi)?)?|h(?:e(?:u[ms]|e|o(?:sz)?)|y)?|y))?)?|m))))|2(?:d(?:\.[\s\xa0]*Timothee|e(?:\.[\s\xa0]*Timothee|[\s\xa0]*Timothee)|[\s\xa0]*Timothee)|(?:[ao](?:\.[\s\xa0]*Timoteo|[\s\xa0]*Timoteo))|e(?:me(?:\.[\s\xa0]*Timothee|[\s\xa0]*Timothee)|\.[\s\xa0]*Tim(?:ot(?:eus|he(?:us|e)))?|[\s\xa0]*Tim(?:ot(?:eus|he(?:us|e)))?)|nd(?:\.[\s\xa0]*T(?:himot(?:hy|y)|omothy|i(?:m(?:ot(?:hy?|y))?)?|m)|[\s\xa0]*T(?:himot(?:hy|y)|omothy|i(?:m(?:ot(?:hy?|y))?)?|m))|\.(?:o(?:\.[\s\xa0]*Timoteo|[\s\xa0]*Timoteo)|[\s\xa0]*(?:List[\s\xa0]*do[\s\xa0]*Tymoteusza|list[\s\xa0]*Tim[eo]teovi|K(?:irje[\s\xa0]*Timoteukselle|a(?:ng[\s\xa0]*Timoteo|y[\s\xa0]*Timoteo))|T(?:eemuathaiyus|ymoteusza|himot(?:hy|y)|omothy|i(?:m(?:ot(?:ius|e(?:j(?:u[\s\xa0]*Poslanica|ovi)|yos|u(?:kselle|s(?:kirje|brev(?:et)?|hoz|nak)?|t)|i|o(?:vi)?)?|h(?:e(?:u(?:m|s(?:brev)?)|e|o(?:s(?:brevet|z))?)|y)?|y))?)?|m)))|[\s\xa0]*(?:List[\s\xa0]*do[\s\xa0]*Tymoteusza|list[\s\xa0]*Tim[eo]teovi|K(?:irje[\s\xa0]*Timoteukselle|a(?:ng[\s\xa0]*Timoteo|y[\s\xa0]*Timoteo))|k(?:\.[\s\xa0]*Timote(?:jovi|ovi)|[\s\xa0]*Timote(?:jovi|ovi))|(?:[ei](?:\.[\s\xa0]*Timoteut|[\s\xa0]*Timoteut))|T(?:eemuathaiyus|himot(?:hy|y)|omothy|ym(?:oteusza)?|i(?:m(?:ot(?:teyuvukku|ius|e(?:j(?:u[\s\xa0]*Poslanica|ovi)|yos|u(?:kselle|s(?:kirje|brev(?:et)?|hoz|nak)?|t)|i|o(?:vi)?)?|h(?:e(?:u(?:m|s(?:brev)?)|e|o(?:s(?:brevet|z))?)|y)?|y))?)?|m))|Tim)|T(?:oinen[\s\xa0]*(?:Kirje[\s\xa0]*Timoteukselle|Timoteu(?:kselle|skirje))|imot(?:teyuvukku[\s\xa0]*Elutiya[\s\xa0]*Irantavatu[\s\xa0]*Nirupam|eyos[\s\xa0]*Labaad|heo[\s\xa0]*II)|weede[\s\xa0]*Tim(?:ot(?:heus|eus))?)|P(?:a(?:vlova[\s\xa0]*druga[\s\xa0]*poslanica[\s\xa0]*Timoteju|ulus(?:'[\s\xa0]*Andet[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Timotheus|’[\s\xa0]*(?:Andet[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Timotheus|andre[\s\xa0]*brev[\s\xa0]*til[\s\xa0]*Timoteus)))|ili[\s\xa0]*Tim(?:otheo)?)|Masodik[\s\xa0]*Tim(?:ot(?:heosz|eus(?:hoz|nak)?))?|Zweite[\s\xa0]*Timotheus|Epistula[\s\xa0]*(?:II[\s\xa0]*ad[\s\xa0]*Timotheum|ad[\s\xa0]*Timotheum[\s\xa0]*II)|D(?:e(?:uxieme(?:s[\s\xa0]*Timothee|[\s\xa0]*Timothee)|zyem[\s\xa0]*Timote)|ru(?:g(?:a[\s\xa0]*(?:List[\s\xa0]*do[\s\xa0]*Tymoteusza|T(?:imoteju[\s\xa0]*Poslanica|ymoteusza))|i[\s\xa0]*(?:List[\s\xa0]*do[\s\xa0]*Tymoteusza|Tymoteusza))|h(?:e[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*Tymofija|a[\s\xa0]*(?:kniha[\s\xa0]*Timote(?:jovi|ovi)|list[\s\xa0]*Tim[eo]teovi|T(?:im(?:ote(?:jovi|ovi|us))?|m))|y[\s\xa0]*(?:list[\s\xa0]*Tim(?:eteovi|ote(?:jovi|ovi))|T(?:im(?:ote(?:jovi|ovi|us))?|m)))))|Se(?:gund[ao][\s\xa0]*Timoteo|cond(?:a[\s\xa0]*(?:lettera[\s\xa0]*a[\s\xa0]*Timoteo|Timoteo)|o[\s\xa0]*Timoteo|[\s\xa0]*T(?:himot(?:hy|y)|omothy|i(?:m(?:ot(?:hy?|y))?)?|m)))|Barua[\s\xa0]*ya[\s\xa0]*Pili[\s\xa0]*kwa[\s\xa0]*Timotheo|Waraka[\s\xa0]*wa[\s\xa0]*Pili[\s\xa0]*kwa[\s\xa0]*Timotheo|And(?:e(?:t[\s\xa0]*Timotheusbrev|n[\s\xa0]*Tim(?:ot(?:heusbrev|eus))?)|r(?:a[\s\xa0]*Timot(?:heosbrevet|eusbrevet)|e[\s\xa0]*Tim(?:oteus(?:brev)?)?)))|(?:ad[\s\xa0]*Timotheum[\s\xa0]*II|Druga[\s\xa0]*(?:poslanica[\s\xa0]*Timoteju|Timoteju)|Timotheum[\s\xa0]*II|II(?:\.[\s\xa0]*Timoteju|[\s\xa0]*Timoteju)|2(?:\.[\s\xa0]*Timoteju|[\s\xa0]*Timoteju))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["1Tim"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:E(?:nsimmainen[\s\xa0]*(?:Kirje[\s\xa0]*Timoteukselle|Timoteu(?:kselle|skirje))|pistula[\s\xa0]*(?:I[\s\xa0]*ad[\s\xa0]*Timotheum|ad[\s\xa0]*Timotheum[\s\xa0]*I)|rste[\s\xa0]*Timotheus|erste[\s\xa0]*Tim(?:ot(?:heus|eus))?|lso[\s\xa0]*Tim(?:ot(?:heosz|eus(?:hoz|nak)?))?)|Kwanza[\s\xa0]*Tim(?:otheo)?|P(?:erse[\s\xa0]*poslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*Tymofija|a(?:vlova[\s\xa0]*prva[\s\xa0]*poslanica[\s\xa0]*Timoteju|ulus(?:['’][\s\xa0]*1(?:\.[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Timotheus|[\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Timotheus)))|ierwsz(?:[aey][\s\xa0]*(?:List[\s\xa0]*do[\s\xa0]*Tymoteusza|Tym(?:oteusza)?))|r(?:em(?:ier(?:e(?:s[\s\xa0]*Timothee|[\s\xa0]*Timothee)|s[\s\xa0]*Timothee|[\s\xa0]*Timothee)|ye[\s\xa0]*Timote)|im(?:e(?:ir[ao][\s\xa0]*Timoteo|r(?:o[\s\xa0]*Timoteo|[\s\xa0]*Timoteo))|a[\s\xa0]*(?:lettera[\s\xa0]*a[\s\xa0]*Timoteo|Timoteo)|o[\s\xa0]*Timoteo)|v(?:a[\s\xa0]*(?:kniha[\s\xa0]*Timote(?:jovi|ovi)|Timote(?:j(?:u[\s\xa0]*Poslanica|ovi)|ovi))|y[\s\xa0]*(?:list[\s\xa0]*Timote(?:jovi|ovi)|Timote(?:jovi|ovi))|ni[\s\xa0]*(?:list[\s\xa0]*Tim[eo]teovi|T(?:im(?:ote(?:ovi|us))?|m)))))|1(?:re(?:\.[\s\xa0]*Timothee|[\s\xa0]*Timothee)|(?:[ao](?:\.[\s\xa0]*Timoteo|[\s\xa0]*Timoteo))|e(?:r(?:\.[\s\xa0]*Timothee|e(?:\.[\s\xa0]*Timothee|[\s\xa0]*Timothee)|[\s\xa0]*Timothee)|\.[\s\xa0]*Tim(?:ot(?:heus|eus))?|[\s\xa0]*Tim(?:ot(?:heus|eus))?)|st(?:\.[\s\xa0]*T(?:himot(?:hy|y)|omothy|i(?:m(?:ot(?:hy?|y))?)?|m)|[\s\xa0]*T(?:himot(?:hy|y)|omothy|i(?:m(?:ot(?:hy?|y))?)?|m))|\.(?:o(?:\.[\s\xa0]*Timoteo|[\s\xa0]*Timoteo)|[\s\xa0]*(?:List[\s\xa0]*do[\s\xa0]*Tymoteusza|list[\s\xa0]*Tim[eo]teovi|K(?:irje[\s\xa0]*Timoteukselle|a(?:ng[\s\xa0]*Timoteo|y[\s\xa0]*Timoteo))|T(?:eemuathaiyus|himot(?:hy|y)|omothy|ym(?:oteusza)?|i(?:m(?:ot(?:ius|e(?:j(?:u[\s\xa0]*Poslanica|ovi)|yos|u(?:kselle|s(?:kirje|brev(?:et)?|hoz|nak)?|t)|i|o(?:vi)?)?|h(?:e(?:u(?:m|s(?:brev)?)|e|o(?:s(?:brevet|z))?)|y)?|y))?)?|m)))|[\s\xa0]*(?:List[\s\xa0]*do[\s\xa0]*Tymoteusza|list[\s\xa0]*Tim[eo]teovi|K(?:irje[\s\xa0]*Timoteukselle|a(?:ng[\s\xa0]*Timoteo|y[\s\xa0]*Timoteo))|k(?:\.[\s\xa0]*Timote(?:jovi|ovi)|[\s\xa0]*Timote(?:jovi|ovi))|(?:[ei](?:\.[\s\xa0]*Timoteut|[\s\xa0]*Timoteut))|T(?:eemuathaiyus|himot(?:hy|y)|omothy|ym(?:oteusza)?|i(?:m(?:ot(?:teyuvukku|ius|e(?:j(?:u[\s\xa0]*Poslanica|ovi)|yos|u(?:kselle|s(?:kirje|brev(?:et)?|hoz|nak)?|t)|i|o(?:vi)?)?|h(?:e(?:u(?:m|s(?:brev)?)|e|o(?:s(?:brevet|z))?)|y)?|y))?)?|m))|Tim)|Timot(?:teyuvukku[\s\xa0]*Elutiya[\s\xa0]*Mutalavatu[\s\xa0]*Nirupam|eyos[\s\xa0]*Kowaad|heo[\s\xa0]*I)|Una(?:ng[\s\xa0]*(?:Kay[\s\xa0]*Timoteo|Timoteo)|[\s\xa0]*(?:Kay[\s\xa0]*Timoteo|Timoteo))|Barua[\s\xa0]*ya[\s\xa0]*Kwanza[\s\xa0]*kwa[\s\xa0]*Timotheo|Waraka[\s\xa0]*wa[\s\xa0]*Kwanza[\s\xa0]*kwa[\s\xa0]*Timotheo|I(?:\.[\s\xa0]*(?:List[\s\xa0]*do[\s\xa0]*Tymoteusza|list[\s\xa0]*Tim[eo]teovi|K(?:irje[\s\xa0]*Timoteukselle|ay[\s\xa0]*Timoteo)|T(?:himot(?:hy|y)|omothy|ym(?:oteusza)?|i(?:m(?:ot(?:ius|e(?:j(?:u[\s\xa0]*Poslanica|ovi)|yos|u(?:kselle|s(?:kirje|hoz|nak)?)|i|o(?:vi)?)?|h(?:e(?:u[ms]|e|o(?:sz)?)|y)?|y))?)?|m))|[\s\xa0]*(?:List[\s\xa0]*do[\s\xa0]*Tymoteusza|list[\s\xa0]*Tim[eo]teovi|K(?:irje[\s\xa0]*Timoteukselle|ay[\s\xa0]*Timoteo)|T(?:himot(?:hy|y)|omothy|ym(?:oteusza)?|i(?:m(?:ot(?:ius|e(?:j(?:u[\s\xa0]*Poslanica|ovi)|yos|u(?:kselle|s(?:kirje|hoz|nak)?)|i|o(?:vi)?)?|h(?:e(?:u[ms]|e|o(?:sz)?)|y)?|y))?)?|m)))|F(?:orsta[\s\xa0]*Timot(?:heosbrevet|eusbrevet)|yrra[\s\xa0]*(?:bref[\s\xa0]*Pals[\s\xa0]*til[\s\xa0]*Timot(?:eusar)?|Timoteusarbref)|irst[\s\xa0]*T(?:himot(?:hy|y)|omothy|i(?:m(?:ot(?:hy?|y))?)?|m)))|(?:ad[\s\xa0]*Timotheum[\s\xa0]*I|Prva[\s\xa0]*(?:poslanica[\s\xa0]*Timoteju|Timoteju)|(?:[1I](?:\.[\s\xa0]*Timoteju|[\s\xa0]*Timoteju))|Timoth(?:eum[\s\xa0]*I|y)?)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Deut"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:F(?:immta[\s\xa0]*(?:bok[\s\xa0]*Mose|Mosebok)|unfte[\s\xa0]*(?:Buch[\s\xa0]*Mose|Mose)|emte[\s\xa0]*Mos(?:ebo(?:g|k(?:en)?))?)|anuwad|P(?:o(?:vtorennja[\s\xa0]*Zakonu|novljeni[\s\xa0]*zakon)|a(?:ngandharing[\s\xa0]*Toret|ta[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Mojzisova))|iata[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|Mojz(?:eszowa|isova)?)|nz|wt)|Li(?:ber[\s\xa0]*Deuteronomii|gji[\s\xa0]*i[\s\xa0]*Perterire|P)|V(?:yavasthaavivaran|i(?:ides[\s\xa0]*Mooseksen[\s\xa0]*kirja|jfde[\s\xa0]*Mozes)|\.[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|Mo(?:oseksen[\s\xa0]*kirja|zes|jz(?:eszowa|isova)?|s(?:ebok)?))|[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|Mo(?:oseksen[\s\xa0]*kirja|zes|j(?:z(?:eszowa|isova)?)?|s(?:ebok)?)))|Andharaning[\s\xa0]*Toret|K(?:itabu[\s\xa0]*cha[\s\xa0]*Tano[\s\xa0]*cha[\s\xa0]*Musa|s(?:ieg(?:[ai][\s\xa0]*Powt(?:orzonego[\s\xa0]*Prawa|[\s\xa0]*Prawa))|\.[\s\xa0]*Powt(?:orzonego[\s\xa0]*Prawa|[\s\xa0]*Prawa)|[\s\xa0]*Powt(?:orzonego[\s\xa0]*Prawa|[\s\xa0]*Prawa))|um(?:b(?:ukumbu[\s\xa0]*la[\s\xa0]*(?:Sheria|Torati))?)?)|D(?:iyuteronomyo|yuteronomyo|u(?:ut(?:(?:[eo]ron(?:omy|my))|ron(?:omy|my))|et(?:eron(?:om(?:io|y)|my)|oron(?:omy|my)|ron(?:omy|my))?)|e(?:zyem[\s\xa0]*liv[\s\xa0]*Lalwa[\s\xa0]*a|yuteronomyo|et(?:(?:[eo]ron(?:omy|my))|ron(?:omy|my))|wariem|t(?:e[rw]onom)?|u(?:t(?:eron(?:m(?:io|y)|om(?:ul|[ae]|i(?:um|y[ao]|[ao])?|ya?)?)|oron(?:om(?:io|y)|m(?:io|y))|ron(?:om(?:io|y)|m(?:io|y)))?)?)?|tn?)|Sharci(?:ga[\s\xa0]*Kunoqoshadiisa)?|M(?:asodik[\s\xa0]*torvenykonyv|ozes[\s\xa0]*(?:otodik[\s\xa0]*konyve|V)|Torv)|Upakamam|5(?:\.[\s\xa0]*(?:kniha[\s\xa0]*Mojzisova|Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|Buch[\s\xa0]*Mose|Mo(?:oseksen[\s\xa0]*kirja|zes|jz(?:eszowa|isova)?|s(?:e(?:bo(?:g|k(?:en)?))?)?)?)|[\s\xa0]*(?:Ks(?:ieg[ai][\s\xa0]*Mojzeszowa|\.[\s\xa0]*Mojzeszowa|[\s\xa0]*Mojzeszowa)|k(?:niha[\s\xa0]*Mojzisova|\.[\s\xa0]*Mojzisova|[\s\xa0]*Mojzisova)|Buch[\s\xa0]*Mose|M(?:o(?:os(?:eksen[\s\xa0]*kirja)?|j(?:z(?:eszowa|isova)?)?|s(?:e(?:bo(?:g|k(?:en)?))?)?|z(?:es)?)?|z)?)))|(?:V(?:iides[\s\xa0]*Mooseksen|\.[\s\xa0]*Mooseksen|[\s\xa0]*Mooseksen)|5(?:\.[\s\xa0]*Mooseksen|[\s\xa0]*Mooseksen)|Kumbukumbu)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Titus"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:P(?:oslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*Tyta|a(?:ulus['’][\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Titus|vlova[\s\xa0]*poslanica[\s\xa0]*Titu))|Epistula[\s\xa0]*ad[\s\xa0]*Titum|Waraka[\s\xa0]*kwa[\s\xa0]*Tito|B(?:re(?:f[\s\xa0]*Pals[\s\xa0]*til[\s\xa0]*Titusar|vet[\s\xa0]*til(?:l[\s\xa0]*Titus|[\s\xa0]*Titus))|arua[\s\xa0]*kwa[\s\xa0]*Tito)|tita(?:slai[\s\xa0]*patra|la[\s\xa0]*patra)|L(?:ettera[\s\xa0]*a[\s\xa0]*Tito|ist[\s\xa0]*(?:do[\s\xa0]*Tytusa|Titovi))|K(?:irje[\s\xa0]*Titukselle|a(?:ng[\s\xa0]*Tito|y[\s\xa0]*Tito))|T(?:eetus|yt|i(?:it(?:os)?|t(?:tuvukku[\s\xa0]*Elutiya[\s\xa0]*Nirupam|us(?:arbref|brevet|hoz|z(?:hoz)?)|e|it?)?)?|t))|(?:P(?:aulus’[\s\xa0]*brev[\s\xa0]*til[\s\xa0]*Titus|oslanica[\s\xa0]*Titu)|ad[\s\xa0]*Titum|tita(?:slai|la)|T(?:ytusa|it(?:tuvukku|u(?:kselle|[ms])?|o(?:vi)?)))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Heb"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Z(?:sid(?:ok(?:hoz[\s\xa0]*irt[\s\xa0]*level)?)?|id(?:om)?|yd|d)|B(?:revet[\s\xa0]*til[\s\xa0]*hebreerne|arua[\s\xa0]*kwa[\s\xa0]*Waebrania)|Mga[\s\xa0]*(?:Hebr(?:ohanon|eo)|Ebreo)|E(?:pi(?:reyarukku[\s\xa0]*Elutiya[\s\xa0]*Nirupam|stula[\s\xa0]*ad[\s\xa0]*Hebraeos)|vr(?:ei)?|b(?:re?)?)|hibruharuko[\s\xa0]*nimti[\s\xa0]*patra|Ibraaaniyon|H(?:w(?:(?:[ew]brew(?:ws|s))|brew(?:ws|s))|br(?:ew(?:ws|s))?|e(?:(?:[ew]brew(?:ws|s))|pr(?:ealaiskirje)?|b(?:w(?:ers|res)|e(?:w[erw]s|[eo](?:(?:[eor]s|s))|r(?:[\s\xa0]*level|[eorw]s|s)|s)|o(?:[eor](?:(?:[eor]s|s))|s)|r(?:ae(?:er|r)|e(?:njve|aid|e(?:rbrevet|en|s)|o(?:hanon|s)|rs|u[sx]|s|w(?:ws|s)?)|o(?:[eor]s|s)|r(?:[eorw]s|s)|w(?:es|s)|s)?)?)?)|L(?:ettera[\s\xa0]*agli[\s\xa0]*Ebrei|ayang[\s\xa0]*Ibrani|ist[\s\xa0]*(?:Hebrej[ou]m|do[\s\xa0]*(?:Hebrajczykow|Zydow)|Zidum))|P(?:avlova[\s\xa0]*poslanica[\s\xa0]*Hebrejima|oslannja[\s\xa0]*do[\s\xa0]*jevreiv)|ibri[\s\xa0]*lokams[\s\xa0]*patra|Cib(?:raaniyada)?|Waraka[\s\xa0]*kwa[\s\xa0]*Waebrania|Kirje[\s\xa0]*he[bp]realaisille)|(?:Z(?:sidokhoz|idum|ydow)|Ibrani|hibruharuko[\s\xa0]*nimti|E(?:pireyarukku|brei)|ad[\s\xa0]*Hebraeos|ibri[\s\xa0]*lokams|Waebrania|Poslanica[\s\xa0]*Hebrejima|He(?:prealaisille|br(?:a(?:jczykow|eos)|e(?:erne|j(?:ima|[ou]m)|o))))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Phil"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:P(?:oslannja[\s\xa0]*apostola[\s\xa0]*Pavla[\s\xa0]*do[\s\xa0]*fylyp['’]jan|ilippiyarukku[\s\xa0]*Elutiya[\s\xa0]*Nirupam|a(?:vlova[\s\xa0]*poslanica[\s\xa0]*Filipljanima|ulus['’][\s\xa0]*Brev[\s\xa0]*til[\s\xa0]*Filipperne)|h(?:l(?:ip(?:ians|p(?:ians)?)?|pp?)|i(?:l(?:l(?:l(?:ip(?:pians|i(?:ians|ans?))|p(?:pians|ians))|p(?:pians?|ans|i(?:ens|ans?))|i(?:p(?:p(?:pians|a(?:ins|ns)|eans?|i(?:[ei]ans|a(?:ins|ns?)|ns))|eans?|i(?:ians|e(?:ans|ns)|a(?:[ai]ns|ns?)|ns)|a(?:i(?:ans|ns?)|ns?))?)?)|i(?:p(?:e(?:ans|ns)|i(?:ians|ens|a(?:id|ns?)|ns)|a(?:i(?:ans|ns?)|ns?)|p(?:pians?|a(?:i(?:ans|ns)|ns?)|e(?:ans?|r)|i(?:beliekhez|ians|ens|a(?:[ai]ns|ns?)|ns?))?)?)?|p(?:eans|i(?:ans?|ns)|a(?:ins|n)|p(?:pians|i(?:ians|ans?))?)?)?)?|p))|Sulat[\s\xa0]*sa[\s\xa0]*mga[\s\xa0]*(?:Filipense|Pilip(?:ense|yano))|L(?:ayang[\s\xa0]*Paulus[\s\xa0]*Filipi|ettera[\s\xa0]*ai[\s\xa0]*Filippesi|ist[\s\xa0]*(?:do[\s\xa0]*Filipian|Filip(?:anom|skym)))|Mga[\s\xa0]*Taga(?:[\s\xa0]*[FP]ilipos|-?(?:[\s\xa0]*[FP]ilipos|Filipos))|Epistula[\s\xa0]*ad[\s\xa0]*Philippenses|F(?:il(?:i(?:boy|p(?:ianeve|en(?:s(?:kym|es|ow)|i)|yen|p(?:aiyon|e(?:rbrevet|n(?:serne|zen))|i(?:laiskirje|ekhez)?))?)?)?|l(?:ippiekhez|p)?|p)|Kirje[\s\xa0]*filippilaisille|B(?:ref[\s\xa0]*Pals[\s\xa0]*til[\s\xa0]*Filippimanna?|arua[\s\xa0]*kwa[\s\xa0]*Wafilipi)|Waraka[\s\xa0]*kwa[\s\xa0]*Wafilipi)|(?:ad[\s\xa0]*Philippenses|Mga[\s\xa0]*(?:Filipense|Pilip(?:ense|yano))|Taga(?:[\s\xa0]*[FP]ilipos|-?(?:[\s\xa0]*[FP]ilipos|Filipos))|P(?:aulus’[\s\xa0]*brev[\s\xa0]*til[\s\xa0]*filipperne|oslanica[\s\xa0]*Filipljanima|ilippiyarukku|hilippenses)|Wafilipi|Filip(?:ljanima|anom|skym|p(?:ilaisille|e(?:rne|si))|os|i(?:an)?))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Dan"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Prophetia[\s\xa0]*Danielis|daniyalko[\s\xa0]*pustak|Liv[\s\xa0]*Danyel[\s\xa0]*la|Ks(?:ieg[ai][\s\xa0]*Daniela|\.[\s\xa0]*Daniela|[\s\xa0]*Daniela)|Taniyel|D(?:haniel|a(?:an(?:iyyel|yeel)?|n(?:i(?:al|el(?:s[\s\xa0]*(?:Bog|bok)|e|i(?:n[\s\xa0]*kirja)?)?)|yil)?)?|[ln]))|(?:Dan(?:iel(?:in|a)|yel)|dani(?:yalko|el))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Jude"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:L(?:ettera[\s\xa0]*di[\s\xa0]*Giuda|ayang[\s\xa0]*Yudas|ist[\s\xa0]*(?:sw(?:\.[\s\xa0]*Judy|[\s\xa0]*Judy)|Jud(?:uv|y)))|San[\s\xa0]*Judas|Gd|Y(?:ahooda|u(?:ta[\s\xa0]*Elutiya[\s\xa0]*Nirupam|ud(?:as)?|d))|Barua[\s\xa0]*ya[\s\xa0]*Yuda|Poslan(?:ica[\s\xa0]*Jude[\s\xa0]*apostola|nja[\s\xa0]*apostola[\s\xa0]*Judy)|yahuda(?:cem[\s\xa0]*patra|ko[\s\xa0]*patra)|Hudas|J(?:u(?:d(?:ina[\s\xa0]*poslanica|ov(?:[\s\xa0]*List|a)|a(?:s(?:['’][\s\xa0]*Brev|arbref|brevet|[\s\xa0]*(?:epistel|brev)))?)|ud(?:aksen[\s\xa0]*kirje)?)|d(?:as|e)|id|wd(?:as)?)|Epistula[\s\xa0]*Iudae|Iuda)|(?:yahuda(?:cem|ko)|Iudae|Giuda|Yu(?:ta|das?)|Ju(?:udaksen|d(?:ina|ov|as(?:’[\s\xa0]*brev)?|[ey])))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["2Macc"]
		apocrypha: true
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:I(?:kalawang[\s\xa0]*M(?:ga[\s\xa0]*Macabeo|acabeos?)|I(?:\.[\s\xa0]*(?:makkabilaiskirja|Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|Wamakabayo|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:j(?:cov|ska))?|k(?:abe(?:usok|een))?)?)))|[\s\xa0]*(?:makkabilaiskirja|Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|Wamakabayo|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:j(?:cov|ska))?|k(?:abe(?:usok|een))?)?)))))|D(?:euxieme(?:s[\s\xa0]*Maccabees|[\s\xa0]*Maccabees)|ru(?:g(?:a[\s\xa0]*(?:knjiga[\s\xa0]*o[\s\xa0]*Makabejcima|Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska))|i[\s\xa0]*Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska))|h(?:a[\s\xa0]*(?:kniha[\s\xa0]*Ma(?:chabejcov|kabejcov)|Ma(?:chabejcov|k(?:abej(?:cov|ska))?))|y[\s\xa0]*(?:list[\s\xa0]*Ma(?:chabejcov|kabejcov)|Ma(?:chabejcov|k(?:abej(?:cov|ska))?)))))|Onnur[\s\xa0]*Makkabeabok|T(?:oinen[\s\xa0]*makkabilaiskirja|weede[\s\xa0]*Mak(?:kabeeen)?)|Kitabu[\s\xa0]*cha[\s\xa0]*Wamakabayo[\s\xa0]*II|Liber[\s\xa0]*(?:II[\s\xa0]*Maccabaeorum|Maccabaeorum[\s\xa0]*II)|Zweite[\s\xa0]*Makkabaer|And(?:en[\s\xa0]*Makk|r(?:a[\s\xa0]*Mackabeerboken|e[\s\xa0]*Makk(?:abeerbok)?))|Pili[\s\xa0]*(?:Wamakabayo|Mak)|Se(?:gund(?:a[\s\xa0]*Macabeus|o[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|us|os?))))|cond(?:a[\s\xa0]*Maccabei|o[\s\xa0]*(?:libro[\s\xa0]*dei[\s\xa0]*Maccabei|Maccabei)|[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?))|Ma(?:chabaeorum[\s\xa0]*II|kkabeusok[\s\xa0]*II|sodik[\s\xa0]*Mak(?:kabeusok)?)|2(?:d(?:\.[\s\xa0]*Maccabees|e(?:\.[\s\xa0]*Maccabees|[\s\xa0]*Maccabees)|[\s\xa0]*Maccabees)|a(?:\.[\s\xa0]*Macabeus|[\s\xa0]*Macabeus)|o(?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|us|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|us|os?))))|nd(?:\.[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?)|\.(?:o(?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?))))|[\s\xa0]*(?:makkabilaiskirja|Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|Wamakabayo|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:kabeerboken|hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:j(?:cov|ska))?|k(?:ab(?:e(?:usok|e(?:rbok|en))|aer))?)?))))|e(?:me(?:\.[\s\xa0]*Maccabees|[\s\xa0]*Maccabees)|\.[\s\xa0]*Ma(?:ccabees|k(?:kabeeen)?)|[\s\xa0]*Ma(?:ccabees|k(?:kabeeen)?))|Macc|[\s\xa0]*(?:makkabilaiskirja|Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|k(?:\.[\s\xa0]*Ma(?:chabejcov|kabejcov)|[\s\xa0]*Ma(?:chabejcov|kabejcov))|Wamakabayo|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?|h(?:ab(?:aeorum|ejcov))?|k(?:abeerboken)?)?|k(?:abe(?:j(?:cov|ska))?|k(?:ab(?:e(?:usok|e(?:rbok|en))|aer))?)?)?|c[bh]?)?)))|(?:Wamakabayo[\s\xa0]*II|2[\s\xa0]*makk)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["3Macc"]
		apocrypha: true
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:K(?:itabu[\s\xa0]*cha[\s\xa0]*Wamakabayo[\s\xa0]*III|olmas[\s\xa0]*makkabilaiskirja)|Liber[\s\xa0]*(?:III[\s\xa0]*Maccabaeorum|Maccabaeorum[\s\xa0]*III)|Ma(?:chabaeorum[\s\xa0]*III|kkabeusok[\s\xa0]*III)|Harmadik[\s\xa0]*Mak(?:kabeusok)?|D(?:ritte[\s\xa0]*Makkabaer|erde[\s\xa0]*Mak(?:kabeeen)?)|T(?:er(?:ce(?:ir[ao][\s\xa0]*Macabeus|r(?:o[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))))|z(?:a[\s\xa0]*Maccabei|o[\s\xa0]*(?:libro[\s\xa0]*dei[\s\xa0]*Maccabei|Maccabei)))|hird[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|r(?:zeci(?:a[\s\xa0]*Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|[\s\xa0]*Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska))|oisieme(?:s[\s\xa0]*Maccabees|[\s\xa0]*Maccabees)|e(?:ca[\s\xa0]*knjiga[\s\xa0]*o[\s\xa0]*Makabejcima|dje[\s\xa0]*Ma(?:ckabeerboken|kk(?:abeerbok)?)|ti(?:a[\s\xa0]*(?:kniha[\s\xa0]*Machabejcov|Machabejcov)|[\s\xa0]*Ma(?:chabejcov|k(?:abejska)?))))|atu[\s\xa0]*(?:Wamakabayo|Mak))|I(?:katlong[\s\xa0]*M(?:ga[\s\xa0]*Macabeo|acabeos?)|II(?:\.[\s\xa0]*(?:makkabilaiskirja|Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|Wamakabayo|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:jska)?|k(?:abe(?:usok|een))?)?)))|[\s\xa0]*(?:makkabilaiskirja|Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|Wamakabayo|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:jska)?|k(?:abe(?:usok|een))?)?)))))|3(?:a(?:\.[\s\xa0]*Macabeus|[\s\xa0]*Macabeus)|o(?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|us|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|us|os?))))|rd(?:\.[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?)|\.(?:o(?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?))))|[\s\xa0]*(?:makkabilaiskirja|Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|Wamakabayo|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:kabeerboken|hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:jska)?|k(?:ab(?:e(?:usok|e(?:rbok|en))|aer))?)?))))|e(?:me(?:\.[\s\xa0]*Maccabees|[\s\xa0]*Maccabees)|\.[\s\xa0]*Ma(?:c(?:kabeerboken|cabees)|k(?:kabeeen)?)|[\s\xa0]*Ma(?:c(?:kabeerboken|cabees)|k(?:kabeeen)?))|Macc|[\s\xa0]*(?:makkabilaiskirja|Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|k(?:\.[\s\xa0]*Machabejcov|[\s\xa0]*Machabejcov)|Wamakabayo|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?|h(?:ab(?:aeorum|ejcov))?|k(?:abeerboken)?)?|k(?:abe(?:jska)?|k(?:ab(?:e(?:usok|e(?:rbok|en))|aer))?)?)|c[bh]?)?)))|(?:Wamakabayo[\s\xa0]*III|3[\s\xa0]*makk)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["4Macc"]
		apocrypha: true
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:C(?:zwarta[\s\xa0]*Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|uarto[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))|tvrta[\s\xa0]*Mak(?:abejska)?)|N(?:eljas[\s\xa0]*makkabilaiskirja|ne[\s\xa0]*(?:Wamakabayo|Mak))|4(?:e(?:me(?:\.[\s\xa0]*Maccabees|[\s\xa0]*Maccabees)|\.[\s\xa0]*Maccabees|[\s\xa0]*Maccabees)|a(?:\.[\s\xa0]*Macabeus|[\s\xa0]*Macabeus)|o(?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|us|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|us|os?))))|th(?:\.[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?)|\.(?:o(?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?))))|[\s\xa0]*(?:makkabilaiskirja|Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|Wamakabayo|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:kabeerboken|hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:jska)?|k(?:ab(?:e(?:usok|e(?:rbok|en))|aer))?)?))))|Macc|[\s\xa0]*(?:makkabilaiskirja|Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|k(?:\.[\s\xa0]*Machabejcov|[\s\xa0]*Machabejcov)|Wamakabayo|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?|h(?:ab(?:aeorum|ejcov))?|k(?:abeerboken)?)?|k(?:abe(?:jska)?|k(?:ab(?:e(?:usok|e(?:rbok|en))|aer))?)?)|c[bh]?)?))|Vier(?:te[\s\xa0]*Makkabaer|de[\s\xa0]*Mak(?:kabeeen)?)|Liber[\s\xa0]*(?:IV[\s\xa0]*Maccabaeorum|Maccabaeorum[\s\xa0]*IV)|Kitabu[\s\xa0]*cha[\s\xa0]*Wamakabayo[\s\xa0]*IV|Ma(?:chabaeorum[\s\xa0]*IV|kkabeusok[\s\xa0]*IV)|Stvrta[\s\xa0]*(?:kniha[\s\xa0]*Machabejcov|Machabejcov)|Qua(?:trieme(?:s[\s\xa0]*Maccabees|[\s\xa0]*Maccabees)|rt(?:a[\s\xa0]*Mac(?:abeus|cabei)|o[\s\xa0]*(?:libro[\s\xa0]*dei[\s\xa0]*Maccabei|Mac(?:abeus|cabei))))|F(?:j(?:arde[\s\xa0]*Mackabeerboken|erde[\s\xa0]*Makk(?:abeerbok)?)|ourth[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?)|I(?:kaapat[\s\xa0]*M(?:ga[\s\xa0]*Macabeo|acabeos?)|V(?:\.[\s\xa0]*(?:makkabilaiskirja|Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|Wamakabayo|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:jska)?|k(?:abe(?:usok|een))?)?)))|[\s\xa0]*(?:makkabilaiskirja|Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|Wamakabayo|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:jska)?|k(?:abe(?:usok|een))?)?))))))|(?:Wamakabayo[\s\xa0]*IV|4[\s\xa0]*makk)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["1Macc"]
		apocrypha: true
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:E(?:nsimmainen[\s\xa0]*makkabilaiskirja|rste[\s\xa0]*Makkabaer|erste[\s\xa0]*Mak(?:kabeeen)?|lso[\s\xa0]*Mak(?:kabeusok)?)|I(?:\.[\s\xa0]*(?:makkabilaiskirja|Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|Wamakabayo|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:jska)?|k(?:abe(?:usok|een))?)?)))|[\s\xa0]*(?:makkabilaiskirja|Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|Wamakabayo|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:jska)?|k(?:abe(?:usok|een))?)?))))|Liber[\s\xa0]*(?:I[\s\xa0]*Maccabaeorum|Maccabaeorum[\s\xa0]*I)|Ma(?:chabaeorum[\s\xa0]*I|kkabeusok[\s\xa0]*I)|Una(?:ng[\s\xa0]*M(?:ga[\s\xa0]*Macabeo|acabeos?)|[\s\xa0]*M(?:ga[\s\xa0]*Macabeo|acabeos?))|1(?:re(?:\.[\s\xa0]*Maccabees|[\s\xa0]*Maccabees)|a(?:\.[\s\xa0]*Macabeus|[\s\xa0]*Macabeus)|o(?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|us|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|us|os?))))|st(?:\.[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?)|\.(?:o(?:\.[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?))))|[\s\xa0]*(?:makkabilaiskirja|Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|Wamakabayo|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:kabeerboken|hab(?:aeorum|ejcov)|ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?|k(?:abe(?:jska)?|k(?:ab(?:e(?:usok|e(?:rbok|en))|aer))?)?))))|e(?:r(?:\.[\s\xa0]*Maccabees|e(?:\.[\s\xa0]*Maccabees|[\s\xa0]*Maccabees)|[\s\xa0]*Maccabees)|\.[\s\xa0]*Mak(?:kabeeen)?|[\s\xa0]*Mak(?:kabeeen)?)|Macc|[\s\xa0]*(?:makkabilaiskirja|Ks(?:ieg[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska)|k(?:\.[\s\xa0]*Machabejcov|[\s\xa0]*Machabejcov)|Wamakabayo|M(?:ga[\s\xa0]*Macabeo|a(?:c(?:ab(?:aeorum|b(?:be(?:e[es]?|s)?|e(?:e(?:[eo]s?|s)?|os?|s)?)|e(?:aid|us|e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be[es]?|e(?:e(?:[es]|os?)?|os?|s)?)|e(?:e(?:[eo]s?|s)?|[is]|os?)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?|h(?:ab(?:aeorum|ejcov))?|k(?:abeerboken)?)?|k(?:abe(?:jska)?|k(?:ab(?:e(?:usok|e(?:rbok|en))|aer))?)?)?|c[bh]?)?))|P(?:ierwsz[aey][\s\xa0]*Ks(?:ieg(?:[ai][\s\xa0]*Machabejska|\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska))|r(?:emier(?:e(?:s[\s\xa0]*Maccabees|[\s\xa0]*Maccabees)|s[\s\xa0]*Maccabees|[\s\xa0]*Maccabees)|im(?:a[\s\xa0]*Maccabei|e(?:ir[ao][\s\xa0]*Macabeus|r(?:o[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))|[\s\xa0]*Mac(?:cab(?:be(?:eos?|os?)|e(?:eos?|os?))|ab(?:be(?:eos?|os?)|e(?:eos?|os?)))))|o[\s\xa0]*(?:libro[\s\xa0]*dei[\s\xa0]*Maccabei|Maccabei))|v(?:y[\s\xa0]*(?:list[\s\xa0]*Machabejcov|Machabejcov)|a[\s\xa0]*(?:kn(?:jiga[\s\xa0]*o[\s\xa0]*Makabejcima|iha[\s\xa0]*Machabejcov)|Ma(?:chabejcov|kabejcov))|ni[\s\xa0]*Mak(?:abejska)?)))|F(?:orsta[\s\xa0]*Mackabeerboken|yrsta[\s\xa0]*Makkabeabok|irst[\s\xa0]*Mac(?:ab(?:b(?:be(?:e[es]?|s)?|e(?:e(?:es?|s)?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be[es]?|e(?:e[es]?|s)?)|e(?:e(?:es?|s)?|s)?)|c(?:ab(?:b(?:be|e[es]?)|e(?:e[es]?|s)?))?)?)?)|K(?:itabu[\s\xa0]*cha[\s\xa0]*Wamakabayo[\s\xa0]*I|wanza[\s\xa0]*(?:Wamakabayo|Mak)))|Pierwsz(?:[aey][\s\xa0]*Ks(?:\.[\s\xa0]*Machabejska|[\s\xa0]*Machabejska))|(?:Wamakabayo[\s\xa0]*I|Maccabees|1[\s\xa0]*makk)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Mark"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Jevanhelije[\s\xa0]*vid[\s\xa0]*Marka|Vangelo[\s\xa0]*di[\s\xa0]*(?:San[\s\xa0]*Marco|Marco)|M(?:a(?:buting[\s\xa0]*Balita[\s\xa0]*ayon[\s\xa0]*kay[\s\xa0]*(?:San[\s\xa0]*Mar[ck]os|Mar[ck]os)|r(?:k(?:ovo[\s\xa0]*evangelium|u(?:ksen[\s\xa0]*evankeliumi|s(?:[\s\xa0]*evangelium|evangeliet)|[\s\xa0]*Narceyti))|akus|ek|cu?))|rc(?:os)?|c)|E(?:l[\s\xa0]*Evangelio[\s\xa0]*de[\s\xa0]*Marcos|van(?:keliumi[\s\xa0]*Markuksen[\s\xa0]*mukaan|geli(?:e(?:[\s\xa0]*volgens[\s\xa0]*Mar[ck]us|t[\s\xa0]*etter[\s\xa0]*Markus)|um[\s\xa0]*(?:secundum[\s\xa0]*Marcum|podle[\s\xa0]*Marka))|jelium[\s\xa0]*Podla[\s\xa0]*Marka)|banghelyo[\s\xa0]*(?:ayon[\s\xa0]*kay[\s\xa0]*Marcos|ni[\s\xa0]*(?:San[\s\xa0]*Mar[ck]os|Mar[ck]os))|w(?:angelia[\s\xa0]*(?:wg[\s\xa0]*sw(?:\.[\s\xa0]*Marka|[\s\xa0]*Marka)|Marka)|\.[\s\xa0]*Marka|[\s\xa0]*Mar(?:ka)?))|Injil(?:i[\s\xa0]*ya[\s\xa0]*Marko|[\s\xa0]*Markus)|Sulat[\s\xa0]*ni[\s\xa0]*San[\s\xa0]*Marcos|mark(?:usle|ane)|The[\s\xa0]*Gospel[\s\xa0]*(?:according[\s\xa0]*to[\s\xa0]*(?:S(?:aint[\s\xa0]*M(?:ark?|k|rk?)|t(?:\.[\s\xa0]*M(?:ark?|k|rk?)|[\s\xa0]*M(?:ark?|k|rk?)))|M(?:ark?|k|rk?))|of[\s\xa0]*(?:S(?:aint[\s\xa0]*M(?:ark?|k|rk?)|t(?:\.[\s\xa0]*M(?:ark?|k|rk?)|[\s\xa0]*M(?:ark?|k|rk?)))|M(?:ark?|k|rk?)))|Ungjilli[\s\xa0]*i[\s\xa0]*Markut)|(?:Evangelio[\s\xa0]*de[\s\xa0]*Marcos|Gospel[\s\xa0]*(?:according[\s\xa0]*to[\s\xa0]*(?:S(?:aint[\s\xa0]*M(?:ark?|k|rk?)|t(?:\.[\s\xa0]*M(?:ark?|rk?|k)|[\s\xa0]*M(?:ark?|rk?|k)))|M(?:ark?|rk?|k))|of[\s\xa0]*(?:S(?:aint[\s\xa0]*M(?:ark?|k|rk?)|t(?:\.[\s\xa0]*M(?:ark?|k|rk?)|[\s\xa0]*M(?:ark?|rk?|k)))|M(?:ark?|rk?|k)))|markus|S(?:a(?:n[\s\xa0]*Marcos|int[\s\xa0]*M(?:ark?|rk?|k))|t(?:\.[\s\xa0]*M(?:ark?|rk?|k)|[\s\xa0]*M(?:ark?|k|rk?)))|M(?:ar(?:c(?:us|os?)|k(?:os?|a|u(?:ksen|s)?)?)?|k|rk?))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Jas"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		yak(?:obacem[\s\xa0]*patra|ubko[\s\xa0]*patra)|(?:T(?:iago|g)|J(?:a(?:ques|ak(?:obin[\s\xa0]*kirje)?|c(?:obo|q(?:ues)?)?|k(?:ab|o(?:vljeva[\s\xa0]*poslanica|b(?:s(?:brevet|[\s\xa0]*(?:epistel|Brev))|us(?:brief)?|it?)?)|ub(?:ov[\s\xa0]*List)?)?|m(?:es?)?|s)?|k|ms?)|Epistula[\s\xa0]*Iacobi|Waraka[\s\xa0]*wa[\s\xa0]*Yakobo|Barua[\s\xa0]*ya[\s\xa0]*Yakobo|Ya(?:c(?:q(?:uub)?)?|k(?:kopu[\s\xa0]*Elutiya[\s\xa0]*Nirupam|oob)?)|L(?:ettera[\s\xa0]*di[\s\xa0]*Giacomo|ayang[\s\xa0]*Yakobus|ist[\s\xa0]*(?:sw(?:\.[\s\xa0]*Jakuba|[\s\xa0]*Jakuba)|Jakub(?:uv|a)))|Ia(?:c(?:o[bv])?|go?)|G[cm]|Poslannja[\s\xa0]*apostola[\s\xa0]*Jakova|S(?:an(?:t(?:iago)?)?|tg?))|(?:yak(?:obacem|ubko)|Giacomo|Ja(?:akobin|k(?:o(?:vljeva|bs(?:[\s\xa0]*brev)?)|ub(?:ov|a)))|Yak(?:kopu|ob(?:us|o))|Iacobi)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Amos"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Prophetia[\s\xa0]*Amos|Liv[\s\xa0]*Amos[\s\xa0]*la|Ks(?:ieg[ai][\s\xa0]*Amosa|\.[\s\xa0]*Amosa|[\s\xa0]*Amosa)|Caam(?:oos)?|A(?:am(?:oksen[\s\xa0]*kirja)?|m(?:o(?:s(?:(?:['’][\s\xa0]*(?:Bog|bok))|[iz]))?|s)?))|(?:A(?:amoksen|mosa?)|amos)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Tob"]
		apocrypha: true
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Cartea[\s\xa0]*lui[\s\xa0]*Tobit|Liber[\s\xa0]*T(?:hobis|obiae)|Ks(?:ieg(?:[ai][\s\xa0]*Tobi(?:asza|ta))|\.[\s\xa0]*Tobi(?:asza|ta)|[\s\xa0]*Tobi(?:asza|ta))|T(?:ho|ob(?:i(?:olo|jas?|t(?:s(?:[\s\xa0]*(?:Bog|bok)|bok)|i(?:n[\s\xa0]*kirja)?)|a(?:an[\s\xa0]*kirja|n[\s\xa0]*kirja|s['’][\s\xa0]*bok)?|e)?|t)?|b))|Tobi(?:a(?:an|[sen])|t(?:in)?)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Jdt"]
		apocrypha: true
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Liber[\s\xa0]*Iudith|K(?:niha[\s\xa0]*Juditina|\.[\s\xa0]*Juditina|itab[\s\xa0]*Yudit|[\s\xa0]*Juditina|s(?:ieg[ai][\s\xa0]*Judyty|\.[\s\xa0]*Judyty|[\s\xa0]*Judyty))|Yud(?:it(?:hi?|i)|t)|G(?:iuditta|dt)|I(?:udita|dt)|J(?:ud(?:it(?:in[\s\xa0]*kirja|s[\s\xa0]*(?:Bog|bok)|a(?:rbok)?|[eh])?|th?)|d(?:ith?|th?)))|(?:Iudith|Jud(?:itin|yty)|Yudit)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Bar"]
		apocrypha: true
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		(?:Proroctvo[\s\xa0]*Baruchovo|Liber[\s\xa0]*Baruch|K(?:niha[\s\xa0]*Baru(?:chova|kova)|itab[\s\xa0]*Barukh|s(?:ieg[ai][\s\xa0]*Barucha|\.[\s\xa0]*Barucha|[\s\xa0]*Barucha))|B(?:a(?:arukin[\s\xa0]*kirja|r(?:u(?:que|[ch]|k(?:in[\s\xa0]*kirja|s(?:[\s\xa0]*(?:Bog|bok)|bok)|u)?))?)?|r))|Ba(?:arukin|ru(?:k(?:in|h)|cha?))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["1Kgs"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:1(?:\.[\s\xa0]*(?:Ks|Re)|[\s\xa0]*(?:Ks|Re))|I(?:\.[\s\xa0]*Ks|[\s\xa0]*Ks))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["2Kgs"]
		regexp: ///(^|[^0-9A-Za-zªµºÀ-ÖØ-öø-ɏ̀-ʹͶ-ͷͺ-ͽΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁ҃-҇Ҋ-ԧ֑-ֽֿׁ-ׂׄ-ׇׅא-תװ-ײؐ-ؚؠ-ٟٮ-ۓە-ۜ۟-۪ۨ-ۯۺ-ۼۿݐ-ݿࢠࢢ-ࢬࣤ-ࣾऀ-ंऄ-ऺ़-ऽु-ै्ॐ-ॣॱ-ॷॹ-ॿਁ-ਂਅ-ਊਏ-ਐਓ-ਨਪ-ਰਲ-ਲ਼ਵ-ਸ਼ਸ-ਹ਼ੁ-ੂੇ-ੈੋ-੍ੑਖ਼-ੜਫ਼ੰ-ੵଁଅ-ଌଏ-ଐଓ-ନପ-ରଲ-ଳଵ-ହ଼-ଽିୁ-ୄ୍ୖଡ଼-ଢ଼ୟ-ୣୱஂ-ஃஅ-ஊஎ-ஐஒ-கங-சஜஞ-டண-தந-பம-ஹீ்ௐก-ฺเ-๎᷀-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼ⃐-⃿Ⱡ-Ɀⷠ-ⷿ々-〆〪-〭〱-〵〻-〼㐀-䶵一-鿌Ꙁ-꙯ꙴ-꙽ꙿ-ꚗꚟꜢ-ꞈꞋ-ꞎꞐ-ꞓꞠ-Ɦꟸ-ꟿ꣠-ꣷꣻ가-힯豈-舘並-龎ﭐ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼ])(
		(?:II(?:\.[\s\xa0]*Ks|[\s\xa0]*Ks)|2(?:\.[\s\xa0]*(?:Ks|Re)|[\s\xa0]*(?:Ks|Re)))
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Ezek", "Ezra"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		Ez
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Hab", "Hag"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		Ha
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Heb", "Hab"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		Hb
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["John"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		Jan
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["John", "Jonah"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		Yn
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["John", "Jonah", "Job", "Josh", "Joel"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		Jo
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Jonah", "Joel"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		Yoo
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Jude", "Judg"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		J(?:d|ud?)
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Lam"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		La
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Matt", "Mark", "Mal"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		Ma
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Mic"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		Mi
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Phil", "Phlm"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		Phl?
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Rev"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		Re
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Song"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		Songs
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	,
		osis: ["Zeph", "Zech"]
		regexp: ///(^|#{bcv_parser::regexps.pre_book})(
		Ze
			)(?:(?=[\d\s\xa0.:,;\x1e\x1f&\(\)（）\[\]/"'\*=~\-\u2013\u2014])|$)///gi
	]
	# Short-circuit the look if we know we want all the books.
	return books if include_apocrypha is true and case_sensitive is "none"
	# Filter out books in the Apocrypha if we don't want them. `Array.map` isn't supported below IE9.
	out = []
	for book in books
		continue if include_apocrypha is false and book.apocrypha? and book.apocrypha is true
		if case_sensitive is "books"
			book.regexp = new RegExp book.regexp.source, "g"
		out.push book
	out

# Default to not using the Apocrypha
bcv_parser::regexps.books = bcv_parser::regexps.get_books false, "none"
